program makenk
  implicit none

  character(len=50) :: fn, fnout, rubbish
  real,pointer :: lam(:), n(:), k(:)
  real :: skip
  integer :: ios,nwav,i,nh

  print*, 'filename in?'
  read*, fn
  print*, 'filename out?'
  read*, fnout
  print*, 'how many lines in the header?'
  read*, nh

  open(unit=10,file=fn,status='old')
  do i = 1,nh
     read(10,*) rubbish
  end do
  
  do i = 1,1000000
     read(unit=10,fmt=*,iostat=ios)
     if (ios/=0) then
        nwav = i-1
        print*, 'lines of data = ', nwav
        exit
     end if
  end do

  rewind(10)

  allocate(lam(nwav))
  allocate(n(nwav))
  allocate(k(nwav))
  
  do i = 1,nh
     read(10,*) rubbish
  end do
  
  do i = 1,nwav
     read(unit=10,fmt=*,iostat=ios) lam(i), skip, skip, n(i),k(i)
     if (ios/=0) then
        print*, 'problem reading'
        stop
     end if
  end do
  
  close(10)


  open (unit=11,file=fnout, status='unknown')
  do i = nwav, 1, -1
     write(11,fmt='(3e12.5)') lam(i), n(i)+1, k(i)
  end do

  close(11)

end program makenk

! Copyright (C) 2005 Barbara Ercolano
!
! Version 2.02
module emission_mod
    use constants_mod
    use common_mod
    use continuum_mod
    use grid_mod
    use xSec_mod
    use elements_mod

    type(resLine_type), allocatable         :: resLine(:)  ! resonant lines

    ! units are [e-25erg/s/N_gas]

    double precision, dimension(34)        :: HeIRecLines          ! emissivity from HeI rec lines

    real                                :: BjumpTemp   !
    real                                :: HbetaProb   ! probability of Hbeta
    real                                :: log10Ne     ! log10(Ne) at this cell
    real                                :: log10Te     ! log10(Te) at this cell
    real                                :: sqrTeUsed   ! sqr(Te) at this cell

    integer                             :: abFileUsed  ! abundance file index used
    integer                             :: cellPUsed   !  cell index
    integer                             :: nspE
        logical,save :: lgFloc=.true.                !
    contains

    ! this is the subroutine to drive the calculation
    ! of the emission spectrum at the given cell
    subroutine emissionDriver(grids, ix, iy, iz, ig)
        implicit none

        integer, intent(in) :: ix, iy, iz, ig  ! pointers to this cell


        type(grid_type), intent(inout) :: grids(*) ! the cartesian grid

        ! local variables

        integer :: err                       ! allocation error status
        integer :: i                         ! counters

        real    :: dV                        ! volume element

        double precision :: gammaHI(nbins)          ! HI fb+ff emission coefficient [e-40 erg*cm^3/s/Hz]
        double precision :: gammaHeI(nbins)         ! HeI fb+ff emission coefficient [e-40erg*cm^3/s/Hz]
        double precision :: gammaHeII(nbins)        ! HeII fb+ff emission coefficient [e-40erg*cm^3/s/Hz]
        double precision :: gammaHeavies(nbins)     ! Heavy ions f-b emission coefficient [e-40 erg*cm^3/s/Hz]
        double precision :: ffCoeff1(nbins)         ! ff emission coefficient for Z=1 ions [e-40 erg*cm^3/s/Hz]
        double precision :: ffCoeff2(nbins)         ! ff emission coefficient for Z=2 ions [e-40 erg*cm^3/s/Hz]
        double precision :: twoPhotHI(nbins)        ! HI 2photon emission coefficient [e-40 erg*cm^3/s/Hz]
        double precision :: twoPhotHeI(nbins)       ! HeI 2photon emission coefficient [e-40 erg*cm^3/s/Hz]
        double precision :: twoPhotHeII(nbins)      ! HeII 2photon emission coefficient [e-40 erg*cm^3/s/Hz]

    ! units are [e-40erg/cm^3/s/Hz]
        double precision :: emissionHI(nbins)                     ! HI continuum emission coefficient
        double precision :: emissionHeI(nbins)                    ! HeI continuum emission coefficient
        double precision :: emissionHeII(nbins)                   ! HeII continuum emission coefficient

        ! check whether this cell is outside the nebula
        if (grids(iG)%active(ix, iy, iz)<=0) return

        cellPUsed = grids(iG)%active(ix, iy, iz)
        if (lgMultiDustChemistry) then
           nspE = grids(iG)%dustAbunIndex(cellPUsed)
        else
           nspE = 1
        end if


        ! set the dust emission PDF
        if (lgDust .and. .not.lgGas) call setDustPDF()

        if (.not.lgGas) return



        ! find the physical properties of this cell
        ionDenUsed= grids(iG)%ionDen(cellPUsed, :, :)

        abFileUsed= grids(iG)%abFileIndex(ix,iy,iz)
        NeUsed    = grids(iG)%Ne(cellPUsed)
        TeUsed    = grids(iG)%Te(cellPUsed)
        sqrTeUsed = sqrt(TeUsed)

        log10Te = log10(TeUsed)
        log10Ne = log10(NeUsed)

        ! check the electron density is not too low
        if (NeUsed < 1.e-5) then
             NeUsed = 1.e-5
        end if

        ! zero out arrays
        continuum      = 0.
        emissionHI     = 0.
        emissionHeI    = 0.
        emissionHeII   = 0.
        gammaHI        = 0.
        gammaHeI       = 0.
        gammaHeII      = 0.
        gammaHeavies   = 0.
        twoPhotHI      = 0.
        twoPhotHeI     = 0.
        twoPhotHeII    = 0.
        ffCoeff1       = 0.
        ffCoeff2       = 0.



        ! calculates the H, He and heavy ions f-b and f-f emission
        ! coefficients
        call fb_ff()



        ! calculate two photon emission coefficients for HI, HeI and
        ! HeII
        call twoPhoton()

        ! calculate the total emission coefficients for H and He

        emissionHI = (gammaHI + twoPhotHI) * grids(iG)&
                 &%elemAbun(grids(iG)%abFileIndex(ix,iy,iz), 1) * ionDenUsed(elementXref(1),2)*NeUsed &
                 &+ gammaHeavies*NeUsed
        emissionHeI = (gammaHeI + twoPhotHeI ) * grids(iG)&
                 &%elemAbun(grids(iG)%abFileIndex(ix,iy,iz),2) * ionDenUsed(elementXref(2),2)*NeUsed
        emissionHeII= (gammaHeII + twoPhotHeII ) * grids(iG)&
                 &%elemAbun(grids(iG)%abFileIndex(ix,iy,iz),2) * ionDenUsed(elementXref(2),3)*NeUsed

        ! zero out near zero contributions

        where (emissionHI < 1.e-15 ) emissionHI = 0.
        where (emissionHeI < 1.e-15 ) emissionHeI = 0.
        where (emissionHeII < 1.e-15 ) emissionHeII = 0.

        continuum = (emissionHI + emissionHeI + emissionHeII)

        dV = getVolume(grids(iG),ix,iy,iz)

        ! add contribution of this cell to the integrated balmer jump
        BjumpTemp = BjumpTemp + real(((emissionHI(BjumpP)&
             &+emissionHeI(BjumpP)+emissionHeII(BjumpP)) *&
             & cRyd*cRyd*nuArray(BjumpP)*nuArray(BjumpP)*1.e-8/c -&
             & (emissionHI(BjumpP-1)+emissionHeI(BjumpP-1)&
             &+emissionHeII(BjumpP-1)) *&
             & cRyd*cRyd*nuArray(BjumpP-1)*nuArray(BjumpP-1)*1.e-8/c)&
             & *grids(iG)%Hden(grids(iG)%active(ix,iy,iz))*dV)

        ! calculate the emission due to HI and HeI recombination lines
        call RecLinesEmission()

        ! calculate the emission due to the heavy elements forbidden lines
        call forLines()

        ! set the PDFs for diffuse radiation
        call setDiffusePDF()

        ! set the resonance line escape probabilities
        if (lgDust.and.convPercent>=resLinesTransfer .and. lgResLinesFirst &
             & .and. (.not.nIterateMC==1)) then
           call setResLineEscapeProb(grids,ig,ix,iy,iz)
        end if

        ! set the extra packets due to dust absorption of resonance lines
        if (lgDust.and.convPercent>=resLinesTransfer &
             & .and. (.not.nIterateMC==1)) then
           call initResLinePackets()
        end if

    contains

      subroutine initResLinePackets()
        implicit none

        real                :: lineIntensity

        integer             :: iRes, imul, n, ai

        species: do n = 1, nSpeciesPart(nspE)
           do ai = 1, nSizes

              if (grids(iG)%Tdust(n,ai,cellPUsed)>0. .and. &
                   & grids(iG)%Tdust(n,ai,cellPUsed)<TdustSublime(dustComPoint(nspE)-1+n)) exit species


           end do
        end do species

        if (n>nSpeciesPart(nspE)) then
           ! all grains have sublimed
           grids(iG)%resLinePackets(cellPUsed) = 0
           return
        end if

        ! calculate total energy deposited into grains at location icell in grid igrid
        lineIntensity=0.
        do iRes = 1, nResLines
           do imul = 1, resLine(iRes)%nmul

              if (resLine(iRes)%elem==1) then
                 if ( resLine(iRes)%ion == 1 .and. resLine(iRes)%moclow(imul)==1 &
                      & .and. resLine(iRes)%mochigh(imul)==2 ) then

                    ! fits to Storey and Hummer MNRAS 272(1995)41
                    lineIntensity = lineIntensity+10**(-0.897*log10(TeUsed) + 5.05)* &
                         & grids(iG)%elemAbun(grids(iG)%abFileIndex(ix,iy,iz),1)*ionDenUsed(elementXref(1),2)*&
                         &  NeUsed*grids(iG)%Hden(grids(iG)%active(ix,iy,iz))*dV*&
                         & (1.-grids(iG)%fEscapeResPhotons(grids(iG)%active(ix,iy,iz), iRes))

                 else

                    print*, "! initResLinePackets: [warning] only dust heating &
                         &from H Lyman alpha and resonance lines from heavy &
                         &elements is implemented in this version. &
                         &Please contact B. Ercolano -1-", ires

                 end if
              else if (resLine(iRes)%elem>2) then

                 lineIntensity = lineIntensity+&
                      &real(forbiddenLines(resLine(iRes)%elem,resLine(iRes)%ion,&
                      &resLine(iRes)%moclow(imul),resLine(iRes)%mochigh(imul))*&
                      & grids(iG)%Hden(grids(iG)%active(ix,iy,iz))*dV*&
                      & (1.-grids(iG)%fEscapeResPhotons(grids(iG)%active(ix,iy,iz), iRes)))

              else

                 print*, "! initResLinePackets: [warning] only dust heating from &
                      &H Lyman alpha and resonance lines from heavy &
                      &elements is implemented in this version. &
                      &Please contact B. Ercolano -2-", ires


              end if

           end do
        end do

        ! calculate number of dust emitted extra packets to be transfered from this location
        ! NOTE :1.e-16 from 1.e45 (from dV) * 1.e-36 (from Lstar) * 1.e-25 (from local forlines)
        grids(iG)%resLinePackets(grids(iG)%active(ix,iy,iz)) = nint(lineIntensity*1.e-16/(Lstar(1)/Nphotons(1)))

      end subroutine initResLinePackets



      ! this subroutine calculates the H, He and heavy ions f-b and f-f
      ! emission coefficients
      ! - it can only be called by emission driver -
      subroutine fb_ff()
        implicit none

        ! local variables

        logical            :: lgTeOut         ! is Te out of range of
        ! available f-b coeffs

        integer            :: elem, ion       ! counters
        integer            :: g0,&            ! stat weight of (elem, nElec) ground state
             & g1             ! stat weight of (elem, nElec-1) ground state
        integer            :: HIPnuP, &       ! pointer to the H IP in nuArray
             & HeIPnuP,&                      ! pointer to the HeI IP in nuArray
             & HeIIPnuP,&                     ! pointer to the HeII IP in nuArray
             & highNuP,&                      ! pointer to the hi en of the current ion in nuArray
             & IPnuP                          ! pointer to the IP of the current ion in nuArray
        integer            :: i, j            ! counters
        integer            :: iup, ilow       ! counters
        integer            :: nElec           ! number of electrons in the ion
        integer            :: nTemp           ! =1 if 5000K<Te<10000K, =2 if 10000K<Te<20000K
        integer            :: outShell        ! outer shell number (1 for k-shell)
        integer            :: xSecP           ! pointer to phot x sec of ion M in xSecArray


        real, dimension(3)              :: statW      ! g0/g1 for HI, HeI and HeII

        double precision                :: aFit, &    ! general calculations factors
             & factor, &
             & expFactor
        double precision                :: constant   ! general calculation constant
        double precision                :: phXSecHI,& ! phot x sec for HI
             & phXSecHeI,&                            ! phot x sec for HeI
             & phXSecHeII,&                           ! phot x sec for HeII
             & phXSecM                                ! phot x sec for ion M
        real, allocatable :: logGammaHIloc(:), logGammaHeIloc(:), logGammaHeIIloc(:)
                                                      ! gamma [e-40 erg/Hz] for HI, HeI and HeII

        allocate (logGammaHIloc(nlimGammaHI), stat=err)
        if (err /= 0) then
            print*, "! fb_ff: can't allocate array memory"
            stop
        end if
        allocate (logGammaHeIloc(nlimGammaHeI), stat=err)
        if (err /= 0) then
            print*, "! fb_ff: can't allocate array memory"
            stop
        end if
        allocate (logGammaHeIIloc(nlimGammaHeII), stat=err)
        if (err /= 0) then
            print*, "! fb_ff: can't allocate array memory"
            stop
        end if

        logGammaHIloc = 0.
        logGammaHeIloc = 0.
        logGammaHeIIloc = 0.

        ! interpolate the coefficients in Temperature (linear in log-log)

        ! check what coefficients are needed for the local electron Temperature
        lgTeOut = .false. ! (re)initialize out of range Te flag
        if (TeUsed <= tkGamma(1)) then
            lgTeOut = .true.
            logGammaHIloc = logGammaHI(1,:)
            logGammaHeIloc = logGammaHeI(1,:)
            logGammaHeIIloc = logGammaHeII(1,:)
        else if (TeUsed >= tkGamma(ntkGamma)) then
            lgTeOut = .true.
            logGammaHIloc = logGammaHI(ntkGamma,:)
            logGammaHeIloc = logGammaHeI(ntkGamma,:)
            logGammaHeIIloc = logGammaHeII(ntkGamma,:)
         else
            call locate (tkGamma, TeUsed, nTemp)

            factor = log10(TeUsed/tkGamma(nTemp))
            do i = 1, nlimGammaHI
               aFit = (logGammaHI(nTemp+1,i)-logGammaHI(nTemp,i))/ &
                    & log10(tkGamma(ntemp+1)/tkGamma(ntemp))
               logGammaHIloc(i) = logGammaHI(nTemp,i) + real(aFit * factor)
            end do

            do i = 1, nlimGammaHeI
               aFit = (logGammaHeI(nTemp+1,i)-logGammaHeI(nTemp,i))/ &
                    & log10(tkGamma(ntemp+1)/tkGamma(ntemp))
               logGammaHeIloc(i) = logGammaHeI(nTemp,i) + real(aFit * factor)

            end do

            do i = 1, nlimGammaHeII
               aFit = (logGammaHeII(nTemp+1,i)-logGammaHeII(nTemp,i))/ &
                    & log10(tkGamma(ntemp+1)/tkGamma(ntemp))
               logGammaHeIIloc(i) = logGammaHeII(nTemp,i) + real(aFit * factor)

            end do
        end if


        ! calculate f-b and f-f emissivity of HI, HeI and HeII
        ! interpolate between the edges in nu, for the HI, HeI and
        ! HeII series

        ! calculate gammaHI (nu<1.Ryd)
        do i = 1, nlimGammaHI/2
            iup  = HINuEdgeP(2*i)
            ilow = HINuEdgeP(2*i - 1)

            if (iup == ilow) then
                print*, "! fb_ff: frequency grid too course - divide&
                     & by zero                          [nu]",&
                     & nuArray(iup)
                stop
            end if
            aFit = (logGammaHIloc(2*i)-logGammaHIloc(2*i - 1)) /&
                 & (nuArray(iup) - nuArray(ilow))
            ! carry out interpolation between edges
            do j = ilow, iup-1
                gammaHI(j) = logGammaHIloc(2*i)+aFit* (nuArray(j)&
                     &-nuArray(iup))
                gammaHI(j) = 10.**gammaHI(j)
            end do
        end do

        ! calculate gammaHeI (nu<0.799Ryd)
        ! note that we are not going all the way up to 1.8ryd.. can be changed

        do i = 1, nlimGammaHeI/2
            iup  = HeINuEdgeP(2*i)
            ilow = HeINuEdgeP(2*i - 1)

            if (iup == ilow) then
                print*, "! fb_ff: frequency grid too course - divide&
                     & by zero                          [nu]",&
                     & nuArray(iup)
                stop
            end if
            aFit = (logGammaHeIloc(2*i)-logGammaHeIloc(2*i - 1)) /&
                 & (nuArray(iup) - nuArray(ilow))
            ! carry out interpolation between edges
            do j = ilow, iup-1
                gammaHeI(j) = logGammaHeIloc(2*i)+aFit* (nuArray(j)&
                     &-nuArray(iup))
                gammaHeI(j) = 10.**gammaHeI(j)


            end do
        end do


        ! calculate gammaHeII (nu<4.0Ryd)

        do i = 1, nlimGammaHeII/2
            iup  = HeIINuEdgeP(2*i)
            ilow = HeIINuEdgeP(2*i - 1)


            if (iup == ilow) then
                print*, "! fb_ff: frequency grid too course - divide&
                     & by zero                          [nu]",&
                     & nuArray(iup)
                stop
            end if

            aFit = (logGammaHeIIloc(2*i)-logGammaHeIIloc(2*i - 1)) /&
                 & (nuArray(iup) - nuArray(ilow))
            ! carry out interpolation between edges
            do j = ilow, iup-1

                gammaHeII(j) = logGammaHeIIloc(2*i)+aFit* (nuArray(j)&
                     &-nuArray(iup))
                gammaHeII(j) = 10.**gammaHeII(j)


            end do
        end do

        ! calculate f-b emission for HI  (nu > 1.), for HeI (nu > 1.8 Ryd)
        ! and for HeII (nu > 4.0 Ryd) by means of Milne relation
        ! - note the ff contribution will then need to be added separately
        ! so set up the free free coefficients
        call free_free()

        constant = 4.9874105e-6 ! Ryd*Ryd*(h^2/(2*Pi*Me*K))**(3/2) [cm*K^(3/2)]
        HIPnuP   = HlevNuP(1)
        HeIPnuP = HeIlevNuP(1)
        HeIIPnuP = HeIIlevNuP(1)
        statW = (/2., 0.5, 2./)
        do i = HIPnuP, nbins
            factor = (nuArray(i)*nuArray(i)*nuArray(i)) / (TeUsed*sqrTeUsed)
            expFactor = exp(dble( (-nuArray(i) + nuArray(HIPnuP)) * hcRyd_k / TeUsed))

            phXSecHI =  xSecArray(i-HIPnuP+1+HlevXSecP(1)-1)
            gammaHI(i) = fourPi * phXSecHI * statW(1) * hcRyd * constant*&
&                          factor * expFactor * 1.e20 *1.e20
            ! add the free free contribution
            gammaHI(i) = gammaHI(i)+ffCoeff1(i)
            ! calculate gammaHeI
!            if (i >= HeIPnuP) then
            if (i >= HeINuEdgeP(nlimGammaHeI) ) then
                expFactor = exp(dble( (-nuArray(i) + nuArray(HeIPnuP)) * hcRyd_k / TeUsed))
                phXSecHeI = xSecArray(i-HeIPnuP+1+HeISingXSecP(1)-1)

                gammaHeI(i) = fourPi * phXSecHeI * statW(2) * hcRyd * constant*&
&                          factor * expFactor * 1.e20 *1.e20
                ! add the free free contribution
                gammaHeI(i) = gammaHeI(i) + ffCoeff1(i)
                if (i >= HeIINuEdgeP(nlimGammaHeII)) then
                    expFactor  = exp(dble( (-nuArray(i) + nuArray(HeIIPnuP)) * hcRyd_k / TeUsed))
                    phXSecHeII = xSecArray(i-HeIIPnuP+1+HeIIXSecP(1)-1)
                    gammaHeII(i) = fourPi * phXSecHeII * statW(3) * hcRyd * constant*&
&                              factor * expFactor * 1.e20 *1.e20
                    ! add the free free contribution
                    gammaHeII(i) = gammaHeII(i) + ffCoeff2(i)
                end if
            end if
        end do

        ! calculate gammaHeavies
        do i = 1, nbins
           ! only elemnts up to z=19 calculated.. for now (problem with statistical
           ! weights for z>19. Contribution from elements wih Z > 19 generally small.
           do elem = 3, 19

                do ion = 1, nstages-1
                    ! check if this element is present in the nebula
                    if (.not.lgElementOn(elem)) exit

                    if (ion > elem) exit

                    ! find the number of electron in this ion
                    nElec = elem - ion +1

                    ! find the outer shell number and stat weights
                    call getOuterShell(elem, nElec, outShell, g0, g1)

                    ! get pointer to this ion's high energy limit in nuArray
                    highNuP = elementP(elem, ion, outShell, 2)
                    if ( highNuP > nbins ) then
                        print*, "! fb_ff: high frequency limit beyond grid limit. Increase&
&                             frequency grid, or switch element off [nuMax,elem,&
&                             ion]", nuMax,elem,ion
                        stop
                    end if

                    ! get pointer to this ion's IP in nuArray
                    IPnuP = elementP(elem, ion, outShell, 1)
                    ! check IP within frequency range
                    if ( IPnuP > nbins ) then
                        print*, "! fb_ff: IP frequency beyond grid limit. Increase&
&                             frequency grid, or switch element off [nuMax,elem,&
&                             ion]", nuMax,elem,ion
                        stop
                    end if

                    ! check IP of atom against current energy
                    if ( (i >= IPnuP) .and. (i < highNuP) ) then

                        ! get pointer to phot xSec of this ion in xSecArray
                        xSecP = elementP(elem, ion, outShell, 3)

                        ! get phot xSec of this ion at this energy
                        phXSecM = xSecArray(i+xSecP-IPnuP+1-1)

                        ! sum up the coefficients
                        expFactor = exp( dble((-nuArray(i)+nuArray(IPnuP)) * hcRyd_k / TeUsed))

                        gammaHeavies(i) = gammaHeavies(i) + &
&                                  expFactor * phXSecM * (real(g0)/real(g1)) * &
&                                  ionDenUsed(elementXref(elem), ion+1) * grids(iG)%elemAbun(grids(iG)%abFileIndex(ix,iy,iz),elem)

                    end if
                    end do
                end do
            factor = nuArray(i)*nuArray(i)*nuArray(i) / (TeUsed*sqrTeUsed)
            gammaHeavies(i) = gammaHeavies(i) * fourPi * constant *&
&                                hcRyd * factor * 1.e20 * 1.e20

        end do

    end subroutine fb_ff

    subroutine twoPhoton()
        implicit none

        ! local variables
        integer                 :: i      ! counter

        ! calculate the two photon emission due to HI and HeII
        ! (use the hydrogenic ions function)
        do i = 1, nbins
            twoPhotHI(i) = hydro2phot(nuArray(i), 1)
            twoPhotHeII(i) = hydro2phot(nuArray(i), 2)
        end do

        ! calculate the two photon emission due to HeI
        call HeI2photSub()
    end subroutine twoPhoton


    ! this function calculates the two photon emission coefficient
    ! for Hydrogenic ions. See Nussbaumer and Schmutz, A&A 138(1984)495
    function hydro2phot(nu, Z)
        implicit none

        double precision                :: hydro2phot   ! emission coeff for 2-phot cont [e-40 erg/cm^3/s/Hz]
                                            ! for the hydrogenic ion [e-40 erg*cm^3/s/Hz]
        real, intent(in)    :: nu           ! frequency [Ryd]

        integer, intent(in) :: Z            ! nuclear charge

        ! local variables
        real                :: alphaEffH22S ! effective recombination coefficient
                                            ! to the 22S state of HI [e-13 cm^3/s]
        real                :: alphaEffHeII21S ! effective recombination coefficient
                                            ! to the 21S state of HeII [e-13 cm^3/s]
        real, parameter     :: A22S12S=8.23 ! Einstein A of forbibben LyAlpha [1/s]
        real, parameter     :: A2qH = 8.2249! total hydrogen 2s->1s 2 photon
                                            ! transition probability [1/s]
        real                :: A2qZ         ! total Z-ion 2s->1s 2 photon
                                            ! transition probability [1/s]
        real                :: Ay           ! transition probability (nu-dependent)
        real                :: factor       ! general interpolation factor
        real                :: gNu          ! spec distribution of 2phot emission
                                            ! [e-27 erg/Hz]
        real                :: nu0          ! frequencyof the 2s->1s transition
        real                :: Q22S22P      ! collisional transitional rates
                                            ! for HI 22S-22P
        real                :: y            ! nu/nu0 where nu0is the frequency
                                            ! of the 2s->1s transition
        ! select the hydrogenic ion
        select case(Z)
        ! for HI
        case (1)
            ! nu [Ryd] of 2s->1s transition (=1215.7 A)
            nu0 = 0.7496
            y = nu/nu0

            ! check for nu >= nu0
            if (nu >= nu0 ) then
                hydro2phot = 0.
                return
            end if

            ! for alphaEffH22S see Pengelly, MNRAS, 127(1964)145
            alphaEffH22S = 0.8368*((TeUsed*1.e-4)**(-0.723))

            Ay = 202.0*(y*(1-y)*(1-(4*y*(1-y))**0.8) + &
&                 0.88*((y*(1-y))**1.53)*(4*y*(1-y))**0.8)

            gNu = hPlanck*y*Ay/A2qH
            gNu = gNu*1e27

            ! calculate the collisional transitional rates for HI 22S-22P
            ! interpolate over temperature the value given in table 4.10
            ! from Osterbrock
            if (TeUsed <= 10000.) then
                Q22S22P = 5.31e-4
            else if (TeUsed >= 20000.) then
                Q22S22P = 4.71e-4
            else
                factor = log10(4.71e-4/5.31e-4) / log10(2.)
                Q22S22P = 10**( log10(5.31e-4) + factor*log10(TeUsed/10000.) )
            end if

            hydro2phot = alphaEffH22s*gNu / (1.+(NeUsed*Q22S22P)/A22S12S)

        case (2) ! HeII
            !  nu [Ryd] of 2s->1s transition (=303.8 A)
            nu0 = 3.00
            y = nu/nu0

            ! check for nu >= nu0
            if (nu >= nu0 ) then
                hydro2phot = 0.
                return
            end if

            ! for alphaEffHeII21S see Storey & Hummer, MNRAS, 272(1995)41
            ! the values used are for Ne = 100 cm^-3; however alphaEffHeII21S is not
            ! very sensitive to density.. only interpolate over temperature
            if (TeUsed <= 5000.) then
                alphaEffHeII21S = 6.161
            else if (TeUsed >= 30000.) then
                alphaEffHeII21S = 2.035
            else if (TeUsed > 5000. .and. TeUsed <= 10000. ) then
                factor = log10(4.091/6.161) / log10(2.)
                alphaEffHeII21S = 10**( log10(6.161) + factor*log10(TeUsed/5000.) )
            else if (TeUsed > 10000. .and. TeUsed <= 15000. ) then
                factor = log10(3.189/4.091) / log10(1.5)
                alphaEffHeII21S = 10**( log10(4.091) + factor*log10(TeUsed/10000.) )
            else if (TeUsed > 15000. .and. TeUsed < 30000. ) then
                factor = log10(2.035/3.189) / log10(2.)
                alphaEffHeII21S = 10**( log10(3.189) + factor*log10(TeUsed/15000.) )
            end if

            Ay = (Z**6)*0.9994667*202.0*(y*(1-y)*(1-(4*y*(1-y))**0.8) + &
&                 0.88*((y*(1-y))**1.53)*(4*y*(1-y))**0.8)

            A2qZ = 8.226*Z**6

            gNu = hPlanck*y*Ay/A2qZ
            gNu = gNu*1e27

            ! collisional de-excitation of the 22S of HeII is negligible

            ! caalculate the 2 photon emission
            hydro2phot = alphaEffHeII21s*gNu


        end select

    end function hydro2phot

    subroutine HeI2photSub()
        implicit none

        ! local variables
        integer             :: i, j          ! counters

        real, parameter     :: A21S11S=51.3  ! HeI 2q [1/s]
                                             ! Almog & Netzer, MNRAS 238(1989)57
        real, parameter     :: nu0=1.514     ! 21s -> 11s frequency [Ryd]

        real                :: alphaEff21SHeI! effective rec coeff to HeI 21S [e-14 cm^3/s]
                                             ! Almog & Netzer, MNRAS 238(1989)57
        real                :: Ay            ! interpolated rate [1/s]
        real                :: fit1, fit2    ! interpolation coefficients
        real                :: y             ! nu/nu0

        ! assume all HeI singlets finally end up in the 2^1S
        ! use total recombination cofficient to all singlets Benjamin, Skillman and SMits, ApJ, 1999, 514, 307
        alphaEff21SHeI = 6.23*((TeUsed/10000.)**(-0.827))

        ! calculate coefficients as a function of frequency
        j = 1
        do i = 1, nbins
            ! calculate y
            y  = nuArray(i)/nu0

            if ( y > y_dat(j) ) j=j+1
            if ( j >= 41 ) exit

            fit1 = (Ay_dat(j+1)-Ay_dat(j)) / &
&                                  (y_dat(j+1)-y_dat(j))
            fit2 = Ay_dat(j) - y_dat(j)*fit1

            Ay = fit1*y + fit2

            if ( Ay < 9.2163086E-03 ) Ay = 0.

            twoPhotHeI(i) = alphaEff21SHeI*Ay*0.66262*y/A21S11S
        end do

      end subroutine HeI2photSub

    ! this subroutine sets the ff emission coefficients for z=1 (ffCoeff1)
    ! and z=2 (ffCoeff2)
    subroutine free_free()
        implicit none

        ! local variables
        integer        :: i   ! counter

        do i = 1, nbins
            ! find the free-free emission coefficient for H+ and He+
            ffCoeff1(i) = ffCoeff(nuArray(i), 1, gauntFF(i))
            ! find the free-free emission coefficient for He++
            ffCoeff2(i) = ffCoeff(nuArray(i), 2, gauntFFHeII(i))
        end do
    end subroutine free_free

    ! this function calculates the ff emission coeficient for interactions between
    ! ions of nuclear charge Z and electrons.
    ! see Allen pg 103.
    function ffCoeff(nu, Z, g)
        implicit none

        double precision     :: ffCoeff     ! ff emission coefficient [e-40 erg*cm^3/s.Hz]
        real, intent(in)     :: g           ! ff gaunt
        real, intent(in)     :: nu          ! frequency [Ryd]

        integer, intent(in)  :: Z           ! nuclear charge

        ! local variables
        double precision     :: expFactor   ! exponential factor

        expFactor = exp(dble(-nu*hcRyd_k/TeUsed))

        ffCoeff = fourPi*54.43*Z*Z*g*expFactor/sqrTeUsed

    end function ffCoeff

    subroutine RecLinesEmission()
        implicit none

        ! local variables
        integer                    :: i, denint   ! counters
        integer                    :: ilow,&      ! pointer to lower level
&                                      iup        ! pointer to upper level

        real                       :: Hbeta       ! Hbeta emission
        real                       :: HeII4686    ! HeII 4686 emission
        real                       :: Lalpha      ! Lalpha emission
        real                       :: T4          ! TeUsed/10000.
        real                       :: x1, x2

        T4 = TeUsed / 10000.

        ! copy HI data into array. this is where reading from file used to happen

        HIRecLines = HIRecLineData

        ! do hydrogenic ions first

        ! calculate Hbeta
        ! Hbeta = 2530./(TeUsed**0.833) ! TeUsed < 26000K CASE
        ! fits to Storey and Hummer MNRAS 272(1995)41
        Hbeta = 10**(-0.870*log10Te + 3.57)
        Hbeta = Hbeta*NeUsed*ionDenUsed(elementXref(1),2)*grids(iG)%elemAbun(grids(iG)%abFileIndex(ix,iy,iz),1)

        ! calculate emission due to HI recombination lines [e-25 ergs/s/cm^3]
        do iup = 15, 3, -1
            do ilow = 2, min(8, iup-1)
                HIRecLines(iup, ilow) = HIRecLines(iup, ilow)*Hbeta
            end do
        end do

        ! add contribution of Lyman alpha
        ! fits to Storey and Hummer MNRAS 272(1995)41
        Lalpha = 10**(-0.897*log10Te + 5.05)
        HIRecLines(15, 8) =HIRecLines(15, 8) + grids(iG)%elemAbun(grids(iG)%abFileIndex(ix,iy,iz),1)*&
             & ionDenUsed(elementXref(1),2)*&
             & NeUsed*Lalpha


        ! copy array. this is where the file used to be read in

        HeIIRecLines = HeIIRecLinedata

        ! calculate HeII 4686 [E-25 ergs*cm^3/s]
        HeII4686 = 10.**(-.997*log10(TeUsed)+5.16)
        HeII4686 = HeII4686*NeUsed*grids(iG)%elemAbun(grids(iG)%abFileIndex(ix,iy,iz),2)*ionDenUsed(elementXref(2),3)

        ! calculate emission due to HeI recombination lines [e-25 ergs/s/cm^3]
        do iup = 30, 3, -1
            do ilow = 2, min(16, iup-1)
                HeIIRecLines(iup, ilow) = HeIIRecLines(iup, ilow)*HeII4686
             end do
        end do

        ! now do HeI

        if (grids(iG)%Ne(grids(iG)%active(ix,iy,iz)) <= 100.) then
           denint=0
        elseif (grids(iG)%Ne(grids(iG)%active(ix,iy,iz)) > 100. .and. grids(iG)%Ne(grids(iG)%active(ix,iy,iz)) <= 1.e4) then
           denint=1
        elseif (grids(iG)%Ne(grids(iG)%active(ix,iy,iz)) > 1.e4 .and. grids(iG)%Ne(grids(iG)%active(ix,iy,iz)) <= 1.e6) then
            denint=2
        elseif (grids(iG)%Ne(grids(iG)%active(ix,iy,iz)) > 1.e6) then
           denint=3
        end if

        ! data from Benjamin, Skillman and Smits ApJ514(1999)307 [e-25 ergs*cm^3/s]
        if (denint>0.and.denint<3) then
           do i = 1, 34
              x1=HeIrecLineCoeff(i,denint,1)*(T4**(HeIrecLineCoeff(i,denint,2)))*exp(HeIrecLineCoeff(i,denint,3)/T4)
              x2=HeIrecLineCoeff(i,denint+1,1)*(T4**(HeIrecLineCoeff(i,denint+1,2)))*exp(HeIrecLineCoeff(i,denint+1,3)/T4)

              HeIRecLines(i) = x1+((x2-x1)*(NeUsed-100.**denint)/(100.**(denint+1)-100.**(denint)))
           end do
       elseif(denint==0) then
           do i = 1, 34
              HeIRecLines(i) = HeIrecLineCoeff(i,1,1)*(T4**(HeIrecLineCoeff(i,1,2)))*exp(HeIrecLineCoeff(i,1,3)/T4)
           end do
        elseif(denint==3) then
           do i = 1, 34
              HeIRecLines(i) = HeIrecLineCoeff(i,3,1)*(T4**(HeIrecLineCoeff(i,3,2)))*exp(HeIrecLineCoeff(i,3,3)/T4)
           end do
        end if
        HeIRecLines=HeIRecLines*NeUsed*grids(iG)%elemAbun(grids(iG)%abFileIndex(ix,iy,iz),2)*ionDenUsed(elementXref(2),2)
    end subroutine RecLinesEmission


    ! this subroutine is the driver for the calculation of the emissivity
    ! from the heavy elements forbidden lines.
    subroutine forLines()
        implicit none

        integer :: elem, ion ! counters

        ! re-initialize forbiddenLines
        forbiddenLines = 0.

        do elem = 3, nElements
           do ion = 1, min(elem+1, nstages)
              if (.not.lgElementOn(elem)) exit

              if (lgDataAvailable(elem, ion)) then

                 if (elem == 26 .and. ion == 2) then
                    if (nstages > 2) then
                       call equilibrium(file_name=dataFile(elem, ion), &
                            &ionDenUp=ionDenUsed(elementXref(elem),ion+1)&
                            &/ionDenUsed(elementXref(elem),ion), Te=TeUsed,&
                            &Ne=NeUsed, FlineEm=forbiddenLinesLarge(&
                            &1:nForLevelsLarge, 1:nForLevelsLarge))
                    else
                       call equilibrium(file_name=dataFile(elem, ion), &
                            &ionDenUp=0., Te=TeUsed,&
                            &Ne=NeUsed, FlineEm=forbiddenLinesLarge(&
                            &1:nForLevelsLarge, 1:nForLevelsLarge))
                    end if

                    forbiddenLinesLarge(:, :) =&
                         &forbiddenLinesLarge(:, :)*grids(iG)%elemAbun(&
                         &grids(iG)%abFileIndex(ix,iy,iz),elem)*&
                         & ionDenUsed(elementXref(elem), ion)

                 else
                    if (ion<nstages) then
                       call equilibrium(file_name=dataFile(elem, ion), &
                            &ionDenUp=ionDenUsed(elementXref(elem),ion+1)/&
                            &ionDenUsed(elementXref(elem),ion), Te=TeUsed,&
                            &Ne=NeUsed, FlineEm=forbiddenLines(elem, ion,&
                            &1:nForLevels, 1:nForLevels))
                    else
                       call equilibrium(file_name=dataFile(elem, ion), &
                            &ionDenUp=0., Te=TeUsed, Ne=NeUsed, &
                            &FlineEm=forbiddenLines(elem, ion,1:nForLevels,&
                            &1:nForLevels))
                    end if

                    forbiddenLines(elem, ion, :, :) =&
                         &forbiddenLines(elem, ion, :, :)*grids(iG)%elemAbun(&
                         &grids(iG)%abFileIndex(ix,iy,iz),elem)*&
                         & ionDenUsed(elementXref(elem), ion)

                 end if
              end if

           end do
        end do


        ! scale the forbidden lines emissivity to give units of [10^-25 erg/s/Ngas]
        ! comment: the forbidden line emissivity is so far in units of cm^-1/s/Ngas
        !          the energy [erg] of unit wave number [cm^-1] is 1.9865e-16, hence
        !          the right units are obtained by multiplying by 1.9865e-16*1e25
        !          which is 1.9865*1e9
        forbiddenLines = forbiddenLines*1.9865e9

    end subroutine forLines

    subroutine setDiffusePDF()
        implicit none

        ! local variables

        real (kind=8)     :: tg
        real(kind=8),dimension(nTbins) :: Tspike,Pspike

        real              :: alpha2tS          ! effective rec coeff to the 2s trip HeI
        real              :: bb                ! blackbody
        real              :: const             ! general calculation constant
        real              :: correction        ! general correction term
        real              :: normalize         ! normHI+normHeI+normHeII
        real              :: normDust           ! normalization constant for dust
        real              :: normFor           ! normalization constant for lines
        real              :: normHI            ! normalization constant for HI
        real              :: normHeI           !                            HeI
        real              :: normHeII          !                            HeII
        real              :: normRec           !                            rec. lines
        real              :: treal
        real              :: T4                ! TeUsed/10000.

        real, allocatable     :: sumDiffuseDust(:) ! summation terms for dust emission
        real, allocatable     :: sumDiffuseHI(:)   ! summation terms for HI emission
        real, allocatable     :: sumDiffuseHeI(:)  ! summation terms for HeI emission
        real, allocatable     :: sumDiffuseHeII(:) ! summation terms for HeII emission

        integer           :: dcp                ! local dustComPointer
        integer           :: elem, ion          ! counters
        integer           :: err                ! allocation error status
        integer           :: j2TsP              ! pointer to 2s triplet state in nuArray
        integer           :: i,iup,ilow,j       ! counters
        integer           :: nuP                ! frequency pointer in nuArray
        integer           :: nS, ai, freq, iT   ! dust counters

        character(len=50) :: cShapeLoc

        real,dimension(NHeIILyman) :: HeIILyman ! HeII Lyman lines em. [e-25ergs*cm^3/s]

        cShapeLoc = 'blackbody'

        ! allocate space for the summation arrays
        allocate(sumDiffuseHI(1:nbins), stat = err)
        if (err /= 0) then
            print*, "! setDiffusePDF: can't allocate recPDF array memory"
            stop
        end if
        allocate(sumDiffuseHeI(1:nbins), stat = err)
        if (err /= 0) then
            print*, "! setDiffusePDF: can't allocate recPDF array memory"
            stop
        end if
        allocate(sumDiffuseHeII(1:nbins), stat = err)
        if (err /= 0) then
            print*, "! setDiffusePDF: can't allocate recPDF array memory"
            stop
        end if



        ! assign pointers for the He line photons
        call locate(nuArray, 1.45673, j2TsP)

        ! calculate normalization constants for the HI, HeI and HeII diffuse probs

        ! initialize constants
        normHI   = 0.
        normHeI  = 0.
        normHeII = 0.

        sumDiffuseHI = 0.
        sumDiffuseHeI = 0.
        sumDiffuseHeII = 0.

        ! perform summations
        do i = 1, nbins

           sumDiffuseHI(i) = real(cRyd*widFlx(i)*emissionHI(i)/1.e15)

           normHI = normHI + sumDiffuseHI(i)

           sumDiffuseHeI(i) =  real(cRyd*widFlx(i)*emissionHeI(i)/1.e15)

           normHeI = normHeI + sumDiffuseHeI(i)

           sumDiffuseHeII(i) = real(cRyd*widFlx(i)*emissionHeII(i)/1.e15)

           normHeII = normHeII + sumDiffuseHeII(i)

        end do


        ! Add contribution of HeI lines able to ionize HI

        ! triplet states:
        ! calculate effective recombination coefficients to triplet states[e-14 cm^3/s]
        ! Benjamin, SKillman and mits, 1999, ApJ 514, 307
        T4 = TeUsed*1.e-4
        alpha2tS = 27.2*(T4**(-0.678))

        ! calculate correction for partial sums and normalization constant
        ! triplet 2s
        ! NOTE: multiply by 1.e11 to make units of [e-25 erg/cm^3/s] as e-14 from
        ! rec coeff (see above).
        correction = alpha2tS * &
             & NeUsed*grids(iG)%elemAbun(grids(iG)%abFileIndex(ix,iy,iz),2)*&
             &ionDenUsed(elementXref(2),2)*1.45673*hcRyd*1e11

        sumDiffuseHeI(j2TsP) = sumDiffuseHeI(j2TsP) + correction
        normHeI = normHeI + correction

        ! Add contribution of HeII lines able to ionize HI and HeII

        ! copy HeIILymanData into new array.  this is where file used to be read in

        HeIILyman = HeIILymanData

        ! calculate Lyman alpha first
        HeIILyman(4) = 10.**(-0.792*log10(TeUsed)+6.01)
        HeIILyman(4) = HeIILyman(4)*NeUsed*ionDenUsed(elementXref(2),3)*grids(iG)%elemAbun(grids(iG)%abFileIndex(ix,iy,iz),2)

        ! calculate emission due to HeII Lyman lines [e-25 ergs/s/cm^3]
        do i = 1, NHeIILyman-1
            HeIILyman(i) = HeIILyman(i)*HeIILyman(4)
        end do

        ! add contributions in respective bins
        do i = 1, NHeIILyman
            ! locate the frequency bin in the array
            call locate(NuArray, HeIILymanNu(i), NuP)
            ! add contribution to HeII partial sums ...
            sumDiffuseHeII(NuP) = sumDiffuseHeII(NuP) + HeIILyman(i)
            ! ... and to HeII normilazation constant
            normHeII = normHeII + HeIILyman(i)
        end do


        ! calculate dust emission
        if (lgDust) then

           dcp = dustComPoint(nspE)

           allocate(sumDiffuseDust(1:nbins), stat = err)
           if (err /= 0) then
              print*, "! setDiffusePDF: can't allocate sumDiffuseDust array memory"
              stop
           end if

           sumDiffuseDust = 0.
           normDust       = 0.
           do ai = 1, nSizes
              do nS = 1, nSpeciesPart(nspE)

                 if (grids(iG)%Tdust(nS,ai,cellPUsed)<TdustSublime(dcp-1+nS)) then

                    if (lgQHeat .and. grainRadius(ai)<minaQHeat .and. &
                         & convPercent>minConvQheat .and. nIterateMC>1) then

                       tg =  grids(iG)%Tdust(nS,ai,cellPused)
                       Tspike=0.
                       Pspike=0.

                       call qHeat(nS, ai,tg,Tspike,Pspike)

                       if (lgWritePss .and. taskid==0) then
                          write(89, *) '              ix iy iz cellp nSpecies aRadius Teq'
                          write(89, *)  ix, iy, iz, cellpUsed, ns, grainRadius(ai), tg
                          write(89, *) '              i Tspike(i) Pspike(i)'
                          do iT = 1, nTbins
                             write(89, *) it, Tspike(it), Pspike(it)
                          end do
                          write(89, *) 'Tmean: ', tg
                          write(89, *) ' '
                       end if

                       do freq = 1, nbins
                          do iT=1,nTbins
                             treal = real(Tspike(iT))
                             bb = getFlux(nuArray(freq), treal, cShapeLoc)
                             sumDiffuseDust(freq) = sumDiffuseDust(freq) + &
                                  &  real(xSecArray(dustAbsXsecP(dcp-1+nS,ai)+freq-1)*bb*widFlx(freq)*&
                                  & grainWeight(ai)*grainAbun(nspE, nS)*Pspike(iT))
                             normDust = normDust+real(xSecArray(dustAbsXsecP(dcp+nS-1,ai)+freq-1)*bb*widFlx(freq)*&
                                  & grainWeight(ai)*grainAbun(nspE, nS)*Pspike(iT))
                          end do
                       end do

                    else

                       do freq = 1, nbins
                          bb = getFlux(nuArray(freq), grids(iG)%Tdust(nS,ai,cellPUsed), cShapeLoc)
                          sumDiffuseDust(freq) = sumDiffuseDust(freq) + &
                               &  xSecArray(dustAbsXsecP(dcp-1+nS,ai)+freq-1)*bb*widFlx(freq)*&
                               & grainWeight(ai)*grainAbun(nspE,nS)
                          normDust = normDust+xSecArray(dustAbsXsecP(dcp-1+nS,ai)+freq-1)*bb*widFlx(freq)*&
                               & grainWeight(ai)*grainAbun(nspE, nS)
                       end do
                    end if
                 end if

              end do
           end do

           ! the hPlanck is re-introduced here (was excluded in the bb calcs)
           const = hPlanck*4.*Pi*1.e25*cRyd
           sumDiffuseDust = sumDiffuseDust*const*grids(iG)%Ndust(cellPUsed)/grids(iG)%Hden(cellPUsed)
           normDust = normDust*const*grids(iG)%Ndust(cellPUsed)/grids(iG)%Hden(cellPUsed)

        end if

        ! Total normalization constant
        normalize = normHI + normHeI + normHeII

        if (lgDust) normalize = normalize+normDust

        ! Sum  up energy in recombination lines

        normRec = 0.
        ! HI
        do iup = 3, 15
            do ilow = 2, min0(8, iup-1)
                normRec = normRec+real(HIRecLines(iup, ilow))
            end do
        end do
        ! HeII
        do iup = 3, 30
            do ilow = 2, min0(16, iup-1)
                normRec = normRec+real(HeIIRecLines(iup, ilow))
            end do
        end do
        ! HeI singlets
        do i = 1, 34
            normRec = normRec+real(HeIRecLines(i))
        end do

        ! Sum  up energy in forbidden lines

        normFor = 0.
        do elem = 3, nElements
           do ion = 1, min(elem+1, nstages)
              if (elem ==26 .and. ion==2) then
                 do ilow = 1, nForLevelsLarge
                    do iup = 1, nForLevelsLarge
                       if (forbiddenLinesLarge(ilow, iup) > 1.e-35)  then
                          normFor = normFor + real(forbiddenLinesLarge(ilow, iup))
                       end if
                    end do
                 end do
              else
                 do ilow = 1, nForLevels
                    do iup = 1, nForLevels
                       if (forbiddenLines(elem, ion, ilow, iup) > 1.e-35)  then
                          normFor = normFor + real(forbiddenLines(elem, ion, ilow, iup))
                       end if
                    end do
                 end do
              end if
           end do
        end do

        ! total energy in lines (note: this variable will later be turned into the fraction of
        ! non-ionizing line photons as in declaration)

        grids(iG)%totalLines(cellPUsed) = normRec + normFor

        if (lgDust) then

           do i = 1, nbins
              if (i == 1) then
                 grids(iG)%recPDF(cellPUsed, i) = sumDiffuseHI(i) + sumDiffuseHeI(i) +&
                      & sumDiffuseHeII(i) + sumDiffuseDust(i)
              else
                 grids(iG)%recPDF(cellPUsed, i) = grids(iG)%recPDF(cellPUsed, i-1) +&
                      & sumDiffuseHI(i) + sumDiffuseHeI(i) +&
                      & sumDiffuseHeII(i) + sumDiffuseDust(i)
              end if

           end do

        else

           do i = 1, nbins
              if (i == 1) then
                 grids(iG)%recPDF(cellPUsed, i) = (sumDiffuseHI(i) + sumDiffuseHeI(i) +&
                      & sumDiffuseHeII(i) )
              else
                 grids(iG)%recPDF(cellPUsed, i) = grids(iG)%recPDF(cellPUsed, i-1) +&
                      & (sumDiffuseHI(i) + sumDiffuseHeI(i) +&
                      & sumDiffuseHeII(i) )
              end if
           end do

        end if

        grids(iG)%recPDF(cellPUsed, :) = grids(iG)%recPDF(cellPUsed, :)/grids(iG)%recPDF(cellPUsed, nbins)

        grids(iG)%recPDF(cellPUsed, nbins) = 1.

        do i = 1, nbins
           if (grids(iG)%recPDF(cellPUsed, i) > 0.999998) grids(iG)%recPDF(cellPUsed, i) = 1.
        enddo

        ! calculate the PDF for recombination and forbidden lines
        if (lgDebug) then
           i = 1
           ! HI recombination lines
           do iup = 3, 15
              do ilow = 2, min(8, iup-1)
                 if (i == 1) then

                    grids(iG)%linePDF(cellPUsed, i) = real(HIRecLines(iup, ilow) / &
&                                                  grids(iG)%totalLines(grids(iG)%active(ix,iy,iz)))



                 else

                    grids(iG)%linePDF(cellPUsed, i) = grids(iG)%linePDF(cellPUsed, i-1) + &
&                        real(HIRecLines(iup, ilow) / grids(iG)%totalLines(cellPUsed))



                 end if
                 i = i+1

              end do
           end do

           ! HeI singlet recombination lines
           do j = 1, 34
              grids(iG)%linePDF(cellPUsed, i) = grids(iG)%linePDF(cellPUsed, i-1) + &
&                           real(HeIRecLines(j) / grids(iG)%totalLines(cellPUsed))
              i = i+1
           end do

           ! HeII recombination lines
           do iup = 3, 30
              do ilow = 2, min(16, iup -1)
                 grids(iG)%linePDF(cellPUsed, i) = grids(iG)%linePDF(grids(iG)%active(ix, iy,&
                      & iz), i-1) + real(HeIIRecLines(iup, ilow) / grids(iG)&
                      &%totalLines(grids(iG)%active(ix,iy,iz)))
                 i = i+1
              end do
           end do

           ! heavy elements forbidden lines
           do elem = 3, nElements
              do ion = 1, min(elem+1, nstages)

                 if (.not.lgElementOn(elem)) exit
                 if (lgDataAvailable(elem, ion)) then
                    if (elem == 26 .and. ion == 2) then

                       do iup = 1, nForLevelsLarge
                          do ilow = 1, nForLevelsLarge
                             grids(iG)%linePDF(cellPUsed, i) = grids(iG)%linePDF(grids(iG)%active(ix, iy&
                                  &, iz), i-1) + real(forbiddenLinesLarge(iup, ilow)&
                                  & / grids(iG)%totalLines(grids(iG)%active(ix,iy,iz)))

                             if (grids(iG)%linePDF(cellPUsed, i) > 1. ) grids(iG)&
                                  &%linePDF(cellPUsed, i) = 1.
                             i = i+1

                          end do
                       end do

                    else

                       do iup = 1, nForLevels
                          do ilow = 1, nForLevels
                             grids(iG)%linePDF(cellPUsed, i) = grids(iG)%linePDF(grids(iG)%active(ix, iy&
                                  &, iz), i-1) + real(forbiddenLines(elem, ion, iup, ilow)&
                                  & / grids(iG)%totalLines(grids(iG)%active(ix,iy,iz)))

                             if (grids(iG)%linePDF(cellPUsed, i) > 1. ) grids(iG)&
                                  &%linePDF(cellPUsed, i) = 1.
                             i = i+1
                          end do
                       end do

                    end if
                 end if

              end do
           end do
           grids(iG)%linePDF(cellPUsed, nLines) = 1.

           ! calculate the probability of Hbeta
           HbetaProb = real(HIRecLines(4,2) / (grids(iG)%totalLines(grids(iG)%active(ix,iy,iz))&
                &+normalize))

        end if ! debug condition

        ! now compute the fraction of non-ionizing photons

        normalize = normalize + grids(iG)%totalLines(grids(iG)%active(ix,iy,iz))

        grids(iG)%totalLines(grids(iG)%active(ix,iy,iz)) = grids(iG)%totalLines(grids(iG)%active(ix,iy,iz)) / normalize
        ! deallocate arrays
        if ( allocated(sumDiffuseHI) ) deallocate(sumDiffuseHI)
        if ( allocated(sumDiffuseHeI) ) deallocate(sumDiffuseHeI)
        if ( allocated(sumDiffuseHeII) ) deallocate(sumDiffuseHeII)
        if (lgDust) then
           if ( allocated(sumDiffuseDust) ) deallocate(sumDiffuseDust)
        end if

    end subroutine setDiffusePDF

    subroutine setDustPDF()
      implicit none

      real :: bb,treal
      real (kind=8) :: tg
      real(kind=8),dimension(nTbins) :: Tspike,Pspike

      integer :: i, n, ai, iT, dcp ! counters

      character(len=50) :: cShapeLoc

      Tspike=0.
      Pspike=0.

      cShapeLoc = 'blackbody'

      dcp = dustComPoint(nspE)

      grids(iG)%dustPDF(grids(iG)%active(ix,iy,iz),:)=0.
      do n = 1, nSpeciesPart(nspE)
         do ai = 1, nSizes

            if (grids(iG)%Tdust(n,ai,cellPUsed) >0. .and. &
                 & grids(iG)%Tdust(n,ai,cellPused)<TdustSublime(dcp-1+n)) then


               if (lgQHeat .and. grainRadius(ai)<minaQHeat .and. &
                    & convPercent>minConvQheat.and. nIterateMC>1) then

                  tg =  grids(iG)%Tdust(n,ai,cellPused)

                  Tspike=0.
                  Pspike=0.

                  call qHeat(n, ai,tg,Tspike,Pspike)

                  do i = 1, nbins
                     do iT = 1, nTbins
                        treal = real(Tspike(iT))
                        bb = getFlux(nuArray(i), treal, cShapeLoc)
                        grids(iG)%dustPDF(cellPUsed, i) = grids(iG)%dustPDF(cellPUsed, i)+ &
                             & real(xSecArray(dustAbsXsecP(dcp-1+n,ai)+i-1)*bb*widFlx(i)*&
                             & grainWeight(ai)*&
                             & grainAbun(nspE, n)*Pspike(iT))
                     end do
                  end do

               else

                  do i = 1, nbins
                     treal = grids(iG)%Tdust(n,ai,cellPused)
                     bb = getFlux(nuArray(i), treal, cShapeLoc)
                     grids(iG)%dustPDF(cellPused, i) = grids(iG)%dustPDF(cellPused, i)+&
                          & xSecArray(dustAbsXsecP(n+dcp-1,ai)+i-1)*bb*widFlx(i)*&
                          & grainWeight(ai)*grainAbun(nspE, n)
                  end do
               end if

            end if
         end do
      end do

      ! normalise
      do i = 2, nbins

         grids(iG)%dustPDF(cellPused,i) = &
              & grids(iG)%dustPDF(cellPUsed,i-1)+grids(iG)%dustPDF(cellPUsed,i)

      end do
      grids(iG)%dustPDF(cellPused,:) = &
           grids(iG)%dustPDF(cellPused,:)/grids(iG)%dustPDF(cellPused,nbins)

      grids(iG)%dustPDF(cellPused,nbins) = 1.

    end subroutine setDustPDF


    ! calculates the quantum heating according to
    ! guhathakurta & draine (G&D, 1989) ApJ 345, 230
    ! adapted from a program originally written by
    ! R. Sylvester
    subroutine qHeat(ns,na,tg,temp,pss)
      implicit none

      real ::  tbase
      integer, intent(in) :: ns, na
      integer             :: i,j,ii,if, dcp
      integer             :: wlp,wllp,wlsp,natom

      character(len=1)    :: sorc

      real(kind=8), dimension(nTbins,nTbins) :: A, B
      real(kind=8), intent(inout) :: tg
      real(kind=8), intent(inout) :: temp(nTbins),pss(nTbins)
      real(kind=8)                :: lambda(nbins), sQabs(nbins),&
           & temp1(nbins),temp2(nbins)
      real(kind=8)                :: U(nTbins),dU(nTbins)
      real(kind=8)                :: mgrain,mdUdt,ch
      real(kind=8)                :: const1, radField(nbins),hc,wlim
      real(kind=8)                :: qHeatTemp,X(nTbins)
      real(kind=8)                :: UiTrun,sumX, sumBx
      real(kind=8)                :: wl,wll,wls
      real(kind=8)                :: qint,qint1,qint2,delwav

      integer :: ifreq

      dcp = dustComPoint(nspE)

      ! radiation field at this location in Flambdas
      if (lgDebug) then
         radField = grids(iG)%Jste(cellPUsed,:) + grids(iG)%Jdif(cellPUsed,:)
      else
         radField = grids(iG)%Jste(cellPUsed,:)
      end if

      do ifreq = 1, nbins
         radField(ifreq) = radField(ifreq)/(widflx(ifreq)*fr1ryd)

        temp1(ifreq) = (radField(ifreq)* (nuArray(ifreq)*fr1Ryd)**2)/(c)
         temp2(ifreq) = xSecArray(dustAbsXSecP(ns+dcp-1,na)+ifreq-1)
      end do
      do ifreq=1, nbins
         radField(ifreq) = temp1(nbins-ifreq+1)
         lambda(ifreq) = c/(nuArray(nbins-ifreq+1)*fr1Ryd)
         sQabs(ifreq) = temp2(nbins-ifreq+1)
      end do


      const1 = (hPlanck*fr1Ryd)
      hc = hPlanck*c

      if (grainRadius(na) > minaQHeat) then
         temp(1)=tg
         pss(1) = 1.
         do i = 2, nTbins
            temp(i)=0.
            pss(i) = 0.
         end do
         return
      end if

      temp = 0.
      pss  = 0.

      sorc = grainLabel(ns)(1:1)

      select case(sorc)
      case ('S') ! silicates
         ! factor of 1.e12 to change from um to A
         natom = nint(0.44*1.e12*grainRadius(na)**3)
         if (natom<=0) then
            print*, '! qHeat: invalid value for natom', sorc, na,natom, grainRadius(na)
         end if

         mgrain = (4.*Pi/3.0)*(grainRadius(na)**3)*rho(dcp-1+ns)*1.e-12

      case ('C')  ! carbonaceous
         natom = nint(0.454*3.*1.e12*grainRadius(na)**3)
         if (natom<=0) then
            print*, '! qHeat: invalid value for natom', sorc, na,natom, grainRadius(na)
         end if
         mgrain = (4.*Pi/3.0)*(grainRadius(na)**3)*rho(dcp-1+ns)*1.e-12
      case default
         qheatTemp = tg
         return
      end select

      ! find enthalpy bins
      call getTmin(ns,na,temp(1))

      tbase=real(tg)
      U(1) = enthalpy(temp(1),natom,na,sorc)

      do i=2,10
         temp(i)= temp(1) + real(i-1)/real(9)*(tbase-temp(1))  !big bins
         U(i)=enthalpy(temp(i),natom,na,sorc)
      end do

      do i = 11, nTbins
         temp(i) = tbase + real(i-10)/real(nTbins-10)*(tmax-tbase)
         U(i) = enthalpy(temp(i), natom, na, sorc)
      end do

      dU(1) = 0.5*(U(2)-U(1))
      do i = 2, nTbins-1
         dU(i) = 0.5*(U(i+1)-U(i-1))
      end do
      dU(nTbins) = 0.5*(U(nTbins)-U(nTbins-1))

      ! discrete heating term:
      ! grain heated from state ii to higher state if
      ! by a photon of wavelength hc/( U(if)-U(ii) )
      do ii = 1, nTbins-1
         do if = ii+1, nTbins

            ! calculate wav of transition ii->if
            wl = hc/ (U(if)-U(ii))
            do wlp = nbins, 1, -1
               if (lambda(wlp)<wl) exit
            end do
            wlp = wlp+1

            if ( (dU(if) >= (0.1* (U(if)-U(ii)))) .and. &
                 & (if < nTbins) ) then

               wls = hc/( (U(if)+U(if+1))/2.0 - U(ii)) ! shorter wl
               wll = hc/( (U(if)+U(if-1))/2.0 - U(ii)) ! longer wl

               if ( wl>= 0.1 .or. wl < lambda(1)) then
                  A(if,ii) = 0.
               else

                  if (wll>0.1) wll =.1
                  if (wls<lambda(1)) wls = lambda(1)

                  do wllp = nbins, 1, -1
                     if (lambda(wllp)<wll) exit
                  end do
                  wllp = wllp+1
                  do wlsp = nbins, 1, -1
                     if (lambda(wlsp)<wls) exit
                  end do
                  wlsp = wlsp+1

                  ! here R. Sylvester program interpolates
                  ! our nu grid is finer and maybe this is
                  ! not necessary - test this and possibly change
                  ! if not too expensive

                  ! 1st trapezium
                  A(if,ii) = 0.5*(sQabs(wlsP)*radField(wlsP)&
                       &*wls**3+sQabs(wlP)*radField(wlP)&
                       &*wl**3)*(U(if+1)-U(if))/2.

                  ! 2nd trapezium
                  A(if,ii) = A(if,ii)+0.5*(sQabs(wlP)*radField(wlP)&
                       &*wl**3+sQabs(wllP)*radField(wllP)&
                       &*wll**3)*(U(if)-U(if-1))/2.

                  A(if,ii) = A(if,ii) /(hc**2)

               end if
            else
               if ( (wl>=0.1) .or. (wl<lambda(1))) then
                  A(if,ii) = 0.
               else
                  A(if,ii) = sQabs(wlP)*&
                       & radField(wlP)*dU(if)*wl**3/(hc**2)
               end if

            end if
         end do

         ! heating of enthalpies beyond the highest bin
         ! G&D p232
         UiTrun = U(nTbins)+dU(nTbins)/2.0 - U(ii)
         wlim = hc/UiTrun

         qint = 0.
         do j = 1,nbins-1

            qint1 = lambda(j)*sQabs(j)*radField(j)
            qint2 = lambda(j+1)*sQabs(j+1)*radField(j+1)
            delwav = lambda(j+1) - lambda(j)

            if (lambda(j+1)<wlim) then

               qint = qint + 0.5*(qint1+qint2)*delwav

            else if (lambda(j) < wlim) then
               qint = qint+(wlim-lambda(j))*(qint1+0.5*(wlim-lambda(j))*&
                    & (qint2-qint1)/delwav)
            end if

         end do

         qint = qint/hc

         A(nTbins,ii) = A(nTbins,ii)+qint
      end do

      ! Work out the cooling terms
      do if = 1, nTbins-1

         call clrate(temp(if+1), lambda,radField,sQabs,mdUdt)
         call cheat(if+1,nTbins,lambda,radField,sQabs,U(1:nTbins),ch)


         A(if,if+1) = mdUdt/dU(if+1)

         if (mdUdt <= ch) then
            A(if,if+1) = A(if,if+1)*1.d-20
            A(if+2,if+1) = A(if+2,if+1) + (ch-mdUdt)/dU(if+1)
         else
            A(if,if+1)=A(if,if+1) - ch/dU(if+1)
         end if

      end do


      if (A(2,1) == 0.) A(2,1) = 2.*A(1,2)


      ! find the B(f,j) terms

      B=0.
      do ii = 1, nTbins

         B(nTbins,ii) = A(nTbins,ii)
         do if = nTbins-1, ii+1,-1

            B(if,ii) = B(if+1,ii)+A(if,ii) ! G&D p233
         end do
      end do
      sumX = 0.
      x(1) = 1.d-100
      do if = 2, nTbins
         sumBx = 0.
         do j = 1, if-1

            sumBx = sumBx + B(if,j)*x(j)
         end do

         x(if) = sumBx/A(if-1,if) ! G&D eqn 2.16

         if (x(if) > 1.d250) then
            do i = 1, if
               if (x(i)< 1.) then
                  x(i) = 0.
               else
                  x(i) = x(i)*1.d-250
               end if
            end do
         end if
      end do

      do j=1,nTbins
         sumx = sumx+x(j)
      end do

      do i = 1, nTbins-1
         if (x(i) > 0.) then
            if (dlog10(x(i))-dlog10(sumx) <= -250.) x(i) = 0.
         end if
         Pss(i) = x(i)/sumx
      end do

      qHeatTemp = 0.
      do i = 1, nTbins

         qHeatTemp = qHeatTemp+Pss(i)*temp(i)
      end do

      tg=qHeatTemp

    end  subroutine qHeat


    subroutine getTmin(ns, ai, tmin)
      implicit none

      real(kind=8), intent(out)      :: tmin  ! continuous heating/cooling equilibrium temp
      real                   :: dustAbsIntegral   ! dust absorption integral
      real                   :: cutoff            ! lambda=1000um (guhathakurta & draine 89)
      real, dimension(nbins) :: radField          ! radiation field

      integer, intent(in) :: ns, ai ! grain species and size pointers
      integer :: iT,ifreq ! pointer to dust temp in dust temp array
      integer :: cutoffP ! pointer to energy cutoff in nuarray
      integer :: dcp

      dcp = dustComPoint(nspE)

      cutoff = 9.11e-5

      if (cutoff<nuArray(1)) then
         print*, "! getTmin: [warning] nuMin larger than cutoff for continuous heating &
              & in quantum heating routine"
         cutoff = nuArray(1)
         cutoffP = 1
      else if (cutoff>=nuArray(nbins)) then
         print*, "! getTmin: nuMax smaller than cutoff for continuous heating &
              & in quantum heating routine"
         stop
      else
         call locate(nuArray, cutoff, cutoffP)
      end if

      ! radiation field at this location
      if (lgDebug) then
         radField = grids(iG)%Jste(cellPUsed,:) + grids(iG)%Jdif(cellPUsed,:)
      else
         radField = grids(iG)%Jste(cellPUsed,:)
      end if

      do ifreq = 1, cutoffP
         radField(ifreq)=0.
      end do

      ! zero out dust temperature
      tmin = 0.

      ! calculate absorption integral
      dustAbsIntegral = 0.
      do i = 1, cutoffP
         dustAbsIntegral =  dustAbsIntegral + xSecArray(dustAbsXsecP(dcp-1+nS,ai)+i-1)*radField(i)/Pi
      end do


      call locate(dustEmIntegral(nS,ai,:), dustAbsIntegral, iT)
      if (iT<=0) then
         iT=1
      end if

      tmin = real(iT)

    end subroutine getTmin


          ! calculates the enthalpy for a spherical silicate
          ! or graphite grain of radius a, temperature tg,
          ! containing natom atoms
          ! based on a program originally written by
          ! R. Sylvester using G&D heat capacity
          function enthalpy(tg,natom,na,sorc)
            implicit none

            real(kind=8) :: enthalpy
            real(kind=8), intent(in) :: tg

            real(kind=8) :: enth1,  enth2,  enth3,  enth4,&
                 & enth1_50,  enth2_150,  enth3_500, &
                 & vg

            integer, intent(in) :: natom, na
            character (len=1), intent(in) :: sorc

            enth1  = (1.4e3/3.) * tg**3
            enth1_50 = (1.4e3/3.) * 50.**3
            enth2 = (2.1647e4/2.3) * (tg**2.3 - 50.**2.3)
            enth2_150 = (2.1647e4/2.3) * (150.**2.3 - 50.**2.3)
            enth3 = (4.8375e5/1.68) * (tg**1.68 - 150.**1.68)
            enth3_500 = (4.8375e5/1.68) * (500.**1.68 - 150.**1.68)
            enth4 = 3.3107e7*(tg-500.)

            vg = (4.18878*1.e-12*grainRadius(na)**3)

            select case (sorc)
            case ('S')

               if (tg<=50.) then
                  enthalpy = enth1
               else if (tg <= 150.) then
                  enthalpy = enth1_50 + enth2
               else if (tg <= 500.) then
                  enthalpy = enth1_50 + enth2_150 + enth3
               else
                  enthalpy = enth1_50 + enth2_150 + enth3_500 +&
                       & enth4
               end if
               enthalpy = (1.-(2./real(natom))) * vg *enthalpy

            case('C')
               enthalpy = real(natom)*(4.15e-22*tg**3.3)
               enthalpy = enthalpy/(1.+6.51e-3*tg + 1.5e-6*tg**2 + 8.3e-7*tg**2.3)
               enthalpy = (1.-(2./real(natom))) * enthalpy
            case default
               print*, '! enthalpy: calculations only available for C & S &
                    & identifiers'
            end select

          end function enthalpy


          ! Calculation of the Plank black body equation
          ! lam in cm; output in erg/cm2/s/cm
          ! C1 = 2.Pi.h.c^2
          ! C2 = h.c/k
          function bbody(lam,tIn)

            real(kind=8)            :: bbody
            real(kind=8), intent(in):: lam, tIn
            real(kind=8), parameter :: C1=3.74185e-5
            real(kind=8), parameter :: C2=1.43883
            real(kind=8)            :: exptest

            exptest=C2/(lam*tIn)

            if(exptest > 400.) then
               bbody=0.
            else
               bbody = C1*(1./lam**5)/(exp(exptest)-1.)
            end if
          end function bbody

          subroutine clrate(tem,lam,fl,sQa,mdudt)
            implicit none

            real(kind=8), intent(out) :: mdudt

            real(kind=8), intent(in) :: tem,lam(nbins),fl(nbins),sQa(nbins)

            real(kind=8) :: cutoff, eout(nbins), engin, engout,eomid, &
                 & delwav

            integer :: k,cutoffP

            cutoff = .1 ! cm

            ! calculate -dU/dt
            engin = 0.
            engout = 0.

            do k = 1, nbins

               eout(k) = sQa(k)*bbody(lam(k),tem)
               if (lam(k)<cutoff) cutoffP=k

               if (k>=2) then
                  eomid=(eout(k)+eout(k-1))/2.
                  delwav = lam(k)-lam(k-1)
                  engout = engout+4.*eomid*delwav

               end if
            end do

            engin  = 0.25*fl(cutoffP)*sQa(cutoffP)*cutoff
            if (engin<0.) print*, "! clrate [warning]: engin < 0."

            mdUdt = engout-engin

          end subroutine clrate

          ! continuous heating within a temoerature bin: photon not energetic
          ! enough to raise the grain to the next temp bin
          subroutine cheat(it,nTbins,lam,fl,sQa,U,ch)
            implicit none

            real(kind=8), intent(out)   :: ch
            real(kind=8), intent(in)    :: U(*),lam(nbins),fl(nbins),sQa(nbins)
            real(kind=8) :: einmax,shwav,cutoff, ein(nbins),engin,&
                 & eimid,hc,delwav

            integer, intent(in) :: it,nTbins
            integer :: nshort,nlong,k

            if (it>nTbins) then
               ch=0.
               return
            end if

            hc = hPlanck*c

            engin=0.
            nshort=0
            nlong=0

            cutoff = .1

            if (it>=nTbins) then
               ch = 0.
               return
            end if

            einmax = 0.5*(U(it+1)-(U(it)))
            shwav=hc/einmax

            if(shwav>=cutoff) then
               ch=0.
               return
            end if

            do k = 1, nbins
               if (lam(k)<shwav) nshort = k
               if (lam(k)<cutoff) nlong = k
               ein(k) = sQa(k)*fl(k)
            end do
            nshort = nshort+1
            if (nshort>=nlong) then
               ch = 0.
               return
            end if

            do k = nshort,nlong
               if (k>=2) then
                  eimid = (ein(k)+ein(k-1))/2.
                  delwav = lam(k)-lam(k-1)
                  engin=engin+eimid*delwav
               end if
            end do

            ch = engin

          end subroutine cheat


  end subroutine emissionDriver



  subroutine equilibrium(file_name, ionDenUp, Te, Ne, fLineEm, wav)
    implicit none

    double precision, dimension(:,:), &
         & intent(inout) :: fLineEm     ! forbidden line emissivity

    double precision, dimension(:,:), &
         & intent(inout), optional :: wav         ! wavelength of transition [A]


    double precision     :: constant                  ! calculations constant
    double precision     :: delTeK                    ! Boltzmann exponent
    double precision     :: expFac                    ! calculations factor
    double precision     :: Eji                       ! energy between levels j and i

    double precision     :: sumN                      ! normalization factor for populations
    double precision     :: sqrTe                     ! sqrt(Te)

    double precision, allocatable          :: x(:,:)      ! matrix arrays
    double precision, allocatable          :: y(:)        !
    double precision, allocatable          :: n(:)        ! level population arrays

    real                 :: a_r(4),a_d(5),z,br       !
    real                 :: qomInt                    ! interpolated value of qom

    real, intent(in) &
         & :: Te, &    ! electron temperature [K]
         & Ne, &       ! electron density [cm^-3]
         & ionDenUp    ! ion density of the upper ion stage

    integer  :: i, j, iT         ! counters/indeces
    integer  :: elem, ion        ! location of atomic data in the array

    integer  :: nLev             ! number of levels in atomic data file
    integer  :: nTemp            ! number of temperature points in atomic data file

    integer, parameter :: safeLim = 100000 ! loop safety limit

    character(len = *), &
         & intent(in)  :: file_name   ! ionic data file name

    do i=3,nelements
      do j=1,10
        if (trim(atomic_data_array(i,j)%ion) .eq. trim(file_name)) then
          goto 888
        endif
      enddo
    enddo

888 elem = i
    ion = j

    sqrTe   = sqrt(Te)
    log10Te = log10(Te)

    if (atomic_data_array(elem,ion)%nlevs > size(fLineEm(1,:))) then
       print*, '! equilibrium: model ion has more levels than &
            &allowed by nForLevels - please enlarge', atomic_data_array(elem,ion)%nlevs, &
            & size(fLineEm(1,:)),  nForLevels, file_name
       stop
    end if
    br = atomic_data_array(elem,ion)%br
    z = atomic_data_array(elem,ion)%z
    a_r = atomic_data_array(elem,ion)%a_r
    a_d = atomic_data_array(elem,ion)%a_d
    nlev = atomic_data_array(elem,ion)%nlevs
    ntemp = atomic_data_array(elem,ion)%ntemps

    ! read power law fit coefficients [e-13 cm^3/s]
    ! and calculate total recombination coefficient
    ! (direct + cascades)
    atomic_data_array(elem,ion)%alphaTotal = 0.

    do j = 2, nLev
!       read(unit=11,fmt=*,iostat=ios) a_fit, b_fit
       if (atomic_data_array(elem,ion)%br .le. 0.d0) then
          exit
       else
         atomic_data_array(elem,ion)%alphaTotal(1) = 1.
       end if
!       alphaTotal(j) = a_fit * (TeUsed/1.e4)**(b_fit) * 1.e-13
       atomic_data_array(elem,ion)%alphaTotal(j)=1.e-13*br*z*a_r(1)*(Te*1.e-4/z**2)**a_r(2)/(1.+a_r(3)*&
            & (Te*1.e-4/Z**2)**a_r(4))+1.0e-12*br*(a_d(1)&
            & /(Te*1.e-4)+a_d(2)+a_d(3)*Te*1.e-4+a_d(4)*(Te*1.e-4)**2)*&
            & (Te*1.e-4)**(-1.5)*exp(-a_d(5)*1.e4/Te)
    end do

    ! form matrices
    ! set up qeff
    do i = 2, nLev
       do j = i, nLev
          do iT = 1, nTemp
             atomic_data_array(elem,ion)%qq(iT) = real(atomic_data_array(elem,ion)%qom(iT, i-1, j))

          end do

          if (nTemp == 1) then
             ! collisional strength available only for one temperature - assume constant
             qomInt = atomic_data_array(elem,ion)%qq(1)
          else if (nTemp == 2) then
             ! collisional strength available only for one temperature - linear interpolation
             qomInt = atomic_data_array(elem,ion)%qq(1) + &
                  (atomic_data_array(elem,ion)%qq(2)-atomic_data_array(elem,ion)%qq(1)) / (atomic_data_array(elem,ion)%logTemp(2)-atomic_data_array(elem,ion)%logTemp(1)) * (log10Te - atomic_data_array(elem,ion)%logTemp(1))
          else
             ! set up second derivatives for spline interpolation
             call spline(atomic_data_array(elem,ion)%logTemp, atomic_data_array(elem,ion)%qq, 1.e30, 1.e30,  atomic_data_array(elem,ion)%qq2)
             ! get interpolated qom for level
             call splint(atomic_data_array(elem,ion)%logTemp, atomic_data_array(elem,ion)%qq, atomic_data_array(elem,ion)%qq2, log10Te, qomInt)
          end if

          ! set collisional strength
          atomic_data_array(elem,ion)%cs(i-1, j) = qomInt

          ! the calculation constant here is the energy [erg]
                ! allocated to unit wavenumber [1/cm] divided by the
          ! boltzmann constant k.
          constant = 1.4388463d0
          ! exponential factor
          delTeK = (atomic_data_array(elem,ion)%e(i-1)-atomic_data_array(elem,ion)%e(j))*constant
          expFac = exp( delTeK/Te )

          atomic_data_array(elem,ion)%qeff(i-1, j) = 8.63d-6 * atomic_data_array(elem,ion)%cs(i-1, j) * expFac /&
               &(atomic_data_array(elem,ion)%g(i-1)*sqrTe)
          atomic_data_array(elem,ion)%qeff(j, i-1) = 8.63d-6 * atomic_data_array(elem,ion)%cs(i-1, j) / (atomic_data_array(elem,ion)%g(j)*sqrTe)

       end do
    end do

    allocate(x(nlev,nlev))
    allocate(y(nlev))
    allocate(n(nlev))

    x=0.
    y=0.
    n=0.

    ! set up x
    do i= 2, nLev
       do j = 1, nLev


          x(1,:) = 1.
!          y = 0.
          y(1)   = 1.

          if (j /= i) then

             x(i, j) = x(i, j) + Ne*atomic_data_array(elem,ion)%qeff(j, i)
             x(i, i) = x(i, i) - Ne*atomic_data_array(elem,ion)%qeff(i, j)
             if (j > i) then

                x(i, j) = x(i, j) + atomic_data_array(elem,ion)%a(j, i)
             else

                x(i, i) = x(i, i) - atomic_data_array(elem,ion)%a(i, j)
             end if
          end if
       end do

       ! when coefficients are available use the following:

       y(i) = -Ne*ionDenUp*atomic_data_array(elem,ion)%alphaTotal(i)

    end do

    call luSlv(x, y, nLev)

    n = y

    sumN = 0.d0
    do i = 1, nLev
       sumN = sumN+n(i)
    end do
    do i = 1, nLev
       n(i) = n(i)/sumN
    end do

    ! now find emissivity and wavelengths
    do i = 1, nLev-1
       do j = i+1, nLev
          if (atomic_data_array(elem,ion)%a(j,i) /= 0.d0) then
             Eji = (atomic_data_array(elem,ion)%e(j)-atomic_data_array(elem,ion)%e(i))
             fLineEm(i,j) = atomic_data_array(elem,ion)%a(j,i) * Eji * n(j)
             if (Eji>0.) then
                if (present(wav)) wav(i,j) = 1.e8/Eji
             else
                if (present(wav)) wav(i,j) = 0.d0
             end if
          end if
       end do
    end do

    deallocate(x)
    deallocate(y)
    deallocate(n)

  end subroutine equilibrium


  ! this procedure performs the solution of linear equations
  subroutine luSlv(a, b, n)
    implicit none

    integer, intent(in)                  :: n

    double precision,&
         & intent(inout), dimension(:,:) :: a
    double precision,&
         & intent(inout), dimension(:)   :: b

    call lured(a,n)

    call reslv(a,b,n)
  end subroutine luSlv

  subroutine lured(a,n)
    implicit none

    integer, intent(in)                  :: n

    double precision,&
         & intent(inout), dimension(:,:)    :: a

    ! local variables
    integer          :: i, j, k                    ! counters

    double precision :: factor                     ! general calculation factor

    if (n == 1) return

    do i = 1, n-1
       do k = i+1, n
          factor = a(k,i)/a(i,i)
          do j = i+1, n
             a(k, j) = a(k, j) - a(i, j) * factor
          end do
       end do
    end do
  end subroutine lured

  subroutine reslv(a,b,n)
    implicit none

    integer, intent(in)              :: n

    double precision,&
         & intent(inout), dimension(:,:) :: a
    double precision,&
         & intent(inout), dimension(:)   :: b

    ! local variables
    integer    :: i, j, k, l              ! counters

    if (n == 1) then
       b(n) = b(n) / a(n,n)
       return
    end if

    do i = 1, n-1
       do j = i+1, n
          b(j) = b(j) - b(i)*a(j, i)/ a(i, i)
       end do
    end do

    b(n) = b(n) / a(n,n)
    do i = 1, n-1
       k = n-i
       l = k+1
       do j = l, n

          b(k) = b(k) - b(j)*a(k, j)
       end do

       b(k) = b(k) / a(k,k)
    end do
  end subroutine reslv

  subroutine initResLines(grid)
    implicit none

    type(grid_type), intent(inout) :: grid(*)

      character(len=2)   :: label
      character(len=120) :: reader ! file reader

      integer :: el  ! element number
      integer :: err ! allocation error status
      integer :: i,ii,j ! counters
      integer :: iGrid ! counter
      integer :: ios ! I/O error status
      integer :: nL  ! line counter
      integer :: nmul ! number of multiplets
      integer :: nResLinesFile
      integer :: safeLimit = 1000000 !

      open(unit=19, action="read", file=PREFIX//"/share/mocassin/data/resLines.dat", status="old", position="rewind", iostat=ios)
      if (ios /= 0) then
         print*, "! initResLines: can't open file: ",PREFIX,"/share/mocassin/data/resLines.dat"
         stop
      end if

      nResLines =0
      do i = 1, safeLimit
         read(unit=19,fmt='(A2,A110,I4)',iostat=ios) label,reader, nmul
         if (ios/=0) exit
         do j = 1, nmul
            read(unit=19,fmt=*, iostat=ios)
            if (ios/=0) then
               print*, "! initResLines: error reading ",PREFIX,"/share/mocassin/data/resLines.dat file"
               stop
            end if
         end do

         ! check what element and if it's included
         el=0
         do j = 1, nElements
            if (trim(label) == trim(elemLabel(j)) ) then
               el=j
               exit
            end if
         end do
         if (el==0) then
            print*, "! initResLines: illegal label ", label, el
            stop
         end if
         if (lgElementOn(el)) nResLines=nResLines+1

      end do
      if (nResLines <= 0) then
         print*, '! initResLines: number of resonant lines is zero or negative'
         stop
      end if

      if (i>=safeLimit) then
         print*, "! initResLines : safe limit exceeded in resonant line list read"
         stop
      end if
      nResLinesFile=i-1
      rewind(19)

      ! allocate space for resLineLabel and resLineNuP arrays
      allocate(resLine(1:nResLines), stat = err)
      if (err /= 0) then
         print*, "! initResLines: can't allocate array memory, resLine"
         stop
      end if

      nL=1
      do ii = 1, nResLinesFile
         if (nL>nResLines) exit

         read(unit=19,fmt='(A2,I2,1x,A23,11x,A7,1x,F9.4,7x,F9.6,4x,F12.6,1x,I2,1x,I2,1x,E8.2,1x,E8.2,1x,I2)', &
              &iostat=ios) resLine(nL)%species, resLine(nL)%ion,&
              & resLine(nL)%transition, resLine(nL)%multiplet, resLine(nL)%wav, resLine(nL)%Elow, resLine(nL)%Ehigh,&
              & resLine(nL)%glow, &
              & resLine(nL)%ghigh, resLine(nL)%Aik, resLine(nL)%fik, resLine(nL)%nmul
         if (ios/=0) then
            print*, '! initResline: error reading file -1- '
            stop
         end if

         allocate(resLine(nL)%moclow(1:resLine(nL)%nmul), stat=err)
         if (err /= 0) then
            print*, "! initResLines: can't allocate array memory, resLine(nL)%moclow"
            stop
         end if
         allocate(resLine(nL)%mochigh(1:resLine(nL)%nmul), stat=err)
         if (err /= 0) then
            print*, "! initResLines: can't allocate array memory, resLine(nL)%mochigh"
            stop
         end if

         do j = 1, resLine(nL)%nmul
            read(unit=19,fmt='(A112,1x,I2,1x,I2)', iostat=ios) reader, &
                 & resLine(nL)%moclow(j), resLine(nL)%mochigh(j)
            if (ios/=0) then
               print*, "! initResLines: error reading ",PREFIX,"/share/mocassin/data/resLines.dat file - 2"
               stop
            end if
         end do

         resLine(nL)%elem=0
         do j = 1, nElements

            if (trim(resLine(nL)%species) == trim(elemLabel(j)))  then
               resLine(nL)%elem=j
               exit
            end if
         end do

         if (resLine(nL)%elem==0) then
            print*, "! initResLines: illegal label -2 -", resLine(nl)%elem, nL
            stop
         end if

         if (lgElementOn(resLine(nL)%elem)) then

            ! convert A to Ryd
            resLine(nL)%freq = c*1.e8/(resLine(nL)%wav*fr1Ryd)

            ! find the mass of the ion in [g]
            resLine(nL)%m_ion = aWeight(resLine(nL)%elem)*amu

            ! locate on nuArary
            call locate(nuArray, resLine(nL)%freq, resLine(nL)%nuP)
            if (resLine(nL)%nuP<=0 .or. resLine(nL)%nuP>=nbins) then
               print*, "! initResLines: wavelength of resonant line is outside grid range", &
                    & ii, resLine(nL)%nuP, resLine(nL)%freq, nuArray(1), nuArray(nbins)
               stop
            end if

            nL = nL +1
         end if

      end do
      close(19)

      if (taskid == 0) then
         print*, "! initResLines: The following resonance lines have been initialised and will &
              &be included in the radiative transfer"
         do i = 1, nResLines
            do j = 1, resLine(i)%nmul
               print*, i, resLine(i)%elem, resLine(i)%ion, resLine(i)%nmul, resLine(i)%wav
               print*, resLine(i)%moclow(j), resLine(i)%mochigh(j)
            end do
         end do
      end if

      do iGrid = 1, nGrids
         ! allocate fEscapeResPhotons
         allocate(grid(iGrid)%fEscapeResPhotons(0:grid(iGrid)%nCells,1:nResLines), stat = err)
         if (err /= 0) then
            print*, "! initResLines: can't allocate array memory, fEscapeResPhotons"
            stop
         end if
         grid(iGrid)%fEscapeResPhotons(0:grid(iGrid)%nCells,1:nResLines) = 0.

         ! and the extra packets to be transferred from each location
         allocate(grid(iGrid)%resLinePackets(0:grid(iGrid)%nCells), stat = err)
         if (err /= 0) then
            print*, "! initResLines: can't allocate array memory, resLinePackets"
            stop
         end if
         grid(iGrid)%resLinePackets(0:grid(iGrid)%nCells) = 0

      end do

      allocate(dustHeatingBudget(0:nAbComponents, 0:nResLines), stat=err)
      if (err /= 0) then
         print*, "! initResLines: can't allocate array memory, dustHeatingBudget"
         stop
      end if
      dustHeatingBudget=0.

    end subroutine initResLines

    subroutine setResLineEscapeProb(grids, gPin, xPin,yPin,zPin)
      implicit none

      type(grid_type), intent(inout) :: grids(*) ! incoming grids

      type(vector) :: uHat, rVec ! direction and position vectors

      real    :: a0,DeltaNuD ! line centre xSec [cm^2] and doppler width
      real    :: bFac
      real    :: deltax,deltaxloc    !
      real    :: k_d, k_l  ! dust and line opacities
      real    :: dSx, dSy, dSz, dS ! distances from walls
      real    :: I1, I2    ! calculation integrals
      real    :: Pline     ! prob line
      real    :: radius    ! radial distance from the centre of the grid
      real    :: tau_mu    ! optical depth in direction mu at line centre
      real    :: gasdensity,gastemperature ! properties of the cells along the line of travel
      real    :: gasdensity0,gastemperature0 ! local cell properties
      real :: k_dTest=0.5e-20, HdenTest=0.252, ionFracTest=0.5, TeTest=1.e4


      integer, intent(in) :: xPin,yPin,zPin,gPin ! incoming cell pointers
      integer             :: xp,yp,zp ! cell pointers
      integer             :: gPmother,xPmother,yPmother,zPmother
      integer             :: icount  ! counter
      integer             :: idir, jdir, kdir ! freq counter
      integer, parameter  :: safeLimit=100000 ! loop limit
      integer             :: gP ! subgrid counters
      integer             :: cellP   ! cell pointer on active grid array
      integer             :: compoP  ! pointer to gas component index
      integer             :: iLine   ! res line counter
      integer             :: ndirx, ndiry,ndirz ! number of directions to sample tau

      logical             :: lgTest


      lgTest = .false.

      xp=xPin
      yp=yPin
      zp=zPin
      gp=gPin

      cellP = grids(gPin)%active(xP,yP,zP)

      if (cellP<=0) return

      ndirx = 4
      ndiry = 4
      ndirz = 4

      ! get local physical properties of the gas
      if (lgTest) then
         gasdensity0 = HdenTest
         gastemperature0 = TeTest
         nResLines=1
      else
         gasdensity0 = grids(gPin)%Hden(grids(gPin)%active(xp,yp,zp))
         gastemperature0 = grids(gPin)%Te(grids(gPin)%active(xP,yP,zP))
      end if

      do iLine = 1, nResLines
         if (.not.lgElementOn(resLine(iLine)%elem)) then
            print*, "!setResLineEscapeProb: attempted to calculate escape probability of resonant line &
                 & from an absent ion"
            stop
         end if

         xp=xPin
         yp=yPin
         zp=zPin
         gp=gPin

         cellP = grids(gPin)%active(xP,yP,zP)
         compoP = grids(gPin)%abFileIndex(xP,yP,zP)

         Pline=0.

         ! calculate mean line opacity for this cell
         DeltaNuD = (resLine(iLine)%freq*fr1Ryd/c)*(2.76124e-16*gastemperature0/resLine(iLine)%m_ion)**0.5
!         call meanLineOpacity(resLine(iLine), DeltaNuD, a0)
         call lineCentreXSec(resLine(iLine), DeltaNuD, a0)
         a0 = a0/1.e-14

         ! find k_d and k_l
         if (lgTest) then
            k_d = k_dTest
            k_l = a0* HdenTest * grids(gPin)%elemAbun(compoP,resLine(iLine)%elem)* &
                 & ionFracTest
         else
            k_d = grids(gPin)%absOpac(cellP,resLine(iLine)%nuP)
            k_l = a0* grids(gPin)%Hden(cellP) * grids(gPin)%elemAbun(compoP,resLine(iLine)%elem)* &
                 &  grids(gPin)%ionDen(cellP,elementXref(resLine(iLine)%elem),resLine(iLine)%ion)
         end if

         ! calculate line profile and calculation integrals
         I1=0.
         I2=0.
         deltax=0.

         ! profiles are too narrow for the following

         if (resLine(iLine)%nuP>=nbins) then
            print*, '! setResLineEscapeProb: res line freq pointer >= nbins', iline, &
                 & resLine(iLine)%nuP, nbins
            stop
         end if

         uHat%x = 1./sqrt(3.)
         uHat%y = uHat%x
         uHat%z = uHat%x

         deltax=0.
         do idir = 0,ndirx
            uHat = rotateX(uHat,real(idir)*Pi/2.)
            do jdir = 0,ndiry
               uHat = rotateY(uHat,real(jdir)*Pi/2.)
               do kdir = 0,ndirz
                  uHat = rotateZ(uHat,real(kdir)*Pi/2.)

                  tau_mu = 0.

                  rVec%x = grids(gPin)%xAxis(xPin)
                  rVec%y = grids(gPin)%yAxis(yPin)
                  rVec%z = grids(gPin)%zAxis(zPin)

                  xp = xpin
                  yp = ypin
                  zp = zpin
                  gp = gpin


                  do icount = 1, safeLimit



                     ! check if we are in a subgrid
                     if (grids(gPin)%active(xP,yP,zP)<0) then


                        gPmother = gP
                        xPmother = xP
                        yPmother = yP
                        zPmother = zP

                        gP = abs(grids(gPin)%active(xP,yP,zP))

                        ! where are we in the sub-grid?
                        call locate(grids(gP)%xAxis, rVec%x, xP)
                        if (xP< grids(gP)%nx) then
                           if (rVec%x >=  (grids(gP)%xAxis(xP+1)+grids(gP)%xAxis(xP))/2.) &
                                & xP = xP + 1
                        end if

                        call locate(grids(gP)%yAxis, rVec%y, yP)
                        if (yP< grids(gP)%ny) then
                           if (rVec%y >=  (grids(gP)%yAxis(yP+1)+grids(gP)%yAxis(yP))/2.) &
                                & yP = yP + 1
                        end if
                        call locate(grids(gP)%zAxis, rVec%z, zP)
                        if (zP< grids(gP)%nz) then
                           if (rVec%z >=  (grids(gP)%zAxis(zP+1)+grids(gP)%zAxis(zP))/2.) &
                                & zP = zP + 1
                        end if

                     end if

                     cellP = grids(gPin)%active(xP,yP,zP)

                     if (cellP > 0 ) then
                        compoP = grids(gPin)%abFileIndex(xP,yP,zP)
                        if (xp == xpin .and. yp == ypin .and. zp == zpin .and. gP == gpin) then
                           gasdensity = gasdensity0
                           gastemperature=gastemperature0
                        else
                           if (lgTest) then
                              gasdensity = HdenTest
                              gastemperature = TeTest
                           else
                              gasdensity = grids(gP)%Hden(grids(gP)%active(xp,yp,zp))
                              gastemperature = grids(gP)%Te(grids(gP)%active(xP,yP,zP))
                           end if
                        end if

                     else

                        gasdensity=0.
                        gastemperature=1.

                     end if

                     ! find distances from all walls

                     if (uHat%x>0.) then
                        if (xP<grids(gP)%nx) then
                           dSx = ( (grids(gP)%xAxis(xP+1)+grids(gP)%xAxis(xP))/2.-rVec%x)/uHat%x
                           if (abs(dSx)<1.e-10) then
                              rVec%x=(grids(gP)%xAxis(xP+1)+grids(gP)%xAxis(xP))/2.
                              xP = xP+1
                           end if
                        else
                           dSx = ( grids(gP)%xAxis(grids(gP)%nx)-rVec%x)/uHat%x
                           if (abs(dSx)<1.e-10) then
                              rVec%x=grids(gP)%xAxis(grids(gP)%nx)
                           end if
                        end if
                     else if (uHat%x<0.) then
                        if (xP>1) then
                           dSx = ( (grids(gP)%xAxis(xP)+grids(gP)%xAxis(xP-1))/2.-rVec%x)/uHat%x
                           if (abs(dSx)<1.e-10) then
                              rVec%x=(grids(gP)%xAxis(xP)+grids(gP)%xAxis(xP-1))/2.
                              xP = xP-1
                           end if
                        else
                           dSx = (grids(gP)%xAxis(1)-rVec%x)/uHat%x
                           if (abs(dSx)<1.e-10) then
                              rVec%x=grids(gP)%xAxis(1)
                           end if
                        end if
                     else if (uHat%x==0.) then
                        dSx = grids(gP)%xAxis(grids(gP)%nx)
                     end if

                     if (.not.lg1D) then
                        if (uHat%y>0.) then
                           if (yP<grids(gP)%ny) then
                              dSy = ( (grids(gP)%yAxis(yP+1)+grids(gP)%yAxis(yP))/2.-rVec%y)/uHat%y
                              if (abs(dSy)<1.e-10) then
                                 rVec%y=(grids(gP)%yAxis(yP+1)+grids(gP)%yAxis(yP))/2.
                                 yP = yP+1
                              end if
                           else
                              dSy = (  grids(gP)%yAxis(grids(gP)%ny)-rVec%y)/uHat%y
                              if (abs(dSy)<1.e-10) then
                                 rVec%y=grids(gP)%yAxis(grids(gP)%ny)
                              end if
                           end if
                        else if (uHat%y<0.) then
                           if (yP>1) then
                              dSy = ( (grids(gP)%yAxis(yP)+grids(gP)%yAxis(yP-1))/2.-rVec%y)/uHat%y
                              if (abs(dSy)<1.e-10) then
                                 rVec%y=(grids(gP)%yAxis(yP)+grids(gP)%yAxis(yP-1))/2.
                                 yP = yP-1
                              end if
                           else
                              dSy = ( grids(gP)%yAxis(1)-rVec%y)/uHat%y
                              if (abs(dSy)<1.e-10) then
                                 rVec%y=grids(gP)%yAxis(1)
                              end if
                           end if
                        else if (uHat%y==0.) then
                           dSy = grids(gP)%yAxis(grids(gP)%ny)
                        end if

                        if (uHat%z>0.) then
                           if (zP<grids(gP)%nz) then
                              dSz = ( (grids(gP)%zAxis(zP+1)+grids(gP)%zAxis(zP))/2.-rVec%z)/uHat%z
                              if (abs(dSz)<1.e-10) then
                                 rVec%z=(grids(gP)%zAxis(zP+1)+grids(gP)%zAxis(zP))/2.
                                 zP = zP+1
                              end if
                           else
                              dSz = ( grids(gP)%zAxis(grids(gP)%nz)-rVec%z)/uHat%z
                              if (abs(dSz)<1.e-10) then
                                 rVec%z=grids(gP)%zAxis(grids(gP)%nz)
                              end if
                           end if
                        else if (uHat%z<0.) then
                           if (zP>1) then
                              dSz = ( (grids(gP)%zAxis(zP)+grids(gP)%zAxis(zP-1))/2.-rVec%z)/uHat%z
                              if (abs(dSz)<1.e-10) then
                                 rVec%z=(grids(gP)%zAxis(zP)+grids(gP)%zAxis(zP-1))/2.
                                 zP = zP-1
                              end if
                           else
                              dSz = ( grids(gP)%zAxis(1)-rVec%z)/uHat%z
                              if (abs(dSz)<1.e-10) then
                                 rVec%z=grids(gP)%zAxis(1)
                              end if
                           end if
                        else if (uHat%z==0.) then
                           dSz = grids(gP)%zAxis(grids(gP)%nz)
                        end if

                     else

                        print*, '! setResLineEscapeProb: oneD option not yet implemented for res line transfer routine'
                        stop

                     end if


                     ! cater for cells on cell wall
                     if ( abs(dSx)<1.e-10 ) dSx = grids(gP)%xAxis(grids(gP)%nx)
                     if ( abs(dSy)<1.e-10 ) dSy = grids(gP)%yAxis(grids(gP)%ny)
                     if ( abs(dSz)<1.e-10 ) dSz = grids(gP)%zAxis(grids(gP)%nz)

                     ! find the nearest wall
                     dSx = abs(dSx)
                     dSy = abs(dSy)
                     dSz = abs(dSz)

                     if (dSx<=0.) then
                        print*, '! setResLineEscapeProb: [warning] dSx <= 0.'
                        dS = min(dSy, dSz)
                     else if (dSy<=0.) then
                        print*, '! setResLineEscapeProb: [warning] dSy <= 0.'
                        dS = min(dSx, dSz)
                     else if (dSz<=0.) then
                        print*, '! setResLineEscapeProb: [warning] dSz <= 0.'
                        dS = min(dSx, dSy)
                     else
                        dS = min(dSx,dSy,dSz)
                     end if

                     ! this should now never ever happen
                     if (dS <= 0.) then
                        print*, 'setResLineEscapeProb: dS <= 0'
                        stop
                     end if

                     ! update optical depth
                     if (cellP>0) then
                        if (lgTest) then
                           tau_mu  = tau_mu + a0*1.e-14*dS*gasdensity*grids(gP)%elemAbun(compoP,resLine(iLine)%elem)*&
                                &ionFracTest
                        else
                           tau_mu  = tau_mu + a0*1.e-14*dS*gasdensity*grids(gP)%elemAbun(compoP,resLine(iLine)%elem)*&
                                &grids(gP)%ionDen(cellP,elementXref(resLine(iLine)%elem),resLine(iLine)%ion)
                        end if
                     end if

                     ! update position
                     rVec = rVec + dS*uHat

                     ! keep track of where you are on mother grid
                     if (gP>1) then
                        if (uHat%x>0.) then
                           if ( xPmother < grids(gPmother)%nx ) then
                              if ( rVec%x >= (grids(gPmother)%xAxis(xPmother)+&
                                   & grids(gPmother)%xAxis(xPmother+1))/2. ) then
                                 xPmother = xPmother+1
                              end if
                           else
                              if ( rVec%x > grids(gPmother)%xAxis(xPmother)) then
                                 print*, '! pathSegment: insanity occurred at mother grid transfer (x axis +)', &
                                      & rVec%x, gP, gPmother
                                 stop
                              end if
                           end if
                        else
                           if ( xPmother > 1 ) then
                              if ( rVec%x <= (grids(gPmother)%xAxis(xPmother-1)+&
                                   & grids(gPmother)%xAxis(xPmother))/2. ) then
                                 xPmother = xPmother-1
                              end if
                           else
                              if (rVec%x < grids(gPmother)%xAxis(1)) then
                                 print*, '! pathSegment: insanity occurred at mother grids transfer (x axis -)', &
                                      & rVec%x, gP, gPmother
                                 stop
                              end if
                           end if
                        end if
                        if (uHat%y>0.) then
                           if (  yPmother < grids(gPmother)%ny ) then
                              if ( rVec%y >= (grids(gPmother)%yAxis( yPmother)+&
                                   & grids(gPmother)%yAxis( yPmother+1))/2. ) then
                                 yPmother =  yPmother+1
                              end if
                           else
                              if ( rVec%y > grids(gPmother)%yAxis( yPmother)) then
                                 print*, '! pathSegment: insanity occurred at mother grid transfer (y axis +)', &
                                      & rVec%y, gP, gPmother
                                 stop
                              end if
                           end if
                        else
                           if (  yPmother > 1 ) then
                              if ( rVec%y <= (grids(gPmother)%yAxis( yPmother-1)+&
                                   & grids(gPmother)%yAxis( yPmother))/2. ) then
                                 yPmother =  yPmother-1
                              end if
                           else
                              if (rVec%y < grids(gPmother)%yAxis(1)) then
                                 print*, '! pathSegment: insanity occurred at mother grid transfer (y axis -)', &
                                      & rVec%y, gP, gPmother
                                 stop
                              end if
                           end if
                        end if
                        if (uHat%z>0.) then
                           if (  zPmother < grids(gPmother)%nz ) then
                              if ( rVec%z >= (grids(gPmother)%zAxis( zPmother)+&
                                   & grids(gPmother)%zAxis( zPmother+1))/2. ) then
                                 zPmother =  zPmother+1
                              end if
                           else
                              if ( rVec%z > grids(gPmother)%zAxis( zPmother)) then
                                 print*, '! pathSegment: insanity occurred at mother grid transfer (z axis +)', &
                                      & rVec%z, gP, gPmother
                                 stop
                              end if
                           end if
                        else
                           if (  zPmother > 1 ) then
                              if ( rVec%z <= (grids(gPmother)%zAxis( zPmother-1)+&
                                   & grids(gPmother)%zAxis( zPmother))/2. ) then
                                 zPmother =  zPmother-1
                              end if
                           else
                              if (rVec%z < grids(gPmother)%zAxis(1)) then
                                 print*, '! pathSegment: insanity occurred at mother grid transfer (z axis -)', &
                                      & rVec%z, gP, gPmother
                                 stop
                              end if
                           end if
                        end if
                     end if

                     ! and update current grid indeces
                     if (.not.lg1D) then
                        if ( (dS == dSx) .and. (uHat%x > 0.)  ) then
                           xP = xP+1
                        else if ( (dS == dSx) .and. (uHat%x < 0.) ) then
                           xP = xP-1
                        else if ( (dS == dSy) .and. (uHat%y > 0.) ) then
                           yP = yP+1
                        else if ( (dS == dSy) .and. (uHat%y < 0.) ) then
                           yP = yP-1
                        else if ( (dS == dSz) .and. (uHat%z > 0.) ) then
                           zP = zP+1
                        else if ( (dS == dSz) .and. (uHat%z < 0.) ) then
                           zP = zP-1
                        end if
                     else

                        print*, '! setResLineEscapeProb: oneD option not yet implemented for res line transfer routine'
                        stop

                        radius = 1.e10*sqrt((rVec%x/1.e10)*(rVec%x/1.e10) + &
                             & (rVec%y/1.e10)*(rVec%y/1.e10) + &
                             & (rVec%z/1.e10)*(rVec%z/1.e10))
                        call locate(grids(gP)%xAxis, radius , xP)

                     end if

                     if(lgPlaneIonization) then

                        if ( (rVec%y <= grids(gP)%yAxis(1) .or. yP<1) .and. uHat%y<0.) then


                           if (gP==1) then
                              ! exit the loop if on mother or return to mother if on sub
                              yP = nint(grids(gP)%yAxis(1))
                              exit
!                              yP=1
!                              rVec%y = grids(gP)%yAxis(1)
!                              uHat%y = -uHat%y
                           else if (gP>1) then
                              xP = xPmother
                              yP = yPmother
!                              zP = zPmother
                              gP = gPmother
                           else
                              print*, '! setResLineEscapeProb: insanity occurred - invalid gP', gP
                              stop
                           end if
                        end if


                        if (rVec%y >= grids(gP)%yAxis(grids(gP)%ny)+grids(gP)%geoCorrY .or. yP>grids(gP)%ny) then

                           if (gP==1) then
                              ! exit the loop if on mother or return to mother if on sub
                              yP = grids(gP)%ny
                              exit
                           else if (gP>1) then
                              xP = xPmother
                              yP = yPmother
                              zP = zPmother
                              gP = gPmother
                           else
                              print*, '! setResLineEscapeProb: insanity occurred - invalid gP', gP
                              stop
                           end if

                        end if

                        if (rVec%x <= grids(gP)%xAxis(1) .or. xP<1) then

                           if (gP==1) then
!                         rVec%x = -rVec%x
                              xP=1
                              rVec%x = grids(gP)%xAxis(1)
                              uHat%x = -uHat%x
                           else if (gP>1) then
                              xP = xPmother
                              yP = yPmother
                              zP = zPmother
                              gP = gPmother
                           else
                              print*, '! setResLineEscapeProb: insanity occurred - invalid gP', gP
                              stop
                           end if
                        end if

                        if (rVec%x >=  grids(gP)%xAxis(grids(gP)%nx) .or. xP>grids(gP)%nx)then

                           if (gP==1) then
!                         rVec%x = 2.*grid(gP)%xAxis(grid(gP)%nx)- rVec%x
                              xP = grids(gP)%nx
                              rVec%x = grids(gP)%xAxis(grids(gP)%nx)
                              uHat%x = -uHat%x
                           else if (gP>1) then
                              xP = xPmother
                              yP =  yPmother
                              zP =  zPmother
                              gP = gPmother
                           else
                              print*, '! setResLineEscapeProb: insanity occurred - invalid gP', gP
                              stop
                           end if

                        end if

                        if (rVec%z <= grids(gP)%zAxis(1) .or.zP<1) then

                           if (gP==1) then
!                         rVec%z = -rVec%z
                              zP=1
                              rVec%z = grids(gP)%zAxis(1)
                              uHat%z = -uHat%z
                           else if (gP>1) then
                              xP = xPmother
                              yP =  yPmother
                              zP =  zPmother
                              gP = gPmother
                           else
                              print*, '! setResLineEscapeProb: insanity occurred - invalid gP', gP
                              stop
                           end if

                        end if

                        if (rVec%z >=  grids(gP)%zAxis(grids(gP)%nz) .or. zP>grids(gP)%nz)then

                           if (gP==1) then
                              zP = grids(gP)%nz
!                         rVec%z = 2.*grid(gP)%zAxis(grid(gP)%nz)- rVec%z
                              rVec%z = grids(gP)%zAxis(grids(gP)%nz)
                              uHat%z = -uHat%z
                           else if (gP>1) then
                              xP = xPmother
                              yP = yPmother
                              zP = zPmother
                              gP = gPmother
                           else
                              print*, '! setResLineEscapeProb: insanity occurred - invalid gP', gP
                              stop
                           end if

                        end if

                     end if

                     ! check if the path is still within the ionized region
                     radius = 1.e10*sqrt((rVec%x/1.e10)*(rVec%x/1.e10) + &
                          & (rVec%y/1.e10)*(rVec%y/1.e10) + &
                          & (rVec%z/1.e10)*(rVec%z/1.e10))

                     if ( radius >= R_out .and. R_out >= 0. ) exit

                     if (lgSymmetricXYZ .and. gP == 1) then
                        if (lgPlaneIonization) then
                           print*, '! setResLineEscapeProb: lgSymmetric and lgPlaneionization flags both raised'
                           stop
                        end if
                        if ( rVec%x <= grids(gP)%xAxis(1) .or. xP<1) then
                           if (uHat%x<0.) uHat%x = -uHat%x
                           xP = 1
                           rVec%x = grids(gP)%xAxis(1)
                        end if
                        if ( rVec%y <= grids(gP)%yAxis(1) .or. yP<1) then
                           if (uHat%y<0.) uHat%y = -uHat%y
                           yP = 1
                           rVec%y = grids(gP)%yAxis(1)
                        end if
                        if ( rVec%z <= grids(gP)%zAxis(1) .or. zP<1) then
                           if (uHat%z<0.) uHat%z = -uHat%z
                           zP=1
                           rVec%z = grids(gP)%zAxis(1)
                        end if
                     end if


                     if (.not.lgPlaneIonization) then

                        if ( (abs(rVec%x) >= grids(gP)%xAxis(grids(gP)%nx)+grids(gP)%geoCorrX) .or.&
                             &(abs(rVec%y) >= grids(gP)%yAxis(grids(gP)%ny)+grids(gP)%geoCorrY) .or.&
                             &(abs(rVec%z) >= grids(gP)%zAxis(grids(gP)%nz)+grids(gP)%geoCorrZ) .or. &
                             & xP>grids(gP)%nx .or. yP>grids(gP)%ny .or. zP>grids(gP)%nz  ) then


                           if ((gP==1) .or.  (radius >= R_out .and. R_out >= 0.)) then
                              if (xP > grids(gP)%nx) xP = grids(gP)%nx
                              if (yP > grids(gP)%ny) yP = grids(gP)%ny
                              if (zP > grids(gP)%nz) zP = grids(gP)%nz
                              exit
                           else if (gP>1) then
                              xP = xPmother
                              yP = yPmother
                              zP = zPmother
                              gP = gPmother
                           else
                              print*, '! setResLineEscapeProb: insanity occurred - invalid gP - ', gP
                              stop
                           end if

                        end if
                        if ( .not. lgSymmetricXYZ .and. ( rVec%x < grids(gP)%xAxis(1) .or.&
                             & rVec%y < grids(gP)%yAxis(1) .or.&
                             & rVec%z < grids(gP)%zAxis(1) .or. &
                             & xP<1.or. yP<1 .or. zP<1 )) then

                           if (gP==1) then
                              if (xP < 1) xP = 1
                              if (yP < 1) yP = 1
                              if (zP < 1) zP = 1
                              exit
                           else if (gP>1) then
                              xP = xPmother
                              yP = yPmother
                              zP = zPmother
                              gP = gPmother
                           else
                              print*, '! setResLineEscapeProb: insanity occurred - invalid gP - ', gP
                              stop
                           end if

                        end if
                     end if


                     if (gP>1) then

                        if ( ( (rVec%x <= grids(gP)%xAxis(1) .or. xP<1) .and. uHat%x <=0.) .or. &
                             & ( (rVec%y <= grids(gP)%yAxis(1) .or. yP<1) .and. uHat%y <=0.) .or. &
                             & ( (rVec%z <= grids(gP)%zAxis(1) .or. zP<1) .and. uHat%z <=0.) ) then

                           ! go back to mother grid
                           xP = xPmother
                           yP = yPmother
                           zP = zPmother
                           gP = gPmother

                        end if

                     end if
                  end do

                  if (iCount>=10000) then
                     print*, '! setResLineEscapeProb: safeLimit exceeded in tau loop', icount, safelimit
                  end if

                  if (tau_mu <= 0.) then
                     tau_mu = 0.
                     if (lgTalk) &
                          & print*, '! setResLineEscapeProb: [warning] tau_mu <= 0. ', &
                          & tau_mu, uHat, xPin,yPin,zPin, cellP, xp,yp,zp
                  end if


                  ! calculate direction-dependent escape probability according to Kwan & Krolik 1981
                  if (tau_mu>=1.) then
                     bFac = sqrt(log(tau_mu))/(1.+tau_mu/1.e5)
                     Pline = 1./(tau_mu*sqrt(Pi)*(1.2+bFac))
                  else
                     Pline=(1.-exp(-2.*tau_mu))/(2.*tau_mu)
                  end if

                  if (tau_mu <= 0.) then
                     deltaxloc=0.
                  else
                     deltaxloc = log(tau_mu/sqrt(Pi))
                     if (deltaxloc >0.) then
                        deltaxloc=sqrt(deltaxloc)
                     else
                        deltaxloc=0.
                     end if
                  end if

                  ! calculate fEscapeResPhotons according to Harrington, Cohen and Hess (1984) eqn A5
                  grids(gPin)%fEscapeResPhotons(grids(gPin)%active(xPin,yPin,zPin),iLine) =&
                       &grids(gPin)%fEscapeResPhotons(grids(gPin)%active(xPin,yPin,zPin),iLine)+ &
                       & Pline
                  deltax = deltax+deltaxloc

               end do
            end do
         end do

         grids(gPin)%fEscapeResPhotons(grids(gPin)%active(xPin,yPin,zPin),iLine) = &
              & grids(gPin)%fEscapeResPhotons(grids(gPin)%active(xPin,yPin,zPin),iLine)/&
              & real((ndirx+1)*(ndiry+1)*(ndirz+1))

         deltax=deltax/real((ndirx+1)*(ndiry+1)*(ndirz+1))

         if (grids(gPin)%fEscapeResPhotons(grids(gPin)%active(xPin,yPin,zPin),iLine)>0.) then
            grids(gPin)%fEscapeResPhotons(grids(gPin)%active(xPin,yPin,zPin),iLine) = &
                 & 1./(1. + k_d*1.e+14*2.*deltax/(k_l*&
                 & grids(gPin)%fEscapeResPhotons(grids(gPin)%active(xPin,yPin,zPin),iLine)))
         else
            grids(gPin)%fEscapeResPhotons(grids(gPin)%active(xPin,yPin,zPin),iLine) = 0.
         end if

      end do


      if (lgTest) then
         print*, xPin, yPin, zPin,grids(gPin)%fEscapeResPhotons(grids(gPin)%active(xPin,yPin,zPin),1)
      end if

    end subroutine setResLineEscapeProb

    ! calculate direction-dependent escape probability according to Harrington, Cohen and Hess (1984) eqn A1
    function getM2_tau(width,lineIn,tauIn, profilein)
      implicit none

      type(resLine_type), intent(in) :: lineIn

      real, intent(in)              :: width, tauIn
      real, intent(in), optional    :: profileIn(nbins)
      real                          :: getM2_tau
      real                          :: dx

      integer                       :: i

      if (tauIn<0.) then
         print*, "! getM2_tau: negative tau", tauIn
         stop
      end if

      if (present(profilein)) then
         getM2_tau=0.
         do i = 1, nbins
            dx = widFlx(lineIn%nuP)*fr1ryd/(real(nbins-1)*width)
            getM2_tau = getM2_tau+profileIn(i)*exp(-tauIn*profileIn(i))*dx
         end do
      else
         getM2_tau = exp(-tauIn)
      end if

    end function getM2_tau

    function profile(profileID, widthIn, lineIn, nuIn)
      implicit none

      type(resLine_type), intent(in) :: lineIn
      real              :: profile ! phi(nu)
      real, intent(in)  :: nuIn ! frequency [Ryd]
      real, intent(in)  :: widthIn !

      character(len=7), intent(in) :: profileID ! what type of broadening?

      select case (profileID)
         case('doppler')
            profile = (1./(sqrt(Pi)*widthIn) ) * Exp(- ((nuIn-lineIn%freq)*fr1Ryd/widthIn)**2)
         case default
            print*, '! profile: unknown profile requested ', profileID
            stop
      end select

    end function profile

    ! use line centre xsec formula
    ! a0 = (Pi e^2 / (m_e c)) f /( (Pi^1/2 DeltaNuD))
    ! DeltaNuD = Doppler width = Nu0 /c * (2 k T /m_ion)^1/2
    !
    subroutine lineCentreXSec(line, width, line_xSec)
      implicit none

      type(resLine_type), intent(inout) :: line

      real, intent(in)         :: width
      real, intent(out)        :: line_xSec


      if (width<=0.) then
         print*, '! lineCentreXSec: width less or equal to zero'
         stop
      end if
      line_xSec = 14.969e-3*line%fik/width

    end subroutine lineCentreXSec


    ! use hummer & kunasz eqn 2.3 : k_l = N_k B_kl h v_kl/(4 Pi DeltaNuP)
    ! and B_kl = e^2 f_kl / (4 E_0 m_e c h n_kl)
    ! hence k_l = N_k e^2 f_kl / (4 E_0 m_e c 4 Pi DeltaNuP)
    ! E_0 is permissivity of free space
    ! a0 = (Pi e^2 / (m_e c)) f /( (Pi^1/2 DeltaNuD))
    ! DeltaNuD = Doppler width = Nu0 /c * (2 k T /m_ion)^1/2
    !
    subroutine meanLineOpacity(line, width, line_xSec)
      implicit none

      type(resLine_type), intent(inout) :: line

      real, intent(in)         :: width
      real, intent(out)        :: line_xSec


      if (width<=0.) then
         print*, '! lineCentreXSec: width less or equal to zero'
         stop
      end if
      line_xSec = 1.681e-4*line%fik/width

    end subroutine meanLineOpacity

  end module emission_mod

! Copyright (C) 2005 Barbara Ercolano
! changed nStages from 6 to 9 for the modelling of higher energy ions (nw2006)
!
! Version 2.02
module constants_mod

    public

    ! physical constant
    real, parameter :: A0 = 6.30e-18               ! H0 phot x sec at the edge [cm^2]
    real, parameter :: amu = 1.66053e-24           ! [g]
    real, parameter :: c = 2.9979250e10            ! speed of light [cm/s]
    real, parameter :: fr1Ryd = 3.28984e15         ! frequency a 1 Ryd [Hz]
    real, parameter :: hPlanck = 6.6262e-27        ! Planck constant [erg s]
    real, parameter :: HIonPot = 0.99946           ! ionization potential of H [Ryd]
    real, parameter :: hnu3c2 = 0.524166
    real, parameter :: me = 9.109382e-28           ! mass of e- [g]
    real, parameter :: kBoltzmann = 1.380658e-16     ! Boltzmann constant
    real, parameter :: radio4p9GHz = 1.489434e-6     ! 4.9 GHz in Ryd
    real, parameter :: Ryd2erg = 2.1799e-11        ! converts ryd to erg
    real, parameter :: RydInf = 109737.315         ! Ryd for infinitme mass nuclei [1/cm]
    real, parameter :: sigma = 5.66956e-5          ! Stefan-Boltzmann constant [erg*cm^-2deg^-4s-1]
    real, parameter :: Te1Ryd = 1.578866e5         ! Te at 1 Ryd [K]
    real, parameter :: Y1 = 0.2                    ! see Baldwin et al. 1991, ApJ 374, 580
    real, parameter :: FeKaCold = 470.388          ![ryd] =6.4keV -> energy of Fe K alpha for cold iron

    ! numerical constants
    real, parameter :: rootThree = 1.732050808
    real, parameter :: kShellLimit = 7.35e4        ! high energy limit to code

    ! pi
    real, parameter :: pi = 3.141592654
    real, parameter :: twoPi = 2.*pi
    real, parameter :: fourPi = 4.*pi
    real, parameter :: piByFour = pi/4.
    real, parameter :: oneOnFourPi = 1./(4.*pi)
    real, parameter :: oneOnTwoPi = 1./(2.*pi)

    ! conversion factors
    real, parameter :: degToRad = pi/180.
    real, parameter :: RydToeV = 13.6056981
    real, parameter :: radToDeg = 180./pi

    ! hard limits
    integer, parameter :: maxGrids = 50000           ! limit to the number of grids to be used
    integer, parameter :: maxTau = 10000000         ! limit to the optical depth arrays
    integer, parameter :: nElements = 30            ! number of elements
    integer, parameter :: nForLevels = 17           ! number of levels
    integer, parameter :: nForLevelsLarge = 142     ! number of levels for FeII
    integer, parameter :: nHlevel =  10             ! number of levels in the H atom
    integer, parameter :: nHeIlevel = 9             ! number of levels in the HeI singlets
    integer, parameter :: nHeIIlevel = 9            ! number of levels in the HeII singlets
    integer, parameter :: NnuMax = 3000             ! limit to the possible number of energy bins (nbins)
    integer, parameter :: xSecMax = 1000000         ! max limit to xSecArray
    integer, parameter :: nTemps=3000
    integer, parameter :: recursionLimit=5000

    real, parameter :: xMax = 0.99999               ! max limit for a relative ionic abundance

end module constants_mod

! Copyright (C) 2005 Barbara Ercolano
!
! Version 2.02
module pathIntegration_mod
    use common_mod
    use interpolation_mod
    use vector_mod

    contains

    ! This subroutine performs the integration of opacities from a position
    ! aVec to the edge of the nebula in the arbitrary direction uHat
    subroutine integratePathTau(grid, aVec, uHat, freq, nTau, absTau, lambda)
        implicit none

        type(grid_type), intent(in) :: grid(*)        ! grid

        type(vector),  intent(in)   :: uHat           ! direction vector
        type(vector),  intent(in)   :: aVec           ! starting position vector

        integer, intent(out)        :: nTau           ! actual size of opacity and length arrays

        real, intent(in)            :: freq           ! the frequency [Hz]
        real, intent(out), &
             & dimension(maxTau)    :: absTau         ! absorption optical depth

        real, intent(out), &
             & dimension(maxTau)    :: lambda         ! distance array

        ! local variables

        type(vector)                :: rVec           ! position vector
        type(vector)                :: vHat           ! direction vector


        integer                     :: freqP          ! frequency index
        integer                     :: i              ! counter
        integer                     :: xP, yP, zP     ! x, y, and z axis indeces
        integer, parameter          :: nl = 4         ! defines the size of the distance increment


        real                        :: dlSmall        ! distance increment

        if (nGrids>1) then
           print*, 'integratePathTau: tau integration routine still not developed for multiple grids... returning '
           return
        end if

        ! locate the input frequency in the frequency array
        call locate(nuArray(1:nbins), freq, freqP)
        if (freqP<=0 .or. freqP>nbins) then
           print*, "! integratePathTau: out of bounds frequency ", freqP, freq, nuArray(1), nuArray(nbins)
           print*, nuArray
           stop
        end if


        ! locate the starting position in the cartesian grid
        call locate(grid(1)%xAxis, aVec%x, xP)
        if ( xP < grid(1)%nx ) then
            if ( aVec%x >= (grid(1)%xAxis(xP)+ &
                 & grid(1)%xAxis(xP+1))/2. ) xP = xP+1
        end if
        call locate(grid(1)%yAxis, aVec%y, yP)
        if ( yP < grid(1)%ny ) then
            if ( aVec%y >= (grid(1)%yAxis(yP)+ &
                 & grid(1)%yAxis(yP+1))/2. ) yP = yP+1
        end if
        call locate(grid(1)%zAxis, aVec%z, zP)
        if ( zP < grid(1)%nz ) then
            if ( aVec%z >= (grid(1)%zAxis(zP)+ &
                 & grid(1)%zAxis(zP+1))/2. ) zP = zP+1
        end if


        ! check that the input position is not outside the grid
        if ( (xP <= 0).or.(xP > grid(1)%nx) ) then
            print*, "! integratePathTau: starting position in x is outside the grid",xP,yP,zP
            stop
        else if ( (yP <= 0).or.(yP > grid(1)%ny) ) then
            print*, "! integratePathTau: starting position in y is outside the grid",xP,yP,zP
            stop
        else if ( (zP <= 0).or.(zP > grid(1)%nz) ) then
            print*, "! integratePathTau: starting position in z is outside the grid",xP,yP,zP
            stop
        end if

        ! define dlSmall
        dlSmall = dl(1)

        ! initialize the optical depth arrays
        absTau = 0.
        lambda = 0.

        ! initialize nTau
        nTau = 1

        ! initialize direction vactor
        vHat = uHat

        ! the first optical depth are all zero (as displacement is zero)
        ! these have already been set to zero in the initialization of the arrays
        ! so add the first displacements vector (dlSmall*vHat)
        rVec = aVec + dlSmall*vHat

        ! execute this loop until the edge of the grid is reached
        do i = 1, maxTau

           ! check if the path is still within the ionized region
           if (rVec%x > grid(1)%xAxis(grid(1)%nx)) exit

           if (rVec%y > grid(1)%yAxis(grid(1)%ny)) exit

           if (rVec%z > grid(1)%zAxis(grid(1)%nz)) exit

           if ( sqrt( (rvec%x/1.e10)**2 + (rvec%y/1.e10)**2 + (rvec%z/1.e10)**2)*1.e10 >= R_out &
                & .and. R_out > 0.) exit


           if (lgSymmetricXYZ) then
              if( rVec%x < grid(1)%xAxis(1) ) then
                 vHat%x = -vHat%x
                 rVec%x = -rVec%x
                 call locate(grid(1)%xAxis, rVec%x, xP)
              end if
              if( rVec%y < grid(1)%yAxis(1) ) then
                 vHat%y = -vHat%y
                 rVec%y = -rVec%y
                 call locate(grid(1)%yAxis, rVec%y, yP)
              end if
              if( rVec%z < grid(1)%zAxis(1) ) then
                 vHat%z = -vHat%z
                 rVec%z = -rVec%z
                 call locate(grid(1)%zAxis, rVec%z, zP)
              end if
           end if

           ! x-axis
           if (xP < grid(1)%nx) then
              if ( rVec%x > (grid(1)%xAxis(xP)+grid(1)%xAxis(xP+1))/2. ) then
                 xP = xP + 1
              end if
           else if (xP == grid(1)%nx) then
              if ( rVec%x > grid(1)%xAxis(xP) ) exit
           end if
           if (xP > 1) then
              if ( rVec%x < (grid(1)%xAxis(xP)+grid(1)%xAxis(xP-1))/2. ) then
                 xP = xP - 1
              end if
           end if

           ! y-axis
           if (yP < grid(1)%ny) then
              if ( rVec%y > (grid(1)%yAxis(yP)+grid(1)%yAxis(yP+1))/2. ) then
                 yP = yP + 1
              end if
           else if (yP == grid(1)%ny) then
              if (rVec%y > grid(1)%yAxis(yP)) exit
           end if
           if (yP > 1) then
              if ( rVec%y < (grid(1)%yAxis(yP)+grid(1)%yAxis(yP-1))/2. ) then
                 yP = yP - 1
              end if
           end if

           ! z-axis
            if (zP < grid(1)%nz) then
               if ( rVec%z > (grid(1)%zAxis(zP)+grid(1)%zAxis(zP+1))/2. ) then
                  zP = zP + 1
               end if
            else if (zP == grid(1)%nz) then
               if (rVec%z > grid(1)%zAxis(zP)) exit
            end if
            if (zP > 1) then
                if ( rVec%z < (grid(1)%zAxis(zP)+grid(1)%zAxis(zP-1))/2. ) then
                    zP = zP - 1
                end if
            end if

            if (.not.lgSymmetricXYZ) then
                if ((xP < 1) .or. (zP < 1) .or. (yP < 1)) exit
            end if

             ! check if there's any symmetries and if the path must be reflected
             if (lgSymmetricXYZ) then
                 if (xP<1) then
                     vHat%x=-vHat%x
                     rVec%x=-rVec%x
                     call locate(grid(1)%xAxis, rVec%x, xP)
                     if (xP < grid(1)%nx) then
                         if ( rVec%x > (grid(1)%xAxis(xP)+grid(1)%xAxis(xP+1))/2. ) xP = xP + 1
                     else if (xP == grid(1)%nx) then
                         if (rVec%x > grid(1)%xAxis(xP)) exit
                     end if
                 end if
                 if (yP<1) then
                     vHat%y=-vHat%y
                     rVec%y=-rVec%y
                     call locate(grid(1)%yAxis, rVec%y, yP)
                     if (yP < grid(1)%ny) then
                         if ( rVec%y > (grid(1)%yAxis(yP)+grid(1)%yAxis(yP+1))/2. ) yP = yP + 1
                     else if (yP == grid(1)%ny) then
                         if (rVec%y > grid(1)%yAxis(yP)) exit
                     end if
                 end if
                 if (zP<1) then
                     vHat%z=-vHat%z
                     rVec%z=-rVec%z
                     call locate(grid(1)%zAxis, rVec%z, zP)
                     if (zP < grid(1)%nz) then
                         if ( rVec%z > (grid(1)%zAxis(zP)+grid(1)%zAxis(zP+1))/2. ) zP = zP + 1
                     else if (zP == grid(1)%nz) then
                         if (rVec%z > grid(1)%zAxis(zP)) exit
                     end if
                 end if
             end if

            ! increment nTau
            nTau = nTau + 1

            ! this should never happen (as the loop is stopped at maxTau anyway)
            ! just a sanity check
            if (nTau > maxTau) then
                print*, "! integratePathTau: tau arrays are full", xP,yP,zP
                exit
            end if

            ! add the delta optical depths
            absTau(nTau) = absTau(nTau-1) + grid(1)%opacity(grid(1)%active(xP,yP,zP),freqP)*dlSmall
            lambda(nTau) = lambda(nTau-1) + dlSmall
            ! increment position by adding the displacements vector (dlSmall*vHat)
            rVec = rVec + dlSmall*vHat

        end do

    end subroutine integratePathTau


    ! This subroutine performs the integration of opacities from a position
    ! aVec to the edge of the nebula in the arbitrary direction uHat
    subroutine integratePathTauNu(grid, aVec, uHat, freqP, absTau)
        implicit none

        type(grid_type), intent(in) :: grid(*)        ! grid

        type(vector),  intent(in)   :: uHat           ! direction vector
        type(vector),  intent(in)   :: aVec           ! starting position vector

        real, intent(out)           :: absTau         ! extinction optical depth

        ! local variables

        type(vector)                :: rVec           ! position vector
        type(vector)                :: vHat           ! direction vector

        integer, intent(in)         :: freqP           ! the frequency index

        integer                     :: i              ! counter
        integer                     :: xP, yP, zP     ! x, y, and z axis indeces

        real                        :: dlSmall        ! distance increment

        if (nGrids>1) then
           print*, 'integratePathTau: tau integration routine still not developed for multiple grids... returning '
           return
        end if

        ! locate the starting position in the cartesian grid
        call locate(grid(1)%xAxis, aVec%x, xP)
        if ( xP < grid(1)%nx ) then
            if ( aVec%x >= (grid(1)%xAxis(xP)+ &
                 & grid(1)%xAxis(xP+1))/2. ) xP = xP+1
        end if
        call locate(grid(1)%yAxis, aVec%y, yP)
        if ( yP < grid(1)%ny ) then
            if ( aVec%y >= (grid(1)%yAxis(yP)+ &
                 & grid(1)%yAxis(yP+1))/2. ) yP = yP+1
        end if
        call locate(grid(1)%zAxis, aVec%z, zP)
        if ( zP < grid(1)%nz ) then
            if ( aVec%z >= (grid(1)%zAxis(zP)+ &
                 & grid(1)%zAxis(zP+1))/2. ) zP = zP+1
        end if


        ! check that the input position is not outside the grid
        if ( (xP <= 0).or.(xP > grid(1)%nx) ) then
            print*, "! integratePathTau: starting position in x is outside the grid",xP,yP,zP
            stop
        else if ( (yP <= 0).or.(yP > grid(1)%ny) ) then
            print*, "! integratePathTau: starting position in y is outside the grid",xP,yP,zP
            stop
        else if ( (zP <= 0).or.(zP > grid(1)%nz) ) then
            print*, "! integratePathTau: starting position in z is outside the grid",xP,yP,zP
            stop
        end if

        dlSmall = 0.
        if (uHat%x > 0.) then
           ! find linear increment
           dlSmall =  abs(grid(1)%xAxis(2) - grid(1)%xAxis(1))
           do i = 2, grid(1)%nx-1
              dlSmall = min(dlSmall, abs(grid(1)%xAxis(i+1)-grid(1)%xAxis(i)) )
           end do
        end if

        if (uHat%y > 0.) then
           if (dlSmall <= 0.) then
              ! find linear increment
              dlSmall =  abs(grid(1)%yAxis(2) - grid(1)%yAxis(1))
              do i = 2, grid(1)%ny-1
                 dlSmall = min(dlSmall, abs(grid(1)%yAxis(i+1)-grid(1)%yAxis(i)) )
              end do
           else
              ! find linear increment
              do i = 1, grid(1)%ny-1
                 dlSmall = min(dlSmall, abs(grid(1)%yAxis(i+1)-grid(1)%yAxis(i)) )
              end do
           end if
        end if

        if (uHat%z > 0.) then
           if (dlSmall <= 0.) then
              ! find linear increment
              dlSmall =  abs(grid(1)%zAxis(2) - grid(1)%zAxis(1))
              do i = 2, grid(1)%nz-1
                 dlSmall = min(dlSmall, abs(grid(1)%zAxis(i+1)-grid(1)%zAxis(i)) )
              end do
           else
              ! find linear increment
              do i = 1, grid(1)%nz-1
                 dlSmall = min(dlSmall, abs(grid(1)%zAxis(i+1)-grid(1)%zAxis(i)) )
              end do
           end if
        end if

        dlSmall = dlSmall/2.

        ! initialize the optical depth arrays
        absTau = 0.

        ! initialize direction vector
        vHat = uHat

        ! the first optical depth are all zero (as displacement is zero)
        ! these have already been set to zero in the initialization of the arrays
        ! so add the first displacements vector (dlSmall*vHat)
        rVec = aVec + dlSmall*vHat

        ! execute this loop until the edge of the grid is reached
        do i = 1, maxTau

           ! check if the path is still within the ionized region
           if (rVec%x > grid(1)%xAxis(grid(1)%nx)) exit

           if (rVec%y > grid(1)%yAxis(grid(1)%ny)) exit

           if (rVec%z > grid(1)%zAxis(grid(1)%nz)) exit

           if ( sqrt( (rvec%x/1.e10)**2 + (rvec%y/1.e10)**2 + (rvec%z/1.e10)**2)*1.e10 >= R_out &
                & .and. R_out > 0.) exit


           if (lgSymmetricXYZ) then
              if( rVec%x < grid(1)%xAxis(1) ) then
                 vHat%x = -vHat%x
                 rVec%x = -rVec%x
                 call locate(grid(1)%xAxis, rVec%x, xP)
              end if
              if( rVec%y < grid(1)%yAxis(1) ) then
                 vHat%y = -vHat%y
                 rVec%y = -rVec%y
                 call locate(grid(1)%yAxis, rVec%y, yP)
              end if
              if( rVec%z < grid(1)%zAxis(1) ) then
                 vHat%z = -vHat%z
                 rVec%z = -rVec%z
                 call locate(grid(1)%zAxis, rVec%z, zP)
              end if
           end if

           ! x-axis
           if (xP < grid(1)%nx) then
              if ( rVec%x > (grid(1)%xAxis(xP)+grid(1)%xAxis(xP+1))/2. ) then
                 xP = xP + 1
              end if
           else if (xP == grid(1)%nx) then
              if ( rVec%x > grid(1)%xAxis(xP) ) exit
           end if
           if (xP > 1) then
              if ( rVec%x < (grid(1)%xAxis(xP)+grid(1)%xAxis(xP-1))/2. ) then
                 xP = xP - 1
              end if
           end if

           ! y-axis
           if (yP < grid(1)%ny) then
              if ( rVec%y > (grid(1)%yAxis(yP)+grid(1)%yAxis(yP+1))/2. ) then
                 yP = yP + 1
              end if
           else if (yP == grid(1)%ny) then
              if (rVec%y > grid(1)%yAxis(yP)) exit
           end if
           if (yP > 1) then
              if ( rVec%y < (grid(1)%yAxis(yP)+grid(1)%yAxis(yP-1))/2. ) then
                 yP = yP - 1
              end if
           end if

           ! z-axis
            if (zP < grid(1)%nz) then
               if ( rVec%z > (grid(1)%zAxis(zP)+grid(1)%zAxis(zP+1))/2. ) then
                  zP = zP + 1
               end if
            else if (zP == grid(1)%nz) then
               if (rVec%z > grid(1)%zAxis(zP)) exit
            end if
            if (zP > 1) then
                if ( rVec%z < (grid(1)%zAxis(zP)+grid(1)%zAxis(zP-1))/2. ) then
                    zP = zP - 1
                end if
            end if

            if (.not.lgSymmetricXYZ) then
                if ((xP < 1) .or. (zP < 1) .or. (yP < 1)) exit
            end if

             ! check if there's any symmetries and if the path must be reflected
             if (lgSymmetricXYZ) then
                 if (xP<1) then
                     vHat%x=-vHat%x
                     rVec%x=-rVec%x
                     call locate(grid(1)%xAxis, rVec%x, xP)
                     if (xP < grid(1)%nx) then
                         if ( rVec%x > (grid(1)%xAxis(xP)+grid(1)%xAxis(xP+1))/2. ) xP = xP + 1
                     else if (xP == grid(1)%nx) then
                         if (rVec%x > grid(1)%xAxis(xP)) exit
                     end if
                 end if
                 if (yP<1) then
                     vHat%y=-vHat%y
                     rVec%y=-rVec%y
                     call locate(grid(1)%yAxis, rVec%y, yP)
                     if (yP < grid(1)%ny) then
                         if ( rVec%y > (grid(1)%yAxis(yP)+grid(1)%yAxis(yP+1))/2. ) yP = yP + 1
                     else if (yP == grid(1)%ny) then
                         if (rVec%y > grid(1)%yAxis(yP)) exit
                     end if
                 end if
                 if (zP<1) then
                     vHat%z=-vHat%z
                     rVec%z=-rVec%z
                     call locate(grid(1)%zAxis, rVec%z, zP)
                     if (zP < grid(1)%nz) then
                         if ( rVec%z > (grid(1)%zAxis(zP)+grid(1)%zAxis(zP+1))/2. ) zP = zP + 1
                     else if (zP == grid(1)%nz) then
                         if (rVec%z > grid(1)%zAxis(zP)) exit
                     end if
                 end if
             end if

             ! add the delta optical depths
             absTau = absTau + grid(1)%opacity(grid(1)%active(xP,yP,zP),freqP)*dlSmall

             ! increment position by adding the displacements vector (dlSmall*vHat)
             rVec = rVec + dlSmall*vHat

        end do

    end subroutine integratePathTauNu



end module pathIntegration_mod

! Copyright (C) 2005 Barbara Ercolano
!
! MoCaSSiNoutput = MOnte CArlo SImulationS of Nebulae
! this is the output-only driver of the simulation
! (requires grid1.out,grid2.out,grid3.out files)
!
! Version 2.02
program MoCaSSiNoutput
    use common_mod
    use constants_mod
    use grid_mod
    use iteration_mod
    use output_mod
    use set_input_mod
    use xSec_mod

    implicit none

    include 'mpif.h'

    type(grid_type) :: grid3D(maxGrids) ! the 3D Cartesian  grid

    integer         :: iGrid

    call mpi_init(ierr)
    call mpi_comm_rank(MPI_COMM_WORLD, taskid, ierr)
    call mpi_comm_size(MPI_COMM_WORLD, numtasks, ierr)

!    starttime = mpi_wtime()

    lgWarm = .true.
    lgRecombination = .true.

    if (taskid == 0) then
        print*, "MOCASSIN 2005 output Version 2.00"
        print*, "Creating output files from current grid*.out files "
        print*, " stored in the output/ directory"
        print*, " "
    end if

    if (taskid == 0) then
        print*, " "
    end if

    ! reset the 3D cartesian grid
    call resetGrid(grid3D)

    call setStarPosition(grid3D(1)%xAxis,grid3D(1)%yAxis,grid3D(1)%zAxis,grid3D)


    ! initialize opacities x sections array
    call initXSecArray()

    ! set the ionzing continuum according to the contShape variable
    call setContinuum()

    ! prepare atomica data stuff
    call makeElements()

    if (taskid ==  0) then
        ! determine final statistics
        if (lgGas) call outputGas(grid3D)
    end if

    call mpi_barrier(mpi_comm_world, ierr)

    ! free all space allocated to the 3D grid
    do iGrid=1, nGrids
       call freeGrid(grid3D(iGrid))
    end do

!    endtime  = mpi_wtime()

    if (taskid == 0) then
!        print*, "time: ", endtime-starttime
    end if

    call mpi_finalize(ierr)
    stop 'mpi done'


end program MoCaSSiNoutput

! Copyright (C) 2005 Barbara Ercolano
!
! Version 2.02
module elements_mod
    use common_mod
    use interpolation_mod
    implicit none

    real :: HlevEn(nHlevel+1), HeIlevEn(nHeIlevel+1), HeIIlevEn(nHeIIlevel+1)

    contains

    subroutine makeCollIonData()
      implicit none

      integer :: elem,ion, i

      close(12)
      open(unit = 12, file = PREFIX//'/share/mocassin/data/cion.dat', status='old', position='rewind')

      do elem = 1, nElements
         do ion = elem, 1, -1
            read(12,*) (CF(i,elem,ion),i=1,5)
         end do
      end do
      read(12,*)
      read(12,*)
      do elem = 3, nElements
         read(12,*) (cionTherm(elem,ion) , ion=1, elem)
      end do
      close(12)

    end subroutine makeCollIonData

    subroutine makeAugerData()
      implicit none

      integer :: elem,ion,shell,nelec,i,j

      close(12)
      open(unit = 12, file = PREFIX//'/share/mocassin/data/auger.dat', status='old', position='rewind')

      nAuger=0
      auger =0.

      do i = 1, 1696
         read(12,*) elem,ion,shell,nelec
         nauger(elem,ion,shell)=nelec
         read(12,*) (auger(elem,ion,shell,j), j = 1, 10)
      end do
      close(12)

    end subroutine makeAugerData

    ! this subroutine makes the data for Hydrogen and Helium
    subroutine makeHydro()

        ! local variables
        integer :: iup          ! counters

        ! define excitation and ionization temperatures for hydrogen
        do iup = 1, nHlevel
            HlevEn(iup) = HIonPot / float(iup*iup)
            ! fill in stat weight for H
        end do
        HlevEn(nHlevel+1) = HlevEn(2)


        ! define excitation and ionization temperatures for HeI
        do iup = 1, nHeIlevel
            HeIlevEn(iup) = 1. / float(iup*iup)
            ! fill in stat weight for HeI
        end do
        ! ground state and the n=2 are not hydrogenic
        HeIlevEn(1) = 1.80802
        HeIlevEn(2) = 0.2478
        HeIlevEn(nHeIlevel+1) = HeIlevEn(2)

        ! define excitation and ionization temperatures for HeII
        do iup = 1, nHeIIlevel
            HeIIlevEn(iup) = 4. / float(iup*iup)
        end do
        HeIIlevEn(nHeIIlevel+1) = HeIIlevEn(2)

     end subroutine makeHydro

    ! this subroutine determines the outer shell and statistical weights
     ! LS coupling
    subroutine getOuterShell(z, nElec, outShell, g0, g1)
        implicit none

        integer, intent(in)  :: z        ! atomic number from 1 to 30
        integer, intent(in)  :: nElec    ! number of electrons from 1 to z
        integer, intent(out) :: outShell ! number of the outer shell
        integer, intent(out) :: g0       ! statistical weight of (z, nelec) ground state
        integer, intent(out) :: g1       ! statistical weight of (z, nelec-1) ground state

        ! local variables
        integer, dimension(30) :: ss, gl ! data for outer shells and statistical weights
        integer, dimension(19:30) :: glhigh


        ! assign the data to the local arrays
        ss = (/1,1,2,2,3,3,3,3,3,3,4,4, &
              &  5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,7,7/)

        gl = (/2, 1, 2, 1, 6, 9, 4, 9, 6, 1, 2, 1, 6, 9, 4, 9, 6, 1, 2, 1, &
             & 10, 21, 28, 7, 6, 25, 28, 21, 2, 1/)

        glhigh = (/10,21,28,25,6,25,28,21,10,1,2,1/)


        if ( .not.lgElementOn(z) ) then
            print*, "! getOuterShell: element is switched off [elem]", z
            stop
        end if

        if ( z > 30 ) then
            print*, "! getOuterShell: atomic number out of range"
            stop
         end if
        if ( (nElec < 1) .or. (nElec > z) ) then
            print*, "! getOuterShell: number of electrons out of range"
            stop
        end if

        ! number of the outer shell and statistical weight
        outShell = ss(nElec)
        if (z==nElec .and.z>18) outShell = 7
        if (z==nElec+1 .and. &
             &(z==20.or.z==21.or.z==22.or.z==25.or.z==26)) outShell = 7

        g0 = gl(nElec)
        if (nElec == 1) then
            g1 = 1
        else
            g1 = gl(nElec-1)
        end if

        if ( (z>20) .and. nElec >= 19 .and. (z-nElec)>=1) then
           g0 = glhigh(nElec)
           if (nElec == 19) then
              g1 = gl(nElec-1)
           else
              g1 = glHigh(nElec-1)
           end if
        end if

        if ( z == nElec ) then
           if (z>20 .and. nElec >= 21) then
              g1 = glHigh(nElec-1)
           end if

           select case (z)
           case (21)
              g1 = 15
           case (22)
              g1 = 28
           case (25)
              g1 = 7
           case (26)
              g1 = 30
           end select

        end if


        if ( z-nElec == 1 ) then
           select case (z)
           case (21)
              g0 = 15
           case (22)
              g0 = 28
           case (25)
              g0 = 7
           case (26)
              g0 = 30
           end select
        end if


     end subroutine getOuterShell

      subroutine readHeIRecLines()
       implicit none

       ! iden = 1 is 100cm^-2
       ! iden = 2 is 10000cm^-2
       ! iden = 3 is 1000000cm^-2
       integer :: iline, iden, j

       close(13)
       open(file=PREFIX//'/share/mocassin/data/HeIrecLines.dat', unit = 13, status='old')

       do iden = 1, 3
          do iline = 1, 34
             read(13,*) (HeIrecLineCoeff(iline,iden,j), j = 1, 4)
             HeIrecLineCoeff(iline,iden,1) = HeIrecLineCoeff(iline,iden,1)*1.e25
          end do
       end do


       close(13)
     end subroutine readHeIRecLines

     ! this subroutine assigns continuum energy pointers
     ! to shells for all atoms
     subroutine setShells(nElem)
         implicit none

         integer, intent(in) :: nElem

         ! local variables
         integer            :: g0             ! statistical weight of (z, n) ground state
         integer            :: g1             ! statistical weight of (z, n-1) ground state
         integer            :: ion            ! ionic stage (=1 for atom up to totElem for hydrogenic)
         integer            :: nElec          ! number of boundn electrons
         integer            :: shell          ! shell number
         integer, parameter :: totElem = 30
         integer            :: outShell       ! outer shell number


         real               :: thres ! threshold [Ryd]

         if ( .not.lgElementOn(nElem) ) then
             print*, "! setShells: element is switched off [elem]", nElem
             stop
         end if

         ! check nElem is within the array bounds
         if ( (nElem > totElem) .or. (nElem < 1) ) then
             print*, "! setShells: nElement out of range [1, 30]"
             stop
         end if

         do ion = 1, nElem

             ! find number of bound electrons
             nElec = nElem - ion + 1
             call getOuterShell(nElem, nElec, outShell, g0, g1)
             nShells(nELem, ion) = outShell

             ! loop on all inner shells, valence shell
             do shell = 1, outShell
                 thres = ph1(1, nElem, nElec, shell) / RydToeV

                 ! negative IP shell doesn't exist, so set
                 ! the upper limit lower then the
                 ! lower limit so this never loop upon.
                 ! used as flags by limitShell to check
                 ! whether this is a real shell
!print*, nelem, ion, shell,  thres, nuArray(1)
                 if ( thres <= 0.1 )  then
                     elementP(nElem, ion, shell, 1) = 2
                     elementP(nElem, ion, shell, 2) = 1
                 else
                     ! this is the lower limit to the range
                     call locate(nuArray, thres, elementP(nElem, ion, shell, 1))
                     if ( elementP(nElem, ion, shell, 1) < nbins ) then
                         elementP(nElem, ion, shell, 1) = elementP(nElem, ion, shell, 1)
                     end if

                     ! this is the higher limit to the range.
                     ! limitShell returns the pointer to the threshold
                     ! of the next major shell. Fo the k-shell returns
                     ! kShellLimit (= nuMax)
                     elementP(nElem, ion, shell, 2) = limitShell(ion, shell, nElem)
                 end if
             end do
             ! this is the valence pointer
             call locate(nuArray, thres, elementP(nElem, ion, outShell, 1))
             if ( elementP(nElem, ion, outShell, 1) < nbins ) then
                 elementP(nElem, ion, outShell, 1) = elementP(nElem, ion, outShell, 1)
             end if

          end do


    end subroutine setShells

    ! this function returns the high energy limit to the energy range
    function limitShell(ion, shell, nElem)
        implicit none

        integer, intent(in) :: ion      ! ionic stage (=1 for atom up to totElem for hydrogenic)
        integer, intent(in) :: nElem    ! element number
        integer, intent(in) :: shell    ! shell number

        integer             :: limitShell

        ! local variables

        if (.not.lgElementOn(nElem)) then
            print*, "! limitShell: element is not switched on [elem]", nElem
            stop
        end if


        select case (shell)
        ! high energy limit to code kShellLimit = nuMax
        case (1)
            limitShell = kShellLimitP
        ! 2s shell, upper limit set to high energy limit
        case (2)
            limitShell = kShellLimitP
        ! 2p shell,  upper limit set to high energy limit
        case (3)
            limitShell = kShellLimitP
        ! 3s shell, upper limit set to k-shell edge
        case (4)
            limitShell = elementP(nElem, ion, 1, 1) -1
        ! 3p shell,  upper limit set to k-shell edge
        case (5)
            limitShell = elementP(nElem, ion, 1, 1) -1
        ! 3d sgell, upper limit set to k-shell edge
        case (6)
            limitShell = elementP(nElem, ion, 1, 1) -1
        ! 4s shell, upper limit set to 3d
        case (7)
            ! if the shell 6 is empty (3d) then set it to 5 (3p)
            if (elementP(nElem, ion, 6, 1)<3) then
                limitShell = elementP(nElem, ion, 5, 1) -1
            else
                limitShell = elementP(nElem, ion, 6, 1) -1
            end if
        case default
            print*, "! limitShell: shell number out of range [1, 7]"
            stop
        end select

      end function limitShell


     ! this subroutine sets up the pointers for the lines and
     ! the cotinua
     subroutine setPointers()

         ! local variables
         integer :: i          ! counters

         ! set pointer for K-shell limit
         call locate(nuArray, KshellLimit, KshellLimitP)

         ! set pointer for secondary ionisation
         call locate(nuArray,7.353,secIonP)

         ! set pointer for Compton recoil
         call locate(nuArray,194., cRecoilHP)
         call locate(nuArray,260., cRecoilHeP)

         ! set xRay pointer
         call locate(nuArray,20.6, xrayP)

         ! set the pointer to the Balmer jump in the nuArray
         call locate(nuArray, 0.25, BjumpP)

         ! set data for hydrogen and helium atoms
         call makeHydro()

         ! read in data from benj skil smit 99
         call readHeIRecLines()

         ! set HlevNuP (pointer to the nth H level in nuArray)
         do i = 1, nHlevel
            call locate(nuArray, HlevEn(i), HlevNuP(i))
         end do
         HlevNuP(nHlevel+1) = HlevNuP(2)

         ! set HeIlevNuP (pointer to the nth HeI level in nuArray)
         do i = 1, nHeIlevel
            call locate(nuArray, HeIlevEn(i), HeIlevNuP(i))
         end do
         HeIlevNuP(nHeIlevel+1) = HeIlevNuP(2)

         ! set HeIIlevNuP (pointer to the nth HeII level in nuArray)
         do i = 1, nHeIIlevel
            call locate(nuArray, HeIIlevEn(i), HeIIlevNuP(i))
            HeIIlevNuP(i) = HeIIlevNuP(i)
         end do
         HeIIlevNuP(nHeIIlevel+1) = HeIIlevNuP(2)

         ! set up shell pointers
         ! the folloowing order of elements is more or less in decreasing
         ! abundance

         ! H and He
         nShells(1,1) = 1
         nShells(2,1) = 1
         nShells(2,2) = 1

         ! carbon
         if (lgElementOn(6)) call setShells(6)

         ! oxygen
         if (lgElementOn(8)) call setShells(8)

         ! nitrogen -after O so that O gets more accurate pointer
         if (lgElementOn(7)) call setShells(7)

         ! neon
         if (lgElementOn(10)) call setShells(10)

         ! sodium
         if (lgElementOn(11)) call setShells(11)

         ! magnesium
         if (lgElementOn(12)) call setShells(12)

         ! alluminium
         if (lgElementOn(13)) call setShells(13)

         ! silicon
         if (lgElementOn(14)) call setShells(14)

         ! phosphorus
         if (lgElementOn(15)) call setShells(15)

         ! sulphur
         if (lgElementOn(16)) call setShells(16)

         ! chlorine
         if (lgElementOn(17)) call setShells(17)

         ! iron
         if (lgElementOn(26)) call setShells(26)

         ! argon
         if (lgElementOn(18)) call setShells(18)

         ! potassium
         if (lgElementOn(19)) call setShells(19)

         ! calcium
         if (lgElementOn(20)) call setShells(20)

         ! scandium
         if (lgElementOn(21)) call setShells(21)

         ! titanium
         if (lgElementOn(22)) call setShells(22)

         ! vanadium
         if (lgElementOn(23)) call setShells(23)

         ! chromium
         if (lgElementOn(24)) call setShells(24)

         ! manganese
         if (lgElementOn(25)) call setShells(25)

         ! fluorine
         if (lgElementOn(9)) call setShells(9)

         ! lithium
         if (lgElementOn(3)) call setShells(3)

         ! beryllium
         if (lgElementOn(4)) call setShells(4)

         ! boron
         if (lgElementOn(5)) call setShells(5)

         ! cobalt
         if (lgElementOn(27)) call setShells(27)

         ! nickel
         if (lgElementOn(28)) call setShells(28)

         ! copper
         if (lgElementOn(29)) call setShells(29)

         ! zinc
         if (lgElementOn(30)) call setShells(30)

     end subroutine setPointers

     subroutine makeElements()
       implicit none

       integer           :: elem, ion  ! counters
       integer           :: i, iup, ilow ! counters
       integer           :: ios        ! I/O error status
       integer, dimension(2) :: indexlow, &      ! lower index for reading CEL data
                              & indexup          ! upper index for reading CEL data

       character(len=128) :: filename !file containing atomic data
       logical :: lgFileExists !some data files don't exist yet

       character(len=1) :: comments(78)
       integer :: J,K,L,NCOMS,GX
       real :: QX
       real  :: iRats            ! coll strength (iRats=0) or (coll rates)/10**iRats
       double precision     ::  ax1,ax2,ax3,ax, ex                    ! readers
       integer  :: i1, j1, i2, j2, i3, j3  ! counters/indices
       integer, parameter :: safeLim = 100000 ! loop safety limit

       close(17)
       open(file=PREFIX//'/share/mocassin/data/fileNames.dat', action="read", unit=17, status='old', position='rewind', iostat=ios)

       if (ios/=0) then

          print*, "! makeElements: can't open ",PREFIX,"/share/mocassin/data/fileNames.dat"
          stop

       end if


       ! read in the file names for the atomica data
       ! (even the non existing ones.. never know might add them later)
       do elem = 3, nElements
          do ion = 1, min(elem+1, 10)

             read(17, '(A20)') dataFile(elem, ion)

             filename = trim(PREFIX)//'/share/mocassin/'//dataFile(elem,ion)

             inquire(file=filename, exist=lgFileExists)

             if (lgFileExists) then

               atomic_data_array(elem,ion)%ion=dataFile(elem,ion)

               open(unit=121, status = 'old', file=filename,action='read')

                   read(121,*)NCOMS

                   do I = 1,NCOMS
                           read(121,"(78A1)") comments
                   enddo

!read # levels and temps, then allocate arrays
                   read(121,*) atomic_data_array(elem,ion)%NLEVS,atomic_data_array(elem,ion)%NTEMPS

                   allocate(atomic_data_array(elem,ion)%label(atomic_data_array(elem,ion)%nlevs))
                   allocate(atomic_data_array(elem,ion)%logtemp(atomic_data_array(elem,ion)%ntemps))
                   allocate(atomic_data_array(elem,ion)%roott(atomic_data_array(elem,ion)%ntemps))
                   allocate(atomic_data_array(elem,ion)%G(atomic_data_array(elem,ion)%nlevs))
                   allocate(atomic_data_array(elem,ion)%e(atomic_data_array(elem,ion)%nlevs))
                   allocate(atomic_data_array(elem,ion)%cs(atomic_data_array(elem,ion)%nlevs,atomic_data_array(elem,ion)%nlevs))
                   allocate(atomic_data_array(elem,ion)%qom(atomic_data_array(elem,ion)%ntemps,atomic_data_array(elem,ion)%nlevs,atomic_data_array(elem,ion)%nlevs))
                   allocate(atomic_data_array(elem,ion)%a(atomic_data_array(elem,ion)%nlevs,atomic_data_array(elem,ion)%nlevs))
                   allocate(atomic_data_array(elem,ion)%alphaTotal(atomic_data_array(elem,ion)%nlevs))
                   allocate(atomic_data_array(elem,ion)%qq(atomic_data_array(elem,ion)%ntemps))
                   allocate(atomic_data_array(elem,ion)%qq2(atomic_data_array(elem,ion)%ntemps))
                   allocate(atomic_data_array(elem,ion)%qeff(atomic_data_array(elem,ion)%nlevs,atomic_data_array(elem,ion)%nlevs))

                   atomic_data_array(elem,ion)%cs = 0d0
                   atomic_data_array(elem,ion)%a = 0d0
                   atomic_data_array(elem,ion)%G = 0
                   atomic_data_array(elem,ion)%e= 0d0
                   atomic_data_array(elem,ion)%logtemp=0d0
                   atomic_data_array(elem,ion)%roott=0d0
                   atomic_data_array(elem,ion)%br = 0.d0

                   atomic_data_array(elem,ion)%qom = 0.d0
                   atomic_data_array(elem,ion)%a_r = 0.d0
                   atomic_data_array(elem,ion)%a_d = 0.d0
                   atomic_data_array(elem,ion)%z = 0.d0
                   atomic_data_array(elem,ion)%alphaTotal = 0.d0
                   atomic_data_array(elem,ion)%qq = 0.d0
                   atomic_data_array(elem,ion)%qq2 = 0.d0
                   atomic_data_array(elem,ion)%qeff = 0.d0

                   !read levels and temperatures
                   do I = 1,atomic_data_array(elem,ion)%NLEVS
                     read(121,"(A20)") atomic_data_array(elem,ion)%label(I)
                   enddo

                   do I = 1,atomic_data_array(elem,ion)%NTEMPS
                     read(121,*) atomic_data_array(elem,ion)%logtemp(I)
                     atomic_data_array(elem,ion)%logtemp(I) = log10(atomic_data_array(elem,ion)%logtemp(I))
                   enddo

                   read(121,*) irats

                   k=0
                   if (iRats == 1) then
                      do i = 1, safeLim
                         ! read in data
                         read(121, *) indexlow(2), indexup(2), (atomic_data_array(elem,ion)%qom(k,indexlow(2),indexup(2)), k = 1, atomic_data_array(elem,ion)%NTEMPS)
                         if (indexlow(2)>=atomic_data_array(elem,ion)%NLEVS-1) then
               !             print*,indexlow(2), indexup(2), atomic_data_array(elem,ion)%NLEVS
               !             print*, (qom(k,indexlow(2),indexup(2)), k = 1, nTemp)
                            exit
                         end if
                      end do

                      do k =1 , 2502

                         read(121, *) i, j, ax,  i1, j1, ax1,  i2, j2, ax2,  i3, j3, ax3

                         atomic_data_array(elem,ion)%a(i,j) = ax
                         atomic_data_array(elem,ion)%a(i1,j1) = ax1
                         atomic_data_array(elem,ion)%a(i2,j2) = ax2
                         atomic_data_array(elem,ion)%a(i3,j3) = ax3
                      end do
                      read(121, *) i, j, ax,  i1, j1, ax1,  i2, j2, ax2

                      atomic_data_array(elem,ion)%a(i,j) = ax
                      atomic_data_array(elem,ion)%a(i1,j1) = ax1
                      atomic_data_array(elem,ion)%a(i2,j2) = ax2
                   else if (iRats == 0) then
                      k=0
                      do i = 1, safeLim
                         ! read in data
                         read(121, *) indexlow(2), indexup(2), qx

                         ! check if end of qx dat
                         if (qx == 0.d0) exit

                         ! indexlow(2) always starts with a non zero value
                         ! so the else condition is true at first and k initialized
                         if (indexlow(2) == 0) then
                            indexlow(2) = indexlow(1)
                            k = k + 1
                         else
                            indexlow(1) = indexlow(2)
                            k = 1
                         end if

                         ! the same as above
                         if (indexup(2) == 0) then
                            indexup(2) = indexup(1)
                         else
                            indexup(1) = indexup(2)
                         end if

                         atomic_data_array(elem,ion)%qom(k, indexlow(2), indexup(2)) = qx

                      end do
                      ! read in transition probabilities
                      do k = 1, atomic_data_array(elem,ion)%NLEVS-1
                         do l = k+1, atomic_data_array(elem,ion)%NLEVS
                            read(121, *) i, j, ax
                            atomic_data_array(elem,ion)%a(j,i) = ax
                         end do
                      end do
                   end if

                   ! read statistical weights, energy levels [1/cm]
                   do j = 1, atomic_data_array(elem,ion)%NLEVS
                      read(121, *) i, gx, ex

                      atomic_data_array(elem,ion)%g(i) = gx
                      atomic_data_array(elem,ion)%e(i) = ex
                   end do

                   ! read power law fit coefficients [e-13 cm^3/s]
                   ! and calculate total recombination coefficient
                   ! (direct + cascades)
                   atomic_data_array(elem,ion)%alphaTotal = 0.
                   do j = 2, atomic_data_array(elem,ion)%NLEVS
               !       read(unit=121,fmt=*,iostat=ios) a_fit, b_fit
                      read(unit=121,fmt=*,iostat=ios) atomic_data_array(elem,ion)%br,atomic_data_array(elem,ion)%z,atomic_data_array(elem,ion)%a_r(:),atomic_data_array(elem,ion)%a_d(:) !a_fit, b_fit
                      if (ios<0) then
                         exit
                      else
                         atomic_data_array(elem,ion)%alphaTotal(1) = 1.
                      end if

                   end do
                   close(121)

             endif

          end do
       end do

       close(17)

       ! find out the number of lines and what files are available
       nLines = 0

       ! HI recombination lines
       do iup = 3, 15
          do ilow = 2, min(8,iup-1)
             nLines = nLines + 1
          end do
       end do

       ! HeI singlet recombination lines
       do i = 1, 9
          nLines = nLines + 1
       end do

       ! HeI triplet recombination lines
       do i = 1, 11
          nLines = nLines + 1
       end do

       ! HeII recombination lines
       do iup = 3, 30
          do ilow = 2, min(16, iup-1)
             nLines = nLines+1
          end do
       end do

       ! initialise lgDataAvailable
       lgDataAvailable = .false.

       ! heavies collisional lines
       do elem = 3, nELements
          do ion = 1, min(elem+1, nstages)

             if(.not.lgElementOn(elem)) exit

             close(18)
             open(file=PREFIX//"/share/mocassin/"//dataFile(elem,ion), unit=18, action="read", status='old', position='rewind', iostat=ios)

             if (ios == 0) then

                close(18)

                if (elem == 26 .and. ion ==2) then
                   nLines = nLines + nForLevelsLarge*nForLevelsLarge! nForlLevels
                   lgDataAvailable(elem, ion) = .true.
                else
                   nLines = nLines + nForLevels*nForLevels ! nForlLevels
                   lgDataAvailable(elem, ion) = .true.
                end if
             else

                lgDataAvailable(elem, ion) = .false.

             end if

          end do
       end do

     end subroutine makeElements

end module elements_mod

! Copyright (C) 2003 Barbara Ercolano
!
! MoCaSSiNwarm = MOnte CArlo SImulationS of Nebulae
! this is the warm-start driver of the simulation
! (requires grid1.out,grid2.out,grid3.out files)
!
! Version 2.02
program MoCaSSiNfluorescence
    use common_mod
    use constants_mod
    use dust_mod
    use grid_mod
    use iteration_mod
    use output_mod
    use set_input_mod
    use xSec_mod

    implicit none

    include 'mpif.h'

    type(grid_type) :: grid3D(maxGrids) ! the 3D Cartesian  grid

    integer         :: err              ! allocation error status
    integer         :: iGrid            !

    call mpi_init(ierr)
    call mpi_comm_rank(MPI_COMM_WORLD, taskid, ierr)
    call mpi_comm_size(MPI_COMM_WORLD, numtasks, ierr)

!    starttime = mpi_wtime()

    lgWarm = .true.
    lgFluorescence = .true.

    if (taskid == 0) then
        print*, "MOCASSIN 2006 fluorescence Version 3.00"
        print*, " "
    end if

    if (taskid == 0) then
        print*, " "
    end if

    ! read input for fluorescence calculation file *N*
    call setFluorescenceInput()

    ! reset the 3D cartesian grid
    call resetGrid(grid3D)

    call setStarPosition(grid3D(1)%xAxis,grid3D(1)%yAxis,grid3D(1)%zAxis,grid3D)

    ! initialize opacities x sections array
    call initXSecArray()
    ! set the ionzing continuum according to the contShape variable
    call setContinuum()

    do igrid = 1, ngrids
       allocate (grid3D(igrid)%fluorescenceCube(0:grid3D(igrid)%nCells, 1:nfluo, 0:nVP), stat=err)
       if (err /= 0) then
          print*, '! setFluorescenceInput: allocation error for fluorescenceCube pointer'
          stop
       end if
       grid3D(igrid)%fluorescenceCube=0.
       allocate (grid3D(igrid)%Lfluorescence(0:grid3D(igrid)%nCells, 1:nfluo), stat=err)
       if (err /= 0) then
          print*, '! setFluorescenceInput: allocation error for fluorescenceCube pointer'
          stop
       end if
       grid3D(igrid)%Lfluorescence = 0.

    end do

    ! prepare atomica data stuff
    call makeElements()

    if (taskid == 0) then
        print*, "Total number of grids (mother+sub-grids): ", nGrids
        print*, "Mother grid used:"
        print*, grid3D(1)%xAxis
        print*, grid3D(1)%yAxis
        print*, grid3D(1)%zAxis
    end if

    ! if grains are included, calculate the dust opacity
    if (lgDust) then
       do iGrid = 1, nGrids
          call dustDriver(grid3D(iGrid))
       end do
    end if

    call mpi_barrier(mpi_comm_world, ierr)

    ! start the Monte Carlo simulation
    call MCIterationDriver(grid3D)

    call mpi_barrier(mpi_comm_world, ierr)

    ! free all space allocated to the 3D grid
!    do iGrid=1, nGrids
!       call freeGrid(grid3D(iGrid))
!    end do

    call mpi_finalize(ierr)
    stop 'mpi done'

  end program MoCaSSiNfluorescence

! Copyright (C) 2005 Barbara Ercolano
!
! Version 2.02
module set_input_mod
    use common_mod
    implicit none

    character(len=50)   :: shapeDiffuse     ! diffuse spectrum shape

    contains

    subroutine readInput()
        implicit none

        ! local variables

        integer             :: err              ! allocation error status
        integer             :: i, j             ! counters
        integer             :: ios              ! I/O error status
        integer             :: maxLim = 1000    ! max limit for reading loop

        character(len=50)   :: cValue           ! character value corresponding to keyword
        character(len=50)   :: in_file          ! input file
        character(len=50)   :: keyword          ! input parameter keyword
        character(len=50)   :: multiPhotoSources ! stars file

        logical :: lgOutputExists ! to check for existence of output directory

        ! set default values and set non oprional values to 0 or 0. or "zero"

        lgIsotropic   = .false.
        lgRecombination = .false.
        lgAutoPackets = .false.
        lgMultiDustChemistry = .false.
        lgMultiChemistry = .false.
        lgTalk        = .false.
        lgHdenConstant= .false.
        lgDfile       = .false.
        lgDebug       = .false.
        lgDlaw        = .false.
        lgDust        = .false.
        lgDustConstant= .false.
        lgGas         = .true.
        lgMdMg        = .false.
        lgMdMh        = .false.
        lgNeInput     = .false.
        lgNeutral     = .true.
        lgOutput      = .false.
        lgPlaneIonization = .false.
        lg1D          = .false.
        lgDustScattering = .true.
        lgSymmetricXYZ= .false.
        lgEcho        = .false.
        lgNosource    = .false.
        lgforceTDust  = .false.
        lgOutputExists= .false.

        nPhotonsDiffuse = 0
        nStars        = 0
        nxIn(:)       = 0
        nyIn(:)       = 0
        nzIn(:)       = 0
        nxIn(1)       = 30
        nyIn(1)       = 30
        nzIn(1)       = 30
        maxIterateMC  = 30
        maxPhotons    = 0
        nbins         = 600
        MdMgValue     = 0.
        MdMgFile      = "none"
        nAngleBins    = 0
        nGrids        = 1
        NdustValue     = 0.
        NdustFile      = "none"
        nstages        = 7

        ! qheat
        Tmax           =700.
        nTbins         =300
        lgWritePss     =.false.
        minaQHeat     = 1.e-3
        minConvQHeat  = 99.

        fillingFactor = 1.
        contCube      = -1.
        convIncPercent= 0.
        convWriteGrid = 0.
        nPhotIncrease = 0.

        densityLaw    = 0.

        multiPhotoSources = "none"
        densityFile   = "none"
        dustFile      = "none"
        gridList      = "none"

        nu0           = 0.
        Ldiffuse      = 0.
        Tdiffuse      = 0.
        shapeDiffuse  = "none"
        Hdensity      = 0.
        H0Start       = 3.e-5
        LPhot         = 0.
        minConvergence= 95.
        NeStart       = 0.
        nuMax         = 15.
        nuMin         = 1.001e-5
        nuStepSize    = 0.075
        resLinesTransfer = 101.
        Rnx           = -1.
        Rny           = -1.
        Rnz           = -1.
        R_in          = -1.
        R_out         = 0.
        TeStart       = 10000.
        XHILimit      = 0.05

        ! ask the user to input file name and check for errors
        in_file = 'input/input.in'

        close(10)
        open (unit = 10, file = in_file, status = "old", position="rewind",  iostat = ios, action="read")
        if (ios /= 0) then
            print*, "!out_in: can't open file input/input.in - terminating"
            stop
        end if

        inquire(file='./output/.', exist=lgOutputExists)
        if ( .not. lgOutputExists ) then
            print *,"!output directory output/ doesn't exist - terminating"
            stop
        end if

        print*, taskid, "input file: ", in_file

        do i = 1, maxLim

            ! check if the end of file has been reached
            read(unit=10, fmt=*, iostat=ios) keyword
            if (ios < 0) exit ! end of file reached

            select case (keyword)
            case ("TDust")           ! BEKS2010
               backspace 10
               read(unit=10,fmt=*, iostat=ios) keyword, forceTDust
               lgforceTDust = .true.
               !print*,keyword,lgforceTDust,forceTDust
            case ("echo")
               backspace 10
               read(unit=10, fmt=*, iostat=ios) keyword, echot1, echot2, echoTemp
               !print "(1X,A4,1X,3es12.4)",keyword,echot1,echot2,echoTemp
               print*, '! readInput [Reminder]: Light echo option - is the inclination correctly specified? [see Readme]'
               print*, '! readInput [Warning]: Light echo option - '
               print*, '!   The actual volume of material illuminated by the echo is probably'
               print*, '!   much smaller than that illuminated in this grid.  Be sure to perform'
               print*, '!   volume correction. See echo.out file for volume illuminated in this grid.'
!               echot1 = echot1 * 2.59020684e15 !ct
!               echot2 = echot2 * 2.59020684e15
               lgEcho = .true.
            case("NoSourceSED")
               lgNosource = .true.
               !print*, keyword, lgNosource
            case("isotropicScattering")
               lgIsotropic = .true.
               !print*, keyword, lgIsotropic
            case("2D")
               lg2D = .true.
               !print*, keyword, lg2D
            case("nstages")
               backspace 10
               read(unit=10, fmt=*, iostat=ios) keyword, nstages
               if (nstages>10) then
                  print*, " !out_in: Max 10 ionisation stages allowed. &
                       &If more are required (and you have the relevant atomic data), &
                       & please update the data/ directory (and let B. Ercolano know ;-) &
                       & and edit the data/fileNames.dat file"
                  stop
               end if
               !print*, keyword, nstages
            case ("getEquivalentTau")
               lgEquivalentTau = .true.
               !print*, keyword, lgEquivalentTau
            case ("diffuseSource")
               backspace 10
               read(unit=10, fmt=*, iostat=ios) keyword, Ldiffuse, Tdiffuse, shapeDiffuse, nPhotonsDiffuse, emittingGrid
               !print*, keyword, Ldiffuse, Tdiffuse, shapeDiffuse, nPhotonsDiffuse, emittingGrid
            case ("traceHeating")
               lgTraceHeating = .true.
               !print*, keyword, lgTraceHeating
            case("quantumHeatGrain")
               lgQheat = .true.
               backspace 10
               read(unit=10, fmt=*, iostat=ios) keyword,minaQHeat,minConvQHeat
               !print*, keyword, minaQHeat,minConvQHeat
            case("quantumHeatGrainParameters")
               backspace 10
               read(unit=10, fmt=*, iostat=ios) keyword,Tmax,nTbins,lgWritePss
               !print*, keyword,Tmax,nTbins,lgWritePss
            case ("noPhotoelectric")
               !print*, keyword
               lgPhotoelectric = .false.
            case ("multiPhotoSources")
               backspace 10
               read(unit=10, fmt=*, iostat=ios) keyword,multiPhotoSources
               !print*, keyword,multiPhotoSources
               lgMultiStars=.true.
            case("continuumCube")
               backspace 10
               read(unit=10, fmt=*, iostat=ios) keyword, contCube(1), contCube(2)
               !print*, keyword, contCube
            case("noScattering")
               !print*, keyword
               lgDustScattering = .false.
            case("resLinesTransfer")
               backspace 10
               read(unit=10, fmt=*, iostat=ios) keyword, resLinesTransfer
               !print*, keyword, resLinesTransfer
            case("multiGrids")
               backspace 10
               read(unit=10, fmt=*, iostat=ios) keyword, nGrids, gridList
               !print*, keyword, nGrids, gridList
               if (nGrids > maxGrids) then
                  print*, "! readInput: please increse the maxGrids parameter in constants_mod.f90", &
                       & nGrids, maxGrids
                  stop
               end if
               call readGridList(gridList)
            case("recombinationLines")
               lgRecombination=.true.
               !print*, keyword
            case ("fillingFactor")
               backspace 10
               read(unit=10, fmt=*, iostat=ios) keyword, fillingFactor
               !print*, keyword, fillingFactor
            case ("slit")
               backspace 10
               read(unit=10, fmt=*, iostat=ios) keyword, dxSlit, dySlit
               !print*, keyword, dxSlit, dySlit
            case ("inputNe")
               backspace 10
               read(unit=10, fmt=*, iostat=ios) keyword
               lgNeInput = .true.
               !print*, keyword
            case ("edges")
               backspace 10
               read(unit=10, fmt=*, iostat=ios) keyword, Rnx, Rny, Rnz
               !print*, keyword,  Rnx, Rny, Rnz
            case ("output")
               backspace 10
               read(unit=10, fmt=*, iostat=ios) keyword
               lgOutput = .true.
               !print*, keyword
            case ("multiChemistry")
               backspace 10
               read(unit=10, fmt=*, iostat=ios) keyword, nAbComponents
               lgMultiChemistry = .true.
               backspace(10)
               allocate(abundanceFile(1:nAbComponents))
               read(unit=10, fmt=*, iostat=ios) keyword, nAbComponents, &
                    & (abundanceFile(j), j=1,nAbComponents)
               !print*, keyword, nAbComponents, (abundanceFile(j), j=1,nAbComponents)
            case ("multiDustChemistry")
               backspace 10
               read(unit=10, fmt=*, iostat=ios) keyword, nDustComponents
               lgMultiDustChemistry = .true.
               lgDust = .true.
               backspace(10)
               allocate(dustSpeciesFile(1:nDustComponents))
               allocate(nSpeciesPart(1:nDustComponents))
               read(unit=10, fmt=*, iostat=ios) keyword, nDustComponents, (dustSpeciesFile(j), j=1,nDustComponents), dustFile(2)
               !print*, keyword, nDustComponents, (dustSpeciesFile(j), j=1,nDustComponents)
               print*, dustFile(2)
            case ("planeIonization")
               backspace 10
               read(unit=10, fmt=*, iostat=ios) keyword, meanField, nu0
               lgPlaneIonization = .true.
               !print*, keyword, meanField, nu0
               allocate(Lstar(1))
               Lstar=0.
            case ("autoPackets")
               backspace 10
               read(unit=10, fmt=*, iostat=ios) keyword, convIncPercent, nPhotIncrease, maxPhotons
               lgAutoPackets = .true.
               !print*, keyword, convIncPercent, nPhotIncrease, maxPhotons
               if (maxPhotons .eq. 0) then
                 print*,'! readInput: autoPackets input invalid - maximum number of photons is zero'
                 stop
               endif
            case ("oneD")
               backspace 10
                read(unit=10, fmt=*, iostat=ios) keyword
                lg1D = .true.
                !print*, keyword
                print*, 'ERROR: oneD option is not currently avalable!!!!'
                stop
             case ("densityFile")
                 backspace 10
                 read(unit=10, fmt=*, iostat=ios) keyword, densityFile
                 lgDfile = .true.
                 !print*, keyword, densityFile
                   open(unit=11,file=densityFile,status='old')
                   read(unit=11, fmt=*, iostat=ios) keyword
                   if (keyword=="#") then
                      backspace 11
                      read(unit=11,fmt=*, iostat=ios) keyword,nxin(1),nyin(1),nzin(1)
                      print*,'grid axes read in from file:',trim(densityFile),nxin(1),nyin(1),nzin(1)
                   endif
                   close(11)
             case ("dustFile")
                 backspace 10
                 read(unit=10, fmt=*, iostat=ios) keyword, dustFile(1), dustFile(2)
                 !print*, keyword, trim(dustFile(1))," | ",trim(dustFile(2))," |"
                 allocate(dustSpeciesFile(1:1))
                 allocate(nspeciesPart(1:1))
                 nDustComponents = 1
                 dustSpeciesFile(1) = dustFile(1)
             case ("debug")
                 backspace 10
                 read(unit=10, fmt=*, iostat=ios) keyword
                 lgDebug = .true.
                 !print*, keyword
            case ("nbins")
                backspace 10
                read(unit=10, fmt=*, iostat=ios) keyword, nbins
                !print*, keyword, nbins
            case ("talk")
                backspace 10
                read(unit=10, fmt=*, iostat=ios) keyword
                lgTalk = .true.
                !print*, keyword
            case ("symmetricXYZ")
                backspace 10
                read(unit=10, fmt=*, iostat=ios) keyword
                lgSymmetricXYZ = .true.
                !print*, keyword
            case ("contShape")
                backspace 10
                nstars=1
                allocate(contShape(0:1))
                allocate(contShapeIn(0:1))
                allocate(spID(0:1))
                allocate(tstep(0:1))
                contShape = 'none'
                read(unit=10, fmt=*, iostat=ios) keyword, contShape(1)
                if (contShape(1) == 'powerlaw') then
                   backspace 10
                   read(unit=10, fmt=*, iostat=ios) keyword, contShape(1), pwlIndex
                   !print*, keyword, contShape(1), pwlIndex
                else
                   !print*, keyword, contShape(1)
                end if
                if (contShape(1) == 'blackbody' .or. contShape(1) == 'powerlaw') then
                   spID(1) = contShape(1)
                else
                   spID(1) = 'rauch'
                end if
                tstep = 0.
            case ("nebComposition")
                backspace 10
                read(unit=10, fmt=*, iostat=ios) keyword, cValue
                if (cValue=="noGas") lgGas=.false.
                !print*, keyword, cValue
                allocate(abundanceFile(1:nAbComponents))
                abundanceFile = cValue
            case ("Hdensity")
                backspace 10
                read(unit=10, fmt=*, iostat=ios) keyword, Hdensity
                lgHdenConstant = .true.
                !print*, keyword, Hdensity
            case ("densityLaw")
                backspace 10
                read(unit=10, fmt=*, iostat=ios) keyword, (densityLaw(j),j=1,3)
                lgDlaw = .true.
                !print*, keyword, densityLaw
            case ("maxIterateMC")
                backspace 10
                read(unit=10, fmt=*, iostat=ios) keyword, maxIterateMC, minConvergence
                !print*, keyword, maxIterateMC, minConvergence
            case ("nPhotons")
                backspace 10
                read(unit=10, fmt=*, iostat=ios) keyword, nPhotonsTot
                !print*, keyword, nPhotonsTot
            case ("nx")
                backspace 10
                read(unit=10, fmt=*, iostat=ios) keyword, nxin(1)
            case ("ny")
                backspace 10
                read(unit=10, fmt=*, iostat=ios) keyword, nyin(1)
            case ("nz")
                backspace 10
                read(unit=10, fmt=*, iostat=ios) keyword, nzin(1)
             case ("starPosition")
                backspace 10
                allocate(starPosition(1))
                read(unit=10, fmt=*, iostat=ios) keyword, starPosition(1)%x, starPosition(1)%y, starPosition(1)%z
                print*,  keyword, starPosition(1)%x, starPosition(1)%y, starPosition(1)%z
             case ("TeStart")
                backspace 10
                read(unit=10, fmt=*, iostat=ios) keyword, TeStart
                !print*, keyword, TeStart
            case ("NeStart")
                backspace 10
                read(unit=10, fmt=*, iostat=ios) keyword, NeStart
                !print*, keyword, NeStart
            case ("TStellar")
                backspace 10
                allocate(TStellar(0:1))
                read(unit=10, fmt=*, iostat=ios) keyword, TStellar(1)
                !print*, keyword, TStellar(1)
            case ("convLimit")
                backspace 10
                read(unit=10, fmt=*, iostat=ios) keyword,  XHILimit
                !print*, keyword, XHILimit
            case ("H0Start")
                backspace 10
                read(unit=10, fmt=*, iostat=ios) keyword, H0Start
                !print*, keyword, H0Start
            case ("LStar")
                backspace 10
                allocate(Lstar(0:1))
                Lstar = 0.
                read(unit=10, fmt=*, iostat=ios) keyword, LStar(1)
                !print*, keyword, LStar(1)
            case ("LPhot")
                backspace 10
                if (.not. allocated(LStar)) allocate(Lstar(0:1))
                Lstar = 0.
                read(unit=10, fmt=*, iostat=ios) keyword, LPhot
                !print*, keyword, LPhot
            case ("nuMax")
                backspace 10
                read(unit=10, fmt=*, iostat=ios) keyword, nuMax
                !print*, keyword, nuMax
            case ("nuMin")
                backspace 10
                read(unit=10, fmt=*, iostat=ios) keyword, nuMin
                !print*, keyword, nuMin
            case ("Rin")
                backspace 10
                read(unit=10, fmt=*, iostat=ios) keyword, R_in
                !print*, keyword, R_in
            case ("Rout")
                backspace 10
                read(unit=10, fmt=*, iostat=ios) keyword, R_out
                !print*, keyword, R_out
            case ("MdMg")
                backspace 10
                read(unit=10, fmt=*, iostat=ios) keyword, keyword
                if (keyword=="constant") then
                   backspace 10
                   read(unit=10, fmt=*, iostat=ios) keyword, keyword, MdMgValue
                   print*, 'MdMg constant ', MdMgValue
                   lgDustConstant = .true.
                   lgDust = .true.
                else if (keyword=="file") then
                   backspace 10
                   read(unit=10, fmt=*, iostat=ios) keyword, keyword, MdMgFile
                   print*, 'MdMg file ', MdMgFile
                   lgDust = .true.
                   open(unit=11,file=MdMgFile,status='old')
                   read(unit=11, fmt=*, iostat=ios) keyword
                   if (keyword=="#") then
                      backspace 11
                      read(unit=11,fmt=*, iostat=ios) keyword,nxin(1),nyin(1),nzin(1)
                      print*,'grid axes read in from file:',trim(MdMgFile),nxin(1),nyin(1),nzin(1)
                   endif
                   close(11)
                else
                   print*, "! readInput: invalid keyword in MdMg field ", keyword
                   stop
                end if
                lgMdMg = .true.
            case ("MdMh")
                backspace 10
                read(unit=10, fmt=*, iostat=ios) keyword, keyword
               if (keyword=="constant") then
                   backspace 10
                   read(unit=10, fmt=*, iostat=ios) keyword, keyword, MdMgValue
                   print*, 'MdMh constant ', MdMgValue
                   lgDustConstant = .true.
                   lgDust = .true.
                else if (keyword=="file") then
                   backspace 10
                   read(unit=10, fmt=*, iostat=ios) keyword, keyword, MdMgFile
                   print*, 'MdMh file ', MdMgFile
                   lgDust = .true.
                   open(unit=11,file=MdMgFile,status='old')
                   read(unit=11, fmt=*, iostat=ios) keyword
                   if (keyword=="#") then
                      backspace 11
                      read(unit=11,fmt=*, iostat=ios) keyword,nxin(1),nyin(1),nzin(1)
                      print*,'grid axes read in from file:',trim(MdMgFile),nxin(1),nyin(1),nzin(1)
                   endif
                   close(11)
                else
                   print*, "! readInput: invalid keyword in MdMh field ", keyword
                   stop
                end if
                lgMdMh = .true.
            case ("Ndust")
                backspace 10
                read(unit=10, fmt=*, iostat=ios) keyword, keyword
                if (keyword=="constant") then
                   backspace 10
                   read(unit=10, fmt=*, iostat=ios) keyword, keyword, NdustValue
                   print*, 'Ndust constant ', NdustValue
                   lgDustConstant = .true.
                   lgDust = .true.
                else if (keyword=="file") then
                   backspace 10
                   read(unit=10, fmt=*, iostat=ios) keyword, keyword, NdustFile
                   print*, 'Ndust file ', NdustFile
                   open(unit=11,file=NdustFile,status='old')
                   read(unit=11, fmt=*, iostat=ios) keyword
                   if (keyword=="#") then
                      backspace 11
                      read(unit=11,fmt=*, iostat=ios) keyword,nxin(1),nyin(1),nzin(1)
                      print*,'grid axes read in from file:',trim(NdustFile),nxin(1),nyin(1),nzin(1)
                   endif
                   close(11)

                   lgDust = .true.
                else
                   print*, "! readInput: invalid keyword in Ndust field ", keyword
                   stop
                end if
            case ("writeGrid")
                backspace 10
                read(unit=10, fmt=*, iostat=ios) keyword, convWriteGrid
                !print*, keyword, convWriteGrid
            case ("inclination")
               backspace 10
               read(unit=10, fmt=*, iostat=ios) keyword, nAngleBins
               if (nAngleBins>2) then
                  print*, '! readInput: only two inclination anges are allowed per simulation. &
                       & If more inclinations are required please run mocassinWarm for the other&
                       & viewing angles.'
                  stop
               end if
               allocate(viewPointTheta(0:nAngleBins), stat=err)
               if (err /= 0) then
                  print*, '! readInput: allocation error for viewPointTheta pointer'
                  stop
               end if
               viewPointTheta=0.
               allocate(viewPointPhi(0:nAngleBins), stat=err)
               if (err /= 0) then
                  print*, '! readInput: allocation error for viewPointPhi pointer'
                  stop
               end if
               viewPointPhi=0.
               backspace 10
               read(unit=10, fmt=*, iostat=ios) keyword, nAngleBins, (viewPointTheta(j), viewPointPhi(j), j=1,nAngleBins)
               !print*, keyword, nAngleBins, (viewPointTheta(j), viewPointPhi(j), j = 1, nAngleBins)
            case ("dustMass")
               backspace 10
               read(unit=10, fmt=*, iostat=ios) keyword, inputDustMass
               lginputDustMass = .true.
            case ("gasMass")
               backspace 10
               read(unit=10, fmt=*, iostat=ios) keyword, inputGasMass
               lginputGasMass = .true.
               print*,"Using gasMass keyword. Be sure to specify gas density file or Hdensity 1.0"
            case default
                print*, "! readInput: unrecognised keyword in model parameter input file", &
&                        in_file, keyword
            end select

         end do

        close(10)

        if (nPhotonsTot .eq. 0 .and. nPhotonsDiffuse .eq. 0) then
          print*,'! readInput: no photons in model.'
          stop
        endif

        allocate(lgDataAvailable(3:nElements, 1:nstages), stat=err)
        if (err /= 0) then
           print*, '! readInput: allocation error for lgDataAvailable pointer'
           stop
        end if

        if (lginputDustMass) then
          inputDustMass = inputDustMass / 5.028e11
          if (lgSymmetricXYZ) then
            inputDustMass = inputDustMass / 8
          end if
        end if

        if (lginputGasMass) then
          inputGasMass = inputGasMass / 5.028e11
          if (lgSymmetricXYZ) then
            inputGasMass = inputGasMass / 8
          end if
        end if

        if (lginputDustMass .and. .not.lgDust) then
           print*,"! readInput: you have asked to scale dustMass but there is no dust"
           stop
        endif
        if (lginputGasMass .and. .not.lgGas) then
           print*,"! readInput: you have asked to scale gasMass but there is no gas"
           stop
        endif

        if (lginputDustMass .and. lginputGasMass) then
           if (lgDust .and. lgGas) then
              if (lgMdMg .or. lgMdMh) then
                 print*,'! readInput: dust mass is defined by your gas-to-dust ratio'
                 print*,'! readInput: please remove dustMass keyword from input.in'
                 stop
              else
                 print*,'! readInput: Simulation will scale gas to gasMass and dust to dustMass.'
                 print*,'! readInput: This will change your gas-to-dust ratio so BE SURE THIS IS WHAT YOU WANT...'
              endif
           endif
        endif

        if (lgMultiStars) then
           call setMultiPhotoSources(multiPhotoSources)
        else if (lgMultiStars .and. nStars==1) then
           print*, '! readInput: multiPhotoSources keyword and Lstar, Tstellar, ContShape are cannot be specified together'
           stop
        else
           allocate(nPhotons(1))
           allocate(deltaE(0:1))
           deltaE = 0.
           nPhotons(1)=nPhotonsTot

           if (Ldiffuse>0. .and. nPhotonsDiffuse>0) then
              if (nStars<1) then
                 if(.not.allocated(contShape)) allocate(contShape(0:0))
                 if(.not.allocated(spID)) allocate(spID(0:0))
                 if(.not.allocated(LStar)) allocate(LStar(0:0))
              end if
              deltaE(0) = Ldiffuse/nPhotonsDiffuse
              contShape(0) = shapeDiffuse
              if (contShape(0) == 'blackbody' .or. contShape(0) == 'powerlaw') then
                 spID(0) = contShape(0)
              else
                 spID(0) = 'rauch'
              end if
           end if

           if (.not.allocated(starPosition)) then
              allocate (starPosition(1))
              starPosition(1)%x=0.
              starPosition(1)%y=0.
              starPosition(1)%z=0.
              print* , '! readInput: [talk] ionising source positioned at 0.,0.,0.'
           end if
        end if

        if (.not.allocated(contShape)) then
           print*, "! readInput: no information about the continuum shape - contShape -"
           stop
        end if
        if (.not.allocated(TStellar)) then
           print*, "! readInput: no information about the stellar effective temperature - Tstellar -"
           stop
        end if
        if (.not.allocated(nPhotons)) then
           print*, "! readInput: no information about the number of energy packets to be used - nPhotons -"
           stop
        end if
        if (.not.allocated(Lstar) .and. Lphot<=0.) then
           print*, "! readInput: no information about the stellar luminosity - Lstar or Lphot -"
           stop
        end if

        contShapeIn = contShape

        print*, "mother nx, ny, nz" , nxin(1), nyin(1), nzin(1)

        ! check for missing or invalid values in the model parameters input file
        if (lg1D) then
           nyIn = 1
           nzIn = 1
           lgSymmetricXYZ = .true.
        else if (lgPlaneIonization .and. lg2d) then
           print*, "! readInput: planeIonization and 2D options are not compatible"
           stop
        else if (resLinesTransfer >= minConvergence .and. resLinesTransfer /= 101. .and. lgDust) then
           print*, "! readInput: the min convergence level assigned to the calculation of &
                &the resonant lines transfer is higher or equal to that assigned by maxIterateMC"
           stop
        else if (resLinesTransfer >= 100.5 .and. lgDust .and. lgGas) then
           print*, "! readInput: [warning] both dust and gas processes have been activated, but the &
                &resonanceLinesTransfer keyword is absent. The dust temperatures may be underestimated!!!!"
        else if (resLinesTransfer <= 100 .and. (.not.lgDust .or. .not.lgGas)) then
           print*, "! readInput: [warning] both dust and gas processes must be activated, to use the&
                &resonanceLinesTransfer keyword. Reset to 101."
           resLinesTransfer = 101.
        else if (.not.allocated(abundanceFile) .and. lgGas) then
           print*, "! readInput: no elemental abundance file has been specified"
           stop
        else if ((lgMdMh .and. lgMdMg) .and. (NdustFile /= "none" .or. NdustValue /=0) )then
           print*, "! readInput: MdMg and Ndust cannot be specified together"
           stop
        else if ( (.not.lgDust) .and. (.not.lgGas) )then
           print*, "! readInput: the grid is completely empty. no gas or dust present.",  &
                lgGas,lgDust
           stop
        else if ( lgDebug .and. .not.(lgGas) ) then
           print*, "! readInput: debugging mode can only be used when a gas component is present. &
                & debugging mode will be turned off."
           lgDebug = .false.
        else if (fillingFactor > 1.) then
           print*, "! readInput: filling factor, epsilon, specified is greater than unity.", &
                & fillingFactor
           stop
        else if ((.not.lgDfile) .and. (Rnx<0. .or. Rny<0. .or. Rnz<0.) .and. (NdustFile == "none")) then
           print*,  "! readInput: Grid edges unspecified or non-valid grid &
                &edges", Rnx,Rny,Rnz
           stop
        else if (lgDfile .and. (Rnx>=0. .or. Rny>=0. .or. Rnz>=0.) ) then
           print*,  "! readInput: [warning] when the density distribution is&
                & specified via an external density file, no grid edges need &
                & to be specified. The specified values will be ignored."
        else if (lgPlaneIonization .and. .not.lgDfile) then
           print*, "! readInput: plane ionizing field specified - must use user defined &
                &density distribution via the densityFile option"
           stop
        else if (lgPlaneIonization .and. lgSymmetricXYZ) then
           print*, "! readInput [warning]: plane ionizing field specified - cannot use&
                & symmetricXYZ - removed."
           lgSymmetricXYZ = .false.
        else if (TStellar(1) == 0. .and. Tdiffuse==0. .and. contShape(1) /= 'powerlaw') then
            print*, "! readInput: TStellar missing from model parameter input file"
            stop
        else if (R_in < 0.) then
            print*, "! readInput: Invalid Rin parameter in the input file", R_in
            stop
       else if (LPhot == 0. .and. .not.allocated(LStar) .and. .not.lgPlaneIonization &
            & .and. Ldiffuse<=0.) then
            print*, "! readInput: LPhot and LStar missing from model parameter input file"
            stop
        else if (LPhot /= 0. .and. allocated(LStar)) then
            print*, "! readInput: [warning] LPhot and LStar both entered. "
        else if (maxIterateMC < 1) then
            print*, "! readInput: invalid maxIterateMC in model parameter input &
                 & file", in_file, maxIterateMC
            stop
         else if (minConvergence < 0. .or. minConvergence > 100.) then
            print*, "! readInput: invalid minConvergence input (must be between 0. and 100.) ", &
                 &  in_file, minConvergence
            stop
        else if (nPhotons(1) < 0) then
            print*, "! readInput: invalid nPhotons in model parameter input &
                 & file", in_file, nPhotons
            stop
        else if (lgDust) then
            if ((dustFile(1) == "none" .or. dustFile(2)=="none") .and. &
                 &.not.lgMultiDustChemistry) then
               print*, "! readInput: dust files were not specified; please include dustFile field &
                    & in the input files and specify name and location of dust files"
               stop
            end if
        else if (nxin(1) < 1 .or. nyin(1) < 1 .or. nzin(1) < 1) then
            print*, "! readInput: invalid grid boundaries in model parameter input &
                 & file", in_file, nxin(1), nyin(1), nzin(1)
            stop
        else if (TStellar(1) < 0.) then
            print*, "! readInput: invalid TStellar  in model parameter input &
                 & file", in_file, TStellar
            stop
        else if (XHILimit < 0.) then
            print*, "! readInput: invalid XHILimit in model parameter input &
                 & file", in_file, XHILimit
            stop
        else if (LPhot < 0.) then
            print*, "! readInput: invalid LPhot  in model parameter input &
                 & file", in_file, LPhot
            stop
        else if (LStar(1) < 0.) then
            print*, "! readInput: invalid LStar  in model parameter input &
                 & file", in_file, LStar
            stop
        else if (nuMax < 0.) then
            print*, "! readInput: invalid nuMax  in model parameter input &
                 & file", in_file, nuMax
            stop
        else if (nuMin < 0.) then
            print*, "! readInput: invalid nuMin  in model parameter input &
                 & file", in_file, nuMin
            stop
        else if (nuMin > 1.4e-6) then
            print*, "! readInput [waring]:  nuMin  in model parameter input &
                 & file is too large to include 5GHz flux calculations", in_file,nuMin
        else if (R_out < 0.) then
            print*, "! readInput: invalid R_out  in model parameter input &
                 & file", in_file, R_out
            stop
        else if (R_in <0.) then
            print*, "! readInput: invalid R_in  in model parameter input &
                 & file", in_file, R_in
            stop
        else if ((R_in >= R_out) .and. (R_out > 0.) ) then
            print*, "! readInput: the inner radius must be smaller than &
                 &the outer radius ", in_file, R_in, R_out
            stop
        else if (lgMultiChemistry .and. .not.lgDfile) then
           print*, "! readInput: the MultiChemistry option has been specified &
                &therefore an user density file of the type x,y,z,den,abIndex must also &
                &be specified."
           stop
        end if

        TStellar(0) = Tdiffuse

        contains

          subroutine readGridList(filename)
            implicit none

            real                          :: skipR

            character(len=50), intent(in) :: filename
            character(len=50)             ::  skipC

            integer                       :: i
            integer                       :: ios
            integer                       :: skip

            close(17)
            open (unit = 17, file = filename, status = "old", position="rewind", iostat = ios, action="read")
            if (ios/=0) then
               print*, "! readGridList: can't open file for reading ", filename
               stop
            end if

            do i = 2, nGrids
              read(17, *) skip, nxIn(i), nyIn(i), nzIn(i), skipC, skipR
              read(17, *) skipR, skipR, skipR, skipR, skipR, skipR

            end do
            close(17)

         end subroutine readGridList

       end subroutine readInput

       subroutine setMultiPhotoSources(infile)
        implicit none

        character(len=50), intent(in) :: infile

        integer                       :: ios, i


        close(13)
        open(file=infile, unit=13, iostat=ios, action="read")
        if (ios /= 0) then
           print*, "! setMultiPhotoSources: can't open ionising sources file", infile
           stop
        end if

        read(13,*) nStars
        print*, "Multiple Ionising sources", nStars
        print*, "(i, Tstellar, Lstar, ContShape, Nphotons, position)"

        allocate(deltaE(0:nStars))
        allocate(spID(0:nStars))
        allocate(tStep(nStars))
        allocate(TStellar(0:nStars))
        allocate(Lstar(nStars))
        allocate(ContShape(0:nStars))
        allocate(ContShapeIn(0:nStars))
        allocate(nPhotons(nStars))
        allocate(starPosition(nStars))

        TStellar=0.
        Lstar=0.
        ContShape='none'
        ContShapeIn='none'
        spID='none'
        tStep=0.
        nPhotons=0

        do i = 1, nStars
           read(13,*) TStellar(i), Lstar(i), ContShape(i), starPosition(i)%x, starPosition(i)%y, starPosition(i)%z, &
                & spID(i), tStep(i)
           contShapeIn(i) = contShape(i)
        end do


        print*, 'i, Tstellar(i), Lstar(i), contShape(i), Nphotons(i), starPosition(i), deltaE(i)'
        do i = 1, nStars
           nPhotons(i) = NphotonsTot/nStars
           deltaE(i) = Lstar(i)/nPhotons(i)
           print*, i, Tstellar(i), Lstar(i), contShape(i), Nphotons(i), starPosition(i), deltaE(i)
        end do

        if (Ldiffuse>0. .and. nPhotonsDiffuse>0) then
           deltaE(0) = Ldiffuse/nPhotonsDiffuse
           contShape(0) = shapeDiffuse
           if (contShape(0) == 'blackbody' .or. contShape(0) == 'powerlaw') then
              spID(0) = contShape(0)
           else
              spID(0) = 'rauch'
           end if
        end if

      end subroutine setMultiPhotoSources

end module set_input_mod

! Copyright (C) 2005 Barbara Ercolano
!
! Version 2.02
module vector_mod


  use constants_mod

  implicit none

  public

  ! The definition of the vector type

  type vector
     real :: x
     real :: y
     real :: z
  end type vector

  ! Define multiply

  interface operator(*)
     module procedure mult
  end interface

  ! and divide

  interface operator(/)
     module procedure divideVec
  end interface

  ! add

  interface operator(+)
     module procedure add
  end interface

  ! subtract

  interface operator(-)
     module procedure subtract
  end interface

  ! equivalence

  interface operator(==)
      module procedure equivalence
  end interface

  ! notEquivalence(/=)

  interface operator(/=)
      module procedure notEquivalence
  end interface

  ! note that the following two operators are costumised
  ! for use in the mocassinPlot routines, these are only
  ! meaningful in the context of this program

  ! >=

  interface operator(>=)
     module procedure greaterEqual
  end interface

  ! <=

  interface operator(<=)
     module procedure lessEqual
  end interface

  ! dot product

  interface operator(.dot.)
     module procedure dotProd
  end interface

  ! cross product

  interface operator(.cross.)
     module procedure crossProd
  end interface

contains

  ! the dot product function

  real function dotProd(a , b)
    type(vector), intent(in) :: a
    type(vector), intent(in) :: b

    dotProd = a%x*b%x + a%y*b%y + a%z*b%z

  end function dotProd

  ! the cross product function

  type(vector) function crossProd(a ,b)
    type(vector), intent(in) :: a
    type(vector), intent(in) :: b

    crossProd%x =  (a%y*b%z - a%z*b%y)
    crossProd%y = -(a%x*b%z - a%z*b%x)
    crossProd%z =  (a%x*b%y - a%y*b%x)
  end function crossProd

  ! normalization subroutine - checks for zero vector

  subroutine normalize(a)
    type(vector) :: a
    real :: m

    m = modulus(a)

    if (m == 0.) then
       write(*,'(a)') "! Attempt to normalize the zero vector"
       STOP
    endif

    a%x = a%x / m
    a%y = a%y / m
    a%z = a%z / m

  end subroutine normalize

  ! find the modulus of a vector

  real function modulus(a)
    type(vector) :: a

    modulus = a%x*a%x + a%y*a%y + a%z*a%z
    modulus = sqrt(modulus)

  end function modulus

  ! multiply function

  type(vector) function mult(a,b)
    real, intent(in) :: a
    type(vector), intent(in) :: b

    mult%x = a * b%x
    mult%y = a * b%y
    mult%z = a * b%z

  end function mult


  ! divide vector by a scalar

  type(vector) function divideVec(a,b)
    type(vector), intent(in) :: a
    real, intent(in) :: b

    divideVec%x = a%x / b
    divideVec%y = a%y / b
    divideVec%z = a%z / b

  end function divideVec

  ! add two vectors

  type(vector) function add(a,b)
    type(vector), intent(in) :: a
    type(vector), intent(in) :: b

    add%x = a%x + b%x
    add%y = a%y + b%y
    add%z = a%z + b%z

  end function add

  ! subtract two vectors

  type(vector) function subtract(a,b)
    type(vector), intent(in) :: a
    type(vector), intent(in) :: b

    subtract%x = a%x - b%x
    subtract%y = a%y - b%y
    subtract%z = a%z - b%z

  end function subtract

  logical function equivalence(a,b)
    type(vector), intent(in) :: a
    type(vector), intent(in) :: b

    if( (a%x == b%x) .and.&
         & (a%y == b%y) .and.&
         & (a%z == b%z) ) then
      equivalence = .true.
    else
      equivalence = .false.
    end if
  end function equivalence

  logical function greaterEqual(a,b)
    type(vector), intent(in) :: a
    type(vector), intent(in) :: b

    if( (a%z <= b%z) .and.&
         & ( a%x/(sqrt(1.-a%z*a%z)) >= &
         & b%x/(sqrt(1.-b%z*b%z))) ) then
      greaterEqual = .true.
    else
      greaterEqual = .false.
    end if
  end function greaterEqual

  logical function lessEqual(a,b)
    type(vector), intent(in) :: a
    type(vector), intent(in) :: b

    if( (a%z >= b%z) .and.&
         & ( a%x/(sqrt(1.-a%z*a%z)) <= &
         & b%x/(sqrt(1.-b%z*b%z))) ) then
      lessEqual = .true.
    else
      lessEqual = .false.
    end if
  end function lessEqual


  logical function notEquivalence(a,b)
    type(vector), intent(in) :: a
    type(vector), intent(in) :: b

    if( (a%x == b%x) .and.&
         & (a%y == b%y) .and.&
         & (a%z == b%z) ) then
      notEquivalence = .false.
    else
      notEquivalence = .true.
    end if
  end function notEquivalence


  ! get polar form of a cartesian vector

  subroutine getPolar(vec, r, theta, phi)

    implicit none
    type(vector) :: vec
    real :: r, theta, phi, cosTheta

    r = modulus(vec)
    if ((vec%y == 0.) .and. (vec%x == 0)) then
       phi = 0.
    else
       phi = atan2(vec%y, vec%x)
    endif
    if (phi < 0.) phi = phi + twoPi
    cosTheta = vec%z/r
    theta = acos(cosTheta)
  end subroutine getPolar

  ! rotate a vector "a" about the z-axis by angle b

  type(vector) function rotateZ(a,b)
    type(vector), intent(in) :: a
    real, intent(in) :: b   ! angle in radians
    real :: cosb, sinb

    cosb = cos(b)
    sinb = sin(b)

    rotateZ%x = cosb * a%x + sinb * a%y
    rotateZ%y =-sinb * a%x + cosb * a%y
    rotateZ%z = a%z

  end function rotateZ

  type(vector) function rotateX(a,b)
    type(vector), intent(in) :: a
    real, intent(in) :: b   ! angle in radians
    real :: cosb, sinb

    cosb = cos(b)
    sinb = sin(b)

    rotateX%x = a%x
    rotateX%y = cosb * a%y + sinb * a%z
    rotateX%z =-sinb * a%y + cosb * a%z

  end function rotateX

  type(vector) function rotateY(a,b)
    type(vector), intent(in) :: a
    real, intent(in) :: b   ! angle in radians
    real :: cosb, sinb

    cosb = cos(b)
    sinb = sin(b)

    rotateY%x = cosb * a%x + sinb * a%z
    rotateY%y = a%y
    rotateY%z =-sinb * a%x + cosb * a%z

  end function rotateY

    type(vector) function randomUnitVector()
    real :: r1, r2, u, v, w, t, ang
    call random_number(r1)
    w = 2.*r1 - 1.
    t = sqrt(1.-w*w)
    call random_number(r2)
    ang = 3.141592654*(2.*r2-1.)
    u = t*cos(ang)
    v = t*sin(ang)

    randomUnitVector = vector(u,v,w)
  end function randomUnitVector


end module vector_mod

! Copyright (C) 2005 Barbara Ercolano
! Department of Physics and Astronomy
! University College London
! Gower Street
! London, WC1E 6BT
! UK
! +44-207-679-7146
! be@star.ucl.ac.uk
!
! This program is free software; you can redistribute it and/or
! modify it under the terms of the GNU General Public License
! as published by the Free Software Foundation; either version 2
! of the License, or (at your option) any later version. This requires
! that any changes or improvements made to the program should also be
! made freely available.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program; if not, write to the Free Software
! Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

!
! MoCaSSiN = MOnte CArlo SImulationS of Nebulae
! Version 2.02
! this is the main driver of the simulation
!
program MoCaSSiN
    use common_mod
    use constants_mod
    use dust_mod
    use grid_mod
    use iteration_mod
    use output_mod
    use set_input_mod
    use xSec_mod
    use readdata_mod

    implicit none

    include 'mpif.h'

    type(grid_type) :: grid3D(maxGrids)       ! the 3D Cartesian  grid

    real            :: test                   ! test
    integer         :: i, iGrid               ! allocation error status
    real, dimension(2) :: timing              ! cputimer
    integer         :: nhours, nminutes, nseconds

    call cpu_time(timing(1))
    call mpi_init(ierr)
    call mpi_comm_rank(MPI_COMM_WORLD, taskid, ierr)
    call mpi_comm_size(MPI_COMM_WORLD, numtasks, ierr)

    if (taskid == 0) then
        print*, "MOCASSIN 2005 Version 2.0"
        print*, " "
    endif

    ! read the input parameters of the simulation
    call readInput()

    print*, " "

    ! initialize the 3D cartesian grid

    do iGrid = 1, nGrids
       call initCartesianGrid(grid3D(iGrid), nxIn(iGrid), nyIn(iGrid), nzIn(iGrid))
    end do

    ! initialize opacities x sections array
    call initXSecArray()
    ! set the ionzing continuum according to the contShape variable
    call setContinuum()

    call fillGrid(grid3D(1:nGrids))

    call setStarPosition(grid3D(1)%xAxis,grid3D(1)%yAxis,grid3D(1)%zAxis, grid3D(1:nGrids))

    do iGrid = 1, nGrids
        print*, 'Grid : ', iGrid
        print*, 'active cells: ', grid3D(iGrid)%nCells
    end do

    ! prepare atomica data stuff
    if (lgGas) then
      call makeElements()
      call readData()
    endif

    print*, 'active elements: ', nElementsUsed

    ! if grains are included, calculate the dust opacity
    if (lgDust) then
       if (taskid==0) print*, '! mocassin: calling dustDriver'
       do iGrid = 1, nGrids
          call dustDriver(grid3D(iGrid))
       end do
       print*, '! mocassin: dustDriver done'
    end if

    call mpi_barrier(mpi_comm_world, ierr)

    ! set local diffuse ionisation field
    if (Ldiffuse>0.) then
       if (taskid==0) print*, '! mocassin: calling setLdiffuse'
       call setLdiffuse(grid3D(1:nGrids))
       test=0.
       do iGrid = 1, nGrids
          do i = 1, grid3D(igrid)%ncells
             test = test+grid3d(igrid)%LdiffuseLoc(i)
          end do
       end do
       if (taskid==0) then
          print*, '! mocassin: setLdiffuse done, total Ldiffuse: ', test
       end if
    end if

    if (taskid==0) print*, '! mocassin: calling MCIterationDriver'
    ! start the Monte Carlo simulation
    call MCIterationDriver(grid3D(1:nGrids))
    if (taskid==0) print*, '! mocassin: MCIterationDriver done'

    call mpi_barrier(mpi_comm_world, ierr)

    ! free all space allocated to the 3D grid
    if (taskid==0) then
      do iGrid=1, nGrids
         call freeGrid(grid3D(iGrid))
      end do
    endif

    call mpi_finalize(ierr)
    call cpu_time(timing(2))
    timing(1)=timing(1)/60.
    timing(2)=timing(2)/60.
    nhours = int((timing(2)-timing(1))/60.)
    nminutes = int(mod(timing(2)-timing(1),60.))
    nseconds = nint(60.*((timing(2)-timing(1))-real(nhours*60)-real(nminutes)))

    if (taskid==0) then
      print "(A,I3.2,A,I2.2,A,I2.2,A)","total run time per processor ",nhours,":",nminutes,":",nseconds," (HMS)"
      print *,'! MoCaSSin: end simulation reached - clean exit -'
    endif

end program MoCaSSiN

! Copyright (C) 2005 Barbara Ercolano
!
! Version 2.02
module interpolation_mod
    contains

    subroutine sortUp(arr)
      implicit none

      real, dimension(:), intent(inout) :: arr
      real, allocatable :: tmp(:)

      real       :: min


      integer    :: i, j
      integer    :: n ! size

      n = size(arr)

      allocate(tmp(n))

      min = 1.e30
      do i = 1, n
         if (arr(i) < min) min = arr(i)
      end do
      tmp(1) = min
      do j = 2, n
         min = 1.e30
         do i = 1, n
            if (arr(i) < min .and. arr(i) > tmp(j-1)) min = arr(i)
         end do
         tmp(j) = min
      end do

      arr = tmp

      deallocate(tmp)

    end subroutine sortUp

    ! given an array xa of length n, and given a value x, this
    ! routine returns a value ns, such that x is located between
    ! xa(ns) and xa(ns+1)
    ! ns = 0 or ns=n is returned to indicate that x is out
    ! of range.

    subroutine locate(xa,x,ns)

        implicit none

        integer, intent(out) :: ns

        real, dimension(:), intent(in) :: xa  ! input array
        real, intent(in) :: x                 ! variable to be located

        ! local variables

        integer :: n                 ! size of array xa

        n = size(xa)

        ! first check if x is out of range
        if ( x > xa(n) ) then
            ns = n
            return
        end if

        if ( x < xa(1) ) then
            ns = 0
            return
        end if

        ! if not, then locate
        ! the command finds the location of the smallest positive value of xa-x
        ! x lies between this location and the previous one
        ! so subtract one, and then x lies between xa(ns) and xa(ns+1)

        ns=max(minloc((xa-x),1,(xa-x).gt.0)-1,1)

    end subroutine locate


    ! this routine will map y(x) onto x_new and return y_new(x_new)
    ! mapping is carried out by means of linear interpolation
    subroutine linearMap(y, x, nx, y_new, x_new, nx_new)
      implicit none

      real, intent(out)   :: y_new(*)
      real, intent(in)    :: y(*), x(*), x_new(*)

      integer, intent(in) :: nx, nx_new
      integer             :: i, ii

      do i = 1, nx_new
         call locate(x(1:nx), x_new(i), ii)
         if (ii==0) then
            y_new(i) = y(1)
         else if (ii==nx) then
            y_new(i) = y(nx)
         else
            y_new(i) = y(ii) +(y(ii+1)-y(ii))*(x_new(i)-x(ii))/(x(ii+1)-x(ii))
         end if
      end do

    end subroutine linearMap

    ! subroutine polint carries out polynomial interpoation
    ! or extrapolation. given arrays xa nd ya, each of length
    ! n, and given a value x, it returns a value y and an
    ! error estimate dy.
    subroutine polint(xa, ya,  x, y, dy)
        implicit none

        real, dimension(:), intent(in) :: xa, ya
        real, intent(in) :: x
        real, intent(out) :: y, dy

        ! local variables

        integer :: i, m                       ! counters
        integer :: n                          ! size of the arrays
        integer :: ns = 1

        real :: den, ho, hp, w
        real, dimension(size(xa)) :: c, d

        ! locate the index ns closest to the table entry
        call locate(xa, x, ns)

        c = ya
        d = ya
        y = ya(ns)
        ns = ns-1

        n = size(xa)

        ! for each entry in the table, loop over the current
        ! c's and d's and update them
        do m=1, n-1
            do i = 1, n-m
                ho = xa(i) - x
                hp = xa(i+m) - x
                w = c(i+1) - d(i)
                den = ho - hp

                if (den == 0) then
                    print*, "! polint: two input xa's &
&                             identical (to within roundoff)"
                    stop
                end if

                den = w/den
                ! update c and d
                d(i) = hp*den
                c(i) = ho*den
            end do

            ! after each column in the table, decide the
            ! correction c or d to be added to the
            ! accumulating value of y.
            if ( (2*ns) < (n-m) ) then
                dy = c(ns+1)
            else
                dy = d(ns)
                ns = ns-1
            end if

            y = y+dy
        end do

    end subroutine polint

    ! subroutine spline given arrays wa and ya each of length
    ! n and given yp1 and ypn for the first derivatives of
    ! the interpolating function at points 1 and n
    ! respectively, returns the array y2a of length n
    ! containing the second derivatives of the interpolating
    ! funtion at the tabulated points. to use the condition
    ! of natural spline (2nd derivatives = 0 at the end
    ! points)  set yp1 and ypn to a value > or = to 1.e30.
    subroutine spline(xa, ya, yp1,ypn, y2a)
    implicit none

        real, dimension(:), intent(inout) :: xa, ya
        real, intent(in) :: yp1, ypn
        real, dimension(:), intent(out) :: y2a

        ! local variables

        integer :: i, k               ! counters
        integer :: n                  ! size of the arrays
        integer, parameter :: nmax=500! safety limit

        real                  :: p, qn, sig, un
        real, dimension(nmax) :: u
        n = size(xa)

        if (yp1 > .99e30) then
            y2a(1) = 0.
            u(1) = 0.
        else
            y2a(1) = -.5
            if ((xa(2)-xa(1))==0.) then
                print*, "! spline: bad xa input or x out of range [2,1] "
                stop
            end if
            u(1) = (3./(xa(2)-xa(1)))* &
                 & ((ya(2)-ya(1))/(xa(2)-xa(1))-yp1)
        end if
        do i = 2, n-1
            if ((xa(i+1)-xa(i-1))==0.) then
                print*, "! spline: bad xa input or x out of range [i+1, i-1] ", (i+1), (i-1)
                stop
            end if
            sig = (xa(i)-xa(i-1))/(xa(i+1)-xa(i-1))
            p=sig*y2a(i-1)+2.
            y2a(i)=(sig-1.)/p
            if ((xa(i+1)-xa(i))==0.) then
                print*, "! spline: bad xa input or x out of range [i+1, i] ", (i+1), (i)
                stop
            end if
            if ((xa(i)-xa(i-1))==0.) then
                print*, "! spline: bad xa input or x out of range [i, i-1] ", (i), (i-1)
                stop
            end if


            u(i)= ya(i+1)
            u(i)=u(i) - ya(i)
            u(i) = u(i) / (xa(i+1)-xa(i))
            u(i)= u(i) - (ya(i)-ya(i-1))/(xa(i)-xa(i-1))
            u(i)=(6.*u(i)/(xa(i+1)-xa(i-1)) - sig*u(i-1))/p
       end do
        if (ypn > .99e30) then
            qn=0.
            un=0.
        else
            qn=0.5
            if ((xa(n)-xa(n-1))==0.) then
                print*, "! spline: bad xa input or x out of range [n, n-1] ", n, (n-1)
                stop
            end if
            un=(3./(xa(n)-xa(n-1))) * &
                 & (ypn-(ya(n)-ya(n-1))/(xa(n)-xa(n-1)))
        end if
        y2a(n)=(un-qn*u(n-1))/(qn*y2a(n-1)+1.)

        do k = (n-1), 1, -1
            y2a(k) = y2a(k)*y2a(k+1)+u(k)
        end do

    end subroutine spline

    ! subroutine splint, given the arrays xa and ya each of
    ! length n and given the array y2a, which is the output
    ! from the subroutine spline, it returns a cubic spline
    ! interpolated value y for the given x
    ! NOTE: if x is out of range splint will return the limit
    ! values
    subroutine splint(xa, ya, y2a, x, y)

       real, dimension(:), intent(in) :: xa, ya, y2a
       real, intent(in) :: x
       real, intent(out) :: y

       ! local variables

       integer :: klo, khi, i, n
       integer, parameter :: imax = 1000

       real :: a, b, h

       n = size(xa)

       ! check if x is within range
       if ( x <= xa(1) ) then
           y = ya(1)
           return
       else if ( x >= xa(n) ) then
           y = ya(n)
           return
       end if

       klo = 1
       khi = n

       do i = 1, imax
           if ( (khi-klo) <= 1) exit
           k = (khi+klo)/2
           if (xa(k) > x) then
               khi=k
           else
               klo=k
           end if
       end do

       h=xa(khi)-xa(klo)

       if (h==0.) then
           print*, "! splint: bad xa input or x out of range [khi, klow] ", khi, klo
           stop
       end if

       a = (xa(khi) - x)/h
       b = (x - xa(klo))/h
       y = a*ya(klo)+b*ya(khi) + &
            & ((a**3-a)*y2a(klo)+(b**3-b)*y2a(khi)) * &
            & (h**2)/6.

    end subroutine splint

    ! this function performs a linear interpolation of a scalar quantity in a
    ! frequency dependent 3D grid. the interpolation coefficients t1, t2, t3 are
    ! are left to be calculated in the calling program, so that only a small
    ! number or arguments need to be passed to the procedure
    function interpGrid(s3Dgrid, s4DGrid, s5Dgrid, xP, yP, zP, freqP, elem, ion, t1, t2, t3)
        implicit none

        integer, intent(in)                  :: xP, yP, zP      ! x, y and z axes  indeces
        integer, intent(in), optional        :: freqP           ! frequency index
        integer, intent(in), optional        :: elem            ! element index
        integer, intent(in), optional        :: ion             ! ion index

        real, intent(in), dimension(:,:,:),&
&                          optional           :: s3Dgrid          ! 3D scalar grid
        real, intent(in), dimension(:,:,:,:),&
&                          optional           :: s4Dgrid          ! 4D scalar grid
        real, intent(in), dimension(:,:,:,:,:),&
&                          optional           :: s5Dgrid          ! 5D scalar grid
        real, intent(in)                     :: t1, t2, t3      ! interpolation coefficients
        real                                 :: interpGrid      ! interpolated value

        if ( present(freqP) .and. (.not.present(elem)) .and. (.not.present(ion)) ) then
            if(.not.present(s4Dgrid)) then
                print*, "! interpGrid: insanity occurred - arguments incompatible"
                stop
            end if
            interpGrid = &
&                   ((1.-t1)  * (1.-t2) * (1.-t3))* s4Dgrid(xP  , yP   , zP   , freqP) + &
&                   ((t1   )  * (1.-t2) * (1.-t3))* s4Dgrid(xP+1, yP   , zP   , freqP) + &
&                   ((t1   )  * (t2   ) * (1.-t3))* s4Dgrid(xP+1, yP+1 , zP   , freqP) + &
&                   ((1.-t1)  * (t2   ) * (t3   ))* s4Dgrid(xP  , yP+1 , zP+1 , freqP) + &
&                   ((1.-t1)  * (t2   ) * (1.-t3))* s4Dgrid(xP  , yP+1 , zP   , freqP) + &
&                   ((t1   )  * (1.-t2) * (t3   ))* s4Dgrid(xP+1, yP   , zP+1 , freqP) + &
&                   ((1.-t1)  * (1.-t2) * (t3   ))* s4Dgrid(xP  , yP   , zP+1 , freqP) + &
&                   ((t1   )  * (t2   ) * (t3   ))* s4Dgrid(xP+1, yP+1 , zP+1 , freqP)
        else if ((.not.present(freqP)) .and. present(elem) .and. present(ion) ) then
           if(.not.present(s5Dgrid)) then
                print*, "! interpGrid: insanity occurred - arguments incompatible"
                stop
            end if
            interpGrid = &
&                   ((1.-t1)  * (1.-t2) * (1.-t3))* s5Dgrid(xP  , yP   , zP   , elem, ion) + &
&                   ((t1   )  * (1.-t2) * (1.-t3))* s5Dgrid(xP+1, yP   , zP   , elem, ion) + &
&                   ((t1   )  * (t2   ) * (1.-t3))* s5Dgrid(xP+1, yP+1 , zP   , elem, ion) + &
&                   ((1.-t1)  * (t2   ) * (t3   ))* s5Dgrid(xP  , yP+1 , zP+1 , elem, ion) + &
&                   ((1.-t1)  * (t2   ) * (1.-t3))* s5Dgrid(xP  , yP+1 , zP   , elem, ion) + &
&                   ((t1   )  * (1.-t2) * (t3   ))* s5Dgrid(xP+1, yP   , zP+1 , elem, ion) + &
&                   ((1.-t1)  * (1.-t2) * (t3   ))* s5Dgrid(xP  , yP   , zP+1 , elem, ion) + &
&                   ((t1   )  * (t2   ) * (t3   ))* s5Dgrid(xP+1, yP+1 , zP+1 , elem, ion)
        else if ((.not.present(freqP)) .and. (.not.present(elem)) .and. (.not.present(ion)) ) then
           if(.not.present(s3Dgrid)) then
                print*, "! interpGrid: insanity occurred - arguments incompatible"
                stop
            end if
            interpGrid = &
&                   ((1.-t1)  * (1.-t2) * (1.-t3))* s3Dgrid(xP  , yP   , zP  ) + &
&                   ((t1   )  * (1.-t2) * (1.-t3))* s3Dgrid(xP+1, yP   , zP  ) + &
&                   ((t1   )  * (t2   ) * (1.-t3))* s3Dgrid(xP+1, yP+1 , zP  ) + &
&                   ((1.-t1)  * (t2   ) * (t3   ))* s3Dgrid(xP  , yP+1 , zP+1) + &
&                   ((1.-t1)  * (t2   ) * (1.-t3))* s3Dgrid(xP  , yP+1 , zP  ) + &
&                   ((t1   )  * (1.-t2) * (t3   ))* s3Dgrid(xP+1, yP   , zP+1) + &
&                   ((1.-t1)  * (1.-t2) * (t3   ))* s3Dgrid(xP  , yP   , zP+1) + &
&                   ((t1   )  * (t2   ) * (t3   ))* s3Dgrid(xP+1, yP+1 , zP+1)
         end if

    end  function interpGrid

end module interpolation_mod

program makenuryd
  implicit none

  integer :: ios, i
  real :: lambda,c=2.9979250e10,ryd=3.28984e15, nu(105)


  open(file='dustysed.dat', unit=10, iostat=ios, status = 'old')
  open(file='nuRyd.dat', unit=11, iostat=ios, status = 'unknown')
  
  do i = 1, 4
     read(10, *)
  end do

  do i = 1, 102
     read(10, *) lambda
     nu(i) = c/(lambda*1.e-4*ryd)
  end do
  
  do i = 102, 1, -1
     write(11, *) nu(i)
  end do          

  close(10)
  close(11)

end program makenuryd
     
     

! Copyright (C) 2005 Barbara Ercolano
!
! Version 2.02
module continuum_mod
    use constants_mod
    use common_mod
    use interpolation_mod

    ! common variables
    real, parameter      :: hcRyd_k = 157893.94    ! constant: h*cRyd/k (Ryd at inf used) [K]
    real, parameter      :: hcRyd = 2.1799153e-11  ! constant: h*c*Ryd (Ryd at inf used) [erg]
    real, parameter      :: cRyd = 3.2898423e15    ! constant: c*Ryd (Ryd at inf used) [Hz]


    real(kind=8), allocatable, save :: inSpectrumErg(:) ! input specrum energy distribution [erg/(cm^2*s*Hz*sr)]
    real(kind=8), allocatable, save :: inSpectrumPhot(:) ! input specrum energy distribution [phot/(cm^2*s*Hz*sr)]
    real, allocatable, save :: inSpectrumProbDen(:,:)  ! probability density for input spectrum (nstars,nbins)

    real, save          :: normConstantErg = 0.    ! normalization constant (area beyond input spectrum)
    real, save          :: normConstantPhot= 0.    ! normalization constant (area beyond input spectrum)
    real                :: correctionPhot
    real,save           :: RStar

    integer, parameter  :: maxLim = 200000        ! max number of rows in the input spectrum file
    integer             :: nuP                     ! frequency pointer

    logical, save       :: lgF=.true.

    contains


    subroutine setContinuum()
        implicit none

        ! local variables

        character(len=50) :: filein          ! input file name

        integer :: err                       ! allocation error status
        integer :: i, j, k, iStar            ! counters
        integer :: ios                       ! I/O error status
        integer :: numLam
        integer :: star1
        integer, parameter :: sb99nuLim=1221

        integer,dimension(nbins) :: lamCount
        real    :: skip, time                ! stellar surface [e36 cm^2]
        real(kind=8),dimension(maxLim)    :: tmp1, tmp2

        real, dimension(maxLim) :: enArray  ! freq array as read from input spectrum file [Hz]
        real(kind=8), dimension(maxLim)  :: Hflux    ! flux array as read from input spectrum file [erg/cm^2/s/Hz/sr]


        print*, 'in setContinuum ', contShape

        ios = 0

        lamCount=0

        ! initialize arrays
        if (lgF) then
           allocate(inSpectrumErg(nbins), stat = err)
           if (err /= 0) then
              print*, "! setContinuum: can't allocate grid memory"
              stop
           end if
           allocate(inSpectrumPhot(nbins), stat = err)
           if (err /= 0) then
              print*, "setContinuum: can't allocate grid memory"
              stop
           end if
           lgF = .false.
        end if
        allocate(inSpectrumProbDen(0:nStars,nbins), stat = err)
        if (err /= 0) then
            print*, "setContinuum: can't allocate grid memory"
            stop
        end if

        inSpectrumProbDen = 0.

        ! find the Lyman limit
        call locate(nuArray, 1., lymanP)

        if (Ldiffuse >0.) then
           star1 = 0
        else
           star1 = 1
        end if

        do iStar=star1, nStars

           ! initialise arrays
           enArray           = 0.
           Hflux             = 0.
           inSpectrumErg     = 0.
           inSpectrumPhot    = 0.
           inSpectrumProbDen(iStar,:) = 0.

           filein = contShape(iStar)

           ! open file for reading
           close(12)
           open(unit = 12, file=filein,  action="read", status = 'old', position = 'rewind', iostat=err)

           if (err /= 0) then

              ! then maybe a set continuum has been chosen
              print*, 'contShape ', contShape(iStar)
              do i = 1, nbins
                 inSpectrumErg(i) = getFlux(nuArray(i), Tstellar(iStar), contShape(iStar))
                 inSpectrumPhot(i) = inSpectrumErg(i)/ (nuArray(i)*hcRyd)

              end do


           else
              print*, 'contShape,spID ', contShape(iStar), spID(iStar)
              select case(spID(iStar))
              case ('sb99')

                 ! Starburst99 input
                 ! NOTE: the file must be in the format of 5 columns
                 !       the first containing the time step
                 !       the second the lambda points (A)
                 !       and the fourth containing the stellar spectrum points
                 !       (erg/s/A/sr). The file must be in ascending
                 !       wavenegth order.
                 !       First 7 lines are comments
                 ! check if the end of the file has been reached
                 if (taskid==0) print*, '! setContinuum: reading STARBURST99 File at t= ',tStep(iStar)
                 do j = 1, 7
                    read(unit=12, fmt=*)
                 end do

                 do j = 1, maxLim

                    read(unit=12, fmt=*, iostat=ios) time
                    if (ios < 0) exit ! end of file reached

                    if (time == tStep(iStar)) then
                       backspace(12)
                       do k = 1, sb99nuLim
                          read(12, *) time, enArray(k), skip, Hflux(k)

                          ! change Log L(lambda) [erg/s/A] into L(nu) [erg/s/Hz]
                          tmp1(k) = (10.**(Hflux(k))*(1.e-8*enArray(k)**2))/c

                          ! change to Ryd
                          tmp2(k) = (c/(enArray(k)*1.e-8))/cRyd

                       end do
                       exit
                    end if

                 end do

                 close(12)

                 do i = 1,sb99nuLim

                    Hflux(i) = tmp1(sb99nuLim-i+1)
                    enArray(i) = real(tmp2(sb99nuLim-i+1))

                 end do

                 do j = 1, sb99nuLim

                    if (enArray(j) >= nuArray(1)-widflx(1)/2. .and.&
                         & enArray(j) < nuArray(1)+widflx(1)/2.) then
                       inSpectrumErg(1) = inSpectrumErg(1)+Hflux(j)
                       lamCount(1) = lamCount(1)+1
                    end if
                    do i = 2, nbins-1
                       if(enArray(j)>=(nuArray(i-1)+nuArray(i))/2. .and.&
                            & enArray(j)<(nuArray(i+1)+nuArray(i))/2.) then
                          inSpectrumErg(i) = inSpectrumErg(i)+Hflux(j)
                          lamCount(i) = lamCount(i)+1

                       end if
                    end do
                    if(enArray(j)>=nuArray(nbins)-widflx(nbins)/2. .and.&
                         & enArray(j) < nuArray(nbins)+widflx(nbins)/2.) then
                       inSpectrumErg(nbins) = inSpectrumErg(nbins)+Hflux(j)
                       lamCount(nbins) = lamCount(nbins)+1
                    end if

                 end do


                 do i = 1, nbins
                    if (lamCount(i)>0) then

                       inSpectrumErg(i) = inSpectrumErg(i)/real(lamCount(i))
                    end if

                    inSpectrumPhot(i) = inSpectrumErg(i)/ (nuArray(i)*hcRyd)
                 end do

                 do i = 2, nbins-1
                    if (inSpectrumErg(i) <= 0. .and. inSpectrumErg(i-1)>0.) then
                       do j = i+1, nbins
                          if (inSpectrumErg(j) > 0.) then
                             inSpectrumErg(i) = inSpectrumErg(i-1)-&
                                  & ( (nuArray(i)-nuArray(i-1))*&
                                  & (inSpectrumErg(i-1)-inSpectrumErg(j))/&
                                  & (nuArray(j)-nuArray(i-1)))
                             exit
                          end if
                       end do
                    end if

                 end do

              case ('rauch')
                 do j = 1, maxLim

                    ! check if the end of file has been reached
                    ! NOTE: the file must be in the format of two columns
                    !       the first containing the lambda points (A)
                    !       and the second containing the input spectrum points
                    !       (erg/cm^2/s/A/sr). The file must be in ascending
                    !       wavenegth order. See e.g. Thomas Rauch's tables
                    !       http://astro.uni-tuebingen.de/~rauch/

                    ! check if the end of the file has been reached
                    read(unit=12, fmt=*, iostat=ios)
                    if (ios < 0) exit ! end of file reached

                    backspace(12)
                    read(12, *) enArray(j), Hflux(j)

                    ! change Hflux(lambda) [erg/cm^"/s/A/sr] into Hflux(nu) [erg/cm^2/s/Hz]

                    tmp1(j) = (Hflux(j)*(1.e-8*enArray(j)**2))/c/4.

                    ! change to Ryd
                    tmp2(j) = (c/(enArray(j)*1.e-8))/cRyd

                 end do

                 close(12)

                 do i = 1,j-1

                    Hflux(i) = tmp1(j-1-i+1)
                    enArray(i) = real(tmp2(j-1-i+1))

                 end do

                 numLam = j-1

                 do j = 1, numLam

                    if (enArray(j) >= nuArray(1)-widflx(1)/2. .and.&
                         & enArray(j) < nuArray(1)+widflx(1)/2.) then
                       inSpectrumErg(1) = inSpectrumErg(1)+Hflux(j)
                       lamCount(1) = lamCount(1)+1
                    end if
                    do i = 2, nbins-1
                       if(enArray(j)>=(nuArray(i-1)+nuArray(i))/2. .and.&
                            & enArray(j)<(nuArray(i+1)+nuArray(i))/2.) then
                          inSpectrumErg(i) = inSpectrumErg(i)+Hflux(j)
                          lamCount(i) = lamCount(i)+1
                       end if
                    end do
                    if(enArray(j)>=nuArray(nbins)-widflx(nbins)/2. .and.&
                         & enArray(j) < nuArray(nbins)+widflx(nbins)/2.) then
                       inSpectrumErg(nbins) = inSpectrumErg(nbins)+Hflux(j)
                       lamCount(nbins) = lamCount(nbins)+1
                    end if

                 end do

                 do i = 1, nbins
                    if (lamCount(i)>0) then
                       inSpectrumErg(i) = inSpectrumErg(i)/real(lamCount(i))
                    end if
                    inSpectrumPhot(i) = inSpectrumErg(i)/ (nuArray(i)*hcRyd)
                 end do

                 ! get physical flux
                 inSpectrumErg = fourPi*inSpectrumErg
                 inSpectrumPhot = fourPi*inSpectrumPhot

              case default

                 print*, '! setContinuum: unsupported spectrum ID', i, spID(i)
                 stop

              end select

           end if

          ! set the input spectrum probability density distribution
          call setProbDen(iStar)


       end do

       if (nStars==1) then
          if (LPhot > 0. ) then  ! calculate Lstar [e36 erg/s]

             if (contShape(1) == 'powerlaw') then
                print*, '! setContinuum: powerlaw do not allow Lphot. Please resubmit with Lstar.'
                stop
             end if

             RStar = sqrt(Lphot / (fourPi*normConstantPhot*cRyd))

              LStar(1) = fourPi*RStar*RStar*sigma*TStellar(1)**4

              deltaE(1)=Lstar(1)/nPhotons(1)

              if (taskid==0) then
                print*, "Q(H) = ", LPhot, " [e36 phot/s]"
                print*, "LStar= ", LStar(1), " [e36 erg/s]"
                print*, "RStar = ", RStar, " [e18 cm]"
                print*, "deltaE = ", deltaE, " [e36 erg/s]"
              endif

           else if (allocated(Lstar)) then ! calculate LPhot [e36 phot/s]

              deltaE(1)=Lstar(1)/nPhotons(1)

              if (contShape(1) /= 'powerlaw') then
                 RStar = sqrt(Lstar(1) / (fourPi*sigma*TStellar(1)**4))

                 LPhot = fourPi*RStar*RStar*normConstantPhot*cRyd

                 if (taskid==0) then
                   print*, "RStar = ", RStar, " [e18 cm]"
                   print*, "Q(H) = ", LPhot, " [e36 phot/s]"
                   print*, "LStar = ", LStar(1), " [e36erg/s]"
                 endif

              end if

              if (taskid==0) print*, "deltaE = ", deltaE(1), " [e36 erg/s]"

           end if


        end if

        if (Ldiffuse>0. .and. nPhotonsDiffuse>0 ) then
           deltaE(0) = Ldiffuse/nPhotonsDiffuse
        end if

        print*, 'out setContinuum'

      end subroutine setContinuum


    ! this function returns energy distribution [erg/(cm^2*s*Hz*sr)] for the
    ! continuum specified by contShape at the specified cell
    function getFlux(energy, temperature, cShape)

        real, intent(in) :: energy     ! energy [Ryd]
        real, intent(in) :: temperature! temperature [K]

        real :: constant               ! units constant
        real :: denominator            ! denominator
        real :: getFlux                ! erg/(cm^2*s*Hz*sr)

        character(len=50), intent(in) :: cShape


        ! calculate the input spectrum
        ! this is the Planck function divided by h (to avoid underflow)
        select case (cShape)
        case ("blackbody")
            constant = 0.5250229/hPlanck ! 2*fr1Ryd^3 / c^2 [erg/cm^2]

            ! Planck's law: B(T) = (2 h nu^3/c^2) / (exp(h nu / (k T)) - 1)
            ! transformaion of frequency into Ryd: nu = Ryd c nu [Ryd]

            if (hcRyd_k*energy/temperature > 86.) then
               ! Wien distribution
                getFlux = constant*energy*energy*energy*&
                     & exp(dble(-hcRyd_k*energy/temperature)) ! single precision maximum exponent is -87.3365479, double precision necessary to avoid FPEs
               return
            end if

            denominator = (exp(hcRyd_k*energy/temperature)-1.)

            if (denominator <= 0.) then

               ! Rayleigh-Jeans distribution
               ! 2*fr1Ryd2*k/c^2 = 3.32154e-6
               getFlux = 3.32154e-6*energy*energy*temperature/hPlanck
               return
            end if

            getFlux = constant*energy*energy*energy/&
                    & denominator

            return

         case ("powerlaw")

            if (energy>=nuMin .and. energy <= nuMax) then
               getFlux = energy**(-pwlIndex)
            else
               getFlux = 0.
            end if
            return

        case default
            print*, "! getFlux: invalid continuum shape", cShape
            stop
        end select

    end function getFlux

    subroutine setProbDen(iS)
        implicit none

        ! local variables
        integer, intent(in) :: iS         ! central star index

        integer :: i                      ! counter

        real :: maxp

        double precision :: inSpSumErg(nbins)    ! partial input spectrum sum [erg/s]
        double precision :: inSpSumPhot(nbins)   ! partial input spectrum sum [phot/s]

        inSpSumPhot = 0.
        inSpSumErg = 0.

!        if (taskid==0) print*,'Ionising/illuminating spectrum:'

        do i = 1, nbins
!           if (taskid==0) print*, i, nuArray(i),  inSpectrumErg(i)
           inSpSumErg(i)  =  real(inSpectrumErg(i))
           inSpSumPhot(i) =  real(inSpectrumPhot(i))
        end do

        ! calculate normalization constants
        normConstantErg=0.
        do i = 1, nbins
            normConstantErg   = normConstantErg  + inSpSumErg(i)*widFlx(i)
        end do

        normConstantPhot=0.
        do i = lymanP, nbins
           normConstantPhot  = normConstantPhot + inSpSumPhot(i)*widFlx(i)
        end do

        ! normalise spectrum and calculate PDF
        inSpectrumProbDen(iS,1) = inSpSumErg(1)*widFlx(1)/normConstantErg
        do i = 2, nbins
           inSpectrumProbDen(iS,i) = inSpectrumProbDen(iS,i-1) + &
                & inSpSumErg(i)*widFlx(i)/normConstantErg
        end do
        maxp = 0.
        do i = 1, nbins
           if (inSpectrumProbDen(iS,i)>maxp) maxp = inSpectrumProbDen(iS,i)
        end do

        do i = 1, nbins
           if (inSpectrumProbDen(iS,i)>=maxp) inSpectrumProbDen(iS,i)=1.

        end do

        if (contShape(iS)=='blackbody') then
           normConstantErg = Pi*normConstantErg*hPlanck
           normConstantPhot = Pi*normConstantPhot*hPlanck
        end if

      end subroutine setProbDen

      subroutine setLdiffuse(grid)
        implicit none

        type(grid_type), intent(inout) :: grid(1:nGrids)

        real    :: norm, dV

        integer :: iloc, igrid, ix, iy, iz, ngridsloc

        if (emittingGrid>0) then
           nGridsloc=emittingGrid
        else
           nGridsloc=nGrids
        end if

        if (lgGas) then
           norm = 0.
           do igrid = 1, nGridsloc
              do ix = 1, grid(igrid)%nx
                 do iy = 1, grid(igrid)%ny
                    do iz = 1, grid(igrid)%nz
                       if (grid(igrid)%active(ix,iy,iz)>0) then
                          dV = getVolumeCon(grid(igrid),ix,iy,iz)
                          iloc = grid(igrid)%active(ix,iy,iz)
                          norm = norm+grid(igrid)%Hden(iloc)*dV
                       end if
                    end do
                 end do
              end do
           end do

           norm = Ldiffuse/norm

           do igrid = 1, nGridsloc
              do ix = 1, grid(igrid)%nx
                 do iy = 1, grid(igrid)%ny
                    do iz = 1, grid(igrid)%nz
                       if (grid(igrid)%active(ix,iy,iz)>0) then
                          dV = getVolumeCon(grid(igrid),ix,iy,iz)
                          iloc = grid(igrid)%active(ix,iy,iz)
                          grid(igrid)%LdiffuseLoc(iloc) = norm*grid(igrid)%Hden(iloc)*dV
                       end if
                    end do
                 end do
              end do
           end do

        else if (lgDust) then
           norm = 0.

           do igrid = 1, nGridsloc
              do ix = 1, grid(igrid)%nx
                 do iy = 1, grid(igrid)%ny
                    do iz = 1, grid(igrid)%nz
                       if (grid(igrid)%active(ix,iy,iz)>0) then
                          dV = getVolumeCon(grid(igrid),ix,iy,iz)
                          iloc = grid(igrid)%active(ix,iy,iz)
                          norm = norm+grid(igrid)%nDust(iloc)*dV
                       end if
                    end do
                 end do
              end do
           end do

           norm = Ldiffuse/norm
           do igrid = 1, nGridsloc
              do ix = 1, grid(igrid)%nx
                 do iy = 1, grid(igrid)%ny
                    do iz = 1, grid(igrid)%nz
                       if (grid(igrid)%active(ix,iy,iz)>0) then
                          dV = getVolumeCon(grid(igrid),ix,iy,iz)
                          iloc = grid(igrid)%active(ix,iy,iz)
                          grid(igrid)%LdiffuseLoc(iloc) = norm*grid(igrid)%nDust(iloc)*dV
                       end if
                    end do
                 end do
              end do
           end do
        else
           print*, 'setLdiffuse: insanity - no dust or gas!'
           stop
        end if

      end subroutine setLdiffuse

      ! this function returns the volume of a cell in [e45 cm^3]
      function getVolumeCon(grid,xP, yP, zP)
        implicit none

        type(grid_type),intent(in) :: grid              ! the grid

        integer, intent(in)        :: xP, yP, zP        ! cell indeces

        real                       :: getVolumeCon         ! volume of the cell [e45 cm^3]

        ! local variables

        real                       :: dx, &             ! cartesian axes increments
&                                      dy, &             ! in [cm]
&                                      dz                !

        if (lg1D) then
           if (nGrids>1) then
              print*, '! getVolumeCon: 1D option and multiple grids options are not compatible'
              stop
           end if

           if (xP == 1) then

              getVolumeCon = 4.*Pi* ( (grid%xAxis(xP+1)/1.e15)**3)/3.


           else if ( xP==grid%nx) then

              getVolumeCon = Pi* ( (3.*(grid%xAxis(xP)/1.e15)-(grid%xAxis(xP-1)/1.e15))**3 - &
                   & ((grid%xAxis(xP)/1.e15)+(grid%xAxis(xP-1)/1.e15))**3 ) / 6.

           else

              getVolumeCon = Pi* ( ((grid%xAxis(xP+1)/1.e15)+(grid%xAxis(xP)/1.e15))**3 - &
                   & ((grid%xAxis(xP-1)/1.e15)+(grid%xAxis(xP)/1.e15))**3 ) / 6.

           end if

           getVolumeCon = getVolumeCon/8.

        else

           if ( (xP>1) .and. (xP<grid%nx) ) then
              dx = abs(grid%xAxis(xP+1)-grid%xAxis(xP-1))/2.
           else if ( xP==1 ) then
              if (lgSymmetricXYZ) then
                 dx = abs(grid%xAxis(xP+1)-grid%xAxis(xP))/2.
              else
                 dx = abs(grid%xAxis(xP+1)-grid%xAxis(xP))
              end if
           else if ( xP==grid%nx ) then
              dx = abs(grid%xAxis(xP)  -grid%xAxis(xP-1))
           end if

           if ( (yP>1) .and. (yP<grid%ny) ) then
              dy = abs(grid%yAxis(yP+1)-grid%yAxis(yP-1))/2.
           else if ( yP==1 ) then
              if (lgSymmetricXYZ) then
                 dy = abs(grid%yAxis(yP+1)-grid%yAxis(yP))/2.
              else
                dy = abs(grid%yAxis(yP+1)-grid%yAxis(yP))
             end if
          else if ( yP==grid%ny ) then
             dy = abs(grid%yAxis(yP)  -grid%yAxis(yP-1))
          end if

          if ( (zP>1) .and. (zP<grid%nz) ) then
             dz = abs(grid%zAxis(zP+1)-grid%zAxis(zP-1))/2.
          else if ( zP==1 ) then
             if (lgSymmetricXYZ) then
                dz = abs(grid%zAxis(zP+1)-grid%zAxis(zP))/2.
             else
                dz = abs(grid%zAxis(zP+1)-grid%zAxis(zP))
             end if
          else if ( zP==grid%nz ) then
             dz = abs(grid%zAxis(zP)-grid%zAxis(zP-1))
          end if

          dx = dx/1.e15
          dy = dy/1.e15
          dz = dz/1.e15


          ! calculate the volume
          getVolumeCon = dx*dy*dz


       end if

    end function getVolumeCon


end module continuum_mod

! Copyright (C) 2005 Barbara Ercolano
!
! Version 2.02
module dust_mod
  use common_mod
  use continuum_mod
  use interpolation_mod
  use xSec_mod

  implicit none

  contains

    subroutine dustDriver(grid)
      implicit none

      include 'mpif.h'

      type(grid_type), intent(inout) :: grid

      ! local variables

      real, allocatable :: absOpacTmp(:,:)
      real, allocatable :: scaOpacTmp(:,:)

      integer :: err ! allocation error status
      integer :: iP,jP,kP ! counter
      integer :: size ! size of MPI reducing string
      integer :: yTop

      logical,save :: lgFirstDustEm=.true.

      ! allocate dust opacity arrays

      allocate(absOpacTmp(0:grid%nCells, 1:nbins), stat = err)
      if (err /= 0) then
         print*, "! dustOpacity: can't allocate absOpacTmp memory"
         stop
      end if

      allocate(scaOpacTmp(0:grid%nCells, 1:nbins), stat = err)
      if (err /= 0) then
         print*, "! dustOpacity: can't allocate scaOpacTmp memory"
         stop
      end if

      allocate(grid%absOpac(0:grid%nCells, 1:nbins), stat = err)
      if (err /= 0) then
         print*, "! dustOpacity: can't allocate absOpac memory"
         stop
      end if

      allocate(grid%scaOpac(0:grid%nCells, 1:nbins), stat = err)
      if (err /= 0) then
         print*, "! dustOpacity: can't allocate scaOpac memory"
         stop
      end if

      if (.not. lgWarm) then
         allocate(grid%Tdust(0:nSpeciesMax, 0:nSizes, 0:grid%nCells), stat = err)
         if (err /= 0) then
            print*, "! dustOpacity: can't allocate Tdust memory"
            stop
         end if
         grid%Tdust   = 50.
      end if

      ! initialize arrays
      grid%absOpac = 0.
      grid%scaOpac = 0.

      ! initialize tmp arrays
      absOpacTmp = 0.
      scaOpacTmp = 0.

      if (lg2D) then
         yTop = 1
      else
         yTop = grid%ny
      end if


      do iP = taskid+1, grid%nx, numtasks
         do jP = 1, yTop
            do kP = 1, grid%nz

               call dustOpacity()

            end do
         end do
      end do

      size = (grid%nCells+1)*nbins

      call mpi_allreduce(grid%absOpac, absOpacTmp, size, &
&                             mpi_real, mpi_sum, mpi_comm_world, ierr)
      call mpi_allreduce(grid%scaOpac, scaOpacTmp, size, &
&                             mpi_real, mpi_sum, mpi_comm_world, ierr)


      do iP = 0, grid%nCells
         do jP = 1, nbins
            grid%absOpac(iP,jP) = absOpacTmp(iP,jP)
            grid%scaOpac(iP,jP) = scaOpacTmp(iP,jP)
         end do
      end do

      ! calculate the dust emission integrals
      if (lgFirstDustEm) then
         call dustEmissionInt()
         lgFirstDustEm=.false.
      end if
      lgDust = .true.


    contains


      subroutine dustOpacity()
        implicit none

        integer :: i ! counter

        ! check whether this cell is outside the nebula
        if (grid%active(iP,jP,kP) <= 0) return

        ! calculate scaOpac array
        ! calculate absOpac array
        do i = 1, nbins
           grid%scaOpac(grid%active(iP,jP,kP),i) = grid%Ndust(grid%active(iP,jP,kP))*&
                & xSecArray(dustScaXsecP(0,1)+i-1)
           grid%absOpac(grid%active(iP,jP,kP),i) = grid%Ndust(grid%active(iP,jP,kP))*&
                & xSecArray(dustAbsXsecP(0,1)+i-1)
        end do


      end subroutine dustOpacity


      ! this subroutine calculates the dust emission integrals for each species with non-zero
      ! abundance for temperatures between 0 and nTempsK in steps of 1K.
      ! assumes grains emit as blackbodies
      ! to be used later to determine dust Temps according to
      ! Kirchoff's law
      subroutine dustEmissionInt()
        implicit none

        real :: bb ! blackbody flux

        integer :: i, nT, nS, ai  ! counters

        character(len=50) :: cShapeLoc


        allocate(dustEmIntegral(1:nSpecies,1:nSizes,nTemps), stat = err)
        if (err /= 0) then
           print*, "! dustEmissionInt: can't allocate dustEmissionInt memory"
           stop
        end if
        dustEmIntegral = 0.

        cShapeLoc = 'blackbody'

        do nS = 1, nSpecies
           do ai = 1, nSizes

              do nT = 1, nTemps

                 do i = 1, nbins
                    bb = getFlux(nuArray(i), real(nT), cShapeLoc)
                    dustEmIntegral(nS,ai,nT) = dustEmIntegral(nS,ai,nT)+&
                         & xSecArray(dustAbsXsecP(nS,ai)+i-1)*bb*fr1Ryd*widFlx(i)
                 end do

              end do
           end do

        end do

        ! the hPlanck is re-introduced here (was excluded in the bb calcs)
        dustEmIntegral = dustEmIntegral*hPlanck*4.

      end subroutine dustEmissionInt

    end subroutine dustDriver

  end module dust_mod

! Copyright (C) 2005 Barbara Ercolano
!
! Version 2.02
module ionization_mod
    use common_mod             ! common variables
    use constants_mod          ! physical constants
    use xSec_mod               ! x sections module

    ! common variables
    real, allocatable :: contBoltz(:)       ! Boltzman factors for the continuum array
    real, allocatable :: FFOpacity(:)       ! FF opacity
    real, allocatable :: log10nuArray(:)    ! log10(nu) at this cell

    real, allocatable &
         &:: density(:,:)               ! abundance*ionDensity*HDen [cm^-3]

    real, save :: log10Ne               ! log10(Ne) at this cell
    real, save :: log10Te               ! log10(Te) at this cell
    real, save :: sqrTeUsed             ! sqr(Te) at this cell
    real, save :: eDenFFSum=0.          ! sum of heavy elements free electrons


    contains

    ! main routine to drive ionization solution for all species
    subroutine ionizationDriver(grid, ix, iy, iz)
        implicit none

        integer, intent(in) :: ix, iy, iz    ! pointers to cell in the x,y,z grid

        logical, save :: firstLg=.true.      ! first time?

        type(grid_type), intent(inout) :: grid

        ! local variables

        integer :: err                       ! allocation error status
        integer :: i, n                      ! counter


        ! check whether this cell is outside the nebula
        if (grid%active(ix,iy,iz) <= 0) return

        if (firstLg) then
           allocate(density(nElements, nStages), stat=err)
           if (err /= 0) then
              print*, "! ionizationDriver: can't allocate grid memory"
              stop
           end if
        end if

        density=0.

        ! find the physical properties of this cell
        ionDenUsed = grid%ionDen(grid%active(ix, iy, iz), :,:)
        log10Ne = log10(grid%Ne(grid%active(ix, iy, iz)))
        log10Te = log10(grid%Te(grid%active(ix, iy, iz)))
        NeUsed = grid%Ne(grid%active(ix, iy, iz))
        TeUsed = grid%Te(grid%active(ix, iy, iz))
        sqrTeUsed = sqrt(TeUsed)

        density = 0.

        ! find the ion number density [cm^-3] at this cell
        do n = 1, nElements
            do i= 1, min(n, nstages)

                ! check this element is present
                if (.not.lgElementOn(n)) exit
                if (grid%abFileIndex(ix,iy,iz)<=0) then
                   print*, '! ionizationDriver: abundance file index has value: ', grid%abFileIndex(ix,iy,iz)
                   print*, 'Cell: ', ix,iy,iz, grid%active(ix,iy,iz)
                   print*, 'Abundance file index array: ', grid%abFileIndex
                   stop
                end if

                density(n, i) = ionDenUsed(elementXref(n), i)*grid%elemAbun(grid%abFileIndex(ix,iy,iz),n)*&
                     & grid%Hden(grid%active(ix, iy, iz))
           end do
        end do

        ! initialize arrays if this is the first time the procedure is called
        if (firstLg) then
            allocate(log10nuArray(nbins), stat = err)
            if (err /= 0) then
                print*, "! ionizationDriver: can't allocate grid memory"
                stop
            end if
            allocate(contBoltz(nbins), stat = err)
            if (err /= 0) then
                print*, "! ionizationDriver: can't allocate grid memory"
                stop
            end if
            allocate(gauntFF(nbins), stat = err)
            if (err /= 0) then
                print*, "! ionizationDriver: can't allocate grid memory"
                stop
            end if
            allocate(gauntFFHeII(nbins), stat = err)
            if (err /= 0) then
                print*, "! ionizationDriver: can't allocate grid memory"
                stop
            end if
            allocate(FFOpacity(nbins), stat = err)
            if (err /= 0) then
                print*, "! ionizationDriver: can't allocate grid memory"
                stop
            end if

            contBoltz = 0.
            FFOpacity = 0.
            gauntFF = 0.
            gauntFFHeII = 0.
            log10nuArray = log10(nuArray)

            firstLg = .false.

       end if

        ! re-evaluate gaunt factors and boltzmann factors
        call BoltGaunt()

        ! (re)evauate the sum of heavy elements free electrons density
         call eDenSum()

        ! reevaluate all opacities if new ionization
        call addOpacity(grid%opacity(grid%active(ix, iy, iz), :))

    end subroutine ionizationDriver


    ! this subroutine evaluates boltzmann  factors for the continuum
    ! and related variables
    subroutine BoltGaunt()
        implicit none

        ! local variables
        integer :: i                            ! counter
        integer :: iflag                        ! status flag returned by getGauntFF
        integer :: max                          ! upper nu limit given by 0 exp

        real :: exponent                        ! exponenent
        real, save :: TeOld1=-1., TeOld2=-1.    ! te on last run of sub

        ! correction factors for induced recombination
        ! are also used as Boltzmann factors.

        ! check for temperature changes or for first evaluation
        if ( (TeOld1 /= TeUsed) .or. (contBoltz(1) <= 0.) ) then
            TeOld1 = TeUsed
            do i = 1, nbins
                exponent = (Te1Ryd / TeUsed) + nuArray(i)
                if( exponent > 84.) exit
                contBoltz(i) = exp(-exponent)
            end do

            ! set max
            max = i

            ! zero out the remainder
            do i = max, nbins
                contBoltz(i) = 0.
            end do
        end if

        ! find the Gaunt factors
        ! check if temperature has changed by much
        if ( abs(1. - TeOld2/TeUsed) > 0.10 ) then
            call getGauntFF(0., log10Te, log10nuArray, gauntFF, iflag)
            ! following is for ionized helium
            call getGauntFF(0.30103, log10Te, log10nuArray, gauntFFHeII, iflag)
            TeOld2 = TeUsed
        end if
    end subroutine BoltGaunt

    ! this subroutine computes the gaunt factors for any charge
    ! it generates thermally averaged free-free non-relativistic gaunt
    ! factor for a hydrogenic ion of charge z, with a maximum relative
    ! error of 0.007, (rms fitting error = 0.001) for tmps and freqs in
    ! intervals:
    !          10^-4 <= U <= 10^1.5
    !          10^-3 <= Gams <= 10^3~
    ! where U = h*nu/k*T and gams = Z^2 * Ryd / k*T. To obtain the stated
    ! accuracy the full number of significant figures must be retained.
    !
    ! this subroutine uses a two-dimensional chebyshev epansion computed
    ! from expressions given bu Karzas and Latter (ApJSuppl., V.6, P.167,
    ! 1961) augmented by various limiting forms of energy-specific gaunt-
    ! factors.
    ! D.G.Hummer, Jila, May 1987. ApJ 327, 477
    ! modified with correct limits, J Ferguson, July 94
    ! modified for MOCASSIN by B Ercolano (Ercolano et al 2003, MNRAS 340, 1136)
    subroutine getGauntFF(z, log10Te, xlf, g, iflag)
        implicit none

        integer, intent(out) :: iflag                ! explanation given in each area

        real, intent(in) :: log10Te                  ! log10(Te)
        real, intent(in) ::  z                       ! log10 of nuclear charge
        real, dimension(:), intent(in) :: xlf        ! array of log10(h*nu/Ryd)
        real, dimension(size(xlf)), intent(out) :: g ! array of values of g

        ! local variables
        integer ::  i, ir, j

        real, dimension(11) :: b
        real, dimension(8) :: c
        real :: con
        real(kind=8), dimension(88) :: dd
        real(kind=8), dimension(8, 11) :: d
        real :: gamma2                               ! gamma^2 (gams = Z^2 * Ryd / k*T)
        real :: slope                                ! slope
        real :: txg                                  ! hummer variable related to gamma^2
        real :: txu                                  ! hummer variable related to U
        real :: u                                    ! U = h*nu/k*T
        real :: xlrkt                                ! log(ryd/kt)

        dd = (/8.986940175e+00, -4.009515855e+00,  8.808871266e-01,&
&          2.640245111e-02, -4.580645915e-02, -3.568055702e-03,&
&          2.827798067e-03,  3.365860195e-04, -8.006936989e-01,&
&          9.466021705e-01,  9.043402532e-02, -9.608451450e-02,&
&         -1.885629865e-02,  1.050313890e-02,  2.800889961e-03,&
&         -1.078209202e-03, -3.781305103e-01,  1.102726332e-01,&
&         -1.543619180e-02,  8.310561114e-03,  2.179620525e-02,&
&          4.259726289e-03, -4.181588794e-03, -1.770208330e-03,&
&          1.877213132e-02, -1.004885705e-01, -5.483366378e-02,&
&         -4.520154409e-03,  8.366530426e-03,  3.700273930e-03,&
&          6.889320423e-04,  9.460313195e-05,  7.300158392e-02,&
&          3.576785497e-03, -4.545307025e-03, -1.017965604e-02,&
&         -9.530211924e-03, -3.450186162e-03,  1.040482914e-03,&
&          1.407073544e-03, -1.744671550e-03,  2.864013856e-02,&
&          1.903394837e-02,  7.091074494e-03, -9.668371391e-04,&
&         -2.999107465e-03, -1.820642230e-03, -3.874082085e-04,&
&         -1.707268366e-02, -4.694254776e-03,  1.311691517e-03,&
&          5.316703136e-03,  5.178193095e-03,  2.451228935e-03,&
&         -2.277321615e-05, -8.182359057e-04,  2.567331664e-04,&
&         -9.155339970e-03, -6.997479192e-03, -3.571518641e-03,&
&         -2.096101038e-04,  1.553822487e-03,  1.509584686e-03,&
&          6.212627837e-04,  4.098322531e-03,  1.635218463e-03,&
&         -5.918883504e-04, -2.333091048e-03, -2.484138313e-03,&
&         -1.359996060e-03, -5.371426147e-05,  5.553549563e-04,&
&          3.837562402e-05,  2.938325230e-03,  2.393747064e-03,&
&          1.328839809e-03,  9.135013312e-05, -7.137252303e-04,&
&         -7.656848158e-04, -3.504683798e-04, -8.491991820e-04,&
&         -3.615327726e-04,  3.148015257e-04,  8.909207650e-04,&
&          9.869737522e-04,  6.134671184e-04,  1.068883394e-04,&
&         -2.046080100e-04/)

        d = reshape( dd, (/8, 11/) )

        ! compute temperature dependent coeffcients for U expansion

        ! xlrxt is log(ryd/kt), code note valid for Te > 10^8
        ! xlrxt is log(ryd/kt), code note valid for Te < 10^2.5
        if ( log10Te < 2.5 ) then
            xlrkt = 5.1983649 - 2.5
        else if ( log10Te > 8. ) then
            xlrkt = 5.1983649 - 8.
        else
            xlrkt = 5.1983649 - log10Te
        end if

        ! set txg
        txg = 0.66666667*(2.0*z+xlrkt)
        gamma2 = 10**(txg*1.5)

        con = 0.72727273*xlrkt+0.90909091
        do j=1,8
            ir = 9
            b(11) = real(d(j,11))
            b(10) = real(txg*b(11)+d(j,10))
            do i=1,9
                b(ir) = real(txg*b(ir+1)-b(ir+2)+d(j,ir))
                ir = ir-1
            end do
            c(j) = 0.25*(b(1)-b(3))
        end do

        ! sum U expansion
        ! loop through energy at fixed temperature
        do i = 1, size(xlf)
            txu = 0.72727273*xlf(i)+con
            u = 10**((txu - .90909091)/.72727273)
            ! criteria set by hummer limits. it is a wedge from
            ! log(hnu),log(T)) =
            ! (-5,2.5) to (-5,4) to (-1,8) to (4,8) to (-1.5,2.5).
            ! these limits correspond to the gamma^2 and U limits
            ! given above
            if(abs(txu)<=2.0) then
                ir = 6
                b(8) = c(8)
                b(7) = txu*b(8)+c(7)
                do j=1,6
                    b(ir) = txu*b(ir+1)-b(ir+2)+c(ir)
                    ir = ir-1
                end do
                g(i) = b(1)-b(3)
                if( (log10Te>=2.5) .and. (log10Te<=8.0)) iflag = 0
                ! On the bottom side of the hummer box,u<-4 and gamma2>.33
            else if( (log10(u)<-4.0) .and. (gamma2<0.3) ) then
               g(i) = 0.551329 * log(2.24593/u)
              if( (log10Te>=2.5) .and. (log10Te<=8.0) ) iflag = 2
            ! On the bottom side of the box,u<-4 and gamma2<.33
            else if( (log10(u)<-4.0) .and. (gamma2>=0.3) ) then
                g(i) = 0.551329 * alog( 0.944931/u/sqrt(gamma2) )
                if( (log10Te>=2.5) .and.( log10Te<=8.0) ) iflag = 3
                ! Now on the bottom side of the box
                else if (txu>2.0) then
                ! Top of the box high T first
                if (log10(gamma2)<-3.) then
                    g(i) =  sqrt(0.9549297/u)
                    if(log10Te>=2.5.and.log10Te<=8.0) iflag = 4
                    ! Must interpolate between two asymptotes
                else if(log10(gamma2)<0.0) then
                    slope = ( sqrt(12*gamma2/u) - sqrt(0.9549297/u) ) / 3.0
                    g(i) =  sqrt(12*gamma2/u) + slope * log10(gamma2)
                    if((log10Te>=2.5) .and. (log10Te<=8.0)) iflag = 7
                else
                ! The top side with wedge of 1.05 where region 6 fails
                    g(i) = sqrt(12. * gamma2 / u)
                    g(i) = min(1.05,g(i))
                    if( (g(i)==1.05) .and. (log10Te>=2.5) .and. (log10Te<=8.0)) &
                         & iflag = 5
                    if( (g(i)<1.05) .and. (log10Te>=2.5) .and. (log10Te<=8.0)) &
                         & iflag = 6
                end if
            end if
            u = 0.0
        end do
    end subroutine getGauntFF


    ! this subroutine sums up the free electron density over all species
    subroutine eDenSum()
        implicit none

        ! local variables
        integer :: n, i                                           ! counters

        ! sum the heavy metal free electron density
        eDenFFSum = 0.
        do n = 3, nElements
            do i = 1, min(n, nstages-1)
                eDenFFSum = eDenFFSum + float(i*i)*density(n, i+1)
            end do
        end do
    end subroutine eDenSum

    subroutine addOpacity(opacity)
        implicit none

        real, dimension(:), intent(out) :: opacity                !  opacity

       ! local variables

        integer :: i                                           ! counters
        real    :: fac1, fac2, fac3       ! factors to be used in calculations

        ! (re) initialize opacity arrays
        opacity = 0.

        ! hydrogen helium and heavy element brems (free-free) opacity,
        ! assuming hydrogen ff gaunt factors
        ! xSecArray is missing factor of 1.e-20 to avoid underflow.
        fac1 = (NeUsed/1.e10) * ( (density(1,2) + density(2, 2) + &
             & 4.*density(2, 3) + eDenFFSum)/1.e10 ) / sqrTeUsed
        fac2 = fac1 * Te1Ryd / TeUsed

        do i = 1, nbins

           if (i>1) then
              if (FFOpacity(i-1)<1.e-35) then
                 FFOpacity(i) = 0.
              end if
           else
              if (contBoltz(i) < 0.995 ) then
                 ! 1-exp(hn/kT) is used only is exp is small
                 ! the last term is scaled h minus free-free absorption

                 fac3 = xSecArray(i-1+bremsXSecP)*(1.-contBoltz(i))*gauntFF(i)

                 FFOpacity(i) = fac3 * fac1

              else

                 fac3 = xSecArray(i-1+bremsXSecP)*nuArray(i)*gauntFF(i)
                 FFOpacity(i) = fac3 * fac2

              end if
           end if

           opacity(i) = opacity(i) + FFOpacity(i)
        end do

       ! hydrogen lyman continuum photoelectric opacity
       call inOpacity(HlevXSecP(1), HlevNuP(1), nbins, density(1,1), 0.)

       ! NOTE: the opacity due to the excited levels of HI, HeI and HeII is
       ! neglected for now as it requires calculations of the densities of
       ! the excited levels populations -> 4th argument in inOpacity is density
       ! of the lower level [cm^-3]

       ! helium singlets HeI (ground special because it extends to the high energy limit)
       call inOpacity(HeISingXSecP(1), HeIlevNuP(1), nbins, density(2, 1), 0.)

       ! ionized helium HeII (ground special because it extends to the high energy limit)
       call inOpacity(HeIIXSecP(1), HeIIlevNuP(1), nbins, density(2, 2), 0.)

       do i = 3, nElements
          if ( lgElementOn(i) ) call putOpacity(i)
       end do

       contains

         ! this subroutine enters the total phoo cross section
         ! for all subshells into opacity array. it drives inOpacity
         ! to put in total opacities
         subroutine putOpacity(nElem)
             implicit none

             integer, intent(in)               :: nElem

             ! local variables
             integer :: nIon                  ! counter
             integer :: nuLowP, nuHighP       ! pointers to lower and highert limit of energy range
             integer :: nShell                ! counter
             integer :: xSecP                 ! pointer to x scetion in xSecArray


             do nIon = 1, min(nElem, nstages)
                 if ( density(nElem, nIon) > 0. ) then

                     ! number of bound electrons
                     do nShell = 1, nShells(nElem, nIon)
                         nuLowP = elementP(nElem, nIon, nShell, 1)
                         nuHighP = elementP(nElem, nIon, nShell, 2)
                         xSecP = elementP(nElem, nIon, nShell, 3)
                         call inOpacity(xSecP, nuLowP, nuHighP, density(nElem, nIon), 0.)
                     end do

                 end if
             end do
          end subroutine putOpacity

         ! this subroutine adds the opacity of individual species,
         ! it can include stimulated emission. the departure coefficient b
         ! can be set to zero.
         subroutine inOpacity(xSecP, nuLowP, nuHighP, den, b)
             implicit none

             integer, intent(in)               :: nuLowP, nuHighP  ! pointers to lower and higher limits in nuArray
             integer, intent(in)               :: xSecP            ! x section pointer

             real, intent(in)                  :: b                ! departure coefficient
             real, intent(in)                  :: den              ! density of the lower level [cm^-3]

             ! local variables
             integer             :: i                              ! counter
             integer             :: iup                            ! upper limit
             integer             :: k                              ! offset

             real                :: bInv                           ! 1./b

             k = xSecP - nuLowP
             iup = min(nuHighP, nbins)
             iup = max(nuLowP, iup)
             if (b > 1e-35) then
                 bInv = 1./b
                 do i = nuLowP, iup
                     opacity(i) = opacity(i) + xSecArray(i+k)*den*&
&                                  max(0., 1.-contBoltz(i)*bInv)
                 end do
             else
                 do i = nuLowP, iup

                     opacity(i) = opacity(i) + xSecArray(i+k)*den

                end do
             end if


        end subroutine inOpacity

    end subroutine addOpacity

end module ionization_mod

! Copyright (C) 2005 Barbara Ercolano
!
! Version 2.02
module iteration_mod
    use common_mod
    use continuum_mod
    use emission_mod
    use ionization_mod
    use output_mod
    use photon_mod
    use update_mod

    implicit none

    contains

    subroutine MCIterationDriver(grid)
       implicit none

       type(grid_type), intent(inout) :: grid(*) ! the 3D cartesian grid

       ! local variables

       integer :: i, j, k                     ! counters


       call iterateMC()

       contains

       recursive subroutine iterateMC()
           implicit none

           include 'mpif.h'

           ! local variables
           real, allocatable :: budgetTemp(:,:)      ! temporary dust heating budget array
           real, allocatable :: dustPDFTemp(:,:)     ! temporary dust emission PDF array
           real, allocatable :: escapedPacketsTemp(:,:,:)!temporary escaped packets array
           real, allocatable :: fEscapeResPhotonsTemp(:,:) ! temporary escape res line phot
           real, allocatable :: JDifTemp(:,:)        ! temporary diffuse field array
           real, allocatable :: JSteTemp(:,:)        ! temporary stellar field array
           real, allocatable :: linePacketsTemp(:,:) ! temporary line packets array
           real, allocatable :: opacityTemp(:,:)     ! temporary opacities array
           real, allocatable :: recPDFTemp(:,:)      ! temporary rec prob distribution function
           real, allocatable :: linePDFTemp(:,:)     ! temporary line prob distribution function
           real, allocatable :: totalLinesTemp(:)    ! temporary fraction of non-ionizing line phots

           real, allocatable          :: noHitPercent(:)    ! percentage of no Hit cells
           real, allocatable          :: noIonBalPercent(:) ! percentage of cell where ion bal not conv
           real, allocatable          :: noTeBalPercent(:)  ! percentage of cell where Te bal not conv
           real,save              :: totPercentOld   ! percentage of converged cells from prev iteration
           real                   :: totCells        ! total # of active cells
           real                   :: totheatdust     ! total dust heating

           integer, allocatable       :: planeIonDistributionTemp(:,:)
           integer, allocatable       :: resLinePacketsTemp(:) ! temporary array for extra packets
           integer                :: err             ! allocation error status
           integer                :: freq,nS         ! counters
           integer                :: ifreq, ian      ! counters
           integer                :: ios,iG          ! I/O error status
           integer                :: load,rest       !
           integer                :: size            ! size for mpi
           integer                :: iCell           ! cell index including non-active
           integer                :: iStar           ! star index
           integer                :: ai              ! grain size counter
           integer                :: icontrib,icomp ! counters
           integer                :: imu             ! direction cosine
           integer                :: cellLoc(3)      ! local cell counters
           integer                :: gpLoc           ! local grid counter
           integer                :: ii,jj,kk        ! counters
           integer                :: ngridloc
           integer                :: yTop

           integer                :: dcp, nsp

           character(len=10)      :: time            ! to display time when each iteration finishes

           allocate(noHitPercent(nGrids))
           allocate(noIonBalPercent(nGrids))
           allocate(noTeBalPercent(nGrids))

           ! re-initialize MC estimators
           do iG = 1, nGrids
              grid(iG)%lgConverged(0:grid(iG)%nCells)    = 0
              grid(iG)%lgBlack(0:grid(iG)%nCells)        = 0
              if (lgGas) then
                 ! zero out PDF arrays
                 grid(iG)%recPDF(0:grid(iG)%nCells, 1:nbins) = 0.
                 if (lgDebug) grid(iG)%linePDF(0:grid(iG)%nCells, 1:nLines)    = 0.
                 grid(iG)%totalLines(0:grid(iG)%nCells) = 0.

                 ! zero out Balmer jump
                 BjumpTemp = 0.
                 Bjump     = 0.
              end if

              if (lgDust .and. .not.lgGas) then
                 ! zero out dust PDF arrays
                 grid(iG)%dustPDF(0:grid(iG)%nCells, 1:nbins)     = 0.
              end if
           end do

!*****************************************************************************

           iCell = 0

           do iG = 1, nGrids

              if (ig>1 .or. (.not.lg2D)) then
                 yTop = grid(iG)%ny
              else if (iG ==1 .and. lg2D) then
                 yTop = 1
              end if


              grid(iG)%opacity(0:grid(iG)%nCells, 1:nbins) = 0.

              if (lgGas) then
                 if (taskid==0) print*, '! iterateMC: ionizationDriver in', iG
                 ! calculate the opacities at every grid cell
                 do i = 1, grid(iG)%nx
                    do j = 1, yTop
                       do k = 1, grid(iG)%nz
                          iCell = iCell+1
                          if (mod(iCell-(taskid+1),numtasks)==0) &
                               & call ionizationDriver(grid(iG),i,j,k)
                       end do
                    end do
                 end do
                 if (taskid==0) print*, '! iterateMC: ionizationDriver out', iG

                 allocate(opacityTemp(0:grid(iG)%nCells, nbins), stat = err)
                 if (err /= 0) then
                    print*, "! iterateMC: can't allocate array memory: opacityTemp ", iG
                    stop
                 end if

                 opacityTemp = 0.

                 size = (grid(iG)%nCells+1)*nbins

                 call mpi_allreduce(grid(iG)%opacity, opacityTemp, size, &
                      & mpi_real, mpi_sum, mpi_comm_world, ierr)


                 do i = 1, grid(iG)%nx
                    do j = 1, yTop
                       do k = 1, grid(iG)%nz
                          do freq = 1, nbins

                             if (grid(iG)%active(i,j,k)>0) then
                                grid(iG)%opacity(grid(iG)%active(i,j,k),freq) = opacityTemp(grid(iG)%active(i,j,k),freq)
                             end if

                          end do
                       end do
                    end do
                 end do
                 if ( allocated(opacityTemp) ) deallocate(opacityTemp)

              end if

              ! add dust contribution to total opacity
              if (taskid==0) print*, '! iterateMC: adding dust contribution to total opacity ',iG
              if (lgDust) then
                 grid(iG)%scaOpac(0:grid(iG)%nCells, 1:nbins) = 0.
                 grid(iG)%absOpac(0:grid(iG)%nCells, 1:nbins) = 0.

                 if((nIterateMC==1 .and. lgEquivalentTau)) then
                    grid(iG)%scaOpac(0:grid(iG)%nCells, 1:nbins) = 0.
                    grid(iG)%absOpac(0:grid(iG)%nCells, 1:nbins) = 0.
                 else


                    if (ig>1 .or. (.not. lg2D)) then
                       yTop = grid(iG)%ny
                    else if (iG ==1 .and. lg2D) then
                       yTop = 1
                    end if

                    do i = 1, grid(iG)%nx
                       do j = 1, yTop
                          do k = 1, grid(iG)%nz
                             if (grid(iG)%active(i,j,k)>0) then
                                if (lgMultiDustChemistry) then
                                   dcp = dustComPoint(grid(iG)%dustAbunIndex(grid(iG)%active(i,j,k)))
                                   nsp = grid(iG)%dustAbunIndex(grid(iG)%active(i,j,k))
                                else
                                   dcp = dustComPoint(1)
                                   nsp = 1
                                end if

                                do nS = 1, nSpeciesPart(nsp)

                                   do ai = 1, nSizes
                                      if (grid(iG)%Tdust(nS,ai,grid(iG)%active(i,j,k))<TdustSublime(dcp-1+nS)) then
                                         do freq = 1, nbins
                                            grid(iG)%scaOpac(grid(iG)%active(i,j,k),freq) = &
                                                 & grid(iG)%scaOpac(grid(iG)%active(i,j,k),freq) + &
                                                 & grainAbun(nsp,nS)*&
                                                 & grainWeight(ai)*grid(iG)%Ndust(grid(iG)%active(i,j,k))*&
                                                 & xSecArray(dustScaXsecP(nS+dcp-1,ai)+freq-1)
                                            grid(iG)%absOpac(grid(iG)%active(i,j,k),freq) = &
                                                 & grid(iG)%absOpac(grid(iG)%active(i,j,k),freq) + &
                                                 & grainAbun(nsp,nS)&
                                                 & *grainWeight(ai)*grid(iG)%Ndust(grid(iG)%active(i,j,k))*&
                                                 & xSecArray(dustAbsXsecP(nS+dcp-1,ai)+freq-1)
                                         end do
                                      end if
                                   end do
                                end do

                                do freq = 1, nbins
                                   grid(iG)%opacity(grid(iG)%active(i,j,k),freq) = &
                                        &grid(iG)%opacity(grid(iG)%active(i,j,k),freq) + &
                                        & (grid(iG)%scaOpac(grid(iG)%active(i,j,k),freq) + &
                                        &grid(iG)%absOpac(grid(iG)%active(i,j,k),freq))
                                end do
                             end if

                          end do
                       end do
                    end do
                 end if

              end if
              if (taskid==0) print*, '! iterateMC: dust contribution to total opacity added ',iG

           end do ! ngrids

           call mpi_barrier(mpi_comm_world, ierr)


!*****************************************************************************




           if (taskid==0 .and. lgWritePss) then
              open(unit=89, file='output/qHeatPss.out',  action="write",status='unknown', position='rewind', iostat=ios)
              if (ios /= 0) then
                 print*, "! iterationMC: can't open file for writing, output/qHeatPss.out"
                 stop
              end if
           end if

           ! check if min convergence was reached to carry out resonant line transfer
           if (lgDust .and. lgGas .and. convPercent>=resLinesTransfer .and. lgResLinesFirst &
                &.and. (.not.nIterateMC==1)) then

              call initResLines(grid(1:nGrids))

              do iG = 1, nGrids
                 allocate(fEscapeResPhotonsTemp(0:grid(iG)%nCells, 1:nResLines), stat &
                      &= err)
                 if (err /= 0) then
                    print*, "! iterateMC: can't allocate array&
                         & memory:fEscapeResPhotonsTemp"
                    stop
                 end if
                 fEscapeResPhotonsTemp = 0.

                 allocate(resLinePacketsTemp(0:grid(iG)%nCells), stat &
                      &= err)
                 if (err /= 0) then
                    print*, "! iterateMC: can't allocate array&
                         & memory:resLinePacketsTemp"
                    stop
                 end if
                 resLinePacketsTemp = 0

              end do
           end if

           ! set the diffuse PDFs at every grid cell
           do iG = 1, nGrids

              if (ig>1 .or. (.not.lg2D) ) then
                 yTop = grid(iG)%ny
              else if (iG ==1 .and. lg2D) then
                 yTop = 1
              end if


              if (taskid==0) print*, '! iterateMC: emissionDriver in',iG
              iCell = 0
              do i = 1, grid(iG)%nz
                 do j = 1, yTop
                    do k = 1, grid(iG)%nx
                       iCell = iCell+1
                       if (mod(iCell-(taskid+1),numtasks)==0) &
                            & call emissionDriver(grid,k,j,i,iG)
                    end do
                 end do
              end do

              if (taskid==0) print*, '! iterateMC: emissionDriver out', iG
              if (taskid==0 .and. lgWritePss) close(89)

              if (lgDust .and. .not.lgGas) then
                 allocate(dustPDFTemp(0:grid(iG)%nCells, 1:nbins),&
                      & stat = err)
                 if (err /= 0) then
                    print*, "! iterateMC: can't allocate array memory:&
                         & dustPDFTemp ", iG
                    stop
                 end if
                 dustPDFTemp = 0.
              end if

              if (lgGas) then
                 call mpi_allreduce(BjumpTemp, Bjump, 1, mpi_real&
                      &, mpi_sum, mpi_comm_world, ierr)

                 ! Balmer jump is in [erg/s/A] since factor of e-40 from gas emissivity
                 ! and factor of e45 from volume calculations, so multiply by e5
                 if (lgSymmetricXYZ) Bjump = Bjump*8.
                 Bjump = Bjump*1.e5

                 if (taskid==0) print*, "Balmer Jump: [erg/s/A] ", Bjump

                 allocate(recPDFTemp(0:grid(iG)%nCells, 1:nbins),&
                      & stat = err)
                 if (err /= 0) then
                    print*, "! iterateMC: can't allocate array memory:&
                         & recPDFTemp "
                    stop
                 end if

                 allocate(totalLinesTemp(0:grid(iG)%nCells), stat =&
                      & err)
                 if (err /= 0) then
                    print*, "! iterateMC: can't allocate array memory:&
                         & opacityTemp "
                    stop
                 end if

                 recPDFTemp = 0.
                 totalLinesTemp = 0.

              end if

              if (lgDebug) then
                 allocate(linePDFTemp(0:grid(iG)%nCells, nLines),&
                      & stat = err)
                 if (err /= 0) then
                    print*, "! iterateMC: can't allocate array memory:&
                         & opacityTemp "
                    stop
                 end if
                 linePDFTemp = 0.
              end if

              size =  (grid(iG)%nCells+1)*nbins



              if (lgGas) then
                 call mpi_allreduce(grid(iG)%recPDF, recPDFTemp, size, mpi_real&
                      &, mpi_sum, mpi_comm_world, ierr)

                 if (lgDebug) then
                    size =  (grid(iG)%nCells+1)*nLines

                    call mpi_allreduce(grid(iG)%linePDF, linePDFTemp, size,&
                         & mpi_real, mpi_sum, mpi_comm_world, ierr)
                 end if
              end if

              if (lgDust .and. .not.lgGas) then

                 call mpi_allreduce(grid(iG)%dustPDF, dustPDFTemp, size, mpi_real&
                      &, mpi_sum, mpi_comm_world, ierr)

                 do i = 0, grid(iG)%nCells
                    do freq = 1, nbins
                       grid(iG)%dustPDF(i,freq) = dustPDFTemp(i,freq)
!if (nIterateMC>1 .and. ig == 181 .and. i==9) then
!print*,i, grid(iG)%dustPDF(i,freq)
!end if
                    end do
                 end do

                 if (allocated(dustPDFTemp)) deallocate(dustPDFTemp)
              end if

              call mpi_barrier(mpi_comm_world, ierr)

              size = (grid(iG)%nCells+1)

              if (lgGas) then
                 call mpi_allreduce(grid(iG)%totalLines, totalLinesTemp, size,&
                      & mpi_real, mpi_sum, mpi_comm_world, ierr)

                 do i = 1, grid(iG)%nx
                    do j = 1, yTop
                       do k = 1, grid(iG)%nz
                          if (grid(iG)%active(i,j,k)>0) then
                             grid(iG)%totalLines(grid(iG)%active(i,j,k)) = totalLinesTemp(grid(iG)%active(i,j,k))
                             do freq = 1, nbins
                                grid(iG)%recPDF(grid(iG)%active(i,j,k),freq) = recPDFTemp(grid(iG)%active(i,j,k) ,freq)
                             end do
                             if (lgDebug) then
                                do freq = 1, nLines
                                   grid(iG)%linePDF(grid(iG)%active(i,j,k),freq) = linePDFTemp(grid(iG)%active(i,j,k),freq)
                                end do
                             end if
                          end if
                       end do
                    end do
                 end do

                 call mpi_barrier(mpi_comm_world, ierr)

                 if ( allocated(totalLinesTemp) )&
                      & deallocate(totalLinesTemp)
                 if (lgDebug) then
                    if ( allocated(linePDFTemp) ) deallocate(linePDFTemp)
                 end if
                 if ( allocated(recPDFTemp) ) deallocate(recPDFTemp)
              end if

              ! check if min convergence was reached to carry out resonant line transfer
              if (lgDust .and. lgGas .and. convPercent>=resLinesTransfer .and. lgResLinesFirst &
                   &.and. (.not.nIterateMC==1)) then

                 if (iG==nGrids) lgResLinesFirst = .false.

                 size = (grid(iG)%nCells+1)*nResLines

                 call mpi_allreduce(grid(iG)%fEscapeResPhotons, fEscapeResPhotonsTemp, size, &
                      & mpi_real, mpi_sum, mpi_comm_world, ierr)

                 grid(iG)%fEscapeResPhotons(0:grid(iG)%nCells, 1:nResLines) = fEscapeResPhotonsTemp

                 size = grid(iG)%nCells+1

                 if (allocated(fEscapeResPhotonsTemp)) deallocate(fEscapeResPhotonsTemp)

                 call mpi_allreduce(grid(iG)%resLinePackets, resLinePacketsTemp, size, &
                      & mpi_real, mpi_sum, mpi_comm_world, ierr)

                 grid(iG)%resLinePackets(0:grid(iG)%nCells) = resLinePacketsTemp

                 if (allocated(resLinePacketsTemp)) deallocate(resLinePacketsTemp)

                 call mpi_barrier(mpi_comm_world, ierr)

              end if


           end do ! nGrids loop

!**********************************************************************************************

           do iG = 1, nGrids

              grid(iG)%Jste(0:grid(iG)%nCells, 1:nbins)    = 0.
              if (lgDebug) then
                 grid(iG)%Jdif(0:grid(iG)%nCells, 1:nbins) = 0.
                 grid(iG)%linePackets(0:grid(iG)%nCells, 1:nLines) = 0.
              end if
           end do


           totalEscaped = 0

           do iG = 1, nGrids
              grid(iG)%escapedPackets(0:grid(iG)%nCells, 0:nbins,0:nAngleBins) = 0.
           end do

           do iStar = 1, nStars
              if(taskid==0) print*, 'iterateMC: Starting transfer for ionising source ', iStar

              load = int(nPhotons(iStar)/numtasks)
              rest = mod(nPhotons(iStar), numtasks)


              if (lgPlaneIonization) then
                 planeIonDistribution = 0
              end if


              ! send the photons through and evaluate the MC
              ! estimators of Jste and Jdif at every grid cell
              if (taskid < rest) then
                 load = load+1
                 call energyPacketDriver(iStar,load, grid(1:nGrids))
              else
                 call energyPacketDriver(iStar,load, grid(1:nGrids))
              end if

              call mpi_barrier(mpi_comm_world, ierr)
           end do

           if (Ldiffuse>0.) then

              if (emittingGrid>0) then
                 ngridloc = emittingGrid
              else
                 ngridloc = ngrids
              end if

              do gpLoc = 1, nGridloc

                 if (gploc>1 .or. (.not. lg2D)) then
                    yTop = grid(gploc)%ny
                 else if (gploc ==1 .and. lg2D) then
                    yTop = 1
                 end if


                 if(taskid==0) print*, 'iterateMC: Starting transfer for diffuse source grid: ', gpLoc
                 do ii = 1,grid(gpLoc)%nx
                    do jj = 1,yTop
                       do kk = 1,grid(gpLoc)%nz

                          if (grid(gpLoc)%active(ii,jj,kk)>0) then

                             cellLoc(1)  = ii
                             cellLoc(2)  = jj
                             cellLoc(3)  = kk

                             load = int(nPhotonsDiffuseLoc/numtasks)
                             rest = mod(nPhotonsDiffuseLoc, numtasks)


                             ! send the photons through and evaluate the MC
                             ! estimators of Jste and Jdif at every grid cell
                             if (taskid < rest) then
                                load = load+1
                                call energyPacketDriver(iStar=0,n=load, grid=grid(1:nGrids), &
                                     & gpLoc=gpLoc, cellLoc=cellLoc)
                             else
                                call energyPacketDriver(iStar=0,n=load, grid=grid(1:nGrids), &
                                     & gpLoc=gpLoc, cellLoc=cellLoc)
                             end if

                             call mpi_barrier(mpi_comm_world, ierr)

                          end if

                       end do
                    end do
                 end do
              end do

           end if


           if (lgPlaneIonization) then

              allocate(planeIonDistributionTemp(grid(1)%nx, grid(1)%nz), stat = err)
              if (err /= 0) then
                 print*, "! iterateMC: can't allocate grid memory, planeIonDistributionTemp"
                 stop
              end if
              planeIonDistributionTemp = 0

              size = grid(1)%nx*grid(1)%nz

              call mpi_allreduce(planeIonDistribution, planeIonDistributionTemp, size, &
                   & mpi_integer, mpi_sum, mpi_comm_world, ierr)

              planeIonDistribution = planeIonDistributionTemp

              if (taskid ==0) then
                 open(file="output/planeIonDistribution.out",  action="write",unit=18, status="unknown")
                 do i = 1, grid(1)%nx
                    do k = 1, grid(1)%nz
                       write(18,*) i,k,planeIonDistribution(i,k)
                    end do
                 end do
                 close(18)
              end if

              if (allocated(planeIonDistributionTemp)) deallocate(planeIonDistributionTemp)

           end if

           do iG = 1, nGrids

              if (ig>1 .or. (.not. lg2D)) then
                 yTop = grid(iG)%ny
              else if (iG ==1 .and. lg2D) then
                 yTop = 1
              end if



              allocate(escapedPacketsTemp(0:grid(iG)%nCells, 0:nbins, 0:nAngleBins), stat = err)
              if (err /= 0) then
                 print*, "! iterateMC: can't allocate grid memory: escapedPacketsTemp", iG
                 stop
              end if

              escapedPacketsTemp  = 0.

              allocate(JSteTemp(0:grid(iG)%nCells, nbins), stat = err)
              if (err /= 0) then
                 print*, "! iterateMC: can't allocate array memory: JsteTemp ", iG
                 stop
              end if
              JSteTemp           = 0.

              if (lgDebug) then
                 allocate(JDifTemp(0:grid(iG)%nCells, nbins), stat = err)
                 if (err /= 0) then
                    print*, "! iterateMC: can't allocate array memory: JdifTemp "
                    stop
                 end if
                 allocate(linePacketsTemp(0:grid(iG)%nCells, nLines), stat = err)
                 if (err /= 0) then
                    print*, "! iterateMC: can't allocate array memory: linePacketsTemp "
                    stop
                 end if

                 JDifTemp           = 0.
                 linePacketsTemp    = 0.
              end if


              size =  (grid(iG)%nCells+1)*(1+nbins)*(nAngleBins+1)

              call mpi_allreduce(grid(iG)%escapedPackets, escapedPacketsTemp, size, &
                   & mpi_real, mpi_sum, mpi_comm_world, ierr)

              do i = 0, grid(iG)%nCells
                 do freq = 0, nbins
                    do imu = 0, nAngleBins
                       grid(iG)%escapedPackets(i, freq,imu) = escapedPacketsTemp(i, freq, imu)

                    end do
                 end do
              end do


              if ( allocated(escapedPacketsTemp) ) deallocate(escapedPacketsTemp)

!              if (taskid==0) call writeSED(grid)
!              if (taskid==0 .and. contCube(1)>0. .and. contCube(2)>0. ) &
!                   & call writeContCube(grid, contCube(1),contCube(2))

              size =  (grid(iG)%nCells+1)*nbins

              if (lgDebug) then
                 call mpi_allreduce(grid(iG)%JDif, JDifTemp, size, &
                      & mpi_real, mpi_sum, mpi_comm_world, ierr)
              end if

              call mpi_allreduce(grid(iG)%JSte, JSteTemp, size, &
                   & mpi_real, mpi_sum, mpi_comm_world, ierr)

              size =  (grid(iG)%nCells+1)*nLines

              if (lgDebug) then
                 call mpi_allreduce(grid(iG)%linePackets, linePacketsTemp, size, &
                      & mpi_real, mpi_sum, mpi_comm_world, ierr)
              end if


              do i = 1, grid(iG)%nx
                 do j = 1, yTop
                    do k = 1, grid(iG)%nz
                       if (grid(iG)%active(i,j,k)>0) then
                          do freq = 1, nbins
                             if (lgDebug) then
                                grid(iG)%JDif(grid(iG)%active(i,j,k),freq) = &
                                     & JDifTemp(grid(iG)%active(i,j,k),freq)
                             end if
                             grid(iG)%JSte(grid(iG)%active(i,j,k),freq) = &
                                  & JSteTemp(grid(iG)%active(i,j,k),freq)
                             if (lg2D) grid(iG)%JSte(grid(iG)%active(i,j,k),freq) = &
                                  & grid(iG)%JSte(grid(iG)%active(i,j,k),freq)/&
                                  & TwoDscaleJ(grid(iG)%active(i,j,k))

                          end do
                          if (lgDebug) then
                             do freq = 1, nLines
                                grid(iG)%linePackets(grid(iG)%active(i,j,k),freq) &
                                     & = linePacketsTemp(grid(iG)%active(i,j,k),freq)
                                if (lg2D) grid(iG)%JDif(grid(iG)%active(i,j,k),freq) = &
                                     & grid(iG)%JDif(grid(iG)%active(i,j,k),freq)/&
                                     & TwoDscaleJ(grid(iG)%active(i,j,k))

                             end do
                          end if
                       end if
                    end do
                 end do
              end do

              call mpi_barrier(mpi_comm_world, ierr)


              if (lgDebug) then
                 if ( allocated(linePacketsTemp) )    deallocate(linePacketsTemp)
                 if ( allocated(JDifTemp) )           deallocate(JDifTemp)
              end if
              if ( allocated(JSteTemp) )           deallocate(JSteTemp)


              do i = 0, grid(iG)%nCells
                 grid(iG)%Jste(i,:) = grid(iG)%Jste(i,:) * 1.e-9

                 if (lgDebug) grid(iG)%Jdif(i,:) = grid(iG)%Jdif(i,:) * 1.e-9
                 do ifreq = 1, nbins
                    totalEscaped = totalEscaped+&
                         & nint(grid(iG)%escapedPackets(i,ifreq, 0))
                    do ian = 0, nAngleBins
                       grid(iG)%escapedPackets(i,ifreq,ian) = grid(iG)%escapedPackets(i,ifreq,ian)
                    end do
                 end do

                 if (lgSymmetricXYZ) then
                    grid(iG)%Jste(i,:) = grid(iG)%Jste(i,:)/8.
                    grid(iG)%escapedPackets(i,:,:) = grid(iG)%escapedPackets(i,:,:)/8.
                    totalEscaped = nint(real(totalEscaped)/8.)
                    if (lgDebug) grid(iG)%Jdif(i,:) = grid(iG)%Jdif(i,:)/8.
                 end if

              end do

           end do


           if (lgDust .and. (nIterateMC>1 .or. .not.lgEquivalentTau)) then
              print*, "! iterateMC: [Interactions] : total -- abs -- sca: "
              print*, "! iterateMC: [Interactions] ", absInt+scaInt, " -- ", &
                   &  absInt*100./(absInt+scaInt),"% -- ", &
                   &  scaInt*100./(scaInt+absInt),"%"
           end if

           if (taskid==0) print*, " total Escaped Packets :",  totalEscaped

           if (taskid==0) call writeSED(grid)
           if (taskid==0 .and. contCube(1)>0. .and. contCube(2)>0. ) &
                & call writeContCube(grid, contCube(1),contCube(2))

!*******************************************************************

           do iG = 1, nGrids

              if (ig>1 .or. (.not.lg2D)) then
                 yTop = grid(iG)%ny
              else if (iG ==1 .and. lg2D) then
                 yTop = 1
              end if


              allocate(lgConvergedTemp(0:grid(iG)%nCells), stat &
                   &= err)
              if (err /= 0) then
                 print*, "! iterateMC: can't allocate array&
                      & memory:lgConvergedTemp"
                 stop
              end if

              allocate(lgBlackTemp(0:grid(iG)%nCells), stat &
                   &= err)
              if (err /= 0) then
                 print*, "! iterateMC: can't allocate array&
                      & memory:lgBlackTemp  "
                 stop
              end if

              if (lgGas) then

                 allocate(NeTemp(0:grid(iG)%nCells), stat = err)
                 if (err /= 0) then
                    print*, "! iterateMC: can't allocate array memory:&
                         & NeTemp ", iG
                    stop
                 end if
                 NeTemp           = 0.
                 allocate(TeTemp(0:grid(iG)%nCells), stat = err)
                 if (err /= 0) then
                    print*, "! iterateMC: can't allocate array memory:&
                         & TeTemp ", iG
                    stop
                 end if
                 TeTemp           = 0.
                 allocate(ionDenTemp(0:grid(iG)%nCells, &
                      & nElementsUsed, nStages), stat = err)
                 if (err /= 0) then
                    print*, "! iterateMC: can't allocate array memory: &
                         &ionDenTemp ", iG
                    stop
                 end if
                 ionDenTemp       = 0.

              end if

              if (lgDust) then
                 allocate(TdustTemp(0:nSpeciesMax,0:nSizes,0:grid(iG)%nCells), stat = err)
                 if (err /= 0) then
                    print*, "! iterateMC: can't allocate array memory:&
                         &TdustTemp ", iG
                    stop
                 end if
                 TdustTemp = 0.
              end if


              grid(iG)%lgConverged(0:grid(iG)%nCells) = 0
              grid(iG)%lgBlack(0:grid(iG)%nCells)     = 0
              grid(iG)%noHit       = 0.
              grid(iG)%noIonBal    = 0.
              grid(iG)%noTeBal     = 0.
              noHitPercent(iG)     = 0.
              noIonBalPercent(iG)  = 0.
              noTeBalPercent(iG)   = 0.
              lgConvergedTemp      = 0
              lgBlackTemp          = 0

               if (lgTraceHeating.and.taskid==0) then
                 open(file="output/thermalBalance.out",  action="write",unit=57, status="unknown", iostat=ios)
                 if (ios /= 0) then
                    print*, "! iterationMC: can't open file for writing, output/thermalBalance.out"
                    stop
                 end if
              end if

              if(taskid==0) print*, 'iterateMC: updateCell in', iG
              iCell = 0
              do i = 1, grid(iG)%nx
                 do j = 1, yTop
                    do k = 1, grid(iG)%nz
                       iCell = iCell+1
                       if (mod(iCell-(taskid+1),numtasks)==0) &
                            & call updateCell(grid(iG),i,j,k)

                    end do
                 end do
              end do
              if(taskid==0) print*, 'iterateMC: updateCell out', iG

              if (lgTraceHeating.and.taskid==0) then
                 close (57)
              end if



              size = 1

              call mpi_allreduce(grid(iG)%noHit, noHitPercent(iG), size, &
                   & mpi_real, mpi_sum,mpi_comm_world, ierr)

              if (lgGas) then
                 call mpi_allreduce(grid(iG)%noIonBal, noIonBalPercent(iG), size, &
                      & mpi_real, mpi_sum, mpi_comm_world, ierr)

                 call mpi_allreduce(grid(iG)%noTeBal, noTeBalPercent(iG), size, &
                      & mpi_real, mpi_sum, mpi_comm_world, ierr)
              end if

              size =  (grid(iG)%nCells+1)

              call mpi_allreduce(grid(iG)%lgConverged, lgConvergedTemp, size, &
                   & mpi_integer, mpi_sum, mpi_comm_world, ierr)
              call mpi_allreduce(grid(iG)%lgBlack, lgBlackTemp, size, &
                   & mpi_integer, mpi_sum, mpi_comm_world, ierr)


              if (lgGas) then
                 call mpi_allreduce(NeTemp, grid(iG)%Ne, size, &
                      & mpi_real, mpi_sum, mpi_comm_world, ierr)
                 call mpi_allreduce(TeTemp, grid(iG)%Te, size, &
                      & mpi_real, mpi_sum, mpi_comm_world, ierr)


                 size = (grid(iG)%nCells+1)*nElementsUsed*nStages

                 call mpi_allreduce(ionDenTemp, grid(iG)%ionDen, size, &
                      & mpi_real, mpi_sum, mpi_comm_world, ierr)

              end if

              if (lgDust) then
                 size =  (grid(iG)%nCells+1)*(nspeciesMax+1)*(nsizes+1)

                 call mpi_allreduce(TdustTemp,grid(iG)%Tdust,size, &
                      & mpi_real, mpi_sum, mpi_comm_world, ierr)

                 if (lgGas .and. convPercent>=resLinesTransfer .and. (.not.lgResLinesFirst) &
                      & .and. .not.(nIterateMC==1)) then

                    allocate(budgetTemp(0:nAbComponents,0:nResLines), stat=err)
                    if (err /= 0) then
                       print*, "! iterateMC: can't allocate array memory:&
                            &budgetTemp "
                       stop
                    end if
                    budgetTemp=0.

                    size = (nAbcomponents+1)*(nResLines+1)

                    call mpi_allreduce(dustHeatingBudget,budgetTemp,size, &
                         & mpi_real, mpi_sum, mpi_comm_world, ierr)

                    dustHeatingBudget = budgetTemp


                    deallocate(budgetTemp)

                 end if

              end if

              do i = 1, grid(iG)%nx
                 do j = 1, yTop
                    do k = 1, grid(iG)%nz
                       if (grid(iG)%active(i,j,k)>0) then
                          grid(iG)%lgConverged(grid(iG)%active(i,j,k)) = &
                               & lgConvergedTemp(grid(iG)%active(i,j,k))
                          grid(iG)%lgBlack(grid(iG)%active(i,j,k)) = &
                               & lgBlackTemp(grid(iG)%active(i,j,k))
                       end if
                    end do
                 end do
              end do


              call mpi_barrier(mpi_comm_world, ierr)

              if ( allocated(lgConvergedTemp) )  deallocate(lgConvergedTemp)
              if ( allocated(lgBlackTemp) )  deallocate(lgBlackTemp)
              if (lgGas) then
                 if ( allocated(NeTemp) )           deallocate(NeTemp)
                 if ( allocated(TeTemp) )           deallocate(TeTemp)
                 if ( allocated(ionDenTemp) )       deallocate(ionDenTemp)
              end if
              if (lgDust) then
                 if ( allocated(TdustTemp)) deallocate(TdustTemp)
              end if

           end do

!******************************************************************************

           if (nGrids>1) then
!              print*, " ! iterateMC: integratePathTau stuff still not implemented for multiple grids.... skipping"
           else
              call writeTauNu(grid)
           end if


           ! decide over final convergence of the model

           ! reinitialize convPercent and totCells
           totPercent  = 0.

           ! calculate the percentage of converged cells
           do iG = 1, nGrids

              totCells    = 0.
              convPercent = 0.

              if (ig>1 .or. (.not.lg2D)) then
                 yTop = grid(iG)%ny
              else if (iG ==1 .and. lg2D) then
                 yTop = 1
              end if

              do i = 1, grid(iG)%nx
                 do j = 1, yTop
                    do k = 1, grid(iG)%nz
                       if (grid(iG)%active(i,j,k)>0)  then
                          if (.not.lgEcho) then
                             convPercent = convPercent + grid(iG)%lgConverged(grid(iG)%active(i,j,k))
                             totCells    = totCells + 1.
                          else ! if light echo then only count echo cells!
                             if (grid(iG)%echoVol(i,j,k).gt.0.0) then
                                convPercent = convPercent + grid(iG)%lgConverged(grid(iG)%active(i,j,k))
                                totCells    = totCells + 1.
                             end if
                          endif
                       end if
                    end do
                 end do
              end do

              convPercent               = 100.*convPercent / totCells
              noHitPercent              = 100.*noHitPercent(iG) / totCells
              grid(iG)%noIonBal         = 100.*noIonBalPercent(iG) / totCells
              grid(iG)%noTeBal          = 100.*noTeBalPercent(iG) / totCells
              totPercent = totPercent + convPercent*grid(iG)%nCells/100.

              if (taskid == 0) then
                 if (nIterateMC == 1) then
                    close(21)
                    open(unit=21, status='unknown', position='rewind', file='output/summary.out', iostat=ios)
                    if (ios /= 0) then
                       print*, "! iterationMC: can't open file for writing, output/summary.out -1"
                       stop
                    end if
                 else
                    close(21)
                    open(unit=21, status='unknown', position='append', file='output/summary.out', iostat=ios)
                    if (ios /= 0) then
                       print*, "! iterationMC: can't open file for writing, output/summary.out -2"
                       stop
                    end if
                 end if

                 print*, "! iterateMC: [Summary] Iteration ",nIterateMC,'; ', &
                      &int(convPercent),"% converged cells in grid ", iG
                 print*, "! iterateMC: [Summary] Iteration ",nIterateMC,'; ', &
                      &int(noHitPercent(iG)),"% no hit cells in grid ", iG
                 print*, "! iterateMC: [Summary] Iteration ",nIterateMC,'; ', &
                      &int(grid(iG)%noIonBal),"% Ion balance not reached in grid ", iG
                 print*, "! iterateMC: [Summary] Iteration ",nIterateMC,'; ', &
                      &int(grid(iG)%noTeBal),"% Te balance not reached in grid", iG
                 write(21,*) "! iterateMC: [Summary] Iteration ",nIterateMC,'; ', &
                      &int(convPercent),"% converged cells in grid ", iG
                 write(21,*) "! iterateMC: [Summary] Iteration ",nIterateMC,'; ', &
                      &int(noHitPercent(iG)),"% no hit cells in grid ", iG
                 write(21,*) "! iterateMC: [Summary] Iteration ",nIterateMC,'; ', &
                      &int(grid(iG)%noIonBal),"% Ion balance not reached in grid ", iG
                 write(21,*) "! iterateMC: [Summary] Iteration ",nIterateMC,'; ', &
                      &int(grid(iG)%noTeBal),"% Te balance not reached in grid", iG
                 if (lgGas .and. convPercent>=resLinesTransfer .and. .not.lgResLinesFirst .and. &
                      & (.not. nIterateMC==1) ) then
                    write(21,*) "! iterateMC: [Summary] Iteration ",nIterateMC,'; '
                    write(21,*) "Dust Budgets: "
                    do icomp = 0, nAbComponents
                       write(21,*) " Component ", icomp
                       totheatdust = 0.
                       do icontrib =0, nResLines
                          totheatdust = totheatdust+dustHeatingBudget(icomp,icontrib)
                       end do
                       do icontrib =0, nResLines
                          write(21,*) " Contribution", icontrib, dustHeatingBudget(icomp,icontrib)/&
                               & totheatdust
                       end do
                    end do
                 end if
              end if

           end do

           if (lgDust .and. convPercent>=resLinesTransfer .and. lgGas .and. &
                & (.not. nIterateMC==1) .and. (.not.lgResLinesFirst)) dustHeatingBudget = 0.

           totCells = 0
           do iG =1,nGrids
              totCells = totCells+grid(iG)%nCells
           end do

           totPercent      = 100.*totPercent / totCells

           if (taskid==0) then
              print*, "! iterateMC: [Summary] Iteration ",nIterateMC,'; Total:  ', &
                   &totPercent,"% converged cells over all grids"
              print*, "! iterateMC: [Summary] Iteration ",nIterateMC,'; ', &
                   &nPhotons, " energy packets used"
              write(21, *) "! iterateMC: [Summary] Iteration ",nIterateMC,'; Total:  ', &
                   &totPercent,"% converged cells over all grids"
              write(21,*) "! iterateMC: [Summary] Iteration ",nIterateMC,'; ', &
                   &nPhotons, " energy packets used"
              call date_and_time(TIME=time)
              write(21,*) "! iterateMC: [Summary] Iteration ",nIterateMC,"; finished at ",time(1:2),":",time(3:4),":",time(5:6)
              write(21,*) ""
              close(21)

              ! write grid to files for warm start

              if ( totPercent >= convWriteGrid) then

                 ! write old grid to disk
                 call writeGrid(grid(1:nGrids))

              end if

           end if

           nPhotonsTot = nPhotons(1)
           do iStar=1, nStars
              nPhotonsTot = nPhotonsTot+nPhotons(iStar)
           end do

           if (nIterateMC > 1 .and. totPercent < 95. .and. lgAutoPackets &
                & .and. nPhotonsTot < maxPhotons .and. totPercentOld > 0.) then

              if ( (totPercent-totPercentOld)/totPercentOld <= convIncPercent ) then
                 nPhotons = nint(nPhotons*nPhotIncrease)
                 deltaE   = deltaE/nPhotIncrease

                 if (taskid==0) &
                      & print*, "! iterateMC: [talk] Total number of energy packets &
                      &increased to ", nPhotons

                 if (Ldiffuse>0.) then
                    nPhotonsDiffuseLoc = nint(nPhotonsDiffuseLoc*nPhotIncrease)
                    if (taskid==0) &
                         & print*, "! iterateMC: [talk] number of diffuse energy packets &
                         &per cell increased to ", nPhotonsDiffuseLoc
                 end if

              end if
           end if


!           if (Ldiffuse>0. .and. nIterateMC > 1 .and. totPercent < 95. .and. lgAutoPackets &
!                &  .and. totPercentOld > 0.) then
!
!              if ( (totPercent-totPercentOld)/totPercentOld <= convIncPercent ) then
!                 nPhotonsDiffuseLoc = nPhotonsDiffuseLoc*nPhotIncrease
!
!                 if (taskid==0) &
!                      & print*, "! iterateMC: [talk] number of diffuse energy packets &
!                      &per cell increased to ", nPhotonsDiffuseLoc
!              end if
!
!           end if


           totPercentOld = totPercent

           if (taskid==0) then
              print *,"! iterateMC: [Summary] Iteration ",nIterateMC,"; finished at ",time(1:2),":",time(3:4),":",time(5:6)
           endif

           if ( totPercent >= minConvergence ) then

              if (taskid==0) then
                 print*, "! iterateMC: [talk] convergence reached after ", &
                      &                           nIterateMC, " iterations. & Finishing up ... "

                 ! output results at this itearation stage (every 3 iterations)

                 call writeGrid(grid(1:nGrids))
                 if (lgGas) call outputGas(grid(1:nGrids))
              end if

              call mpi_barrier(mpi_comm_world, ierr)

           else if (nIterateMC >= maxIterateMC) then

              if (taskid==0) then

                 print*, " ! iterateMC: maximum number of iterations reached. Finishing up ... ",&
                      & maxIterateMC

                 call writeGrid(grid(1:nGrids))
                 if (lgGas) call outputGas(grid(1:nGrids))
              end if

              call mpi_barrier(mpi_comm_world, ierr)

           else

              if (lgOutput .and. taskid == 0 ) then
                 ! output results at this itearation stage (every ? iterations)
                 if ( mod(nIterateMC, 1) == 0 ) then
                    if (lgGas) call outputGas(grid(1:nGrids))
                 end if
              end if

              call mpi_barrier(mpi_comm_world, ierr)

              ! step up MC iterations counter
              nIterateMC = nIterateMC + 1

              if (lgTalk) print*, "! iterateMC: [talk] now starting iteration #",&
                   &                            nIterateMC

              ! start the next iteration

              call iterateMC()
              return

           end if

         end subroutine iterateMC

       end subroutine MCIterationDriver

 end module iteration_mod

! 
! this program greates a grain size distribution file for use 
! by the MOCASSIN code
! it creates nsizes equally spaced bins in log10 space from 
! amin and amax
! 
! B. Ercolano 23/09/04
program makeGrainSizeDistribution
  implicit none
  
  character(len=50) :: outfile
  integer :: nsizes, i
  real    :: slope, amin, amax, astep
  
  print*, 'how many bins?'
  read*, nsizes
  print*, 'what is the exponential giving the slope of the distribution? (p)'
  read*, slope
  print*, 'what are amin and amax in microns?'
  read*, amin, amax
  print*, 'what should the output file be called?'
  read*, outfile

  astep = (log10(amax)-log10(amin))/real(nsizes-1)

  open(unit=10,file=outfile,status='unknown')
  
  write(10,*) nsizes, ' sizes ' 
  do i=1,nsizes
     write(10,*) i, 10.**(log10(amin)+(i-1)*astep), (10.**(log10(amin)+(i-1)*astep))**(-slope)
  end do
  
  write(10,*)
  write(10,*)
  write(10,*) 'slope (p): ', slope

  
end program makeGrainSizeDistribution
  
  

  
  

! Copyright (C) 2005 Barbara Ercolano
!
! Version 2.02
module grid_mod

    use common_mod             ! common variablesesca
    use composition_mod        ! cemical abundances
    use constants_mod          ! physical constants
    use continuum_mod          ! ionising field
    use elements_mod           ! hydrogen data
    use interpolation_mod      ! interpolation maths
    use pathIntegration_mod    ! path integration
    use set_input_mod          ! model inputs
    use vector_mod             ! vectyor maths
    use xSec_mod               ! x Section data


    contains

    ! initCartesianGrid initializes a cartesian grid
    subroutine initCartesianGrid(grid, nx, ny, nz)
        implicit none

        integer, intent(in) :: nx, ny, nz           ! x, y and z arrays sizes

        type(grid_type),intent(inout) :: grid       ! grid


        ! local variables

        integer :: err, ios                         ! allocation error status
        integer :: i, iCount, nuCount, elem, ion    ! counters
        integer :: g0,g1
        integer :: nEdges
        integer :: nElec
        integer :: outshell

        logical, save :: lgFirst=.true.

        integer, parameter :: maxLim = 10000
        integer, parameter :: nSeries = 17

        real, dimension(17)  :: seriesEdge

        real                 :: nuMinArray, nuMaxArray

        real, allocatable        :: nuTemp(:)

        print*, "in initCartesianGrid"

        nullUnitVector%x = 1.
        nullUnitVector%y = 0.
        nullUnitVector%z = 0.


        elemLabel = (/'*H','He','Li','Be','*B','*C','*N','*O','*F','Ne','Na','Mg',&
             &'Al','Si','*P','*S','Cl','Ar','*K','Ca','Sc','Ti','*V','Cr','Mn','Fe',&
             &'Co','Ni','Cu','Zn'/)

       ! set up atomic weight array
       aWeight = (/1.0080, 4.0026, 6.941, 9.0122, 10.811, 12.0111, 14.0067, 15.9994, &
            & 18.9984, 20.179, 22.9898, 24.305, 26.9815, 28.086, 30.9738, 32.06, 35.453, &
            & 39.948, 39.102, 40.08, 44.956, 47.90, 50.9414, 51.996, 54.9380, 55.847, 58.9332, &
            & 58.71, 63.546, 65.37 /)

        ! only calculate the frequency/energy grid and assign the abundances if this is the
        ! first time that
        ! this procedure is called - the grid will be constant throughout the execution

        allocate(grid%elemAbun(nAbComponents, nElements), stat = err)
        if (err /= 0) then
           print*, "! initCartesianGrid: can't allocate grid memory"
            stop
        end if
        grid%elemAbun=0.

        if (lgFirst) then

           if (lgGas) then
              ! set chemical abundances according to the grid%composition
              ! variable  given
              allocate(forbiddenLines(nElements,nstages, nForLevels,nForLevels), stat=err)
              if (err /= 0) then
                 print*, "! emissionDriver: can't allocate array memory"
                 stop
              end if
              allocate(forbiddenLinesLarge(nForLevelsLarge,nForLevelsLarge), stat=err)
              if (err /= 0) then
                 print*, "! emissionDriver: can't allocate array memory"
                 stop
              end if

              forbiddenLines(:,:,:,:) = 0.
              forbiddenLinesLarge(:,:) = 0.

              call setComposition(grid)

           else

              lgElementOn=.false.
              elementXref=0
              nElementsUsed=0

           end if

            ! calculate the frequency grid

            ! allocate just enough space for the energy array
            allocate(nuArray(1:nbins), stat = err)
            if (err /= 0) then
                print*, "! grid: can't allocate grid memory"
                stop
            end if

            ! allocate just enough space for the widFlx array
            allocate(widFlx(1:nbins), stat = err)
            if (err /= 0) then
                print*, "! grid: can't allocate grid memory"
                stop
            end if

            allocate(continuum(1:nbins), stat = err)
            if (err /= 0) then
                print*, "! grid: can't allocate continuum emission array memory"
                stop
            end if

            if (lgGas) then

               call phInit() ! set up photoionization data

               seriesEdge = (/0.0069, 0.0083, 0.01, 0.0123, 0.0156, 0.0204, 0.0278, 0.04, &
                    & 0.0625, 0.11117, &
                    & 0.11610, 0.12248, 0.13732, 0.24763, 0.24994, 0.26630, 0.29189/)

               nEdges = 1

               ! find the ionization edges included in our frequency range
               do elem = 1, nElements  ! begin element loop
                  do ion = 1, min(elem, nStages-1) ! begin ion loop
                     if(.not.lgElementOn(elem)) exit

                     if (elem > 2) then

                        ! find the number of electrons in this ion
                        nElec = elem - ion + 1

                        ! find the outer shell number and statistical weights
                        call getOuterShell(elem, nELec, outShell, g0, g1)

                        ! get threshold energy
                        ionEdge(nEdges) = ph1(1,elem, nElec, outShell)/RydtoEv
                     else if (elem == 1) then ! HI

                        ionEdge(nEdges) = 0.999434

                     else if ( (elem == 2) .and. (ion == 1) ) then ! HeI

                        ionEdge(nEdges) = 1.80804

                     else if ( (elem == 2) .and. (ion == 2) ) then ! HeII

                        ionEdge(nEdges) = 4.

                     end if

                     if (ionEdge(nEdges) <= nuMax) nEdges = nEdges + 1


                  end do
               end do

               nEdges = nEdges -1

               call sortUp(ionEdge(1:nEdges))

            end if


            if ( (lgDust) .and. (.not.lgGas) ) then
               close(72)
               open (unit= 72,  action="read", file=PREFIX//"/share/mocassin/dustData/nuDustRyd.dat", status = "old", position = "rewind", &
                    & iostat = ios)
               if (ios /= 0) then
                  print*, "! initCartesianGrid: can't open dust nu grid file - ",PREFIX,"/share/mocassin/dustData/nuDustRyd.dat"
                  stop
               end if

               do i = 1, 10000000
                  if (i<=nbins+1) then
                     read(unit=72,fmt=*,iostat=ios) nuArray(i)
                     if (nuArray(i)>nuMax) exit ! nuMax reached
                     if (ios < 0) exit ! end of file reached
                  else
                     print*, "! initCartesianGrid: nbins is smaller that the number of &
                          & frequency points in dustData/nuDustRyd.dat file - enlarge nbins"
                     stop
                  end if
               end do

               nbins = i-1
               print*, "! initCartesianGrid: nbins reset to ", nbins

               close(72)

               allocate (nuTemp(1:nbins))
               nuTemp = nuArray(1:nbins)
               if (allocated(nuArray)) deallocate(nuArray)
               allocate (nuArray(1:nbins))
               nuArray = nuTemp
               if (allocated(nuTemp)) deallocate(nuTemp)

            else if (lgGas .and. (.not.lgDust)) then

               ! first count how many edge, thresholds etc
               if (nuMin<radio4p9GHz) then
                  nuArray(1)     = radio4p9GHz
                  nuCount = 2
               else
                  nuCount = 1
               end if

               nuMinArray = nuMin
               nuMaxArray = nuMax
               ! H series edges
               do i = 1, nSeries
                  nuArray(nuCount) = seriesEdge(i)
                  nuArray(nuCount+1) = seriesEdge(i)- 0.0003
                  nuArray(nuCount+2) = seriesEdge(i)+ 0.0003
                  if ( nuArray(nuCount) < nuMinArray ) nuMinArray= nuArray(nuCount)- 0.0006
                  if ( nuArray(nuCount) > nuMaxArray ) then
                     nuMaxArray= nuArray(nuCount)
                     print*, 'initCartesianGrid [warning]: H series - nuMaxArray increased to ', nuMaxArray, i
                  end if
                  nuCount = nuCount+3

               end do
               ! IP Thresholds
               do i = 1, nEdges
                  if (ionEdge(i) < nuMaxArray) then
                     nuArray(nuCount) = ionEdge(i)
                     nuArray(nuCount+1) = ionEdge(i)- 0.0003
                     nuArray(nuCount+2) = ionEdge(i)+ 0.0003
                     if ( nuArray(nuCount) < nuMinArray ) nuMinArray= nuArray(nuCount)- 0.0006
                     nuCount = nuCount+3
                  end if
               end do

               ! build the log energy mesh
               iCount = nbins-nuCount+1
               nuStepSize = (log10(nuMaxArray)-log10(nuMinArray))/(iCount-1)
               nuArray(nuCount) = nuMinArray
               do i = nuCount+1, nbins
                  nuArray(i) = 10.**(log10(nuArray(i-1))+nuStepSize)
               enddo

               ! now sort in ascending order
               call sortUp(nuArray)

            else if (lgDust .and. lgGas) then

               ! first count how many edge, thresholds etc
               if (nuMin<radio4p9GHz) then
                  nuArray(1)     = radio4p9GHz
                  nuCount = 2
               else
                  nuCount = 1
               end if

               nuMinArray = nuMin
               nuMaxArray = nuMax
               ! H series edges
               do i = 1, nSeries
                  nuArray(nuCount) = seriesEdge(i)
                  nuArray(nuCount+1) = seriesEdge(i)- 0.0003
                  nuArray(nuCount+2) = seriesEdge(i)+ 0.0003
                  if ( nuArray(nuCount) < nuMinArray ) nuMinArray= nuArray(nuCount)- 0.0006
                  if ( nuArray(nuCount) > nuMaxArray ) then
                     nuMaxArray= nuArray(nuCount)
                     print*, 'initCartesianGrid [warning]: H series - nuMaxArray increased to ', nuMaxArray, i
                  end if
                  nuCount = nuCount+3

               end do
               ! IP Thresholds
               do i = 1, nEdges
                  if (ionEdge(i) < nuMaxArray) then
                     nuArray(nuCount) = ionEdge(i)
                     nuArray(nuCount+1) = ionEdge(i)- 0.0003
                     nuArray(nuCount+2) = ionEdge(i)+ 0.0003
                     if ( nuArray(nuCount) < nuMinArray ) nuMinArray= nuArray(nuCount)- 0.0006
                     nuCount = nuCount+3
                  end if
               end do

               ! dust data points
               close(72)
               open (unit= 72,  action="read", file=PREFIX//"/share/mocassin/dustData/nuDustRyd.dat", status = "old", position = "rewind", &
                    & iostat = ios)
               if (ios /= 0) then
                  print*, "! initCartesianGrid: can't open dust nu grid file - ",PREFIX,"/share/mocassin/nuDustGrid.dat"
                  stop
               end if

               do i = 1, 10000000
                  if (i<=nbins) then
                     read(unit=72,fmt=*,iostat=ios) nuArray(nuCount)
                     nuCount = nuCount+1
                     if (ios < 0) exit ! end of file reached
                     if (nuArray(i)>= seriesEdge(1)) exit
                  else
                     print*, "! initCartesianGrid: nbins is smaller that the number of &
                          & frequency points in nuDustGrid.dat file - enlarge nbins"
                     stop
                  end if
               end do

               close(72)

               ! build the log energy mesh
               iCount = nbins-nuCount+1
               nuStepSize = (log10(nuMaxArray)-log10(nuMinArray))/(iCount-1)
               nuArray(nuCount) = nuMinArray
               do i = nuCount+1, nbins
                  nuArray(i) = 10.**(log10(nuArray(i-1))+nuStepSize)
               enddo

               ! now sort in ascending order
               call sortUp(nuArray)

            end if

            widFlx(1) = nuArray(2)-nuArray(1)
            do i = 2, nbins-1
               widFlx(i) = (nuArray(i+1)-nuArray(i-1))/2.
               !print*, i, nuArray(i), widFlx(i)
            end do
            widFlx(nbins) =  nuArray(nbins)-nuArray(nbins-1)

             ! set the 4.9 GHz pointer
            if (nuArray(1) <= radio4p9GHz) then
               call locate(nuArray,radio4p9GHz,radio4p9GHzP)
               if (radio4p9GHz > (nuArray(radio4p9GHzP)+nuArray(radio4p9GHzP+1))/2.) &
                    & radio4p9GHzP =radio4p9GHzP+1
            end if

            if (widFlx(1)<=0. .or. widFlx(nbins)<=0. ) then
               print*, " ! initCartesianGrid: null or negative frequency bin [1, nbins]", widFlx(1), widFlx(nbins)
               stop
            end if

            lgFirst = .false.

            ! initialize the continuum gamma coeffs
            call initGammaCont()

         end if

        ! allocate active cells pointers
        allocate(grid%active(1:nx, 1:ny, 1:nz), stat = err)
        if (err /= 0) then
            print*, "Can't allocate grid memory, active"
            stop
        end if

        ! allocate active cells volume
!        if (lgEcho) then
           allocate(grid%echoVol(1:nx, 1:ny, 1:nz), stat = err)
           if (err /= 0) then
              print*, "Can't allocate grid memory, echoVol"
              stop
           end if
!        endif

        ! allocate axes

        allocate(grid%xAxis(1:nx), stat = err)
        if (err /= 0) then
            print*, "Can't allocate grid memory, xAxis"
            stop
        end if

        allocate(grid%yAxis(1:ny), stat = err)
        if (err /= 0) then
            print*, "Can't allocate grid memory, yAxis"
            stop
        end if

        allocate(grid%zAxis(1:nz), stat = err)
        if (err /= 0) then
            print*, "Can't allocate grid memory, zAxis"
            stop
        end if

        if (lgGas) then
           allocate(grid%abFileIndex(1:nx,1:ny,1:nz), stat = err)
           if (err /= 0) then
              print*, "Can't allocate grid memory, abFileIndex "
              stop
           end if

           grid%abFileIndex = 1
        end if

        grid%nx = nx
        grid%ny = ny
        grid%nz = nz

        ! initialize the arrays with zeros
        grid%active = 0
        grid%xAxis = 0.
        grid%yAxis = 0.
        grid%zAxis = 0.

        !new
         dTheta = Pi/totAngleBinsTheta
!         dTheta = Pi/totAngleBins

         do i = 1, nAngleBins
            if (viewPointPhi(i)<0.) then
               totAngleBinsPhi=1
               print*, '! initCartesianGrid : [warning] phi-dependance in viewing angle turned off'
               viewPointPhi=-1.
               exit
            end if
         end do

         ! new
         dPhi = twoPi/totAngleBinsPhi

!         allocate(viewPointP(0:totAngleBins), stat = err)
!         if (err /= 0) then
!            print*, "Can't allocate grid memory, viewAngleP "
!            stop
!         end if


         if (allocated(viewPointPTheta)) deallocate(viewPointPTheta) ! todo:would be better to work out when this is no longer needed and deallocate there
         allocate(viewPointPTheta(0:totAngleBinsTheta), stat = err)
         if (err /= 0) then
            print*, "! initCartesianGrid: Can't allocate grid memory, viewAnglePTheta "
            stop
         end if

         if (allocated(viewPointPPhi)) deallocate(viewPointPPhi) ! todo:would be better to work out when this is no longer needed and deallocate here
         allocate(viewPointPPhi(0:totAngleBinsPhi), stat = err)
         if (err /= 0) then
            print*, "! initCartesianGrid: Can't allocate grid memory, viewAnglePPhi "
            stop
         end if

         viewPointPtheta = 0
         viewPointPphi = 0

!         ii = 1
!         do i = 1, nAngleBins
!            viewPointP(int(viewPoint(i)/dTheta)+1) = ii
!            ii = ii+1
!         end do

         do i = 1, nAngleBins
            if (viewPointTheta(i) > Pi/2. .and. lgSymmetricXYZ) then
               print*, '! initCartesianGrid: the inclination theta required is not available for symmetricXYZ models (theta > Pi/2)'
               stop
            end if
            viewPointPtheta(int(viewPointTheta(i)/dTheta)+1) = i
            viewPointPphi(int(viewPointPhi(i)/dPhi)+1) = i
         end do

!         print*, 'viewpointptheta'
!         print*, viewpointptheta
!         print*, ' '
!         print*, 'viewpointpphi'
!         print*, viewpointpphi

         print*, 'dTheta : ', dTheta
         print*, 'dPhi : ', dPhi

         print*, "out initCartesianGrid"

    end subroutine initCartesianGrid


    ! fillGrid sets up a 3d grid ith a bipolar geometry. this
    ! procedure is only implemented for a cartesian geometry at present.
    !
    ! Version 1.0 and later: this subroutine now sets up any type of grids
    subroutine fillGrid(grid)
        implicit none

        include 'mpif.h'

        type(grid_type), dimension(:),intent(inout) :: grid

        ! local variables
        integer :: i, j, k, elem, iG, jG                  ! counters
        integer :: err                                    ! memory allocation status
        integer :: ngridsloc
        integer, parameter :: max_points = 10000          ! safety limit

!        character(len=30)            :: in_file

        ! pointer to the array of 2nd derivatives of the interpolating function
        ! calculated by spline for use into splint

        integer :: totCells
        integer :: totCellsLoc=0

        integer, parameter :: maxLim = 10000
        integer, parameter :: nSeries = 17

        real :: massFac,dV
        integer                        :: ix,iy,iz     ! counters
        integer                        :: nspec, ai    ! counters
        integer                        :: nsp          ! pointer

        print*, "in fillGrid"

        if (lg1D) lgSymmetricXYZ = .false.

        if (lgPlaneIonization) then
           allocate(planeIonDistribution(grid(1)%nx,grid(1)%nz), stat = err)
           if (err /= 0) then
              print*, "! fillGrid: can't allocate dl memory"
              stop
           end if
           planeIonDistribution = 0
        end if

        if (.not.lgDfile) then

           if (lgSymmetricXYZ ) then

              ! create the grid axes, forcing it to have grid points at the
              ! centre
              do i = 1, grid(1)%nx
                 grid(1)%xAxis(i) = real(i-1)/real(grid(1)%nx-1)
                 grid(1)%xAxis(i) = grid(1)%xAxis(i) * Rnx
              end do

              do i = 1, grid(1)%ny
                 grid(1)%yAxis(i) = real(i-1)/real(grid(1)%ny-1)
                 grid(1)%yAxis(i) = grid(1)%yAxis(i) * Rny
              end do

              do i = 1, grid(1)%nz
                 grid(1)%zAxis(i) = real(i-1)/real(grid(1)%nz-1)
                 grid(1)%zAxis(i) = grid(1)%zAxis(i) * Rnz
              end do

           else if (lg1D) then

              do i = 1, grid(1)%nx
                 grid(1)%xAxis(i) = real(i-1)/real(grid(1)%nx-1)
                 grid(1)%xAxis(i) = grid(1)%xAxis(i) * Rnx
              end do

              grid(1)%yAxis = 0.
              grid(1)%zAxis = 0.

           else ! not lgSymmetricXYZ

              if (mod(grid(1)%nx,2) == 0.) then
                 print*, "! fillGrid: the automatic grid option &
                      & requires odd integer nx if not symmetric"
                 stop
              end if

              if (mod(grid(1)%ny,2) == 0.) then
                 print*, "! fillGrid: the automatic grid option &
                      & requires odd integer ny if not symmetric"
                 stop
              end if

              if (mod(grid(1)%nz,2) == 0.) then
                 print*, "! fillGrid: the automatic grid option &
                      & requires odd integer nz if not symmetric"
                 stop
              end if

              ! create the grid axes, forcing it to have grid points at the
              ! centre
              do i = 1, grid(1)%nx
                 grid(1)%xAxis(i) = 2.*real(i-1)/real(grid(1)%nx-1) - 1.
                 grid(1)%xAxis(i) = grid(1)%xAxis(i) * Rnx
              end do


              do i = 1, grid(1)%ny
                 grid(1)%yAxis(i) = 2.*real(i-1)/real(grid(1)%ny-1) - 1.
                 grid(1)%yAxis(i) = grid(1)%yAxis(i) * Rny
              end do

              do i = 1, grid(1)%nz
                 grid(1)%zAxis(i) = 2.*real(i-1)/real(grid(1)%nz-1) - 1.
                grid(1)%zAxis(i) = grid(1)%zAxis(i) * Rnz
              end do

           end if

        end if

        if (lg1D) lgSymmetricXYZ = .true.



        if (lgNeutral) then

           ! set up density distribution and initial grid properties

           call setMotherGrid(grid(1))

!           if (taskid == 0) then
!              print*, "Mother Grid:"
!              print*, "xAxis: ", grid(1)%xAxis
!              print*, "yAxis: ", grid(1)%yAxis
!              print*, "zAxis: ", grid(1)%zAxis
!           end if

           ! set the subGrids
           if (nGrids>1) call setSubGrids(grid(1:nGrids))

!BEKS 2011: scale the gas mass here to gasMass keyword
           if (lgGas .and. lginputGasMass) then
              totalGasMass = 0.
              do iG = 1, nGrids
                 do ix = 1, grid(iG)%nx
                    do iy = 1, grid(iG)%ny
                       do iz = 1, grid(iG)%nz
                          if (grid(iG)%active(ix,iy,iz)>0) then
                             dV = getVolume(grid(iG),ix,iy,iz)
                             do elem = 1, nElements
                                totalGasMass = totalGasMass + &
                                     & grid(iG)%Hden(grid(iG)%active(ix,iy,iz))*dV*&
                                     & grid(iG)%elemAbun(grid(iG)%abFileIndex(ix,iy,iz),elem)*&
                                     & aWeight(elem)*amu
                             end do
                          endif
                       enddo
                    enddo
                 enddo
              enddo
              massFac = inputGasMass / totalGasMass
              print*,'! fillGrid: Scaling all gas densities by ',massFac
              if (lgDust .and. (lgMdMg .or. lgMdMh)) &
                   & print*,'! fillGrid: Scaling all dust densities by ',massFac
              do iG = 1, nGrids
                 do ix = 1, grid(iG)%nx
                    do iy = 1, grid(iG)%ny
                       do iz = 1, grid(iG)%nz
                          if (grid(iG)%active(ix,iy,iz)>0) then
                             grid(iG)%Hden(grid(iG)%active(ix,iy,iz)) = &
                                  & grid(iG)%Hden(grid(iG)%active(ix,iy,iz)) *  massFac
                             grid(iG)%Ne(grid(iG)%active(ix,iy,iz)) =  &
                                  & grid(iG)%Hden(grid(iG)%active(ix,iy,iz))
                             if (lgDust .and. (lgMdMg .or. lgMdMh)) &
                                  &  grid(iG)%Ndust(grid(iG)%active(ix,iy,iz)) = &
                                  & grid(iG)%Ndust(grid(iG)%active(ix,iy,iz)) *  massFac
                          endif
                       enddo
                    enddo
                 enddo
              enddo
              totalGasMass = inputGasMass
              totalDustMass = totalDustMass * massFac
           endif

!BEKS 2010: scale the dust mass here using dustMass keyword.
           if (lgDust .and. lginputDustMass) then
              if (lgGas .and. (lgMdMh .or. lgMdMg)) then
                 print*,"grid_mod: you cannot specify dustMass if you are using"
                 print*,"gas and specify the gas-to-dust ratio"
                 stop
              endif
              totalDustMass = 0.
              do iG = 1, nGrids
                 do ix = 1, grid(iG)%nx
                    do iy = 1, grid(iG)%ny
                       do iz = 1, grid(iG)%nz
                          if (grid(iG)%active(ix,iy,iz)>0) then
                             if (lgMultiDustChemistry) then
                                nsp = grid(iG)%dustAbunIndex(grid(iG)%active(ix,iy,iz))
                             else
                                nsp = 1
                             end if
                             dV = getVolume(grid(iG),ix,iy,iz)
                             do ai = 1, nsizes
                                do nspec = 1, nspeciesPart(nsp)
                                   totalDustMass = totalDustMass + &
                           & (1.3333*Pi*((grainRadius(ai)*1.e-4)**3)*&
                           & rho(dustComPoint(nsp)-1+nspec)*&
                           & grainWeight(ai)*grainAbun(nsp,nspec)&
                           & *grid(iG)%Ndust(grid(iG)%active(ix,iy,iz))*dV)
                                end do
                             end do
                          endif
                       enddo
                    enddo
                 enddo
              enddo
              massFac = inputDustMass / totalDustMass
              print*,'fillGrid: Scaling all dust densities by ',massFac
              do iG = 1, nGrids
                 do ix = 1, grid(iG)%nx
                    do iy = 1, grid(iG)%ny
                       do iz = 1, grid(iG)%nz
                          if (grid(iG)%active(ix,iy,iz)>0) then
                             grid(iG)%Ndust(grid(iG)%active(ix,iy,iz)) = &
 & grid(iG)%Ndust(grid(iG)%active(ix,iy,iz)) *  massFac

                          endif
                       enddo
                    enddo
                 enddo
              enddo
              totalDustMass = inputDustMass
           endif
!
           totCells = 0
           totcellsloc=0
           if (emittingGrid>0) then
              nGridsloc = emittingGrid
           else
              nGridsloc = ngrids
           end if

           do i = 1, nGrids
              totCells = totCells+grid(i)%nCells
           end do
           do i = 1, nGridsloc
              totCellsloc = totCellsloc+grid(i)%nCells
           end do

           if (taskid==0) print*, '! fillGrid: total number of active cells over all grids: ', totCells

           if (lgGas) then
              if (lgSymmetricXYZ) totalGasMass=totalGasMass*8.
              print*, 'fillGrid: Actual total gas mass [1.e45 g]: ', totalGasMass
              print*, 'fillGrid: Actual total gas mass [Msol]: ', totalGasMass*5.028e11
           end if
           if (lgDust) then
              if (lgSymmetricXYZ) totalDustMass=totalDustMass*8.
              print*, 'fillGrid: Actual total dust mass [1.e45 g]: ', totalDustMass
              print*, 'fillGrid: Actual total dust mass [Msol]: ', totalDustMass*5.028e11
           end if

           if (nPhotonsDiffuse > 0 .and. nPhotonsDiffuse < totCellsloc) then
              print*, '! fillGrid: total number of active cells is larger than the &
                   &total number of packets to be used in the simulation please enlarge nPhotonsDiffuse,&
                   &[nPhotonsDiffuse, totcellsloc]', nPhotonsDiffuse, totcellsloc
              stop
           end if

           if (totCellsloc<=0) then
              print*, '! setSubGrids: totCellsloc <=0'
              stop
           end if

           nPhotonsDiffuseLoc = nPhotonsDiffuse/totCellsloc
           if (taskid==0) print*, '! setSubGrids: number of diffuse packets per active cell: ', nPhotonsDiffuseLoc

        else

           print*, '! fillGrid: only neutral option available &
                & in this version. plese re-run with neutral keyword'
           stop
        end if

        ! print out Grid
!        if (taskid == 0) then
!           print*, "Mother Grid:"
!           print*, "xAxis: ", grid(1)%xAxis
!           print*, "yAxis: ", grid(1)%yAxis
!           print*, "zAxis: ", grid(1)%zAxis
!           do iG = 2, nGrids
!              print*, "Grid : ", iG
!              print*, "xAxis: ", grid(iG)%xAxis
!              print*, "yAxis: ", grid(iG)%yAxis
!              print*, "zAxis: ", grid(iG)%zAxis
!           end do
!        end if

        if (lgPlaneIonization) then
           R_out = 1.e10*( (grid(1)%xAxis(grid(1)%nx)/1.e10)*&
                & (grid(1)%yAxis(grid(1)%ny)/1.e10)*&
                & (grid(1)%zAxis(grid(1)%nz)/1.e10) )
           print*, "! fillGrid [warning]: Plane Ionization model -> R_out &
                & reset to maximum extension", R_out
        end if

        ! locate the origin of the axes
        call locate(grid(1)%xAxis, 0., iOrigin)
        call locate(grid(1)%yAxis, 0., jOrigin)
        call locate(grid(1)%zAxis, 0., kOrigin)

        if (taskid == 0) print*, 'Origin at mother grid cell:  ' , iOrigin, jOrigin, kOrigin

        ! allocate dl
        allocate(dl(nGrids), stat = err)
        if (err /= 0) then
           print*, "! fillGrid: can't allocate dl memory"
           stop
        end if
        dl = 0.

        do iG = 1, nGrids
           ! find geometric corrections
           grid(iG)%geoCorrX = (grid(iG)%xAxis(grid(iG)%nx) - grid(iG)%xAxis(grid(iG)%nx-1))/2.
           if (.not. lg1D) then
              grid(iG)%geoCorrY = (grid(iG)%yAxis(grid(iG)%ny) - grid(iG)%yAxis(grid(iG)%ny-1))/2.
              grid(iG)%geoCorrZ = (grid(iG)%zAxis(grid(iG)%nz) - grid(iG)%zAxis(grid(iG)%nz-1))/2.
           else
              grid(iG)%geoCorrY = 0.
              grid(iG)%geoCorrZ = 0.
           end if

           if (taskid==0) print*, "Geometric grid corrections for grid ", &
                & iG, ' : ', grid(iG)%geoCorrX, grid(iG)%geoCorrY, grid(iG)%geoCorrZ

           ! find linear increment
           dl(iG) =  abs(grid(iG)%xAxis(2) - grid(iG)%xAxis(1))
           do i = 2, grid(iG)%nx-1
              dl(iG) = min(dl(iG), abs(grid(iG)%xAxis(i+1)-grid(iG)%xAxis(i)) )
           end do
           do i = 1, grid(iG)%ny-1
              dl(iG) = min(dl(iG), abs(grid(iG)%yAxis(i+1)-grid(iG)%yAxis(i)) )
           end do
           do i = 1, grid(iG)%nz-1
              dl(iG) = min(dl(iG), abs(grid(iG)%zAxis(i+1)-grid(iG)%zAxis(i)) )
           end do
           dl(iG) = dl(iG)/50.
        end do

        if (nGrids>1) then

           do iG = 1, nGrids

              do i = 1, grid(iG)%nx
                 do j = 1, grid(iG)%ny
                    do k = 1, grid(iG)%nz

                       do jG = 2, nGrids
                          if (jG /= iG) then
                             if (lgSymmetricXYZ) then

                                if ( ( &
                                     & (grid(iG)%xAxis(i) > grid(jG)%xAxis(1)) .or.&
                                     & (grid(iG)%xAxis(i) >= grid(jG)%xAxis(1) .and. grid(jG)%xAxis(1)==0.) &
                                     & ) .and. &
                                     & grid(iG)%xAxis(i)<grid(jG)%xAxis(grid(jG)%nx) .and.&
                                     & ( &
                                     & (grid(iG)%yAxis(j) > grid(jG)%yAxis(1)) .or. &
                                     & (grid(iG)%yAxis(j) >= grid(jG)%yAxis(1) .and. grid(jG)%yAxis(1)==0. ) &
                                     & ) .and. &
                                     & grid(iG)%yAxis(j)<grid(jG)%yAxis(grid(jG)%ny) .and. &
                                     & ( &
                                     & (grid(iG)%zAxis(k) > grid(jG)%zAxis(1)) .or.&
                                     & (grid(iG)%zAxis(k) >= grid(jG)%zAxis(1) .and. grid(jG)%zAxis(1)==0. ) &
                                     & ) .and. &
                                     & grid(iG)%zAxis(k)<grid(jG)%zAxis(grid(jG)%nz) ) then
                                   grid(iG)%active(i,j,k) = -jG

                                end if



                          else
                                if ( (grid(iG)%xAxis(i) > grid(jG)%xAxis(1) .and. &
                                     &grid(iG)%xAxis(i)<grid(jG)%xAxis(grid(jG)%nx)) .and.&
                                     & (grid(iG)%yAxis(j)>grid(jG)%yAxis(1) .and. &
                                     & grid(iG)%yAxis(j)<grid(jG)%yAxis(grid(jG)%ny)) .and. &
                                     & (grid(iG)%zAxis(k)>grid(jG)%zAxis(1) .and. &
                                     & grid(iG)%zAxis(k)<grid(jG)%zAxis(grid(jG)%nz)) ) then
                                   grid(iG)%active(i,j,k) = -jG
                                end if

                             end if

                          end if
                       end do

                    end do
                 end do
              end do

           end do

        end if


        print*, "out fillGrid"

      end subroutine fillGrid


      subroutine setMotherGrid(grid)
        implicit none

        type(grid_type), intent(inout) :: grid      ! the grid

        ! local variables
        real                           :: denominator   ! denominator
        real                           :: dV           ! volume element
        real                           :: expFactor    ! exp factor in density law calculations
        real                           :: gasCell      ! mass of gas in current cell
        real                           :: H0in         ! estimated H0 at the inner radius for regionI
        real, allocatable                  :: MdMg(:,:,:)  ! Md/Mg
        real                           :: MhMg         ! mass oh hydrogen over mass of gas
        real                           :: norm, scale  ! normalisation and scaling for meanField
        real                           :: radius       ! distance from the origin
        real                           :: random       ! random nmumber
        real                           :: totalMass    ! total ionized mass
        real                           :: totalVolume  ! total active volume
        real                      :: echoVolume, vol   ! just echo volume

        real, dimension(nElements) :: aWeight
        real, parameter :: amu = 1.66053e-24 ! [g]

        real, allocatable                  :: HdenTemp(:,:,:) ! temporary Hden
        real, allocatable                  :: NdustTemp(:,:,:) ! temporary dust number density arra
        real, allocatable                  :: dustAbunIndexTemp(:,:,:) ! temporary dust abundance index array
        real, allocatable                  :: twoDscaleJTemp(:)



        integer                        :: i,j,k        ! counters
        integer                        :: index        ! general index
        integer                        :: ios, err     ! I/O and allocation error status
        integer                        :: elem, ion    ! counters
        integer                        :: nspec, ai    ! counters
        integer                        :: nsp          ! pointer
        integer                        :: nu0P         !

        integer                        :: yTop, xPmap  ! 2D indeces

                                                       ! with one of the axes
        character(len=40)              :: keyword      ! character string readers

        print*, 'in setMotherGrid'

        ! this is the mother grid
        grid%motherP = 0

        if (lgGas) then

           ! allocate space for HdenTemp
           allocate(HdenTemp(1:grid%nx, 1:grid%ny, 1:grid%nz), stat = err)
           if (err /= 0) then
              print*, "! setMotherGrid: can't allocate grid memory"
              stop
           end if
           HdenTemp = 0.

           if (lgDfile) then
              open (unit= 77,  action="read", file=densityFile, status = "old", position = "rewind", &
                   & iostat = ios)
              if (ios /= 0) then
                 print*, "! setMotherGrid: can't open density file"
                 stop
              end if
              read(77,*)keyword
              if (keyword .ne. "#") backspace 77
           end if

        end if


        if (lg2D) then
           yTop = 1
        else
           yTop = grid%ny
        end if


        grid%active = 1
        if (lgGas) then
           do i = 1, grid%nx
              do j = 1, yTop
                 do k = 1, grid%nz

                    ! set density
                    if (lgDlaw) then

                       ! calculate radius
                       if (lg1D) then
                          radius = grid%xAxis(i)
                       else
                          radius = 1.e10*sqrt( (grid%xAxis(i)/1.e10)*(grid%xAxis(i)/1.e10) + &
                                 &                                        (grid%yAxis(j)/1.e10)*(grid%yAxis(j)/1.e10) + &
                                 &                                        (grid%zAxis(k)/1.e10)*(grid%zAxis(k)/1.e10) )
                       end if

                         ! edit the following to use a different density law

                         ! N(r) = N0 * (r/r1)^n * exp[-0.5*(r/r1)^2]
                         ! Clegg, Harrington, Barlow and Walsh 1987, ApJ, 314, 551

                         expFactor = exp(-0.5*(radius/densityLaw(1))*(radius/densityLaw(1)))


                         HdenTemp(i,j,k) = densityLaw(3)*expFactor*(radius/densityLaw(1))**densityLaw(2)


                      else if (lgHdenConstant) then

                         HdenTemp(i,j,k) = Hdensity

                      else if (lgDfile) then

                         if (.not.lgMultiChemistry) then

                            read(77, *) grid%xAxis(i), grid%yAxis(j), grid%zAxis(k), HdenTemp(i,j,k)

                         else

                            read(77, *) grid%xAxis(i), grid%yAxis(j), grid%zAxis(k), &
                              & HdenTemp(i,j,k), grid%abFileIndex(i,j,k)

                         end if

                      else

                         print*, "! setMotherGrid: no density distribution was set"
                         stop

                      end if

                      if (fillingFactor<1.) then

                         call random_number(random)

                         if (random > fillingFactor) HdenTemp(i,j,k) = 0.

                      end if


                      if (grid%active(i,j,k) <= 0 ) HdenTemp(i,j,k) = 0.

                   end do
                end do
             end do
          end if ! lgGas

          if (lgGas) close(77)

          ! set up dust data
          if (lgDust) then
              allocate(NdustTemp(1:grid%nx,1:grid%ny,1:grid%nz), stat = err)
              if (err /= 0) then
                 print*, "! setMotherGrid: can't allocate NdustTemp memory"
                 stop
              end if

              NdustTemp = 0.

              if (lgMultiDustChemistry) then
                 allocate(dustAbunIndexTemp(1:grid%nx,1:grid%ny,1:grid%nz), stat = err)
                 if (err /= 0) then
                    print*, "! setMotherGrid: can't allocate dustAbunIndexTemp memory"
                    stop
                 end if
                 dustAbunIndexTemp = 0.
              end if

              ! set grains mass density [g/cm^3]
!              allocate(dustComPoint(nDustComponents))
!              dustComPoint = 0
!              dustComPoint(1) = 1

!              nSpecies = 0
!              nSpeciesMax = 0
!print*, 'heer', ndustcomponents
!              do icomp = 1, nDustComponents
!print*, icomp
!                 close(13)
!                 open(file =   dustSpeciesFile(icomp), action="read",unit=13, &
!                      &position="rewind",status="old", iostat = ios)
!                 if (ios /= 0 ) then
!                    print*, "! setMotherGrid: can't open file ", dustSpeciesFile(icomp)
!                    stop
!                 end if
!                 read(13, *) nSpeciesPart(icomp)
!print*, nspeciespart(icomp)
!                 close(13)
!                 nSpecies = nSpecies+nSpeciesPart(icomp)
!print*, nspecies
!                 if (nSpeciesMax < nSpeciesPart(icomp)) nSpeciesMax = nSpeciesPart(icomp)
!print*, nspeciesmax
!              end do
!
!              allocate(rho(1:nSpecies), stat = err)
!              if (err /= 0) then
!                 print*, "! setMotherGrid: can't allocate rho memory"
!                 stop
!              end if
!              rho=0.
!              allocate(grainVn(1:nSpecies), stat = err)
!              if (err /= 0) then
!                 print*, "! setMotherGrid: can't allocate grainVn memory"
!                 stop
!              end if
!              grainVn=0.
!              allocate(MsurfAtom(1:nSpecies), stat = err)
!              if (err /= 0) then
!                 print*, "! setMotherGrid: can't allocate surfAtom memory"
!                 stop
!              end if
!              MsurfAtom=0
!
!              do icomp = 1, nDustComponents
!                 if (icomp > 1) dustComPoint(icomp) = dustComPoint(icomp-1)+nSpeciesPart(icomp)
!                 close(13)
!                 open(file =   dustSpeciesFile(icomp), action="read",unit=13, &
!                      & position="rewind",status="old", iostat = ios)
!                 if (ios /= 0 ) then
!                    print*, "! setMotherGrid: can't open file ", dustSpeciesFile(icomp)
!                    stop
!                 end if
!                 read(13, *) nSpeciesPart(icomp)
!
!                 do i = 1, nSpeciesPart(icomp)
!                    read(13,*) extFile
!                    close(14)
!                    open(file=extFile,unit=14,  action="read", position="rewind",status="old", iostat = ios)
!                    if (ios /= 0 ) then
!                       print*, "! setMotherGrid: can't open file ", extFile
!                       stop
!                    end if
!                    read(14,*) readChar
!                    read(14,*) readChar, readReal, rho(dustComPoint(icomp)+i-1), grainVn(dustComPoint(icomp)+i-1), &
!                         &MsurfAtom(dustComPoint(icomp)+i-1)
!                    close(14)
!                 end do
!                 close(13)
!              end do
!
              if (lgMdMg .or. lgMdMh) then

                 allocate(MdMg(1:grid%nx,1:grid%ny,1:grid%nz), stat = err)
                 if (err /= 0) then
                    print*, "! setMotherGrid: can't allocate MdMg memory"
                    stop
                 end if
                 MdMg = 0.

                 if (lgDustConstant) then
                    MdMg = MdMgValue
                 else
                    close(20)
                    open(unit=20, file=MdMgFile,  action="read", position="rewind",status="old", iostat = ios)
                    if (ios /= 0 ) then
                       print*, "! setMotherGrid: can't open MdMgFile file ", MdMgFile
                       stop
                    end if
                    read(20,*)keyword
                    if (keyword .ne. "#") backspace 20

                    if (lgMultiDustChemistry) then
                       do i = 1, grid%nx
                          do j = 1, yTop
                             do k = 1, grid%nz
                                read(20, *) index, index, index, MdMg(i,j,k), dustAbunIndexTemp(i,j,k)
                             end do
                          end do
                       end do
                    else
                       do i = 1, grid%nx
                          do j = 1, yTop
                             do k = 1, grid%nz
                                read(20, *) index, index, index, MdMg(i,j,k)
                             end do
                          end do
                       end do
                    end if
                    close(20)
                 end if

              else

                 ! Ndust was directly defined by  the user
                 if (lgDustConstant) then
                    NdustTemp = NdustValue
                 else
                    close(20)
                    open(unit=20, file=NdustFile,  action="read", position="rewind",status="old", iostat = ios)
                    if (ios /= 0 ) then
                       print*, "! setMotherGrid: can't open NdustFile file ", NdustFile
                       stop
                    end if
                    read(20,*)keyword
                    if (keyword .ne. "#") backspace 20

                    if (lgMultiDustChemistry) then
                       do i = 1, grid%nx
                          do j = 1, yTop
                             do k = 1, grid%nz
                                read(20, *) grid%xAxis(i), grid%yAxis(j), &
                                     & grid%zAxis(k), NdustTemp(i,j,k), dustAbunIndexTemp(i,j,k)
                             end do
                          end do
                       end do
                    else
                       print*,grid%nx,yTop,grid%nz
                       do i = 1, grid%nx
                          do j = 1, yTop
                             do k = 1, grid%nz
                                read(20, *) grid%xAxis(i), grid%yAxis(j), grid%zAxis(k), NdustTemp(i,j,k)
!                                write(6,'(3i4,4es11.3)')i,j,k,grid%xAxis(i), grid%yAxis(j), grid%zAxis(k), NdustTemp(i,j,k)
                             end do
                          end do
                       end do
                    end if
                    close(20)
                 end if

              end if

           end if

           if (lg2D) grid%yAxis = grid%xAxis


          ! set active cells pointers
          grid%nCells = 0
          do i = 1, grid%nx
             do j = 1, yTop
                do k = 1, grid%nz

                   ! calculate radius
                   if (lg1D) then
                      radius = grid%xAxis(i)
                   else
                      radius = 1.e10*sqrt( (grid%xAxis(i)/1.e10)*(grid%xAxis(i)/1.e10) + &
&                                        (grid%yAxis(j)/1.e10)*(grid%yAxis(j)/1.e10) + &
&                                        (grid%zAxis(k)/1.e10)*(grid%zAxis(k)/1.e10) )
                   end if


                   ! check if this grid point is  valid nebular point
                   if (.not. lgPlaneIonization) then

                      if (radius < R_in) then
                         grid%active(i,j,k) = 0
                      else if (radius > R_out .and. R_out>0.) then
                         grid%active(i,j,k) = 0
                      end if

                   end if

                   if (grid%active(i,j,k) <= 0 .and. lgDust ) then
                      NdustTemp(i,j,k) = 0.
                      if (lgMultiDustChemistry) dustAbunIndexTemp(i,j,k) = 0.
                   end if

                   if (grid%active(i,j,k) <= 0 .and. lgGas ) HdenTemp(i,j,k) = 0.

                   if (lgDust .and. lgGas) then
                      if (HdenTemp(i,j,k) > 0. .or. NdustTemp(i,j,k)>0.) then
                         grid%nCells = grid%nCells + 1
                         grid%active(i,j,k) = grid%nCells
                      else
                         grid%active(i,j,k) = 0
                         HdenTemp(i,j,k) = 0.
                         NdustTemp(i,j,k) = 0.
                         if (lgMultiDustChemistry) dustAbunIndexTemp(i,j,k) = 0.
                      end if
                   else if ( lgDust .and. (.not.lgGas) ) then
                      if (NdustTemp(i,j,k)>0.) then
                         grid%nCells = grid%nCells + 1
                         grid%active(i,j,k) = grid%nCells
                      else
                         grid%active(i,j,k) = 0
                         NdustTemp(i,j,k) = 0.
                         if (lgMultiDustChemistry) dustAbunIndexTemp(i,j,k) = 0.
                      end if
                   else if ( (.not.lgDust) .and. lgGas) then
                      if (HdenTemp(i,j,k) > 0.) then
                         grid%nCells = grid%nCells + 1
                         grid%active(i,j,k) = grid%nCells
                      else
                         grid%active(i,j,k) = 0
                         HdenTemp(i,j,k) = 0.
                      end if
                   else

                      print*, '! setMotherGrid: no gas and no dust? The grid is empty.'
                      stop
                   end if

                end do
             end do
          end do


          allocate(TwoDscaleJtemp(grid%nCells))
          TwoDscaleJtemp = 1.


          if (lg2D) then
             do i = 1, grid%nx
                do j = 2, grid%ny
                   do k = 1, grid%nz
                      radius = 1.e10*sqrt( (grid%xAxis(i)/1.e10)*&
                           &(grid%xAxis(i)/1.e10) + &
                           &(grid%yAxis(j)/1.e10)*(grid%yAxis(j)/1.e10) )

                      call locate(grid%xAxis, radius, xPmap)
                      if (xPmap < grid%nx) then
                         if (radius >= (grid%xAxis(xPmap)+grid%xAxis(xPmap+1))/2.) &
                              & xPmap = xPmap+1
                      end if
                      grid%active(i,j,k) = grid%active(xPmap, 1, k)

                      if (grid%active(xPmap,1,k)>0) &
                           & TwoDScaleJtemp(grid%active(xPmap,1,k)) = &
                           & TwoDScaleJtemp(grid%active(xPmap,1,k))+1.

                   end do
                end do
             end do

             grid%nCells = 0
             do i = 1,  grid%nx
                do k = 1,  grid%nz
                   if (grid%active(i,1,k) > 0) grid%nCells = grid%nCells +1

                end do
             end do

             allocate(TwoDscaleJ(grid%nCells))
             do i = 1, grid%nCells
                TwoDscaleJ(i) = TwoDscaleJtemp(i)
             end do
             deallocate(TwoDscaleJtemp)

          end if



          print*, '! setMotherGrid: active cells :', grid%nCells



          ! allocate grid arrays
          if (lgGas .and. lgDust .and. lgPhotoelectric) then
             allocate(grid%JPEots(1:grid%nCells, 1:nbins), stat = err)
             if (err /= 0) then
                print*, "! setMotherGrid: can't allocate JPEots memory"
                stop
             end if
             grid%JPEots=0
          end if

          if (lgGas) then

             allocate(grid%Hden(0:grid%nCells), stat = err)
             if (err /= 0) then
                print*, "! setMotherGrid: can't allocate grid memory"
                stop
             end if

             allocate(grid%recPDF(0:grid%nCells, 1:nbins), stat = err)
             if (err /= 0) then
                print*, "Can't allocate grid memory, 8"
                stop
             end if

             allocate(grid%totalLines(0:grid%nCells), stat = err)
             if (err /= 0) then
                print*, "Can't allocate grid memory, 10"
                stop
             end if

             allocate(grid%ionDen(0:grid%nCells, 1:nElementsUsed, 1:nstages), stat = err)
             if (err /= 0) then
                print*, "! setMotherGrid: can't allocate grid memory,ionDen"
                stop
             end if
             allocate(ionDenUsed(1:nElementsUsed, 1:nstages), stat = err)
             if (err /= 0) then
                print*, "! setMotherGrid: can't allocate grid memory,ionDenUsed"
                stop
             end if
             allocate(grid%Ne(0:grid%nCells), stat = err)
             if (err /= 0) then
                print*, "! setMotherGrid: can't allocate grid memory"
                stop
             end if
             allocate(grid%Te(0:grid%nCells), stat = err)
             if (err /= 0) then
                print*, "! setMotherGrid:can't allocate grid memory"
                stop
             end if

             grid%Hden = 0.
             grid%Ne = 0.
             grid%Te = 0.
             grid%ionDen = 0.
             grid%recPDF = 0.
             grid%totalLines = 0.

          end if

          if (Ldiffuse>0.) then
             allocate(grid%LdiffuseLoc(0:grid%nCells), stat = err)
             if (err /= 0) then
                print*, "! setMotherGrid: can't allocate grid memory : LdiffuseLoc "
                stop
             end if
             grid%LdiffuseLoc=0.
          end if


          allocate(grid%opacity(0:grid%nCells, 1:nbins), stat = err)
          if (err /= 0) then
             print*, "! setMotherGrid: can't allocate grid memory : opacity "
             stop
          end if
          allocate(grid%Jste(0:grid%nCells, 1:nbins), stat = err)
          if (err /= 0) then
             print*, "! setMotherGrid: can't allocate grid memory : Jste"
             stop
          end if

          allocate(grid%escapedPackets(0:grid%nCells, 0:nbins,0:nAngleBins), stat = err)
          if (err /= 0) then
             print*, "! setMotherGrid: can't allocate grid memory : Jste"
             stop
          end if

          if (lgEquivalentTau) then

             allocate(SEDnoExt(1:nbins), stat = err)
             if (err /= 0) then
                print*, "! setMotherGrid: can't allocate grid memory : SEDnoExt"
                stop
             end if
             allocate(equivalentTau(1:nbins), stat = err)
             if (err /= 0) then
                print*, "! setMotherGrid: can't allocate grid memory : equivalentTau"
                stop
             end if

          end if
          if (lgDust) then

             allocate(grid%Ndust(0:grid%nCells), stat = err)
             if (err /= 0) then
                print*, "! grid: can't allocate Ndust memory"
                stop
             end if
             grid%Ndust=0.
             ! be 2.02.44
             allocate(grid%dustAbunIndex(0:grid%nCells), stat = err)
             if (err /= 0) then
                print*, "! grid: can't allocate dustAbunIndex memory"
                stop
             end if
             grid%dustAbunIndex=0
             ! be 2.02.44 end

             if (.not.lgGas) then
                allocate(grid%dustPDF(0:grid%nCells, 1:nbins), stat = err)
                if (err /= 0) then
                   print*, "! grid: can't allocate dustPDF memory"
                   stop
                end if
                grid%dustPDF = 0.
             end if

          end if
!          print* ,'a'

!BS10          if (lgDebug) then
             allocate(grid%Jdif(0:grid%nCells, 1:nbins), stat = err)
             if (err /= 0) then
                print*, "! grid: can't allocate grid memory"
                stop
             end if

             grid%Jdif = 0.

             ! allocate pointers depending on nLines
             if (nLines > 0) then

                allocate(grid%linePackets(0:grid%nCells, 1:nLines), stat = err)
                if (err /= 0) then
                   print*, "! initCartesianGrid: can't allocate grid%linePackets memory"
                   stop
                end if

                allocate(grid%linePDF(0:grid%nCells, 1:nLines), stat = err)
                if (err /= 0) then
                   print*, "! initCartesianGrid: can't allocate grid%linePDF memory"
                   stop
                end if

                grid%linePackets = 0.
                grid%linePDF     = 0.

             end if

!BS10          end if

          allocate(grid%lgConverged(0:grid%nCells), stat = err)
          if (err /= 0) then
             print*, "Can't allocate memory to lgConverged array"
             stop
          end if

          allocate(grid%lgBlack(0:grid%nCells), stat = err)
          if (err /= 0) then
             print*, "Can't allocate memory to lgBlack array"
             stop
          end if


          if (lgNeInput) then
             allocate(grid%NeInput(0:grid%nCells), stat = err)
             if (err /= 0) then
                print*, "! setMotherGrid: can't allocate grid memory, grid%NeInput"
                stop
             end if
             grid%NeInput = 0.
          end if


          grid%opacity = 0.
          grid%Jste = 0.
          grid%lgConverged = 0
          grid%lgBlack = 0

          do i = 1, grid%nx
             do j = 1, yTop
                do k = 1, grid%nz
                   if (grid%active(i,j,k)>0) then

                      if (lgGas) then
                         grid%Hden(grid%active(i,j,k)) = HdenTemp(i,j,k)
                         grid%Te(grid%active(i,j,k)) = TeStart
                      end if
                      if (lgDust) then
                         grid%Ndust(grid%active(i,j,k)) = NdustTemp(i,j,k)
                         if (lgMultiDustChemistry) &
                              & grid%dustAbunIndex(grid%active(i,j,k)) = &
                              &nint(dustAbunIndexTemp(i,j,k))
                      end if
                   end if
                end do
             end do
          end do
!          print*, 'b'
          if (lgNeInput) then
             grid%NeInput = grid%Hden
             ! 1.11 is just a starting guess for the ionization
             ! factor
             grid%Hden = grid%Hden/1.11
          end if

          if (lgGas) then

             H0in  = 1.e-5

             do i = 1, grid%nx
                do j = 1, yTop
                   do k = 1, grid%nz

                      if (grid%active(i,j,k)>0 ) then

                         ! calculate ionDen for H0
                         if (lgElementOn(1)) then
                            grid%ionDen(grid%active(i,j,k),elementXref(1),1) = H0in
                            grid%ionDen(grid%active(i,j,k),elementXref(1),2) = &
                                 & 1.-grid%ionDen(grid%active(i,j,k),elementXref(1),1)
                         end if
                         if (lgElementOn(2)) then
                            grid%ionDen(grid%active(i,j,k),elementXref(2),1) = &
                                 & grid%ionDen(grid%active(i,j,k),elementXref(1),1)
                            grid%ionDen(grid%active(i,j,k),elementXref(2),2) = &
                                 & (1.-grid%ionDen(grid%active(i,j,k),elementXref(2),1))
                            grid%ionDen(grid%active(i,j,k),elementXref(2),3) = 0.
                         end if

                         ! initialize Ne
                         grid%Ne(grid%active(i,j,k)) =  grid%Hden(grid%active(i,j,k))

                         ! initialize all heavy ions (careful that the sum over all ionisation
                         ! stages of a given atom doesn't exceed 1.)
                         do elem = 3, nElements
                            do ion = 1, min(elem+1,nstages)
                               if (lgElementOn(elem)) then
                                  if (ion == 1) then
                                     grid%ionDen(grid%active(i,j,k),elementXref(elem),ion) &
                                          & = grid%ionDen(grid%active(i,j,k),1,1)
                                  else
                                     grid%ionDen(grid%active(i,j,k),elementXref(elem),ion) = 0.
                                  end if
                               end if
                            end do
                         end do
                      end if     ! active condition

                   end do
                end do
             end do

             ! deallocate temp array
             if(allocated(HdenTemp)) deallocate(HdenTemp)

          end if ! lgGas

           if (lgDust) then
              if(allocated(NdustTemp)) deallocate(NdustTemp)
              if(lgMultiDustChemistry .and. allocated(dustAbunIndexTemp)) deallocate(dustAbunIndexTemp)
           end if

           ! set up atomic weight array
           aWeight = (/1.0080, 4.0026, 6.941, 9.0122, 10.811, 12.0111, 14.0067, 15.9994, &
                & 18.9984, 20.179, 22.9898, 24.305, 26.9815, 28.086, 30.9738, 32.06, 35.453, &
                & 39.948, 39.102, 40.08, 44.956, 47.90, 50.9414, 51.996, 54.9380, 55.847, 58.9332, &
                & 58.71, 63.546, 65.37 /)

           totalDustMass = 0.
           totalMass = 0.
           totalVolume = 0.
           echoVolume = 0.

           do i = 1, grid%nx
              do j = 1, yTop
                 do k = 1, grid%nz
                    grid%echoVol(i,j,k)=0. ! initialize
                    if (grid%active(i,j,k)>0) then

                       dV = getVolume(grid,i,j,k)

                       if (lgGas) then
                          gasCell = 0.
                          do elem = 1, nElements
                             gasCell = gasCell + grid%elemAbun(grid%abFileIndex(i,j,k),elem)*&
                                  & aWeight(elem)*amu
                             totalMass = totalMass + &
                                  & grid%Hden(grid%active(i,j,k))*dV*grid%elemAbun(grid%abFileIndex(i,j,k),elem)*&
                                  & aWeight(elem)*amu
                          end do
                       end if

                       totalVolume = totalVolume + dV
!
! echoes only
!
                       if (lgEcho) then
                          grid%echoVol(i,j,k)=vEcho(grid,i,j,k,echot1,echot2,vol)
                          echoVolume = echoVolume + vol
                       endif

                       if (lgDust .and. (lgMdMg.or.lgMdMh) ) then


                          if (lgMdMh) then
                             MhMg=0.
                             do elem = 1, nElements
                                ! transform to MdMg
                                MhMg = MhMg+grid%elemAbun(grid%abFileIndex(i,j,k),elem)*&
                                     & aWeight(elem)
                             end do
                             MhMg = 1./MhMg
                             MdMg(i,j,k) = MdMg(i,j,k)*MhMg
                          end if

                          if (.not.lgGas) then
                             print*, '! setMotherGrid: Mass to dust ratio (MdMg) cannot be used in a pure dust (noGas)&
                                  & simulation. Ndust must be used instead.'
                             stop
                          end if

                          grid%Ndust(grid%active(i,j,k)) = gasCell*MdMg(i,j,k)*grid%Hden(grid%active(i,j,k))

                          denominator = 0.

                          if (lgMultiDustChemistry) then
                             nsp = grid%dustAbunIndex(grid%active(i,j,k))
                          else
                             nsp = 1
                          end if
!print*, nsp, 'here!'
                          do nspec = 1, nSpeciesPart(nsp)
                             do ai = 1, nSizes
                                denominator = denominator + &
                                     & (1.3333*Pi*( (grainRadius(ai)*1.e-4)**3)*&
                                     & rho(dustComPoint(nsp)+nspec-1)*grainWeight(ai)*&
                                     & grainAbun(nsp, nspec))
                             end do
                          end do
                          grid%Ndust(grid%active(i,j,k)) = grid%Ndust(grid%active(i,j,k))/&
                               & (denominator)
                       end if

                       ! calculate total dust mass
                       if (lgDust) then
                          if (lgMultiDustChemistry) then
                             nsp = grid%dustAbunIndex(grid%active(i,j,k))
                          else
                             nsp = 1
                          end if

                          do ai = 1, nsizes
                             do nspec = 1, nspeciesPart(nsp)
                                totalDustMass = totalDustMass + &
                                     &(1.3333*Pi*((grainRadius(ai)*1.e-4)**3)*&
                                     & rho(dustComPoint(nsp)-1+nspec)*grainWeight(ai)*&
                                     & grainAbun(nsp,nspec))*grid%Ndust(grid%active(i,j,k))*dV

                             end do
                          end do

                       end if

                    end if
                 end do
              end do
           end do



           if(allocated(MdMg)) deallocate(MdMg)

           if (taskid == 0) then

              print*, 'Mothergrid :'
              if (lgGas) then
                 print*, 'Total gas mass of ionized region by mass [1.e45 g]: ', totalMass
                 print*, '                                         [Msol]   : ', totalMass*5.025e11
              end if
              if (lgDust) then
                 print*, 'Total dust mass of ionized region by mass [1.e45 g]: ', totalDustMass
                 print*, '                                          [Msol]   : ', totalDustMass*5.025e11
              end if
              print*, 'Total volume of the active region [e45 cm^3]: ', totalVolume
              if (lgEcho) then
                 print*, 'Total volume of the echo [e45 cm^3]: ', echoVolume*846732407.," or ",echoVolume," ly^3"
                 open(unit=99, status='unknown', position='rewind', file='output/echo.out', action="write",iostat=ios)
                 write(99,*)'Total volume of the active region [e45 cm^3]: ', totalVolume
                 write(99,*)'Total volume of the echo [e45 cm^3]: ', echoVolume*846732407.," or ",echoVolume," ly^3"
                 if (echoVolume .eq. 0.) then
                    print*,'No dust in echo region. Stopping'
                    write(99,*)'No dust in echo region. Stopping'
                    stop
                 endif
                 close(99)
              endif

           end if

           ! if we are using a plane parallel ionization then we must find the luminosity
           ! of the ionizing plane from the input meanField
           if (lgPlaneIonization) then

              print*, 'Flux above ', nu0, ' is ', meanField

              if (nu0 > 0.) then
                 call locate(nuArray, nu0, nu0P)
                 if (nu0P >= nbins .or. nu0P <1) then
                    print*, "! setMotherGrid: insanity in nu0P", nu0P, nuArray(i), nuArray(nbins)
                    stop
                 end if
                 norm = 0.
                 do i = nu0P, nbins
                    norm = norm+real(inSpectrumPhot(i)*widflx(i))
                 end do
                 scale  = meanField/norm
                 norm = 0.
                 do i = 1, nbins
                    norm = norm+real(inSpectrumErg(i)*widFlx(i))
                 end do
                 meanField = norm*scale
              end if

              print*, 'Flux bolometric is ', meanField

              Lstar(1) = (meanField/1.e36)*grid%xAxis(grid%nx)*grid%zAxis(grid%nz)
              deltaE(1) = Lstar(1)/nPhotons(1)
           end if

           if (taskid == 0) then
              print*, 'Total ionizing flux :', Lstar(1)
              print*, 'deltaE :', deltaE(1)
           end if

           print*, 'out setMotherGrid'

         end subroutine setMotherGrid

         subroutine setSubGrids(grid)
           implicit none

           type(grid_type), dimension(:),intent(inout) :: grid        ! the grid



           ! local variables
           real                           :: x,y,z        ! x,y,z
           real                           :: delta        ! displacement for realigning subgrids to mothergrid
           real                           :: denominator   ! denominator
           real                           :: denfac       ! enhancement factor
           real                           :: dV           ! volume element
           real                           :: gasCell      ! mass of gas in current cell
           real                           :: H0in         ! estimated H0 at the inner radius for regionI
           real                           :: MhMg         ! hdrogen to gas mass ratio
           real                           :: radius       ! distance from the origin
           real                           :: totalMass    ! total ionized mass
           real                           :: totalVolume  ! total active volume
           real                      :: echoVolume, vol   ! just echo volume


           real, allocatable                  :: HdenTemp(:,:,:) ! temporary Hden
           real, allocatable                  :: NdustTemp(:,:,:) ! temporary dust number density array
           real, allocatable                  :: dustAbunIndexTemp(:,:,:) ! temporary dust number density array

           integer                        :: edgeP        ! subgrid edge pointer on mothergrid
           integer                        :: i,j,k,iG,ai  ! counters
           integer                        :: ix,iy,iz     ! counters
           integer                        :: ios, err     ! I/O and allocation error status
           integer                        :: elem, ion    ! counters
           integer                        :: nsp, nspec   ! pointer
           character(len=50)              :: dFileRead    ! subgrid dFile  reader

           ! open grid info file
           close(71)
           open (unit= 71, file=gridList,  action="read", status = "old", position = "rewind", &
                & iostat = ios)
           if (ios /= 0) then
              print*, "! setsubGrids: can't open grid list file", gridList
              stop
           end if

           do iG = 2, nGrids

              ! set the elemental abundances
              grid(iG)%elemAbun = grid(1)%elemAbun


              read(71, *) grid(iG)%motherP ,  grid(iG)%nx,  grid(iG)%ny,  grid(iG)%nz, dFileRead, denfac

              read(71, *) grid(iG)%xAxis(1), grid(iG)%xAxis(grid(iG)%nx), &
                   & grid(iG)%yAxis(1), grid(iG)%yAxis(grid(iG)%ny), &
                   &grid(iG)%zAxis(1), grid(iG)%zAxis(grid(iG)%nz)

              ! realign boundaries with mother grid cell half-way boundaries
              if (.false.) then

              call locate(grid(grid(iG)%motherP)%xAxis, grid(iG)%xAxis(1), edgeP)

              if (edgeP>=grid(grid(iG)%motherP)%nx) then
                 print*, 'setSubGrids : edgeP for lower x boundary equals to nx of the mother grid'
                 stop
              end if
              if (edgeP == 1 .and. grid(iG)%xAxis(1) > 1.001*grid(grid(iG)%motherP)%xAxis(1) ) then

                 delta = (grid(grid(iG)%motherP)%xAxis(edgeP)+&
                      & grid(grid(iG)%motherP)%xAxis(edgeP+1))/2. -&
                      & grid(iG)%xAxis(1)

                 if (taskid==0) then
                    print*, 'setSubGrids : Lower x-edge displaced by ', delta, ' for subGrid ', iG
                 end if

                 grid(iG)%xAxis(1) = &
                      & (grid(grid(iG)%motherP)%xAxis(edgeP)+grid(grid(iG)%motherP)%xAxis(edgeP+1))/2.

              else

                 grid(iG)%xAxis(1) = &
                      & (grid(grid(iG)%motherP)%xAxis(edgeP))

              end if

              call locate(grid(grid(iG)%motherP)%xAxis, grid(iG)%xAxis(grid(iG)%nx), edgeP)

              if (edgeP==grid(grid(iG)%motherP)%nx) then

                 delta = grid(grid(iG)%motherP)%xAxis(edgeP)-&
                   & grid(iG)%xAxis(grid(iG)%nx)
              else

                 delta = (grid(grid(iG)%motherP)%xAxis(edgeP)+grid(grid(iG)%motherP)%xAxis(edgeP+1))/2. -&
                      & grid(iG)%xAxis(grid(iG)%nx)
              end if

              if (taskid==0) then
                 print*, 'setSubGrids : Upper x-edge displaced by ', delta, ' for subGrid ', iG
              end if

              if (edgeP==grid(grid(iG)%motherP)%nx) then
                 grid(iG)%xAxis(grid(iG)%nx) = grid(grid(iG)%motherP)%xAxis(edgeP)
              else
                 grid(iG)%xAxis(grid(iG)%nx) = (grid(grid(iG)%motherP)%xAxis(edgeP)+&
                      &grid(grid(iG)%motherP)%xAxis(edgeP+1))/2.
              end if

              if (taskid==0) then
                 print*, 'setSubGrids : x1,x2,iG: ',  grid(iG)%xAxis(1),  grid(iG)%xAxis(grid(iG)%nx), iG
              end if

              call locate(grid(grid(iG)%motherP)%yAxis, grid(iG)%yAxis(1), edgeP)

              if (edgeP>=grid(grid(iG)%motherP)%ny) then
                 print*, 'setSubGrids : edgeP for lower y boundary equals to ny of the mother grid'
                 stop
              end if

              if (edgeP == 1 .and. grid(iG)%yAxis(1) > 1.001*grid(grid(iG)%motherP)%yAxis(1) ) then

                 delta = (grid(grid(iG)%motherP)%yAxis(edgeP)+&
                      & grid(grid(iG)%motherP)%yAxis(edgeP+1))/2. -&
                      & grid(iG)%yAxis(1)

                 if (taskid==0) then
                    print*, 'setSubGrids : Lower y-edge displaced by ', delta, ' for subGrid ', iG
                 end if

                 grid(iG)%yAxis(1) =  (grid(grid(iG)%motherP)%yAxis(edgeP)+&
                         & grid(grid(iG)%motherP)%yAxis(edgeP+1))/2.


              else

                 grid(iG)%yAxis(1) = &
                      & (grid(grid(iG)%motherP)%yAxis(edgeP))

              end if

              call locate(grid(grid(iG)%motherP)%yAxis, grid(iG)%yAxis(grid(iG)%ny), edgeP)

              if (edgeP==grid(grid(iG)%motherP)%ny) then

                 delta = grid(grid(iG)%motherP)%yAxis(edgeP)-&
                   & grid(iG)%yAxis(grid(iG)%ny)
              else
                 delta = (grid(grid(iG)%motherP)%zAxis(edgeP)+&
                      & grid(grid(iG)%motherP)%zAxis(edgeP+1))/2. -&
                      & grid(iG)%zAxis(grid(iG)%nz)
              end if

              if (taskid==0) then
                 print*, 'setSubGrids : Upper y-edge displaced by ', delta, ' for subGrid ', iG
              end if

              if (edgeP==grid(grid(iG)%motherP)%ny) then
                 grid(iG)%yAxis(grid(iG)%ny) = grid(grid(iG)%motherP)%yAxis(edgeP)
              else
                 grid(iG)%yAxis(grid(iG)%ny) =  (grid(grid(iG)%motherP)%yAxis(edgeP)+&
                      &grid(grid(iG)%motherP)%yAxis(edgeP+1))/2.
              end if

              if (taskid==0) then
                 print*, 'setSubGrids : y1,y2,iG: ',  grid(iG)%yAxis(1),  grid(iG)%yAxis(grid(iG)%ny)
              end if


              call locate(grid(grid(iG)%motherP)%zAxis, grid(iG)%zAxis(1), edgeP)

              if (edgeP>=grid(grid(iG)%motherP)%nz) then
                 print*, 'setSubGrids : edgeP for lower z boundary equals to nz of the mother grid'
                 print*, grid(grid(iG)%motherP)%zAxis, grid(iG)%zAxis(1), edgeP
                 stop
              end if

              if (edgeP == 1 .and. grid(iG)%zAxis(1) > 1.001*grid(grid(iG)%motherP)%zAxis(1) ) then

                 delta = (grid(grid(iG)%motherP)%zAxis(edgeP)+&
                      & grid(grid(iG)%motherP)%zAxis(edgeP+1))/2. -&
                      & grid(iG)%zAxis(1)

                 if (taskid==0) then
                    print*, 'setSubGrids : Lower z-edge displaced by ', delta, ' for subGrid ', iG
                 end if


                 grid(iG)%zAxis(1) =  (grid(grid(iG)%motherP)%zAxis(edgeP)+&
                      & grid(grid(iG)%motherP)%zAxis(edgeP+1))/2.

              else

                 grid(iG)%zAxis(1) = &
                      & (grid(grid(iG)%motherP)%zAxis(edgeP))

              end if

              call locate(grid(grid(iG)%motherP)%zAxis, grid(iG)%zAxis(grid(iG)%nz), edgeP)

              if (edgeP==grid(grid(iG)%motherP)%nz) then
                 delta = grid(grid(iG)%motherP)%zAxis(edgeP) -&
                      & grid(iG)%zAxis(grid(iG)%nz)
              else
                 delta = (grid(grid(iG)%motherP)%zAxis(edgeP)+&
                      & grid(grid(iG)%motherP)%zAxis(edgeP+1))/2. -&
                      & grid(iG)%zAxis(grid(iG)%nz)
              end if

              if (taskid==0) then
                 print*, 'setSubGrids : Upper z-edge displaced by ', delta, ' for subGrid ', iG
              end if

              if (edgeP==grid(grid(iG)%motherP)%nz) then
                 grid(iG)%zAxis(grid(iG)%nz) = grid(grid(iG)%motherP)%zAxis(edgeP)
              else
                 grid(iG)%zAxis(grid(iG)%nz) = (grid(grid(iG)%motherP)%zAxis(edgeP)+&
                      & grid(grid(iG)%motherP)%zAxis(edgeP+1))/2.
              end if

              if (taskid==0) then
                 print*, 'setSubGrids : z1,z2,iG: ',  grid(iG)%zAxis(1),  grid(iG)%zAxis(grid(iG)%nz)
              end if

           end if

              close(72)
              open (unit= 72, file=dFileRead,  action="read", status = "old", position = "rewind", &
                   & iostat = ios)
              if (ios /= 0) then
                 print*, "! setsubGrids: can't open subgrid density file", dFileRead
                 stop
              end if

              if (lgDust) then
                 allocate(NdustTemp(1:grid(iG)%nx,1:grid(iG)%ny,1:grid(iG)%nz), stat = err)
                 if (err /= 0) then
                    print*, "! setSubGrids: can't allocate NdustTemp memory for subGrid", iG
                    stop
                 end if
                 NdustTemp = 0.
                 if (lgMultiDustChemistry) then
                    allocate(dustAbunIndexTemp(1:grid(iG)%nx,1:grid(iG)%ny,1:grid(iG)%nz), stat = err)
                    if (err /= 0) then
                       print*, "! setSubGrids: can't allocate dustAbunIndexTemp memory for subGrid", iG
                       stop
                    end if
                    dustAbunIndexTemp = 0.
                 end if
              end if

              if (lgEcho) then ! allocate active cells volume
                 allocate(grid(iG)%echoVol(1:grid(iG)%nx, 1:grid(iG)%ny, 1:grid(iG)%nz), stat = err)
                 if (err /= 0) then
                    print*, "Can't allocate grid memory, echoVol"
                    stop
                 end if
              endif

              ! allocate space for HdenTemp
              if (lgGas) then
                 allocate(HdenTemp(1:grid(iG)%nx, 1:grid(iG)%ny, 1:grid(iG)%nz), stat = err)
                 if (err /= 0) then
                    print*, "! setSubGrid: can't allocate sub grid memory: HdenTemp", iG
                    stop
                 end if
                 HdenTemp = 0.
              end if

              grid(iG)%active = 1
              grid(iG)%nCells = 0
              do ix = 1, grid(iG)%nx
                 do iy = 1, grid(iG)%ny
                    do iz = 1, grid(iG)%nz

                       if (lg1D) then
                          print*, "! setSubGrids: No 1D option with multiple grids!!"
                          stop
                       end if

                       if (.not.lgMultiChemistry) then

                          if (lgMultiDustChemistry) then

                             if (lgGas .and. lgDust) then
                                read(72, *) x,y,z, HdenTemp(ix,iy,iz), &
                                     & NdustTemp(ix,iy,iz), dustAbunIndexTemp(ix,iy,iz)
!print*, x,y,z, HdenTemp(ix,iy,iz), NdustTemp(ix,iy,iz), dustAbunIndexTemp(ix,iy,iz)

                             else if (lgGas .and. .not. lgDust) then
                                read(72, *) x,y,z, HdenTemp(ix,iy,iz)
                             else if (.not.lgGas .and. lgDust) then
                                read(72, *) x,y,z, NdustTemp(ix,iy,iz), dustAbunIndexTemp(ix,iy,iz)
                             else
                                print*, "! setSubGrids: No gas or dust with multiple grids!!"
                                stop
                             end if

                          else

                             if (lgGas .and. lgDust) then
                                read(72, *) x,y,z, HdenTemp(ix,iy,iz), NdustTemp(ix,iy,iz)
                             else if (lgGas .and. .not. lgDust) then
                                read(72, *) x,y,z, HdenTemp(ix,iy,iz)
                             else if (.not.lgGas .and. lgDust) then
                                read(72, *) x,y,z, NdustTemp(ix,iy,iz)
                             else
                                print*, "! setSubGrids: No gas or dust with multiple grids!!"
                                stop
                             end if

                          end if
                       else

                          if (lgMultiDustChemistry) then

                             if (lgGas .and. lgDust) then
                                read(72, *) x,y,z, HdenTemp(ix,iy,iz), NdustTemp(ix,iy,iz),&
                                     &grid(iG)%abFileIndex(ix,iy,iz), dustAbunIndexTemp(ix,iy,iz)
                             else if (.not.lgGas .and. lgDust) then
                                print*, '! setSubGrids: gas must be present when the multichemistry option is used'
                                stop
                             else
                                print*, "! setSubGrids: No gas or dust with multiple grids and multichemistry!!"
                                stop
                             end if
                          else
                             if (lgGas .and. lgDust) then
                                read(72, *) x,y,z, HdenTemp(ix,iy,iz), NdustTemp(ix,iy,iz),grid(iG)%abFileIndex(ix,iy,iz)
                             else if (lgGas .and. .not. lgDust) then
                                read(72, *) x,y,z, HdenTemp(ix,iy,iz),grid(iG)%abFileIndex(ix,iy,iz)
                             else if (.not.lgGas .and. lgDust) then
                                print*, '! setSubGrids: gas must be present when the multichemistry option is used'
                                stop
                             else
                                print*, "! setSubGrids: No gas or dust with multiple grids and multichemistry!!"
                                stop
                             end if

                          end if
                       end if

                       x = grid(iG)%xAxis(1)+x*(grid(iG)%xAxis(grid(iG)%nx)-grid(iG)%xAxis(1))
                       y = grid(iG)%yAxis(1)+y*(grid(iG)%yAxis(grid(iG)%ny)-grid(iG)%yAxis(1))
                       z = grid(iG)%zAxis(1)+z*(grid(iG)%zAxis(grid(iG)%nz)-grid(iG)%zAxis(1))

                       if (ix == grid(iG)%nx) then
                          if ( abs(x-grid(iG)%xAxis(ix)) >= abs(grid(iG)%xAxis(ix)-grid(iG)%xAxis(ix-1))  ) then
                             print*, "! setSubGrids: insanity occurred in setting xAxis for subGrid ", iG,dFileRead,&
                                  & grid(iG)%xAxis
                             stop
                          end if
                       end if
                       if (iy == grid(iG)%ny) then
                          if ( abs(y-grid(iG)%yAxis(iy)) >= abs(grid(iG)%yAxis(iy)-grid(iG)%yAxis(iy-1))  ) then
                             print*, "! setSubGrids: insanity occurred in setting yAxis for subGrid ", iG,dFileRead,&
                                  & grid(iG)%yAxis
                             stop
                          end if
                       end if
                       if (iz == grid(iG)%nz) then
                          if ( abs(z-grid(iG)%zAxis(iz)) >= abs(grid(iG)%zAxis(iz)-grid(iG)%zAxis(iz-1))  ) then
                             print*, "! setSubGrids: insanity occurred in setting zAxis for subGrid ", iG,dFileRead,&
                                  & grid(iG)%zAxis
                             stop
                          end if
                       end if

                       grid(iG)%xAxis(ix) = x
                       grid(iG)%yAxis(iy) = y
                       grid(iG)%zAxis(iz) = z

                       radius = 1.e10*sqrt( (grid(iG)%xAxis(ix)/1.e10)*(grid(iG)%xAxis(ix)/1.e10) + &
                            & (grid(iG)%yAxis(iy)/1.e10)*(grid(iG)%yAxis(iy)/1.e10) + &
                            & (grid(iG)%zAxis(iz)/1.e10)*(grid(iG)%zAxis(iz)/1.e10) )


                       ! check if this grid point is  valid nebular point
                       if (.not. lgPlaneIonization) then

                          if (radius < R_in) then
                             grid(iG)%active(ix,iy,iz) = 0
                          else if (radius > R_out .and. R_out>0.) then
                             grid(iG)%active(ix,iy,iz) = 0
                          end if

                       end if

                       if (grid(iG)%active(ix,iy,iz) <= 0 .and. lgDust ) then
                          NdustTemp(ix,iy,iz) = 0.
                          if (lgMultiDustChemistry) dustAbunIndexTemp(ix,iy,iz) = 0.
                       end if
                       if (grid(iG)%active(ix,iy,iz) <= 0 .and. lgGas ) HdenTemp(ix,iy,iz) = 0.

                       if (lgDust .and. lgGas) then
                          if (HdenTemp(ix,iy,iz) > 0. .or. NdustTemp(ix,iy,iz)>0.) then
                             grid(iG)%nCells =  grid(iG)%nCells + 1
                             grid(iG)%active(ix,iy,iz) =  grid(iG)%nCells
                          else
                             grid(iG)%active(ix,iy,iz) = 0
                             HdenTemp(ix,iy,iz) = 0.
                             NdustTemp(ix,iy,iz) = 0.
                             if (lgMultiDustChemistry) dustAbunIndexTemp(ix,iy,iz) = 0.
                          end if
                       else if ( lgDust .and. (.not.lgGas) ) then
                          if (NdustTemp(ix,iy,iz)>0.) then
                             grid(iG)%nCells =  grid(iG)%nCells + 1
                             grid(iG)%active(ix,iy,iz) =  grid(iG)%nCells
                          else
                             grid(iG)%active(ix,iy,iz) = 0
                             NdustTemp(ix,iy,iz) = 0.
                             if (lgMultiDustChemistry) dustAbunIndexTemp(ix,iy,iz) = 0.
                          end if
                       else if ( (.not.lgDust) .and. lgGas) then
                          if (HdenTemp(ix,iy,iz) > 0.) then
                             grid(iG)%nCells =  grid(iG)%nCells + 1
                             grid(iG)%active(ix,iy,iz) =  grid(iG)%nCells
                          else
                             grid(iG)%active(ix,iy,iz) = 0
                             HdenTemp(ix,iy,iz) = 0.
                          end if
                       else

                          print*, '! setSubGrids: no gas and no dust? The grid is empty.'
                          stop
                       end if
                    end do
                 end do
              end do

              close(72)

              ! allocate grid arrays

              if (lgGas) then

                 allocate(grid(iG)%Hden(0:grid(iG)%nCells), stat = err)
                 if (err /= 0) then
                    print*, "! setSubGrid: can't allocate grid memory"
                    stop
                 end if

                 allocate(grid(iG)%recPDF(0:grid(iG)%nCells, 1:nbins), stat = err)
                 if (err /= 0) then
                    print*, "Can't allocate grid memory, 8"
                    stop
                 end if

                 allocate(grid(iG)%totalLines(0:grid(iG)%nCells), stat = err)
                 if (err /= 0) then
                    print*, "Can't allocate grid memory, 10"
                    stop
                 end if

                 allocate(grid(iG)%ionDen(0:grid(iG)%nCells, 1:nElementsUsed, 1:nstages), stat = err)
                 if (err /= 0) then
                    print*, "! setSubGrid: can't allocate grid memory,ionDen"
                    stop
                 end if
if (allocated(ionDenUsed)) deallocate (ionDenUsed)
                 allocate(ionDenUsed(1:nElementsUsed, 1:nstages), stat = err)
                 if (err /= 0) then
                    print*, "! setSubGrid: can't allocate grid memory,ionDenUsed"
                    stop
                 end if
                 allocate(grid(iG)%Ne(0:grid(iG)%nCells), stat = err)
                 if (err /= 0) then
                    print*, "! setSubGrid: can't allocate grid memory"
                    stop
                 end if
                 allocate(grid(iG)%Te(0:grid(iG)%nCells), stat = err)
                 if (err /= 0) then
                    print*, "! setSubGrid:can't allocate grid memory"
                    stop
                 end if

                 grid(iG)%Hden = 0.
                 grid(iG)%Ne = 0.
                 grid(iG)%Te = 0.
                 grid(iG)%ionDen = 0.
                 grid(iG)%recPDF = 0.
                 grid(iG)%totalLines = 0.

              end if

              if (Ldiffuse>0.) then
                 allocate(grid(iG)%LdiffuseLoc(0:grid(iG)%nCells), stat = err)
                 if (err /= 0) then
                    print*, "! setSubGrid: can't allocate grid memory : LdiffuseLoc "
                    stop
                 end if
              grid(iG)%LdiffuseLoc=0.
              end if


              allocate(grid(iG)%opacity(0:grid(iG)%nCells, 1:nbins), stat = err)
              if (err /= 0) then
                 print*, "! setSubGrid: can't allocate grid memory : opacity "
                 stop
              end if
              allocate(grid(iG)%Jste(0:grid(iG)%nCells, 1:nbins), stat = err)
              if (err /= 0) then
                 print*, "! setSubGrid: can't allocate grid memory : Jste"
                 stop
              end if

              allocate(grid(iG)%escapedPackets(0:grid(iG)%nCells, 0:nbins,0:nAngleBins), stat = err)
              if (err /= 0) then
                 print*, "! setSubGrid: can't allocate grid memory : escapedPackets"
                 stop
              end if

              if (lgDust) then
                 allocate(grid(iG)%Ndust(0:grid(iG)%nCells), stat = err)
                 if (err /= 0) then
                    print*, "! grid: can't allocate Ndust memory"
                    stop
                 end if
                 grid(iG)%Ndust=0.

                 allocate(grid(iG)%dustAbunIndex(0:grid(iG)%nCells), stat = err)
                 if (err /= 0) then
                    print*, "! grid: can't allocate dustAbunIndex memory"
                    stop
                 end if
                 grid(iG)%dustAbunIndex=0

                 if (.not.lgGas) then
                    allocate(grid(iG)%dustPDF(0:grid(iG)%nCells, 1:nbins), stat = err)
                    if (err /= 0) then
                       print*, "! grid: can't allocate dustPDF memory"
                       stop
                    end if
                    grid(iG)%dustPDF = 0.
                 end if

              end if

!BS10              if (lgDebug) then
                 allocate(grid(iG)%Jdif(0:grid(iG)%nCells, 1:nbins), stat = err)
                 if (err /= 0) then
                    print*, "! grid: can't allocate grid memory"
                    stop
                 end if

                 grid(iG)%Jdif = 0.

                 ! allocate pointers depending on nLines
                 if (nLines > 0) then

                    allocate(grid(iG)%linePackets(0:grid(iG)%nCells, 1:nLines), stat = err)
                    if (err /= 0) then
                       print*, "! initCartesianGrid: can't allocate grid(iG)%linePackets memory"
                       stop
                    end if

                    allocate(grid(iG)%linePDF(0:grid(iG)%nCells, 1:nLines), stat = err)
                    if (err /= 0) then
                       print*, "! initCartesianGrid: can't allocate grid(iG)%linePDF memory"
                       stop
                    end if

                    grid(iG)%linePackets = 0.
                    grid(iG)%linePDF     = 0.

                 end if

!BS10              end if

              allocate(grid(iG)%lgConverged(0:grid(iG)%nCells), stat = err)
              if (err /= 0) then
                 print*, "Can't allocate memory to lgConverged array"
                 stop
              end if

              allocate(grid(iG)%lgBlack(0:grid(iG)%nCells), stat = err)
              if (err /= 0) then
                 print*, "Can't allocate memory to lgBlack array"
                 stop
              end if


              if (lgNeInput) then
                 allocate(grid(iG)%NeInput(0:grid(iG)%nCells), stat = err)
                 if (err /= 0) then
                    print*, "! setSubGrid: can't allocate grid memory, grid(iG)%NeInput"
                    stop
                 end if
                 grid(iG)%NeInput = 0.
              end if

              grid(iG)%opacity = 0.
              grid(iG)%Jste = 0.
              grid(iG)%lgConverged = 0
              grid(iG)%lgBlack = 0

              do ix = 1, grid(iG)%nx
                 do iy = 1, grid(iG)%ny
                    do iz = 1, grid(iG)%nz
                       if (grid(iG)%active(ix,iy,iz)>0) then

                          if (lgGas) then
                             grid(iG)%Hden(grid(iG)%active(ix,iy,iz)) = HdenTemp(ix,iy,iz)*denfac
                             grid(iG)%Te(grid(iG)%active(ix,iy,iz)) = TeStart
                          end if
                          if (lgDust) then
                             grid(iG)%Ndust(grid(iG)%active(ix,iy,iz)) = NdustTemp(ix,iy,iz)*denfac
                             if (lgMultiDustChemistry) grid(iG)%dustAbunIndex(grid(iG)%active(ix,iy,iz)) =  nint(dustAbunIndexTemp(ix,iy,iz)*denfac)
                          end if
                       end if
                    end do
                 end do
              end do

              if (lgNeInput) then
                 grid(iG)%NeInput = grid(iG)%Hden
                 ! 1.11 is just a starting guess for the ionization
                 ! factor
                 grid(iG)%Hden = grid(iG)%Hden/1.11
              end if

              if (lgGas) then

                 H0in  = 1.e-5

                 do ix = 1, grid(iG)%nx
                    do iy = 1, grid(iG)%ny
                       do iz = 1, grid(iG)%nz

                          if (grid(iG)%active(ix,iy,iz)>0 ) then

                             ! calculate ionDen for H0
                             if (lgElementOn(1)) then
                                grid(iG)%ionDen(grid(iG)%active(ix,iy,iz),elementXref(1),1) = H0in
                                grid(iG)%ionDen(grid(iG)%active(ix,iy,iz),elementXref(1),2) = &
                                     & 1.-grid(iG)%ionDen(grid(iG)%active(ix,iy,iz),elementXref(1),1)
                             end if
                             if (lgElementOn(2)) then
                                grid(iG)%ionDen(grid(iG)%active(ix,iy,iz),elementXref(2),1) = &
                                     & grid(iG)%ionDen(grid(iG)%active(ix,iy,iz),elementXref(1),1)
                                grid(iG)%ionDen(grid(iG)%active(ix,iy,iz),elementXref(2),2) = &
                                 & (1.-grid(iG)%ionDen(grid(iG)%active(ix,iy,iz),elementXref(2),1))
                                grid(iG)%ionDen(grid(iG)%active(ix,iy,iz),elementXref(2),3) = 0.
                             end if

                             ! initialize Ne
                             grid(iG)%Ne(grid(iG)%active(ix,iy,iz)) =  grid(iG)%Hden(grid(iG)%active(ix,iy,iz))

                             ! initialize all heavy ions (careful that the sum over all ionisation
                             ! stages of a given atom doesn't exceed 1.)
                             do elem = 3, nElements
                                do ion = 1, min(elem+1,nstages)
                                   if (lgElementOn(elem)) then
                                      if (ion == 1) then
                                         grid(iG)%ionDen(grid(iG)%active(ix,iy,iz),elementXref(elem),ion) &
                                              & = grid(iG)%ionDen(grid(iG)%active(ix,iy,iz),1,1)
                                      else
                                         grid(iG)%ionDen(grid(iG)%active(ix,iy,iz),elementXref(elem),ion) = 0.
                                      end if
                                   end if
                                end do
                             end do
                          end if     ! active condition

                       end do
                    end do
                 end do

                 ! deallocate temp array
                 if(allocated(HdenTemp)) deallocate(HdenTemp)

              end if ! lgGas

              if (lgDust) then
                 if(allocated(NdustTemp)) deallocate(NdustTemp)
                 if (lgMultiDustChemistry .and. allocated(dustAbunIndexTemp)) deallocate(dustAbunIndexTemp)
              end if

              totalMass = 0.
              totalVolume = 0.
              echoVolume = 0.

              do ix = 1, grid(iG)%nx
                 do iy = 1, grid(iG)%ny
                    do iz = 1, grid(iG)%nz
                       if (grid(iG)%active(ix,iy,iz)>0) then

                          dV = getVolume(grid(iG),ix,iy,iz)

                          if (lgGas) then
                             gasCell = 0.
                             do elem = 1, nElements
                                gasCell = gasCell + &
                                     & grid(iG)%elemAbun(grid(iG)%abFileIndex(ix,iy,iz),elem)*&
                                     & aWeight(elem)*amu
                                totalMass = totalMass + &
                                     & grid(iG)%Hden(grid(iG)%active(ix,iy,iz))*dV*&
                                     & grid(iG)%elemAbun(grid(iG)%abFileIndex(ix,iy,iz),elem)*&
                                     & aWeight(elem)*amu
                             end do
                          end if

                          totalVolume = totalVolume + dV
!
! echoes only
!
                          if (lgEcho) then
                             grid(iG)%echoVol(i,j,k)=vEcho(grid(iG),i,j,k,echot1,echot2,vol)
                             echoVolume = echoVolume + vol
                          endif


                          if (lgDust .and. lgMdMg .or. lgMdMh) then

                             if (lgMdMh) then
                                MhMg=0.
                                do elem = 1, nElements
                                   ! transform to MdMg
                                   MhMg = MhMg+grid(iG)%elemAbun(grid(iG)%abFileIndex(ix,iy,iz),elem)*&
                                        & aWeight(elem)
                                end do
                                MhMg = 1./MhMg
                                grid(iG)%Ndust(grid(iG)%active(ix,iy,iz)) = grid(iG)%Ndust(grid(iG)%active(ix,iy,iz))*MhMg
                             end if

                             if (.not.lgGas) then
                                print*, '! setSubGrid: Mass to dust ratio (MdMg) cannot be used in a pure dust (noGas)&
                                     & simulation. Ndust must be used instead.'
                                stop
                             end if

                             grid(iG)%Ndust(grid(iG)%active(ix,iy,iz)) = gasCell*grid(iG)%Ndust(grid(iG)%active(ix,iy,iz)) &
                                 & *grid(iG)%Hden(grid(iG)%active(ix,iy,iz))

                             denominator = 0.

                             if (lgMultiDustChemistry) then
                                nsp = grid(iG)%dustAbunIndex(grid(iG)%active(ix,iy,iz))
                             else
                                nsp = 1
                             end if

                             do nspec = 1, nSpeciesPart(nsp)
                                do ai = 1, nSizes
                                   denominator = denominator + &
                                        & (1.3333*Pi*( (grainRadius(ai)*1.e-4)**3)*&
                                        & rho(dustComPoint(nsp)-1+nspec)&
                                        &*grainWeight(ai)*grainAbun(nsp,nspec))
                                end do
                             end do
                             grid(iG)%Ndust(grid(iG)%active(ix,iy,iz)) = grid(iG)%Ndust(grid(iG)%active(ix,iy,iz))/&
                                  & (denominator)

                          end if

                          ! calculate total dust mass
                          if (lgDust) then

                             if (lgMultiDustChemistry) then
                                nsp = grid(iG)%dustAbunIndex(grid(iG)%active(ix,iy,iz))
                             else
                                nsp = 1
                             end if

                             do ai = 1, nsizes
                                do nspec = 1, nspeciesPart(nsp)
                                   totalDustMass = totalDustMass + &
                                        &(1.3333*Pi*((grainRadius(ai)*1.e-4)**3)*&
                                        & rho(dustComPoint(nsp)-1+nspec)*&
                                        & grainWeight(ai)*grainAbun(nsp,nspec)&
                                        & *grid(iG)%Ndust(grid(iG)%active(ix,iy,iz))*dV)
                                end do
                             end do

                          end if

                       end if
                    end do
                 end do
              end do

              if (taskid == 0) then

                 print*, 'Sub Grid: ', iG
                 if (lgGas) &
                    &print*, 'Total gas mass of ionized region by mass [1.e45 g]: ', totalMass
                     print*, '                                         [Msol]   : ', totalMass*5.025e11


                 print*, 'Total volume of the active region [e45 cm^3]: ', totalVolume
                 if (lgEcho) print*, 'Total volume of the echo region [e45 cm^3]: ', echoVolume
                 print*, '! Number of active cells :', grid(iG)%nCells
              end if

           end do

         end subroutine setSubGrids

         subroutine freeGrid(grid)

           type(grid_type), intent(inout) :: grid
           print*, "in freeGrid"

           if (lgDust) then
              if(allocated(grid%absOpac)) deallocate(grid%absOpac)
              if(allocated(grid%scaOpac)) deallocate(grid%scaOpac)
              if(allocated(grid%Ndust)) deallocate(grid%Ndust)
              if(allocated(grid%Tdust)) deallocate(grid%Tdust)
              if (lgMultiChemistry .and. allocated(grid%dustAbunIndex)) &
                   &  deallocate(grid%dustAbunIndex)
              if (.not.lgGas) then
                 if(allocated(grid%dustPDF)) deallocate(grid%dustPDF)
              end if
           end if
           if (allocated(grid%active)) deallocate(grid%active)
           if (allocated(grid%lgConverged)) deallocate(grid%lgConverged)
           if (allocated(grid%lgBlack)) deallocate(grid%lgBlack)
           if (lgGas) then
              if (allocated(grid%abFileIndex)) deallocate(grid%abFileIndex)
              if (allocated(grid%Te)) deallocate(grid%Te)
              if (allocated(grid%Ne)) deallocate(grid%Ne)
              if (allocated(grid%Hden)) deallocate(grid%Hden)
              if (allocated(grid%ionDen)) deallocate(grid%ionDen)
              if (allocated(ionDenUsed)) deallocate(ionDenUsed)
              if (allocated(grid%recPDF)) deallocate(grid%recPDF)
              if (allocated(grid%totalLines)) deallocate(grid%totalLines)
           end if
           if (allocated(grid%opacity)) deallocate(grid%opacity)
           if (allocated(grid%Jste)) deallocate(grid%Jste)
!BS10           if (lgDebug) then
              if (allocated(grid%Jdif)) deallocate(grid%Jdif)
              if (allocated(grid%linePackets)) deallocate(grid%linePackets)
              if (allocated(grid%linePDF)) deallocate(grid%linePDF)
!BS10           end if
           if (lgNeInput) then
               if (allocated(grid%NeInput)) deallocate(grid%NeInput)
           end if
           if (allocated(grid%xAxis)) deallocate(grid%xAxis)
           if (allocated(grid%yAxis)) deallocate(grid%yAxis)
           if (allocated(grid%zAxis)) deallocate(grid%zAxis)

           print*, "out freeGrid"
         end subroutine freeGrid

         subroutine writeGrid(grid)
           implicit none

           type(grid_type), dimension(:), intent(in) :: grid                ! grid

           ! local variables
           integer                     :: cellP               ! cell pointer
           integer                     :: elem                ! element counter
           integer                     :: ion                 ! ion counter
           integer                     :: ios                 ! I/O error status
           integer                     :: i,j,k,iG,ai         ! counters
           integer                     :: yTop                ! 2D index

           print* , 'in writeGrid'

           close(21)
           open(unit=21, file="output/grid0.out",  action="write", position="rewind",status="unknown", iostat = ios)
           if (ios /= 0 ) then
              print*, "! writeGrid: can't open file for writing - output/grid1.out"
              stop
           end if

           if (lgGas) then
              ! open files for writing
              close(20)
              open(unit=20, file="output/grid1.out", action="write",position="rewind",status="unknown", iostat = ios)
              if (ios /= 0 ) then
                 print*, "! writeGrid: can't open file for writing - output/grid1.out"
                 stop
              end if
              close(30)
              open(unit=30, file="output/grid2.out", action="write",position="rewind",status="unknown", iostat = ios)
              if (ios /= 0 ) then
                 print*, "! writeGrid: can't open file for writing - output/grid2.out"
                 stop
              end if
           end if
           if (lgDust) then
              close(50)
              open(unit=50, file="output/dustGrid.out", action="write",position="rewind",status="unknown", iostat = ios)
              if (ios /= 0 ) then
                 print*, "! writeGrid: can't open file for writing - output/dustGrid.out"
                 stop
              end if
           end if

           do iG = 1, nGrids

              ! write nx, ny, nz, to file
              write(21, *) nGrids
              write(21, *) grid(iG)%nx, grid(iG)%ny, grid(iG)%nz, grid(iG)%nCells, grid(iG)%motherP, R_out

              ! write x, y, and z axis to the file
              do i = 1, grid(iG)%nx
                 write(21,*) grid(iG)%xAxis(i)
              end do
              do i = 1, grid(iG)%ny
                 write(21,*) grid(iG)%yAxis(i)
              end do
              do i = 1, grid(iG)%nz
                 write(21,*) grid(iG)%zAxis(i)
              end do

              if (iG>1 .or. (.not. lg2D)) then
                 yTop = grid(iG)%ny
              else if (iG == 1 .and. lg2D) then
                 yTop = 1
              end if


              ! write the rest of the grid to files
              do i = 1, grid(iG)%nx
                 do j = 1, yTop
                 do k = 1, grid(iG)%nz

                    cellP = grid(iG)%active(i,j,k)

                    if (cellP<0) cellP=0

                    write(21, *) grid(iG)%active(i,j,k), grid(iG)%lgConverged(cellP), &
                         & grid(iG)%lgBlack(cellP)


                    if (lgGas) then
                       if (lgMultiChemistry) then
                          write(20, *) grid(iG)%Te(cellP), grid(iG)%Ne(cellP), &
                               & grid(iG)%Hden(cellP), grid(iG)%abFileIndex(i,j,k)
                       else
                          write(20, *) grid(iG)%Te(cellP), grid(iG)%Ne(cellP), &
                               & grid(iG)%Hden(cellP)
                       end if

                       do elem = 1, nElements
                          if (lgElementOn(elem)) then

                             write(30, *) (grid(iG)%ionDen(cellP,elementXref(elem),ion), ion =1, &
                                  & min(elem+1,nstages))
                          end if
                       end do
                    end if
                    if (lgDust) then

                       if (lgMultiChemistry) then
                          write(50, *) grid(iG)%Ndust(cellP), grid(iG)%dustAbunIndex(cellP)
                       else
                          write(50, *) grid(iG)%Ndust(cellP)
                       end if
                       do ai = 0, nSizes
                          write(50, *) (grid(iG)%Tdust(elem,ai,cellP),' ', elem=0,nSpeciesMax)
                       end do

                    end if

                 end do
              end do
           end do

        end do

        ! close files
        close(21)
        if (lgGas) then
           close(20)
           close(30)
        end if
        if (lgDust) then
           write(50,*) ' '
           write(50,*) 'Total dust mass [1.e45 g]: ', totalDustMass
           write(50,*) 'Total dust mass [Msol]: ', totalDustMass*5.028e11
           close(50)
        end if

        ! stellar parameters
        close(42)
        open(unit=42, file="output/photoSource.out", action="write",position="rewind",status="unknown", iostat = ios)
        if (ios /= 0 ) then
            print*, "! writeGrid: can't open file for writing - output/photoSource.out"
            stop
        end if


        write(42, *) nStars, ' number of photon sources'
        do i = 1, nStars
           write(42, *) "'",trim(contShapeIn(i)),"'", TStellar(i), LStar(i), nPhotons(i), &
                & starPosition(i)%x/grid(1)%xAxis(grid(1)%nx),&
                & starPosition(i)%y/grid(1)%yAxis(grid(1)%ny),&
                & starPosition(i)%z/grid(1)%zAxis(grid(1)%nz),&
                & trim(spID(i)), tStep(i)
           if (contShapeIn(i)=='powerlaw') write(42,*) pwlIndex
        end do

        write(42, *) '(contShape, T_eff[K], L_* [E36 erg/s], nPackets, (x,y,z) position, spID, tstep)'
        close(42)

        ! general simulation parameters
        close(40)
        open(unit=40, file="output/grid3.out", action="write",position="rewind",status="unknown", iostat = ios)
        if (ios /= 0 ) then
            print*, "! writeGrid: can't open file for writing - output/grid3.out"
            stop
        end if

        write(40, *) nGrids
        write(40, *) convWriteGrid, ' convWriteGrid'
        write(40, *) lgAutoPackets, convIncPercent, nPhotIncrease, maxPhotons, ' lgAutoPackets'
        write(40, *) lgSymmetricXYZ, ' lgSymmetricXYZ'
        write(40, *) lgTalk, ' lgTalk'
        write(40, *) lg1D, ' lg1D'
        write(40, *) nbins, ' nbins'
        write(40, *) nuStepSize, ' nuStepSize'
        write(40, *) nuMax,' nuMax'
        write(40, *) nuMin, ' nuMin'
        write(40, *) R_in, ' R_in'
        write(40, *) XHIlimit, ' XHIlimit'
        write(40, *) maxIterateMC, minConvergence, ' maxIterateMC'
        write(40, *) lgDebug, ' lgDebug'
        write(40, *) lgPlaneIonization, ' lgPlaneIonization'
        write(40, *) nAbComponents, ' nAbComponents'
        do i=1,nAbComponents
           write(40,*) '"',abundanceFile(i),'"'
        end do
        write(40, *) lgOutput, ' lgOutput'
        write(40, *) dxSlit,dySlit,' dxSlit,dySlit'
        write(40, *) lgDust, lgDustConstant, ' lgDust, lgDustConstant'
        write(40, *) lgMultiDustChemistry, nDustCOmponents, ' lgMultiDustChemistry, nDustComponents'
        if (lgDust) then
           do i = 1, nDustComponents
              write(40, *) '"',trim(dustSpeciesFile(i)),'"', ' dustFile'
           end do
        else
           write(40, *) 'none', ' dustFile'
        end if
        write(40, *) '"',trim(dustFile(2)),'"', ' dustFile'
        write(40, *) lgGas, ' lgGas'
        write(40, *) lgRecombination, ' lgRecombination'
        if (lgDust) then
           write(40, *) nSpeciesMax, nSpecies, nSizes, ' nSpeciesMax, nSpecies, nSizes'
           write(40, *) (nSpeciesPart(i), i=1, nDustComponents) , ' Partial nspecies'
        else
           write(40, *) 1, 1, 1, ' nSpeciesMax, nSpecies, nSizes'
           write(40, *) 1, ' Partial nspecies'
        end if
        write(40, *) resLinesTransfer, 'resLinesTransfer'
        write(40, *) lgDustScattering, 'lgDustScattering'
        write(40, *) nAngleBins, ' nAngleBins'
        if (nanglebins>0) then
           write(40, *) viewPointTheta, ' inclination theta'
           write(40, *) viewPointPhi, ' inclination theta'
        end if
        write(40, *) contCube(1),contCube(2), ' continuumCube'
        write(40, *) lgPhotoelectric, ' lgPhotoelectric'
        write(40, *) lgTraceHeating, ' lgTraceHeating'
        write(40, *) Ldiffuse, ' Ldiffuse'
        write(40, *) Tdiffuse, ' Tdiffuse'
        write(40, *) shapeDiffuse, ' shapeDiffuse'
        write(40, *) nPhotonsDiffuse, 'nPhotonsDiffuse'
        write(40, *) emittingGrid, ' emittingGrid'
        write(40, *) nstages, ' emittingGrid'
        write(40, *) lgMultistars, ' lgMultiStars'
        write(40,*)  lg2D, ' 2D geometry?'
        write(40,*) lgEcho, echot1, echot2, echoTemp," Echo on/off"
        write(40,*) lgNosource," NoSourceSED"
        ! close file
        close(40)

        print*, 'out writeGrid'
      end subroutine writeGrid


      ! this function returns the volume of a cell in [e45 cm^3]
      function getVolume(grid,xP, yP, zP)
        implicit none

        type(grid_type),intent(in) :: grid              ! the grid

        integer, intent(in)        :: xP, yP, zP        ! cell indeces

        real                       :: getVolume         ! volume of the cell [e45 cm^3]

        ! local variables

        real                       :: dx, &             ! cartesian axes increments
&                                      dy, &             ! in [cm]
&                                      dz                !

        if (lg1D) then
           if (nGrids>1) then
              print*, '! getVolume: 1D option and multiple grids options are not compatible'
              stop
           end if

           if (xP == 1) then

              getVolume = 4.*Pi* ( (grid%xAxis(xP+1)/1.e15)**3)/3.


           else if ( xP==grid%nx) then

              getVolume = Pi* ( (3.*(grid%xAxis(xP)/1.e15)-(grid%xAxis(xP-1)/1.e15))**3 - &
                   & ((grid%xAxis(xP)/1.e15)+(grid%xAxis(xP-1)/1.e15))**3 ) / 6.

           else

              getVolume = Pi* ( ((grid%xAxis(xP+1)/1.e15)+(grid%xAxis(xP)/1.e15))**3 - &
                   & ((grid%xAxis(xP-1)/1.e15)+(grid%xAxis(xP)/1.e15))**3 ) / 6.

           end if

           getVolume = getVolume/8.

        else

           if ( (xP>1) .and. (xP<grid%nx) ) then
              dx = abs(grid%xAxis(xP+1)-grid%xAxis(xP-1))/2.
           else if ( xP==1 ) then
              if (lgSymmetricXYZ) then
                 dx = abs(grid%xAxis(xP+1)-grid%xAxis(xP))/2.
              else
                 dx = abs(grid%xAxis(xP+1)-grid%xAxis(xP))
              end if
           else if ( xP==grid%nx ) then
              dx = abs(grid%xAxis(xP)  -grid%xAxis(xP-1))
           end if

           if ( (yP>1) .and. (yP<grid%ny) ) then
              dy = abs(grid%yAxis(yP+1)-grid%yAxis(yP-1))/2.
           else if ( yP==1 ) then
              if (lgSymmetricXYZ) then
                 dy = abs(grid%yAxis(yP+1)-grid%yAxis(yP))/2.
              else
                dy = abs(grid%yAxis(yP+1)-grid%yAxis(yP))
             end if
          else if ( yP==grid%ny ) then
             dy = abs(grid%yAxis(yP)  -grid%yAxis(yP-1))
          end if

          if ( (zP>1) .and. (zP<grid%nz) ) then
             dz = abs(grid%zAxis(zP+1)-grid%zAxis(zP-1))/2.
          else if ( zP==1 ) then
             if (lgSymmetricXYZ) then
                dz = abs(grid%zAxis(zP+1)-grid%zAxis(zP))/2.
             else
                dz = abs(grid%zAxis(zP+1)-grid%zAxis(zP))
             end if
          else if ( zP==grid%nz ) then
             dz = abs(grid%zAxis(zP)-grid%zAxis(zP-1))
          end if

          dx = dx/1.e15
          dy = dy/1.e15
          dz = dz/1.e15


          ! calculate the volume
          getVolume = dx*dy*dz


       end if

    end function getVolume

    subroutine resetGrid(grid)
      implicit none

      type(grid_type), intent(inout) :: grid(maxGrids)  ! the 3d grids

      ! local variables

      integer                        :: cellP ! cell pointer
      integer                        :: err,ios   ! I/O error status
      integer                        :: i,j,k ! counters
      integer                        :: elem,&!
&                                       ion,i1 ! counters
      real                           :: p0,p00,p1,p2,p3,ind
      real, allocatable                  :: p(:)
      integer :: iG, ai  ! counters
      integer :: totCells, totcellsloc
      integer :: yTop, xPmap


      integer, parameter :: maxLim = 10000
      integer, parameter :: nSeries = 17

      real                 :: radius

      print*, 'resetGrid in'


      ! read stellar parameters
      close(72)
      open(unit=72, file="output/photoSource.out",action="read", position="rewind",status="old", iostat = ios)
      if (ios /= 0 ) then
         print*, "! writeGrid: can't open file for reading - output/photoSource.out"
         stop
      end if


       read(72, *) nStars
       print*, nStars, ' photon sources'
       print*, '(contShape, T_eff[K], L_* [E36 erg/s], nPackets, (x,y,z) position [cm])'
       allocate(TStellar(nStars))
       allocate(LStar(nStars))
       allocate(nPhotons(nStars))
       allocate(starPosition(nStars))
       allocate(contShape(nStars))
       allocate(contShapeIn(nStars))
       allocate(spID(nStars))
       allocate(tStep(nStars))
       allocate(deltaE(0:nStars))

       do i = 1, nStars
          read(72, *) contShape(i), TStellar(i), LStar(i), nPhotons(i), starPosition(i)%x,starPosition(i)%y,&
               &starPosition(i)%z,spID(i), tStep(i)
          contShapeIn(i)=contShape(i)
          if (contShape(i)=='powerlaw') read(72,*) pwlIndex
          print*, i, contShape(i), TStellar(i), LStar(i), nPhotons(i), starPosition(i)%x,starPosition(i)%y,&
               &starPosition(i)%z, spID(i), tStep(i)
          print*, pwlIndex
          deltaE(i) = Lstar(i)/nPhotons(i)
          print*, 'deltaE', deltaE(i), i
       end do
       close(72)

      ! read in file containing general simulation parameters
      close(77)
      open(unit=77, file='output/grid3.out', action="read",position='rewind',  &
&          status='old', iostat = err)
      if (err /= 0) then
         print*, "! resetMotherGrid: error opening file  output/grid3.out"
         stop
      end if

      read(77, *) nGrids
      read(77, *) convWriteGrid
      read(77, *) lgAutoPackets, convIncPercent, nPhotIncrease, maxPhotons
      read(77, *) lgSymmetricXYZ
      read(77, *) lgTalk
      read(77, *) lg1D
      read(77, *) nbins
      read(77, *) nuStepSize
      read(77, *) nuMax
      read(77, *) nuMin
      read(77, *) R_in
      read(77, *) XHIlimit
      read(77, *) maxIterateMC, minConvergence
      read(77, *) lgDebug
      read(77, *) lgPlaneIonization
      read(77, *) nAbComponents
      allocate(abundanceFile(nAbComponents))
      if (nAbComponents>1) then
         lgMultiChemistry = .true.
      else
         lgMultiChemistry = .false.
      end if
      do i = 1, nAbComponents
         read(77, *) abundanceFile(i)
      end do
      read(77, *) lgOutput
      read(77, *) dxSlit, dySlit
      read(77, *) lgDust, lgDustConstant
      read(77, *) lgMultiDustChemistry, nDustComponents
      allocate(dustSpeciesFile(1:nDustComponents))
      do i = 1, nDustComponents
         read(77, *) dustSpeciesFile(i)
      end do
      read(77, *) dustFile(2)
      read(77, *) lgGas
      read(77, *) lgRecombination
      read(77, *) nSpeciesMax,nSpecies, nSizes
      allocate(nSpeciesPart(1:nDustComponents))
      read(77, *) (nSpeciesPart(i), i = 1, nDustComponents)
      read(77, *) resLinesTransfer
      read(77, *) lgDustScattering
      read(77, *) nAngleBins
      if (nanglebins>0) then
         allocate(viewPointTheta(0:nAngleBins), stat=err)
         if (err /= 0) then
            print*, '! readInput: allocation error for viewPoint pointer'
            stop
         end if
         viewPointTheta = 0.
         allocate(viewPointPhi(0:nAngleBins), stat=err)
         if (err /= 0) then
            print*, '! readInput: allocation error for viewPoint pointer'
            stop
         end if
         viewPointPhi = 0.
         read(77, *) (viewPointTheta(i), i = 1, nAngleBins)
         read(77, *) (viewPointPhi(i), i = 1, nAngleBins)
      end if
      read(77, *) contCube(1),contCube(2)
      read(77, *) lgPhotoelectric
      read(77, *) lgTraceHeating
      read(77, *) Ldiffuse
      read(77, *) Tdiffuse
      read(77, *) shapeDiffuse
      read(77, *) nPhotonsDiffuse
      if (Ldiffuse>0. .and. nPhotonsDiffuse>0 ) then
         deltaE(0) = Ldiffuse/nPhotonsDiffuse
      end if
      read(77, *) emittingGrid
      read(77, *) nstages
      read(77, *) lgMultistars
      read(77, *) lg2D
      read(77, *) lgEcho, echot1, echot2, echoTemp
      read(77,*) lgNosource

      if (taskid == 0) then
         print*,  nGrids,'nGrids'
         print*,  convWriteGrid, ' convWriteGrid'
         print*,  lgAutoPackets, convIncPercent, nPhotIncrease, maxPhotons, &
              & ' lgAutoPackets, convIncPercent, nPhotIncrease, maxPhotons'
         print*,  lgSymmetricXYZ, ' lgSymmetricXYZ'
         print*,  lgTalk, ' lgTalk'
         print*,  lg1D, ' lg1D'
         print*,  nbins, ' nbins'
         print*,  nuStepSize, ' nuStepSize.'
         print*,  nuMax, ' nuMax'
         print*,  nuMin, ' nuMin'
         print*,  R_in, ' R_in'
         print*,  XHIlimit, ' XHIlimit'
         print*,  maxIterateMC, minConvergence, ' maxIterateMC, minConvergence'
         print*,  lgDebug,  ' lgDebug'
         print*,  lgPlaneIonization, ' lgPlaneIonization'
         print*,  nAbComponents, ' nAbComponents'
         print*,  lgMultiChemistry, ' ',abundanceFile, ' lgMultiChemistry, abundanceFile'
         print*,  lgOutput, ' lgOutput'
         print*,  dxSlit, dySlit, ' dxSlit, dySlit'
         print*,  lgDust, lgDustConstant, ' lgDust, lgDustConstant'
         print*,  lgMultiDustChemistry, nDustComponents, ' lgMultiDustChemistry, nDustComponents'
         do i =1 , nDustComponents
            print*,  dustSpeciesFile(i), ' dustFiles'
         end do
         print*,  dustFile(2)
         print*,  lgGas, ' lgGas'
         print*,  lgRecombination, ' lgRecombination'
         print*,  nSPeciesMax, nSpecies, nSizes, ' nSPeciesMax, nSpecies, nSizes'
         print*,  (nSpeciesPart(i), i = 1, nDustComponents)
         print*,  resLinesTransfer, ' resLinesTransfer'
         print*,  lgDustScattering, ' lgDustScattering'
         print*,  nAngleBins, ' nAngleBins'
         print*,  contCube(1),contCube(2), 'continuumCube'
         print*,  lgPhotoelectric, ' lgPhotoelectric'
         print*,  lgTraceHeating, ' lgTraceHeating'
         print*,  Ldiffuse, ' Ldiffuse'
         print*,  Tdiffuse, ' Tdiffuse'
         print*,  shapeDiffuse, ' shapeDiffuse'
         print*,  nPhotonsDiffuse, ' nPhotonsDiffuse'
         print*,  emittingGrid, ' emittingGrid'
         print*,  nstages, ' nstages'
         print*,  lgMultistars, ' lgMultiStars'
         print*,  lg2D, ' lg2D'
         print*,  lgEcho, echot1, echot2, echoTemp
         print*,  lgNosource," NoSourceSED"
      end if
      close(77)


      allocate(p(nstages))
      p=0.
      allocate(lgDataAvailable(3:nElements, nstages))

      close(89)
      open(unit=89, file='output/grid0.out',  action="read",position='rewind',  &
           &          status='old', iostat = err)
      if (err /= 0) then
         print*, "! resetGrid: error opening file  output/grid0.out"
         stop
      end if

      if (lgGas) then
         close(78)
         open(unit=78, file='output/grid1.out',  action="read",position='rewind',  &
              &          status='old', iostat = err)
         if (err /= 0) then
            print*, "! resetGrid: error opening file  output/grid1.out"
            stop
         end if
         ! open the grid2.out file for later
         close(79)
         open(unit=79, file='output/grid2.out', action="read", position='rewind',  &
              &          status='old', iostat = err)
         if (err /= 0) then
            print*, "! resetGrid: error opening file  output/grid2.out"
            stop
         end if
      end if
      if (lgDust) then
         close(88)
         open(unit=88, file='output/dustGrid.out', action="read", position='rewind',  &
              &          status='old', iostat = err)
         if (err /= 0) then
            print*, "! resetGrid: error opening file  output/dustGrid.out"
            stop
         end if
      end if

      allocate(dl(1:nGrids), stat = err)
      if (err /= 0) then
         print*, "! resetGrid: can't allocate grid memory"
         stop
      end if

      totCells = 0
      totCellsloc = 0
      do iG = 1, nGrids
         read(89, *) nGrids
         read(89, *) nxIn(iG), nyIn(iG), nzIn(iG), grid(iG)%nCells, grid(iG)%motherP, R_out

         print*, nxIn(iG), nyIn(iG), nzIn(iG), grid(iG)%nCells, grid(iG)%motherP, R_out

         ! initialize cartesian grid
         call initCartesianGrid(grid(iG),nxIn(iG), nyIn(iG), nzIn(iG))


         if (iG>1) then
            grid(iG)%elemAbun = grid(1)%elemAbun
         end if

         if (lgPlaneIonization .and. iG==1) then
            allocate(planeIonDistribution(grid(iG)%nx,grid(iG)%nz), stat = err)
            if (err /= 0) then
               print*, "! resetMotherGrid: can't allocate dl memory"
               stop
            end if
            planeIonDistribution = 0
         end if


         ! Allocate grid arrays
         if (lgGas) then
            allocate(grid(iG)%Hden(0:grid(iG)%nCells), stat = err)
            if (err /= 0) then
               print*, "! resetGrid: can't allocate grid memory"
               stop
            end if

            allocate(grid(iG)%Ne(0:grid(iG)%nCells), stat = err)
            if (err /= 0) then
               print*, "! resetGrid: can't allocate grid memory"
               stop
            end if

            allocate(grid(iG)%Te(0:grid(iG)%nCells), stat = err)
            if (err /= 0) then
               print*, "! resetGrid:can't allocate grid memory"
               stop
            end if

            allocate(grid(iG)%ionDen(0:grid(iG)%nCells, 1:nElementsUsed, 1:nstages), stat = err)
            if (err /= 0) then
               print*, "! resetGrid: can't allocate grid memory,ionDen"
               stop
            end if

            allocate(ionDenUsed(1:nElementsUsed, 1:nstages), stat = err)
            if (err /= 0) then
               print*, "! resetGrid: can't allocate grid memory,ionDenUsed"
               stop
            end if

            allocate(grid(iG)%recPDF(0:grid(iG)%nCells, 1:nbins), stat = err)
            if (err /= 0) then
               print*, "Can't allocate grid memory, 8"
               stop
            end if

            allocate(grid(iG)%totalLines(0:grid(iG)%nCells), stat = err)
            if (err /= 0) then
               print*, "Can't allocate grid memory, 10"
               stop
            end if

            grid(iG)%Hden = 0.
            grid(iG)%Ne = 0.
            grid(iG)%Te = 0.
            grid(iG)%ionDen = 0.
            grid(iG)%recPDF = 0.
            grid(iG)%totalLines = 0.

         end if

         if (Ldiffuse>0.) then
            allocate(grid(iG)%LdiffuseLoc(0:grid(iG)%nCells), stat = err)
            if (err /= 0) then
               print*, "! resetGrid: can't allocate grid memory : LdiffuseLoc "
               stop
            end if
            grid(iG)%LdiffuseLoc=0.
         end if

         totCells = totCells + grid(iG)%nCells
         if (emittingGrid>0 .and. iG<=emittingGrid) then
            totCellsLoc = totCellsLoc + grid(iG)%nCells
         elseif (emittingGrid==0) then
            totCellsLoc = totCellsLoc + grid(iG)%nCells
         end if



         allocate(grid(iG)%opacity(0:grid(iG)%nCells, 1:nbins), stat = err)
         if (err /= 0) then
            print*, "! resetGrid: can't allocate grid memory,opacity "
            stop
         end if

         allocate(grid(iG)%Jste(0:grid(iG)%nCells, 1:nbins), stat = err)
         if (err /= 0) then
            print*, "! resetGrid: can't allocate Jste grid memory"
            stop
         end if

!BS10         if (lgDebug) then
            allocate(grid(iG)%Jdif(0:grid(iG)%nCells, 1:nbins), stat = err)
            if (err /= 0) then
               print*, "! grid: can't allocate grid memory"
               stop
            end if

            ! allocate pointers depending on nLines
            if (nLines > 0) then

               allocate(grid(iG)%linePackets(0:grid(iG)%nCells, 1:nLines), stat = err)
               if (err /= 0) then
                  print*, "! resetGrid: can't allocate grid(iG)%linePackets memory"
                  stop
               end if

               allocate(grid(iG)%linePDF(0:grid(iG)%nCells, 1:nLines), stat = err)
               if (err /= 0) then
                  print*, "! resetGrid: can't allocate grid(iG)%linePDF memory"
                  stop
               end if

               grid(iG)%linePackets = 0.
               grid(iG)%linePDF     = 0.

            end if

            grid(iG)%Jdif = 0.

!BS10         end if

         allocate(grid(iG)%lgConverged(0:grid(iG)%nCells), stat = err)
         if (err /= 0) then
            print*, "Can't allocate memory to lgConverged array"
            stop
         end if

         allocate(grid(iG)%lgBlack(0:grid(iG)%nCells), stat = err)
         if (err /= 0) then
            print*, "Can't allocate memory to lgBlack array"
            stop
         end if

         allocate(grid(iG)%escapedPackets(0:grid(iG)%nCells, 0:nbins,0:nAngleBins), stat = err)
         if (err /= 0) then
            print*, "! resetGrid: can't allocate grid memory : Jste"
            stop
         end if

         if (lgDust) then
            allocate(grid(iG)%Ndust(0:grid(iG)%nCells), stat = err)
            if (err /= 0) then
               print*, "Can't allocate grid memory, Ndust"
               stop
            end if
            allocate(grid(iG)%Tdust(0:nSpeciesMax, 0:nSizes, 0:grid(iG)%nCells), stat = err)
            if (err /= 0) then
               print*, "Can't allocate grid memory, Tdust"
               stop
            end if
            grid(iG)%Ndust = 0.
            grid(iG)%Tdust = 0.

            if (.not.lgGas) then

               allocate(grid(iG)%dustPDF(0:grid(iG)%nCells, 1:nbins), stat = err)
               if (err /= 0) then
                  print*, "Can't allocate grid memory, dustPDF"
                  stop
               end if
               grid(iG)%dustPDF=0.
            end if

         end if

         grid(iG)%opacity = 0.
         grid(iG)%Jste = 0.
         grid(iG)%lgConverged = 0
         grid(iG)%lgBlack = 0



         ! axis points
         do i = 1, grid(iG)%nx
            read(89, *) grid(iG)%xAxis(i)
         end do
         do i = 1, grid(iG)%ny
            read(89, *) grid(iG)%yAxis(i)
         end do
         do i = 1, grid(iG)%nz
            read(89, *) grid(iG)%zAxis(i)
         end do

         if (lg2D) then
            yTop = 1
         else
            yTop = grid(iG)%ny
         end if

         ! read the rest of the files into grid
         do i = 1, grid(iG)%nx
            do j = 1, yTOp
               do k = 1, grid(iG)%nz

                  read(89, *) cellP, p0,p00
!print*, cellP
                  grid(iG)%active(i,j,k) = cellP
                  if (cellP<0) cellP = 0

                  grid(iG)%lgConverged(cellP)=nint(p0)
                  grid(iG)%lgBlack(cellP)=nint(p00)

                  if (lgGas) then

                     i1=1
                     if (lgMultiChemistry) then
                        read(78, *) p1,p2,p3,i1
                     else
                        read(78, *) p1,p2,p3
                     end if

                     grid(iG)%Te(cellP)=p1
                     grid(iG)%Ne(cellP)=p2
                     grid(iG)%Hden(cellP)=p3
                     grid(iG)%abFileIndex(i,j,k)=i1

                     do elem = 1, nElements
                        if (lgElementOn(elem)) then

                           read(79, *) (p(ion), ion =1,min(elem+1,nstages))

                           grid(iG)%ionDen(cellP,elementXref(elem),:)=p

                        end if
                     end do
                  end if

                  if (lgDust) then
                     if (lgMultiDustChemistry) then
                        read(88, *) p00, ind
                        grid(iG)%dustAbunIndex(cellP) = nint(ind)
                     else
                        read(88, *) p00
                     end if

                     do ai = 0, nSizes
                        read(88, *) (grid(iG)%Tdust(elem,ai,cellP), elem = 0,nSpeciesMax)
                     end do
                     grid(iG)%Ndust(cellP) = p00
                  end if

               end do
            end do
         end do



         if (lg2D .and. iG==1) then
            allocate(TwoDscaleJ(grid(iG)%nCells))
            TwoDscaleJ = 1.

            do i = 1, grid(ig)%nx
               do j = 2, grid(ig)%ny
                  do k = 1, grid(ig)%nz
                     radius = 1.e10*sqrt( (grid(ig)%xAxis(i)/1.e10)*&
                          &(grid(ig)%xAxis(i)/1.e10) + &
                          &(grid(ig)%yAxis(j)/1.e10)*(grid(ig)%yAxis(j)/1.e10) )

                     call locate(grid(ig)%xAxis, radius, xPmap)
                     if (xPmap < grid(ig)%nx) then
                        if (radius >= (grid(ig)%xAxis(xPmap)+grid(ig)%xAxis(xPmap+1))/2.) &
                             & xPmap = xPmap+1
                     end if
                     grid(ig)%active(i,j,k) = grid(ig)%active(xPmap, 1, k)

                     if (grid(ig)%active(xPmap,1,k)>0) &
                          & TwoDScaleJ(grid(ig)%active(xPmap,1,k)) = &
                          & TwoDScaleJ(grid(ig)%active(xPmap,1,k))+1.

                   end do
                end do
             end do
          end if




         ! find geometric corrections
         grid(iG)%geoCorrX = (grid(iG)%xAxis(grid(iG)%nx) - grid(iG)%xAxis(grid(iG)%nx-1))/2.
         if (.not. lg1D) then
            grid(iG)%geoCorrY = (grid(iG)%yAxis(grid(iG)%ny) - grid(iG)%yAxis(grid(iG)%ny-1))/2.
            grid(iG)%geoCorrZ = (grid(iG)%zAxis(grid(iG)%nz) - grid(iG)%zAxis(grid(iG)%nz-1))/2.
         else
            grid(iG)%geoCorrY = 0.
            grid(iG)%geoCorrZ = 0.
         end if
         if (taskid == 0) print*, "Geometric grid corrections at grid: ", iG, &
           & grid(iG)%geoCorrX, grid(iG)%geoCorrY, grid(iG)%geoCorrZ

         ! find linear increment
         dl(iG) =  abs(grid(iG)%xAxis(2) - grid(iG)%xAxis(1))
         do i = 2, grid(iG)%nx-1
            dl(iG) = min(dl(iG), abs(grid(iG)%xAxis(i+1)-grid(iG)%xAxis(i)) )
         end do
         do i = 1, grid(iG)%ny-1
            dl(iG) = min(dl(iG), abs(grid(iG)%yAxis(i+1)-grid(iG)%yAxis(i)) )
         end do
         do i = 1, grid(iG)%nz-1
            dl(iG) = min(dl(iG), abs(grid(iG)%zAxis(i+1)-grid(iG)%zAxis(i)) )
         end do
         dl(iG) = dl(iG)/50.


      end do ! closes nGrids loop

      if (emittingGrid>0) then
         if (totCellsloc<=0) then
            print*, '! resetGrid: insanity totCellsloc'
            stop
         end if
         nPhotonsDiffuseLoc = nPhotonsDiffuse/totCellsLoc
      else
         if (totCells<=0) then
            print*, '! resetGrid: insanity totCellsloc'
            stop
         end if
         nPhotonsDiffuseLoc = nPhotonsDiffuse/totCells
      end if

      ! close files
      close(89)

      if (lgGas) then
         close(78)
         close(79)
      end if

      if (lgDust) close(88)

      ! locate the origin of the axes
      call locate(grid(1)%xAxis, 0., iOrigin)
      call locate(grid(1)%yAxis, 0., jOrigin)
      call locate(grid(1)%zAxis, 0., kOrigin)

      if (taskid == 0) print*, 'Mothergrid origin at cell:  ' , iOrigin, jOrigin, kOrigin

      if (allocated(p)) deallocate(p)

    end subroutine resetGrid

    subroutine setStarPosition(xA,yA,zA,grid)
      implicit none

      type(grid_type), intent(inout) :: grid(maxGrids)  ! the 3d grids

      real, dimension(:) :: xA,yA,zA

      Integer :: i, xP,yP,zP, nxA,nyA,nzA

      nxA = size(xA)
      nyA = size(yA)
      nzA = size(zA)

      allocate(starIndeces(nStars,4))

      do i = 1, nStars

         starPosition(i)%x = starPosition(i)%x*xA(nxA)
         starPosition(i)%y = starPosition(i)%y*yA(nyA)
         starPosition(i)%z = starPosition(i)%z*zA(nzA)

         call locate(xA, starPosition(i)%x, xP)
         if (xP<nxA) then
            if (starPosition(i)%x > &
                 & (xA(xP)+xA(xP+1))/2.) &
                 xP=xP+1
         end if

         call locate(yA, starPosition(i)%y, yP)
         if (yP<nyA) then
            if (starPosition(i)%y > &
                 & (yA(yP)+yA(yP+1))/2.) &
                 yP=yP+1
         end if

         call locate(zA, starPosition(i)%z, zP)
         if (zP<nzA) then
            if (starPosition(i)%z > &
                 & (zA(zP)+zA(zP+1))/2.) &
                 zP=zP+1
         end if


         if (grid(1)%active(xp,yp,zp)>=0) then
            starIndeces(i,1) = xP
            starIndeces(i,2) = yP
            starIndeces(i,3) = zP
            starIndeces(i,4) = 1

         else

            starIndeces(i,4) = abs(grid(1)%active(xp,yp,zp))

            nxA = grid(starIndeces(i,4))%nx
            nyA = grid(starIndeces(i,4))%ny
            nzA = grid(starIndeces(i,4))%nz

            call locate(grid(starIndeces(i,4))%xAxis, starPosition(i)%x, xP)
            if (xP<nxA) then
               if (starPosition(i)%x > &
                    & (grid(starIndeces(i,4))%xAxis(xP)+grid(starIndeces(i,4))%xAxis(xP+1))/2.) &
                    xP=xP+1
            end if

            call locate(grid(starIndeces(i,4))%yAxis, starPosition(i)%y, yP)
            if (yP<nyA) then
               if (starPosition(i)%y > &
                    & (grid(starIndeces(i,4))%yAxis(yP)+grid(starIndeces(i,4))%yAxis(yP+1))/2.) &
                    yP=yP+1
            end if

            call locate(grid(starIndeces(i,4))%zAxis, starPosition(i)%z, zP)
            if (zP<nzA) then
               if (starPosition(i)%z > &
                    & (grid(starIndeces(i,4))%yAxis(zP)+grid(starIndeces(i,4))%yAxis(zP+1))/2.) &
                    zP=zP+1
            end if

            starIndeces(i,1) = xP
            starIndeces(i,2) = yP
            starIndeces(i,3) = zP

         end if

      end do

    end subroutine setStarPosition

!
! =Light Echo routines, BEKS 2010==========================================
!
      function vEcho(grid,xP,yP,zP,t1i,t2i,volume)
! return the fraction of the grid cell containing an echo
      implicit none
      type(grid_type),intent(in) :: grid              ! the grid
      integer, intent(in)        :: xP, yP, zP        ! cell indeces
      double precision :: x,y,z,dx,dy,dz,t1,t2,vol
      real             :: t1i,t2i,vEcho,odx,ody,odz,volume
      double precision :: h,rho,ddx,ddy,xx,yy
      double precision :: dfac=9.4605284e17,tfac=365.25
      integer :: i,j
      integer :: n=25 ! number of points in grid cell over which to integrate

! N.B. work in yrs & lt-yrs, they are easier...

      x=dble(grid%xAxis(xP))/dfac
      y=dble(grid%yAxis(yP))/dfac
      z=dble(grid%zAxis(zP))/dfac

      t1=dble(t1i)/tfac
      t2=dble(t2i)/tfac

      if ( (xP>1) .and. (xP<grid%nx) ) then
         odx = abs(grid%xAxis(xP+1)-grid%xAxis(xP-1))/2.
      else if ( xP==1 ) then
         if (lgSymmetricXYZ) then
            odx = abs(grid%xAxis(xP+1)-grid%xAxis(xP))/2.
         else
            odx = abs(grid%xAxis(xP+1)-grid%xAxis(xP))
         end if
      else if ( xP==grid%nx ) then
         odx = abs(grid%xAxis(xP)  -grid%xAxis(xP-1))
      end if

      if ( (yP>1) .and. (yP<grid%ny) ) then
         ody = abs(grid%yAxis(yP+1)-grid%yAxis(yP-1))/2.
      else if ( yP==1 ) then
         if (lgSymmetricXYZ) then
            ody = abs(grid%yAxis(yP+1)-grid%yAxis(yP))/2.
         else
            ody = abs(grid%yAxis(yP+1)-grid%yAxis(yP))
         end if
      else if ( yP==grid%ny ) then
         ody = abs(grid%yAxis(yP)  -grid%yAxis(yP-1))
      end if

      if ( (zP>1) .and. (zP<grid%nz) ) then
         odz = abs(grid%zAxis(zP+1)-grid%zAxis(zP-1))/2.
      else if ( zP==1 ) then
         if (lgSymmetricXYZ) then
            odz = abs(grid%zAxis(zP+1)-grid%zAxis(zP))/2.
         else
            odz = abs(grid%zAxis(zP+1)-grid%zAxis(zP))
         end if
      else if ( zP==grid%nz ) then
         odz = abs(grid%zAxis(zP)-grid%zAxis(zP-1))
      end if

      dx=dble(odx)/dfac
      dy=dble(ody)/dfac
      dz=dble(odz)/dfac

      vEcho=0.
      vol=0.0

! integrate all echo space inside torus

      ddx=dx/dble(n)
      ddy=dy/dble(n)
!      write(6,'(a2,8f9.3)')'s',x,y,z,dx,dy,dz,ddx,ddy
      do i=1,n
         do j=1,n
            xx=x-dx/2.+ddx/2.+dble(i-1)*ddx ! test at center of each subcell
            yy=y-dy/2.+ddy/2.+dble(j-1)*ddy
            rho=sqrt(xx**2+yy**2)
            h=max((min(z+dz,zee(rho,t1))-max(z,zee(rho,t2))),0.)
            vol=vol+h
!            if (vol.gt.0.) write(6,'(2f8.4,x,4f8.4,x,f8.4,1pg12.4)')&
!                 &xx,yy,zee(rho,t2),z,z+dz,zee(rho,t1),h,vol
         enddo
      enddo
      volume=real(vol*ddx*ddy)
      vEcho=real(vol*ddx*ddy/(dx*dy*dz)) ! ratio of volume in echo to grid cell
!      if (vEcho.gt.0.) write(6,'(a2,4f9.3)')'a',x,y,z,vEcho

      return
    end function vEcho
!
    function zee(rho,t)
      double precision :: zee,rho,t

      zee=rho**2/(2.*t)-t/2.
      return
    end function zee


end module grid_mod

! Copyright (C) 2005 Barbara Ercolano
!
! MoCaSSiN = MOnte CArlo SImulationS of Nebulae
! this is the plotting driver
!
! Version 2.02
program MoCaSSiNplot
    use common_mod
    use constants_mod
    use emission_mod
    use grid_mod
    use iteration_mod
    use output_mod
    use set_input_mod
    use xSec_mod

    implicit none

    include 'mpif.h'

    type(grid_type) :: grid3D(maxGrids)         ! the 3D Cartesian  grid

    type(plot_type) :: plot           ! the plot

    real(kind=8), allocatable    :: flinePlot(:,:,:,:)
    real(kind=8), allocatable    :: flinePlotLarge(:,:)
    real, allocatable   :: image(:,:,:,:)

    ! filter transmission stuff
    real            :: frequency(5000), frequencyTemp(5000),tranCoeff(5000),tranCoeffTemp(5000)
    Real, allocatable   :: coeff(:)

    real            :: dV                     ! volume of local cell [e45 cm^3]
    real            :: freq1,freq2
    real            :: log10TeLoc

    character(len=30) :: filename       ! input file
    character(len=30) :: bandFile       ! band transmission coeff file

    integer         :: abFileIndexUsed
    integer         :: err            ! allocation error statu
    integer         :: elem, ion      ! element ion counters
    integer         :: i,j,k,iG       ! counters
    integer         :: iCount         ! cell index
    integer         :: iLine          ! line counter
    integer         :: iup, ilow, l   ! energy levels pointerst
    integer         :: ios            ! I/O error status
    integer         :: nxMax,nyMax,nzMax !
    integer         :: maxCells       ! maxCells
    integer         :: plotNum        ! counter
    integer         :: tranP          ! transmnission coeff index
    integer         :: tranMaxP       ! maximum tran coeff index
    integer         :: contP          ! continuum index counter
    integer         :: yP             !

    logical         :: lgContinuum    !

    call mpi_init(ierr)
    call mpi_comm_rank(MPI_COMM_WORLD, taskid, ierr)
    call mpi_comm_size(MPI_COMM_WORLD, numtasks, ierr)


    if (taskid == 0) then
        print*, "MOCASSIN 2005 plot Version 2.00"
        print*, " "
    end if

    filename = 'input/plot.in'


    ! reset the 3D cartesian grid
    call resetGrid(grid3D)

    call setStarPosition(grid3D(1)%xAxis,grid3D(1)%yAxis,grid3D(1)%zAxis,grid3D)

    ! prepare atomica data stuff
    call makeElements()

    maxCells = grid3D(1)%nCells
    do iG = 1, ngrids
       if (grid3D(iG)%nCElls>maxCElls) maxCElls = grid3D(iG)%nCElls
    end do

    print*, nstages
    allocate(flinePlot(nElements,nstages, nForLevels,nForLevels), stat=err)
    if (err /= 0) then
       print*, "! emissionDriver: can't allocate array memory"
       stop
    end if
    flinePlot = 0.
    if (lgElementOn(26) .and. nstages>=2) then
       allocate(flinePlotLarge(nForLevelsLarge,nForLevelsLarge), stat=err)
       if (err /= 0) then
          print*, "! emissionDriver: can't allocate array memory"
          stop
       end if
       flinePlotLarge = 0.
    end if

    ! read the file into the plot variable
    plot = readPlot(filename)

    lgContinuum = .false.
    do plotNum = 1, plot%nPlots
       if (.not.plot%lgLine(plotNum)) then
          print*, " ! mocassinPlot: no continuum plots are available in this version. &
               &Please contact Barbara Ercolano (be@star.ucl.ac.uk)"
          stop
       end if
    end do

    if (plot%lgFilter) then
       open(unit=72, file=bandFile,  action="read",status='old', position='rewind',iostat=ios)
       if (ios /= 0) then
          print*, "! readPlot: can't open band file for reading: ", bandFile
          stop
       end if

       frequency = 0.
       tranCoeff = 0.

       tranMaxP = 0
       do i = 1, 5000

          read(unit=72,fmt=*,iostat=ios) frequency(i), tranCoeff(i)

          if (ios < 0) exit

          ! the following assumes that wavelengths are in band file are in angstroms
          frequency(i) = 910.998/frequency(i)

          tranMaxP = tranMaxP + 1

       end do

       do i=1, tranMaxP
          frequencyTemp(i) = frequency(1+tranMaxP-i)
          tranCoeffTemp(i) = tranCoeff(1+tranMaxP-i)
       end do

       frequency = frequencyTemp
       tranCoeff = tranCoeffTemp

    end if

    if (taskid == 0) then
       open(unit=29, file='output/grid4.out', status='unknown',  action="write",position='rewind',iostat=ios)
       if (ios /= 0) then
          print*, "! readPlot: can't open file for writing: output/grid4.out"
          stop
       end if
    end if

    ! read in data file for higher level H transitions
    call hdatx
    ! read in data from benj skil smit 99
    call readHeIRecLines()


    do iG = 1, nGrids


       if (lg2D) then
          yP = 1
       else
          yP = grid3D(iG)%ny
       end if

       do i = 1, grid3D(iG)%nx
          do j = 1, yP
             do k = 1, grid3D(iG)%nz

                ! find the volume of this cell
                dV = getVolume(grid3D(iG), i,j,k)

                if (taskid ==0) write(29, *) grid3D(iG)%xAxis(i),grid3D(iG)%yAxis(j),grid3D(iG)%zAxis(k),dV

                ! check this cell is in the ionized region
                if (grid3D(iG)%active(i,j,k) >0) then

                   ! find the physical properties of this cell
                   HdenUsed        = grid3D(iG)%Hden(grid3D(iG)%active(i,j,k))
                   ionDenUsed      = grid3D(iG)%ionDen(grid3D(iG)%active(i,j,k), :, :)
                   NeUsed          = grid3D(iG)%Ne(grid3D(iG)%active(i,j,k))
                   TeUsed          = grid3D(iG)%Te(grid3D(iG)%active(i,j,k))
                   abFileIndexUsed = grid3D(iG)%abFileIndex(i,j,k)
                   log10TeLoc      = log10(TeUsed)

                   ! recalculate line emissivities at this cell

                   ! calculate the emission due to HI and HeI rec lines
                   call RecLinesEmission()

                   ! calculate the emission due to the heavy elements
                   ! forbidden lines
                   call forLines()

                   ! find the volume of this cell
                   dV = getVolume(grid3D(iG), i,j,k)

                   do plotNum = 1, plot%nPlots

                      if (plot%lgLine(plotNum)) then

                         ! initialise line number counter
                         iLine = 1


                         ! HI rec lines
                         do ilow = 2,8
                            do iup = ilow+1, 30

                               if (plot%lineNumber(plotNum) == iLine) &
                                    & plot%intensity(iG, grid3D(iG)%active(i,j,k),plotNum) = &
                                    & real(HIRecLines(iup,ilow)*HdenUsed*dV)
                               iLine = iLine+1

                            end do
                         end do

                         do l = 1, 34
                            if (plot%lineNumber(plotNum) == iLine) &
                                 & plot%intensity(iG,grid3D(iG)%active(i,j,k),plotNum) = &
                                 & real(HeIRecLines(l)*HdenUsed*dV)

                            iLine = iLine+1

                         end do


                         ! HeII rec lines
                         do iup = 3, 30
                            do ilow = 2, min(16, iup-1)


                               if (plot%lineNumber(plotNum) == iLine) &
                                    & plot%intensity(iG, grid3D(iG)%active(i,j,k),plotNum) = &
                                    & real(HeIIRecLines(iup,ilow)*HdenUsed*dV)

                               iLine = iLine+1

                            end do
                         end do

                         ! Heavy elements forbidden lines
                         do elem = 3, nElements
                            do ion = 1, min(elem+1, nstages)

                               if (.not.lgElementOn(elem)) exit
                               if (lgDataAvailable(elem,ion)) then

                                  if (elem == 26 .and. ion ==2) then

                                     do iup = 1, nforlevelsLarge
                                        do ilow = 1, nforlevelsLarge

                                           if (plot%lineNumber(plotNum) == iLine) then

!                                              print*, flinePlotLarge(iup,ilow), elem,ion,iup,ilow
                                              plot%intensity(iG, grid3D(iG)%active(i,j,k),plotNum) = &
                                                   & real(flinePlotLarge(iup,ilow)*HdenUsed*dV)

                                           end if

                                           iLine = iLine+1

                                        end do
                                     end do

                                  else

                                     do iup = 1, nforlevels
                                        do ilow = 1, nforlevels


                                           if (plot%lineNumber(plotNum) == iLine) then

!                                              print*, flinePlot(elem,ion,iup,ilow), elem,ion,iup,ilow
                                              plot%intensity(iG, grid3D(iG)%active(i,j,k),plotNum) = &
                                                   & real(flinePlot(elem,ion,iup,ilow)*HdenUsed*dV)

                                           end if

                                           iLine = iLine+1

                                        end do
                                     end do

                                  end if
                               end if
                            end do
                         end do

                         ! calculate the intensity per unit frequency
!                         plot%intensity(iG, grid3D(iG)%active(i,j,k),plotNum) = &
!                              & plot%intensity(iG,grid3D(iG)%active(i,j,k),plotNum) / &
!                              & 2.1799153e-11*nuArray(plot%nuP(plotNum,1))

                      else

                         print*, " ! mocassinPlot: no continuum plots are available in this version. &
                              &Please contact Barbara Ercolano (be@star.ucl.ac.uk)"
                         stop

                         do contP = 1, nbins

                            if ( (contP >= plot%nuP(plotNum,1)) .and. (contP <= plot%nuP(plotNum,2)) &
                                 &  .and. (continuum(contP) >=1.e-20) ) then

                               if (plot%lgFilter) then

                                  call locate(frequency(1:tranMaxP), nuArray(contP), tranP)
                                  if ( nuArray(contP) >= (frequency(tranP) + frequency(tranP+1))/2. ) &
                                       tranP = tranP+1
                                  if( (tranP <= 0) .or. (tranP >= tranMaxP) ) coeff = 0.

                                  coeff(plotNum) = tranCoeff(tranP)

                                  ! continuum is in units of [e-40 erg/cm^3/s/Hz]; multiply by 1.e-15
                                  ! to bring to the same units as the lines, also cRyd at the bottom (2.1799153e-11)
                                  ! so just multipy by 4.587e-5
                                  plot%intensity(iG,grid3D(iG)%active(i,j,k),plotNum) = &
                                       & plot%intensity(iG,grid3D(iG)%active(i,j,k),plotNum) + &
                                    & continuum(contP)*4.587e-5*HdenUsed*dV*coeff(plotNum)/nuArray(contP)
                               else
                                  ! continuum is in units of [e-40 erg/cm^3/s/Hz]; multiply by 1.e-15
                                  ! to bring to the same units as the lines, also cRyd at the bottom (2.1799153e-11)
                                  ! so just multipy by 4.587e-5
                                  plot%intensity(iG,grid3D(iG)%active(i,j,k),plotNum) = &
                                       & plot%intensity(iG,grid3D(iG)%active(i,j,k),plotNum) + &
                                       & continuum(contP)*4.587e-5*HdenUsed*dV/nuArray(contP)
                               end if

                            end if
                         end do

                      end if
                   end do ! plots

                end if ! inner/outer cell condition

             end do
          end do
       end do
    end do

    if (taskid == 0) close(29)

    ! calculate intensities in units of [E30 erg/s/Hz]
    ! Note:  intensities are now in E-25 * E45 ergs/sec (the E-25 comes from the emission
    ! module calculations and the E45 comes from the volume calculations to avoid
    ! overflow. Hence intensities are in [E20 ergs/s], so we need to multiply by E-16
    ! to give units of  [E36 erg/s].
    plot%intensity = plot%intensity*1.e-16

    ! per sterradian
!    plot%intensity = plot%intensity/fourPi

    if (plot%lgFilter) then

       do plotNum = 1, plot%nPlots

          if (plot%lgLine(plotNum)) then
             call locate(frequency(1:tranMaxP), nuArray(plot%nuP(plotNum,1)), tranP)
             if ( nuArray(plot%nuP(plotNum,1)) >= (frequency(tranP) + frequency(tranP+1))/2. ) &
                  tranP = tranP+1
             if( (tranP <= 0) .or. (tranP >= tranMaxP) ) then
                print*, 'mocassinPlot: [warning] frequency outside the band', nuArray(plot%nuP(plotNum,1))
                coeff = 0.
             end if

             coeff(plotNum) = tranCoeff(tranP)

          else
             coeff(plotNum) = 1.
          end if

       end do

    else

       coeff = 1.

    end if

    open(unit=28, file='output/plot.out', status='unknown',  action="write",position='rewind',iostat=ios)
    if (ios /= 0) then
       print*, "! readPlot: can't open file for writing: output/plot.out"
       stop
    end if

    iCount = 0

    ! allocate pointers depending on nLines
    nxMax=grid3D(1)%nx
    nyMax=grid3D(1)%ny
    nzMax=grid3D(1)%nz
    do iG=1,nGrids
       if (grid3D(iG)%nx > nxMax) nxMax=grid3D(iG)%nx
       if (grid3D(iG)%ny > nxMax) nyMax=grid3D(iG)%ny
       if (grid3D(iG)%nz > nxMax) nzMax=grid3D(iG)%nz
    end do

    allocate(image(1:nGrids,1:nxMax, 1:nyMax, 1:nzMax), stat = err)
    if (err /= 0) then
       print*, "! mocassinPlot: can't allocate image memory"
       stop
    end if

    image = 0.

    do iG=1, nGrids
       do i = 1, grid3D(iG)%nx
          do j = 1, yP
             do k = 1, grid3D(iG)%nz

                if (plot%lgFilter) then
                   do plotNum = 1, plot%nPlots
                      image(iG,i,j,k) = image(iG,i,j,k) + plot%intensity(iG,grid3D(iG)%active(i,j,k),plotNum)*coeff(plotNum)
                   end do

                   iCount = iCount + 1
                   write(28,*) iCount,' ',(plot%intensity(iG,grid3D(iG)%active(i,j,k),plotNum),' ', &
                        & plotNum = 1, plot%nPlots), image(iG,i,j,k)

                else

                   iCount = iCount + 1
                   write(28,*) iCount,' ',(plot%intensity(iG,grid3D(iG)%active(i,j,k),plotNum),' ', &
                        & plotNum = 1, plot%nPlots)

                end if

             end do
          end do
       end do
    end do
!******************************************************************************

    ! free all space allocated to the 3D grid
    do iG=1, nGrids
       call freeGrid(grid3D(iG))
    end do

    ! free all space allocated to the plot
    call freePlot(plot)

    if (allocated(ionDenUsed)) deallocate(ionDenUsed)
    if (allocated(fLinePlot)) deallocate(fLinePlot)


    call mpi_finalize(ierr)
    stop 'mpi done'



    contains

      function readPlot(filename)
        implicit none

        type(plot_type)           :: readPlot    ! plot

        character(len=15), intent(in) &
&                                 :: filename    ! plot parameters file


        ! local variables
        real                      :: freq        ! cont freq

        character(len=10)         :: lineORcont  ! line or continuum ?
        character(len=10)         :: filter      ! filter?


        integer                   :: err         ! allocation error status
        integer                   :: i           ! counters
        integer                   :: ios         ! I/O error status
        integer                   :: maxLim      ! loop limit
        integer                   :: code        ! line code number (0 if cont)


        close(77)
        open(unit=77, file=filename, status='old', position='rewind', action="read",iostat=ios)
        if (ios /= 0) then
           print*, "! readPlot: can't open file for reading", filename
           stop
        end if

        maxLim = 10000

        ! find nPlots
        readPlot%nPlots = 0

        read(unit=77,fmt=*,iostat=ios) filter

        select case(filter)
        case('band')
           readPlot%lgFilter = .true.
           backspace(77)
           read(unit=77,fmt=*,iostat=ios) filter, bandFile
        case('mono')
           readPlot%lgFilter = .false.
           backspace(77)
        case default
           print*, '! readPlot: band or mono must be specified for plots'
           stop
        end select

        do i = 1, maxLim

        read(unit=77,fmt=*,iostat=ios) lineOrcont

           if (ios < 0) exit

           readPlot%nPlots = readPlot%nPlots + 1

        end do

        readPlot%nPlots = readPlot%nPlots - 1

        print*, 'Number of plots: ', readPlot%nPlots

        close(77)

        ! allocate pointers
        allocate(readPlot%lineNumber(readPlot%nPlots), stat=err)
        if (err /= 0) then
           print*, "! readPlot: can't allocate memory for lineNumber array"
           stop
        end if
        allocate(readPlot%nuP(readPlot%nPlots,2), stat=err)
        if (err /= 0) then
           print*, "! readPlot: can't allocate memory for nuP array"
           stop
        end if
        allocate(readPlot%lgLine(readPlot%nPlots), stat=err)
        if (err /= 0) then
           print*, "! readPlot: can't allocate memory for lgLine array"
           stop
        end if
        allocate(readPlot%intensity(1:nGrids,0:maxCells,readPlot%nPlots), stat=err)
        if (err /= 0) then
           print*, "! readPlot: can't allocate memory for intensity array"
           stop
        end if
        allocate(coeff(readPlot%nPlots), stat=err)
        if (err /= 0) then
           print*, "! readPlot: can't allocate memory for transmission coeff array"
           stop
        end if

        readPlot%lineNumber   = 0
        readPlot%nuP          = 0
        readPlot%lgLine       = .true.
        readPlot%intensity    = 0.
        freq                  = 0.
        code                  = 0

        open(unit=77, file=filename, status='old', position='rewind', action="read",iostat=ios)
        if (ios /= 0) then
           print*, "! readPlot: can't open file for reading", filename
           stop
        end if

        read(77,*) filter

        do i = 1, readPlot%nPlots

           read(77, *) lineORcont, code, freq1, freq2

           ! assume freq1 and freq2 are wavelengths in Angstroms
           freq1 = 910.998/freq1
           freq2 = 910.998/freq2

           ! decide whether line or continuum and assign to plot
           select case (lineORcont)
           case ('line')
              readPlot%lgLine(i)     = .true.
              readPlot%lineNumber(i) = code
              call locate(nuArray, freq1, readPlot%nuP(i,1))
              if (freq1 >= (nuArray(readPlot%nuP(i,1)) + nuArray(readPlot%nuP(i,1)+1))/2. ) &
                   readPlot%nuP(i,1) = readPlot%nuP(i,1)+1
              readPlot%nuP(i,2) = readPlot%nuP(i,1)
           case ('continuum')
              readPlot%lgLine(i)     = .false.
              readPlot%lineNumber(i) = code
              call locate(nuArray, freq2, readPlot%nuP(i,1))
              if (freq2 >= (nuArray(readPlot%nuP(i,1)) + nuArray(readPlot%nuP(i,1)+1))/2. ) &
                   readPlot%nuP(i,1) = readPlot%nuP(i,1)+1
              call locate(nuArray, freq1, readPlot%nuP(i,2))
              if (freq1 >= (nuArray(readPlot%nuP(i,2)) + nuArray(readPlot%nuP(i,2)+1))/2. ) &
                   readPlot%nuP(i,2) = readPlot%nuP(i,2)+1
           end select
        end do

        ! close file
        close(77)

        print*, 'out readPlot'

      end function readPlot

      subroutine freePlot(plot)
        implicit none

        type(plot_type), intent(inout) :: plot

        if (allocated(plot%intensity))  deallocate(plot%intensity)
        if (allocated(plot%lgLine))     deallocate(plot%lgLine)
        if (allocated(plot%lineNumber)) deallocate(plot%lineNumber)
        if (allocated(plot%nuP))        deallocate(plot%nuP)

      end subroutine freePlot



      ! this subroutine is the driver for the calculation of the emissivity
      ! from the heavy elements forbidden lines.
      subroutine forLines()
        implicit none

        integer                     :: elem, ion ! counters

        ! re-initialize forbiddenLines
        fLinePlot = 0.

        do elem = 3, nElements
           do ion = 1, min(elem+1, nstages)
              if (.not.lgElementOn(elem)) exit

              if (lgDataAvailable(elem, ion)) then

                 if (elem == 26 .and. ion ==2) then

                    if (ion<min(elem+1,nstages)) then
                       call equilibrium(dataFile(elem, ion), &
                            &ionDenUsed(elementXref(elem), ion+1)/&
                            &ionDenUsed(elementXref(elem),ion), &
                            & TeUsed, NeUsed, flinePlotLarge(:,:))
                    else
                       call equilibrium(dataFile(elem, ion), 0., &
                            & TeUsed, NeUsed, flinePlotLarge(:,:))
                    end if

                    flinePlotLarge(:, :) =flinePlotLarge(:,:)*&
                         &grid3D(iG)%elemAbun(abFileIndexUsed,elem)*&
                         & ionDenUsed(elementXref(elem), ion)
                 else

                    if (ion<min(elem+1,nstages)) then
                       call equilibrium(dataFile(elem, ion), &
                            &ionDenUsed(elementXref(elem), ion+1)/&
                            &ionDenUsed(elementXref(elem),ion), &
                            & TeUsed, NeUsed, flinePlot(elem,ion,:,:))
                    else
                       call equilibrium(dataFile(elem, ion), 0., &
                            & TeUsed, NeUsed, flinePlot(elem,ion,:,:))
                    end if

                    flinePlot(elem, ion, :, :) =flinePlot(elem,ion,:,:)*&
                         &grid3D(iG)%elemAbun(abFileIndexUsed,elem)*&
                         & ionDenUsed(elementXref(elem), ion)

                 end if
              end if
           end do
        end do


        ! scale the forbidden lines emissivity to give units of [10^-25 erg/s/Ngas]
        ! comment: the forbidden line emissivity is so far in units of cm^-1/s/Ngas
        !          the energy [erg] of unit wave number [cm^-1] is 1.9865e-16, hence
        !          the right units are obtained by multiplying by 1.9865e-16*1e25
        !          which is 1.9865*1e9
        flinePlot = flinePlot*1.9865e9

        if (lgElementOn(26) .and. ion>=2) flinePlotLarge = flinePlotLarge*1.9865e9


      end subroutine forLines

    subroutine RecLinesEmission()
        implicit none

        ! local variables
        integer                    :: i           ! counters
        integer                    :: ilow,&      ! pointer to lower level
&                                      iup        ! pointer to upper level
        integer                    :: denint

        real                       :: Hbeta       ! Hbeta emission
        real                       :: HeII4686    ! HeII 4686 emission
        real                       :: Lalpha      ! Lalpha emission
        real                       :: T4          ! TeUsed/10000.
        real                       :: x1,x2
        real                       :: hb          ! emissivity of H 4->2
        real                       :: fh          ! emissivity of H


        T4 = TeUsed / 10000.

        ! do hydrogenic ions first

        ! calculate Hbeta
        if (TeUsed > 26000.) then
           print*, "! recLineEmission: [warning] temperature exceeds 26000K - Hbeta &
                & calculations may be uncertain"
        end if
        Hbeta = 2530./(TeUsed**0.833) ! TeUsed < 26000K CASE

        ! fits to Storey and Hummer MNRAS 272(1995)41
!        Hbeta = 10**(-0.870*log10Te + 3.57)
        Hbeta = Hbeta*NeUsed*ionDenUsed(elementXref(1),2)*grid3D(iG)%elemAbun(abFileIndexUsed,1)

        call hlinex(4,2,TeUsed,NeUsed,fh)
        hb = fh

        do ilow = 2, 8
           do iup = 30, ilow+1, -1
              call hlinex(iup,ilow,TeUsed,NeUsed,fh)
              HIRecLines(iup, ilow) = (fh/hb)*Hbeta

           enddo
        enddo


        ! add contribution of Lyman alpha
        ! fits to Storey and Hummer MNRAS 272(1995)41
        Lalpha = 10**(-0.897*log10TeLoc + 5.05)

        HIRecLines(30, 8) =HIRecLines(30, 8) + grid3D(iG)%elemAbun(abFileIndexUsed,1)*&
             & ionDenUsed(elementXref(1),2)*&
             & NeUsed*Lalpha


        ! calculate HeII 4686 [E-25 ergs*cm^3/s]
        HeII4686 = 10.**(-.997*log10(TeUsed)+5.16)
        HeII4686 = HeII4686*NeUsed*grid3D(iG)%elemAbun(abFileIndexUsed,2)*ionDenUsed(elementXref(2),3)

        ! calculate emission due to HeI recombination lines [e-25 ergs/s/cm^3]
        do iup = 30, 3, -1
            do ilow = 2, min(16, iup-1)
                HeIIRecLines(iup, ilow) = HeIIRecLines(iup, ilow)*HeII4686
            end do
        end do

        ! now do HeI

        if (NeUsed <= 100.) then
           denint=0
        elseif (NeUsed > 100. .and. NeUsed <= 1.e4) then
           denint=1
        elseif (NeUsed > 1.e4 .and. NeUsed < 1.e6) then
            denint=2
        elseif (NeUsed >= 1.e6) then
           denint=3
        end if

        ! data from Benjamin, Skillman and Smits ApJ514(1999)307 [e-25 ergs*cm^3/s]
        if (denint>0.and.denint<3) then
           do i =1, 34
              x1=HeIrecLineCoeff(i,denint,1)*(T4**(HeIrecLineCoeff(i,denint,2)))*exp(HeIrecLineCoeff(i,denint,3)/T4)

              x2=HeIrecLineCoeff(i,denint+1,1)*(T4**(HeIrecLineCoeff(i,denint+1,2)))*exp(HeIrecLineCoeff(i,denint+1,3)/T4)

              HeIRecLines(i) = x1+((x2-x1)*(NeUsed-100.**denint)/(100.**(denint+1)-100.**(denint)))


           end do
        elseif(denint==0) then
           do i = 1, 34
              HeIRecLines(i) = HeIrecLineCoeff(i,1,1)*(T4**(HeIrecLineCoeff(i,1,2)))*exp(HeIrecLineCoeff(i,1,3)/T4)
           end do
        elseif(denint==3) then
           do i = 1, 34
              HeIRecLines(i) = HeIrecLineCoeff(i,3,1)*(T4**(HeIrecLineCoeff(i,3,2)))*exp(HeIrecLineCoeff(i,3,3)/T4)
           end do
        end if
        HeIRecLines=HeIRecLines*NeUsed*grid3D(iG)%elemAbun(abFileIndexUsed,2)*ionDenUsed(elementXref(2),2)
    end subroutine RecLinesEmission

end program MoCaSSiNplot

module readdata_mod
use common_mod

!subroutines to read in data files to arrays at beginning of simulation

contains

    subroutine readData()

        implicit none
        integer :: i, ios                    ! counter, io state
        integer :: iup, ilow                 ! H counters

    ! initialise all the arrays that we are reading in

        y_dat = 0.
        Ay_dat = 0.
        HIRecLineData = 0.
        HeIILymanData = 0.
        HeIILymanNu = 0.
        HeIIRecLinedata = 0.
        direc_coeffs%elem = 0
        direc_coeffs%n = 0
        direc_coeffs%a = 0.
        direc_coeffs%b = 0.
        direc_coeffs%c = 0.
        direc_coeffs%d = 0.
        direc_coeffs%f = 0.
        direc_coeffs%g = 0
        aldropequi_coeffs%elem = 0
        aldropequi_coeffs%n = 0
        aldropequi_coeffs%a = 0
        aldropequi_coeffs%b = 0
        aldropequi_coeffs%t0 = 0.
        aldropequi_coeffs%t1 = 0.

    ! read in rates from data/HeI2phot.dat

        open(unit = 93,  action="read", file = PREFIX//"/share/mocassin/data/HeI2phot.dat", status = "old", position = "rewind", iostat=ios)
        if (ios /= 0) then
            print*, "! readData: can't open file: ",PREFIX,"/share/mocassin/data/HeI2phot.dat"
            stop
        end if
        do i = 1, 41
            read(unit = 93, fmt = *) y_dat(i), Ay_dat(i)
        end do

        close(93)

        ! read in HI recombination lines [e-25 ergs*cm^3/s]
        ! (Storey and Hummer MNRAS 272(1995)41)

        open(unit = 94,  action="read", file = PREFIX//"/share/mocassin/data/r1b0100.dat", status = "old", position = "rewind", iostat=ios)
        if (ios /= 0) then
            print*, "! readData: can't open file: ",PREFIX,"/share/mocassin/data/r1b0100.dat"
            stop
        end if

        do iup = 15, 3, -1
            read(94, fmt=*) (HIRecLinedata(iup, ilow), ilow = 2, min(8, iup-1))
        end do

        close(94)

        ! read in HeII Lyman line ratios up to level n=5 [e-25 ergs*cm^3/s]
        ! (Storey and Hummer MNRAS 272(1995)41)

        open(unit = 98,  action="read", file = PREFIX//"/share/mocassin/data/r2a0100.dat", status = "old", position = "rewind", iostat=ios)
        if (ios /= 0) then
            print*, "! readData: can't open file: ",PREFIX,"/share/mocassin/data/r2a0100.dat"
            stop
        end if

        do i = 1, NHeIILyman
            read(98, fmt=*) HeIILymanData(i), HeIILymanNu(i)
        end do

        close(98)

        ! read in HeII recombination lines [e-25 ergs*cm^3/s]
        ! (Storey and Hummer MNRAS 272(1995)41)

        open(unit = 95,  action="read", file = PREFIX//"/share/mocassin/data/r2b0100.dat", status = "old", position = "rewind", iostat=ios)
        if (ios /= 0) then
            print*, "! readData: can't open file: ",PREFIX,"/share/mocassin/data/r2b0100.dat"
            stop
        end if
        do iup = 30, 3, -1
            read(95, fmt=*) (HeIIRecLinedata(iup, ilow), ilow = 2, min(16, iup-1))
        end do

        close(95)

        ! dielectronic recombination coefficients

        open (unit=18, file=PREFIX//'/share/mocassin/data/dielectronic.dat', status='old',position='rewind', iostat = ios, action="read")
        do i = 1, 25
           read(unit=18, fmt=*, iostat=ios) direc_coeffs(i)%elem, direc_coeffs(i)%n, direc_coeffs(i)%a, direc_coeffs(i)%b, direc_coeffs(i)%c, direc_coeffs(i)%d, direc_coeffs(i)%f, direc_coeffs(i)%g
           if (ios < 0) exit ! end of file reached
        enddo
        close(18)

        ! high temperature dielectronic recombination coefficients from
        ! Aldrovandi and Pequignot 1973

        open (unit=17, file=PREFIX//'/share/mocassin/data/aldrovandi.dat', status='old',position='rewind', iostat = ios, action="read")
        if (ios /= 0) then
           print*, "! readData: can't open file ",PREFIX,"/share/mocassin/data/alrovandi.dat"
           stop
        end if

        do i = 1, 167
            read(unit=17, fmt=*, iostat=ios) aldropequi_coeffs(i)%elem, aldropequi_coeffs(i)%n, aldropequi_coeffs(i)%a, aldropequi_coeffs(i)%b, aldropequi_coeffs(i)%t0, aldropequi_coeffs(i)%t1
            if (ios < 0) exit ! end of file reached
        end do

        close(17)

    end subroutine readData

end module readdata_mod

! Copyright (C) 2005 Barbara Ercolano
!
! Version 2.02
module photon_mod

    use common_mod
    use constants_mod
    use continuum_mod
    use grid_mod
    use interpolation_mod
    use pathIntegration_mod
    use vector_mod

    ! common variables

    real :: Qphot = 0.


    type(vector), parameter :: origin=vector(0.,0.,0.)  ! origin of the cartesian grid axes

    integer     , parameter :: safeLim = 10000          ! safety limit for the loops
    integer                        :: totalEscaped

    contains

    subroutine energyPacketDriver(iStar, n, grid, gpLoc, cellLoc)
        implicit none

        integer, intent(in)            :: n           ! number of energy packets
        integer, intent(in)            :: iStar       ! central star index

        integer, intent(inout), optional &
             & :: gpLoc                               ! local grid (only used for extra diffuse sources)
        integer, intent(inout), optional &
             & :: cellLoc(3)                          ! local cell (only used for extra diffuse sources)

        type(grid_type), dimension(:), intent(inout) :: grid        ! the grid(s)

        type(vector)                   :: posDiff     ! initial position vector for diff ext
        type(vector)                   :: posVector   ! initial position vector for dust emi

        ! local variables
        integer                        :: gPIn        !
        integer                        :: igp         ! 1= mother 2 =sub
        integer                        :: i           ! counter
        integer                        :: iCell       ! cell counter
        integer                        :: igrid,ix,iy,iz ! location indeces
        integer                        :: ierr        ! allocation error status
        integer                        :: iPhot       ! counter
        integer                        :: seedSize    ! pseudo random number generator seed
        integer, dimension(2)          :: inX,inY,inZ ! initial position indeces
        integer, allocatable               :: seed(:)     ! seed array
        integer                        :: msec        ! millisecs of the sec
        integer                        :: dt(8)       ! date and time values
        integer                        :: trapped
        integer                        :: reRun

        character(len=7)               :: chTypeD     ! character type for driver
        character(len=7)               :: chTypeIn    ! character type

        type(vector)                   :: positionIn  ! position of packet absorption


        if (iStar == 0) then
           deltaE(0) = grid(gpLoc)%LdiffuseLoc(grid(gpLoc)%active(cellLoc(1),cellLoc(2),cellLoc(3)))/NphotonsDiffuseLoc
        end if

        call date_and_time(values=dt)
        msec=dt(8)

        call random_seed(seedSize)

        allocate(seed(1:seedSize), stat= ierr)
        if (ierr /= 0) then
            print*, "energyPacketDriver: can't allocate array memory: seed"
            stop
        end if

        seed = 0

        call random_seed(get = seed)

        seed = seed + msec + taskid

        call random_seed(put = seed)

        if (allocated(seed)) deallocate(seed)

        Qphot = 0.

        trapped = 0

        do iPhot = 1, n

           if (iStar>=1) then

              chTypeD = "stellar"
              if (starIndeces(iStar,4)==1) then
                 igp = 1
              else if (starIndeces(iStar,4)>1) then
                 igp = 2
              else
                 print*, "! energyPacketDriver: insane grid pointer, starIndeces(iStar,4)", starIndeces(iStar,4)
                 stop
              end if

              inX=-1
              inY=-1
              inZ=-1

              inX(igp) = starIndeces(iStar,1)
              inY(igp) = starIndeces(iStar,2)
              inZ(igp) = starIndeces(iStar,3)


              chTypeIn = chTypeD
              positionIn = starPosition(iStar)
              gPIn = starIndeces(iStar,4)
              reRun = 0
              do i = 1, recursionLimit
                 call energyPacketRun(chTypeIn, positionIn, inX, inY, &
                      &inZ, gPIn, reRun)
                 if (rerun == 0) exit

              end do
              if (i>=recursionLimit) trapped = trapped+1

           else if (iStar==0) then

              chTypeD = "diffExt"
              inX=-1
              inY=-1
              inZ=-1

              if (gpLoc==1) then
                 igp = 1
              else if (gpLoc>1) then
                 igp = 2
              else
                 print*, "! energyPacketDriver: insane grid pointer"
                 stop
              end if

              inX(igp) = cellLoc(1)
              inY(igp) = cellLoc(2)
              inZ(igp) = cellLoc(3)

              posDiff%x = grid(gpLoc)%xAxis(cellLoc(1))
              posDiff%y = grid(gpLoc)%yAxis(cellLoc(2))
              posDiff%z = grid(gpLoc)%zAxis(cellLoc(2))

              chTypeIn = chTypeD
              positionIn = posDiff
              gPIn = gPLoc
              reRun = 0
              do i = 1, recursionLimit
                 call energyPacketRun(chTypeIn, positionIn, inX, inY, &
                      &inZ, gPIn, reRun)
                 if (rerun == 0) exit

              end do
              if (i>=recursionLimit) trapped = trapped+1

           else

              print*, '! energyPacketDriver: insanity in iStar value'
              stop

           end if
        end do

        if (iStar>0) then
          if (taskid==0) then
            print*, 'Star: ', iStar
            print*, 'Qphot = ', Qphot
          endif
        end if


        if (lgDust.and.convPercent>=resLinesTransfer .and.&
             & .not.lgResLinesFirst&
             & .and. (.not.nIterateMC==1)) then

           print*, "! energyPacketDriver: starting resonance line packets transfer"


           iCell = 0
           do igrid = 1, nGrids

              if (igrid==1) then
                 igp = 1
              else if (igrid>1) then
                 igp = 2
              else
                 print*, "! energyPacketDriver: insane grid pointer"
                 stop
              end if


              do ix = 1, grid(igrid)%nx
                 do iy = 1, grid(igrid)%ny
                    do iz = 1, grid(igrid)%nz
                       iCell = iCell+1

                       if (mod(iCell-(taskid+1),numtasks)==0) then
                          if (grid(igrid)%active(ix,iy,iz)>0) then

                             do iPhot = 1, grid(igrid)%resLinePackets(grid(igrid)%active(ix,iy,iz))

                                chTypeD = "diffuse"
                                posVector%x = grid(igrid)%xAxis(ix)
                                posVector%y = grid(igrid)%yAxis(iy)
                                posVector%z = grid(igrid)%zAxis(iz)

                                inX=-1
                                inY=-1
                                inZ=-1
                                inX(igp)=ix
                                inY(igp)=iy
                                inZ(igp)=iz

                                if (igrid>1) then
                                   ! check location on mother grid
                                   call locate(grid(grid(igrid)%motherP)%xAxis, &
                                        & posVector%x,inX(1))
                                   if (posVector%x > (grid(grid(igrid)%motherP)%xAxis(inX(1))+&
                                        & grid(grid(igrid)%motherP)%xAxis(inX(1)+1) )/2.) &
                                        & inX(1) = inX(1)+1
                                   call locate(grid(grid(igrid)%motherP)%yAxis, &
                                        & posVector%y,inY(1))
                                   if (posVector%y > (grid(grid(igrid)%motherP)%yAxis(inY(1))+&
                                        & grid(grid(igrid)%motherP)%yAxis(inY(1)+1) )/2.) &
                                        & inY(1) = inY(1)+1
                                   call locate(grid(grid(igrid)%motherP)%zAxis, &
                                        & posVector%z,inZ(1))
                                   if (posVector%z > (grid(grid(igrid)%motherP)%zAxis(inZ(1))+&
                                        & grid(grid(igrid)%motherP)%zAxis(inZ(1)+1) )/2.) &
                                        & inZ(1) = inZ(1)+1
                                end if

                                chTypeIn = chTypeD
                                positionIn = posVector
                                gPIn = igrid
                                reRun = 0

                                do i = 1, recursionLimit
                                   call energyPacketRun(chTypeIn, positionIn, inX, inY, &
                                        &inZ, gPIn, reRun)
                                   if (rerun == 0) exit

                                end do
                                if (i>=recursionLimit) trapped = trapped+1

                             end do
                          end if
                       end if

                    end do
                 end do
              end do

           end do

           print*, "! energyPacketDriver: ending resonance line packets transfer"

        end if


        if (iStar>0 .and. taskid==0) print*, 'Qphot = ', Qphot
        if (lgTalk) print*, 'Packets trapped = ', trapped, taskid

        ! evaluate Jste and Jdif
        ! NOTE : deltaE is in units of [E36 erg/s] however we also need a factor of
        ! 1.e-45 from the calculations of the volume of the cell hence these
        ! two factors cancel each other out giving units of [E-9erg/s] so we need to
        ! multiply by 1.E-9
        ! NOTE : Jste and Jdif calculated this way are in units of
        ! [erg sec^-1 cm^-2] -> no Hz^-1 as they are summed over separate bins (see
        ! Lucy A&A (1999)

        if(iStar>0. .and. taskid==0) then
           print*, 'Lstar', Lstar(iStar)
        end if


        contains


          subroutine energyPacketRun(chType, position, xP, yP, zP, gP, rR)
            implicit none

            type(vector),intent(inout) :: position         ! the position of the photon

            integer, dimension(2), intent(inout)    :: xP, yP, &
                 & zP                                            ! cartesian axes indeces
                                                                 ! 1= mother; 2=sub


            integer, intent(inout) :: rR               ! rerun?
            integer, intent(inout) :: gP               ! grid index
            integer                          :: igpr             ! grid pointer 1= mother 2=sub
            integer                          :: difSourceL(3)    ! cell indeces

            integer                          :: idirP, idirT     ! direction cosines

            type(photon_packet)              :: enPacket         ! the energu packet

            character(len=7), intent(inout)     :: chType           ! stellar or diffuse?

!            countRecursive = countRecursive+1
!            if (countRecursive > recursionLimit) then
!               trapped = trapped+1
!               return
!            end if

            rR = 0

            if (gP==1) then
               igpr = 1
            else if (gP>1) then
               igpr = 2
            else
               print*,  "! energyPacketRun: insane grid index"
               stop
            end if


            ! create a new photon packet
            select case (chType)

            ! if the energy packet is stellar
            case ("stellar")
               ! check for errors in the sources position
               if( position /= starPosition(iStar) ) then
                  print*, "! energyPacketRun: stellar energy packet must&
                       & start at the stellar position"
                  stop
               end if

               ! create the packet
               enPacket = newPhotonPacket(chType,position, xp, yp, zp, gp, noCellLoc)

            ! if the photon is from an extra source of diffuse radiation
             case ("diffExt")

                difSourceL(1) = xP(igpr)
                difSourceL(2) = yP(igpr)
                difSourceL(3) = zP(igpr)


                enPacket = newPhotonPacket(chType, position, xp, yp, zp, gP, difSourceL)

            ! if the photon is diffuse

            case ("diffuse")

                ! create the packet

                enPacket = newPhotonPacket(chType=chType, position=position, xP=xP, yP=yP, &
                     & zP=zP, gP=gP, difSource=noCellLoc)

            case ("dustEmi")

                ! crate the packet
                enPacket = newPhotonPacket(chType=chType, position=position, xP=xP, yP=yP, &
                     &zP=zP, gP=gP, difSource = noCellLoc)

            end select

            if (.not.lgDust .and. enPacket%nu < ionEdge(1) .and. .not.enPacket%lgLine) then

               ! the packet escapes without further interaction
               if (lgSymmetricXYZ) then
                  idirT = int(acos(abs(enPacket%direction%z))/dTheta)+1
               else
                  idirT = int(acos(enPacket%direction%z)/dTheta)+1
               end if

               if (idirT>totangleBinsTheta) then
                  idirT=totangleBinsTheta
               end if
               if (idirT<1 .or. idirT>totAngleBinsTheta) then
                  print*, '! energyPacketRun: error in theta direction cosine assignment',&
                       &  idirT, enPacket, dTheta, totAngleBinsTheta
                  stop
               end if


               if (abs(enPacket%direction%x)<1.e-35) then
                  idirP = 0
               else
                  if (lgSymmetricXYZ) then
                     idirP = int(atan(abs(enPacket%direction%y)/abs(enPacket%direction%x))/dPhi)
                  else
                     idirP = int(atan(enPacket%direction%y/enPacket%direction%x)/dPhi)
                  end if
               end if
               if (idirP<0) idirP=totAngleBinsPhi+idirP

               idirP=idirP+1

               if (idirP>totangleBinsPhi) then
                  idirP=totangleBinsPhi
!                  print*, '! energyPacketRun: idir>totanglebins - error corrected', &
!                       & idir, totanglebins, enPacket%direction, dtheta
               end if

               if (idirP<1 .or. idirP>totAngleBinsPhi) then
                  print*, '! energyPacketRun: error in phi direction cosine assignment -1',&
                       &  idirP, enPacket, dPhi, totAngleBinsPhi
                  stop
               end if

               if (nAngleBins>0) then
                  if (viewPointPtheta(idirT) > 0 .and. viewPointPhi(viewPointPtheta(idirT)) < 0) then

                     grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), enPacket%nuP,viewPointPtheta(idirT)) = &
                          &grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                          & enPacket%nuP,viewPointPtheta(idirT)) + deltaE(iStar)
                     grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                          & enPacket%nuP,0) = &
                          & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                          & enPacket%nuP,0) +  deltaE(iStar)

                  elseif (viewPointPtheta(idirT) == viewPointPphi(idirP).or. &
                       & (viewPointTheta(viewPointPphi(idirP))==viewPointTheta(viewPointPtheta(idirT))) .or. &
                       & (viewPointPhi(viewPointPtheta(idirT))==viewPointPhi(viewPointPphi(idirP))) ) then

                     grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), enPacket%nuP,viewPointPtheta(idirT)) = &
                          &grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                          & enPacket%nuP,viewPointPtheta(idirT)) + deltaE(iStar)
                     if (viewPointPtheta(idirT)/=0) grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                          & enPacket%nuP,0) = &
                          & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                          & enPacket%nuP,0) +  deltaE(iStar)

                  else

                     grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                          & enPacket%nuP,0) = &
                          & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                          & enPacket%nuP,0) +  deltaE(iStar)

                  end if

               else

                  if (enPacket%origin(1) == 0) then
                     print*, '! energyPacketRun: enPacket%origin(1) ==0'
                     stop
                  end if
                  if (enPacket%origin(2) < 0) then
                     print*, '! energyPacketRun: enPacket%origin(2) < 0'
                     stop
                  end if

                  grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                       & enPacket%nuP,0) = &
                       & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                       & enPacket%nuP,0) +  deltaE(iStar)

               end if

               return
            end if

            ! if the new packet is capable of re-ionizing or we have dust
            if (.not.enPacket%lgLine) then

                ! compute the next segment of trajectory
                call pathSegment(enPacket)

                return

            else ! if the packet is a line packet
                ! add to respective line packet bin

               if (lgDebug) &
                    & grid(gP)%linePackets(grid(gP)%active(enPacket%xP(igpr), &
                    & enPacket%yP(igpr), enPacket%zP(igpr)), enPacket%nuP) = &
                    & grid(gP)%linePackets(grid(gP)%active(enPacket%xP(igpr), &
                    & enPacket%yP(igpr), enPacket%zP(igpr)), enPacket%nuP) +deltaE(iStar)


            end if

        end subroutine energyPacketRun


        ! this function initializes a photon packet
        function initPhotonPacket(nuP,  position, direction, lgLine, lgStellar, xP, yP, zP, gP, lgHg)
            implicit none

            type(photon_packet)      :: initPhotonPacket  ! the photon packet

            real                     :: random            ! random number

            integer, intent(in)      :: nuP               ! the frequency of the photon packet
            integer, intent(in),dimension(2) :: xP, yP, &
                 & zP                                     ! indeces of position on the x, y and z axes
            integer, intent(in)      :: gP                ! grid index
            integer                  :: igpi              ! grid pointer 1=mother, 2=sub


            logical, intent(in)      :: lgLine, lgStellar,&
                 & lgHG ! line, stellar packet Heyney-Greenstein?

            type(vector), intent(in) :: position          ! the position at which the photon
                                                          ! packet is created
            type(vector), intent(in) :: direction
            ! local variables

            integer                  :: irepeat           ! counter


            initPhotonPacket%direction = direction

            if (.not. (direction%x >= 0. .or. direction%x < 0)) then
               print*, '! initPhotonPacket: [0] insane direction%x [direction%x]'
               print*, direction%x
               stop
            end if


            initPhotonPacket%position = position

            initPhotonPacket%iG  = gP

            if (gP==1) then
               igpi=1
            else if (gp>1) then
               igpi=2
            else
               print*, "! initPhotonPacket: insane gridp pointer"
               stop
            end if

            initPhotonPacket%nuP      = nuP

            initPhotonPacket%lgStellar = lgStellar



            ! check if photon packen is line or continuum photon
            if ( lgLine ) then
                ! line photon
                initPhotonPacket%nu       = 0.
                initPhotonPacket%lgLine   = .true.
            else
                ! continuum photon
                initPhotonPacket%nu       = nuArray(nuP)
                initPhotonPacket%lgLine   = .false.
            end if

            initPhotonPacket%xP  = xP
            initPhotonPacket%yP  = yP
            initPhotonPacket%zP  = zP

            if (.not.lgHG .or. lgIsotropic .or. initPhotonPacket%lgStellar) then
               ! cater for plane parallel ionization case
               if (initPhotonPacket%lgStellar .and. lgPlaneIonization) then

                  ! get position

                  ! x-direction
                  call random_number(random)
                  random = 1. - random
                  initPhotonPacket%position%x = &
                    & -(grid(gP)%xAxis(2)-grid(gP)%xAxis(1))/2. + random*( &
                    & (grid(gP)%xAxis(2)-grid(gP)%xAxis(1))/2.+&
                    & (grid(gP)%xAxis(grid(gP)%nx)-grid(gP)%xAxis(grid(gP)%nx-1))/2.+&
                    & grid(gP)%xAxis(grid(gP)%nx))
                  if (initPhotonPacket%position%x<grid(gP)%xAxis(1)) &
                       & initPhotonPacket%position%x=grid(gP)%xAxis(1)
                  if (initPhotonPacket%position%x>grid(gP)%xAxis(grid(gP)%nx))&
                       & initPhotonPacket%position%x=grid(gP)%xAxis(grid(gP)%nx)

                  call locate(grid(gP)%xAxis, initPhotonPacket%position%x,&
                       & initPhotonPacket%xP(igpi))
                  if (initPhotonPacket%xP(igpi) < grid(gP)%nx) then
                     if (initPhotonPacket%position%x >= &
                          &(grid(gP)%xAxis(initPhotonPacket%xP(igpi))+&
                          & grid(gP)%xAxis(initPhotonPacket%xP(igpi)+1))/2.) &
                          & initPhotonPacket%xP(igpi) = initPhotonPacket%xP(igpi)+1
                  end if

                  ! y-direction
                  initPhotonPacket%position%y = 0.
                  initPhotonPacket%yP(igpi) = 1

                  ! z-direction
                  call random_number(random)
                  random = 1. - random
                  initPhotonPacket%position%z = -&
                       & (grid(gP)%zAxis(2)-grid(gP)%zAxis(1))/2. &
                       & + random*( &
                       & (grid(gP)%zAxis(2)-grid(gP)%zAxis(1))/2.+&
                       & (grid(gP)%zAxis(grid(gP)%nz)-&
                       & grid(gP)%zAxis(grid(gP)%nz-1))/2.+&
                       & grid(gP)%zAxis(grid(gP)%nz))
                  if (initPhotonPacket%position%z<grid(gP)%zAxis(1)) &
                       & initPhotonPacket%position%z=grid(gP)%zAxis(1)
                  if (initPhotonPacket%position%z>&
                       & grid(gP)%zAxis(grid(gP)%nz)) &
                       & initPhotonPacket%position%z=&
                       & grid(gP)%zAxis(grid(gP)%nz)

                  call locate(grid(gP)%zAxis, &
                       & initPhotonPacket%position%z, initPhotonPacket%zP(igpi))
                  if (initPhotonPacket%zP(igpi) < grid(gP)%nz) then
                     if (initPhotonPacket%position%z >= &
                          & (grid(gP)%xAxis(initPhotonPacket%zP(igpi))+&
                          & grid(gP)%zAxis(initPhotonPacket%zP(igpi)+1))&
                          & /2.) initPhotonPacket%zP(igpi) =&
                          & initPhotonPacket%zP(igpi)+1
                  end if

                  if (initPhotonPacket%xP(igpi)<1) &
                       & initPhotonPacket%xP(igpi)=1
                  if (initPhotonPacket%zP(igpi)<1) &
                       & initPhotonPacket%zP(igpi)=1

                  ! direction is parallel to y-axis direction
                  initPhotonPacket%direction%x = 0.
                  initPhotonPacket%direction%y = 1.
                  initPhotonPacket%direction%z = 0.

                  if (initPhotonPacket%xP(igpi) >  &
                       & grid(gP)%xAxis(grid(gP)%nx) .or. &
                       & initPhotonPacket%zP(igpi) >  &
                       & grid(gP)%zAxis(grid(gP)%nz)) then
                     print*, "! initPhotonPacket: insanity in &
                          & planeIonisation init"
                     print*, igpi, initPhotonPacket%xP(igpi),  &
                          & grid(gP)%xAxis(grid(gP)%nx), &
                          & initPhotonPacket%zP(igpi), &
                          & grid(gP)%zAxis(grid(gP)%nz),  random, &
                          & initPhotonPacket%position%z

                     stop
                  end if

                  planeIonDistribution(initPhotonPacket%xP(igpi),&
                       & initPhotonPacket%zP(igpi)) = &
                       & planeIonDistribution(initPhotonPacket%xP(igpi),&
                       & initPhotonPacket%zP(igpi)) + 1

               else

                  do irepeat = 1, 1000000
                     ! get a random direction
                     initPhotonPacket%direction = randomUnitVector()

                     if (.not. (initPhotonPacket%direction%x >= 0. .or. initPhotonPacket%direction%x < 0)) then
                        print*, '! initPhotonPacket: [1] insane initPhotonPacket%direction%x [initPhotonPacket%direction%x]'
                        print*, initPhotonPacket%direction%x
                        stop
                     end if

                     if (initPhotonPacket%direction%x/=0. .and. &
                          & initPhotonPacket%direction%y/=0. .and. &
                          & initPhotonPacket%direction%z/=0.) exit
                  end do

               end if

               if ((lgSymmetricXYZ) .and. initPhotonPacket%lgStellar &
                    & .and. .not.lgMultistars) then
                  if (initPhotonPacket%direction%x<0.) &
                       & initPhotonPacket%direction%x = -initPhotonPacket%direction%x
                  if (initPhotonPacket%direction%y<0.) &
                       & initPhotonPacket%direction%y = -initPhotonPacket%direction%y
                  if (initPhotonPacket%direction%z<0.) &
                       & initPhotonPacket%direction%z = -initPhotonPacket%direction%z
               end if

            end if

            initPhotonPacket%origin(1) = gP
            initPhotonPacket%origin(2) = grid(gP)%active(initPhotonPacket%xP(igpi),&
                 & initPhotonPacket%yP(igpi), initPhotonPacket%zP(igpi))


        end function initPhotonPacket


        ! this subroutine determines the frequency of a newly created photon packet
        ! according to the given probability density
        subroutine getNu(probDen, nuP)

            real, dimension(:), intent(in) :: probDen    ! probability density function

            integer, intent(out)           :: nuP         ! frequency index of the new

            ! local variables
            real                           :: random     ! random number

            ! get a random number
            call random_number(random)

            random = 1.-random

            ! see what frequency random corresponds to
            call locate(probDen, random, nuP)
             if (nuP <= 0) nuP = 1

 !           if (probDen(nuP) /= random) then
 !              nuP = nuP+1
 !           end if

             if (nuP<nbins) then
                if (random>=(probDen(nuP+1)+probDen(nuP))/2.) nuP=nuP+1
             end if

        end subroutine getNu

        ! this subroutine determines the frequency of a newly created photon packet
        ! according to the given probability density
        ! does not use bisection to locate nu on array
        subroutine getNu2(probDen, nuP)

            real, dimension(:), intent(in) :: probDen    ! probability density function

            real                           :: random     ! random number

            integer, intent(out)           :: nuP        ! frequency index of the new

            integer                        :: isearch,i  !

            ! get a random number
            call random_number(random)

            do i = 1, 10000
               if (random==0 .or. random==1. .or. random == 0.9999999) then
                  call random_number(random)
               else
                  exit
               end if
            end do
            if (i>=10000) then
               print*, '! getNu2: problem with random number generator', random, i
               stop
            end if

            ! see what frequency random corresponds to
            nuP=1
            do isearch = 1, nbins
               if (random>=probDen(isearch)) then
                  nuP=isearch
               else
                  exit
               end if
            end do

            if (nuP<nbins-1) then
               nuP=nuP+1
            end if

            if (nuP>=nbins) then
               print*, 'random: ', random
               print*, 'probDen: ', probDen
            end if

          end subroutine getNu2


        ! this function creates a new photon packet
        function newPhotonPacket(chType, position, xP, yP, zP, gP, difSource)

            type(photon_packet)                :: newPhotonPacket! the photon packet to be created

            character(len=7), intent(in)       :: chType         ! stellar or diffuse?

            type(vector), intent(in), optional :: position       ! the position of the photon
                                                                 ! packet
            ! local variables
            type(vector)                       :: positionLoc    ! the position of the photon
                                                                 ! packet

            integer                            :: nuP            ! the frequency index of the photon packet
            integer, dimension(2)         :: orX,orY,orZ    ! dummy
            integer, dimension(2), intent(in) :: xP, yP, &
                 & zP                                            ! cartesian axes indeces
            integer, intent(in)      :: difSource(3)  ! grid and cell indeces
            integer, intent(inout)   :: gP
            integer                            :: igpn           ! grid pointe 1=motehr, 2=sub

            real                               :: random         ! random number

            if (gP==1) then
               igpn = 1
            else if (gp>1) then
               igpn = 2
            else
               print*,  "! newPhotonPacket: insane grid pointer"
               stop
            end if

            select case (chType)

            ! if the photon is stellar
            case ("stellar")

                ! check for errors in the sources position
               if( position /= starPosition(iStar) ) then
                  print*, "! newPhotonPacket: stellar photon packet must&
                       & start at the stellar position"
                  stop
               end if


!                gP = starIndeces(iStar,4)

                if (starIndeces(iStar,4) == 1) then
                   igpn = 1
                else if (starIndeces(iStar,4) > 1) then
                   igpn = 2
                else
                   print*,  "! newPhotonPacket: insane grid pointer -star position- "
                   stop
                end if

                ! determine the frequency of the newly created photon packet
                call getNu2(inSpectrumProbDen(iStar,1:nbins), nuP)

                if (nuP>=nbins) then
                   print*, "! newPhotonPacket: insanity occurred in stellar photon &
                        &nuP assignment (nuP,xP,yP,zP,activeP)", nuP, xP(igpn),yP(igpn),zP(igpn), &
                        & grid(starIndeces(iStar,4))%active(xP(igpn),yP(igpn),zP(igpn))
                   print*, "inSpectrumProbDen: ",iStar,inSpectrumProbDen(iStar,:), nuP
                   stop
                end if

                if (nuP < 1) then
                    print*, "! newPhotonPacket: insanity occurred in stellar photon &
&                               nuP assignment"
                    stop
                end if

                ! initialize the new photon packet
                orX(igpn) = starIndeces(iStar,1)
                orY(igpn) = starIndeces(iStar,2)
                orZ(igpn) = starIndeces(iStar,3)


                if (grid(starIndeces(iStar,4))%active(orX(igpn), orY(igpn), orZ(igpn)) < 0.) then
                   print*, "! newPhotonPacket: new packet cannot be emitted from re-mapped cell -1-"
                   print*, "chType, nuP, starPosition(iStar), .false., .true., orX,orY,orZ, gp"
                   print*, chType, nuP, starPosition(iStar), .false., .true., orX,orY,orZ, gp
                   stop
                end if

                newPhotonPacket = initPhotonPacket(nuP, &
                     &starPosition(iStar), nullUnitVector,.false., .true., &
                     & orX,orY,orZ, &
                     & starIndeces(iStar,4), .false.)


                if (newPhotonPacket%nu>1.) then
                   Qphot = Qphot + deltaE(iStar)/(2.1799153e-11*newPhotonPacket%nu)
                end if

                ! if the photon is from an extra diffuse source
             case ("diffExt")

                call getNu2(inSpectrumProbDen(0,1:nbins), nuP)

                if (nuP>=nbins) then
                   print*, "! newPhotonPacket: insanity occurred in extra diffuse photon &
                        & nuP assignment (nuP,gp,activeP)", nuP, gp
                   print*, "difSpectrumProbDen: ", inSpectrumProbDen(0,:)
                   stop
                end if

                if (nuP < 1) then
                   print*, "! newPhotonPacket: insanity occurred in extra diffuse photon &
                        & nuP assignment (nuP,gp,activeP)", nuP, gp,grid(gP)%active(xP(igpn),yP(igpn),zP(igpn))
                   print*, "difSpectrumProbDen: ", inSpectrumProbDen(0,:)
                   stop
                end if

                positionLoc%x = grid(gP)%xAxis(difSource(1))
                positionLoc%y = grid(gP)%yAxis(difSource(2))
                positionLoc%z = grid(gP)%zAxis(difSource(3))

                ! initialize the new photon packet
                orX(igPn) = difSource(1)
                orY(igPn) = difSource(2)
                orZ(igPn) = difSource(3)

                ! initialize the new photon packet
                if (grid(gP)%active(orX(igpn), orY(igpn), orZ(igpn)) < 0.) then
                   print*, "! newPhotonPacket: new packet cannot be emitted from re-mapped cell -3-"
                   print*, "chType, nuP, starPosition(iStar), .false., .true., orX,orY,orZ, gp"
                   print*, chType, nuP, starPosition(iStar), .false., .true., orX,orY,orZ, gp
                   stop
                end if
!                newPhotonPacket = initPhotonPacket(nuP, positionLoc, .false., .false., orX,&
!                     & orY, orZ, gP)

                newPhotonPacket = initPhotonPacket(nuP, positionLoc, &
                     & nullUnitVector,.false., .false., orX,&
                     & orY, orZ, gP, .false.)


            ! if the photon is diffuse
            case ("diffuse")

                ! check that gas is present in the grid
                if (.not.lgGas) then
                   print*, "! newPhotonPacket: diffuse packet cannot be created in a no gas grid"
                   stop
                end if

                ! check that the position is not inside the inner region
                if (grid(gP)%active(xP(igPn),yP(igPn),zP(igPn))<= 0) then
                    print*, "! newPhotonPacket: position of the new diffuse &
                         & photon packet is inside the inner region", xP(igPn),yP(igPn),zP(igPn),gP
                    stop
                end if

                ! decide whether continuum or line photon
                call random_number(random)

                random = 1.-random

                if (random <= grid(gP)%totalLines(grid(gP)%active(xP(igPn),yP(igPn),zP(igPn)))) then
                   ! line photon
                   ! line photons escape so don't care which one it is unless debugging
                   if (lgDebug) then
                      call getNu2( grid(gP)%linePDF(grid(gP)%active(xP(igPn),yP(igPn),zP(igPn)),:), nuP )

                      if (nuP < 1) then
                         print*, "! newPhotonPacket: insanity occurred in line photon &
                              & nuP assignment"
                         stop
                      end if

                   else

                      nuP = 0

                   end if

                   ! initialize the new photon packet
                   if (grid(gP)%active(xP(igpn), yp(igpn), zp(igpn)) < 0.) then
                      print*, "! newPhotonPacket: new packet cannot be emitted from re-mapped cell -4-"
                      print*, "chType, nuP, starPosition(iStar), .false., .true., xp,yp,zp, gp"
                      print*, chType, nuP, starPosition(iStar), .false., .true., xp,yp,zp, gp
                      stop
                   end if


                   newPhotonPacket = initPhotonPacket(nuP, position, &
                        & nullUnitVector, .true., .false., xP, yP, zP, gP, .false.)
!                   newPhotonPacket = initPhotonPacket(nuP, position, .true., .false., xP, yP, zP, gP)
                else
                    ! continuum photon

                    call getNu2(grid(gP)%recPDF(grid(gP)%active(xP(igPn),yP(igPn),zP(igPn)),1:nbins), nuP)

                    if (nuP>=nbins) then
                       print*, "! newPhotonPacket: insanity occurred in diffuse photon &
                       & nuP assignment (nuP,xP,yP,zP,activeP)", nuP, xP(igPn),yP(igPn),zP(igPn),&
                       &  grid(gP)%active(xP(igPn),yP(igPn),zP(igPn))
                       print*, "recPDF: ", grid(gP)%recPDF(grid(gP)%active(xP(igPn),yP(igPn),zP(igPn)),1:nbins)
                       stop
                    end if

                    if (nuP < 1) then
                        print*, "! newPhotonPacket: insanity occurred in diffuse photon &
                             & nuP assignment", nuP, xP(igPn),yP(igPn),zP(igPn), &
                             & grid(gP)%active(xP(igPn),yP(igPn),zP(igPn))
                       print*, "recPDF: ", grid(gP)%recPDF(grid(gP)%active(xP(igPn),yP(igPn),zP(igPn)),:)
                        stop
                    end if

                    ! initialize the new photon packet
                   if (grid(gP)%active(xP(igpn), yp(igpn), zp(igpn)) < 0.) then
                      print*, "! newPhotonPacket: new packet cannot be emitted from re-mapped cell -5-"
                      print*, "chType, nuP, starPosition(iStar), .false., .true., xp,yp,zp, gp"
                      print*, chType, nuP, starPosition(iStar), .false., .true., xp,yp,zp, gp
                      stop
                   end if

!                    newPhotonPacket = initPhotonPacket(nuP, position, .false., .false., xP, yP, zP, gP)


                    newPhotonPacket = initPhotonPacket(nuP, position, nullUnitVector,&
                         & .false., .false., xP, yP, zP, gP, .false.)

                end if

            case ("dustEmi")

               ! check dust is present
               if (.not.lgDust) then
                  print*, "! newPhotonPacket: dust emitted packet cannot be created in a &
                       &no dust grid."
                  stop
               end if

               if (lgGas) then
                  print*, "! newPhotonPacket: dustEmi-type packet should be created in a &
                       & grid containing gas."
                  stop
               end if

               ! check that the position is not inside the inner region
               if (grid(gP)%active(xP(igPn),yP(igPn),zP(igPn))<= 0) then
                  print*, "! newPhotonPacket: position of the new dust emitted &
                       &photon packet is inside the inner region", xP(igPn),yP(igPn),zP(igPn)
                  stop
               end if

               call getNu2(grid(gP)%dustPDF(grid(gP)%active(xP(igPn),yP(igPn),zP(igPn)),1:nbins), nuP)

               if (nuP>=nbins) then
                   print*, "! newPhotonPacket: insanity occurred in dust emitted photon &
                       &nuP assignment (iphot, nuP,xP(gP),yP(gP),zP(gP),activeP)", iphot, &
                       & nuP, xP(igPn),yP(igPn),zP(igPn), &
                       & grid(gP)%active(xP(igPn),yP(igPn),zP(igPn))
                   print*, "dustPDF: ", grid(gP)%dustPDF(grid(gP)%active(xP(igPn),yP(igPn),zP(igPn)),1:nbins)
                   print*, "grain T: ", grid(gP)%Tdust(:,0,grid(gP)%active(xP(igPn),yP(igPn),zP(igPn)))
                   stop
                end if

               if (nuP < 1) then
                  print*, "! newPhotonPacket: insanity occurred in dust emitted photon &
                       &nuP assignment", nuP,xP(igPn),yP(igPn),zP(igPn), grid(gP)%active(xP(igPn),yP(igPn),zP(igPn))
                  print*, "dustPDF: ", grid(gP)%dustPDF(grid(gP)%active(xP(igPn),yP(igPn),zP(igPn)),1:nbins)
                  print*, "grain T: ", grid(gP)%Tdust(:, 0, grid(gP)%active(xP(igPn),yP(igPn),zP(igPn)))
                  stop
               end if

               ! initialize the new photon packet
                   if (grid(gP)%active(xP(igpn), yp(igpn), zp(igpn)) < 0.) then
                      print*, "! newPhotonPacket: new packet cannot be emitted from re-mapped cell -6-"
                      print*, "chType, nuP, starPosition(iStar), .false., .true., xp,yp,zp, gp"
                      print*, chType, nuP, starPosition(iStar), .false., .true., xp,yp,zp, gp
                      stop
                   end if

!               newPhotonPacket = initPhotonPacket(nuP, position, .false., .false., xP, yP, zP, gP)

               newPhotonPacket = initPhotonPacket(nuP, position, nullUnitVector,&
                    & .false., .false., xP, yP, zP, gP, .false.)



            ! if the photon packet type is wrong or missing
            case default

                print*, "! newPhotonPacket: wrong photon packet type - 'stellar', 'diffuse' and &
                     & dust emitted types allowed-"
                stop
            end select

        end function newPhotonPacket

        subroutine pathSegment(enPacket)
          implicit none

          type(photon_packet), intent(inout) :: enPacket ! the energy packet

          ! local variables
          type(vector)                    :: vHat     ! direction vector
          type(vector)                    :: rVec     ! position vector

          real                            :: absTau   ! optical depth
          real                            :: dlLoc    ! local displacement
          real                            :: dx, dy, dz
          real                            :: dSx, dSy, dSz
                                                      ! distances from x,y and z wall
          real                            :: dS       ! distance from nearest wall
          real                            :: dV       ! lume of this cell
          real                            :: passProb ! prob of passing the next segment
          real                            :: probSca  ! prob that the packet scatters
          real                            :: radius   ! radius
          real                            :: random   ! random number
          real                            :: tauCell  ! local tau

          integer                         :: iierr, ihg
          integer                         :: idirT,idirP ! direction cosine counters
          integer                         :: i, j, nS ! counter
          integer                         :: xP,yP,zP ! cartesian axes indeces
          integer                         :: gP       ! grid index
          integer                         :: igpp     ! grid index 1=mother 2=sub
          integer                         :: safeLimit =1000
                                                      ! safe limit for the loop

          character(len=7)                :: packetType ! stellar, diffuse, dustEmitted?

          logical                         :: lgScattered ! is the packet scattering with dust?
          logical                         :: lgReturn


          if (enPacket%iG == 1) then
             igpp = 1
          else if (enPacket%iG>1) then
             igpp = 2
          else
             print*, "! pathSegment: insane grid index"
             stop
          end if

          ! check that the input position is not outside the grid
          if ( (enPacket%iG <= 0).or.(enPacket%iG > nGrids) ) then
             print*, "! pathSegment: starting position not in any defined grids"
             print*, 'iPhot                 ', iPhot
             print*, 'enPacket%nuP          ', enPacket%nuP
             print*, 'enPacket%iG           ', enPacket%iG
             print*, 'enPacket%xP           ', enPacket%xP
             print*, 'enPacket%yP           ', enPacket%yP
             print*, 'enPacket%zP           ', enPacket%zP
             print*, 'enPacket%lgStellar    ', enPacket%lgStellar
             print*, 'enPacket%lgLine       ', enPacket%lgLine
             print*, 'enPacket%position     ', enPacket%position
             print*, 'enPacket%direction    ', enPacket%direction
             stop
          else if ( (enPacket%xP(igpp) <= 0).or.&
               &(enPacket%xP(igpp) > grid(enPacket%iG)%nx) ) then
             print*, "! pathSegment: starting position in x is outside the grid",&
                  & enPacket
             stop
          else if ( (enPacket%yP(igpp) <= 0).or. &
               & (enPacket%yP(igpp) > grid(enPacket%iG)%ny) ) then
             print*, "! pathSegment: starting position in y is outside the grid",&
                  & enPacket
             stop
          else if ( (enPacket%zP(igpp) <= 0).or.&
               & (enPacket%zP(igpp) > grid(enPacket%iG)%nz) ) then
             print*, "! pathSegment: starting position in z is outside the grid",&
                  & enPacket
             stop
          end if

          ! define vHat and rVec
          rVec = enPacket%position
          vHat = enPacket%direction


          if (.not. (rVec%x >= 0. .or. rVec%x < 0)) then
             print*, '! pathSegment: [0] insane rVec%x [rVec%x, dlLoc, vHat%x]'
             print*, rVec%x, dlLoc, vHat%x
             stop
          end if
          if (.not. (vHat%x >= 0. .or. vHat%x < 0)) then
             print*, '! pathSegment: [0] insane vHat%x [rVec%x, dlLoc, vHat%x]'
             print*, rVec%x, dlLoc, vHat%x
             stop
          end if


          ! initialize xP, yP,zP
          xP = enPacket%xP(igpp)
          yP = enPacket%yP(igpp)
          zP = enPacket%zP(igpp)
          gP = enPacket%iG

          ! initialise distance from walls
          dSx = 0.
          dSy = 0.
          dSz = 0.

          if (lg1D) then
             radius = 1.e10*sqrt((rVec%x/1.e10)*(rVec%x/1.e10) + &
                  &                               (rVec%y/1.e10)*(rVec%y/1.e10) + &
                  &                               (rVec%z/1.e10)*(rVec%z/1.e10))
             call locate(grid(1)%xAxis, radius, xP)
             if (nGrids > 1 .or. gP >1) then
                print*, " ! pathSegment: multiple grids are not allowed in a 1D simulation"
                stop
             end if
          end if

          ! initialize optical depth
          absTau = 0.

          ! get a random number
          call random_number(random)

          ! calculate the probability
          passProb = -log(1.-random)

          ! speed up photons that my be trapped
          if (lgPlaneIonization) then
             safeLimit=5000
          else
             safeLimit=500000
!             safeLimit=500
          end if

          do i = 1, safeLimit

             do j = 1, safeLimit

                if (xP > grid(gP)%nx .or. xP < 1 .or. &
                     & yP > grid(gP)%ny .or. yP < 1 .or. &
                     & zP > grid(gP)%nz .or. zP < 1 ) then
                   print*, "! pathSegment: insanity [gp,xp,yp,zp,j,i]", &
                        & gp, xp, yp, zp, j, i
                   stop
                end if

                if (grid(gP)%active(xP,yP,zP)<0) then

                   ! packet is entering a subgrid
                   enPacket%xP(1) = xP
                   enPacket%yP(1) = yP
                   enPacket%zP(1) = zP


                   gP = abs(grid(gP)%active(xP,yP,zP))

                   ! where is the packet in the sub-grid?

                   call locate(grid(gP)%xAxis, rVec%x, xP)
                   if (xP==0) xP = xP+1
                   if (xP< grid(gP)%nx) then
                      if (rVec%x >  (grid(gP)%xAxis(xP+1)+grid(gP)%xAxis(xP))/2.) &
                           & xP = xP + 1
                   end if

                   call locate(grid(gP)%yAxis, rVec%y, yP)
                   if (yP==0) yP=yP+1
                   if (yP< grid(gP)%ny) then
                      if (rVec%y >  (grid(gP)%yAxis(yP+1)+grid(gP)%yAxis(yP))/2.) &
                           & yP = yP + 1
                   end if

                   call locate(grid(gP)%zAxis, rVec%z, zP)
                   if (zP==0) zP=zP+1
                   if (zP< grid(gP)%nz) then
                      if (rVec%z >  (grid(gP)%zAxis(zP+1)+grid(gP)%zAxis(zP))/2.) &
                           & zP = zP + 1
                   end if


                   enPacket%iG = gP
                   igpp = 2

                end if ! line 1224


                ! find distances from all walls

                if (lgSymmetricXYZ) then
                   if ( rVec%x <= grid(1)%xAxis(1) ) then
                      if (vHat%x<0.) vHat%x = -vHat%x
                      rVec%x = grid(1)%xAxis(1)
                   end if
                   if ( rVec%y <= grid(1)%yAxis(1) ) then
                      if (vHat%y<0.) vHat%y = -vHat%y
                      rVec%y = grid(1)%yAxis(1)
                   end if
                   if ( rVec%z <= grid(1)%zAxis(1) ) then
                      if (vHat%z<0.) vHat%z = -vHat%z
                      rVec%z = grid(1)%zAxis(1)
                   end if
                end if

                if (vHat%x>1.e-10) then
                   if (xP<grid(gP)%nx) then

                      dSx = ( (grid(gP)%xAxis(xP+1)+grid(gP)%xAxis(xP))/2.-rVec%x)/vHat%x

                      if (abs(dSx)<1.e-10) then
                         rVec%x=(grid(gP)%xAxis(xP+1)+grid(gP)%xAxis(xP))/2.
                         xP = xP+1
                      end if
                   else
                      dSx = ( grid(gP)%xAxis(grid(gP)%nx)-rVec%x)/vHat%x
                      if (abs(dSx)<1.e-10) then
                         rVec%x=grid(gP)%xAxis(grid(gP)%nx)
                         if (.not.lgPlaneIonization .and. gP==1) return
                      end if
                   end if
                else if (vHat%x<-1.e-10) then
                   if (xP>1) then
                      dSx = ( (grid(gP)%xAxis(xP)+grid(gP)%xAxis(xP-1))/2.-rVec%x)/vHat%x
                      if (abs(dSx)<1.e-10) then
                         rVec%x=(grid(gP)%xAxis(xP)+grid(gP)%xAxis(xP-1))/2.
                         xP = xP-1
                      end if
                   else
                      dSx = (grid(gP)%xAxis(1)-rVec%x)/vHat%x
                      if (abs(dSx)<1.e-10) then
                         rVec%x=grid(gP)%xAxis(1)
                      end if
                   end if
                else
!                   dSx = grid(gP)%xAxis(grid(gP)%nx)
                   dSx =1.e35
                end if

                if (.not. (dSx >= 0. .or. dSx <0.)) then
                   print*, '! pathSegment: insane dSx [dSx, xP, grid(gP)%xAxis(xP), rVec%x, vHat%x]'
                   print*, dSx, xP, grid(gP)%xAxis(xP), rVec%x, vHat%x
                   stop
                end if

                if (.not.lg1D) then
                   if (vHat%y>1.e-10) then
                      if (yP<grid(gP)%ny) then
                         dSy = ( (grid(gP)%yAxis(yP+1)+grid(gP)%yAxis(yP))/2.-rVec%y)/vHat%y
                         if (abs(dSy)<1.e-10) then
                            rVec%y=(grid(gP)%yAxis(yP+1)+grid(gP)%yAxis(yP))/2.
                            yP = yP+1
                         end if
                      else
                         dSy = (  grid(gP)%yAxis(grid(gP)%ny)-rVec%y)/vHat%y
                         if (abs(dSy)<1.e-10) then
                            rVec%y=grid(gP)%yAxis(grid(gP)%ny)
                            if(gP==1) return
                         end if
                      end if
                   else if (vHat%y<-1.e-10) then
                      if (yP>1) then
                         dSy = ( (grid(gP)%yAxis(yP)+grid(gP)%yAxis(yP-1))/2.-rVec%y)/vHat%y
                         if (abs(dSy)<1.e-10) then
                            rVec%y=(grid(gP)%yAxis(yP)+grid(gP)%yAxis(yP-1))/2.
                            yP = yP-1
                         end if
                      else
                         dSy = ( grid(gP)%yAxis(1)-rVec%y)/vHat%y
                         if (abs(dSy)<1.e-10) then
                            rVec%y=grid(gP)%yAxis(1)
                         end if
                      end if
                   else
!                      dSy = grid(gP)%yAxis(grid(gP)%ny)
                      dSy = 1.e35
                   end if

                   if (.not. (dSy >= 0. .or. dSy <0.)) then
                      print*, '! pathSegment: insane dSy [dSy, yP, grid(gP)%yAxis(yP), rVec%y, vHat%y]'
                      print*, dSy, yP, grid(gP)%yAxis(yP), rVec%y, vHat%y
                      stop
                   end if


                   if (vHat%z>1.e-10) then
                      if (zP<grid(gP)%nz) then
                         dSz = ( (grid(gP)%zAxis(zP+1)+grid(gP)%zAxis(zP))/2.-rVec%z)/vHat%z
                         if (abs(dSz)<1.e-10) then
                            rVec%z=(grid(gP)%zAxis(zP+1)+grid(gP)%zAxis(zP))/2.
                            zP = zP+1
                         end if
                      else
                         dSz = ( grid(gP)%zAxis(grid(gP)%nz)-rVec%z)/vHat%z
                         if (abs(dSz)<1.e-10) then
                            rVec%z=grid(gP)%zAxis(grid(gP)%nz)
                            if (.not.lgPlaneIonization .and. gP==1) return
                         end if
                      end if
                   else if (vHat%z<-1.e-10) then
                      if (zP>1) then
                         dSz = ( (grid(gP)%zAxis(zP)+grid(gP)%zAxis(zP-1))/2.-rVec%z)/vHat%z
                         if (abs(dSz)<1.e-10) then
                            rVec%z=(grid(gP)%zAxis(zP)+grid(gP)%zAxis(zP-1))/2.
                            zP = zP-1
                         end if
                      else
                         dSz = ( grid(gP)%zAxis(1)-rVec%z)/vHat%z
                         if (abs(dSz)<1.e-10) then
                            rVec%z=grid(gP)%zAxis(1)
                         end if
                      end if
                   else
!                      dSz = grid(gP)%zAxis(grid(gP)%nz)
                      dSz = 1.e35
                   end if

                   if (.not. (dSz >= 0. .or. dSz <0.)) then
                      print*, '! pathSegment: insane dSz [dSz, zP, grid(gP)%zAxis(zP), rVec%z, vHat%z]'
                      print*, dSz, zP, grid(gP)%zAxis(zP), rVec%z, vHat%z
                      stop
                   end if

                   if (xP > grid(gP)%nx .or. xP < 1 .or. &
                        & yP > grid(gP)%ny .or. yP < 1 .or. &
                        & zP > grid(gP)%nz .or. zP < 1 ) then
                      print*, "! pathSegment: insanity -2- [gp,xp,yp,zp]", &
                           & gp, xp, yp, zp
                      stop
                   end if

                end if

                if (grid(gP)%active(xP,yP,zP)>=0) exit
             end do

             ! cater for cells on cell wall
             if ( abs(dSx)<1.e-10 ) dSx = grid(gP)%xAxis(grid(gP)%nx)
             if ( abs(dSy)<1.e-10 ) dSy = grid(gP)%yAxis(grid(gP)%ny)
             if ( abs(dSz)<1.e-10 ) dSz = grid(gP)%zAxis(grid(gP)%nz)

             ! find the nearest wall
             dSx = abs(dSx)
             dSy = abs(dSy)
             dSz = abs(dSz)

             if (dSx<=0.) then
                print*, '! pathSegment: [warning] dSx <= 0.',dSx
                print*, 'grid(gP)%xAxis ', grid(gP)%xAxis
                print*, 'gP,xP,grid(gP)%xAxis(xP), rVec%x, vHat%x'
                print*, gP,xP,grid(gP)%xAxis(xP), rVec%x, vHat%x
                dS = min(dSy, dSz)
             else if (dSy<=0.) then
                print*, '! pathSegment: [warning] dSy <= 0.', dSy
                print*, 'grid(gP)%yAxis ', grid(gP)%yAxis
                print*, 'gP,yP,grid(gP)%yAxis(yP), rVec%y, vHat%y'
                print*, gP,yP,grid(gP)%yAxis(yP), rVec%y, vHat%y
                dS = min(dSx, dSz)
             else if (dSz<=0.) then
                print*, '! pathSegment: [warning] dSz <= 0.', dSz
                print*, 'grid(gP)%zAxis ', grid(gP)%zAxis
                print*, 'gP,zP,grid(gP)%zAxis(zP), rVec%z, vHat%z'
                print*, gP,zP,grid(gP)%zAxis(zP), rVec%z, vHat%z
                dS = min(dSx, dSy)
             else
                dS = min(dSx,dSy)
                dS = min(dS, dSz)
             end if

             ! this should now never ever happen
             if (dS <= 0.) then
                print*, 'pathSegment: dS <= 0', dSx, dSy, dSz
                print*, gP, rVec
                stop
             end if

             ! calculate the optical depth to the next cell wall
             tauCell = dS*grid(gP)%opacity(grid(gP)%active(xP,yP,zP), enPacket%nuP)


             ! find the volume of this cell
!             dV = getVolumeLoc(grid(gP), xP,yP,zP)


             if (lg1D) then
                if (nGrids>1) then
                   print*, '! getVolumeLoc: 1D option and multiple grids options are not compatible'
                   stop
                end if

                if (xP == 1) then

                   dV = 4.*Pi* ( (grid(gP)%xAxis(xP+1)/1.e15)**3)/3.


                else if ( xP==grid(gP)%nx) then

                   dV = Pi* ( (3.*(grid(gP)%xAxis(xP)/1.e15)-(grid(gP)%xAxis(xP-1)/1.e15))**3 - &
                        & ((grid(gP)%xAxis(xP)/1.e15)+(grid(gP)%xAxis(xP-1)/1.e15))**3 ) / 6.

                else

                   dV = Pi* ( ((grid(gP)%xAxis(xP+1)/1.e15)+(grid(gP)%xAxis(xP)/1.e15))**3 - &
                        & ((grid(gP)%xAxis(xP-1)/1.e15)+(grid(gP)%xAxis(xP)/1.e15))**3 ) / 6.

                end if

                dV = dV/8.

             else

                if ( (xP>1) .and. (xP<grid(gP)%nx) ) then

                   dx = abs(grid(gP)%xAxis(xP+1)-grid(gP)%xAxis(xP-1))/2.
                else if ( xP==1 ) then
                   if (lgSymmetricXYZ) then
                      dx = abs(grid(gP)%xAxis(xP+1)-grid(gP)%xAxis(xP))/2.
                   else
                      dx = abs(grid(gP)%xAxis(xP+1)-grid(gP)%xAxis(xP))
                   end if
                else if ( xP==grid(gP)%nx ) then
                   dx = abs(grid(gP)%xAxis(xP)  -grid(gP)%xAxis(xP-1))
                end if

                if ( (yP>1) .and. (yP<grid(gP)%ny) ) then
                   dy = abs(grid(gP)%yAxis(yP+1)-grid(gP)%yAxis(yP-1))/2.
                else if ( yP==1 ) then
                   if (lgSymmetricXYZ) then
                      dy = abs(grid(gP)%yAxis(yP+1)-grid(gP)%yAxis(yP))/2.
                   else
                      dy = abs(grid(gP)%yAxis(yP+1)-grid(gP)%yAxis(yP))
                   end if
                else if ( yP==grid(gP)%ny ) then
                   dy = abs(grid(gP)%yAxis(yP)  -grid(gP)%yAxis(yP-1))
                end if

                if ( (zP>1) .and. (zP<grid(gP)%nz) ) then
                   dz = abs(grid(gP)%zAxis(zP+1)-grid(gP)%zAxis(zP-1))/2.
                 else if ( zP==1 ) then
                   if (lgSymmetricXYZ) then
                      dz = abs(grid(gP)%zAxis(zP+1)-grid(gP)%zAxis(zP))/2.
                   else
                      dz = abs(grid(gP)%zAxis(zP+1)-grid(gP)%zAxis(zP))
                   end if
                else if ( zP==grid(gP)%nz ) then
                   dz = abs(grid(gP)%zAxis(zP)-grid(gP)%zAxis(zP-1))
                end if

                dx = dx/1.e15
                dy = dy/1.e15
                dz = dz/1.e15


                ! calculate the volume
                dV = dx*dy*dz

             end if

             ! check if the packet interacts within this cell
             if ((absTau+tauCell > passProb) .and. (grid(gP)%active(xP,yP,zP)>0)) then
! .and. &
!                  & grid(gP)%opacity(grid(gP)%active(xP,yP,zP), enPacket%nuP) > 1.e-10) then

                ! packet interacts

                ! calculate where within this cell the packet is absorbed
                dlLoc = (passProb-absTau)/grid(gP)%opacity(grid(gP)%active(xP,yP,zP), enPacket%nuP)

                ! update packet's position
                rVec = rVec + dlLoc*vHat

                if (.not. (rVec%x >= 0. .or. rVec%x < 0)) then
                   print*, '! pathSegment: insane rVec%x [rVec%x, dlLoc, vHat%x]'
                   print*, rVec%x, dlLoc, vHat%x
                   stop
                end if

                if (.not. (rVec%y >= 0. .or. rVec%y < 0)) then
                   print*, '! pathSegment: insane rVec%y [rVec%y, dlLoc, vHat%y]'
                   print*, rVec%y, dlLoc, vHat%y
                   stop
                end if

                if (.not. (rVec%z >= 0. .or. rVec%z < 0)) then
                   print*, '! pathSegment: insane rVec%z [rVec%z, dlLoc, vHat%z]'
                   print*, rVec%z, dlLoc, vHat%z
                   stop
                end if

                if (lgSymmetricXYZ .and. gP==1) then
                   if ( rVec%x <= grid(gP)%xAxis(1) ) then
                      if (vHat%x<0.) vHat%x = -vHat%x
                      rVec%x = grid(gP)%xAxis(1)
                   end if
                   if ( rVec%y <= grid(gP)%yAxis(1) ) then
                      if (vHat%y<0.) vHat%y = -vHat%y
                      rVec%y = grid(gP)%yAxis(1)
                   end if
                   if ( rVec%z <= grid(gP)%zAxis(1) ) then
                      if (vHat%z<0.) vHat%z = -vHat%z
                      rVec%z = grid(gP)%zAxis(1)
                   end if
                end if

                ! add contribution of the packet to the radiation field
                if (enPacket%lgStellar) then
                   grid(gP)%Jste(grid(gP)%active(xP,yP,zP),enPacket%nuP) = &
                        grid(gP)%Jste(grid(gP)%active(xP,yP,zP),enPacket%nuP) + dlLoc*deltaE(iStar) / dV
                else ! if the energy packet is diffuse
                   if (lgDebug) then
                      grid(gP)%Jdif(grid(gP)%active(xP,yP,zP),enPacket%nuP) = &
                           & grid(gP)%Jdif(grid(gP)%active(xP,yP,zP),enPacket%nuP) + dlLoc*deltaE(iStar) / dV
                   else
                      grid(gP)%Jste(grid(gP)%active(xP,yP,zP),enPacket%nuP) = &
                           & grid(gP)%Jste(grid(gP)%active(xP,yP,zP),enPacket%nuP) + dlLoc*deltaE(iStar) / dV
                   end if
                end if

                ! check if the position within the cell is still within the outer radius
                if ( sqrt( (rvec%x/1.e10)**2 + (rvec%y/1.e10)**2 + (rvec%z/1.e10)**2)*1.e10 >= R_out &
                     & .and. R_out > 0.) then


                   ! the packet escapes without further interaction
                   if (lgSymmetricXYZ) then
                      idirT = int(acos(abs(enPacket%direction%z))/dTheta)+1
                   else
                      idirT = int(acos(enPacket%direction%z)/dTheta)+1
                   end if

                   if (idirT>totangleBinsTheta) then
                      idirT=totangleBinsTheta
                   end if
                   if (idirT<1 .or. idirT>totAngleBinsTheta) then
                      print*, '! pathSegment: error in theta direction cosine assignment',&
                           &  idirT, enPacket, dTheta, totAngleBinsTheta
                      stop
                   end if

!                   if (enPacket%direction%x<1.e-35) then
!                      idirP = 0
!                   else
!                      idirP = int(atan(enPacket%direction%y/enPacket%direction%x)/dPhi)
!                   end if
!                   if (idirP<0) idirP=totAngleBinsPhi+idirP


                   if (abs(enPacket%direction%x)<1.e-35) then
                      idirP = 0
                   else
                      if (lgSymmetricXYZ) then
                         idirP = int(atan(abs(enPacket%direction%y)/abs(enPacket%direction%x))/dPhi)
                      else
                         idirP = int(atan(enPacket%direction%y/enPacket%direction%x)/dPhi)
                      end if
                   end if
                   if (idirP<0) idirP=totAngleBinsPhi+idirP

                   idirP=idirP+1

                   if (idirP>totangleBinsPhi) then
                      idirP=totangleBinsPhi
                   end if

                   if (idirP<1 .or. idirP>totAngleBinsPhi) then
                      print*, '! pathSegment: error in Phi direction cosine assignment -2',&
                           &  idirP, enPacket, dPhi, totAngleBinsPhi
                      stop
                   end if

!print*, 'a', nanglebins
!print*, enPacket%lgStellar, enPacket%direction
!print*, idirT, viewPointPTheta(idirT), viewPointTheta(viewPointPTheta(idirT))
!print*, idirP, viewPointPPhi(idirP), viewPointPhi(viewPointPPhi(idirP)), viewPointPhi(viewPointPtheta(idirT))

                   if (nAngleBins>0) then
                      if (viewPointPtheta(idirT) > 0 .and. viewPointPhi(viewPointPtheta(idirT)) < 0) then
                         grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), enPacket%nuP,viewPointPtheta(idirT)) = &
                              &grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                              & enPacket%nuP,viewPointPtheta(idirT)) + deltaE(iStar)
                         grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                              & enPacket%nuP,0) = &
                              & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                              & enPacket%nuP,0) +  deltaE(iStar)

                      elseif (viewPointPtheta(idirT) == viewPointPphi(idirP).or. &
                           & (viewPointTheta(viewPointPphi(idirP))==viewPointTheta(viewPointPtheta(idirT))) .or. &
                           & (viewPointPhi(viewPointPtheta(idirT))==viewPointPhi(viewPointPphi(idirP))) ) then
                         grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), enPacket%nuP,viewPointPtheta(idirT)) = &
                              &grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                              & enPacket%nuP,viewPointPtheta(idirT)) +  deltaE(iStar)
                         if (viewPointPtheta(idirT)/=0) grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                              & enPacket%nuP,0) = &
                              & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                              & enPacket%nuP,0) +  deltaE(iStar)
                      else
                         grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                          & enPacket%nuP,0) = &
                          & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                          & enPacket%nuP,0) +  deltaE(iStar)
                      end if
                   else

                      grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                           & enPacket%nuP,0) = &
                           & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                           & enPacket%nuP,0) +  deltaE(iStar)

                   end if

                   return
                end if


                ! check if the packet is absorbed or scattered
                if (lgDust) then

                   probSca = grid(gP)%scaOpac(grid(gP)%active(xP,yP,zP),enPacket%nuP)/&
                        & (grid(gP)%opacity(grid(gP)%active(xP,yP,zP),enPacket%nuP))

                   call random_number(random)

                   random = 1.-random

                   if (random > probSca) then
                      lgScattered = .false.
                   else if (random <= probSca) then
                      lgScattered = .true.
                   else
                      print*, '! pathSegment: insanity occurred at the scattering/absorption&
                           & decision stage.'
                      print*,'gP,xP,yP,zP,nuP'
                      print*,gP,xP,yP,zP,nuP
                      print*,'scaOpac,opacity,Ndust'
                      print*,&
 &grid(gP)%scaOpac(grid(gP)%active(xP,yP,zP),enPacket%nuP),&
 &grid(gP)%opacity(grid(gP)%active(xP,yP,zP),enPacket%nuP),&
 &grid(gP)%Ndust(grid(gP)%active(xP,yP,zP))
                      print*,'random number=',random,'probSca=',probSca
                      stop
                   end if

                   if (.not. lgScattered) then

                      absInt = absInt + 1.

                      if (.not.lgGas) then

                         ! packet is absobed by the dust
                         packetType = "dustEmi"
                         exit

                      else

                         ! packet is absobed by the dust+gas
                         packetType = "diffuse"
                         exit

                      end if

                   else

                      scaInt = scaInt + 1.

                      if (lgMultiDustChemistry) then
                         do nS = 1, nSpeciesPart(grid(gP)%dustAbunIndex(grid(gP)%active(xP,yP,zP)))
                            if (grainabun(grid(gP)%dustAbunIndex(grid(gP)%active(xP,yP,zP)),nS)>0. &
                                 &.and. grid(gP)%Tdust(nS, 0, &
                                 & grid(gP)%active(xP,yP,zP))<TdustSublime(dustComPoint(&
                                 &grid(gP)%dustAbunIndex(grid(gP)%active(xP,yP,zP)))-1+nS)) exit
                         end do
                         if (nS>nSpeciesPart(grid(gP)%dustAbunIndex(grid(gP)%active(xP,yP,zP)))) then
                            print*, "! pathSegment: packet scatters with dust at position where all &
                                 &grains have sublimed -1-."
                            print*, xP,yP,zP, grid(gP)%active(xP,yP,zP), tauCell, absTau, passProb
                            stop
                         end if
                      else
                         do nS = 1, nSpeciesPart(1)
                            if (grainabun(1,nS)>0. &
                                 &.and. grid(gP)%Tdust(nS, 0, &
                                 & grid(gP)%active(xP,yP,zP))<TdustSublime(dustComPoint(&
                                 &1)-1+nS)) exit
                         end do
                         if (nS>nSpeciesPart(1)) then
                            print*, "! pathSegment: packet scatters with dust at position where all &
                                 &grains have sublimed -2-."
                            print*, xP,yP,zP, grid(gP)%active(xP,yP,zP), tauCell, absTau, passProb
                            stop
                         end if
                      end if

                      ! packet is scattered by the grain
                      ! calculate new direction

                      enPacket%xP(igpp) = xP
                      enPacket%yP(igpp) = yP
                      enPacket%zP(igpp) = zP


                      if (grid(gP)%active(enPacket%xp(igpp), enPacket%yp(igpp), enPacket%zp(igpp)) < 0.) then
                         print*, "! pathSegment: new packet cannot be emitted from re-mapped cell -1-"
                         print*, "nuP, starPosition(iStar), .false., .true., xp,yp,zp, gp"
                         print*, nuP, starPosition(iStar), .false., .true.,  xp,yp,zp, gp
                         stop
                      end if

                      enPacket = initPhotonPacket(enPacket%nuP, rVec, enPacket%direction, .false., .false., enPacket%xP(1:2), &
                           & enPacket%yP(1:2), enPacket%zP(1:2), gP, .true.)

                      if (.not.lgIsotropic .and. .not.enPacket%lgStellar) then
                         do ihg = 1,10
                            call hg(enPacket,iierr)
                            if(iierr==0) exit
                         end do
                         if (ihg >=10) then
                            print*, '! pathSegment [warning]: hg called ten times [enPacket]', enPacket
                         end if
                      end if

                      vHat%x = enPacket%direction%x
                      vHat%y = enPacket%direction%y
                      vHat%z = enPacket%direction%z


                      if (.not. (enPacket%direction%x >= 0. .or. enPacket%direction%x < 0)) then
                         print*, '! pathSegment: [1] insane direction%x [direction%x]'
                         print*, enPacket%direction%x
                         stop
                      end if


                      ! initialize optical depth
                      absTau = 0.

                      ! get a random number
                      call random_number(random)

                      ! calculate the probability
                      passProb = -log(1.-random)

                   end if

                else

                   absInt = absInt + 1.

                   if (.not.lgGas) then
                      print*, "! pathSegment: Insanity occurred - no gas present when no dust interaction"
                      stop
                   end if

                   ! packet interacts with gas
                   packetType = "diffuse"
                   exit

                end if


             else

                ! the packet is not absorbed within this cell
                ! add contribution of the packet to the radiation field

                if (enPacket%lgStellar) then
                   grid(gP)%Jste(grid(gP)%active(xP,yP,zP),enPacket%nuP) = &
                        grid(gP)%Jste(grid(gP)%active(xP,yP,zP),enPacket%nuP) + dS*deltaE(iStar) / dV
                else ! if the energy packet is diffuse
                   if (lgDebug) then
                      grid(gP)%Jdif(grid(gP)%active(xP,yP,zP),enPacket%nuP) = &
                           & grid(gP)%Jdif(grid(gP)%active(xP,yP,zP),enPacket%nuP) + dS*deltaE(iStar) / dV
                   else
                      grid(gP)%Jste(grid(gP)%active(xP,yP,zP),enPacket%nuP) = &
                           & grid(gP)%Jste(grid(gP)%active(xP,yP,zP),enPacket%nuP) + dS*deltaE(iStar) / dV
                   end if
                end if

                ! update absTau
                absTau = absTau+tauCell

                ! update packet's position
                rVec = rVec+dS*vHat

                ! keep track of where you are on mother grid
                if (gP>1) then

                   if (enPacket%xP(1) <= 0 .or. &
                        & enPacket%yP(1) <= 0 .or. &
                        & enPacket%zP(1) <= 0 .or. &
                        & enPacket%xP(1) > grid(grid(gP)%motherP)%nx .or. &
                        & enPacket%yP(1) > grid(grid(gP)%motherP)%ny .or. &
                        & enPacket%zP(1) > grid(grid(gP)%motherP)%nz) then

                      ! locate where we are at on the mother grid
                      call locate(grid(grid(gP)%motherP)%xAxis, rvec%x, enPacket%xP(1))
                      if ( enPacket%xP(1)< grid(grid(gP)%motherP)%nx) then
                         if ( rvec%x > ( grid(grid(gP)%motherP)%xAxis(enPacket%xP(1)) + &
                              & grid(grid(gP)%motherP)%xAxis(enPacket%xP(1)+1)/2.) ) &
                              & enPacket%xP(1) = enPacket%xP(1)+1
                      end if

                      call locate( grid(grid(gP)%motherP)%yAxis, rvec%y, enPacket%yP(1))
                      if ( enPacket%yP(1)< grid(grid(gP)%motherP)%ny) then
                         if ( rvec%y > ( grid(grid(gP)%motherP)%yAxis(enPacket%yP(1)) + &
                              & grid(grid(gP)%motherP)%yAxis(enPacket%yP(1)+1)/2.) ) &
                              & enPacket%yP(1) = enPacket%yP(1)+1
                      end if

                      call locate(grid(grid(gP)%motherP)%zAxis, rvec%z, enPacket%zP(1))
                      if ( enPacket%zP(1)< grid(grid(gP)%motherP)%nz) then
                         if ( rvec%z > ( grid(grid(gP)%motherP)%zAxis(enPacket%zP(1)) + &
                              & grid(grid(gP)%motherP)%zAxis(enPacket%zP(1)+1)/2.) ) &
                              & enPacket%zP(1) = enPacket%zP(1)+1
                      end if

                   else

                      if (vHat%x>0.) then
                         if ( enPacket%xP(1) < grid(grid(gP)%motherP)%nx ) then
                            if ( rVec%x > (grid(grid(gP)%motherP)%xAxis(enPacket%xP(1))+&
                                 & grid(grid(gP)%motherP)%xAxis(enPacket%xP(1)+1))/2. ) then
                               enPacket%xP(1) = enPacket%xP(1)+1
                            end if
                         else
                            if ( rVec%x > grid(grid(gP)%motherP)%xAxis(enPacket%xP(1))) then
!                            print*, '! pathSegment: insanity occurred at mother grid transfer (x axis +)', &
!                                 & rVec%x, gP, grid(gP)%motherP
!                            stop
                            end if
                         end if
                      else
                         if ( enPacket%xP(1) > 1 ) then
                            if ( rVec%x <= (grid(grid(gP)%motherP)%xAxis(enPacket%xP(1)-1)+&
                                 & grid(grid(gP)%motherP)%xAxis(enPacket%xP(1)))/2. ) then
                               enPacket%xP(1) = enPacket%xP(1)-1
                            end if
                         else
                            if (rVec%x < grid(grid(gP)%motherP)%xAxis(1)) then
!                            print*, '! pathSegment: insanity occurred at mother grid transfer (x axis-)',&
!                                 & rVec%x, gP, grid(gP)%motherP
!                            stop
                            end if
                         end if
                      end if
                      if (vHat%y>0.) then
                         if (  enPacket%yP(1) < grid(grid(gP)%motherP)%ny ) then
                            if ( rVec%y > (grid(grid(gP)%motherP)%yAxis( enPacket%yP(1))+&
                                 & grid(grid(gP)%motherP)%yAxis(enPacket%yP(1)+1))/2. ) then
                               enPacket%yP(1) =  enPacket%yP(1)+1
                            end if
                         else
                            if ( rVec%y > grid(grid(gP)%motherP)%yAxis( enPacket%yP(1))) then
!                            print*, '! pathSegment: insanity occurred at mother grid transfer (y axis +)',&
!                                 & rVec%y, gP, grid(gP)%motherP
!                            stop
                            end if
                         end if
                      else
                         if (  enPacket%yP(1) > 1 ) then
                            if ( rVec%y <= (grid(grid(gP)%motherP)%yAxis( enPacket%yP(1)-1)+&
                                 & grid(grid(gP)%motherP)%yAxis(enPacket%yP(1)))/2. ) then
                               enPacket%yP(1) =  enPacket%yP(1)-1
                            end if
                         else
                            if (rVec%y < grid(grid(gP)%motherP)%yAxis(1)) then
!                            print*, '! pathSegment: insanity occurred at mother grid transfer (y axis -)', &
!                                 & rVec%y, gP, grid(gP)%motherP
!                            stop
                            end if
                         end if
                      end if
                      if (vHat%z>0.) then
                         if (  enPacket%zP(1) < grid(grid(gP)%motherP)%nz ) then
                            if ( rVec%z > (grid(grid(gP)%motherP)%zAxis( enPacket%zP(1))+&
                                 & grid(grid(gP)%motherP)%zAxis(enPacket%zP(1)+1))/2. ) then
                               enPacket%zP(1) =  enPacket%zP(1)+1
                            end if
                         else
                            if ( rVec%z > grid(grid(gP)%motherP)%zAxis( enPacket%zP(1))) then
!                            print*, '! pathSegment: insanity occurred at mother grid transfer (z axis +)', &
!                                 & rVec%z, gP, grid(gP)%motherP
!                            stop
                            end if
                         end if
                      else
                         if (  enPacket%zP(1) > 1 ) then
                            if ( rVec%z <= (grid(grid(gP)%motherP)%zAxis( enPacket%zP(1)-1)+&
                                 & grid(grid(gP)%motherP)%zAxis(enPacket%zP(1)))/2. ) then
                               enPacket%zP(1) =  enPacket%zP(1)-1
                            end if
                         else
                            if (rVec%z < grid(grid(gP)%motherP)%zAxis(1)) then
!                        print*, '! pathSegment: insanity occurred at mother grid transfer (z axis -)', &
!                             & rVec%z, gP, grid(gP)%motherP
!                        stop
                            end if
                         end if
                      end if

                   end if
                end if

                if (.not.lg1D) then
                   if ( (dS == dSx) .and. (vHat%x > 0.)  ) then
                      xP = xP+1
                   else if ( (dS == dSx) .and. (vHat%x < 0.) ) then
                      xP = xP-1
                   else if ( (dS == dSy) .and. (vHat%y > 0.) ) then
                      yP = yP+1
                   else if ( (dS == dSy) .and. (vHat%y < 0.) ) then
                      yP = yP-1
                   else if ( (dS == dSz) .and. (vHat%z > 0.) ) then
                      zP = zP+1
                   else if ( (dS == dSz) .and. (vHat%z < 0.) ) then
                      zP = zP-1
                   else
                      print*, '! pathSegment: insanity occurred in dS assignement &
                           & [dS,dSx,dSy,dSz,vHat]', dS,dSx,dSy,dSz,vHat
                   end if
                else
                   radius = 1.e10*sqrt((rVec%x/1.e10)*(rVec%x/1.e10) + &
                        & (rVec%y/1.e10)*(rVec%y/1.e10) + &
                        & (rVec%z/1.e10)*(rVec%z/1.e10))
                   call locate(grid(gP)%xAxis, radius , xP)

                end if

                ! be 6/6/06
                if(.not.lgPlaneIonization.and..not.lgSymmetricXYZ) then
                   lgReturn=.false.

                   if ( rVec%y <= grid(gP)%yAxis(1)-grid(gP)%geoCorrY .or. yP<1) then

                      ! the energy packet escapes this grid
                      if (gP==1) then
                         yP=1
                         lgReturn=.true.
                      else if (gP>1) then
                         xP = enPacket%xP(grid(gP)%motherP)
                         yP = enPacket%yP(grid(gP)%motherP)
                         zP = enPacket%zP(grid(gP)%motherP)
                         gP = grid(gP)%motherP
                      else
                         print*, '! pathSegment: insanity occurred - invalid gP', gP
                         stop
                      end if

                   end if

                   if (rVec%y > grid(gP)%yAxis(grid(gP)%ny)+grid(gP)%geoCorrY .or. yP>grid(gP)%ny) then

                      if (gP==1) then
                         ! the energy packet escapes
                         yP = grid(gP)%ny
                         lgReturn=.true.
                      else if (gP>1) then
                         xP = enPacket%xP(grid(gP)%motherP)
                         yP =  enPacket%yP(grid(gP)%motherP)
                         zP =  enPacket%zP(grid(gP)%motherP)
                         gP = grid(gP)%motherP
                      else
                         print*, '! pathSegment: insanity occurred - invalid gP', gP
                         stop
                      end if

                   end if

                   if ( (rVec%x <= grid(gP)%xAxis(1)-grid(gP)%geoCorrX .or. xP<1) .and. gP==1) then
                      xP=1
                      lgReturn=.true.

                   end if


                   if ( (rVec%x <= grid(gP)%xAxis(1)-grid(gP)%geoCorrX .or. xP<1) &
                    & .and. gP>1) then

                      xP = enPacket%xP(grid(gP)%motherP)
                      yP =  enPacket%yP(grid(gP)%motherP)
                      zP =  enPacket%zP(grid(gP)%motherP)
                      gP = grid(gP)%motherP

                   end if


                   if ( (rVec%x >=  grid(gP)%xAxis(grid(gP)%nx)+grid(gP)%geoCorrX &
                        & .or. xP>grid(gP)%nx) .and. gP==1 )then
                      xP = grid(gP)%nx
                      lgReturn=.true.

                   end if

                   if ( (rVec%x >=  grid(gP)%xAxis(grid(gP)%nx)+grid(gP)%geoCorrX&
                        & .or. xP>grid(gP)%nx) .and.  gP>1) then

                      xP = enPacket%xP(grid(gP)%motherP)
                      yP =  enPacket%yP(grid(gP)%motherP)
                      zP =  enPacket%zP(grid(gP)%motherP)
                      gP = grid(gP)%motherP

                   end if

                   if ( (rVec%z <= grid(gP)%zAxis(1)-grid(gP)%geoCorrZ .or.zP<1) &
                        & .and. gP==1) then
                      zP=1
                      lgReturn=.true.

                   end if

                   if ( (rVec%z <= grid(gP)%zAxis(1)-grid(gP)%geoCorrZ &
                        & .or.zP<1) .and. gP>1) then

                      xP = enPacket%xP(grid(gP)%motherP)
                      yP =  enPacket%yP(grid(gP)%motherP)
                      zP =  enPacket%zP(grid(gP)%motherP)
                      gP = grid(gP)%motherP

                   end if

                   if ( (rVec%z >=  grid(gP)%zAxis(grid(gP)%nz)+grid(gP)%geoCorrZ &
                        & .or. zP>grid(gP)%nz) &
                        & .and. gP==1) then

                      zP = grid(gP)%nz
                      lgReturn=.true.

                   end if

                   if ((rVec%z >=  grid(gP)%zAxis(grid(gP)%nz)+grid(gP)%geoCorrZ &
                        & .or. zP>grid(gP)%nz) .and. gP>1) then

                      xP = enPacket%xP(grid(gP)%motherP)
                      yP =  enPacket%yP(grid(gP)%motherP)
                      zP =  enPacket%zP(grid(gP)%motherP)
                      gP = grid(gP)%motherP

                   end if

                   if (lgReturn) then

                      ! the packet escapes without further interaction
                      ! the packet escapes without further interaction
                      if (lgSymmetricXYZ) then
                         idirT = int(acos(abs(enPacket%direction%z))/dTheta)+1
                      else
                         idirT = int(acos(enPacket%direction%z)/dTheta)+1
                      end if

!                      idirT = int(acos(enPacket%direction%z)/dTheta)+1
                      if (idirT>totangleBinsTheta) then
                         idirT=totangleBinsTheta
                      end if
                      if (idirT<1 .or. idirT>totAngleBinsTheta) then
                         print*, '! pathSegment: error in theta direction cosine assignment',&
                              &  idirT, enPacket, dTheta, totAngleBinsTheta
                         stop
                      end if


!                      if (enPacket%direction%x<1.e-35) then
!                         idirP = 0
!                      else
!                         idirP = int(atan(enPacket%direction%y/enPacket%direction%x)/dPhi)
!                      end if
!                      if (idirP<0) idirP=totAngleBinsPhi+idirP

                      if (abs(enPacket%direction%x)<1.e-35) then
                         idirP = 0
                      else
                         if (lgSymmetricXYZ) then
                            idirP = int(atan(abs(enPacket%direction%y)/abs(enPacket%direction%x))/dPhi)
                         else
                            idirP = int(atan(enPacket%direction%y/enPacket%direction%x)/dPhi)
                         end if
                      end if
                      if (idirP<0) idirP=totAngleBinsPhi+idirP

                      idirP=idirP+1

                      if (idirP>totangleBinsPhi) then
                         idirP=totangleBinsPhi
                      end if
                      if (idirP<1 .or. idirP>totAngleBinsPhi) then
                         print*, '! pathSegment: error in phi direction cosine assignment -3',&
                              &  idirP, enPacket, dPhi, totAngleBinsPhi
                         stop
                      end if


!print*, 'b''c', nanglebins
!print*, enPacket%lgStellar, enPacket%direction
!print*, idirT, viewPointPTheta(idirT), viewPointTheta(viewPointPTheta(idirT))
!print*, idirP, viewPointPPhi(idirP), viewPointPhi(viewPointPPhi(idirP)), viewPointPhi(viewPointPtheta(idirT))

                      if (nAngleBins>0) then
                         if (viewPointPtheta(idirT) > 0 .and. viewPointPhi(viewPointPtheta(idirT)) < 0) then

                            grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), enPacket%nuP,viewPointPtheta(idirT)) = &
                                 &grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                 & enPacket%nuP,viewPointPtheta(idirT)) + deltaE(iStar)
                            grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                 & enPacket%nuP,0) = &
                                 & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                 & enPacket%nuP,0) +  deltaE(iStar)

                         elseif (viewPointPtheta(idirT) == viewPointPphi(idirP).or. &
                              & (viewPointTheta(viewPointPphi(idirP))==viewPointTheta(viewPointPtheta(idirT))) .or. &
                              & (viewPointPhi(viewPointPtheta(idirT))==viewPointPhi(viewPointPphi(idirP))) ) then
                            grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), enPacket%nuP,&
                                 & viewPointPtheta(idirT)) =grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2),&
                                 & enPacket%nuP,viewPointPtheta(idirT)) +  deltaE(iStar)

                            if (viewPointPtheta(idirT)/=0) grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                 &enPacket%nuP,0) = &
                                 & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                 & enPacket%nuP,0) +  deltaE(iStar)

                         else
                            grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                 & enPacket%nuP,0) = &
                                 & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                 & enPacket%nuP,0) +  deltaE(iStar)

                         end if

                      else

                         grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                              enPacket%nuP,0) = &
                              & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                              & enPacket%nuP,0) +  deltaE(iStar)
                      end if

                      return
                   end if

                end if

                ! end be 6/6/06


                if(lgPlaneIonization) then
                   lgReturn=.false.

                   if ( rVec%y <= grid(gP)%yAxis(1)-grid(gP)%geoCorrY .or. yP<1) then

                      ! the energy packet escapes this grid
                      if (gP==1) then
                         yP=1
                         lgReturn=.true.
                      else if (gP>1) then
                         xP = enPacket%xP(1)
                         yP = enPacket%yP(1)
                         zP = enPacket%zP(1)
                         gP = 1
                         igpp = 1
                      else
                         print*, '! pathSegment: insanity occurred - invalid gP', gP
                         stop
                      end if

                   end if

                   if (rVec%y > grid(gP)%yAxis(grid(gP)%ny)+grid(gP)%geoCorrY .or. yP>grid(gP)%ny) then

                      if (gP==1) then
                         ! the energy packet escapes
                         yP = grid(gP)%ny
                         lgReturn=.true.
                      else if (gP>1) then
                         xP = enPacket%xP(1)
                         yP = enPacket%yP(1)
                         zP = enPacket%zP(1)
                         gP = 1
                         igpp = 1
                      else
                         print*, '! pathSegment: insanity occurred - invalid gP', gP
                         stop
                      end if

                   end if

                   if ( (rVec%x <= grid(1)%xAxis(1) .or. xP<1) ) then
                      xP=1
                      rVec%x = grid(gP)%xAxis(1)
                      vHat%x = -vHat%x

                   end if

                   if ( (rVec%x <= grid(gP)%xAxis(1)-grid(gP)%geoCorrX .or. xP<1) &
                        & .and. gP>1) then

                      xP = enPacket%xP(1)
                      yP = enPacket%yP(1)
                      zP = enPacket%zP(1)
                      gP = 1
                      igpp = 1

                   end if

                   if ( (rVec%x >=  grid(1)%xAxis(grid(gP)%nx) &
                        & .or. xP>grid(gP)%nx)  )then
                      xP = grid(gP)%nx
                      rVec%x = grid(gP)%xAxis(grid(gP)%nx)
                      vHat%x = -vHat%x

                   end if

                   if ( (rVec%x >=  grid(gP)%xAxis(grid(gP)%nx)+grid(gP)%geoCorrX&
                        & .or. xP>grid(gP)%nx) .and.  gP>1) then

                      xP = enPacket%xP(1)
                      yP = enPacket%yP(1)
                      zP = enPacket%zP(1)
                      gP = 1
                      igpp = 1
                   end if

                   if ( (rVec%z <= grid(1)%zAxis(1) .or.zP<1) ) then
                      zP=1
                      rVec%z = grid(gP)%yAxis(1)
                      vHat%z = -vHat%z

                   end if

                   if ( (rVec%z <= grid(gP)%zAxis(1)-grid(gP)%geoCorrZ &
                        & .or.zP<1) .and. gP>1) then

                      xP = enPacket%xP(1)
                      yP = enPacket%yP(1)
                      zP = enPacket%zP(1)
                      gP = 1
                      igpp = 1

                   end if

                   if ( (rVec%z >=  grid(1)%zAxis(grid(gP)%nz) .or. zP>grid(gP)%nz) &
                        & ) then

                      zP = grid(gP)%nz
                      rVec%z = grid(gP)%zAxis(grid(gP)%nz)
                      vHat%z = -vHat%z

                   end if

                   if ((rVec%z >=  grid(gP)%zAxis(grid(gP)%nz)+grid(gP)%geoCorrZ &
                        & .or. zP>grid(gP)%nz) .and. gP>1) then

                      xP = enPacket%xP(1)
                      yP = enPacket%yP(1)
                      zP = enPacket%zP(1)
                      gP = 1
                      igpp = 1

                   end if


                   if (lgReturn) then

                      ! the packet escapes without further interaction
                      ! the packet escapes without further interaction
                      if (lgSymmetricXYZ) then
                         idirT = int(acos(abs(enPacket%direction%z))/dTheta)+1
                      else
                         idirT = int(acos(enPacket%direction%z)/dTheta)+1
                      end if

!                      idirT = int(acos(enPacket%direction%z)/dTheta)+1
                      if (idirT>totangleBinsTheta) then
                         idirT=totangleBinsTheta
                      end if
                      if (idirT<1 .or. idirT>totAngleBinsTheta) then
                         print*, '! pathSegment: error in theta direction cosine assignment',&
                              &  idirT, enPacket, dTheta, totAngleBinsTheta
                         stop
                      end if



                      if (abs(enPacket%direction%x)<1.e-35) then
                         idirP = 0
                      else
                         if (lgSymmetricXYZ) then
                            idirP = int(atan(abs(enPacket%direction%y)/abs(enPacket%direction%x))/dPhi)
                         else
                            idirP = int(atan(enPacket%direction%y/enPacket%direction%x)/dPhi)
                         end if
                      end if
                      if (idirP<0) idirP=totAngleBinsPhi+idirP

!                      if (enPacket%direction%x<1.e-35) then
!                         idirP = 0
!                      else
!                         idirP = int(atan(enPacket%direction%y/enPacket%direction%x)/dPhi)
!                      end if
!                      if (idirP<0) idirP=totAngleBinsPhi+idirP

                      idirP=idirP+1

                      if (idirP>totangleBinsPhi) then
                         idirP=totangleBinsPhi
                      end if
                      if (idirP<1 .or. idirP>totAngleBinsPhi) then
                         print*, '! pathSegment: error in phi direction cosine assignment -4',&
                              &  idirP, enPacket, dPhi, totAngleBinsPhi
                         stop
                      end if


!print*, 'c', nanglebins
!print*, enPacket%lgStellar, enPacket%direction
!print*, idirT, viewPointPTheta(idirT), viewPointTheta(viewPointPTheta(idirT))
!print*, idirP, viewPointPPhi(idirP), viewPointPhi(viewPointPPhi(idirP)), viewPointPhi(viewPointPtheta(idirT))

                      if (nAngleBins>0) then
                         if (viewPointPtheta(idirT) > 0 .and. viewPointPhi(viewPointPtheta(idirT)) < 0) then

                            grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), enPacket%nuP,viewPointPtheta(idirT)) = &
                                 &grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                 & enPacket%nuP,viewPointPtheta(idirT)) + deltaE(iStar)
                            grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                 & enPacket%nuP,0) = &
                                 & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                 & enPacket%nuP,0) +  deltaE(iStar)

                         elseif (viewPointPtheta(idirT) == viewPointPphi(idirP).or. &
                              & (viewPointTheta(viewPointPphi(idirP))==viewPointTheta(viewPointPtheta(idirT))) .or. &
                              & (viewPointPhi(viewPointPtheta(idirT))==viewPointPhi(viewPointPphi(idirP))) ) then
                            grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), enPacket%nuP,viewPointPtheta(idirT)) = &
                                 &grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                 & enPacket%nuP,viewPointPtheta(idirT)) +  deltaE(iStar)
                            if (viewPointPtheta(idirT)/=0) grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                 enPacket%nuP,0) = &
                                 & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                 & enPacket%nuP,0) +  deltaE(iStar)

                         else
                            grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                 enPacket%nuP,0) = &
                             & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                             & enPacket%nuP,0) +  deltaE(iStar)

                         end if

                      else

                         grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                              enPacket%nuP,0) = &
                              & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                              & enPacket%nuP,0) +  deltaE(iStar)

                      end if

                      return
                   end if

                end if

                ! check if the path is still within the simulation region
                radius = 1.e10*sqrt((rVec%x/1.e10)*(rVec%x/1.e10) + &
                     &                     (rVec%y/1.e10)*(rVec%y/1.e10) + &
                     &                     (rVec%z/1.e10)*(rVec%z/1.e10))

                if (.not.lgPlaneIonization) then

                   if ( (.not.lgSymmetricXYZ .and. (rVec%x<=grid(1)%xAxis(1)-grid(1)%geoCorrX .or.&
                        & rVec%y<=grid(1)%yAxis(1)-grid(1)%geoCorrY .or. rVec%z<=grid(1)%zAxis(1)-&
                        & grid(1)%geoCorrZ)) .or.&
                        & (rVec%x >= grid(gP)%xAxis(grid(gP)%nx)+grid(gP)%geoCorrX) .or.&
                        &(rVec%y >= grid(gP)%yAxis(grid(gP)%ny)+grid(gP)%geoCorrY) .or.&
                        &(rVec%z >= grid(gP)%zAxis(grid(gP)%nz)+grid(gP)%geoCorrZ) .or. &
                        & xP>grid(gP)%nx .or. yP>grid(gP)%ny .or. zP>grid(gP)%nz ) then

                  if (gP==1) then

                     if (enPacket%xP(1) > grid(1)%nx) xP = grid(1)%nx
                     if (enPacket%yP(1) > grid(1)%ny) yP = grid(1)%ny
                     if (enPacket%zP(1) > grid(1)%nz) zP = grid(1)%nz
                     if (enPacket%xP(1) < 1) xP = 1
                     if (enPacket%yP(1) < 1) yP = 1
                     if (enPacket%zP(1) < 1) zP = 1


                     ! the energy packet escapes

                     ! the packet escapes without further interaction
                     ! the packet escapes without further interaction
                     if (lgSymmetricXYZ) then
                        idirT = int(acos(abs(enPacket%direction%z))/dTheta)+1
                     else
                        idirT = int(acos(enPacket%direction%z)/dTheta)+1
                     end if

!                     idirT = int(acos(enPacket%direction%z)/dTheta)+1
                     if (idirT>totangleBinsTheta) then
                        idirT=totangleBinsTheta
                     end if
                     if (idirT<1 .or. idirT>totAngleBinsTheta) then
                        print*, '! pathSegment: error in theta direction cosine assignment',&
                             &  idirT, enPacket, dTheta, totAngleBinsTheta
                        stop
                     end if

!                     if (enPacket%direction%x<1.e-35) then
!                        idirP = 0
!                     else
!                        idirP = int(atan(enPacket%direction%y/enPacket%direction%x)/dPhi)
!                     end if
!                     if (idirP<0) idirP=totAngleBinsPhi+idirP


                     if (abs(enPacket%direction%x)<1.e-35) then
                        idirP = 0
                     else
                        if (lgSymmetricXYZ) then
                           idirP = int(atan(abs(enPacket%direction%y)/abs(enPacket%direction%x))/dPhi)
                        else
                           idirP = int(atan(enPacket%direction%y/enPacket%direction%x)/dPhi)
                        end if
                     end if
                     if (idirP<0) idirP=totAngleBinsPhi+idirP

                     idirP=idirP+1

                     if (idirP>totangleBinsPhi) then
                        idirP=totangleBinsPhi
                     end if

                     if (idirP<1 .or. idirP>totAngleBinsPhi) then
                        print*, '! pathSegment: error in phi direction cosine assignment -5',&
                             &  idirP, enPacket, dPhi, totAngleBinsPhi
                        stop
                     end if

!print*, 'd', nanglebins
!print*, enPacket%lgStellar, enPacket%direction
!print*, idirT, viewPointPTheta(idirT), viewPointTheta(viewPointPTheta(idirT))
!print*, idirP, viewPointPPhi(idirP), viewPointPhi(viewPointPPhi(idirP)), viewPointPhi(viewPointPtheta(idirT))


                     if (nAngleBins>0) then
                        if (viewPointPtheta(idirT) > 0 .and. viewPointPhi(viewPointPtheta(idirT)) < 0) then

                           grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), enPacket%nuP,viewPointPtheta(idirT)) = &
                                &grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                & enPacket%nuP,viewPointPtheta(idirT)) + deltaE(iStar)
                           grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                & enPacket%nuP,0) = &
                                & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                & enPacket%nuP,0) +  deltaE(iStar)
!print*, 'd1', enPacket%origin(1), enPacket%origin(2)

                        elseif (viewPointPtheta(idirT) == viewPointPphi(idirP).or. &
                             & (viewPointTheta(viewPointPphi(idirP))==viewPointTheta(viewPointPtheta(idirT))) .or. &
                             & (viewPointPhi(viewPointPtheta(idirT))==viewPointPhi(viewPointPphi(idirP))) ) then
                           grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), enPacket%nuP,&
                                & viewPointPtheta(idirT)) = &
                                &grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                & enPacket%nuP,viewPointPtheta(idirT)) +  deltaE(iStar)
!print*, 'd2'
                           if (viewPointPtheta(idirT)/=0) grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                enPacket%nuP,0) = &
                                & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                & enPacket%nuP,0) +  deltaE(iStar)
                        else

!print*, 'd3'
                           grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                enPacket%nuP,0) = &
                                & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                & enPacket%nuP,0) +  deltaE(iStar)
                        end if
                     else
!print*, 'd4'
                        grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                             enPacket%nuP,0) = &
                             & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                             & enPacket%nuP,0) +  deltaE(iStar)

                     end if

                     !b2.005
                     return

                  else if (gP>1) then

                     xP = enPacket%xP(1)
                     yP = enPacket%yP(1)
                     zP = enPacket%zP(1)
                     gP = 1
                     igpp = 1


                     if (gP/=1) then
                        print*, '! pathSegment: nested multigrids still not implemented'
                        stop
                     end if

                     if ( (radius >= R_out .and. R_out >= 0.) .or.&
                          & (rVec%x >= grid(1)%xAxis(grid(1)%nx)+grid(1)%geoCorrX) .or.&
                          &(rVec%y >= grid(1)%yAxis(grid(1)%ny)+grid(1)%geoCorrY) .or.&
                          &(rVec%z >= grid(1)%zAxis(grid(1)%nz)+grid(1)%geoCorrZ) .or. &
                          & (.not.lgSymmetricXYZ .and.  (rVec%x<=grid(1)%xAxis(1)-grid(1)%geoCorrX .or.&
                          & rVec%y<=grid(1)%yAxis(1)-grid(1)%geoCorrY .or. rVec%z<=grid(1)%zAxis(1)-&
                          & grid(1)%geoCorrZ))) then


                        if (xP > grid(gP)%nx) xP = grid(gP)%nx
                        if (yP > grid(gP)%ny) yP = grid(gP)%ny
                        if (zP > grid(gP)%nz) zP = grid(gP)%nz

                        if (xP < 1) xP = 1
                        if (yP < 1) yP = 1
                        if (zP < 1) zP = 1

                        ! the energy packet escapes

                        ! the packet escapes without further interaction
                        ! the packet escapes without further interaction
                        if (lgSymmetricXYZ) then
                           idirT = int(acos(abs(enPacket%direction%z))/dTheta)+1
                        else
                           idirT = int(acos(enPacket%direction%z)/dTheta)+1
                        end if

!                        idirT = int(acos(enPacket%direction%z)/dTheta)+1
                        if (idirT>totangleBinsTheta) then
                           idirT=totangleBinsTheta
                        end if
                        if (idirT<1 .or. idirT>totAngleBinsTheta) then
                           print*, '! pathSegment: error in theta direction cosine assignment',&
                                &  idirT, enPacket, dTheta, totAngleBinsTheta
                           stop
                        end if

!                        if (enPacket%direction%x<1.e-35) then
!                           idirP = 0
!                        else
!                           idirP = int(atan(enPacket%direction%y/enPacket%direction%x)/dPhi)
!                        end if
!                        if (idirP<0) idirP=totAngleBinsPhi+idirP


                        if (abs(enPacket%direction%x)<1.e-35) then
                           idirP = 0
                        else
                           if (lgSymmetricXYZ) then
                              idirP = int(atan(abs(enPacket%direction%y)/abs(enPacket%direction%x))/dPhi)
                           else
                              idirP = int(atan(enPacket%direction%y/enPacket%direction%x)/dPhi)
                           end if
                        end if
                        if (idirP<0) idirP=totAngleBinsPhi+idirP


                        idirP=idirP+1

                        if (idirP>totangleBinsPhi) then
                           idirP=totangleBinsPhi
                        end if

                        if (idirP<1 .or. idirP>totAngleBinsPhi) then
                           print*, '! pathSegment: error in phi direction cosine assignment -6',&
                                &  idirP, enPacket, dPhi, totAngleBinsPhi
                           stop
                        end if

                        if (nAngleBins>0) then
                           if (viewPointPtheta(idirT) > 0 .and. viewPointPhi(viewPointPtheta(idirT)) < 0) then

                              grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), enPacket%nuP,viewPointPtheta(idirT)) = &
                                   &grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                   & enPacket%nuP,viewPointPtheta(idirT)) + deltaE(iStar)
                              grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                   & enPacket%nuP,0) = &
                                   & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                   & enPacket%nuP,0) +  deltaE(iStar)

                           elseif (viewPointPtheta(idirT) == viewPointPphi(idirP).or. &
                                &(viewPointTheta(viewPointPphi(idirP))==viewPointTheta(viewPointPtheta(idirT))).or. &
                                & (viewPointPhi(viewPointPtheta(idirT))==viewPointPhi(viewPointPphi(idirP))) ) then
                              grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), enPacket%nuP,&
                                   & viewPointPtheta(idirT)) = &
                                   &grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                   & enPacket%nuP,viewPointPtheta(idirT)) +  deltaE(iStar)
                              if (viewPointPtheta(idirT)/=0) grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                   enPacket%nuP,0) = &
                                   & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                   & enPacket%nuP,0) +  deltaE(iStar)
                           else
                              grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                   enPacket%nuP,0) = &
                                   & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                   & enPacket%nuP,0) +  deltaE(iStar)
                           end if
                        else

                           grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                enPacket%nuP,0) = &
                                & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                & enPacket%nuP,0) +  deltaE(iStar)

                        end if

                        !b2.005
                        return

                     end if
                  else
                     print*, '! pathSegment: insanity occurred - invalid gP - ', gP
                     stop
                  end if

               end if

!            if (lgSymmetricXYZ .and. gP == 1) then
               if (lgSymmetricXYZ ) then
                  if (lgPlaneIonization) then
                     print*, '! pathSegment: lgSymmetric and lgPlaneionization flags both raised'
                     stop
                  end if

                  if ( rVec%x <= grid(1)%xAxis(1) .or. (gP==1 .and. xP<1)) then
                     if (vHat%x<0.) vHat%x = -vHat%x
                     enPacket%xP(1) = 1
                     xP = 1
                     rVec%x = grid(gP)%xAxis(1)
                  end if
                  if ( rVec%y <= grid(1)%yAxis(1) .or. (gP==1 .and. yP<1)) then
                     if (vHat%y<0.) vHat%y = -vHat%y
                     enPacket%yP(1)=1
                     yP = 1
                     rVec%y = grid(gP)%yAxis(1)
                  end if
                  if ( rVec%z <= grid(1)%zAxis(1) .or. (gP==1 .and. zP<1)) then
                     if (vHat%z<0.) vHat%z = -vHat%z
                     enPacket%zP(1) = 1
                     zP=1
                     rVec%z = grid(1)%zAxis(1)
                  end if

               end if

            end if

            if (gP>1) then
               if ( ( (rVec%x <= grid(gP)%xAxis(1) &
                    &.or. xP<1) .and. vHat%x <=0.) .or. &
                    & ( (rVec%y <= grid(gP)%yAxis(1) &
                    & .or. yP<1) .and. vHat%y <=0.) .or. &
                    & ( (rVec%z <= grid(gP)%zAxis(1) &
                    &  .or. zP<1) .and. vHat%z <=0.) .or. &
                    & ( (rVec%x >= grid(gP)%xAxis(grid(gP)%nx) &
                    &.or. xP>grid(gP)%nx) .and. vHat%x >=0.) .or. &
                    & ( (rVec%y >= grid(gP)%yAxis(grid(gP)%ny) &
                    & .or. yP>grid(gP)%ny) .and. vHat%y >=0.) .or. &
                    & ( (rVec%z >= grid(gP)%zAxis(grid(gP)%nz) &
                    &  .or. zP>grid(gP)%nz) .and. vHat%z >=0.) ) then

                  ! go back to mother grid
                  xP = enPacket%xP(1)
                  yP = enPacket%yP(1)
                  zP = enPacket%zP(1)
                  gP = 1
                  igpp = 1

               end if

            end if




         end if

         if (.not. lgPlaneIonization .and. gP==1 .and. (xP > grid(gP)%nx  &
              & .or. yP > grid(gP)%ny .or. zP > grid(gP)%nz) ) then

            ! the energy packet escapes

            ! the packet escapes without further interaction

            ! the packet escapes without further interaction
            if (lgSymmetricXYZ) then
               idirT = int(acos(abs(enPacket%direction%z))/dTheta)+1
            else
               idirT = int(acos(enPacket%direction%z)/dTheta)+1
            end if

!            idirT = int(acos(enPacket%direction%z)/dTheta)+1
            if (idirT>totangleBinsTheta) then
               idirT=totangleBinsTheta
            end if
            if (idirT<1 .or. idirT>totAngleBinsTheta) then
               print*, '! pathSegment: error in theta direction cosine assignment',&
                    &  idirT, enPacket, dTheta, totAngleBinsTheta
               stop
            end if

!            if (enPacket%direction%x<1.e-35) then
!               idirP = 0
!            else
!               idirP = int(atan(enPacket%direction%y/enPacket%direction%x)/dPhi)
!            end if
!            if (idirP<0) idirP=totAngleBinsPhi+idirP

            if (abs(enPacket%direction%x)<1.e-35) then
               idirP = 0
            else
               if (lgSymmetricXYZ) then
                  idirP = int(atan(abs(enPacket%direction%y)/abs(enPacket%direction%x))/dPhi)
               else
                  idirP = int(atan(enPacket%direction%y/enPacket%direction%x)/dPhi)
               end if
            end if
            if (idirP<0) idirP=totAngleBinsPhi+idirP

            idirP=idirP+1

            if (idirP>totangleBinsPhi) then
               idirP=totangleBinsPhi
            end if

            if (idirP<1 .or. idirP>totAngleBinsPhi) then
               print*, '! pathSegment: error in phi direction cosine assignment -7',&
                    &  idirP, enPacket, dPhi, totAngleBinsPhi
               stop
            end if


!print*, 'f', nanglebins
!print*, enPacket%lgStellar, enPacket%direction
!print*, idirT, viewPointPTheta(idirT), viewPointTheta(viewPointPTheta(idirT))
!print*, idirP, viewPointPPhi(idirP), viewPointPhi(viewPointPPhi(idirP)), viewPointPhi(viewPointPtheta(idirT))

            if (nAngleBins>0) then
               if (viewPointPtheta(idirT) > 0 .and. viewPointPhi(viewPointPtheta(idirT)) < 0) then

                  grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), enPacket%nuP,viewPointPtheta(idirT)) = &
                       &grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                       & enPacket%nuP,viewPointPtheta(idirT)) + deltaE(iStar)
                  grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                       & enPacket%nuP,0) = &
                       & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                       & enPacket%nuP,0) +  deltaE(iStar)

               elseif (viewPointPtheta(idirT) == viewPointPphi(idirP).or. &
                    & (viewPointTheta(viewPointPphi(idirP))==viewPointTheta(viewPointPtheta(idirT))) .or. &
                    & (viewPointPhi(viewPointPtheta(idirT))==viewPointPhi(viewPointPphi(idirP))) ) then
                  grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), enPacket%nuP,&
                       & viewPointPtheta(idirT)) = &
                       &grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                    & enPacket%nuP,viewPointPtheta(idirT)) +  deltaE(iStar)
                  if (viewPointPtheta(idirT)/=0) grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                       enPacket%nuP,0) = &
                       & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                       & enPacket%nuP,0) +  deltaE(iStar)
               else
                  grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                       enPacket%nuP,0) = &
                       & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                       & enPacket%nuP,0) +  deltaE(iStar)
               end if
            else

               grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                    enPacket%nuP,0) = &
                    & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                    & enPacket%nuP,0) +  deltaE(iStar)

            end if

            !b2.005
            return


         end if

      end do ! safelimit loop

      if (i>= safeLimit) then
         if (.not.lgPlaneIonization) then
            print*, '! pathSegment: [warning] packet trajectory has exceeded&
                 &  maximum number of events', safeLimit, gP, xP,yP,zP, grid(gP)%active(xP,yP,zP), &
              & rvec, vhat, enPacket, iphot
         end if
         return

      end if

      if (gP==1) then
         igpp = 1
      else if (gP>1) then
         igpp = 2
      else
         print*, "! pathSegment: insane grid index "
         stop
      end if

      enPacket%xP(igpp) = xP
      enPacket%yP(igpp) = yP
      enPacket%zP(igpp) = zP

      ! the energy packet has beenid absorbed - reemit a new packet from this position

      chTypeIn = packetType
      positionIn = rVec
      inX =  enPacket%xP(1:2)
      inY =  enPacket%yP(1:2)
      inZ =  enPacket%zP(1:2)
      gPIn = gP
      reRun = 1
      return

    end subroutine pathSegment


 subroutine hg(inpacket,ierr)

   implicit none

   type(photon_packet), intent(inout) :: inpacket

   real :: sint,cost,sinp,cosp,phi
   real :: random, random0, vin(3), vout(3), s, denom
   real :: hgg, znorm

   integer :: ierr

   ierr = 0

! BEKS 2010
   vin(1) = inpacket%direction%x
   vin(2) = inpacket%direction%y
   vin(3) = inpacket%direction%z

   hgg = gSca(inpacket%nuP)

   ! henyey-greenstein http://robertoreif.com/Documents/Chapter3.pdf
   call random_number(random0) ! this is the theta dependence
   s=2.*random0-1.
   if (hgg.ge.0.0001) then
      cost=0.5/hgg*(1.+hgg**2-((1.-hgg**2)/(1.+hgg*s))**2)
   else
      cost=s !+1.5*hgg*(1.-s**2)-2*hgg**2*s*(1.-s**2)
   endif
   if (cost .ge. 1.0) then
      cost=1.0
      sint=0.
   elseif (cost .lt. -1.0) then
      cost=-1.0
      sint=0.
   else
      sint=sqrt(1.-cost**2)
   endif

   call random_number(random) ! this is the phi dependence
   phi = twoPi*random
   cosp=cos(phi)
   sinp=sin(phi)
   denom=sqrt(1.-vin(3)**2)

   if (denom.gt.0.001) then
      vout(1)=sint/denom*(vin(1)*vin(3)*cosp-vin(2)*sinp) + vin(1)*cost
      vout(2)=sint/denom*(vin(2)*vin(3)*cosp+vin(1)*sinp) + vin(2)*cost
      vout(3)=-sint*cosp*denom+vin(3)*cost
   else
      vout(1)=sint*cosp
      vout(2)=sint*sinp
      if (vin(3).ge.0.) then
         vout(3)=cost
      else
         vout(3)=-cost
      endif
   endif



   if ( ( (abs(vout(1)) <= 1.) .and. (abs(vout(2)) <= 1.) .and. (abs(vout(3)) <= 1.) )&
        & .and. (vout(1) >= 0. .or. vout(1) < 0.) .and. &
        & (vout(2) >= 0. .or. vout(2) < 0.) .and. &
        & (vout(3) >= 0. .or. vout(3) < 0.)) then

      inpacket%direction%x =  vout(1)
      inpacket%direction%y =  vout(2)
      inpacket%direction%z =  vout(3)


      ierr = 0
   elseif ((abs(vout(1))>=1.).or.(abs(vout(2))>=1.).or.(abs(vout(3))>=1.)&
        & .and. (vout(1) >= 0. .or. vout(1) < 0.) .and. &
        & (vout(2) >= 0. .or. vout(2) < 0.) .and. &
        & (vout(3) >= 0. .or. vout(3) < 0.)) then
      znorm=sqrt(vout(1)**2 + vout(2)**2 + vout(3)**2)
      vout=vout/znorm
   else
      ierr = 1
      print*,'FAIL',random0,random,s
      print*,' ',vin
      print*,' ',cost,sint
      print*,' ',cosp,sinp,denom
      print*,' ',vout

      vout(1) = vin(1)
      vout(2) = vin(2)
      vout(3) = vin(3)

!      print*, vout
!      print*, vin
!      print*, random0, random
!      print*, hgg
!      print*, inpacket%nuP
!      print*, sint, cost, sinp, cosp

   end if

   return




! OLD
!   bmu= ((1.+g2)-((1.-g2)/(1.-hgg+2.*hgg*random))**2)/(2.*hgg)
!ßpathSe
!   cosb2=bmu**2
!   b=cosb2-1.
!
!   if(abs(bmu) > 1.) then
!      if(bmu>1.) then
!         bmu=1.
!         cosb2=1.
!         b=0.
!      else
!         bmu=-1.
!         cosb2=1.
!         b=0.
!      end if
!   end if
!   sinbt=sqrt(1.-cosb2)
!   call random_number(random)
!
!   ri1=twoPi*random
!
!   if(ri1>pi) then
!      ri3=twoPi-ri1
!      cosi3=cos(ri3)
!      sini3=sin(ri3)
!      sin2i3=2.*sini3*cosi3
!      cos2i3=2.*cosi3*cosi3-1.
!
!
!      if(abs(bmu)==1.) return
!
!      cost=costp*bmu+sintp*sinbt*cosi3
!
!      if(abs(cost)<1.) then
!         sint=abs(sqrt(1.-cost*cost))
!         sini2=sini3*sintp/sint
!         bott=sint*sinbt
!         cosi2=costp/bott-cost*bmu/bott
!      else
!         sint=0.
!         sini2=0.
!         if(cost.ge.1.)  cosi2=-1.
!         if(cost.le.-1.) cosi2=1.
!      end if
!
!      cosdph=-cosi2*cosi3+sini2*sini3*bmu
!      if(abs(cosdph)>1.) then
!         if(cosdph>1.) then
!            cosdph=1.
!         else
!            cosdph=-1.
!         end if
!      end if
!      phi=phip+acos(cosdph)
!      if(phi>twoPi) phi=phi-twoPi
!      if(phi<0.)    phi=phi+twoPi
!
!      sin2i2=2.*sini2*cosi2
!      cos2i2=2.*cosi2*cosi2-1.
!      sin2=sin2i2*sin2i3
!      cos2=cos2i2*cos2i3
!      sin2cos1=sin2i2*cos2i3
!      cos2sin1=cos2i2*sin2i3
!
!   else
!
!      cosi1=cos(ri1)
!      sini1=sin(ri1)
!      sin2i1=2.*sini1*cosi1
!      cos2i1=2.*cosi1*cosi1-1.
!
!      if(abs(bmu)==1.) return
!
!      cost=costp*bmu+sintp*sinbt*cosi1
!
!      if(abs(cost)<1.) then
!         sint=abs(sqrt(1.-cost*cost))
!         sini2=sini1*sintp/sint
!         bott=sint*sinbt
!         cosi2=costp/bott-cost*bmu/bott
!      else
!         sint=0.
!         sini2=0.
!         if(cost.ge.1.)  cosi2=-1.
!         if(cost.le.-1.) cosi2=1.
!      end if
!
!      cosdph=-cosi1*cosi2+sini1*sini2*bmu
!      if(abs(cosdph)>1.) then
!         if(cosdph>1.) then
!            cosdph=1.
!         else
!            cosdph=-1.
!         end if
!      end if
!      phi=phip-acos(cosdph)
!      if(phi>twoPi) phi=phi-twoPi
!      if(phi<0.)    phi=phi+twoPi
!
!      sin2i2=2.*sini2*cosi2
!      cos2i2=2.*cosi2*cosi2-1.
!      sin2=sin2i2*sin2i1
!      cos2=cos2i2*cos2i1
!      sin2cos1=sin2i2*cos2i1
!      cos2sin1=cos2i2*sin2i1
!
!   end if
!
!
!   cosp=cos(phi)
!   sinp=sin(phi)
!
!   nxp=sint*cosp
!   nyp=sint*sinp
!   nzp=cost
!
!
!   inpacket%direction%x =  nxp
!   inpacket%direction%y =  nyp
!   inpacket%direction%z =  nzp

 end subroutine hg

end subroutine energyPacketDriver


 end module photon_mod

! Copyright (C) 2005 Barbara Ercolano
!
! Version 2.02
module composition_mod
    use constants_mod
    use common_mod

    contains

    subroutine setComposition(grid)
        implicit none

        type(grid_type) :: grid      ! grid

        ! local variables
        integer :: icount            ! counter
        integer :: nelem             ! counter
        integer :: ios               ! I/O error status
        integer :: i,j               ! counters
        integer :: off               ! off everywhere?

        ! open file containing composition data


        do i = 1, nAbComponents

           close(80)
           open(unit=80, action="read", file = abundanceFile(i), status="old", position="rewind", iostat = ios)
           if (ios /= 0) then
              print*, "! setComposition: can't open file: ", abundanceFile(i)
              stop
           end if
           do j = 1, nElements
              read(80, *) grid%elemAbun(i, j)
           end do
           close(80)



        end do

        ! set the switches

        ! first initialise to true
        lgElementOn = .true.

        ! initialise nElementsUsed
        nElementsUsed = nElements
        icount = 1

        ! check what elements can be switched off
        do nelem = 1, nElements
           off = 1
           do i = 1, nAbComponents
              if (grid%elemAbun(i,nelem) > 1.e-12) then
                 off = 0
              end if
           end do


           if (off==0) then
              elementXref(nelem) = icount
              icount = icount+1
           else
              lgElementOn(nelem) = .false.
              nElementsUsed = nElementsUsed - 1
              elementXref(nelem) = 0
           end if

        end do

    end subroutine setComposition

end module composition_mod

! Copyright (C) 2005 Barbara Ercolano
!
! Version 2.02
module common_mod
    use constants_mod
    use vector_mod
    implicit none


    ! fluorescence variables
    integer          :: nFluo ! # of fluorescent lines to be transfered
    integer          :: nVP   ! # of fluorescent viewing angles

    character(len=4), allocatable :: fluorescenceLabel(:) ! ID labels of fluorescent transitions
    real, allocatable    :: fluorescenceVP(:,:) ! viewing angles for fluorescence cube &
                                            ! (for the first dimension 1=theta;2=phi)

    ! MPI variables
    integer, allocatable :: lgConvergedTemp(:)  ! temporary converged? flag
    integer, allocatable :: lgBlackTemp(:)      ! temporary converged? flag

    logical         :: lg2D=.false.             ! 2D?
    logical         :: lgIsotropic

    logical             :: lgMultiStars=.false.
    logical         :: lgEquivalentTau          ! calculate equivalent tau?
    logical         :: lgWarm=.false.           ! warm started?
    logical         :: lgFluorescence=.false.   ! fluorescence run?
    logical         :: lgNeInput=.false.        ! Ne distribution entered
    logical         :: lgResLinesFirst = .true. ! first time the res lines transfer proc is called?
    logical         :: lgPhotoelectric = .true. ! photoelectric effect on
    logical         :: lgQheat = .false.        ! temperature spiking on?
    logical         :: lgWritePss=.false.       ! write Pss for qHeat file?
    logical         :: lgTraceHeating = .false. ! trace thermal balance?
    logical         :: lgGrainSpiking = .true.  ! temperature spiking for small grains
    logical         :: lgEcho = .false.         ! light time travel included?
    logical         :: lgforceTDust = .false.   !
    logical         :: lgNosource = .false.     ! exclude sources from SED?
    logical         :: lginputDustMass = .false.! user sets input dust mass?
    logical         :: lginputGasMass = .false. ! user sets input gas mass?

    real, allocatable :: gSca(:)                 ! gSca(freq)

    real, allocatable   :: TdustTemp(:,:,:)     ! temporary dust temperature array (species,size,cell)
    real, allocatable   :: ionDenTemp(:,:,:)    ! temporary ion density array
    real, allocatable   :: NeTemp(:)            ! temporary electron density array
    real, allocatable   :: TeTemp(:)            ! temporary electron Temperature array
    real            :: HeIrecLineCoeff(34,3,4)
    real, allocatable   :: KNsigmaArray(:,:)    ! Klein Nishina calc PDFs (nbins,180)
    real, allocatable   :: KNsigmaT(:)          ! Klein Nishina cross-sections integrated over the solid angle
    real, allocatable   :: PcompArray (:,:)
    real, allocatable   :: twoDscaleJ(:)

    integer         :: radio4p9GHzP   !

    integer         :: ierr           ! MPI error status
    integer         :: numtasks       ! total # of processes
    integer         :: taskid         ! process identification #
    real            :: starttime      ! start time [sec]

    real            :: endtime        ! end time [sec]
    real            :: absInt         ! total number of absorption events
    real            :: scaInt         ! total number of scattering events
    real            :: echot1=0., echot2=0.   ! light time travel parameters
    real            :: echoTemp=0.       ! temperature outside the illuminated parabula
    real            :: dTheta                  !
    real            :: dPhi                    !
    real            :: nu0                     !
    real            :: nu0Add                  !
    real            :: totalDustMass
    real            :: totalGasMass
    real            :: inputDustMass           ! for when user sets desired dust mass in input
    real            :: inputGasMass           ! for when user sets desired gas mass in input
    real            :: forceTDust = 0.         ! for TDust feature
    real            :: convPercent=0.          ! total convergence percentage
    real            :: pwlIndex = 0.           ! power law input spectrum index
    real            :: pwlMin=0.               ! power law lower cutoff [Ryd]
    real            :: pwlMax=0.               ! power law higher cutoff [Ryd]
    real            :: totPercent=0.           !
    real            :: minaQHeat = 0.          ! min radius for Q Heat in [um]
    real            :: NeUsed, TeUsed, HdenUsed ! local properties of the gas
    real            :: Tmax                    ! max temp for qheat
    real            :: auger(30,30,10,10)      ! auger yields



    integer, allocatable  :: HINuEdgeP(:)     ! pointers to the HI, HeI and HeII
    integer, allocatable  :: HeINuEdgeP(:)    ! series edges in nuArray
    integer, allocatable  :: HeIINuEdgeP(:)   !


    integer :: nTbins                     ! # of temp bins in qheat
    integer :: nlimGammaHI,nlimGammaHeI, nlimGammaHeII, ntkGamma

    integer :: nIterateMC = 1                  ! current MC interation #

    integer :: nflux = 1                       ! number of energy bins to the high energy end
                                               ! of the incident spectrum
    integer :: nLines = 0                      ! total number of lines

    integer :: iOrigin, jOrigin, kOrigin       ! pointers to the origin of the axes

    ! stack pointers

    integer :: KshellLimitP                    ! KshellLimitP
    integer :: FeKaColdP                       ! pointer to 6.4keV in nuArray
    integer :: secIonP
    integer :: cRecoilP                        ! pointer to compton recoil (194.Ryd) in nuArray
    integer :: xrayP                           ! pointer to carbon k-shell ionization in nuArray
    integer :: cRecoilHP, cRecoilHeP           ! recoil pointers

    integer :: BjumpP                          ! pointer to balmer jump

    integer :: nAuger(30,30,10)                ! max number of auger electrons freed

    integer :: noGpLoc = -1
    integer, dimension(3) :: noCellLoc=-1

    integer, dimension(nElements, nElements, 7, 3) &
         &:: elementP                          ! first dim is atomic number of element,
                                               ! second dimension is ion stage, 1 for atom
                                               ! third is shell, 1 for k shell, up to 7
                                               ! last is 1 for pointer to energy of threshold
                                               ! 2 is highest energy for shell
                                               ! 3 is opacity offset


    integer, allocatable :: dustScaXsecP(:,:)       ! pointer to dust scatterring x-sec in xSecArray (species,size)
    integer, allocatable :: dustAbsXsecP(:,:)       ! pointer to dust absorption x-sec in xSecArray  (species,size)



    integer, dimension(nHlevel+1) &
         & :: HlevNuP = 0      ! pointer to the nth H level in nuArray

    integer, dimension(nHeIlevel+1) &
         & :: HeIlevNuP = 0    ! pointer to the nth HeI level in nuArray


    integer, dimension(nHeIIlevel+1) &
         & :: HeIIlevNuP = 0   ! pointer to the nth HeII level in nuArray


    logical, allocatable :: &
         & lgDataAvailable(:,:)! is the atomic data available for this species?

    character(len=50), dimension(3:nElements, 1:10) :: &
         & dataFile       ! name of the file containing the atomic data for this species

    integer, dimension(nElements, nElements)&
         & :: nShells          ! number of shells for each element and ionization stage
                                               ! first dimension is atomic weight, second is ionization stage

    character(len=2)        :: elemLabel(30)


    ! energies temperatures etc..
    real :: Bjump = 0.                        ! Balmer jump


    ! slit stuff
    real :: dxSlit = 0.
    real :: dySlit = 0.

    ! photoionization data
    real, dimension(5,30,30) :: CF=0.
    real, dimension(30,30)   :: cionTherm = 0.
    real, dimension(6, 30, 30, 7) :: ph1
    real, dimension(7, 30, 30) :: ph2
    real, dimension(nElements) :: aWeight
    real, dimension(450) :: ionEdge

    real, allocatable :: logGammaHI(:,:),logGammaHeI(:,:),logGammaHeII(:,:), tkGamma(:), nuGammaHI(:),&
         & nuGammaHeI(:),nuGammaHeII(:)

    ! dust arrays
    real, allocatable :: TdustSublime(:)        ! sublimation T (nspecies)
    real, allocatable :: grainVn(:)             ! potential of neutral grain
    real, allocatable :: MsurfAtom(:)           ! mass of surf atom of a grain [amu]
    real, allocatable :: rho(:)                 ! intrinsic density (nspecies)
    real, allocatable :: dustHeatingBudget(:,:) ! heating budget of grains (nAbComponents, nResLines+1)
    real, allocatable :: SEDnoExt(:)            ! SED no extinction
    real, allocatable :: equivalentTau(:)       ! SED no extinction

    double precision, save, allocatable::&
          & forbiddenLines(:,:,:,:)                                 ! emissivity from heavies  rec lines
    double precision, save, allocatable::&
          & forbiddenLinesLarge(:,:)

    ! linear increments
    real, allocatable :: dl(:)

    ! calculate recombination lines?
    logical :: lgRecombination=.false.

    ! composition switches
    logical, dimension(nElements) :: lgElementOn ! is this element present?

    ! dust arrays
    real, allocatable :: dustEmIntegral(:,:,:)   ! dust emission integral (species,size,temperature)

    ! allocatable arrays
    real, allocatable :: absOpacSpecies(:,:)     ! absOpacSpecies (nspecies, freq)

    real, allocatable :: continuum(:)            ! continuum array (freq)

    real, allocatable :: gauntFF(:)              ! gaunt factor

    real, allocatable :: gauntFFHeII(:)          ! gaunt ff for HeII

    real, allocatable :: H2phot(:)               ! H 2-photon emission

    real, allocatable :: HeI2phot(:)             ! HeI 2-photon emission

    real, allocatable :: HeII2phot(:)            ! HeII 2-photon emission

    real, allocatable :: ionDenUsed(:,:)         ! local ionDen array

    real, allocatable :: nuArray(:)              ! energy array [Ryd]

    real, allocatable :: xSecArray(:)            ! x Section array calculated in xSec_mod

    real, allocatable :: xSecRecoil(:)           ! compton recoil xSec

    real, allocatable :: comXSecH(:)             ! compton Xsec Heat array

    real, allocatable :: comXSecC(:)             ! compton Xsec Cool array

    real, allocatable :: widFlx(:)               ! widFlx array

    real, allocatable :: photoRateFluo(:,:)      ! photoionisation rate (nfluo, nstages) [sec^-1]


    integer, allocatable :: planeIonDistribution(:,:) ! initial distribution of ionising photons



    ! derived types

    type grid_type             ! derived grid type

        character(len=50) :: composition            ! chemical composition

        integer :: nx                               ! size of cartesian grid in x
        integer :: ny                               ! size of cartesian grid in y
        integer :: nz                               ! size of cartesian grid in z
        integer :: nCells                           ! number of active cells
        integer :: motherP                          ! pointer to the motherGrid

        integer, allocatable :: dustAbunIndex(:)        ! dust chemistry file index (cell)
        integer, allocatable :: resLinePackets(:)       ! extraPackets to be generated cell (cell)
        integer, allocatable :: abFileIndex(:,:,:)      ! abundance file index axxay
        integer, allocatable :: lgConverged(:)          ! has the model converged at this grid cell?
        integer, allocatable :: lgBlack(:)              ! is this to remain a black cell?

        integer, allocatable :: active(:,:,:)           ! point to active cell in 1d array;
                                                    ! returns 0 for inactive cells

        real    :: geoCorrX,geoCorrY,geoCorrZ       ! geometric correction
        real    :: noHit                            ! cells not sampled by rad field
        real    :: noIonBal                         ! Ion Balance not raeched
        real    :: noTeBal                          ! Te Balance not reached


        real, allocatable :: absOpac(:,:)               ! dust absorption opacity
        real, allocatable :: scaOpac(:,:)               ! dust scattering opacity
        real, allocatable :: dustPDF(:,:)               ! dust emission PDF
        real, allocatable :: fEscapeResPhotons(:,:)     ! frac of res line photons escaping (cell,resline)
        real, allocatable :: fluorescenceCube(:,:,:)    ! escaped fluorescence packets (ncell,nFluo,nVP)
        real, allocatable :: Hden(:)                    ! density of H [1/cm^3]
        real, allocatable :: Ne(:)                      ! electron density [1/cm^3]
        real, allocatable :: Te(:)                      ! electron temperature [K]
        real, allocatable :: Tdust(:,:,:)               ! dust temperature (species,size,cell) [K]
        real, allocatable :: ionDen(:,:,:)              ! fractional ion density (x,y,z,elem,stage)
        real, allocatable :: Jste(:,:)                  ! MC estimator of stellar J (cell,nu)
        real, allocatable :: Jdif(:,:)                  ! MC estimator of diffuse J (cell,nu)
        real, allocatable :: JPEots(:,:)                ! OTS line contribution to photoelectric emission
        real, allocatable :: escapedPackets(:,:,:)      ! escaped packets (cell,nu, angle)
        real, allocatable :: linePackets(:,:)           ! line packets (x,y,z,n)
        real, allocatable :: LFluorescence(:,:)         ! local fluorescence luminosity of cell [e36 erg/sec]
        real, allocatable :: LdiffuseLoc(:)             ! loc luminosity of diffuse source [e36 erg/sec]
        real, allocatable :: Ndust(:)                   ! number density for dust

        real, allocatable :: xAxis(:)                   ! x-axis
        real, allocatable :: yAxis(:)                   ! y-axiss
        real, allocatable :: zAxis(:)                   ! z-axis

        real, allocatable :: NeInput(:)                 ! only used if lgNeInput=.t.


        real, allocatable :: opacity(:,:)               ! total  opacity (cell,nu) [1/cm]
        real, allocatable :: recPDF(:,:)                ! rec prob distribution function
        real, allocatable :: linePDF(:,:)               ! line prob distribution function
        real, allocatable :: totalLines(:)              ! fraction of non-ionizing line phots

        real, allocatable :: elemAbun(:,:)              ! elemental abundance (specified
                                                    ! by number relative to total
                                                    ! hydrogen density)
        real, allocatable :: echoVol(:,:,:)  ! BEKS 2010. Contains volume of one
        ! grid cell enclosed by echo.  Only used if lgEcho=.true.
    end type grid_type

    ! photon packet type
    type photon_packet

        integer       :: nuP       ! pointer
        integer, dimension(2) &
             & :: xP,yP,zP         ! grids position indeces 1= mother 2=sub
        integer, dimension(2) :: origin ! 1=ig, 2=icell
        integer       :: iG        ! grid index

        real          :: nu
        logical       :: lgStellar
        logical       :: lgLine

        type(vector)  :: position
        type(vector)  :: direction


    end type photon_packet

    ! plot type
    type plot_type
       real, allocatable         :: intensity(:,:,:)
       real, allocatable         :: xAxis(:), yAxis(:)

       logical               :: lgFilter
       logical               :: lgMap
       logical, allocatable      :: lgLine(:)

       integer, allocatable      :: lineNumber(:)
       integer               :: nPlots
       integer, allocatable      :: nuP(:,:)

    end type plot_type

    type resLine_type
       character(len=2)      :: species
       character(len=30)     :: transition, multiplet! label

       integer               :: nuP  ! pointer to freq of line in nuArray
       integer               :: elem ! elemnt
       integer               :: ion  ! ionization stage
       integer               :: glow, ghigh ! lower and upper statistical weights
       integer               :: nmul ! # of components in the multiplet
       integer, allocatable       :: moclow(:), mochigh(:) ! mocassin's lower and higher levels code

       real                  :: m_ion ! mass of the ion
       real                  :: wav  ! wavelength [A]
       real                  :: freq ! frequency [Ryd]
       real                  :: Elow,Ehigh ! lower and higher level energies
       real                  :: Aik,fik ! trans prob and oscillator strength
    end type resLine_type

    !  model parameters

    type(vector), allocatable :: starPosition(:) ! ionising source(s) position
    type(vector)       :: nullUnitVector

    logical            :: lgCompton        ! evaluate Compton energy exchange?
    logical            :: lgAutoPackets    ! automatic increase of packets on the fly?
    logical            :: lgTalk           ! talk on?
    logical            :: lgDfile          ! use an external density file?
    logical            :: lgDebug          ! debigging mode? (memory consuming)
    logical            :: lgDlaw           ! use the density law routine?
    logical            :: lgDust           ! is dust included in this model?
    logical            :: lgDustScattering ! is dust scattering included in this model?
    logical            :: lgDustConstant   ! is the md/Mg constant throughtout the grid?
    logical            :: lgGas            ! is there any gas in teh grid?
    logical            :: lgHdenConstant   ! use the constant density parameters?
    logical            :: lgMdMg           ! dust to gas mass ratio used>?
    logical            :: lgMdMh           ! dust to hydrogen mass ratio used>?
    logical            :: lgOutput         ! output line fluxes,temp & ion struct files?
    logical            :: lg1D             ! 1-D switch
    logical            :: lgMultiDustChemistry ! do we have a inhomogeneous dust species distribution?
    logical            :: lgMultiChemistry ! do we have a chemically inhomogeneous gas?
    logical            :: lgNeutral        ! starting from neutral gas?
    logical            :: lgPlaneIonization! plane parallel ionization?
    logical            :: lgSymmetricXYZ   ! symmetric in x, y, and z?

    character(len=50)  :: gridList ! grid list file name
    character(len=50), allocatable  :: abundanceFIle(:) ! abundance file names
    character(len=50), allocatable  :: dustSpeciesFIle(:) ! abundance file names
    character(len=50)           :: contDiffuse      ! shape of the diffuse ionising spectrum
    character(len=50), allocatable  :: contShape(:)     ! continuumShape
    character(len=50), allocatable  :: contShapeIn(:)   ! continuumShape
    character(len=50), allocatable  :: spID(:)          ! input spectrum generator ID
    character(len=50)  :: densityFile      ! density file
    character(len=50)  :: dustFile(2)      ! dust files
    character(len=50)  :: MdMgFile         ! name of MdMg file
    character(len=50)  :: NdustFile        ! name of Ndust file
    character(len=50)  :: Qfile            ! name of Qfile
    character(len=30), allocatable       :: grainLabel(:)    ! name of this species

    integer, allocatable    :: viewPointPtheta(:), viewPointPphi(:)       ! viewing angles

    integer            :: nAngleBins=0     ! number of viewing angles for SED
    integer            :: TotAngleBinsTheta=10 ! total # of theta angle bins for SED
    integer            :: TotAngleBinsPhi=20 ! total # of phi angle bins for SED
    integer            :: nGrids           ! total number of grids to be used in the simulation
    integer            :: maxIterateMC     ! limit on number of MC iterations
    integer            :: maxPhotons       ! limit to packets to be use
    integer            :: nAbComponents=1  ! number of abundance components
    integer            :: nDustComponents=1 ! number of dust components
    integer, allocatable   :: dustComPoint(:)  !
    integer            :: nBins            ! number of energy bins
    integer            :: nElementsUsed    ! actual number of elements used
    integer, allocatable   :: nPhotons(:)      ! # of packets to be used in the sim
    integer            :: nPhotonsTot      ! # of packets to be used in the sim
    integer            :: nPhotonsDiffuse  ! # of packets to be used by the diffuse ionisation source
    integer            :: nPhotonsDiffuseLoc! # of packets to be used by the diffuse ionisation source
    integer            :: nPacketsFluo     ! # of packets to be used for each fluorescent transition
    integer            :: nPacketsFluoLoc  ! # of packets to be used for each fluorescent trans in one cell
    integer, dimension(maxGrids) &
                      &:: nxIn,nyIn, nzIn  ! x, y and z dimensions of the grids
    integer            :: nStars           ! number of ionising sources
    integer            :: elementXref(nElements) ! x reference index array for elements actually used
    integer            :: emittingGrid     ! grid emiting illuminating radiation [0 for all]
    integer, allocatable   :: starIndeces(:,:) ! (nstars, 3) 1=x; 2=y; 3=z, 4=gp
    integer            :: nstages          ! # of ionisation stages to be included

    real               :: fluoCubeMineV, fluoCubeMaxeV ! limits of the fluorescence cube band
    real               :: fillingFactor    ! filling factor epsilon
    real               :: contCube(2)      ! continuum cube
    real               :: convIncPercent   ! percentage by  which conv must increase
    real               :: convWriteGrid    ! min conv level before starting to write the grid
    real               :: nPhotIncrease    ! nPhoton increase factor
    real               :: densityLaw(3)    ! density law parameters (R1,n,f,N0)
    real, allocatable       :: grainAbun(:,:)     ! abundance of this species
    real, allocatable       :: grainRadius(:)   ! grain radius [um]
    real, allocatable       :: grainWeight(:)   ! grain weight normalised to 1
    real, allocatable       :: viewPointTheta(:),viewPointPhi(:)     ! viewing angles
    real               :: Hdensity         ! constant H density values (cm-^3)
    real               :: H0Start          ! initial guess at X(H0) for regions I and II
    real               :: Lphot            ! L of ionizing source [e36 phot/sec]
    real               :: Ldiffuse         ! total luminosity of diffuse source [e36 erg/sec]
    real, allocatable       :: LStar(:)         ! L of ionizing source [e36 erg/sec]
    real               :: meanField        ! mean ionizing field to be used with plane parallel
                                           ! geometry [erg/sec/cm^2]
    real               :: meanFieldin
    real               :: minConvergence   ! stop when this level of convergence has been reached
    real               :: minConvQHeat     ! min convergence level for Qheat routines to run
    real               :: NeStart          ! initial guess at Ne
    real               :: MdMgValue        ! dust-to-gas ratio by mass
    real               :: NdustValue       ! dust number density [cm^-3]
    real               :: nuMax            ! max nu limit [Ryd]
    real               :: nuMin            ! min nu limit [Ryd]
    real               :: nuStepSize       !
    real               :: resLinesTransfer ! after what conv percent should the resonant line transfer start?
    real               :: Rnx,Rny,Rnz      ! edges [cm]
    real               :: R_in             ! inner radius [cm]
    real               :: R_out            ! outer radius [cm]
    real               :: SEDfreq(2)       !
    real               :: TeStart          ! initial guess at Te for regions I and II
    real, allocatable      :: deltaE(:)        ! energy carried by a single photon
    real               :: Tdiffuse         ! energy of diffuse ionising source [K]
    real, allocatable      :: Tstellar(:)      ! T of ionizing source [K]
    real, allocatable      :: tStep(:)         ! time step for sb99 inputs [yrs]
    real               :: XHILimit         ! convergence limit on X(HI)

    integer             :: lymanP                  ! frequency pointer to Lyman limit
    ! dust parameters
    integer            :: nSizes           ! number of grain sizes
    integer, allocatable    :: nSpeciesPart(:)  ! number of grain specie
    integer            :: nSpecies         ! number of grain specie
    integer            :: nSpeciesMax      ! max number of grain species
    integer            :: nResLines=0      ! number of resonant lines to be transfered

! CEL atomic data

    type atomic_data
        integer :: NTEMPS
        integer :: NLEVS
        integer :: irats
        character(len=50) :: ion
        real,allocatable :: logtemp(:)
        real,allocatable :: roott(:)
        character(len=20),allocatable :: label(:)
        integer,allocatable :: g(:) !statistical weight
        double precision,allocatable :: e(:) ! energy in wavenumbers
        double precision,allocatable :: a(:,:) !einstein A coefficient
        double precision,allocatable :: cs(:,:) !collision strength
        double precision,allocatable :: qeff(:,:)
        double precision,allocatable :: qom(:,:,:)
        real,allocatable :: qq(:),qq2(:)
        real :: a_r(4),a_d(5),z,br
        real,allocatable :: alphaTotal(:)
    end type atomic_data

    type(atomic_data), dimension(3:nElements, 1:10) :: atomic_data_array

! HeI2phot

    real, dimension(41) :: Ay_dat        ! data point in Ay (rates) [1/s]
    real, dimension(41) :: y_dat         ! data point in y (=nu/nu0)

! H I emissivity
! units are [e-25erg/s/N_gas]
    double precision, dimension(3:30, 2:8) :: HIRecLineData ! data
    double precision, dimension(3:30, 2:8) :: HIRecLines           ! emissivity from HI rec lines

! He II

    integer, parameter:: NHeIILyman = 4     ! Number of HeII Lym lines included
    real, dimension(NHeIILyman) :: HeIILymanData     ! HeII Lyman lines em.  [e-25ergs*cm^3/s]
    real, dimension(NHeIILyman) :: HeIILymanNu       ! HeII Lyman lines freq. [Ryd]
    double precision, dimension(3:30, 2:16) :: HeIIRecLineData ! HeII rec line data (Storey & Hummer 1995)
    double precision, dimension(3:30, 2:16) :: HeIIRecLines    ! emissivity from HeII rec lines

! dielectronic recombination

    type direcdata
        integer :: elem   ! atomic number
        integer :: n      ! number of electrons
        real :: a,b,c,d,f ! fitting coefficients
        integer :: g      ! temperature flag
    end type direcdata

    type(direcdata), dimension(25) :: direc_coeffs

    type aldropequidata
        integer :: elem   ! atomic number
        integer :: n      ! number of electrons
        real :: a,b,t0,t1 ! fitting coefficients
    end type aldropequidata

    type(aldropequidata), dimension(167) :: aldropequi_coeffs

end module common_mod

! Copyright (C) 2005 Barbara Ercolano
!
! Version 2.02
module update_mod
    use constants_mod
    use common_mod
    use composition_mod
    use emission_mod
    use grid_mod
    use interpolation_mod
    use xSec_mod

    contains

      subroutine updateCell(grid, xP, yP, zP)
        implicit none

        type(grid_type), intent(inout) :: grid         ! the grid

        real, parameter :: Y0 = 0.5, Y1 = 0.2          ! see Baldwin et al. 1991

        real                           :: deltaXHI        ! delta ionDen of H0
                                                       ! H0 2 is from He0 and 3 is
                                                       ! is for He+)
        real                           :: phXSec      ! ph xSec of ion M at freqency bin j
        real                           :: thResidual   ! thermal balance residual
        real                           :: thResidualHigh! ther bal residual-high lim
        real                           :: thResidualLow! ther bal residual-low lim
        real                           :: Thigh        ! T high limit [K]
        real                           :: Tlow         ! T low limit  [K]
        real                           :: XOldHI       ! old ionDen of H0 at this cell

        ! dust-gas interaction heating and cooling process
        real                           :: grainEmi, grainRec ! grain emissions and recom
        real, allocatable                  :: gasDustColl_d(:,:) ! cooling/heating of the
                                                             ! dust through collisions with grains
        real                           :: gasDustColl_g ! cooling/heating of the
                                                       ! gas through collisions with grains
        real, allocatable                   :: photoelHeat_d(:,:) ! cooling of dust by photoelectric
                                                             ! emission
        real                           :: photoelHeat_g ! heating of gas by dust photoelctric
                                                       !emission
        real, allocatable                   :: grainPot(:,:)  ! [Ryd]

        real, parameter                :: hcRyd_k = &  ! constant: h*cRyd/k (Ryd at inf used) [K]
             & 157893.94
        real, parameter                :: hcRyd = &    ! constant: h*c*Ryd (Ryd at inf used) [erg]
             & 2.1799153e-11
        real, parameter                :: thLimit = 0.01! convergence limit T-iteration

        real, dimension(nElements, nstages) &
             & :: alphaTot     ! total recombination coeffs

        real, dimension(nElements, nStages) &
             & :: nPhotoSte, & ! # of stellar photoionizations
             & nPhotoDif    ! # of diffuse photoionizations



        integer, intent(in)            :: xP, yP, zP   ! cell indexes on the Cartesian axes

        ! local variables
        logical                        :: lgHit        ! has this cell been hit by a photon?

        integer , allocatable               :: grainPotP(:,:)
        integer                        :: cellP        ! points to this cell
        integer                        :: highNuP      ! pointer to highest energy of shell
        integer                        :: IPnuP        ! pointer to this ion's IP in NuArray
        integer                        :: xSecP        ! pointer to an ion's xSec in xSecArray
        integer                        :: elem         ! element counter
        integer                        :: g0, g1       ! stat weights
        integer                        :: ion          ! ionization stage counter
        integer                        :: i,j          ! counter
        integer                        :: nElec        ! # of electrons in ion
        integer                        :: nIterateGC   ! # of GC iterations
        integer                        :: nIterateT    ! # of T iterations
        integer                        :: nIterateX    ! # of X iterations
        integer                        :: outShell     ! outer shell number (1 for k shell)
        integer                        :: nspU
        integer, parameter             ::  nTbins=300  ! number of enthalpy bins for T spike
        integer, parameter             :: maxIterateGC&! limit to number of grain charge it
             & = 100
        integer, parameter             :: maxIterateX& ! limit to number of X-iterat ions
             & = 25
        integer, parameter             :: maxIterateT& ! limit to number of T-iterations
             & = 25


        ! check whether this cell is outside the nebula
        if (grid%active(xP, yP, zP)<=0) return

        cellP = grid%active(xP, yP, zP)

        if (lgMultiDustChemistry) then
           nspU = grid%dustAbunIndex(cellP)
        else
           nspU = 1
        end if

        ! initialise lgBlack
        grid%lgBlack(cellP) = 0

        ! initialise lgHit
        lgHit = .false.

        ! find out if this cell has been hit by at least one photon
        if (.not.lgDebug) then
           do i = 1, nbins
              if ( grid%Jste(cellP,i) > 0.) then
                 lgHit = .true.
                 exit
              end if
           end do
        else
           do i = 1, nbins
              if ( (grid%Jste(cellP,i) > 0.) .or. &
                   & (grid%Jdif(cellP,i) > 0.)) then
                 lgHit = .true.
                 exit
              end if
           end do
        end if

        ! in the case of a light echo only update cells inside the echo
        if (lgEcho) then
           if (grid%echoVol(xP,yP,zP).eq.0.0) then
              grid%Tdust(:,:,cellP) = echoTemp
              TdustTemp(:,:,cellP)  = grid%Tdust(:,:,cellP)
              return
           end if

        end if

        ! do not update this cell if there were no hits
        if (.not.lgHit) then

            if (lgTalk) print*, "! updateCell [talk]: no photon hits, &
                 &returning...", xP,yP,zP

            if (lgDust) then
               TdustTemp(:,:,cellP)       = grid%Tdust(:,:,cellP)
            end if

            if (lgGas) then
               ! the grid values stay the same
               TeTemp(cellP)         = grid%Te(cellP)
               NeTemp(cellP)         = grid%Ne(cellP)
               ionDenTemp(cellP,:,:) = grid%ionDen(cellP,:,:)
            end if

            grid%noHit = grid%noHit+1.

            return
        end if

        if (lgGas) then

           ! initialize local Te and Ne

           TeUsed     = grid%Te(cellP)
           NeUsed     = grid%Ne(cellP)
           ionDenUsed = grid%ionDen(cellP, :, :)


           ! save present value of H0 abundance in XOldHI
           XOldHI = grid%ionDen(cellP,elementXref(1),1)

           nPhotoSte = 1.e-20
           if (lgDebug) nPhotoDif = 1.e-20


           ! calculate the number of stellar and diffuse photoionizations for each species
           ! NOTE: no need to time by the frequency bin width (widflx(j)) because JSte and JDif
           !       were calculated for each individual bin
           do elem = 1, nElements  ! begin element loop
            do ion = 1, min(elem, nStages-1) ! begin ion loop
               if(.not.lgElementOn(elem)) exit

               if (elem > 2) then

                  ! find the number of electrons in this ion
                  nElec = elem - ion + 1

                  ! find the outer shell number and statistical weights
                  call getOuterShell(elem, nELec, outShell, g0, g1)

                  ! get pointer to this ion's IP in NuArray
                  IPnuP = elementP(elem, ion, outShell, 1)

                  ! get pointer to this cell's highest energy
                  highNuP = elementP(elem, ion, outShell, 2) - 1

               else if (elem == 1) then ! HI

                  IPNuP   = HlevNuP(1)
                  highNuP = nbins

               else if ( (elem == 2) .and. (ion == 1) ) then ! HeI

                  IPNuP   = HeIlevNuP(1)
                  highNuP = nbins

               else if ( (elem == 2) .and. (ion == 2) ) then ! HeII

                  IPNuP   = HeIIlevNuP(1)
                  highNuP = nbins

               end if

               do j = IPnuP, highNuP ! begin frequency loop
                  if ( elem > 2 ) then

                     ! get pointer to phot xSec of this ion in xSecArray
                     xSecP = elementP(elem, ion, outShell, 3)

                     ! get phot xSec of ion at this energy
                     phXSec = xSecArray(j+xSecP-IPnuP+1-1)

                  else if ( elem == 1 ) then ! HI

                     phXSec  = xSecArray(j-IPnuP+1+HlevXSecP(1)-1)

                  else if ( (elem == 2) .and. (ion == 1) ) then ! HeI

                     phXSec  = xSecArray(j-IPnuP+1+HeISingXSecP(1)-1)

                  else if ( (elem == 2) .and. (ion == 2) ) then ! HeII

                     phXSec  = xSecArray(j-IPnuP+1+HeIIXSecP(1)-1)

                  end if

                  if ((phXSec < 1.e-35) ) then
!                     print*, "! updateCell: [warning] bad xSec value &
!                          & exiting loop (j, phXSec)",&
!                          & nuArray(j), phXSec
!                     exit
                     phXSec = 0.
                 end if

                  if ((nuArray(j) < 1.e-35) ) then
                     print*, "! updateCell: insane nu value (j, nuArray(j)", &
                          & j, nuArray(j)
                     stop
                  end if

                  ! stellar photoionizations

                  if ( grid%Jste(cellP,j) > 0. )then

                     nPhotoSte(elem,ion) = nPhotoSte(elem,ion) + &
                          & grid%JSte(cellP,j)*phXSec/(hcRyd*nuArray(j))


                  end if

                  ! diffuse photoionizations

                  if (lgDebug) then
                     if ( grid%Jdif(cellP,j) > 0. ) then
                        nPhotoDif(elem,ion) = nPhotoDif(elem,ion) + &
                             & grid%JDif(cellP,j)*phXSec/(hcRyd*nuArray(j))

                     end if
                  end if

               end do ! end frequency loop
            end do ! end ion loop
         end do ! end element loop

         ! zero out T-iteration components
         nIterateT      = 0
         thResidual     = 0.
         thResidualHigh = 0.
         thResidualLow  = 0.
         Thigh          = 0.
         Tlow           = 0.

         if (lgDust .and. lgGas .and. lgPhotoelectric) then
            allocate (grainPot(1:nSPecies, 1:nsizes))
            grainPot=0.
            allocate (grainPotP(1:nSPecies, 1:nsizes))
            grainPotP=0
            allocate (photoelHeat_d(1:nSPecies, 1:nsizes))
            photoelHeat_d=0.
            allocate ( gasDustColl_d(1:nSPecies, 1:nsizes))
            gasDustColl_d=0.
         end if

         ! call the recursive iteration procedure for the gas
         call iterateT()

         ! call the non recursive itaration procedure for the dust
         if (lgDust) call getDustT()

         ! this was added to help implementing MPI comunication
         if (lgDust) TdustTemp(:,:,cellP)          = grid%Tdust(:,:,cellP)

         if (lgNeInput .and. lgTalk) then
            print*, '! updateCell: [talk] cell:', xP,yP,zP, " NeInput: ", &
                 &grid%NeInput(cellP), " NeUsed: ", &
                 &grid%Ne(cellP),  " N_gas: ", &
                 &grid%Hden(cellP)
         end if

      else

         if (.not.lgDust) then
            print*, '! updateCell: no gas or dust present. the grid is empty.'
            stop
         end if

         XOldHI = grid%Tdust(0,0,cellP)

         call getDustT()

         ! determine if the model has converged at this cell
         ! NOT  variable names refer to gas phase for reasons of laziness
         deltaXHI = (grid%Tdust(0,0,cellP) - XOldHI) / XOldHI
         if ( abs(deltaXHI) <= XHILimit ) then
            grid%lgConverged(cellP) = 1
         else
            grid%lgConverged(cellP) = 0
         end if

         if (lgTalk) &
              & print*, "updateCell: [talk] cell", xP,yP,zP, "; converged?",&
              & grid%lgConverged(cellP), "; mean dust T: ", &
              & grid%Tdust(0,0,cellP), "; &
              & mean dust T old: ", XOldHI,"; dT(dust): ", deltaXHI

         ! this was added to help implementing MPI comunication
         TdustTemp(:,:,cellP)          = grid%Tdust(:,:,cellP)

      end if

    contains

        recursive subroutine iterateT()
            implicit none

            ! local variables
            integer                       :: isp, ai         ! counters
            integer                       :: ispbig          ! counter

            logical                       :: lgGCBConv       ! grain charge converged?
            logical                       :: lgIBConv        ! converged?

            real                          :: coolInt         ! tot cooling integral [erg/s/Hden]
            real                          :: heatInt         ! tot heating integral [erg/s/Hden]

            real, parameter               :: Xmax = 0.9999   ! max rel abundance

            ! step up T-iteration
            nIterateT = nIterateT + 1

            ! calculate the recombination coefficients for this cell
            call calcalpha()

            ! initialize X iteration counter
            nIterateX = 1

            ! calculate the ion abundances for the remaning ions
            call ionBalance(lgIBConv)

            ! calculate dust-gas interaction heating/cooling terms
            if (lgDust .and. lgGas .and. lgPhotoelectric) then
               do isp = 1, nSpeciesPart(nspU)
                  do ai = 1, nsizes
                     nIterateGC     = 0
                     grainEmi       = 0.
                     grainRec       = 0.

                     ispbig = isp+dustComPoint(nspU)-1
                     call setGrainPotential(ispbig,ai,lgGCBConv)

                     call locate(nuArray, grainPot(isp,ai), grainPotP(isp,ai))
                     if (grainPotP(isp,ai) == 0) grainPotP = 1

                  end do
               end do
               call setPhotoelHeatCool()


               call setDustGasCollHeatCool()

            end if


            ! solve thermal balance
            call thermBalance(heatInt, coolInt)

            ! Now calculate new Te

            ! calculate thResidual = heatInt - coolInt
            thResidual = heatInt - coolInt
!print*, cellp, thresidual, heatint, coolint
            if ( abs(thResidual) >= thLimit*heatInt ) then ! start convergence condition

                if ( nIterateT < maxIterateT ) then ! start nIterateT condition

                    if ( thResidual < 0) then

                        thResidualLow = thResidual
                        Tlow          = TeUsed

                        if ( Thigh /= 0. ) then

                            TeUsed = Tlow-(Thigh-Tlow)*thResidualLow/&
                                 & (thResidualHigh-thResidualLow)

                        else

                            TeUsed = TeUsed/1.2

                        end if

                    else

                        thResidualHigh = thResidual
                        Thigh          = TeUsed

                        if ( Tlow /= 0. ) then

                            TeUsed = Tlow-(Thigh-Tlow)*thResidualLow/&
                                 & (thResidualHigh-thResidualLow)

                        else

                            TeUsed = TeUsed*1.2

                        end if

                    end if


                    if (nIterateT >= 6) then
                        if (abs(Thigh-Tlow) <= (0.002*(Thigh+Tlow)) ) then

                            if ( thResidual < 0 ) then

                                TeUsed = Thigh - 100.
                                 Thigh  = 0.

                            else

                                TeUsed = Tlow+100.
                                Tlow   = 0.

                            end if
                        end if
                    end if

                    if (TeUsed <= 0.) TeUsed = 1.

                    ! next T-iteration
                    call iterateT()
                    return

                else ! if nIterateT > maxIterateT

                    ! after maxIterateT number of iterations the temperature
                    ! is determined as follows

                    if ( Thigh == 0. ) then

                        TeUsed = Tlow

                    else

                        if (Tlow == 0.) then

                            TeUsed = Thigh

                        else

                            TeUsed = (Thigh+Tlow)*0.5

                        end if

                    end if


                    if (lgTalk) print*, "! iterateT: [warning] no convergence after ", &
                         & nIterateT, " steps. (cell, T)", cellP,xP,yP,zP,TeUsed

                    grid%noTeBal = grid%noTeBal+1.

                    grid%lgBlack(cellP) = 1

                end if

            else ! if thResidual < thLimit

                ! the T-iteration has converged

                if (lgTalk) print*, "! iterateT: [talk] convergence achieved after ",&
                     & nIterateT, " steps. (cell, T)", xP,yP,zP,TeUsed, grid%abFileIndex(xP,yP,zP)

            end if ! end convergence condition

            if (.not.lgIBConv) then
               grid%noIonBal = grid%noIonBal+1
               grid%lgBlack(cellP) = 1
            end if

            grid%Te(cellP)         = TeUsed

            ! determine if the model has converged at this cell
            deltaXHI = (grid%ionDen(cellP,elementXref(1),1) - XOldHI) / XOldHI
            if ( abs(deltaXHI) <= XHILimit ) then
               grid%lgConverged(cellP) = 1
            else
               grid%lgConverged(cellP) = 0
            end if

            if (lgTalk) print*, "iterateT: [talk] cell", xP,yP,zP, "; converged?",&
                 & grid%lgConverged(cellP), "; X(H0): ", &
                 & grid%ionDen(cellP,elementXref(1),1), &
                 & "; X(H0) old: ", XOldHI,"; dX(H0): ", deltaXHI

            ! this was added to help implementing MPI comunication
            TeTemp(cellP)          = TeUsed

        end subroutine iterateT

        recursive subroutine setGrainPotential(iSp, ai, lgGCBConv)
          implicit none

          real,save            :: delta,delta1
          real,save            :: grainPotOld ! local copy of grai pot
          real                 :: grainEmi, grainRec ! grain emissions and recom
          real,save            :: grainEmiOld, grainRecOld ! grain emissions and recom
          real,parameter       :: errorLim = 0.005, dm = 0.05 ! loop convergence
          real,parameter       :: safeLim = 100 ! loop safety limit
          real                 :: threshold,fac
          real,save            :: dVg,slope

          integer, intent(in)  :: iSp, ai

          logical, intent(inout) :: lgGCBConv   ! converged?

          nIterateGC = nIterateGC+1

          if (nIterateGC==1) then
             dVg=0.05
             grainPot(isp,ai) = 0.
             grainPotOld = grainPot(isp,ai)
             lgGCBConv = .true.
             grainEmiOld = getGrainEmission(grainPot(isp,ai), isp, ai)
             grainRecOld = getGrainRecombination(grainPot(isp,ai))
             grainPot(isp,ai) = grainPotOld+0.05
          end if

          threshold = max(grainVn(isp)+grainPot(isp,ai),grainVn(isp))
          grainEmi = getGrainEmission(grainPot(isp,ai), isp, ai)
          grainRec = getGrainRecombination(grainPot(isp,ai))
          delta = grainEmi-grainRec

          delta1 = abs(delta/(0.5*max(1.e-35, grainEmi+grainRec)))


          ! check for convergence
          if (delta1<errorLim) then
             return
          else

             if (grainPot(iSp,ai) /= grainPotOld) then
                fac = (grainEmi-grainEmiOld)-(grainRec-grainRecOld)
                if (fac/=0.) slope = fac/(grainPot(iSp,ai)-grainPotOld)
             end if

             grainPotOld=grainPot(iSp,ai)
             grainRecOld = grainRec
             grainEmiOld = grainEmi

             delta1 = -delta/slope
             delta = abs(delta1)
             delta = min(delta, dm*threshold)
             delta = sign(delta, delta1)

             grainPot(iSp,ai) = grainPot(iSp,ai)+delta

             if (nIterateGC< maxIterateGC) then
                call setGrainPotential(isp,ai,lgGCBConv)
                return
             else

!                print*, '! setGrainPotential: no convergence', &
!                     & cellP,grainPot(isp,ai),grainEmi,grainRec
                lgGCBConv=.false.
                return
             end if

          end if

        end subroutine setGrainPotential

        ! calculate the grain recombination
        ! using eqn 18 etc of Baldwin et al. (1991)
        ! cellFactor is dependant on the physical conditions of the gas,
        function getGrainEmission(Vg, isp,ai)
          implicit none


          real :: getGrainEmission
          real, intent(in) :: Vg ! grain potential
          real :: Yn, Yhat

          real :: Qa ! grain absorption efficiency
          real :: thres, photFlux

          integer, intent(in) :: isp, ai
          integer :: ifreq, ip

          getGrainEmission=0.


          ! get the threshold
          thres = max(grainVn(isp)+Vg,grainVn(isp))

          call locate( nuArray, thres, ip)
          ip = ip+1


          do ifreq = ip, nbins


             Yn = min(Y0*(1.-grainVn(isp)/nuArray(ifreq)), Y1)

             Yhat = Yn*min(1., max(0.,1.-Vg/(nuArray(ifreq)-grainVn(isp))))

             if (.not. lgDebug) then
!                photFlux = (grid%JPEots(cellP,ifreq) + &
!                & grid%Jste(cellP,ifreq))/(hcRyd*nuArray(ifreq))
                photFlux =  grid%Jste(cellP,ifreq)/(hcRyd*nuArray(ifreq))
             else
!                photFlux = (grid%JPEots(cellP,ifreq) +&
!                &  grid%Jste(cellP,ifreq)+grid%Jdif(cellP,ifreq))/&
!                     & (hcRyd*nuArray(ifreq))
             end if

             photFlux = photFlux*fourPi

             Qa = XSecArray(dustAbsXsecP(isp,ai)+ifreq-1)/(1.e-8*grainRadius(ai)**2)

             getGrainEmission = getGrainEmission+Yhat*photFlux*Qa

          end do

        end function getGrainEmission


        ! calculate the grain recombination
        ! using eqn 23 etcof Baldwin et al. (1991)
        ! cellFactor is dependant on the physical conditions of the gas,
        function getGrainRecombination(Vg)
          implicit none

          real :: getGrainRecombination
          real, intent(in) :: Vg ! grain potential [ryd]

          real :: eta   ! Coulomb correction
          real :: cpDen ! colliding particle number density [cm^-3]
          real :: eightkT_pi ! 8*k * Te/Pi [erg]
          real :: mcp   ! mass of colliding particle in [g]
          real :: kT    ! k*Te [ryd]
          real :: S     ! sticking coefficient
          real :: vmean ! colliding particle mean velocity
          real :: Z     ! colliding particle charge

          integer :: istage

          getGrainRecombination = 0.
          eta = 0.
          kT =6.336e-6*TeUsed
          eightkT_pi = (1.1045e-15)*TeUsed/Pi

          ! add e- collisions contributions

          vmean = sqrt(eightkT_pi/me)

          S  =1. ! electron sticking probability


          ! eq 24 of Baldwin et al 91
          eta = -Vg/kT

          if (eta <= 0.) then
             eta = 1.-eta
          else if (eta >0.) then
             eta = exp(-eta)
          else
             print*, "! getGrainRecombination: insane eta for e-", eta
          end if

          getGrainRecombination = getGrainRecombination + &
               & NeUsed*vmean*S*eta

          ! add contribution from all other neutral and ionic species
          do elem = 1, nElements
             if (lgElementOn(elem)) then
                do istage = 2, min(elem+1,nstages)
                   ! get cpDen
                   cpDen = grid%ionDen(cellP,elementXref(elem),istage)*&
                        & grid%elemAbun(grid%abFileIndex(xP,yP,zP),elem)*&
                        & grid%Hden(cellP)
                   mcp = (aWeight(elem)*amu)
                   vmean = sqrt(eightkT_pi/mcp)

                   S = 1.
                   Z = real(istage-1)

                   eta = Z*Vg/kT

                   if (eta <= 0.) then
                      eta = 1.-eta
                   else if (eta >0.) then
                      eta = exp(-eta)
                   else
                      print*, "! getGrainRecombination: insane eta", &
                           & eta, elem, istage
                   end if

                   getGrainRecombination = getGrainRecombination - &
                        & cpDen*vmean*S*eta

                end do
             end if
          end do

        end function getGrainRecombination

        ! see Baldwin et al 1991; but beware that we are resolving the size distribution.
        ! so must keep size dependance, so Qa ia really Pi a^2 Qa
        subroutine setPhotoelHeatCool()
          implicit none

          real    :: Qa, photFlux, EY, Yhat,Yn,th

          integer :: ns,na,ifreq,thP

          ! calculate the cooling of dust by photoelectric emission
          !  and heating of gas
          ! Baldwin et al. 1991 eqn 25-27

          photoelHeat_d=0.
          photoelHeat_g=0.
          do ns = 1, nSpeciesPart(nspU)
             do na = 1, nSizes


                if (grainPotP(ns,na) <= 0) then
                   print*, "! setPhotoelHeatCool irregular grain potential index", &
                        grainPotP(ns,na), grainPot(ns,na)
                   stop
                end if

                th = max(grainVn(ns)+grainPot(ns,na), grainVn(ns))
                call locate(nuArray,th,thP)
                if(thP<=0) thP=1

                do ifreq = thP, nbins

!                do ifreq = grainPotP(ns,na), nbins

                   Yn = min(Y0*(1.-grainVn(ns)/nuArray(ifreq)), Y1)


                   Yhat = Yn*min(1., max(0.,1.-grainPot(ns,na)/(nuArray(ifreq)-grainVn(ns))))

                   if (.not. lgDebug) then
!                      photFlux = (grid%JPEots(cellP,ifreq) + &
!                           & grid%Jste(cellP,ifreq))/(hcRyd*nuArray(ifreq))
                      photFlux = grid%Jste(cellP,ifreq)/(hcRyd*nuArray(ifreq))
                   else
!                      photFlux = (grid%JPEots(cellP,ifreq) + grid%Jste(cellP,ifreq)+&
!                           & grid%Jdif(cellP,ifreq))/(hcRyd*nuArray(ifreq))
                      photFlux = (grid%Jste(cellP,ifreq)+grid%Jdif(cellP,ifreq))/(hcRyd*nuArray(ifreq))

                   end if

                   photFlux = photFLux

                   Qa = XSecArray(dustAbsXsecP(ns,na)+ifreq-1)


                   EY = Yn*0.5* min(nuArray(ifreq)-grainVn(ns),&
                        & max(0., ((nuArray(ifreq)-grainVn(ns))**2-grainPot(ns,na)**2)/&
                        & (nuArray(ifreq)-grainVn(ns))))

!                   photoelHeat_d(ns,na) = photoelHeat_d(ns,na)+Qa*photFlux*EY*hcRyd/Pi
                   photoelHeat_d(ns,na) = photoelHeat_d(ns,na)+Qa*photFlux*EY*hcRyd/Pi

                   photoelHeat_g = photoelHeat_g+Qa*photFlux*(EY-Yhat*grainPot(ns,na))*&
                        & grainAbun(nspU,ns)*grainWeight(na)

                end do
             end do
          end do

          photoelHeat_g = photoelHeat_g*grid%Ndust(cellP)*hcRyd/grid%Hden(cellP)

        end subroutine setPhotoelHeatCool

        ! sets the cooling and heating rates of gas and dust due to collisions between the two phases
        ! see Baldwin et al 1991
        ! only collisions with up to the 3 times ionised case are considered here
        ! (process becomes unimportant for higher ionisation cases)
        subroutine setDustGasCollHeatCool()
          implicit none

          real :: Z , kT, eta, psi,xi,  S, IPerg
          real :: eightkT_pi ! 8*k * Te/Pi [erg]
          integer :: ss(30)
          real :: vmean, mcp ! colliding particle mean velocity and mean particle mass
          integer :: nelectrons, istage, ns, na

          ! outer shell array
          ss = (/1,1,2,2,3,3,3,3,3,3,4,4,5,5,5,5,5,5,&
               &6,6,6,6,6,6,6,6,6,6,7,7/)

          gasDustColl_g = 0.
          gasDustColl_d = 0.

          kT =6.336e-6*TeUsed ! ryd
          eightkT_pi = (1.1045e-15)*TeUsed/Pi


          do elem = 1, nElements ! 0 for electrons
             if ( lgElementOn(elem)) then

                   do istage = 1, min(nstages,elem+1)
                      Z = real(istage-1)

                      mcp = aWeight(elem)*amu
                      vmean = sqrt(eightkT_pi/mcp)

                      ! number of e-'s of the ionisation stage above
                      nelectrons = elem-istage+1

                      if (istage>1) then
                         if (elem == 1) then
                            IPerg = nuArray(HlevNuP(1))*ryd2erg
                         else if (elem == 2 .and. istage == 2) then
                            IPerg = nuArray(HeIlevNuP(1))*ryd2erg
                         else if (elem == 2 .and. istage == 3) then
                            IPerg = nuArray(HeIIlevNuP(1))*ryd2erg
                         else
                            IPerg = nuArray(elementP(elem,istage-1,nShells(elem,istage-1),1))*ryd2erg
                         end if
                      end if

                      do ns = 1, nSpeciesPart(nspU)
                         if (istage == 1) then
                            S = 2*mcp*MsurfAtom(ns)/(mcp+MsurfAtom(ns))**2
                         else
                            S = 1.
                         end if
                         do na = 1, nSizes

                            psi = Z*grainPot(ns,na)/kT
                            if (psi <= 0. ) then
                               eta = 1.-psi
                               xi = 1. - psi/2.
                            else
                               eta = exp(-psi)
                               xi = (1.+psi/2.) * eta
                            end if

                            gasDustColl_d(ns,na) = gasDustColl_d(ns,na)+&
                                 & ionDenUsed(elementXref(elem),istage)*&
                                 & grid%elemAbun(grid%abFileIndex(xP,yP,zP),elem)*&
                                 & grid%Hden(cellP)*&
                                 & Pi*grainRadius(na)*grainRadius(na)*1.e-8*&
                                 & S*vmean*(2.*kT*Ryd2erg*xi-eta*&
                                 & (Z*grainPot(ns,na)*Ryd2erg-IPerg+&
                                 & 2.*kBoltzmann*grid%Tdust(ns,na,cellP)))

                            gasDustColl_g = gasDustColl_g + &
                                 & ionDenUsed(elementXref(elem),istage)*&
                                 & grainWeight(na)*grainAbun(nspU,ns)*grid%Ndust(cellP)*&
                                 & grid%elemAbun(grid%abFileIndex(xP,yP,zP),elem)*&
                                 & Pi*grainRadius(na)*grainRadius(na)*1.e-8*&
                                 & S*vmean*(2.*kT*Ryd2erg*xi-eta*2.*kBoltzmann*&
                                 & grid%Tdust(ns,na,cellP))
                         end do
                      end do
                   end do
                end if
             end do

             ! add contribution of e- collisions
             vmean = sqrt(eightkT_pi/me)
             do ns = 1, nSpeciesPart(nspU)
                S = 1.
                Z=-1.
                do na = 1, nSizes


                   psi = Z*grainPot(ns,na)/kT
                   if (psi <= 0. ) then
                      eta = 1.-psi
                      xi = 1. - psi/2.
                   else
                      eta = exp(-psi)
                      xi = (1.+psi/2.) * eta
                   end if

                   gasDustColl_d(ns,na) = gasDustColl_d(ns,na)+&
                        & NeUsed* &
                        & Pi*grainRadius(na)*grainRadius(na)*1.e-8*&
                        & S*vmean*(2.*kT*Ryd2erg*xi-eta*&
                        & (Z*grainPot(ns,na)*ryd2erg))

                   gasDustColl_g = gasDustColl_g + &
                        & NeUsed* &
                        & grainWeight(na)*grainAbun(nspU, ns)*grid%Ndust(cellP)*&
                        & Pi*grainRadius(na)*grainRadius(na)*1.e-8*&
                        & S*vmean*(2.*kT*Ryd2erg*xi)/&
                        & grid%Hden(cellP)
                end do
             end do

             ! factor of fourpi to make up for the lack of fourpi
             ! in the balance eqns for J
             gasDustColl_d(:,:)= gasDustColl_d(:,:)/fourpi
             gasDustColl_g= gasDustColl_g/fourpi

           end subroutine setDustGasCollHeatCool


        subroutine thermBalance(heatInt, coolInt)
            implicit none

            real, intent(out)      :: heatInt, &    ! total heating and
                 & coolInt       ! cooling integrals
            ! local variables

            integer                :: i,j,k         ! counters
            integer                :: elem, ion     ! counters

            real                   :: betaFF        ! energy loss coeff due to ff rad
            real                   :: betaRec       ! energy loss coeff due to recomb
            real                   :: ch12, ch13, & ! collision excitation of
                 & ex12, ex13,&                     ! hydrogen data
                 & th12, th13                       ! (Mathis, Ly alpha, beta)
            real                   :: coolFF        ! cool due to FF radiation [erg/s/Hden]
            real                   :: coolColl      ! cool due to coll excit   [erg/s/Hden]
            real                   :: coolRec       ! cool due to recombination[erg/s/Hden]
            real                   :: fcool
            real                   :: heatIonSte    ! heat due to this ion stellar phot
            real                   :: heatIonDif    ! heat due to this ion diffuse phot
            real                   :: heatSte       ! tot heat gain due to stellar phot
            real                   :: heatDif       ! tot heat gain due to diffuse phot
            real                   :: log10Te       ! log10(Te)
            real                   :: log10TeScaled ! log10(Te/Z^2)
            real                   :: Np            ! proton density
            real                   :: Te4           ! Te/10000.


            ! find log10Te and Te4 at this cell
            log10Te = log10(TeUsed)
            Te4     = TeUsed / 1.e4

            ! open ff, rec beta files for H+ and He2+ (Hummer, MNRAS 268(1994) 109, Table 1.

            ! find the N(H+)
            Np = grid%ionDen(cellP,elementXref(1),2)*grid%elemAbun(grid%abFileIndex(xP,yP,zP),1)

            ! cooling of gas due to FF radiation from H+
            ! fits to Hummer, MNRAS 268(1994) 109, Table 1. or  least square fitting to m=4

            betaFF = 1.0108464E-11 + 9.7930778E-13*log10Te - &
                 & 6.6433144E-13*log10Te*log10Te + 2.4793747E-13*log10Te*log10Te*log10Te -&
                 & 2.3938215E-14*log10Te*log10Te*log10Te*log10Te

            coolFF = Np*NeUsed*betaFF*kBoltzmann*TeUsed/sqrt(TeUsed)

            if (lgTraceHeating.and.taskid==0) then
               write(57,*) 'Cell: ', xp,yp,zp
               write(57,*) 'FF H+: ', coolFF
            end if

            ! cooling of gas due to recombination of H+
            ! fits to Hummer, MNRAS 268(1994) 109, Table 1.
            ! least square fitting to m=4
            betaRec = 9.4255985E-11 -4.04794384E-12*log10Te &
                 & -1.0055237E-11*log10Te*log10Te +  1.99266862E-12*log10Te*log10Te*log10Te&
                 & -1.06681387E-13*log10Te*log10Te*log10Te*log10Te

            coolRec = Np*NeUsed*betaRec*kBoltzmann*TeUsed/sqrt(TeUsed)

            if (lgTraceHeating.and.taskid==0) then
               if (nIterateT > 1) then
                  do i = 1, 12
                     backspace 57
                  end do
               end if

               write(57,*) 'Rec H+: ', coolrec
            end if

            ! cooling of gas due to FF radiation from He++
            ! fits to Hummer, MNRAS 268(1994) 109, Table 1. least square fitting to m=4 and
            ! scaled to Z=2

            ! find N(He++)
            Np =  grid%ionDen(cellP,elementXref(2),3)*grid%elemAbun(grid%abFileIndex(xP, yP,zP),2)

            log10TeScaled = log10(TeUsed/4.)

            betaFF = 2.*(1.0108464E-11 + 9.7930778E-13*log10TeScaled - &
                 & 6.6433144E-13*log10TeScaled*log10TeScaled + &
                 & 2.4793747E-13*log10TeScaled*log10TeScaled*log10TeScaled -&
                 & 2.3938215E-14*log10TeScaled*log10TeScaled*log10TeScaled*log10TeScaled)


            coolFF = coolFF + Np*NeUsed*betaFF*kBoltzmann*TeUsed/sqrt(TeUsed/4.)

            if (lgTraceHeating.and.taskid==0) then
               write(57,*) 'FF He++: ',Np*NeUsed*betaFF*kBoltzmann*TeUsed/sqrt(TeUsed/4.)
            end if


            ! cooling of gas due to recombination of He++
            ! fits to Hummer, MNRAS 268(1994) 109, Table 1.  least square fitting to m=4
            ! and scaled to Z=2
            betaRec = 2.*(9.4255985E-11 -4.04794384E-12*log10TeScaled &
                 & -1.0055237E-11*log10TeScaled*log10TeScaled  &
                 & +1.99266862E-12*log10TeScaled*log10TeScaled*log10TeScaled&
                 & -1.06681387E-13*log10TeScaled*log10TeScaled*log10TeScaled*log10TeScaled)

            coolRec = coolRec + Np*NeUsed*betaRec*kBoltzmann*TeUsed/sqrt(TeUsed/4.)

            if (lgTraceHeating.and.taskid==0) then
               write(57,*) 'Rec He++: ',Np*NeUsed*betaRec*kBoltzmann*TeUsed/sqrt(TeUsed/4.)
            end if

            ! cooling of gas due to FF radiation from He+
            ! fits to Hummer and Storey, MNRAS 297(1998) 1073, Table 6. least square fitting to m=4

            ! find N(He+)
            Np =  grid%ionDen(cellP,elementXref(2),2)*grid%elemAbun(grid%abFileIndex(xp, yP, zP),2)

            betaFF =  1.070073e-11    -2.5730207e-13*log10Te + &
                 & 2.109134e-13*log10Te*log10Te

            coolFF = coolFF + Np*NeUsed*betaFF*kBoltzmann*TeUsed/sqrt(TeUsed)

            if (lgTraceHeating.and.taskid==0) then
               write(57,*) 'FF He+: ',Np*NeUsed*betaFF*kBoltzmann*TeUsed/sqrt(TeUsed)
            end if


            ! cooling of gas due to recombination of He+
            ! fits to Hummer and Storey, MNRAS 297(1998) 1073, Table 6. least square fitting to m=4
            betaRec =    9.4255985E-11 -4.04794384E-12*log10Te &
                 & -1.0055237E-11*log10Te*log10Te  &
                 & +1.99266862E-12*log10Te*log10Te*log10Te &
                 & -1.06681387E-13*log10Te*log10Te*log10Te*log10Te

            coolRec = coolRec + Np*NeUsed*betaRec*kBoltzmann*TeUsed/sqrt(TeUsed)

            if (lgTraceHeating.and.taskid==0) then
               write(57,*) 'Rec He+: ',Np*NeUsed*betaRec*kBoltzmann*TeUsed/sqrt(TeUsed)
            end if

            ! collisional excitation of Hydrogen
            ! Mathis, Ly alpha, beta
            ch12 = 2.47e-8
            ch13 = 1.32e-8
            ex12 = -0.228
            ex13 = -0.460
            th12 = 118338.
            th13 = 140252.

            if (TeUsed > 5000.) then

                coolColl = (ch12*exp(-th12/TeUsed)*Te4**ex12 + &
                     & ch13*exp(-th13/TeUsed)*Te4**ex13) * &
                     & hcRyd*grid%ionDen(cellP,elementXref(1),1)*NeUsed

             else

                coolColl = 0.

             end if

            if (lgTraceHeating.and.taskid==0) then
               write(57,*) 'Coll exc H: ',coolColl
               fcool = 0.
            end if


             ! collisional excitation of Heavies

             ! get the emissivities of the forb lines
             call forLines()

             ! sum all contributions from the heavies to coolColl
             do elem = 3, nElements
                do ion = 1, min(elem+1, nstages)
                   do j = 1, 10
                      do k = 1, 10
                         coolColl = coolColl + real(forbiddenLines(elem,ion,j,k))
                         if (lgTraceHeating.and.taskid==0) then
                            fcool = fcool + real(forbiddenLines(elem,ion,j,k))
                         end if
                      end do
                   end do
                end do
             end do

            if (lgTraceHeating.and.taskid==0) then
               write(57,*) 'CELs cool: ',fcool
               fcool = 0.
            end if

             ! heating due to photoionization

             ! re-initialize heatSte and heatDif
             heatSte = 0.
             if (lgDebug) heatDif = 0.

             do elem = 1, nElements  ! begin element loop
                 do ion = 1, min(elem, nStages-1) ! begin ion loop
                     if(.not.lgElementOn(elem)) exit

                     if (elem > 2) then

                         ! find the number of electrons in this ion
                         nElec = elem - ion + 1

                         ! find the outer shell number and statistical weights
                         call getOuterShell(elem, nELec, outShell, g0, g1)

                         ! get pointer to this ion's IP in NuArray
                         IPnuP = elementP(elem, ion, outShell, 1)

                         ! get pointer to this cell's highest energy
                         highNuP = elementP(elem, ion, outShell, 2)

                     else if (elem == 1) then ! HI

                         IPNuP   = HlevNuP(1)
                         highNuP = nbins

                     else if ( (elem == 2) .and. (ion == 1) ) then ! HeI

                         IPNuP   = HeIlevNuP(1)
                         highNuP = nbins

                     else if ( (elem == 2) .and. (ion == 2) ) then ! HeII

                         IPNuP   = HeIIlevNuP(1)
                         highNuP = nbins

                     end if

                     ! re-initialize heatIonSte and heatIonDif
                     heatIonSte = 0.
                     if (lgDebug) heatIonDif = 0.
                     do j = IPnuP, highNuP ! begin frequency loop
                             if ( elem > 2 ) then

                                 ! get pointer to phot xSec of this ion in xSecArray
                                 xSecP = elementP(elem, ion, outShell, 3)

                                 ! get phot xSec of ion at this energy
                                 phXSec = xSecArray(j+xSecP-IPnuP+1-1)

                             else if ( elem == 1 ) then ! HI

                                 phXSec  = xSecArray(j-IPnuP+1+HlevXSecP(1)-1)

                             else if ( (elem == 2) .and. (ion == 1) ) then ! HeI


                                 phXSec  = xSecArray(j-IPnuP+1+HeISingXSecP(1)-1)


                             else if ( (elem == 2) .and. (ion == 2) ) then ! HeII

                                 phXSec  = xSecArray(j-IPnuP+1+HeIIXSecP(1)-1)

                             end if

                             if ((phXSec < 1.e-35) ) then
                                 exit
                             end if

                             if ((nuArray(j) < 1.e-35) ) then
                                 print*, "! thermBalance: insane nu value (j, nuArray(j)", &
                                      & j, nuArray(j)
                                 stop
                             end if

                             ! stellar photoionizations
                             if ( grid%Jste(cellP,j) > 0. )then

                                heatIonSte = heatIonSte + phXSec*grid%Jste(cellP,j)*&
                                     & (nuArray(j)-nuArray(IPNuP)) / (nuArray(j))

                             end if

                             ! diffuse photoionizations

                             if (lgDebug) then
                                if ( grid%Jdif(cellP,j) > 0. ) then

                                   heatIonDif = heatIonDif + phXSec*grid%JDif(cellP,j)* &
                                        & (nuArray(j)-nuArray(IPNuP)) / (nuArray(j))

                                end if
                             end if

                    end do ! end frequency loop

                    ! get total heat gain from stellar and diffuse photoionizations

                    heatIonSte = heatIonSte*ionDenUsed(elementXref(elem),ion)*&
                         & grid%elemAbun(grid%abFileIndex(xP,yP,zP),elem)
                    if (lgDebug) &
                         & heatIonDif = heatIonDif*ionDenUsed(elementXref(elem),ion)*&
                         &grid%elemAbun(grid%abFileIndex(xP,yP,zP),elem)

                    heatSte    = heatSte + heatIonSte
                    if (lgDebug) &
                         & heatDIf    = heatDif + heatIonDif

                end do ! end ion loop

            end do ! end element loop

            ! calculate the total heating and cooling integrals

            if (lgDebug) then
               heatInt = heatSte + heatDIf
            else
               heatInt = heatSte
            end if

            if (lgTraceHeating.and.taskid==0) then
               write(57,*) 'Dust gas coll cool: ',gasDustColl_g
               write(57,*) 'Heat photionization: ', heatInt
               write(57,*) 'Heat photoelectric: ', photoelHeat_g
            end if

            coolInt = coolFF + coolRec + coolColl

            if (lgDust .and. lgPhotoelectric) then
               coolInt = coolInt+gasDustColl_g
               heatInt = heatInt+photoelHeat_g
            end if


        end subroutine thermBalance


        ! this subroutine is the driver for the calculation of the emissivity
        ! from the heavy elements forbidden lines.
        subroutine forLines()
          implicit none

          integer        :: elem, ion ! counters

          ! re-initialize forbiddenLines
          forbiddenLines = 0.

          do elem = 3, nElements
             do ion = 1, min(elem+1, nstages)
                if (.not.lgElementOn(elem)) exit

                if (lgDataAvailable(elem, ion)) then

                   if (elem == 26 .and. ion == 2) then
                      if (nstages > 2) then
                         call equilibrium(file_name=dataFile(elem, ion), &
                              &ionDenUp=ionDenUsed(elementXref(elem),ion+1)/&
                              &ionDenUsed(elementXref(elem),ion), Te=TeUsed,&
                              &Ne=NeUsed, FlineEm=forbiddenLinesLarge(&
                              &1:nForLevelsLarge, 1:nForLevelsLarge))
                      else
                         call equilibrium(file_name=dataFile(elem, ion), &
                              &ionDenUp=0., Te=TeUsed,&
                              &Ne=NeUsed, FlineEm=forbiddenLinesLarge(&
                              &1:nForLevelsLarge, 1:nForLevelsLarge))
                      end if
                      forbiddenLinesLarge(:, :) = forbiddenLinesLarge(:, :)*&
                           & grid%elemAbun(grid%abFileIndex(xP,yP,zP),elem)*&
                           & ionDenUsed(elementXref(elem), ion)
                   else
                      if (ion<nstages) then
                         call equilibrium(dataFile(elem, ion), &
                              &ionDenUsed(elementXref(elem), ion+1)/&
                              &ionDenUsed(elementXref(elem),ion), &
                              & TeUsed, NeUsed, forbiddenLines(elem, ion,:,:))
                      else
                         call equilibrium(dataFile(elem, ion), 0., &
                            & TeUsed, NeUsed, forbiddenLines(elem, ion,:,:))
                      end if
                      forbiddenLines(elem, ion, :, :) = forbiddenLines(elem, ion, :, :)*&
                           & grid%elemAbun(grid%abFileIndex(xP,yP,zP),elem)*&
                           & ionDenUsed(elementXref(elem), ion)
                   end if
                end if
             end do
          end do

          ! scale the forbidden lines emissivity to give units of [erg/s/Ngas]
          ! comment: the forbidden line emissivity is so far in units of cm^-1/s/Ngas
          !          the energy [erg] of unit wave number [cm^-1] is 1.9865e-16, hence
          !          the right units are obtained by multiplying by 1.9865e-16
          forbiddenLines = forbiddenLines*1.9865e-16
          if (lgElementOn(26) .and. ion>2) forbiddenLinesLarge = forbiddenLinesLarge*1.9865e-16

        end subroutine forLines

        recursive subroutine ionBalance(lgConv)
            implicit none

            logical, intent(out)   :: lgConv        ! did ion bal converge?

            ! local variables
            real                   :: collIon       ! collisional ionization of H
            real                   :: correction    ! used in lgNeInput = .t.
            real                   :: deltaHI       ! delta(X(H0))
            real                   :: deltaHeI      ! delta(X(He0))
            real                   :: deltaHeII     ! delta(X(HeII))
            real                   :: expFact       ! exponential factor
            real                   :: t4            ! TeUsed/10000.
            real, save             :: HIOld         ! X(H0) from last iteration
            real, save             :: HeIOld        ! X(He0) from last iteration
            real, save             :: HeIIOld       ! X(He+) from last iteration
            real, parameter        :: limit = 0.01  ! convergence limit

            integer                :: elem, ion     ! element and ion counters
            integer                :: g0,g1         ! stat weights
            integer                :: i             ! counter
            integer                :: nElec         ! of  e's in the ion
            integer                :: outShell      ! byproduct of proc to get stat weights


            real                   :: revRate       ! reverse charge exchange rate

            double precision, dimension(nELements) :: &
                 & denominator   ! denominator of final ion abundance


            real, dimension(nElements, nstages) :: &
                 & deltaE_k      ! deltaE/k [K]

            double precision, dimension(nElements, nstages) :: &
                 & ionRatio, &   ! X(i+1)/X(+i)
                 & ionProd       ! ionRatio products
            real, dimension(nElements, nstages,4) :: &
                 & chex         ! ch exchange coeff in cm^3/s


            ! initialize variables
            correction  = 0.
            ionRatio    = 0.
            ionProd     = 1.
            denominator = 1.
            lgConv      = .true.

            ! take into account collisional ionization of H
            ! Drake & Ulrich, ApJS42(1980)351
            expFact = 157893.94/TeUsed

            if (expFact > 75.) then
                ! prevents underflow of exponential factor in collIon
                expFact = 75.
            end if

            collIon = 2.75E-16*TeUsed*sqrt(TeUsed)*&
                 & (157893.94/TeUsed+2.)*exp(-expFact)


            ! get HIOld, HeIOld, HeIIOld from last iteration
            HIOld   = ionDenUsed(elementXref(1),1)
            HeIOld  = ionDenUSed(elementXref(2),1)
            HeIIOld = ionDenUsed(elementXref(2),2)

            ! the set of charge exchange coeffs is not complete; the following might need
            ! to be changed when a more complete set is available



            chex          = 0.
            deltaE_k      = 0.

            chex(2,1,:)  = (/7.47e-6, 2.06, 9.93,-3.89/)! He0
            chex(2,2,:)  = (/1.e-5  , 0.  , 0.  , 0./)  ! He+
            chex(3,2,:)  = (/1.26   , 0.96,3.02 ,-0.65/)! Li+
            chex(3,3,:)  = (/1.e-5  , 0.  , 0.  , 0. /) ! Li+2
            chex(4,2,:)  = (/1.e-5  , 0.  , 0.  , 0. /) ! Be+
            chex(4,3,:)  = (/1.e-5  , 0.  , 0.  , 0. /) ! Be+2
            chex(4,4,:)  = (/5.17   , 0.82, -.69, -1.12 /)! Be+3
            chex(5,2,:)  = (/2.e-2  , 0.  , 0.  , 0. /) ! B+
            chex(5,3,:)  = (/1.e-5  , 0.  , 0.  , 0. /) ! B+2
            chex(5,4,:)  = (/5.27e-1, 0.76,-0.63,-1.17/)! B+3
            chex(6,1,:)  = (/1.76e-9, 8.33, 4278.78, -6.41/)! C0
            chex(6,2,:)  = (/1.67e-4, 2.79, 304.72, -4.07/)! C+
            chex(6,3,:)  = (/3.25   , 0.21, 0.19, -3.29/)! C+2
            chex(6,4,:)  = (/332.46 ,-0.11,-0.995,-1.58e-3/)! C+3
            chex(7,1,:)  = (/1.01e-3,-0.29,-0.92, -8.38/)! N0
            chex(7,2,:)  = (/3.05e-1, 0.60, 2.65, -0.93/)! N+
            chex(7,3,:)  = (/4.54   , 0.57,-0.65, -0.89/)! N2+
            chex(7,4,:)  = (/3.28   , 0.52,-0.52, -0.19/)! N3+
            chex(8,1,:)  = (/1.04   , 3.15e-2, -0.61, -9.73/)! O0
            chex(8,2,:)  = (/1.04   , 0.27, 2.02, -5.92/)! O+
            chex(8,3,:)  = (/3.98   , 0.26, 0.56, -2.62/)! O2+
            chex(8,4,:)  = (/2.52e-1, 0.63, 2.08, -4.16/)! O3+
            chex(9,2,:)  = (/1.e-5  , 0.  , 0.  , 0./) ! F+
            chex(9,3,:)  = (/9.86   , 0.29,-0.21,-1.15/) ! F+2
            chex(9,4,:)  = (/7.15e-1, 1.21,-0.70,-0.85/) ! F3+
            chex(10,2,:) = (/1.e-5  , 0.  , 0.  , 0.  /) ! Ne+
            chex(10,3,:) = (/14.73  , 4.52e-2, -0.84, -0.31 /) ! Ne+2
            chex(10,4,:) = (/6.47   , 0.54 , 3.59 , -5.22 /) ! Ne+3
            chex(11,2,:) = (/1.e-5  , 0.   , 0.   , 0. /) ! Na+
            chex(11,3,:) = (/1.33   , 1.15 , 1.20 , -0.32 /)! Na+2
            chex(11,4,:) = (/1.01e-1, 1.34 , 10.05, -6.41 /)! Na+3
            chex(12,2,:) = (/8.58e-5, 2.49e-3, 2.93e-2, -4.33 /)! Mg+
            chex(12,3,:) = (/6.49   , 0.53 , 2.82, -7.63 /) ! Mg+2
            chex(12,4,:) = (/6.36   , 0.55 , 3.86, -5.19 /) ! Mg+3
            chex(13,2,:) = (/1.e-5  , 0.   , 0.  , 0./) ! Al+
            chex(13,3,:) = (/7.11e-5, 4.12 , 1.72e4, -22.24/)! Al+2
            chex(13,4,:) = (/7.52e-1, 0.77 , 6.24, -5.67/) ! Al+3
            chex(14,2,:) = (/1.23   , 0.24 , 3.17, 4.18e-3/) ! Si+
            chex(14,3,:) = (/4.900e-1, -8.74e-2, -0.36, -0.79/)! Si+2
            chex(14,4,:) = (/7.58   , 0.37 , 1.06, -4.09/)! Si+3
            chex(16,1,:) = (/3.82e-7, 11.10, 2.57e4, -8.22/)! S0
            chex(16,2,:) = (/1.e-5  , 0.   , 0.   ,0. /)! S+
            chex(16,3,:) = (/2.29   , 4.02e-2, 1.59, -6.06/)! S+2
            chex(16,4,:) = (/6.44   , 0.13 , 2.69 , -5.69/)! S+3
            chex(18,2,:) = (/1.e-5  , 0.   , 0.    , 0./) ! Ar+
            chex(18,3,:) = (/4.57   , 0.27 , -0.18 , -1.57/)! Ar+2
            chex(18,4,:) = (/6.37   , 2.12 , 10.21 , -6.22/)! Ar+3
            chex(18,3,:) = (/3.17e-2, 2.12 , 12.06 , -0.40/)! Ca+2
            chex(18,4,:) = (/2.68   , 0.69 , -0.68 , -4.47/)! Ca+3
            chex(26,2,:) = (/1.26   , 7.72e-2, -0.41, -7.31/)! Fe+
            chex(26,3,:) = (/3.42   , 0.51 , -2.06 , -8.99/)! Fe+2.


            deltaE_k(7,1) = 10863.
            deltaE_k(8,1) = 2205.

            chex(:,:,1) = chex(:,:,1)*1.e-9


            t4 = TeUsed/10000.


            ! calculate the X(i+1)/X(i) ratio
            do elem = 1, nElements
                do ion = 1, min(elem, nstages-1)
                    if (.not.lgElementOn(elem)) exit

                    chex(elem,ion,1) = chex(elem,ion,1)*(t4**chex(elem,ion,2))*&
                         & (1.+chex(elem,ion,3)*exp(chex(elem,ion,4)*t4))

                    if (chex(elem,ion,1) < 0. ) chex(elem,ion,1) = 0.
                    if (TeUsed < 6000. .or. TeUsed>5.e4) chex(elem,ion,1) = 0.

                    ! find the number of electron in this ion
                    nElec = elem - ion +1

                    ! find the stat weights
                    call getOuterShell(elem, nElec, outShell, g0, g1)

                    ! calculate the reverse charge exchange rate (only if deltaE_k > 1.)
                    if ( deltaE_k(elem,ion) > 1.) then

                       revRate = chex(elem,ion,1) * &
                            & (1.-grid%ionDen(cellP, &
                            & elementXref(1),1))*grid%Hden(cellP)*&
                            & 2. * exp(-deltaE_k(elem,ion)/TeUsed)/(real(g0)/real(g1))
                    else
                       revRate = 0.
                    end if

                    if ( (elem>1) .or. (ion>1) ) collIon = 0.

                    ! calculate the X(i+1)/X(i) ratio
                    if (lgDebug) then
                       ionRatio(elem,ion) = (nPhotoSte(elem,ion)+nPhotoDif(elem,ion)+&
                            & collIon+revRate)/&
                            & (NeUsed*alphaTot(elem,ion)&
                            & +chex(elem,ion,1)*grid%Hden(grid%active(xP,yp,zP)) * &
                            & grid%ionDen(cellP,elementXref(1),1))
                    else
                       ionRatio(elem,ion) = (nPhotoSte(elem,ion)+&
                            & collIon+revRate)/&
                            & (NeUsed*alphaTot(elem,ion)&
                            & +chex(elem,ion,1)*grid%Hden(grid%active(xP,yp,zP)) * &
                            & grid%ionDen(cellP,elementXref(1),1))

                    end if
                 end do
              end do

            ! calculate the products of ionRatio
            do elem = 1, nElements
                do ion = 1, min(elem, nstages-1)
                   if (.not.lgElementOn(elem)) exit

                   ! generate the product
                   do i = 1, ion
                       ionProd(elem, ion) = ionProd(elem,ion)*ionRatio(elem, i)

                   end do

                end do
            end do

            ! calculate denominators for final ion abundances
            do elem = 1, nElements
                do ion = 1, min(elem, nstages-1)
                    if (.not.lgElementOn(elem)) exit

                    denominator(elem) = denominator(elem) + ionProd(elem, ion)

               end do
            end do


            ! calculate the new abundances for all ions
            do elem = 1, nElements
                do ion = 1, min(elem+1, nstages)

                    if (.not.lgElementOn(elem)) exit


                    if (ion == 1) then
                        grid%ionDen(cellP,elementXref(elem),ion) = real(1.0/denominator(elem))
                    else

                        grid%ionDen(cellP,elementXref(elem),ion) = &
                             & real(ionProd(elem, ion-1)/denominator(elem))

                   end if

                   ! take back within the limit
                   if (grid%ionDen(cellP,elementXref(elem),ion) > xMax) &
                        & grid%ionDen(cellP,elementXref(elem),ion) = xMax
                   if (grid%ionDen(cellP,elementXref(elem),ion) < 1.e-20) &
                        & grid%ionDen(cellP,elementXref(elem),ion) = 1.e-20


                   ionDenUsed(elementXref(elem), ion) = &
                        & grid%ionDen(cellP,elementXref(elem),ion)
                   ! this was added to help MPI communication
                   ionDenTemp(cellP,elementXref(elem),ion) = &
                        & grid%ionDen(cellP,elementXref(elem),ion)


                end do
            end do

            ! calculate new Ne
          NeUsed = 0.
            do elem = 1, nElements
                do ion = 2, min(elem+1, nstages)
                    if (lgElementOn(elem)) then
                      if( ionDenUsed(elementXref(elem),ion) >= 1.e-10) &
                           & NeUsed = NeUsed + (ion-1)*&
                           &grid%elemAbun(grid%abFileIndex(xP,yP,zP),elem)*&
                           &ionDenUsed(elementXref(elem), ion)
                    end if

                end do
            end do

            NeUsed = NeUsed * grid%Hden(cellP)

            if (NeUsed==0. .and.lgTalk) print*, '! ionBalance [warning]: cell ', xP,yP,zP, &
                 &'; NeUsed = ',  NeUsed

            if (NeUsed == 0.) then
               NeUsed = 1.
            end if

            if (LgNeInput) then
               correction = NeUsed/grid%NeInput(cellP)
               grid%Hden(cellP) = grid%Hden(cellP)/correction
            end if

            ! this was added to help MPI implementation
            NeTemp(cellP) = NeUsed

            grid%Ne(cellP) = NeUsed


            ! calculate the residuals
            deltaHI   = (ionDenUsed(elementXref(1),1) - HIOld)   / HIOld
            deltaHeI  = (ionDenUsed(elementXref(2),1) - HeIOld)  / HeIOld
            deltaHeII = (ionDenUsed(elementXref(2),2) - HeIIOld) / HeIIOld

            ! check for convergence
            if ( ( (abs(deltaHI)>limit) .or. (abs(deltaHeI)>limit) .or. &
                 &(abs(deltaHeII)>limit) ) .and. (nIterateX<maxIterateX) ) then

                ! stepa up X iteration
                nIterateX = nIterateX + 1
                call ionBalance(lgConv)
                return

            else if (( (abs(deltaHI)>limit) .or. (abs(deltaHeI)>limit) .or. &
                 &(abs(deltaHeII)>limit) ) .and. (nIterateX == maxIterateX) ) then

               if (lgTalk)  print*, "! ionBalance: [warning] convergence not reached after ", &
                    &maxIterateX, " steps. Finishing up..."

                lgConv = .false.
            end if

            ! this was added to help MPI implementation
            NeTemp(cellP) = NeUsed

        end subroutine ionBalance

        subroutine calcAlpha()
            implicit none

            real, dimension(nElements, nstages) &
                 &:: diRec  ! total recombination coeffs


            ! zero out alphaTot and contributors
            alphaTot = 0.
            diRec    = 0.

            ! calculate radiative recombination part first
            do elem = 1, nElements
                do ion = 1, min(nstages-1, elem)
                    alphaTot(elem, ion) = radRecFit(elem, elem-ion+1)
                end do
            end do

            call dielectronic(diRec)

            ! calculate dielectronic recombination part
            do elem = 3, nElements
                do ion = 1, min(nstages-1, elem)
                   if (diRec(elem,ion) == 0.) diRec(elem,ion) = diRec(8,ion)
                    alphaTot(elem, ion) = alphaTot(elem, ion) + diRec(elem, ion)
                end do
            end do



       end subroutine calcAlpha


       ! This subroutine calculates rates of radiative recombination for all ions
       ! of all elements from H through Zn by use of the following fits:
       ! H-like, He-like, Li-like, Na-like - Verner & Ferland, 1996, ApJS, 103, 467
       ! Other ions of C, N, O, Ne - Pequignot et al. 1991, A&A, 251, 680,
       ! refitted by Verner & Ferland formula to ensure correct asymptotes
       ! Fe XVII-XXIII - Arnaud & Raymond, 1992, ApJ, 398, 394
       ! Fe I-XV - refitted by Verner & Ferland formula to ensure correct asymptotes
       ! Other ions of Mg, Si, S, Ar, Ca, Fe, Ni -
       !                     - Shull & Van Steenberg, 1982, ApJS, 48, 95
       ! Other ions of Na, Al - Landini & Monsignori Fossi, 1990, A&AS, 82, 229
       ! Other ions of F, P, Cl, K, Ti, Cr, Mn, Co (excluding Ti I-II, Cr I-IV,
       ! Mn I-V, Co I)        - Landini & Monsignori Fossi, 1991, A&AS, 91, 183
       ! All other species    - interpolations of the power-law fits
       !  Input parameters: z - atomic number
       !                    n - number of electrons from 1 to z
       ! Output parameter:  radRecFit  - rate coefficient, cm^3 s^(-1)

       function radRecFit(z, n)
            implicit none

            integer, intent(in)             :: z     ! atomic weight of the element
            integer, intent(in)             :: n     ! number of electrons (from 1 to z)


            real                            :: radRecFit    ! rad rate coeff [cm^3/s]

            ! local variables
            integer                              :: elem    ! element counter
            integer                              :: i       ! counter
            integer                              :: ion     ! ion stage counter
            integer                              :: ios     ! I/O error status


            logical, save                        :: lgFirst = .true.
                                                            ! first time this is evaluated?

            real                                 :: tt      ! temp dep fact in interpolation

            real, dimension(2, nElements, nElements),&      ! coefficients for the
                 & save  :: rrec    ! calculation of the
            real, dimension(4, nElements, nElements),&      ! radiative rates
                 & save  :: rnew    !
            real, dimension(3, 4:13), save         :: fe    !

            ! if this is the first time this procedure is called
            ! read in radiative recombination coefficient file
            ! and the dielectronic recombination data
            if (lgFirst) then
                close(17)
                open (unit=17, file=PREFIX//'/share/mocassin/data/radrec.dat', status='old',position='rewind', iostat = ios, action="read")

                do ion = 4, 30
                    if (ion /= 11) then
                        do elem = ion, 30
                            if ( (elem /= 26) .or. (ion >= 14) ) then
                                read(unit=17, fmt=*, iostat=ios) (rrec(i,elem,ion), i=1,2)
                            end if
                        end do
                    end if
                end do

                do ion = 1, 3
                    do elem = ion, 30
                        read(unit=17, fmt=*, iostat=ios) (rnew(i,elem,ion), i=1,4)
                    end do
                end do

                do elem = 11, 30
                   read(unit=17, fmt=*, iostat=ios) (rnew(i,elem,11), i=1,4)
                end do

                do ion = 4, 10
                    do elem = max(6,ion), 8
                        read(unit=17, fmt=*, iostat=ios) (rnew(i,elem,ion), i=1,4)
                    end do
                    read(unit=17, fmt=*, iostat=ios) (rnew(i,10,ion), i=1,4)
                end do

                do ion = 12, 26
                    read(unit=17, fmt=*, iostat=ios) (rnew(i,26,ion), i=1,4)
                end do

                ! close the files
                close(17)

                ! set data for Fe
                fe(1,:) = (/4.33e-10,3.91e-10,3.49e-10,3.16e-10,&
                     &2.96e-10,2.59e-10,2.24e-10,1.91e-10,1.68e-10,1.46e-10/)
                fe(2,:) = (/0.531,0.523,0.521,0.534, &
                     &0.557,0.567,0.579,0.601,0.602,0.597/)
                fe(3,:) = (/5.77e-02,6.15e-02,6.22e-02,6.02e-02,&
                     &5.79e-02,5.65e-02,5.49e-02,5.10e-02,5.07e-02,5.22e-02/)

                ! set lgFirst to .false.
                lgFirst = .false.
            end if

            ! check right element and number of electron reference
            if ( (z<1) .or. (z>30) ) then
                print*, "! radRecFit: insane atomic number", z
                stop
            end if
            if ( (n<1) .or. (n>z) ) then
                print*, "! radRecFit: insane number of electrons", n
                stop
            end if

            ! calculate the rates
            if ( (n<=3) .or. (n==11) .or. ((z>5) .and. (z<9)) .or. (z==10) .or.&
                 &((z==26) .and. (n>11)) ) then

                tt = sqrt(TeUsed/rnew(3,z,n))
                radRecFit = rnew(1,z,n) / (tt*(tt+1.)**(1.-rnew(2,z,n))*&
                     &(1.+sqrt(TeUsed/rnew(4,z,n)))**(1.+rnew(2,z,n)))
            else
               tt = TeUsed*1.e-4
               if ( (z==26) .and. (n<=13) ) then
                   radRecFit = fe(1,n)/tt**(fe(2,n)+fe(3,n)*log10(tt))
               else
                   radRecFit = rrec(1,z,n)/tt**rrec(2,z,n)
               end if
            end if

        end function radRecFit

        subroutine dielectronic(diRec)
            implicit none

            real, intent(out), dimension(nElements, nstages) :: diRec   ! total recombination coeffs

            ! local variables

            integer                             :: ion
            real                                :: t         ! t = TeUsed/10000., t0,t1 are fitting par
            real                                :: alpha
            real, dimension(nElements, nstages) :: aldroPequi! high T dielec rec coeff by A&P73

            aldroPequi = 0.

            t = TeUsed/10000.

            alpha = 0.
            aldroPequi=0.

            do i = 1, size(direc_coeffs)
               ion = direc_coeffs(i)%elem + 1 - direc_coeffs(i)%n

               if (ion <= nstages) then

                  if (direc_coeffs(i)%g == 0) then
                     diRec(direc_coeffs(i)%elem, ion) = (10.**(-12))*(direc_coeffs(i)%a/t+direc_coeffs(i)%b+direc_coeffs(i)%c*t+direc_coeffs(i)%d*t**2)*t**(-3./2.)*exp(-direc_coeffs(i)%f/t)
                  else if (direc_coeffs(i)%g == 1 .and. TeUsed .lt. 20000.) then
                     diRec(direc_coeffs(i)%elem, ion) = (10.**(-12))*(direc_coeffs(i)%a/t+direc_coeffs(i)%b+direc_coeffs(i)%c*t+direc_coeffs(i)%d*t**2)*t**(-3./2.)*exp(-direc_coeffs(i)%f/t)
                  else if (direc_coeffs(i)%g == 2 .and. TeUsed .ge. 20000.) then
                     diRec(direc_coeffs(i)%elem, ion) = (10.**(-12))*(direc_coeffs(i)%a/t+direc_coeffs(i)%b+direc_coeffs(i)%c*t+direc_coeffs(i)%d*t**2)*t**(-3./2.)*exp(-direc_coeffs(i)%f/t)
                  end if
               end if
            end do

            ! calculate the high temperatures dielectronic recombination coeficients of
            ! Aldrovandi and Pequignot 1973
            t = TeUsed

            do i = 1, size(aldropequi_coeffs)
               ion = aldropequi_coeffs(i)%elem + 1 - aldropequi_coeffs(i)%n
               alpha = aldropequi_coeffs(i)%a*t**(-3./2.)*exp(-aldropequi_coeffs(i)%t0/t)*(1.+aldropequi_coeffs(i)%b*exp(-aldropequi_coeffs(i)%t1/t))
               if (ion <= nstages) aldroPequi(aldropequi_coeffs(i)%elem, ion) = alpha
            end do

            if (TeUsed>60000.) then
               diRec = aldroPequi
            else
               where (direc .eq. 0.)
                 diRec = aldroPequi
               endwhere
            end if

          end subroutine dielectronic

         subroutine getDustT()
            implicit none

            real                   :: dustAbsIntegral   ! dust absorption integral
            real                   :: dabs
            real                   :: resLineHeat       ! resonance line heating
            real, dimension(nbins) :: radField          ! radiation field

            integer :: nS, i, ai ! counters
            integer :: iT        ! pointer to dust temp in dust temp array

            ! radiation field at this location
            if (lgDebug) then
               radField = ((grid%Jste(cellP,:) + grid%Jdif(cellP,:)))/Pi
            else
               radField = grid%Jste(cellP,:)/Pi
            end if

            ! zero out dust temperature arrays
            grid%Tdust(:,:,cellP) = 0.
            if (lgforceTDust) then ! BEKS2010
               grid%Tdust(:,:,cellP) = forceTDust
               return
            endif

            ! calculate absorption integrals for each species
            do nS = 1, nSpeciesPart(nspU)

               do ai = 1, nSizes

                  dustAbsIntegral=0.
                  if (lgTraceHeating.and.taskid==0) dabs=0.

                  do i = 1, nbins
                     dustAbsIntegral = dustAbsIntegral+xSecArray(dustAbsXsecP(nS,ai)+i-1)*radField(i)
                     if (lgTraceHeating.and.taskid==0) then
                        dabs = dabs+xSecArray(dustAbsXsecP(nS,ai)+i-1)*radField(i)
                     end if
                  end do

                  if (lgGas .and. convPercent>=resLinesTransfer .and. (.not.lgResLinesFirst) .and. &
                       & (.not.nIterateMC==1) ) then
                     dustHeatingBudget(grid%abFileIndex(xp,yp,zp),0) = dustHeatingBudget(grid%abFileIndex(xp,yp,zp),0)+&
                          & dustAbsIntegral*grainWeight(ai)*grainAbun(nspU,nS)*grid%Ndust(cellP)
                     dustHeatingBudget(0,0) = dustHeatingBudget(0,0)+&
                          & dustAbsIntegral*grainWeight(ai)*grainAbun(nspU,nS)*grid%Ndust(cellP)
                     resLineHeat = resLineHeating(ai,ns,nspU)
                     dustAbsIntegral = dustAbsIntegral+resLineHeat
                  end if

                  if (lgGas .and. lgPhotoelectric) then
                     dustAbsIntegral = dustAbsIntegral+gasDustColl_d(nS,ai)-&
                          & photoelHeat_d(nS,ai)
                  end if

                  if (lgTraceHeating.and.taskid==0) then
                     write(57,*) 'Dust Species: ', ns, ai
                     write(57,*) 'Abs of cont rad field  ', dabs
                     write(57,*) 'Res Lines Heating: ', reslineheat
                     if (lgGas .and. lgPhotoelectric) then

                        write(57,*) 'Grain potential ', grainPot(ns,ai)
                        write(57,*) 'Gas-dust collision heat', gasDustColl_d(nS,ai)
                        write(57,*) 'Photoelctric cooling: ', photoelHeat_d(nS,ai)
                     end if
                  end if

                  call locate(dustEmIntegral(nS,ai,:), dustAbsIntegral, iT)

                  if (iT<=0 .and. lgTalk) then
                     print*, "getDustT: [warning] temperature of grain = 0. K!!!!"
                     print*, cellP
                     print*, nS, dustAbsIntegral
                     print*, dustEmIntegral(nS,ai,1)
                     !stop
                     iT=1
                     grid%Tdust(nS,ai,cellP) = 1.
                  else if (iT>=nTemps) then
                     grid%Tdust(nS,ai,cellP) = real(nTemps)
                  else
                     grid%Tdust(nS,ai,cellP) = real(iT) + &
                          & (dustAbsIntegral-dustEmIntegral(nS,ai,iT))*&
                          & (real(iT+1)-real(iT))/(dustEmIntegral(nS,ai,iT+1)-&
                          & dustEmIntegral(nS,ai,iT))
                  end if

                  if (lgTraceHeating.and.taskid==0) then
                     write(57,*) 'Radiative cooling: ', dustEmIntegral(ns,ai,iT)
                     write(57,*) 'Grain temperature: ', grid%Tdust(nS,ai,cellP), &
                          & " species ", grainLabel(nS), " size:", grainRadius(ai)

                  end if

                  if (lgTalk) &
                       & print*, "! getDustT: [talk] cell ", xP,yP,zP,"; Grain temperature: "&
                       &, grid%Tdust(nS,ai,cellP), " species ", grainLabel(nS), " size:", grainRadius(ai)

                  ! find weighted mean
                  grid%Tdust(nS,0,cellP) = grid%Tdust(nS,0,cellP)+&
                       & grid%Tdust(nS,ai,cellP)*grainWeight(ai)

               end do

               grid%Tdust(0,0,cellP) = grid%Tdust(0,0,cellP)+&
                    & grid%Tdust(nS,0,cellP)*grainAbun(nspU,nS)

            end do


          end subroutine getDustT

          function resLineHeating(sizeP,speciesP, icompP)
            implicit none

            real                :: resLineHeating ! dust heating due to res lines

            real                :: Gline   ! energy is the line [erg sec^-1]
            real                :: heat    ! sub calculation var

            integer, intent(in) :: sizeP   ! size pointer
            integer, intent(in) :: speciesP! species pointer
            integer, intent(in) :: icompP! dust componenent pointer

            integer             :: iL      ! line counter
            integer             :: imul    ! multiplet counter

            resLineHeating = 0.
            do iL = 1, nResLines

               Gline = 0.
               do imul = 1, resLine(iL)%nmul
                  if (resLine(iL)%elem==1) then

                     if ( resLine(iL)%ion == 1 .and. resLine(iL)%moclow(imul)==1 .and. resLine(iL)%mochigh(imul)==2 ) then

                        ! fits to Storey and Hummer MNRAS 272(1995)41
                        Gline = Gline + 10**(-0.897*log10(TeUsed) + 5.05)*grid%elemAbun(grid%abFileIndex(xP,yP,zP),1)&
                             & *1.e-25*ionDenUsed(elementXref(1),2)*&
                             & NeUsed

                     else

                        print*, "! resLineHeating: [warning] only dust &
                             &heating from H Lyman alpha and resonance lines from heavy"
                        print*, "elements is implemented in this version. please contact author B. Ercolano -1-", &
                             &iL, resLine(iL)%elem, &
                             & resLine(iL)%ion

                     end if

                  else if (resLine(iL)%elem>2) then

                     Gline = Gline+real(forbiddenLines(resLine(iL)%elem,resLine(iL)%ion, &
                          &resline(iL)%moclow(imul), resline(iL)%mochigh(imul)))

                  else

                     print*, "! resLineHeating: [warning] only dust heating from H ",&
                          &"Lyman alpha and resonance lines from heavy"
                     print*, "elements is implemented in this version. please contact author B. Ercolano -2-", &
                          &iL, resLine(iL)%elem, &
                             & resLine(iL)%ion

                  end if


               end do

               Gline=Gline/Pi

               heat = Gline*grid%Hden(cellP)* &
                    & (1.-grid%fEscapeResPhotons(cellP, iL))*&
                    & xSecArray(dustAbsXSecP(speciesP,sizeP)+resLine(iL)%nuP-1)/&
                    & (grid%Ndust(cellP)*&
                    & absOpacSpecies(speciesP,resLine(iL)%nuP))

               ! Harrington Monk and Clegg 1988 (section 3.2)
               resLineHeating = resLineHeating + heat

               dustHeatingBudget(grid%abFileIndex(xP,yP,zP),iL) = &
                    & dustHeatingBudget(grid%abFileIndex(xP,yP,zP),iL) + &
                    & heat*grainWeight(sizeP)*grainAbun(icompP,speciesP)*grid%Ndust(cellP)
               dustHeatingBudget(0,iL) = dustHeatingBudget(0,iL) + &
                    & heat*grainWeight(sizeP)*grainAbun(icompP,speciesP)*grid%Ndust(cellP)


            end do

          end function resLineHeating


        end subroutine updateCell

end module update_mod

! Copyright (C) 2007 Barbara Ercolano
!
! Version 3.00
module fluorescence_mod

    use common_mod
    use constants_mod
    use continuum_mod
    use grid_mod
    use interpolation_mod
    use pathIntegration_mod
    use vector_mod


    type(vector), parameter :: origin=vector(0.,0.,0.)  ! origin of the cartesian grid axes

    integer     , parameter :: safeLim = 10000          ! safety limit for the loops

    contains

      recursive subroutine fluorescencePacketRun(grid, fType, rvec, xP, yP, zP, gP)
        implicit none


        real :: number
        real, save :: ionPhot = 0.

        type(vector), intent(inout)                  :: rVec        !

        integer, dimension(2), intent(inout)              :: xP, yP, &
             & zP                                            ! cartesian axes indeces
        ! 1= mother; 2=sub

        integer, intent(inout)           :: gP               ! grid index
        integer                          :: igpr             ! grid pointer 1= mother 2=sub
        integer                          :: difSourceL(3)    ! cell indeces
        integer                          :: err              ! allocation error status
        integer                          :: i, j             ! counters
        integer                          :: idirP, idirT     ! direction cosines

        type(grid_type), dimension(:), intent(inout) :: grid        ! the grid(s)

        type(photon_packet)              :: fluoPacket         ! the energu packet

        character(len=4), intent(inout)                   :: fType ! what resonance line?


        if (fType == 'diffuse') then
           ! the energy packet has beenid absorbed - reemit a new packet from this position
           call energyPacketRun(ftype, rVec, enPacket%xP(1:2), enPacket%yP(1:2), &
                & enPacket%zP(1:2), gP)
           return
        end if

        if (gP==1) then
           igpr = 1
        else if (gP>1) then
           igpr = 2
        else
           print*,  "! fluorescencePacketRun: insane grid index"
           stop
        end if

        difSourceL(1) = xP(igpr)
        difSourceL(2) = yP(igpr)
        difSourceL(3) = zP(igpr)

        fluoPacket = newFluorescencePacket(chType=fType, gP=gP, difSource=difSourceL, rvec=rvec)

        ! compute the next segment of trajectory
        call fluoPathSegment(fluoPacket)

        return


      contains


        ! this function initializes a photon packet
        function initFluorescencePacket(nuP,  position, lgLine, lgStellar, xP, yP, zP, gP)
          implicit none


          real                     :: random            ! random number
          type(vector), intent(in) :: position          ! the position at which the photon

          integer, intent(in)      :: nuP               ! the frequency of the photon packet
          integer, intent(in),dimension(2) :: xP, yP, &
               & zP                                     ! indeces of position on the x, y and z axes
          integer, intent(in)      :: gP                ! grid index
          integer                  :: igpi              ! grid pointer 1=mother, 2=sub
          integer                  :: i, irepeat        ! counter

          type(photon_packet)      :: initFluorescencePacket  ! the photon packet

          logical, intent(in)      :: lgLine, lgStellar ! line, stellar packet?



          initFluorescencePacket%position = position

          initFluorescencePacket%iG  = gP

          if (gP==1) then
             igpi=1
          else if (gp>1) then
             igpi=2
          else
             print*, "! initFluorescencePacket: insane gridp pointer"
             stop
          end if

          initFluorescencePacket%nuP      = nuP

          initFluorescencePacket%lgStellar = lgStellar

          ! check if photon packen is line or continuum photon
          if ( lgLine ) then
             ! line photon
             initFluorescencePacket%nu       = 0.
             initFluorescencePacket%lgLine   = .true.
          else
             ! continuum photon
             initFluorescencePacket%nu       = nuArray(nuP)
             initFluorescencePacket%lgLine   = .false.
          end if

          initFluorescencePacket%xP  = xP
          initFluorescencePacket%yP  = yP
          initFluorescencePacket%zP  = zP


          ! cater for plane parallel ionization case
          if (initFluorescencePacket%lgStellar .and. lgPlaneIonization) then

             ! get position

             ! x-direction
             call random_number(random)
             random = 1. - random
             initFluorescencePacket%position%x = &
                  & -(grid(gP)%xAxis(2)-grid(gP)%xAxis(1))/2. + random*( &
                  & (grid(gP)%xAxis(2)-grid(gP)%xAxis(1))/2.+&
                  & (grid(gP)%xAxis(grid(gP)%nx)-grid(gP)%xAxis(grid(gP)%nx-1))/2.+&
                  & grid(gP)%xAxis(grid(gP)%nx))
             if (initFluorescencePacket%position%x<grid(gP)%xAxis(1)) &
                  & initFluorescencePacket%position%x=grid(gP)%xAxis(1)
             if (initFluorescencePacket%position%x>grid(gP)%xAxis(grid(gP)%nx)) &
                  initFluorescencePacket%position%x=grid(gP)%xAxis(grid(gP)%nx)

             call locate(grid(gP)%xAxis, initFluorescencePacket%position%x, initFluorescencePacket%xP(igpi))
             if (initFluorescencePacket%xP(igpi) < grid(gP)%nx) then
                if (initFluorescencePacket%position%x >= (grid(gP)%xAxis(initFluorescencePacket%xP(igpi))+&
                     & grid(gP)%xAxis(initFluorescencePacket%xP(igpi)+1))/2.) &
                     & initFluorescencePacket%xP(igpi) = initFluorescencePacket%xP(igpi)+1
             end if

             ! y-direction
             initFluorescencePacket%position%y = 0.
             initFluorescencePacket%yP(igpi) = 1

             ! z-direction
             call random_number(random)
             random = 1. - random
             initFluorescencePacket%position%z = -(grid(gP)%zAxis(2)-grid(gP)%zAxis(1))/2. + random*( &
                  & (grid(gP)%zAxis(2)-grid(gP)%zAxis(1))/2.+&
                  & (grid(gP)%zAxis(grid(gP)%nz)-grid(gP)%zAxis(grid(gP)%nz-1))/2.+&
                  & grid(gP)%zAxis(grid(gP)%nz))
             if (initFluorescencePacket%position%z<grid(gP)%zAxis(1)) &
                  & initFluorescencePacket%position%z=grid(gP)%zAxis(1)
             if (initFluorescencePacket%position%z>grid(gP)%zAxis(grid(gP)%nz)) &
                  & initFluorescencePacket%position%z=grid(gP)%zAxis(grid(gP)%nz)

             call locate(grid(gP)%zAxis, initFluorescencePacket%position%z, initFluorescencePacket%zP(igpi))
             if (initFluorescencePacket%zP(igpi) < grid(gP)%nz) then
                if (initFluorescencePacket%position%z >= (grid(gP)%xAxis(initFluorescencePacket%zP(igpi))+&
                     & grid(gP)%zAxis(initFluorescencePacket%zP(igpi)+1))/2.) initFluorescencePacket%zP(igpi) =&
                     & initFluorescencePacket%zP(igpi)+1
             end if

             if (initFluorescencePacket%xP(igpi)<1) initFluorescencePacket%xP(igpi)=1
             if (initFluorescencePacket%zP(igpi)<1) initFluorescencePacket%zP(igpi)=1

             ! direction is parallel to y-axis direction
             initFluorescencePacket%direction%x = 0.
             initFluorescencePacket%direction%y = 1.
             initFluorescencePacket%direction%z = 0.

             if (initFluorescencePacket%xP(igpi) >  grid(gP)%xAxis(grid(gP)%nx) .or. &
                  & initFluorescencePacket%zP(igpi) >  grid(gP)%zAxis(grid(gP)%nz)) then
                print*, "! initFluorescencePacket: insanity in planeIonisation init"
                print*, igpi, initFluorescencePacket%xP(igpi),  grid(gP)%xAxis(grid(gP)%nx), &
                     & initFluorescencePacket%zP(igpi), grid(gP)%zAxis(grid(gP)%nz),  &
                     &random, initFluorescencePacket%position%z

                stop
             end if

             planeIonDistribution(initFluorescencePacket%xP(igpi),initFluorescencePacket%zP(igpi)) = &
                  & planeIonDistribution(initFluorescencePacket%xP(igpi),initFluorescencePacket%zP(igpi)) + 1

          else

             do irepeat = 1, 1000000
                ! get a random direction
                initFluorescencePacket%direction = randomUnitVector()
                if (initFluorescencePacket%direction%x/=0. .and. &
                     & initFluorescencePacket%direction%y/=0. .and. &
                     & initFluorescencePacket%direction%z/=0.) exit
             end do
          end if

          initFluorescencePacket%origin(1) = gP
          initFluorescencePacket%origin(2) = grid(gP)%active(initFluorescencePacket%xP(igpi),&
               & initFluorescencePacket%yP(igpi), initFluorescencePacket%zP(igpi))

        end function initFluorescencePacket


        ! this function creates a new fluorescence packet
        function newFluorescencePacket(chType, gP, difSource, rvec)

            type(photon_packet)                :: newFluorescencePacket! the photon packet to be created
            type(vector), intent(in)           :: rVec           !
            real                               :: random         ! random number

            type(vector)                       :: positionLoc    ! the position of the photon
                                                                 ! packet
            integer                            :: nuP            ! the frequency index of the photon packet
            integer, dimension(2)              :: orX,orY,orZ    ! dummy
            integer, intent(in)                :: difSource(3)   ! grid and cell indeces
            integer, intent(inout)             :: gP
            integer                            :: igpn           ! grid pointe 1=motehr, 2=sub

            character(len=4), intent(in)       :: chType         ! what line?




            if (gP==1) then
               igpn = 1
            else if (gp>1) then
               igpn = 2
            else
               print*,  "! newFluorescencePacket: insane grid pointer"
               stop
            end if

            positionLoc%x = rVec%x
            positionLoc%y = rVec%y
            positionLoc%z = rVec%z

            ! initialize the new fluorescence packet
            orX(igPn) = difSource(1)
            orY(igPn) = difSource(2)
            orZ(igPn) = difSource(3)

            ! initialize the new fluorescence packet
            if (grid(gP)%active(orX(igpn), orY(igpn), orZ(igpn)) < 0.) then
               print*, "! newFluorescencePacket: new packet cannot be emitted from re-mapped cell -3-"
               print*, "chType, nuP,  .false., .true., orX,orY,orZ, gp"
               print*, chType, nuP,  .false., .true., orX,orY,orZ, gp
               stop
            end if

            select case (chType)
            ! if the photon is stellar
            case ("FeKa")

               newFluorescencePacket = initFluorescencePacket(FeKaColdP, positionLoc, .false., .false., orX,&
                    & orY, orZ, gP)

            case ("FeL1")

               newFluorescencePacket = initFluorescencePacket(FeL1P, positionLoc, .false., .false., orX,&
                    & orY, orZ, gP)
            case ("FeL2")

               newFluorescencePacket = initFluorescencePacket(FeL2P, positionLoc, .false., .false., orX,&
                    & orY, orZ, gP)

            case ("CKa")

               newFluorescencePacket = initFluorescencePacket(CKaP, positionLoc, .false., .false., orX,&
                    & orY, orZ, gP)

            case ("NKa")

               newFluorescencePacket = initFluorescencePacket(NKaP, positionLoc, .false., .false., orX,&
                    & orY, orZ, gP)

            case ("OKa")

               newFluorescencePacket = initFluorescencePacket(OKaP, positionLoc, .false., .false., orX,&
                    & orY, orZ, gP)

            case ("NeKa")

               newFluorescencePacket = initFluorescencePacket(NeKaP, positionLoc, .false., .false., orX,&
                    & orY, orZ, gP)

            case ("MgKa")

               newFluorescencePacket = initFluorescencePacket(MgKaP, positionLoc, .false., .false., orX,&
                    & orY, orZ, gP)

            case ("AlKa")

               newFluorescencePacket = initFluorescencePacket(AlKaP, positionLoc, .false., .false., orX,&
                    & orY, orZ, gP)

            case ("SiKa")

               newFluorescencePacket = initFluorescencePacket(SiKaP, positionLoc, .false., .false., orX,&
                    & orY, orZ, gP)

            case ("SKa")

               newFluorescencePacket = initFluorescencePacket(SKaP, positionLoc, .false., .false., orX,&
                    & orY, orZ, gP)

            case ("ArKa")

               newFluorescencePacket = initFluorescencePacket(ArKaP, positionLoc, .false., .false., orX,&
                    & orY, orZ, gP)

            case ("CaKa")

               newFluorescencePacket = initFluorescencePacket(CaKaP, positionLoc, .false., .false., orX,&
                    & orY, orZ, gP)

            case ("NiKa")

               newFluorescencePacket = initFluorescencePacket(NiKaP, positionLoc, .false., .false., orX,&
                    & orY, orZ, gP)

            ! if the photon packet type is wrong or missing
            case default

                print*, "! newFluorescencePacket: unsupported fluorescent transition.", chType
                stop

             end select

           end function newFluorescencePacket

           subroutine fluoPathSegment(enPacket)
             implicit none


             ! local variables
             type(vector)                    :: vHat     ! direction vector
             type(vector)                    :: rVec     ! position vector

             real                            :: absTau   ! optical depth
             real                            :: dlLoc    ! local displacement
             real                            :: dx, dy, dz
             real                            :: dSx, dSy, dSz
                                                      ! distances from x,y and z wall
             real                            :: dS       ! distance from nearest wall
             real                            :: dV       ! lume of this cell
             real                            :: passProb ! prob of passing the next segment
             real                            :: probSca  ! prob that the packet scatters
             real                            :: radius   ! radius
             real                            :: random   ! random number
             real                            :: tauCell  ! local tau

             integer                         :: idirT,idirP ! direction cosine counters
             integer                         :: i, j, nS ! counter
             integer                         :: xP,yP,zP ! cartesian axes indeces
             integer                         :: gP       ! grid index
             integer                         :: igpp     ! grid index 1=mother 2=sub
             integer                         :: safeLimit =1000 ! safe limit for the loop

             type(photon_packet), intent(inout) :: enPacket ! the energy packet

             character(len=7)                :: packetType ! what line?

             logical                         :: lgScattered ! is the packet scattering with dust?
             logical                         :: lgReturn

             if (enPacket%iG == 1) then
                igpp = 1
             else if (enPacket%iG>1) then
                igpp = 2
             else
                print*, "! fluoPathSegment: insane grid index"
                stop
             end if

             ! check that the input position is not outside the grid
             if ( (enPacket%iG <= 0).or.(enPacket%iG > nGrids) ) then
                print*, "! fluoPathSegment: starting position not in any defined gridhses",&
                     & enPacket
                stop
             else if ( (enPacket%xP(igpp) <= 0).or.&
                  &(enPacket%xP(igpp) > grid(enPacket%iG)%nx) ) then
                print*, "! fluoPathSegment: starting position in x is outside the grid",&
                     & enPacket
                stop
             else if ( (enPacket%yP(igpp) <= 0).or. &
                  & (enPacket%yP(igpp) > grid(enPacket%iG)%ny) ) then
                print*, "! fluoPathSegment: starting position in y is outside the grid",&
                     & enPacket
                stop
             else if ( (enPacket%zP(igpp) <= 0).or.&
                  & (enPacket%zP(igpp) > grid(enPacket%iG)%nz) ) then
                print*, "! fluoPathSegment: starting position in z is outside the grid",&
                     & enPacket
                stop
             end if

             ! define vHat and rVec
             rVec = enPacket%position
             vHat = enPacket%direction

             ! initialize xP, yP,zP
             xP = enPacket%xP(igpp)
             yP = enPacket%yP(igpp)
             zP = enPacket%zP(igpp)
             gP = enPacket%iG

             ! initialise distance from walls
             dSx = 0.
             dSy = 0.
             dSz = 0.

             if (lg1D) then
                radius = 1.e10*sqrt((rVec%x/1.e10)*(rVec%x/1.e10) + &
                     &                               (rVec%y/1.e10)*(rVec%y/1.e10) + &
                     &                               (rVec%z/1.e10)*(rVec%z/1.e10))
                call locate(grid(1)%xAxis, radius, xP)
                if (nGrids > 1 .or. gP >1) then
                   print*, " ! fluorescencePacketRun: multiple grids are not allowed in a 1D simulation"
                   stop
                end if
             end if

             ! initialize optical depth
             absTau = 0.

             ! get a random number
             call random_number(random)

             ! calculate the probability
             passProb = -log(1.-random)

             ! speed up photons that my be trapped
             if (lgPlaneIonization) then
                safeLimit=5000
             else
!             safeLimit=500000
                safeLimit=1000
             end if

             do i = 1, safeLimit

                do j = 1, safeLimit

                   if (xP > grid(gP)%nx .or. xP < 1 .or. &
                        & yP > grid(gP)%ny .or. yP < 1 .or. &
                        & zP > grid(gP)%nz .or. zP < 1 ) then
                      print*, "! fluoPathSegment: insanity [gp,xp,yp,zp,j,i]", &
                           & gp, xp, yp, zp, j, i
                      stop
                   end if

                   if (grid(gP)%active(xP,yP,zP)<0) then

                      ! packet is entering a subgrid
                      enPacket%xP(1) = xP
                      enPacket%yP(1) = yP
                      enPacket%zP(1) = zP

                      gP = abs(grid(gP)%active(xP,yP,zP))

                      ! where is the packet in the sub-grid?

                      call locate(grid(gP)%xAxis, rVec%x, xP)
                      if (xP==0) xP = xP+1
                      if (xP< grid(gP)%nx) then
                         if (rVec%x >  (grid(gP)%xAxis(xP+1)+grid(gP)%xAxis(xP))/2.) &
                              & xP = xP + 1
                      end if

                      call locate(grid(gP)%yAxis, rVec%y, yP)
                      if (yP==0) yP=yP+1
                      if (yP< grid(gP)%ny) then
                         if (rVec%y >  (grid(gP)%yAxis(yP+1)+grid(gP)%yAxis(yP))/2.) &
                              & yP = yP + 1
                      end if

                      call locate(grid(gP)%zAxis, rVec%z, zP)
                      if (zP==0) zP=zP+1
                      if (zP< grid(gP)%nz) then
                         if (rVec%z >  (grid(gP)%zAxis(zP+1)+grid(gP)%zAxis(zP))/2.) &
                              & zP = zP + 1
                      end if

                   end if

                   enPacket%iG = gP
                   igpp = 2

                   ! find distances from all walls

                   if (lgSymmetricXYZ) then
                      if ( rVec%x <= grid(1)%xAxis(1) ) then
                         if (vHat%x<0.) vHat%x = -vHat%x
                         rVec%x = grid(1)%xAxis(1)
                      end if
                      if ( rVec%y <= grid(1)%yAxis(1) ) then
                         if (vHat%y<0.) vHat%y = -vHat%y
                         rVec%y = grid(1)%yAxis(1)
                      end if
                      if ( rVec%z <= grid(1)%zAxis(1) ) then
                         if (vHat%z<0.) vHat%z = -vHat%z
                         rVec%z = grid(1)%zAxis(1)
                      end if
                   end if

                   if (vHat%x>0.) then
                      if (xP<grid(gP)%nx) then

                         dSx = ( (grid(gP)%xAxis(xP+1)+grid(gP)%xAxis(xP))/2.-rVec%x)/vHat%x

                         if (abs(dSx)<1.e-10) then
                            rVec%x=(grid(gP)%xAxis(xP+1)+grid(gP)%xAxis(xP))/2.
                            xP = xP+1
                         end if
                      else
                         dSx = ( grid(gP)%xAxis(grid(gP)%nx)-rVec%x)/vHat%x
                         if (abs(dSx)<1.e-10) then
                            rVec%x=grid(gP)%xAxis(grid(gP)%nx)
                            if (.not.lgPlaneIonization .and. gP==1) return
                         end if
                      end if
                   else if (vHat%x<0.) then
                      if (xP>1) then
                         dSx = ( (grid(gP)%xAxis(xP)+grid(gP)%xAxis(xP-1))/2.-rVec%x)/vHat%x
                         if (abs(dSx)<1.e-10) then
                            rVec%x=(grid(gP)%xAxis(xP)+grid(gP)%xAxis(xP-1))/2.
                            xP = xP-1
                         end if
                      else
                         dSx = (grid(gP)%xAxis(1)-rVec%x)/vHat%x
                         if (abs(dSx)<1.e-10) then
                            rVec%x=grid(gP)%xAxis(1)
                         end if
                      end if
                   else if (vHat%x==0.) then
                      dSx = grid(gP)%xAxis(grid(gP)%nx)
                   end if

                   if (.not.lg1D) then
                      if (vHat%y>0.) then
                         if (yP<grid(gP)%ny) then
                            dSy = ( (grid(gP)%yAxis(yP+1)+grid(gP)%yAxis(yP))/2.-rVec%y)/vHat%y
                            if (abs(dSy)<1.e-10) then
                               rVec%y=(grid(gP)%yAxis(yP+1)+grid(gP)%yAxis(yP))/2.
                               yP = yP+1
                            end if
                         else
                            dSy = (  grid(gP)%yAxis(grid(gP)%ny)-rVec%y)/vHat%y
                            if (abs(dSy)<1.e-10) then
                               rVec%y=grid(gP)%yAxis(grid(gP)%ny)
                               if(gP==1) return
                            end if
                         end if
                      else if (vHat%y<0.) then
                         if (yP>1) then
                            dSy = ( (grid(gP)%yAxis(yP)+grid(gP)%yAxis(yP-1))/2.-rVec%y)/vHat%y
                            if (abs(dSy)<1.e-10) then
                               rVec%y=(grid(gP)%yAxis(yP)+grid(gP)%yAxis(yP-1))/2.
                               yP = yP-1
                            end if
                         else
                            dSy = ( grid(gP)%yAxis(1)-rVec%y)/vHat%y
                            if (abs(dSy)<1.e-10) then
                               rVec%y=grid(gP)%yAxis(1)
                            end if
                         end if
                      else if (vHat%y==0.) then
                         dSy = grid(gP)%yAxis(grid(gP)%ny)
                      end if

                      if (vHat%z>0.) then
                         if (zP<grid(gP)%nz) then
                            dSz = ( (grid(gP)%zAxis(zP+1)+grid(gP)%zAxis(zP))/2.-rVec%z)/vHat%z
                            if (abs(dSz)<1.e-10) then
                               rVec%z=(grid(gP)%zAxis(zP+1)+grid(gP)%zAxis(zP))/2.
                               zP = zP+1
                            end if
                         else
                            dSz = ( grid(gP)%zAxis(grid(gP)%nz)-rVec%z)/vHat%z
                            if (abs(dSz)<1.e-10) then
                               rVec%z=grid(gP)%zAxis(grid(gP)%nz)
                               if (.not.lgPlaneIonization .and. gP==1) return
                            end if
                         end if
                      else if (vHat%z<0.) then
                         if (zP>1) then
                            dSz = ( (grid(gP)%zAxis(zP)+grid(gP)%zAxis(zP-1))/2.-rVec%z)/vHat%z
                            if (abs(dSz)<1.e-10) then
                               rVec%z=(grid(gP)%zAxis(zP)+grid(gP)%zAxis(zP-1))/2.
                               zP = zP-1
                            end if
                         else
                            dSz = ( grid(gP)%zAxis(1)-rVec%z)/vHat%z
                            if (abs(dSz)<1.e-10) then
                               rVec%z=grid(gP)%zAxis(1)
                            end if
                         end if
                      else if (vHat%z==0.) then
                         dSz = grid(gP)%zAxis(grid(gP)%nz)
                      end if

                      if (xP > grid(gP)%nx .or. xP < 1 .or. &
                           & yP > grid(gP)%ny .or. yP < 1 .or. &
                           & zP > grid(gP)%nz .or. zP < 1 ) then
                         print*, "! fluoPathSegment: insanity -2- [gp,xp,yp,zp]", &
                              & gp, xp, yp, zp
                         stop
                      end if

                   end if

                   if (grid(gP)%active(xP,yP,zP)>=0) exit
                end do

                ! cater for cells on cell wall
                if ( abs(dSx)<1.e-10 ) dSx = grid(gP)%xAxis(grid(gP)%nx)
                if ( abs(dSy)<1.e-10 ) dSy = grid(gP)%yAxis(grid(gP)%ny)
                if ( abs(dSz)<1.e-10 ) dSz = grid(gP)%zAxis(grid(gP)%nz)

                ! find the nearest wall
                dSx = abs(dSx)
                dSy = abs(dSy)
                dSz = abs(dSz)

                if (dSx<=0.) then
                   print*, '! fluoPathSegment: [warning] dSx <= 0.',dSx
                   print*, 'grid(gP)%xAxis ', grid(gP)%xAxis
                   print*, 'gP,xP,grid(gP)%xAxis(xP), rVec%x, vHat%x'
                   print*, gP,xP,grid(gP)%xAxis(xP), rVec%x, vHat%x
                   dS = min(dSy, dSz)
                else if (dSy<=0.) then
                   print*, '! fluoPathSegment: [warning] dSy <= 0.', dSy
                   print*, 'grid(gP)%yAxis ', grid(gP)%yAxis
                   print*, 'gP,yP,grid(gP)%yAxis(yP), rVec%y, vHat%y'
                   print*, gP,yP,grid(gP)%yAxis(yP), rVec%y, vHat%y
                   dS = min(dSx, dSz)
                else if (dSz<=0.) then
                   print*, '! fluoPathSegment: [warning] dSz <= 0.', dSz
                   print*, 'grid(gP)%zAxis ', grid(gP)%zAxis
                   print*, 'gP,zP,grid(gP)%zAxis(zP), rVec%z, vHat%z'
                   print*, gP,zP,grid(gP)%zAxis(zP), rVec%z, vHat%z
                   dS = min(dSx, dSy)
                else
                   dS = min(dSx,dSy)
                   dS = min(dS, dSz)
                end if

                ! this should now never ever happen
                if (dS <= 0.) then
                   print*, 'fluoPathSegment: dS <= 0', dSx, dSy, dSz
                   print*, gP, rVec
                   stop
                end if

                ! calculate the optical depth to the next cell wall
                tauCell = dS*grid(gP)%opacity(grid(gP)%active(xP,yP,zP), enPacket%nuP)

                if (lg1D) then
                   if (nGrids>1) then
                      print*, '! getVolumeLoc: 1D option and multiple grids options are not compatible'
                      stop
                   end if

                   if (xP == 1) then

                      dV = 4.*Pi* ( (grid(gP)%xAxis(xP+1)/1.e15)**3)/3.


                   else if ( xP==grid(gP)%nx) then

                      dV = Pi* ( (3.*(grid(gP)%xAxis(xP)/1.e15)-(grid(gP)%xAxis(xP-1)/1.e15))**3 - &
                           & ((grid(gP)%xAxis(xP)/1.e15)+(grid(gP)%xAxis(xP-1)/1.e15))**3 ) / 6.

                   else

                      dV = Pi* ( ((grid(gP)%xAxis(xP+1)/1.e15)+(grid(gP)%xAxis(xP)/1.e15))**3 - &
                           & ((grid(gP)%xAxis(xP-1)/1.e15)+(grid(gP)%xAxis(xP)/1.e15))**3 ) / 6.

                   end if

                   dV = dV/8.

                else

                   if ( (xP>1) .and. (xP<grid(gP)%nx) ) then

                      dx = abs(grid(gP)%xAxis(xP+1)-grid(gP)%xAxis(xP-1))/2.
                   else if ( xP==1 ) then
                      if (lgSymmetricXYZ) then
                         dx = abs(grid(gP)%xAxis(xP+1)-grid(gP)%xAxis(xP))/2.
                      else
                         dx = abs(grid(gP)%xAxis(xP+1)-grid(gP)%xAxis(xP))
                      end if
                   else if ( xP==grid(gP)%nx ) then
                      dx = abs(grid(gP)%xAxis(xP)  -grid(gP)%xAxis(xP-1))
                   end if

                   if ( (yP>1) .and. (yP<grid(gP)%ny) ) then
                      dy = abs(grid(gP)%yAxis(yP+1)-grid(gP)%yAxis(yP-1))/2.
                   else if ( yP==1 ) then
                      if (lgSymmetricXYZ) then
                         dy = abs(grid(gP)%yAxis(yP+1)-grid(gP)%yAxis(yP))/2.
                      else
                         dy = abs(grid(gP)%yAxis(yP+1)-grid(gP)%yAxis(yP))
                      end if
                   else if ( yP==grid(gP)%ny ) then
                      dy = abs(grid(gP)%yAxis(yP)  -grid(gP)%yAxis(yP-1))
                   end if

                   if ( (zP>1) .and. (zP<grid(gP)%nz) ) then
                      dz = abs(grid(gP)%zAxis(zP+1)-grid(gP)%zAxis(zP-1))/2.
                   else if ( zP==1 ) then
                      if (lgSymmetricXYZ) then
                         dz = abs(grid(gP)%zAxis(zP+1)-grid(gP)%zAxis(zP))/2.
                      else
                         dz = abs(grid(gP)%zAxis(zP+1)-grid(gP)%zAxis(zP))
                      end if
                   else if ( zP==grid(gP)%nz ) then
                      dz = abs(grid(gP)%zAxis(zP)-grid(gP)%zAxis(zP-1))
                   end if

                   dx = dx/1.e15
                   dy = dy/1.e15
                   dz = dz/1.e15


                   ! calculate the volume
                   dV = dx*dy*dz

                end if

                ! check if the packet interacts within this cell
                if ((absTau+tauCell > passProb) .and. (grid(gP)%active(xP,yP,zP)>0)) then

                   ! packet interacts

                   ! calculate where within this cell the packet interacts
                   dlLoc = (passProb-absTau)/grid(gP)%opacity(grid(gP)%active(xP,yP,zP), enPacket%nuP)

                   ! update packet's position
                   rVec = rVec + dlLoc*vHat

                   if (lgSymmetricXYZ .and. gP==1) then
                      if ( rVec%x <= grid(gP)%xAxis(1) ) then
                         if (vHat%x<0.) vHat%x = -vHat%x
                         rVec%x = grid(gP)%xAxis(1)
                      end if
                      if ( rVec%y <= grid(gP)%yAxis(1) ) then
                         if (vHat%y<0.) vHat%y = -vHat%y
                         rVec%y = grid(gP)%yAxis(1)
                      end if
                      if ( rVec%z <= grid(gP)%zAxis(1) ) then
                         if (vHat%z<0.) vHat%z = -vHat%z
                         rVec%z = grid(gP)%zAxis(1)
                      end if
                   end if

                   ! add contribution of the packet to the radiation field
                   if (enPacket%lgStellar) then
                      grid(gP)%Jste(grid(gP)%active(xP,yP,zP),enPacket%nuP) = &
                           grid(gP)%Jste(grid(gP)%active(xP,yP,zP),enPacket%nuP) + dlLoc*deltaEUsed / dV
                   else ! if the energy packet is diffuse
                      if (lgDebug) then
                         grid(gP)%Jdif(grid(gP)%active(xP,yP,zP),enPacket%nuP) = &
                              & grid(gP)%Jdif(grid(gP)%active(xP,yP,zP),enPacket%nuP) + dlLoc*deltaEUsed / dV
                      else
                         grid(gP)%Jste(grid(gP)%active(xP,yP,zP),enPacket%nuP) = &
                              & grid(gP)%Jste(grid(gP)%active(xP,yP,zP),enPacket%nuP) + dlLoc*deltaEUsed / dV
                      end if
                   end if

                   ! check if the position within the cell is still within the outer radius
                   if ( sqrt( (rvec%x/1.e10)**2 + (rvec%y/1.e10)**2 + (rvec%z/1.e10)**2)*1.e10 >= R_out &
                        & .and. R_out > 0.) then

                      ! the packet escapes without further interaction
                      idirT = int(acos(enPacket%direction%z)/dTheta)+1
                      if (idirT>totangleBinsTheta) then
                         idirT=totangleBinsTheta
                      end if
                      if (idirT<1 .or. idirT>totAngleBinsTheta) then
                         print*, '! fluorescencePacketRun: error in theta direction cosine assignment',&
                              &  idirT, enPacket, dTheta, totAngleBinsTheta
                         stop
                      end if

                      if (enPacket%direction%x<1.e-35) then
                         idirP = 0
                      else
                         idirP = int(atan(enPacket%direction%y/enPacket%direction%x)/dPhi)
                      end if
                      if (idirP<0) idirP=totAngleBinsPhi+idirP
                      idirP=idirP+1
                      if (idirP>totangleBinsPhi) then
                         idirP=totangleBinsPhi
                      end if

                      if (idirP<1 .or. idirP>totAngleBinsPhi) then
                         print*, '! fluorescencePacketRun: error in Phi direction cosine assignment',&
                              &  idirP, enPacket, dPhi, totAngleBinsPhi
                         stop
                      end if

                      if (nAngleBins>0) then
                         if (viewPointPtheta(idirT) == viewPointPphi(idirP).or. &
                              & (viewPointTheta(viewPointPphi(idirP))==viewPointTheta(viewPointPtheta(idirT))) .or. &
                              & (viewPointPhi(viewPointPtheta(idirT))==viewPointPhi(viewPointPphi(idirP))) ) then
                            grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), enPacket%nuP,viewPointPtheta(idirT)) = &
                                 &grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                 & enPacket%nuP,viewPointPtheta(idirT)) +  deltaEUsed
                            if (viewPointPtheta(idirT)/=0) grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                 & enPacket%nuP,0) = &
                                 & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                 & enPacket%nuP,0) +  deltaEUsed
                         else
                            grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                 & enPacket%nuP,0) = &
                                 & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                 & enPacket%nuP,0) +  deltaEUsed
                         end if
                      else

                         grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                              & enPacket%nuP,0) = &
                              & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                              & enPacket%nuP,0) +  deltaEUsed

                      end if

                      return
                   end if


                   ! check if the packet is absorbed or scattered
                   ! NOTE : we are ignoring dust
                   probSca = KNsigmaT(enPacket%nuP)*&
                        &grid(gP)%Ne(grid(gP)%active(xp,yp,zp))/&
                        & (grid(gp)%opacity(grid(gp)%active(xp,yp,zp),&
                        &enPacket%nuP))

                   call random_number(random)

                   random = 1.-random

                   if (random > probSca) then
                      lgScattered = .false.
                   else if (random <= probSca) then
                      lgScattered = .true.
                   else
                      print*, '! fluoPathSegment: insanity occurred and scattering/absorption &
                           & decision stage.'
                      stop
                   end if

                   if (.not. lgScattered) then

                      absInt = absInt + 1.
                      exit

                   else

                      scaInt = scaInt + 1.
                      ! packet is compton scattered
                      ! calculate new direction
                      ! for now assume scattering is isotropic, when phase
                      ! function is introduced the following must be changed

                      enPacket%xP(igpp) = xP
                      enPacket%yP(igpp) = yP
                      enPacket%zP(igpp) = zP

                      if (grid(gP)%active(enPacket%xp(igpp), enPacket%yp(igpp), enPacket%zp(igpp)) < 0.) then
                         print*, "! fluoPathSegment: new packet cannot be emitted from re-mapped cell -1-"
                         print*, "nuP, .false., .true., xp,yp,zp, gp"
                         print*, nuP, .false., .true.,  xp,yp,zp, gp
                         stop
                      end if

                      call comptonScatter(enPacket)

                      vHat%x = enPacket%direction%x
                      vHat%y = enPacket%direction%y
                      vHat%z = enPacket%direction%z

                      ! initialize optical depth
                      absTau = 0.

                      ! get a random number
                      call random_number(random)

                      ! calculate the probability
                      passProb = -log(1.-random)

                   end if

                else

                   ! the packet is not absorbed within this cell
                   ! add contribution of the packet to the radiation field

                   if (enPacket%lgStellar) then
                      grid(gP)%Jste(grid(gP)%active(xP,yP,zP),enPacket%nuP) = &
                           grid(gP)%Jste(grid(gP)%active(xP,yP,zP),enPacket%nuP) + dS*deltaEUsed / dV
                   else ! if the energy packet is diffuse
                      if (lgDebug) then
                         grid(gP)%Jdif(grid(gP)%active(xP,yP,zP),enPacket%nuP) = &
                              & grid(gP)%Jdif(grid(gP)%active(xP,yP,zP),enPacket%nuP) + dS*deltaEUsed / dV
                      else
                         grid(gP)%Jste(grid(gP)%active(xP,yP,zP),enPacket%nuP) = &
                              & grid(gP)%Jste(grid(gP)%active(xP,yP,zP),enPacket%nuP) + dS*deltaEUsed / dV
                      end if
                   end if

                   ! update absTau
                   absTau = absTau+tauCell

                   ! update packet's position
                   rVec = rVec+dS*vHat

                   ! keep track of where you are on mother grid
                   if (gP>1) then

                      if (enPacket%xP(1) <= 0 .or. &
                           & enPacket%yP(1) <= 0 .or. &
                           & enPacket%zP(1) <= 0 ) then

                         ! locate where we are at on the mother grid
                         call locate(grid(grid(gP)%motherP)%xAxis, rvec%x, enPacket%xP(1))
                         if ( enPacket%xP(1)< grid(grid(gP)%motherP)%nx) then
                            if ( rvec%x > ( grid(grid(gP)%motherP)%xAxis(enPacket%xP(1)) + &
                                 & grid(grid(gP)%motherP)%xAxis(enPacket%xP(1)+1)/2.) ) &
                                 & enPacket%xP(1) = enPacket%xP(1)+1
                         end if

                         call locate( grid(grid(gP)%motherP)%yAxis, rvec%y, enPacket%yP(1))
                         if ( enPacket%yP(1)< grid(grid(gP)%motherP)%ny) then
                            if ( rvec%y > ( grid(grid(gP)%motherP)%yAxis(enPacket%yP(1)) + &
                                 & grid(grid(gP)%motherP)%yAxis(enPacket%yP(1)+1)/2.) ) &
                                 & enPacket%yP(1) = enPacket%yP(1)+1
                         end if

                         call locate(grid(grid(gP)%motherP)%zAxis, rvec%z, enPacket%zP(1))
                         if ( enPacket%zP(1)< grid(grid(gP)%motherP)%nz) then
                            if ( rvec%z > ( grid(grid(gP)%motherP)%zAxis(enPacket%zP(1)) + &
                                 & grid(grid(gP)%motherP)%zAxis(enPacket%zP(1)+1)/2.) ) &
                                 & enPacket%zP(1) = enPacket%zP(1)+1
                         end if


                      else

                         if (vHat%x>0.) then
                            if ( enPacket%xP(1) < grid(grid(gP)%motherP)%nx ) then
                               if ( rVec%x > (grid(grid(gP)%motherP)%xAxis(enPacket%xP(1))+&
                                    & grid(grid(gP)%motherP)%xAxis(enPacket%xP(1)+1))/2. ) then
                                  enPacket%xP(1) = enPacket%xP(1)+1
                               end if
                            else
                               if ( rVec%x > grid(grid(gP)%motherP)%xAxis(enPacket%xP(1))) then
!                            print*, '! fluoPathSegment: insanity occurred at mother grid transfer (x axis +)', &
!                                 & rVec%x, gP, grid(gP)%motherP
!                            stop
                               end if
                            end if
                         else
                            if ( enPacket%xP(1) > 1 ) then
                               if ( rVec%x <= (grid(grid(gP)%motherP)%xAxis(enPacket%xP(1)-1)+&
                                    & grid(grid(gP)%motherP)%xAxis(enPacket%xP(1)))/2. ) then
                                  enPacket%xP(1) = enPacket%xP(1)-1
                               end if
                            else
                               if (rVec%x < grid(grid(gP)%motherP)%xAxis(1)) then
!                            print*, '! fluoPathSegment: insanity occurred at mother grid transfer (x axis-)',&
!                                 & rVec%x, gP, grid(gP)%motherP
!                            stop
                               end if
                            end if
                         end if
                         if (vHat%y>0.) then
                            if (  enPacket%yP(1) < grid(grid(gP)%motherP)%ny ) then
                               if ( rVec%y > (grid(grid(gP)%motherP)%yAxis( enPacket%yP(1))+&
                                    & grid(grid(gP)%motherP)%yAxis(enPacket%yP(1)+1))/2. ) then
                                  enPacket%yP(1) =  enPacket%yP(1)+1
                               end if
                            else
                               if ( rVec%y > grid(grid(gP)%motherP)%yAxis( enPacket%yP(1))) then
!                            print*, '! fluoPathSegment: insanity occurred at mother grid transfer (y axis +)',&
!                                 & rVec%y, gP, grid(gP)%motherP
!                            stop
                               end if
                            end if
                         else
                            if (  enPacket%yP(1) > 1 ) then
                               if ( rVec%y <= (grid(grid(gP)%motherP)%yAxis( enPacket%yP(1)-1)+&
                                    & grid(grid(gP)%motherP)%yAxis(enPacket%yP(1)))/2. ) then
                                  enPacket%yP(1) =  enPacket%yP(1)-1
                               end if
                            else
                               if (rVec%y < grid(grid(gP)%motherP)%yAxis(1)) then
!                            print*, '! fluoPathSegment: insanity occurred at mother grid transfer (y axis -)', &
!                                 & rVec%y, gP, grid(gP)%motherP
!                            stop
                               end if
                            end if
                         end if
                         if (vHat%z>0.) then
                            if (  enPacket%zP(1) < grid(grid(gP)%motherP)%nz ) then
                               if ( rVec%z > (grid(grid(gP)%motherP)%zAxis( enPacket%zP(1))+&
                                    & grid(grid(gP)%motherP)%zAxis(enPacket%zP(1)+1))/2. ) then
                                  enPacket%zP(1) =  enPacket%zP(1)+1
                               end if
                            else
                               if ( rVec%z > grid(grid(gP)%motherP)%zAxis( enPacket%zP(1))) then
!                            print*, '! fluoPathSegment: insanity occurred at mother grid transfer (z axis +)', &
!                                 & rVec%z, gP, grid(gP)%motherP
!                            stop
                               end if
                            end if
                         else
                            if (  enPacket%zP(1) > 1 ) then
                               if ( rVec%z <= (grid(grid(gP)%motherP)%zAxis( enPacket%zP(1)-1)+&
                                    & grid(grid(gP)%motherP)%zAxis(enPacket%zP(1)))/2. ) then
                                  enPacket%zP(1) =  enPacket%zP(1)-1
                               end if
                            else
                               if (rVec%z < grid(grid(gP)%motherP)%zAxis(1)) then
!                        print*, '! fluoPathSegment: insanity occurred at mother grid transfer (z axis -)', &
!                             & rVec%z, gP, grid(gP)%motherP
!                        stop
                               end if
                            end if
                         end if

                      end if
                   end if

                   if (.not.lg1D) then
                      if ( (dS == dSx) .and. (vHat%x > 0.)  ) then
                         xP = xP+1
                      else if ( (dS == dSx) .and. (vHat%x < 0.) ) then
                         xP = xP-1
                      else if ( (dS == dSy) .and. (vHat%y > 0.) ) then
                         yP = yP+1
                      else if ( (dS == dSy) .and. (vHat%y < 0.) ) then
                         yP = yP-1
                      else if ( (dS == dSz) .and. (vHat%z > 0.) ) then
                         zP = zP+1
                      else if ( (dS == dSz) .and. (vHat%z < 0.) ) then
                         zP = zP-1
                      else
                         print*, '! fluoPathSegment: insanity occurred in dS assignment &
                              & [dS,dSx,dSy,dSz,vHat]', dS,dSx,dSy,dSz,vHat
                      end if
                   else
                      radius = 1.e10*sqrt((rVec%x/1.e10)*(rVec%x/1.e10) + &
                           & (rVec%y/1.e10)*(rVec%y/1.e10) + &
                           & (rVec%z/1.e10)*(rVec%z/1.e10))
                      call locate(grid(gP)%xAxis, radius , xP)

                   end if

                   ! be 6/6/06
                   if(.not.lgPlaneIonization.and..not.lgSymmetricXYZ) then
                      lgReturn=.false.

                      if ( rVec%y <= grid(gP)%yAxis(1)-grid(gP)%geoCorrY .or. yP<1) then

                         ! the energy packet escapes this grid
                         if (gP==1) then
                            yP=1
                            lgReturn=.true.
                         else if (gP>1) then
                            xP = enPacket%xP(grid(gP)%motherP)
                            yP = enPacket%yP(grid(gP)%motherP)
                            zP = enPacket%zP(grid(gP)%motherP)
                            gP = grid(gP)%motherP
                         else
                            print*, '! fluoPathSegment: insanity occurred - invalid gP', gP
                            stop
                         end if

                      end if

                      if (rVec%y > grid(gP)%yAxis(grid(gP)%ny)+grid(gP)%geoCorrY .or. yP>grid(gP)%ny) then

                         if (gP==1) then
                            ! the energy packet escapes
                            yP = grid(gP)%ny
                            lgReturn=.true.
                         else if (gP>1) then
                            xP = enPacket%xP(grid(gP)%motherP)
                            yP =  enPacket%yP(grid(gP)%motherP)
                            zP =  enPacket%zP(grid(gP)%motherP)
                            gP = grid(gP)%motherP
                         else
                            print*, '! fluoPathSegment: insanity occurred - invalid gP', gP
                            stop
                         end if

                      end if

                      if ( (rVec%x <= grid(gP)%xAxis(1)-grid(gP)%geoCorrX .or. xP<1) .and. gP==1) then
                         xP=1
                         lgReturn=.true.
                      end if


                      if ( (rVec%x <= grid(gP)%xAxis(1)-grid(gP)%geoCorrX .or. xP<1) &
                           & .and. gP>1) then

                         xP = enPacket%xP(grid(gP)%motherP)
                         yP =  enPacket%yP(grid(gP)%motherP)
                         zP =  enPacket%zP(grid(gP)%motherP)
                         gP = grid(gP)%motherP

                      end if


                      if ( (rVec%x >=  grid(gP)%xAxis(grid(gP)%nx)+grid(gP)%geoCorrX &
                           & .or. xP>grid(gP)%nx) .and. gP==1 )then
                         xP = grid(gP)%nx
                         lgReturn=.true.
                      end if

                      if ( (rVec%x >=  grid(gP)%xAxis(grid(gP)%nx)+grid(gP)%geoCorrX&
                           & .or. xP>grid(gP)%nx) .and.  gP>1) then

                         xP = enPacket%xP(grid(gP)%motherP)
                         yP =  enPacket%yP(grid(gP)%motherP)
                         zP =  enPacket%zP(grid(gP)%motherP)
                         gP = grid(gP)%motherP

                      end if

                      if ( (rVec%z <= grid(gP)%zAxis(1)-grid(gP)%geoCorrZ .or.zP<1) &
                           & .and. gP==1) then
                         zP=1
                         lgReturn=.true.

                     end if

                     if ( (rVec%z <= grid(gP)%zAxis(1)-grid(gP)%geoCorrZ &
                          & .or.zP<1) .and. gP>1) then

                        xP = enPacket%xP(grid(gP)%motherP)
                        yP =  enPacket%yP(grid(gP)%motherP)
                        zP =  enPacket%zP(grid(gP)%motherP)
                        gP = grid(gP)%motherP

                     end if

                     if ( (rVec%z >=  grid(gP)%zAxis(grid(gP)%nz)+grid(gP)%geoCorrZ &
                          & .or. zP>grid(gP)%nz) &
                          & .and. gP==1) then

                        zP = grid(gP)%nz
                        lgReturn=.true.

                     end if

                     if ((rVec%z >=  grid(gP)%zAxis(grid(gP)%nz)+grid(gP)%geoCorrZ &
                          & .or. zP>grid(gP)%nz) .and. gP>1) then

                        xP = enPacket%xP(grid(gP)%motherP)
                        yP =  enPacket%yP(grid(gP)%motherP)
                        zP =  enPacket%zP(grid(gP)%motherP)
                        gP = grid(gP)%motherP

                     end if

                     if (lgReturn) then

                        ! the packet escapes without further interaction
                        idirT = int(acos(enPacket%direction%z)/dTheta)+1
                        if (idirT>totangleBinsTheta) then
                           idirT=totangleBinsTheta
                        end if
                        if (idirT<1 .or. idirT>totAngleBinsTheta) then
                           print*, '! fluorescencePacketRun: error in theta direction cosine assignment',&
                                &  idirT, enPacket, dTheta, totAngleBinsTheta
                           stop
                        end if


                        if (enPacket%direction%x<1.e-35) then
                           idirP = 0
                        else
                           idirP = int(atan(enPacket%direction%y/enPacket%direction%x)/dPhi)
                        end if
                        if (idirP<0) idirP=totAngleBinsPhi+idirP
                        idirP=idirP+1

                        if (idirP>totangleBinsPhi) then
                           idirP=totangleBinsPhi
                        end if
                        if (idirP<1 .or. idirP>totAngleBinsPhi) then
                           print*, '! fluorescencePacketRun: error in phi direction cosine assignment',&
                                &  idirP, enPacket, dPhi, totAngleBinsPhi
                           stop
                        end if


                        if (nAngleBins>0) then
                           if (viewPointPtheta(idirT) == viewPointPphi(idirP).or. &
                                & (viewPointTheta(viewPointPphi(idirP))==viewPointTheta(viewPointPtheta(idirT))) .or. &
                                & (viewPointPhi(viewPointPtheta(idirT))==viewPointPhi(viewPointPphi(idirP))) ) then
                              grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), enPacket%nuP,&
                                   & viewPointPtheta(idirT)) =grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2),&
                                   & enPacket%nuP,viewPointPtheta(idirT)) +  deltaEUsed

                              if (viewPointPtheta(idirT)/=0) grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                   &enPacket%nuP,0) = &
                                   & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                   & enPacket%nuP,0) +  deltaEUsed

                           else
                              grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                   & enPacket%nuP,0) = &
                                   & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                   & enPacket%nuP,0) +  deltaEUsed

                           end if

                        else

                           grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                enPacket%nuP,0) = &
                                & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                & enPacket%nuP,0) +  deltaEUsed
                        end if

                        return
                     end if

                  end if

                  ! end be 6/6/06


                  if(lgPlaneIonization) then
                     lgReturn=.false.

                     if ( rVec%y <= grid(gP)%yAxis(1)-grid(gP)%geoCorrY .or. yP<1) then

                        ! the energy packet escapes this grid
                        if (gP==1) then
                           yP=1
                           lgReturn=.true.
                        else if (gP>1) then
                           xP = enPacket%xP(1)
                           yP = enPacket%yP(1)
                           zP = enPacket%zP(1)
                           gP = 1
                           igpp = 1
                        else
                           print*, '! fluoPathSegment: insanity occurred - invalid gP', gP
                           stop
                        end if

                     end if

                     if (rVec%y > grid(gP)%yAxis(grid(gP)%ny)+grid(gP)%geoCorrY .or. yP>grid(gP)%ny) then

                        if (gP==1) then
                           ! the energy packet escapes
                           yP = grid(gP)%ny
                           lgReturn=.true.
                        else if (gP>1) then
                           xP = enPacket%xP(1)
                           yP = enPacket%yP(1)
                           zP = enPacket%zP(1)
                           gP = 1
                           igpp = 1
                        else
                           print*, '! fluoPathSegment: insanity occurred - invalid gP', gP
                           stop
                        end if

                     end if

                     if ( (rVec%x <= grid(1)%xAxis(1) .or. xP<1) ) then
                        xP=1
                        rVec%x = grid(gP)%xAxis(1)
                        vHat%x = -vHat%x

                     end if

                     if ( (rVec%x <= grid(gP)%xAxis(1)-grid(gP)%geoCorrX .or. xP<1) &
                          & .and. gP>1) then

                        xP = enPacket%xP(1)
                        yP = enPacket%yP(1)
                        zP = enPacket%zP(1)
                        gP = 1
                        igpp = 1

                     end if

                     if ( (rVec%x >=  grid(1)%xAxis(grid(gP)%nx) &
                          & .or. xP>grid(gP)%nx)  )then
                        xP = grid(gP)%nx
                        rVec%x = grid(gP)%xAxis(grid(gP)%nx)
                        vHat%x = -vHat%x

                     end if

                     if ( (rVec%x >=  grid(gP)%xAxis(grid(gP)%nx)+grid(gP)%geoCorrX&
                          & .or. xP>grid(gP)%nx) .and.  gP>1) then

                        xP = enPacket%xP(1)
                        yP = enPacket%yP(1)
                        zP = enPacket%zP(1)
                        gP = 1
                        igpp = 1
                     end if

                     if ( (rVec%z <= grid(1)%zAxis(1) .or.zP<1) ) then
                        zP=1
                        rVec%z = grid(gP)%yAxis(1)
                        vHat%z = -vHat%z

                     end if

                     if ( (rVec%z <= grid(gP)%zAxis(1)-grid(gP)%geoCorrZ &
                          & .or.zP<1) .and. gP>1) then

                        xP = enPacket%xP(1)
                        yP = enPacket%yP(1)
                        zP = enPacket%zP(1)
                        gP = 1
                        igpp = 1

                     end if

                     if ( (rVec%z >=  grid(1)%zAxis(grid(gP)%nz) .or. zP>grid(gP)%nz) &
                          & ) then

                        zP = grid(gP)%nz
                        rVec%z = grid(gP)%zAxis(grid(gP)%nz)
                        vHat%z = -vHat%z

                     end if

                     if ((rVec%z >=  grid(gP)%zAxis(grid(gP)%nz)+grid(gP)%geoCorrZ &
                          & .or. zP>grid(gP)%nz) .and. gP>1) then

                        xP = enPacket%xP(1)
                        yP = enPacket%yP(1)
                        zP = enPacket%zP(1)
                        gP = 1
                        igpp = 1

                     end if


                     if (lgReturn) then

                        ! the packet escapes without further interaction

                        idirT = int(acos(enPacket%direction%z)/dTheta)+1
                        if (idirT>totangleBinsTheta) then
                           idirT=totangleBinsTheta
                        end if
                        if (idirT<1 .or. idirT>totAngleBinsTheta) then
                           print*, '! energyPacketRun: error in theta direction cosine assignment',&
                                &  idirT, enPacket, dTheta, totAngleBinsTheta
                           stop
                        end if


                        if (enPacket%direction%x<1.e-35) then
                           idirP = 0
                        else
                           idirP = int(atan(enPacket%direction%y/enPacket%direction%x)/dPhi)
                        end if
                        if (idirP<0) idirP=totAngleBinsPhi+idirP
                        idirP=idirP+1

                        if (idirP>totangleBinsPhi) then
                           idirP=totangleBinsPhi
                        end if
                        if (idirP<1 .or. idirP>totAngleBinsPhi) then
                           print*, '! energyPacketRun: error in phi direction cosine assignment',&
                                &  idirP, enPacket, dPhi, totAngleBinsPhi
                           stop
                        end if


                        if (nAngleBins>0) then
                           if (viewPointPtheta(idirT) == viewPointPphi(idirP).or. &
                                & (viewPointTheta(viewPointPphi(idirP))==viewPointTheta(viewPointPtheta(idirT))) .or. &
                                & (viewPointPhi(viewPointPtheta(idirT))==viewPointPhi(viewPointPphi(idirP))) ) then
                              grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), enPacket%nuP,viewPointPtheta(idirT)) = &
                                   &grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                   & enPacket%nuP,viewPointPtheta(idirT)) +  deltaEUsed
                              if (viewPointPtheta(idirT)/=0) grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                   enPacket%nuP,0) = &
                                   & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                   & enPacket%nuP,0) +  deltaEUsed

                           else
                              grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                enPacket%nuP,0) = &
                                & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                & enPacket%nuP,0) +  deltaEUsed

                           end if

                        else

                           grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                enPacket%nuP,0) = &
                                & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                & enPacket%nuP,0) +  deltaEUsed

                        end if

                        return
                     end if

                  end if

                  ! check if the path is still within the simulation region
                  radius = 1.e10*sqrt((rVec%x/1.e10)*(rVec%x/1.e10) + &
                       &                     (rVec%y/1.e10)*(rVec%y/1.e10) + &
                       &                     (rVec%z/1.e10)*(rVec%z/1.e10))

                  if (.not.lgPlaneIonization) then

                     if ( (.not.lgSymmetricXYZ .and. (rVec%x<=grid(1)%xAxis(1)-grid(1)%geoCorrX .or.&
                          & rVec%y<=grid(1)%yAxis(1)-grid(1)%geoCorrY .or. rVec%z<=grid(1)%zAxis(1)-&
                          & grid(1)%geoCorrZ)) .or.&
                          & (rVec%x >= grid(gP)%xAxis(grid(gP)%nx)+grid(gP)%geoCorrX) .or.&
                          &(rVec%y >= grid(gP)%yAxis(grid(gP)%ny)+grid(gP)%geoCorrY) .or.&
                          &(rVec%z >= grid(gP)%zAxis(grid(gP)%nz)+grid(gP)%geoCorrZ) .or. &
                          & xP>grid(gP)%nx .or. yP>grid(gP)%ny .or. zP>grid(gP)%nz ) then

                        if (gP==1) then

                           if (enPacket%xP(1) > grid(1)%nx) xP = grid(1)%nx
                           if (enPacket%yP(1) > grid(1)%ny) yP = grid(1)%ny
                           if (enPacket%zP(1) > grid(1)%nz) zP = grid(1)%nz
                           if (enPacket%xP(1) < 1) xP = 1
                           if (enPacket%yP(1) < 1) yP = 1
                           if (enPacket%zP(1) < 1) zP = 1


                           ! the energy packet escapes

                           ! the packet escapes without further interaction
                           idirT = int(acos(enPacket%direction%z)/dTheta)+1
                           if (idirT>totangleBinsTheta) then
                              idirT=totangleBinsTheta
                           end if
                           if (idirT<1 .or. idirT>totAngleBinsTheta) then
                              print*, '! energyPacketRun: error in theta direction cosine assignment',&
                                   &  idirT, enPacket, dTheta, totAngleBinsTheta
                              stop
                           end if

                           if (enPacket%direction%x<1.e-35) then
                              idirP = 0
                           else
                              idirP = int(atan(enPacket%direction%y/enPacket%direction%x)/dPhi)
                           end if
                           if (idirP<0) idirP=totAngleBinsPhi+idirP
                           idirP=idirP+1

                           if (idirP>totangleBinsPhi) then
                              idirP=totangleBinsPhi
                           end if

                           if (idirP<1 .or. idirP>totAngleBinsPhi) then
                              print*, '! energyPacketRun: error in phi direction cosine assignment',&
                                   &  idirP, enPacket, dPhi, totAngleBinsPhi
                              stop
                           end if

                           if (nAngleBins>0) then
                              if (viewPointPtheta(idirT) == viewPointPphi(idirP).or. &
                                   & (viewPointTheta(viewPointPphi(idirP))==viewPointTheta(viewPointPtheta(idirT))) .or. &
                                   & (viewPointPhi(viewPointPtheta(idirT))==viewPointPhi(viewPointPphi(idirP))) ) then
                                 grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), enPacket%nuP,&
                                      & viewPointPtheta(idirT)) = &
                                      &grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                      & enPacket%nuP,viewPointPtheta(idirT)) +  deltaEUsed
                                 if (viewPointPtheta(idirT)/=0) grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                      enPacket%nuP,0) = &
                                      & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                      & enPacket%nuP,0) +  deltaEUsed
                              else
                                 grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                      enPacket%nuP,0) = &
                                      & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                      & enPacket%nuP,0) +  deltaEUsed
                              end if
                           else

                              grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                   enPacket%nuP,0) = &
                                   & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                   & enPacket%nuP,0) +  deltaEUsed

                           end if

                           !b2.005
                           return

                        else if (gP>1) then

                           xP = enPacket%xP(1)
                           yP = enPacket%yP(1)
                           zP = enPacket%zP(1)
                           gP = 1
                           igpp = 1


                           if (gP/=1) then
                              print*, '! fluoPathSegment: nested multigrids still not implemented'
                              stop
                           end if

                           if ( (radius >= R_out .and. R_out >= 0.) .or.&
                                & (rVec%x >= grid(1)%xAxis(grid(1)%nx)+grid(1)%geoCorrX) .or.&
                                &(rVec%y >= grid(1)%yAxis(grid(1)%ny)+grid(1)%geoCorrY) .or.&
                                &(rVec%z >= grid(1)%zAxis(grid(1)%nz)+grid(1)%geoCorrZ) .or. &
                                & (.not.lgSymmetricXYZ .and.  (rVec%x<=grid(1)%xAxis(1)-grid(1)%geoCorrX .or.&
                                & rVec%y<=grid(1)%yAxis(1)-grid(1)%geoCorrY .or. rVec%z<=grid(1)%zAxis(1)-&
                                & grid(1)%geoCorrZ))) then

                              if (xP > grid(gP)%nx) xP = grid(gP)%nx
                              if (yP > grid(gP)%ny) yP = grid(gP)%ny
                              if (zP > grid(gP)%nz) zP = grid(gP)%nz

                              if (xP < 1) xP = 1
                              if (yP < 1) yP = 1
                              if (zP < 1) zP = 1

                              ! the energy packet escapes

                              ! the packet escapes without further interaction

                              idirT = int(acos(enPacket%direction%z)/dTheta)+1
                              if (idirT>totangleBinsTheta) then
                                 idirT=totangleBinsTheta
                              end if
                              if (idirT<1 .or. idirT>totAngleBinsTheta) then
                                 print*, '! energyPacketRun: error in theta direction cosine assignment',&
                                      &  idirT, enPacket, dTheta, totAngleBinsTheta
                                 stop
                              end if

                              if (enPacket%direction%x<1.e-35) then
                                 idirP = 0
                              else
                                 idirP = int(atan(enPacket%direction%y/enPacket%direction%x)/dPhi)
                              end if
                              if (idirP<0) idirP=totAngleBinsPhi+idirP
                              idirP=idirP+1

                              if (idirP>totangleBinsPhi) then
                                 idirP=totangleBinsPhi
                              end if

                              if (idirP<1 .or. idirP>totAngleBinsPhi) then
                                 print*, '! energyPacketRun: error in phi direction cosine assignment',&
                                      &  idirP, enPacket, dPhi, totAngleBinsPhi
                                 stop
                              end if

                              if (nAngleBins>0) then
                                 if (viewPointPtheta(idirT) == viewPointPphi(idirP).or. &
                                      &(viewPointTheta(viewPointPphi(idirP))==viewPointTheta(viewPointPtheta(idirT))).or. &
                                      & (viewPointPhi(viewPointPtheta(idirT))==viewPointPhi(viewPointPphi(idirP))) ) then
                                    grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), enPacket%nuP,&
                                         & viewPointPtheta(idirT)) = &
                                         &grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                         & enPacket%nuP,viewPointPtheta(idirT)) +  deltaEUsed
                                    if (viewPointPtheta(idirT)/=0) grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                         enPacket%nuP,0) = &
                                         & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                         & enPacket%nuP,0) +  deltaEUsed
                                 else
                                    grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                         enPacket%nuP,0) = &
                                         & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                         & enPacket%nuP,0) +  deltaEUsed
                                 end if
                              else

                                 grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                      enPacket%nuP,0) = &
                                      & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                                      & enPacket%nuP,0) +  deltaEUsed

                              end if

                              !b2.005
                              return

                           end if
                        else
                           print*, '! fluoPathSegment: insanity occurred - invalid gP - ', gP
                           stop
                        end if

                     end if

                     if (lgSymmetricXYZ ) then
                         if (lgPlaneIonization) then
                            print*, '! fluoPathSegment: lgSymmetric and lgPlaneionization flags both raised'
                            stop
                         end if

                         if ( rVec%x <= grid(1)%xAxis(1) .or. (gP==1 .and. xP<1)) then
                            if (vHat%x<0.) vHat%x = -vHat%x
                            enPacket%xP(1) = 1
                            xP = 1
                            rVec%x = grid(gP)%xAxis(1)
                         end if
                         if ( rVec%y <= grid(1)%yAxis(1) .or. (gP==1 .and. yP<1)) then
                            if (vHat%y<0.) vHat%y = -vHat%y
                            enPacket%yP(1)=1
                            yP = 1
                            rVec%y = grid(gP)%yAxis(1)
                         end if
                         if ( rVec%z <= grid(1)%zAxis(1) .or. (gP==1 .and. zP<1)) then
                            if (vHat%z<0.) vHat%z = -vHat%z
                            enPacket%zP(1) = 1
                            zP=1
                            rVec%z = grid(1)%zAxis(1)
                         end if

                      end if

                   end if

                   if (gP>1) then
                      if ( ( (rVec%x <= grid(gP)%xAxis(1) &
                           &.or. xP<1) .and. vHat%x <=0.) .or. &
                           & ( (rVec%y <= grid(gP)%yAxis(1) &
                           & .or. yP<1) .and. vHat%y <=0.) .or. &
                           & ( (rVec%z <= grid(gP)%zAxis(1) &
                           &  .or. zP<1) .and. vHat%z <=0.) .or. &
                           & ( (rVec%x >= grid(gP)%xAxis(grid(gP)%nx) &
                           &.or. xP>grid(gP)%nx) .and. vHat%x >=0.) .or. &
                           & ( (rVec%y >= grid(gP)%yAxis(grid(gP)%ny) &
                           & .or. yP>grid(gP)%ny) .and. vHat%y >=0.) .or. &
                           & ( (rVec%z >= grid(gP)%zAxis(grid(gP)%nz) &
                           &  .or. zP>grid(gP)%nz) .and. vHat%z >=0.) ) then

                         ! go back to mother grid
                         xP = enPacket%xP(1)
                         yP = enPacket%yP(1)
                         zP = enPacket%zP(1)
                         gP = 1
                         igpp = 1

                      end if

                   end if

               end if

               if (.not. lgPlaneIonization .and. gP==1 .and. (xP > grid(gP)%nx  &
                    & .or. yP > grid(gP)%ny .or. zP > grid(gP)%nz) ) then

           ! the energy packet escapes

           ! the packet escapes without further interaction

           idirT = int(acos(enPacket%direction%z)/dTheta)+1
           if (idirT>totangleBinsTheta) then
              idirT=totangleBinsTheta
           end if
           if (idirT<1 .or. idirT>totAngleBinsTheta) then
              print*, '! energyPacketRun: error in theta direction cosine assignment',&
                   &  idirT, enPacket, dTheta, totAngleBinsTheta
              stop
           end if

           if (enPacket%direction%x<1.e-35) then
              idirP = 0
           else
              idirP = int(atan(enPacket%direction%y/enPacket%direction%x)/dPhi)
           end if
           if (idirP<0) idirP=totAngleBinsPhi+idirP
           idirP=idirP+1

           if (idirP>totangleBinsPhi) then
              idirP=totangleBinsPhi
           end if

           if (idirP<1 .or. idirP>totAngleBinsPhi) then
              print*, '! energyPacketRun: error in phi direction cosine assignment',&
                   &  idirP, enPacket, dPhi, totAngleBinsPhi
              stop
           end if

           if (nAngleBins>0) then
              if (viewPointPtheta(idirT) == viewPointPphi(idirP).or. &
                   & (viewPointTheta(viewPointPphi(idirP))==viewPointTheta(viewPointPtheta(idirT))) .or. &
                   & (viewPointPhi(viewPointPtheta(idirT))==viewPointPhi(viewPointPphi(idirP))) ) then
                 grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), enPacket%nuP,&
                      & viewPointPtheta(idirT)) = &
                      &grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                   & enPacket%nuP,viewPointPtheta(idirT)) +  deltaEUsed
                 if (viewPointPtheta(idirT)/=0) grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                      enPacket%nuP,0) = &
                      & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                      & enPacket%nuP,0) +  deltaEUsed
              else
                 grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                      enPacket%nuP,0) = &
                      & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                      & enPacket%nuP,0) +  deltaEUsed
              end if
           else

              grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                   enPacket%nuP,0) = &
                   & grid(enPacket%origin(1))%escapedPackets(enPacket%origin(2), &
                   & enPacket%nuP,0) +  deltaEUsed

           end if

           !b2.005
            return


         end if

      end do ! safelimit loop

      if (i>= safeLimit) then
         if (.not.lgPlaneIonization) then
            print*, '! fluoPathSegment: [warning] packet trajectory has exceeded&
                 &  maximum number of events', safeLimit, gP, xP,yP,zP, grid(gP)%active(xP,yP,zP), &
              & rvec, vhat, enPacket
         end if
         return

      end if

      if (gP==1) then
         igpp = 1
      else if (gP>1) then
         igpp = 2
      else
         print*, "! fluoPathSegment: insane grid index "
         stop
      end if

      enPacket%xP(igpp) = xP
      enPacket%yP(igpp) = yP
      enPacket%zP(igpp) = zP

      packetType = 'diffuse'

      ! the energy packet has beenid absorbed - reemit a new packet from this position
      call fluorescencePacketRun(grid, packetType, rvec, enPacket%xP(1:2), enPacket%yP(1:2), &
           & enPacket%zP(1:2), gP)

      return

 end subroutine fluoPathSegment

 ! determine energy and direction for compton redistribution of fluorescent lines
 subroutine comptonScatter(fPacket)
   implicit none


   real                              :: newNu,newTheta     ! new energy and theta
   real                              :: random             ! random number
   real                              :: u,v,w,t            ! direction units
   type(photon_packet),intent(inout) :: fPacket            ! the fluorescent packet

   integer                           :: newNuP,newThetaP   ! pointer to new energy and theta

   ! calculate new direction
   call getNu2(KNsigmaArray(fPacket%nuP,1:180),newThetaP)
   newTheta = real(newThetaP)*Pi/180.

   ! calculate u,v,w (Harries & Howarth, 1997)
   call random_number(random)
   w = 2.*random - 1.
   t = sqrt(1-w*w)
   u = t*cos(newTheta)
   v = t*sin(newTheta)

   fPacket%direction%x = u
   fPacket%direction%y = v
   fPacket%direction%z = w

   ! calculate new energy
   newNu = fPacket%nu*PcompArray(fPacket%nuP,newThetaP)

   ! find this in the nuArray
   call locate(nuArray,newNu,newNuP)

   fPacket%Nu  = newNu
   fPacket%NuP = newNuP

 end subroutine comptonScatter

 ! this subroutine determines the index in the PDFs
 ! same as getNu2
 subroutine getNu2(probDen, nuP)

   real, dimension(:), intent(in) :: probDen    ! probability density function

   real                           :: random     ! random number

   integer, intent(out)           :: nuP        ! frequency index of the new

   integer                        :: isearch,i  !

   ! get a random number
   call random_number(random)

   do i = 1, 10000
      if (random==0 .or. random==1.) then
         call random_number(random)
      else
         exit
      end if
   end do
   if (i>=10000) then
      print*, '! getNu2: problem with random number generator', random, i
      stop
   end if

   ! see what frequency random corresponds to
   nuP=1
   do isearch = 1, nbins
      if (random>=probDen(isearch)) then
         nuP=isearch
      else
         exit
      end if
   end do

   if (nuP>=nbins) then
      print*, 'random: ', random
      print*, 'probDen: ', probDen
   end if

 end subroutine getNu2

end subroutine fluorescencePacketRun


end module fluorescence_mod

! Copyright (C) 2005 Barbara Ercolano
!! Version 2.02
module output_mod
    use common_mod
    use constants_mod
    use emission_mod
    use photon_mod

    contains


      subroutine outputGas(grid, extMap)
        implicit none

        type(grid_type), intent(inout) :: grid(*) ! the 3D grid

        character(len=30), optional, intent(in) :: extMap

        ! local variables

        logical                     :: lgInSlit !is this cell within the slit?

        integer                     :: i,j,k,l,iG, &     ! counters
             & iup,ilow,iLine,elem,ion,iCount,iAb,iRes
        integer                     :: nrec              ! counter for rec lines
        integer                     :: abFileUsed
        integer                     :: cellPUsed
        integer                     :: ios               ! I/O error status
        integer                     :: err, imul
        integer                     :: totLinePackets    ! total number of line packets
        integer                     :: totEscapedPackets ! total number of esc packets
        integer                     :: ypLoc


        real, allocatable               :: cMap(:)           ! local c-value
        real, allocatable               :: flam(:)           ! f(lambda) value from file

        real                        :: dV       ! volume of this cell
        real                        :: factor1  ! calculations factor
        real                        :: factor2  ! calculations factor
        real                        :: g        ! alpha*h*nu (used to calculate line intensities)
        real, allocatable               :: HbetaLuminosity(:) ! MC Hbeta luminosity [E36 erg/sec]
        real, allocatable               :: HbetaVol(:) ! analytical Hbeta vol em  [E36  erg/sec]
        real                        :: LtotAn   ! HbetaVol * sumAn
        real                        :: LtotMC   ! HbetaLuminosity * sumMC
        real                        :: sumAn    ! sum of the relative an intensities
        real                        :: sumMC    ! sum of the relative MC intensities
        real                        :: Te10000  ! TeUsed/10000.miser_qinfo -A
        real, parameter             :: hcryd = 2.1799153e-11!
        real                        :: radius, dz, dr

        ! lexingotn
        !        real, allocatable :: denominatorIon(:,:,:) ! denominator for IonVol calculations

        ! Harrington 1982
        real, allocatable ::  denominatorIon(:,:)           ! denominator for IonVol calculations
        real, allocatable :: denominatorTe(:,:,:)           ! denominator for TeVol calculations

        real, dimension(nLines)             :: &
             &                                       linePacketsUsed ! linePackets at this cell
        real, dimension(nElements) ::  elemAbundanceUsed  ! local abundances
        real, allocatable         :: resLinesVol(:,:)    ! resonance lines volume emission
        real, allocatable         :: resLinesVolCorr(:,:)! resonance lines volume emissivity corrected
        real, allocatable         :: HIVol(:,:,:)        ! analytical HI rec lines volume emissivity
        real, allocatable         :: HeIVol(:,:)        ! analytical HeI  volume emissivity
        real, allocatable         :: HeIIVol(:,:,:)      ! analytical HeII rec lines volume emissivity
        real, allocatable         :: ionDenVol(:,:,:)    ! volume av ion abun per H+ particle
        real, allocatable         :: lineLuminosity(:,:) ! MC luminosity in a given line

        double precision, dimension(nElements,nstages,nForLevels,nForLevels) :: wav
        double precision, dimension(nForLevelsLarge,nForLevelsLarge) :: wavLarge
        real, allocatable         :: forbVol(:,:,:,:,:)  ! analytical forbidden lines volume emissivit
        real, allocatable         :: forbVolLarge(:,:,:)  ! analytical forbidden lines volume emissivity
        real, allocatable         :: TeVol(:,:,:)      ! mean Temperature for a given ion

        ! recombination lines stuff (1=Oii, 2=mgii,3=neii,4=cii,5=n33ii,6=n34ii)

        real(kind=8), allocatable          :: RecLinesFlux(:,:,:)    ! 1st is ion num, 2nd is emissivity
        real(kind=8), dimension(500)   :: recLambdaOII           ! lambda in angstrom
        real(kind=8), dimension(500)   :: recLambdaMgII
        real(kind=8), dimension(500)   :: recLambdaNeII
        real(kind=8), dimension(500)   :: recLambdaCII
        real(kind=8), dimension(500)   :: recLambdaN33II      !   3-3, Kisielius & Storey 2002
        real(kind=8), dimension(500)   :: recLambdaN34II      !   3d-4f, Escalante & Victor 1990

        real(kind=8), dimension(500) :: recFlux               ! local rec lines fluxes from subroutine
        real(kind=8), dimension(500) :: recLinesLambda        ! local rec lines wavelengths from subroutine

        real                         :: denIon=0.


        print*, "in outputGas"

        ! allocate and initialize arrays and variables


        if (convPercent >= resLinesTransfer .and. lgDust) then
           allocate(resLinesVol(0:nAbComponents, 1:nResLines), stat=err)
           if (err /= 0) then
              print*, "! output mod: can't allocate array resLinesVol memory"
              stop
           end if
           resLinesVol = 0.
           allocate(resLinesVolCorr(0:nAbComponents, 1:nResLines), stat=err)
           if (err /= 0) then
              print*, "! output mod: can't allocate array resLinesVolCorr memory"
              stop
           end if
           resLinesVolCorr = 0.
        end if
        allocate(HIVol(0:nAbComponents, 3:30, 2:8), stat=err)
        if (err /= 0) then
           print*, "! output mod: can't allocate array HIVol memory"
           stop
        end if
        allocate(HeIVol(0:nAbComponents, 1:34), stat=err)
        if (err /= 0) then
           print*, "! output mod: can't allocate array HeIVol memory"
           stop
        end if
        allocate(HeIIVol(0:nAbComponents, 3:30, 2:16), stat=err)
        if (err /= 0) then
           print*, "! output mod: can't allocate array HeIIVol memory"
           stop
        end if
        allocate(ionDenVol(0:nAbComponents, 1:nElements, 1:nstages), stat=err)
        if (err /= 0) then
           print*, "! output mod: can't allocate array ionDenVol memory"
           stop
        end if
        allocate(forbVol(0:nAbComponents, 1:nElements, 1:nstages, nForLevels,nForLevels), stat=err)
        if (err /= 0) then
           print*, "! output mod: can't allocate array forbVol memory"
           stop
        end if
        allocate(forbVolLarge(0:nAbComponents, nForLevelsLarge,nForLevelsLarge), stat=err)
        if (err /= 0) then
           print*, "! output mod: can't allocate array forbVol memory"
           stop
        end if
        allocate(TeVol(0:nAbComponents, 1:nElements, 1:nstages), stat=err)
        if (err /= 0) then
           print*, "! output mod: can't allocate array TeVol memory"
           stop
        end if
        allocate(recLinesFlux(0:nAbComponents, 1:6, 1:500), stat=err)
        if (err /= 0) then
           print*, "! output mod: can't allocate array recLinesFlux memory"
           stop
        end if
        ! Lexington
        !        allocate(denominatorIon(0:nAbComponents, 1:nElements, 1:nstages), stat=err)
        !        if (err /= 0) then
        !           print*, "! output mod: can't allocate array denominatorIon memory"
        !           stop
        !        end if
        ! Harrington
        allocate(denominatorIon(0:nAbComponents, 1:nElements), stat=err)
        if (err /= 0) then
           print*, "! output mod: can't allocate array denominatorIon memory"
           stop
        end if
        allocate(denominatorTe(0:nAbComponents, 1:nElements, 1:nstages), stat=err)
        if (err /= 0) then
           print*, "! output mod: can't allocate array denominatorTe memory"
           stop
        end if
        allocate(HbetaVol(0:nAbComponents), stat=err)
        if (err /= 0) then
           print*, "! output mod: can't allocate array HbetaVol memory"
           stop
        end if

        if (lgDebug) then
           allocate(lineLuminosity(0:nAbComponents, 1:nLines), stat=err)
           if (err /= 0) then
              print*, "! output mod: can't allocate array lineLuminosity memory"
              stop
           end if
           allocate(HbetaLuminosity(0:nAbComponents), stat=err)
           if (err /= 0) then
              print*, "! output mod: can't allocate array HbetaVol memory"
              stop
           end if
           HbetaLuminosity = 0.
           lineLuminosity  = 0.
        end if


        denominatorIon  = 0.
        denominatorTe   = 0.
        g               = 0.
        HbetaVol        = 0.
        HIVol           = 0.
        HeIVol         = 0.
        HeIIVol         = 0.
        elemAbundanceUsed = 0.
        ionDenUsed      = 0.
        ionDenVol       = 0.
        LtotAn          = 0.
        LtotMC          = 0.
        wav             = 0.
        wavLarge        = 0.
        forbVol         = 0.
        forbVolLarge    = 0.
        recLinesLambda  = 0.
        recLambdaOII    = 0.
        recLambdaMgII   = 0.
        recLambdaNeII   = 0.
        recLambdaCII    = 0.
        recLambdan33II  = 0.
        recLambdan34II  = 0.
        recLinesFlux    = 0.
        sumAn           = 0.
        sumMC           = 0.
        TeVol           = 0.
        totLinePackets  = 0
        totEscapedPackets=0

        if (present(extMap)) then

           if (ngrids>1) then
              print*, '! outputGas: no multiple grids are allowed with extinction maps (yet)'
              print*, 'if this is needed please contact B. Ercolano'
              stop
           end if

           allocate(cMap(0:grid(iG)%nCells), stat=err)
           if (err /= 0) then
              print*, "! output mod: can't allocate array c memory"
              stop
           end if

           cMap=0.

           open(unit=19, status='old', position='rewind', file=extMap,  action="read",iostat=ios)
           if (ios /= 0) then
              print*, "! outputGas: can't open file for reading, ", extMap
              stop
           end if

           do i = 1, grid(1)%nx
              do j = 1, grid(1)%ny
                 do k = 1, grid(1)%nz
                    if (grid(1)%active(i,j,k)>0) then
                       read(19, *) l,l,l, cMap(grid(1)%active(i,j,k))
                    else
                       read(19, *)
                    end if
                 end do
              end do
           end do

           close(19)

           open(unit=20, status='old', position='rewind', file=PREFIX//'/share/mocassin/data/flambda.dat',  action="read",iostat=ios)
           if (ios /= 0) then
              print*, "! outputGas: can't open file for reading, ",PREFIX,"/share/mocassin/data/flambda.dat"
              stop
           end if

           read(20,*) l

           allocate(flam(1:l), stat=err)
           if (err /= 0) then
              print*, "! output mod: can't allocate array flam memory"
              stop
           end if

           flam = 0.

           do i = 1, l
              read(20, *) flam(i)
           end do

           close(20)

        end if

        ! read in data file for higher level H transitions
        call hdatx

        ! calculate analytical emissivities first

        ! sum over all cells
        do iG = 1, nGrids

           if (lg2D) then
              yPloc = 1
           else
              yPloc = grid(iG)%ny
           end if


           outer: do i = 1, grid(iG)%nx
              do j = 1, yploc
                 do k = 1, grid(iG)%nz

!print*, i, j,k
                    ! temporary arrangement
                    if (lg1D ) then
                       if (grid(iG)%ionDen(grid(iG)%active(i,j,k),elementXref(1),1) > 0.95) then
                          print*, 'R_out = ', grid(iG)%xAxis(i-1), ' (',i-1,')'
                          exit outer
                       end if
                    end if

                    ! slit condition
                    if (dxSlit > 0. .and. dySlit > 0.) then
                       if ( (abs(grid(iG)%xAxis(i))<=dxSlit/2.) .and. &
                            (abs(grid(iG)%yAxis(i))<=dySlit/2.) ) then
                          lgInSlit = .true.
                       else
                          lgInSlit = .false.
                       end if
                    else
                       lgInSlit = .true.
                    end if
!print*, grid(iG)%active(i, j, k)
                    ! check this cell is in the ionized region
                    if ((grid(iG)%active(i, j, k)>0)) then
                       if (grid(iG)%lgBlack(grid(iG)%active(i,j,k))<1 .and. lgInSlit ) then

                       ! find the physical properties of this cell
                       cellPUsed       = grid(iG)%active(i,j,k)
                       abFileUsed      = grid(iG)%abFileIndex(i,j,k)
                       elemAbundanceUsed(:) = grid(iG)%elemAbun(grid(iG)%abFileIndex(i,j,k), :)
                       HdenUsed        = grid(iG)%Hden(grid(iG)%active(i,j,k))
                       ionDenUsed      = grid(iG)%ionDen(grid(iG)%active(i,j,k), :, :)
                       if (lgDebug) linePacketsUsed = grid(iG)%linePackets(grid(iG)%active(i,j,k), :)
                       NeUsed          = grid(iG)%Ne(grid(iG)%active(i,j,k))
                       TeUsed          = grid(iG)%Te(grid(iG)%active(i,j,k))
                       Te10000         = TeUsed/10000.
                       log10Te         = log10(TeUsed)
                       log10Ne         = log10(NeUsed)
                       sqrTeUsed = sqrt(TeUsed)

                       ! recalculate line emissivities at this cell

                       ! calculate the emission due to HI and HeI rec lines
                       call RecLinesEmission()

                       ! calculate the emission due to the heavy elements
                       ! forbidden lines
                       call forLines()


                       ! apply extinction correction according to extinction map
                       if (present(extMap)) then

                          if (ngrids>1) then
                             print*, '! outputGas: no multiple grids are allowed with extinction maps (yet)'
                             print*, 'if this is needed please contact be@star.ucl.ac.uk'
                             stop
                          end if

                          iCount = 1

                          ! H recombination lines
                          do iup = 30, ilow+1, -1
                             do ilow = 2, min(8, iup-1)
                                HIRecLines(iup, ilow) = &
                                     & HIRecLines(iup, ilow)*10.**(-(cMap(grid(1)%active(i,j,k))*flam(iCount)&
                                     & +cMap(grid(1)%active(i,j,k))))
                                iCount = iCount + 1

                             end do
                          end do

                          ! He I recombination lines
                          do l = 1, 34
                             HeIRecLines(l) = HeIRecLines(l)*10.**&
                                  & (-(cMap(grid(1)%active(i,j,k))*flam(iCount)+cMap(grid(1)%active(i,j,k))))
                             iCount = iCount + 1
                          end do

                          ! HeII recombination lines
                          ! HeII rec lines
                          do iup = 3, 30
                             do ilow = 2, min(16, iup-1)
                                HeIIRecLines(iup,ilow) = HeIIRecLines(iup,ilow)*&
                                     & 10.**(-(cMap(grid(1)%active(i,j,k))*flam(iCount)+cMap(grid(1)%active(i,j,k))))
                                iCount = iCount + 1
                             end do
                          end do

                          ! collisionally exited lines
                          do elem = 3, nElements
                             do ion = 1, min(elem+1, nstages)
                                if (.not.lgElementOn(elem)) exit

                                if (lgDataAvailable(elem, ion)) then
                                   if (elem == 26 .and. ion == 2) then
                                      do iup = 1,nForLevelsLarge
                                         do ilow = 1, nForLevelsLarge
                                            forbiddenLinesLarge(iup,ilow) = &
                                                 & forbiddenLinesLarge(iup,ilow)*10.**&
                                                 & (-(cMap(grid(1)%active(i,j,k))*flam(iCount)+&
                                                 & cMap(grid(1)%active(i,j,k))))
                                            iCount = iCount+1
                                         end do
                                      end do

                                   else
                                      do iup = 1,nForLevels
                                         do ilow = 1, nForLevels
                                            forbiddenLines(elem,ion,iup,ilow) = &
                                                 & forbiddenLines(elem,ion,iup,ilow)*10.**&
                                                 & (-(cMap(grid(1)%active(i,j,k))*flam(iCount)+&
                                                 & cMap(grid(1)%active(i,j,k))))
                                            iCount = iCount+1
                                         end do
                                      end do
                                   end if

                                end if

                             end do
                          end do

                       end if

!                       dV = getVolume(grid(iG), i,j,k)


                       if (lg2D .and. lgSymmetricXYZ) then
                          radius = sqrt((grid(iG)%xAxis(i)/1.e15)*&
                               &(grid(iG)%xAxis(i)/1.e15) + (grid(iG)%yAxis(j)/1.e15)*&
                               &(grid(iG)%yAxis(j)/1.e15))
                          if (i == 1) then
                             dr = (grid(iG)%xAxis(2)-grid(iG)%xAxis(1))/2.
                          elseif (i == grid(iG)%nx) then
                             dr = (grid(iG)%xAxis(grid(iG)%nx)-&
                                  &grid(iG)%xAxis(grid(ig)%nx-1))
                          else
                             dr = (grid(iG)%xAxis(i+1)-grid(iG)%xAxis(i-1))/2.
                          end if
                          dr = dr/1.e15
                          if (k == 1) then
                             dz = (grid(iG)%zAxis(2)-grid(iG)%zAxis(1))/2.
                          elseif (k == grid(iG)%nz) then
                             dz = (grid(iG)%zAxis(grid(iG)%nz)-&
                                  &grid(iG)%zAxis(grid(ig)%nz-1))
                          else
                             dz = (grid(iG)%zAxis(k+1)-grid(iG)%zAxis(k-1))/2.
                          end if
                          dz = dz/1.e15
                          dV = 2.*Pi*radius*dr*dz
!                          dV = getVolume(grid(iG), i,j,k)*scale2d
                       else if (lg2D .and. .not.lgSymmetricXYZ) then
                          print*, "! outputGas: a 2d grid must be symmetric"
                          stop
                       else if (.not. lg2D) then
                          dV = getVolume(grid(iG), i,j,k)
                       end if





                       ! Hbeta
                       HbetaVol(abFileUsed) = HbetaVol(abFileUsed) + real(HIRecLines(4,2)*HdenUsed*dV)

                       HbetaVol(0) = HbetaVol(0) + real(HIRecLines(4,2)*HdenUsed*dV)


                       ! HI rec lines
                       do ilow = 2, 8
                          do iup = ilow+1, 30
                             HIVol(abFileUsed,iup,ilow) = HIVol(abFileUsed,iup,ilow) + &
                                  & real(HIRecLines(iup,ilow)*HdenUsed*dV)
                             HIVol(0,iup,ilow) = HIVol(0,iup,ilow) + &
                                  & real(HIRecLines(iup,ilow)*HdenUsed*dV)
                          end do
                       end do

                       ! HeI recombination lines
                       HeIVol(abFileUsed,:) = HeIVol(abFileUsed,:) + real(HeIRecLines(:)*HdenUsed*dV)
                       HeIVol(0,:) = HeIVol(0,:) + real(HeIRecLines(:)*HdenUsed*dV)

                       ! HeII rec lines
                       do iup = 3, 30
                          do ilow = 2, min(16, iup-1)
                             HeIIVol(abFileUsed,iup,ilow) = HeIIVol(abFileUsed,iup,ilow) + &
                                  & real(HeIIRecLines(iup,ilow)*HdenUsed*dV)
                             HeIIVol(0,iup,ilow) = HeIIVol(0,iup,ilow) + &
                                  & real(HeIIRecLines(iup,ilow)*HdenUsed*dV)
                          end do
                       end do

                       ! Heavy elements forbidden lines
                       do elem = 3, nElements
                          do ion = 1, min(elem+1, nstages)

                             if (elem == 26 .and. ion == 2) then
                                do iup = 1, nForLevelsLarge
                                   do ilow = 1, nForLevelsLarge
                                      forbVolLarge(abFileUsed,iup,ilow) = &
                                           & forbVolLarge(abFileUsed,iup,ilow) + &
                                           & real(forbiddenLinesLarge(iup,ilow)*HdenUsed*dV)
                                      forbVolLarge(0,iup,ilow) = &
                                           & forbVolLarge(0,iup,ilow) + &
                                           & real(forbiddenLinesLarge(iup,ilow)*HdenUsed*dV)
                                   end do
                                end do
                             else
                                do iup = 1, nForLevels
                                   do ilow = 1, nForLevels
                                      forbVol(abFileUsed,elem,ion,iup,ilow) = &
                                           & forbVol(abFileUsed,elem,ion,iup,ilow) + &
                                           & real(forbiddenLines(elem,ion,iup,ilow)*HdenUsed*dV)
                                      forbVol(0,elem,ion,iup,ilow) = &
                                           & forbVol(0,elem,ion,iup,ilow) + &
                                           & real(forbiddenLines(elem,ion,iup,ilow)*HdenUsed*dV)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!                                      print*,'HEFL',elem,ion,iup,ilow,forbiddenLines(elem,ion,iup,ilow),HdenUsed,dV
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
                                   end do
                                end do
                             end if
                          end do
                       end do

                       if (lgDust .and. convPercent>resLinesTransfer) then

                          do iRes =1, nResLines

                             do imul = 1, resLine(iRes)%nmul

                                if (resLine(iRes)%elem==1) then
                                   if ( resLine(iRes)%ion == 1 .and. &
                                        &resLine(iRes)%moclow(imul)==1 &
                                        &.and. resLine(iRes)%mochigh(imul)==2 ) then

                                      ! fits to Storey and Hummer MNRAS 272(1995)41
                                      resLinesVol(abFileUsed, iRes) = resLinesVol(abFileUsed, iRes)+&
                                           &  10**(-0.897*log10(TeUsed) + 5.05)* &
                                           & grid(iG)%elemAbun(abFileUsed,1)*ionDenUsed(elementXref(1),2)*&
                                           &  real(NeUsed*HdenUsed*dV)
                                      resLinesVolCorr(abFileUsed, iRes) = resLinesVolCorr(abFileUsed, iRes)+&
                                           &  10**(-0.897*log10(TeUsed) + 5.05)* &
                                           & grid(iG)%elemAbun(abFileUsed,1)*ionDenUsed(elementXref(1),2)*&
                                           &  real(NeUsed*HdenUsed*dV* (grid(iG)%fEscapeResPhotons(cellPUsed, iRes)))
                                      resLinesVol(0, iRes) = resLinesVol(0, iRes)+&
                                           &  10**(-0.897*log10(TeUsed) + 5.05)* &
                                           & grid(iG)%elemAbun(abFileUsed,1)*ionDenUsed(elementXref(1),2)*&
                                           &  real(NeUsed*HdenUsed*dV)
                                      resLinesVolCorr(0, iRes) = resLinesVolCorr(0, iRes)+&
                                           &  10**(-0.897*log10(TeUsed) + 5.05)* grid(iG)%elemAbun(abFileUsed,1)*&
                                           & ionDenUsed(elementXref(1),2)*&
                                           &  real(NeUsed*HdenUsed*dV* (grid(iG)%fEscapeResPhotons(cellPUsed, iRes)))
                                   else

                                      print*, "! outputGas: [warning] only dust heating from H Lyman &
                                           &alpha and resonance lines from heavy"
                                      print*, "elements is implemented in this version. please contact &
                                           &author B. Ercolano -1-", ires

                                   end if

                                else if (resLine(iRes)%elem>2) then

                                   resLinesVol(abFileUsed, iRes) = resLinesVol(abFileUsed, iRes)+&
                                        &real(forbiddenLines(resLine(iRes)%elem,resLine(iRes)%ion,&
                                        &resLine(iRes)%moclow(imul),resLine(iRes)%mochigh(imul))*HdenUsed*dV)
                                   resLinesVolCorr(abFileUsed, iRes) = resLinesVolCorr(abFileUsed, iRes)+&
                                        &real(forbiddenLines(resLine(iRes)%elem,resLine(iRes)%ion,&
                                        & resLine(iRes)%moclow(imul),resLine(iRes)%mochigh(imul))*&
                                        & HdenUsed*dV*(grid(iG)%fEscapeResPhotons(cellPUsed, iRes)))
                                   resLinesVol(0, iRes) = resLinesVol(0, iRes)+&
                                        &real(forbiddenLines(resLine(iRes)%elem,resLine(iRes)%ion,&
                                        &resLine(iRes)%moclow(imul),resLine(iRes)%mochigh(imul))*HdenUsed*dV)
                                   resLinesVolCorr(0, iRes) = resLinesVolCorr(0, iRes)+&
                                        &real(forbiddenLines(resLine(iRes)%elem,resLine(iRes)%ion,&
                                        & resLine(iRes)%moclow(imul),resLine(iRes)%mochigh(imul))*&
                                        & HdenUsed*dV*(grid(iG)%fEscapeResPhotons(cellPUsed, iRes)))


                                else

                                   print*, "! outputGas: [warning] only dust heating from H Lyman &
                                        &alpha and resonance lines from heavy"
                                   print*, "elements is implemented in this version. please &
                                        &contact author B. Ercolano -2-", ires

                                end if

                             end do

                          end do
                       end if

                       if (lgRecombination) then

                          if (lgElementOn(8)) then
                             denIon = ionDenUsed(elementXref(8),3)*&
                                  & grid(iG)%elemAbun(abFileUsed,8)*HdenUsed

                             recFlux = 0.
                             recLinesLambda = 0.
                             ! rec lines for OII
                             call roii(recLinesLambda, recFlux,TeUsed, NeUsed)

                             do nrec = 1, 500
                                recLinesFlux(abFileUsed,1,nrec) = recLinesFlux(abFileUsed,1,nrec) + &
                                     &recFlux(nrec)*HIRecLines(4,2)*&
                                     & HdenUsed*dV*&
                                     &ionDenUsed(elementXref(8),3)*&
                                     &grid(iG)%elemAbun(abFileUsed,8)/ionDenUsed(elementXref(1),2)
                                recLinesFlux(0,1,nrec) = recLinesFlux(0,1,nrec) + &
                                     &recFlux(nrec)*HIRecLines(4,2)*&
                                     & HdenUsed*dV*&
                                     &ionDenUsed(elementXref(8),3)*&
                                     &grid(iG)%elemAbun(abFileUsed,8)/ionDenUsed(elementXref(1),2)
                             end do
                             recLambdaOII = recLinesLambda
                          end if

                          if (lgElementOn(12)) then
                             recFlux = 0.
                             recLinesLambda = 0.
                             ! rec lines for MgII 4481
                             call rmgii(recFlux, recLinesLambda, TeUsed)

                             recLinesFlux(abFileUsed,2,:) = recLinesFlux(abFileUsed,2,:) + recFlux*&
                                  &HIRecLines(4,2)*HdenUsed*dV*&
                                  &ionDenUsed(elementXref(12),3)*&
                                  &grid(iG)%elemAbun(abFileUsed,12)/ionDenUsed(elementXref(1),2)

                             recLinesFlux(0,2,:) = recLinesFlux(0,2,:) + recFlux*&
                                  &HIRecLines(4,2)*HdenUsed*dV*&
                                  &ionDenUsed(elementXref(12),3)*&
                                  &grid(iG)%elemAbun(abFileUsed,12)/ionDenUsed(elementXref(1),2)

                             recLambdaMgII = recLinesLambda
                          end if

                          if (lgElementOn(10)) then
                             recFlux = 0.
                             recLinesLambda = 0.
                             ! rec lines for NeII
                             call rneii(recLinesLambda, recFlux, TeUsed)

                             do nrec = 1, 500
                                recLinesFlux(abFileUsed,3,nrec) = recLinesFlux(abFileUsed,3,nrec) + recFlux(nrec)*&
                                     &HIRecLines(4,2)*HdenUsed*dV*&
                                     &ionDenUsed(elementXref(10),3)*&
                                     &grid(iG)%elemAbun(abFileUsed,10)/ionDenUsed(elementXref(1),2)
                                recLinesFlux(0,3,nrec) = recLinesFlux(0,3,nrec) + recFlux(nrec)*&
                                     &HIRecLines(4,2)*HdenUsed*dV*&
                                     &ionDenUsed(elementXref(10),3)*&
                                     &grid(iG)%elemAbun(abFileUsed,10)/ionDenUsed(elementXref(1),2)
                             end do
                             recLambdaNeII = recLinesLambda
                          end if

                          if (lgElementOn(6)) then
                             recFlux = 0.
                             recLinesLambda = 0.
                             ! rec lines for CII
                             call rcii(recLinesLambda, recFlux, TeUsed)

                             do nrec = 1, 500
                                recLinesFlux(abFileUsed,4,nrec) = recLinesFlux(abFileUsed,4,nrec) + recFlux(nrec)*&
                                     &HIRecLines(4,2)*HdenUsed*dV*&
                                     &ionDenUsed(elementXref(6),3)*&
                                     &grid(iG)%elemAbun(abFileUsed,6)/ionDenUsed(elementXref(1),2)
                                recLinesFlux(0,4,nrec) = recLinesFlux(0,4,nrec) + recFlux(nrec)*&
                                     &HIRecLines(4,2)*HdenUsed*dV*&
                                     &ionDenUsed(elementXref(6),3)*&
                                     &grid(iG)%elemAbun(abFileUsed,6)/ionDenUsed(elementXref(1),2)
                             end do
                             recLambdaCII = recLinesLambda
                          end if

                          if (lgElementOn(7)) then
                             recFlux = 0.
                             recLinesLambda = 0.
                             denIon = ionDenUsed(elementXref(7),3)*&
                                  & grid(iG)%elemAbun(abFileUsed,7)*HdenUsed

                             ! rec lines for NII 3-3
                             call rnii(recLinesLambda, recFlux, TeUsed, NeUsed)

                             do nrec = 1, 500
                                recLinesFlux(abFileUsed,5,nrec) = recLinesFlux(abFileUsed,5,nrec) + recFlux(nrec)*&
                                     &HIRecLines(4,2)*HdenUsed*dV*&
                                     &ionDenUsed(elementXref(7),3)*&
                                     &grid(iG)%elemAbun(abFileUsed,7)/ionDenUsed(elementXref(1),2)
                                recLinesFlux(0,5,nrec) = recLinesFlux(0,5,nrec) + recFlux(nrec)*&
                                     &HIRecLines(4,2)*HdenUsed*dV*&
                                     &ionDenUsed(elementXref(7),3)*&
                                     &grid(iG)%elemAbun(abFileUsed,7)/ionDenUsed(elementXref(1),2)
                             end do
                             recLambdaN33II = recLinesLambda


                             recFlux = 0.
                             recLinesLambda = 0.

                             ! rec lines for NII 3d-4f
                             call rnii4f(recLinesLambda, recFlux, TeUsed)

                             do nrec = 1, 500
                                recLinesFlux(0,6,nrec) = recLinesFlux(0,6,nrec) + recFlux(nrec)*&
                                     &HIRecLines(4,2)*HdenUsed*dV*&
                                     &ionDenUsed(elementXref(7),3)*&
                                     &grid(iG)%elemAbun(abFileUsed,7)/ionDenUsed(elementXref(1),2)
                             end do
                             recLambdaN34II = recLinesLambda
                          end if

                       end if


                       ! calculate line packets luminosities
                       ! first of all sum over all the cells
                       if (lgDebug) then
                          do l = 1, nLines
                             lineLuminosity(abFileUsed,l) = lineLuminosity(abFileUsed,l) + linePacketsUsed(l)
                             lineLuminosity(0,l) = lineLuminosity(0,l) + linePacketsUsed(l)
                             totLinePackets    = totLinePackets + nint(linePacketsUsed(l))
                          end do

                          ! calculate the total number of escaped packets
                          do l = 1, nbins
                             totEscapedPackets = totEscapedPackets + &
                                  & nint(grid(iG)%escapedPackets(grid(iG)%active(i,j,k),l,0))
                          end do

                          ! MC estimator of Hbeta luminosity
                          HbetaLuminosity(abFileUsed) = lineLuminosity(abFileUsed,2)
                          HbetaLuminosity(0) = lineLuminosity(0,2)

                       end if

                       ! calculate mean temperatures for the ions
                       ! and the mean <ion>/<H+>
                       factor1 = TeUsed*NeUsed*HdenUsed*dV
                       factor2 = NeUsed*HdenUsed*dV

                       do elem = 1, nElements
                          do ion = 1, min(elem+1,nstages)
                             if (.not.lgElementOn(elem)) exit

                             TeVol(abFileUsed,elem,ion) = TeVol(abFileUsed,elem,ion) + &
                                  & ionDenUsed(elementXref(elem),ion)*factor1

                             denominatorTe(abFileUsed,elem,ion) = denominatorTe(abFileUsed,elem,ion) + &
                                  & ionDenUsed(elementXref(elem),ion)*factor2


                             ionDenVol(abFileUsed,elem,ion) = ionDenVol(abFileUsed,elem,ion)+ &
                                  & ionDenUsed(elementXref(elem),ion)*factor2


                             ! this is the definition used in the lexington benchmark
!                                denominatorIon(abFileUsed,elem,ion) = denominatorIon(abFileUsed,elem,ion) + &
!                                     & ionDenUsed(elementXref(1),2)*factor2

                             TeVol(0,elem,ion) = TeVol(0,elem,ion) + &
                                  & ionDenUsed(elementXref(elem),ion)*factor1

                             denominatorTe(0,elem,ion) = denominatorTe(0,elem,ion) + &
                                  & ionDenUsed(elementXref(elem),ion)*factor2


                             ionDenVol(0,elem,ion) = ionDenVol(0,elem,ion)+ &
                                  & ionDenUsed(elementXref(elem),ion)*factor2


                             ! this is the definition used in the lexington benchmark
!                                denominatorIon(0,elem,ion) = denominatorIon(0,elem,ion) + &
!                                     & ionDenUsed(elementXref(1),2)*factor2


                          end do
                       end do

                    end if
                    end if

                 end do
              end do
           end do outer

        end do

        ! the following is the definition given by Harrington et al. 1982

        do iAb = 0, nAbComponents

           ! reinitialize sumAm and sumMC
           sumAn = 0.
           sumMC = 0.

           do elem = 1, nElements
              do ion = 1, min(elem+1, nstages)
                 denominatorIon(iAb,elem) = denominatorIon(iAb,elem) + ionDenVol(iAb,elem,ion)

              end do
           end do


           do elem = 1, nElements
              do ion = 1, min(elem+1, nstages)
                 if (.not.lgElementOn(elem)) exit

                 if (denominatorTe(iAb,elem,ion) <= 0.) then
                    TeVol(iAb,elem,ion) = 0.
                 else
                    TeVol(iAb,elem,ion) = TeVol(iAb,elem,ion) / denominatorTe(iAb,elem,ion)
                 end if

                 ! lexington benchmark

!                 if (denominatorIon(iAb,elem,ion) <= 0.) then
!                    ionDenVol(iAb,elem,ion) = 0.
!                 else
!                 ionDenVol(iAb,elem,ion) = ionDenVol(iAb,elem,ion) / denominatorIon(iAb,elem,ion)
!                 end if

                 ! Harrington 1982

                 if (denominatorIon(iAb,elem) <= 0.) then
                    ionDenVol(iAb,elem,ion) = 0.
                 else
                    ionDenVol(iAb,elem,ion) = ionDenVol(iAb,elem,ion) / denominatorIon(iAb,elem)
                 end if
              end do
           end do

           ! calculate analytical relative line intensities (relative to Hbeta)
           if (HbetaVol(0) <= 0.) then

              print*, "! outputGas:[warning] Hbeta analytical negative or zero in regionI"

           else

              ! HI rec lines
              do ilow = 2, 8
                 do iup = ilow+1, 30
                    HIVol(iAb,iup,ilow) = HIVol(iAb,iup,ilow) /HbetaVol(iAb)
                 end do
              end do

              ! HeI
              HeIVol(iAb,:) = HeIVol(iAb,:) / HbetaVol(iAb)


              ! HeII rec lines
              do iup = 3, 30
                 do ilow = 2, min(16, iup-1)
                    HeIIVol(iAb,iup,ilow) = HeIIVol(iAb,iup,ilow) / HbetaVol(iAb)
                 end do
              end do

              ! Heavy elements forbidden lines
!              do elem = 3, nElements
!                 do ion = 1, min(elem+1, nstages)
!                    do iup = 1, nForLevels
!                       do ilow = 1, nForLevels
              forbVol(iAb,:,:,:,:) = forbVol(iAb,:,:,:,:) / HbetaVol(iAb)
              forbVolLarge(iAb,:,:) = forbVolLarge(iAb,:,:) / HbetaVol(iAb)
!                       end do
!                    end do
!                 end do
!              end do

              if (lgDust .and. convPercent>resLinesTransfer) then
                 do iRes = 1, nResLines
                    resLinesVol(iAb, iRes) = resLinesVol(iAb, iRes)/HbetaVol(iAb)
                    resLinesVolCorr(iAb, iRes) = resLinesVolCorr(iAb, iRes)/HbetaVol(iAb)
                 end do

              end if
              if (lgRecombination) recLinesFlux(iAb,:,:) = recLinesFlux(iAb,:,:)/HbetaVol(iAb)

           end if


           if (lgDebug) then
              ! calculate relative MC line luminosities
              if (lineLuminosity(iAb,2) <= 0. .and. nIterateMC>1) then
                 print*, "! outputGas: MC luminosty of Hbeta negative or zero",&
                      & lineLuminosity(iAb,2)
              else
                 do l = 1, nLines
                    lineLuminosity(iAb,l) = lineLuminosity(iAb,l)/HbetaLuminosity(iAb)
                 end do
              end if
           end if

        end do

        do iAb = 0, nAbComponents
           ! calculate Hbeta in units of [E36 erg/s]
           ! Note: Hbeta is now in E-25 * E45 ergs/sec (the E-25 comes from the emission
           ! module calculations and the E45 comes from the volume calculations to avoid
           ! overflow. Hence Hbeta is in [E20 ergs/s], so we need to multiply by E-16
           ! to give units of  [E36 erg/s].
           HbetaVol(iAb) = HbetaVol(iAb)*1.e-16

           ! correct for symmetry case
!           if (lgSymmetricXYZ ) then
!              HbetaVol(iAb)        = 8.*HbetaVol(iAb)
!           end if

           ! correct for symmetry case
           if (lgSymmetricXYZ .and. .not.lg2D) then
              HbetaVol(iAb)        = 8.*HbetaVol(iAb)
           elseif (lgSymmetricXYZ .and. lg2D) then
              HbetaVol(iAb)        = 2.*HbetaVol(iAb)
           end if

           ! calculate Hbeta in units of [E36 erg/sec]
           if (lgDebug) HbetaLuminosity(iAb) = HbetaLuminosity(iAb)
        end do

        ! write the lineFlux.out file
        if (present(extMap)) then
           open(unit=10, status='unknown', position='rewind', file='output/lineFlux.ext', action="write", iostat=ios)
           if (ios /= 0) then
              print*, "! outputGas: can't open file for writing: output/lineFlux.ext"
              stop
           end if
        else
           open(unit=10, status='unknown', position='rewind', file='output/lineFlux.out', action="write",iostat=ios)
           if (ios /= 0) then
              print*, "! outputGas: can't open file for writing: output/lineFlux.out"
              stop
           end if
        end if


        write(10, *) "Totals integrated over all nebular components: "
        do iAb = 0, nAbComponents

           ! The following code generates a first output with the some common nebular lines
           write(10, *)
           if (iAb>0) write(10, *) "Component: ", iAb
           write(10, *)
           write(10, *) "Line Ratios (Hbeta=1.) :               Analytical"
           write(10, *) "Hbeta [E36 erg/s]:     ",  HbetaVol(iAb)
           write(10, *)
           write(10, *) "HeI"
           do i = 1, 34
              write(10, *) HeIrecLineCoeff(i,1,4), HeIVol(iAb,i)
           end do
           write(10, *) "HeII 4686", HeIIVol(iAb,4,3)
           if (lgElementOn(7) .and. lgDataAvailable(7,2)) then
              write(10, *)
              write(10, *) "[NII] 5755", forbVol(iAb,7,2,4,5)
              write(10, *) "[NII] 6548", forbVol(iAb,7,2,2,4)
              write(10, *) "[NII] 6584", forbVol(iAb,7,2,3,4)
           end if
           if (lgElementOn(8) .and. lgDataAvailable(8,2)) then
              write(10, *)
              write(10, *) "[OII] 3726", forbVol(iAb,8,2,1,3)
              write(10, *) "[OII] 3729", forbVol(iAb,8,2,1,2)
              write(10, *) "[OII] 7318,9", forbVol(iAb,8,2,2,4)+forbVol(iAb,8,2,2,5)
              write(10, *) "[OII] 7330,0", forbVol(iAb,8,2,3,4)+forbVol(iAb,8,2,3,5)
           end if
           if (lgElementOn(8) .and. lgDataAvailable(8,3)) then
              write(10, *)
              write(10, *) "[OIII] 4363", forbVol(iAb,8,3,4,5)
              write(10, *) "[OIII] 4932", forbVol(iAb,8,3,1,4)
              write(10, *) "[OIII] 4959", forbVol(iAb,8,3,2,4)
              write(10, *) "[OIII] 5008", forbVol(iAb,8,3,3,4)
           end if
           if (lgElementOn(10) .and. lgDataAvailable(10,3)) then
              write(10, *)
              write(10, *) "[NeIII] 3869", forbVol(iAb,10,3,1,4)
              write(10, *) "[NeIII] 3967", forbVol(iAb,10,3,2,4)
           end if
           if (lgElementOn(16) .and. lgDataAvailable(16,2)) then
              write(10, *)
              write(10, *) "[SII] 4069",  forbVol(iAb,16,2,1,5)
              write(10, *) "[SII] 4076",  forbVol(iAb,16,2,1,4)
              write(10, *) "[SII] 6717",  forbVol(iAb,16,2,1,3)
              write(10, *) "[SII] 6731",  forbVol(iAb,16,2,1,2)
           end if
           if (lgElementOn(16) .and. lgDataAvailable(16,3)) then
              write(10, *)
              write(10, *) "[SIII] 6312",  forbVol(iAb,16,3,4,5)
           end if
           if (lgElementOn(17) .and. lgDataAvailable(17,3)) then
              write(10, *)
              write(10, *) "[ClIII] 5518",  forbVol(iAb,17,3,1,3)
              write(10, *) "[ClIII] 5538",  forbVol(iAb,17,3,1,2)
           end if
           if (lgElementOn(17) .and. lgDataAvailable(17,4)) then
              write(10, *)
              write(10, *) "[ClIV] 7531",  forbVol(iAb,17,4,2,4)
              write(10, *) "[ClIV] 8046",  forbVol(iAb,17,4,3,4)
           end if
           if (lgElementOn(18) .and. lgDataAvailable(18,3)) then
              write(10, *)
              write(10, *) "[ArIII] 7136",  forbVol(iAb,18,3,1,4)
              write(10, *) "[ArIII] 7752",  forbVol(iAb,18,3,2,4)
           end if
           if (lgElementOn(18) .and. lgDataAvailable(18,4)) then
              write(10, *)
              write(10, *) "[ArIV] 4712",  forbVol(iAb,18,4,1,3)
              write(10, *) "[ArIV] 4741",  forbVol(iAb,18,4,1,2)
           end if

           write(10, *)
           write(10, *) "Line Diagnostics"
           write(10, *) "                  Ne:"
           if (lgElementOn(16) .and. lgDataAvailable(16,2)) &
                & write(10, *) "[SII] 6731/6717 ", forbVol(iAb,16,2,1,2)/ forbVol(iAb,16,2,1,3)
           if (lgElementOn(8) .and. lgDataAvailable(8,2)) &
                & write(10, *) "[OII] 3729/3726 ", forbVol(iAb,8,2,1,2)/ forbVol(iAb,8,2,1,3)
           if (lgElementOn(17) .and. lgDataAvailable(17,3)) &
                & write(10, *) "[ClIII] 5537/5517 ", forbVol(iAb,17,3,1,2)/ forbVol(iAb,17,3,1,3)
           if (lgElementOn(18) .and. lgDataAvailable(18,4)) &
                & write(10, *) "[ArIV] 4740/4712 ", forbVol(iAb,18,4,1,2)/ forbVol(iAb,18,4,1,3)
           write(10, *) "                  Te:"
           if (lgElementOn(7) .and. lgDataAvailable(7,2)) &
                & write(10, *) "[NII](6584+6546)/5754 ", (forbVol(iAb,7,2,2,4)+forbVol(iAb,7,2,3,4))/&
                &forbVol(iAb,7,2,4,5)
           if (lgElementOn(8) .and. lgDataAvailable(8,2)) &
                & write(10, *) "[OII] 3726/7320 ", forbVol(iAb,8,2,1,3)/(forbVol(iAb,8,2,2,4)+&
                &forbVol(iAb,8,2,2,5))
           if (lgElementOn(8) .and. lgDataAvailable(8,3)) &
                & write(10, *) "[OIII] (4959+5007)/4363 ", (forbVol(iAb,8,3,2,4)+forbVol(iAb,8,3,3,4))/&
                &forbVol(iAb,8,3,4,5)

           write(10, *)
           write(10, *)

           if (lgDust .and. convPercent>resLinesTransfer) then
              write(10,*) " Resonance Lines Attenuated by dust absorption"
              write(10,*) " Line                               Uncorrected         Corrected"
              do iRes = 1, nResLines

                 if (lgElementOn(resLine(iRes)%elem)) then
                    write(10,*) trim(resLine(iRes)%species), resLine(iRes)%ion, resLinesVol(iAb,iRes), &
                         &resLinesVolCorr(iAb,iRes)
                 end if
              end do
           end if

           if (lgDebug ) then
              if (HbetaLuminosity(iAb)>0.) then
                 write(10, *) "Line Ratios :               Analytical     MC         &
                      &                        Analytical/MC:"
                 write(10, *) "Hbeta [E36 erg/s]:     ", &
                      & HbetaVol(iAb), HbetaLuminosity(iAb), HbetaVol(iAb)/HbetaLuminosity(iAb)
              else
                 write(10, *) "Line Ratios :            Formal Solution "
                 write(10, *) "Hbeta [E36 erg/s]:     ", HbetaVol(iAb)
              end if
           else
              write(10, *) "Line Ratios :               Formal Solution "
              write(10, *) "Hbeta [E36 erg/s]:     ", &
                   & HbetaVol(iAb)
           end if

           write(10, *)
           write(10, *) "HI recombination lines:"
           write(10, *)
           iLine = 1
           do ilow = 2, 8
              do iup = ilow+1, 30

                 if (lgDebug) then
                    if (lineLuminosity(iAb,iLine) > 0. ) then
                       write(10, *) iup, ilow, HIVol(iAb,iup,ilow), lineLuminosity(iAb,iLine), &
                            & HIVol(iAb,iup,ilow)/lineLuminosity(iAb,iLine), iLine
                       sumAn = sumAn + HIVol(iAb,iup,ilow)
                       sumMC = sumMC + lineLuminosity(iAb,iLine)
                    else
                       write(10, *) iup, ilow, HIVol(iAb,iup,ilow), iLine, wave_a(hwavelength(ilow,iup,1))
                    end if
                 else
                    write(10, *) iup, ilow, HIVol(iAb,iup,ilow), iLine, wave_a(hwavelength(ilow,iup,1))
                 end if
                 iLine = iLine + 1
              end do
           end do

           write(10, *)
           write(10, *) "HeI "
           write(10, *)
           do l = 1, 34

              if (lgDebug) then
                 if (lineLuminosity(iAb,iLine) > 0. ) then
                    write(10, *) l,"            ",  HeIVol(iAb,l),  lineLuminosity(iAb,iLine), &
                         & HeIVol(iAb,l)/lineLuminosity(iAb,iLine), iLine
                    sumAn = sumAn + HeIVol(iAb,l)
                    sumMC = sumMC + lineLuminosity(iAb,iLine)
                 else
                    write(10, *) l,HeIrecLineCoeff(l,1,4),"            ", HeIVol(iAb,l), iLine
                 end if
              else
                 write(10, *) l,HeIrecLineCoeff(l,1,4),"            ",  HeIVol(iAb,l), iLine
              end if
              iLine = iLine + 1
           end do


           write(10, *)
           write(10, *) "HeII recombination lines:"
           write(10, *)
           do iup = 3, 30
              do ilow = 2, min(16, iup-1)

                 if (lgDebug ) then
                    if ( lineLuminosity(iAb,iLine) > 0. ) then
                       write(10, *) iup, ilow, HeIIVol(iAb,iup,ilow), lineLuminosity(iAb,iLine), &
                            & HeIIVol(iAb,iup,ilow)/lineLuminosity(iAb,iLine), iLine
                       sumAn = sumAn + HeIIVol(iAb,iup,ilow)
                       sumMC = sumMC + lineLuminosity(iAb,iLine)
                    else
                       write(10, *) iup, ilow, HeIIVol(iAb,iup,ilow), iLine, wave_a(hwavelength(ilow,iup,2))
                    end if
                 else
                    write(10, *) iup, ilow, HeIIVol(iAb,iup,ilow), iLine, wave_a(hwavelength(ilow,iup,2))
                 end if

                 iLine = iLine + 1
              end do
           end do

           write(10, *)
           write(10, *) "Heavy ions forbidden lines"
           write(10, *)
           do elem = 3, nElements
              do ion = 1, min(elem+1, nstages)

                 if (.not.lgElementOn(elem)) exit
                 if (lgDataAvailable(elem,ion)) then
                    if (elem==26 .and.  ion==2) then

                       do iup = 1, nForLevelsLarge
                          do ilow = 1, nForLevelsLarge
                             if (forbVolLarge(iAb,iup, ilow) > 0.) then
                                write(10, *) ' 26', ' 2 ', iup, ilow, wavLarge(iup, ilow), &
                                     & forbVolLarge(iAb,iup,ilow), iLine
                             end if

                             iLine = iLine + 1

                          end do
                       end do

                    else

                       do iup = 1, nForLevels
                          do ilow = 1, nForLevels
                             if (forbVol(iAb,elem,ion, iup, ilow) > 0.) then
                                if (lgDebug) then
                                   if (lineLuminosity(iAb,iLine) > 0. ) then
                                      write(10, *) elem, ion, iup, ilow, wav(elem,ion, iup, ilow), &
                                           & forbVol(iAb,elem,ion, iup, ilow), &
                                           &lineLuminosity(iAb,iLine), &
                                           & forbVol(iAb,elem, ion, iup, ilow)/&
                                           &lineLuminosity(iAb,iLine), iLine
                                      sumAn = sumAn + forbVol(iAb,elem,ion,iup,ilow)
                                      sumMC = sumMC + lineLuminosity(iAb,iLine)
                                   else
                                      write(10, *) elem, ion, iup, ilow, wav(elem,ion, iup, ilow), &
                                           & forbVol(iAb,elem,ion,iup,ilow), iLine
                                   end if
                                else
                                   write(10, *) elem, ion, iup, ilow, wav(elem,ion, iup, ilow), &
                                        & forbVol(iAb,elem,ion,iup,ilow), iLine
                                end if
                             end if

                             iLine = iLine + 1

                          end do
                       end do
                    end if
                 end if
              end do
           end do

           if (lgRecombination) then
              write(10,*)
              write(10,*)
              write(10,*) "Recombination Lines for CII, Davey et al. (2000)"
              write(10,*)
              do i = 1, 159
                 write(10,*) recLambdaCII(i), recLinesFlux(iAb,4,i)
              end do

              write(10,*)
              write(10,*)
              write(10,*) "Recombination Lines for NII, Kisielius & Storey(2000)"
              write(10,*)
              do i = 1,115
                 write(10,*) recLambdaN33II(i), recLinesFlux(iAb,5,i)
              end do
              write(10,*) "3d--4f Escalante & Victor(1990)"
              write(10,*)
              do i = 1,23
                 write(10,*) recLambdaN34II(i), recLinesFlux(iAb,6, i)
              end do

              write(10,*)
              write(10,*)
              write(10,*) "Recombination Lines for OII, Storey & Hummer(1994) and Liu et al. (1995)"
              write(10,*)
              do i = 1, 415
                 write(10,*) recLambdaOII(i), recLinesFlux(iAb,1,i)
              end do

              write(10,*)
              write(10,*)
              write(10,*) "Recombination Lines for NeII, Kisielius et al. (1998)&
                   & and Storey (private commumication)"
              write(10,*)
              do i = 1,439
                 write(10,*) recLambdaNeII(i), recLinesFlux(iAb,3,i)
              end do

              write(10,*)
              write(10,*)
              write(10,*) "Recombination Lines for MgII 4481, similar to CII 4667"
              write(10,*)
              write(10,*) "4481.21 ", recLinesFlux(iAb,2,1)+recLinesFlux(iAb,2,2)&
                   &+recLinesFlux(iAb,2,3)

           end if

           LtotAn = HbetaVol(iAb)*sumAn
           if(lgDebug) LtotMC = HbetaLuminosity(iAb)*sumMC

        end do

        ! close lineFlux.out file
        close(10)

        ! write the temperature.out file
        open(unit=20, status='unknown', position='rewind', file='output/temperature.out', action="write",iostat=ios)
        if (ios /= 0) then
           print*, "! outputGas: can't open file for writing: output/temperature.out"
           stop
        end if

        open(unit=27, status='unknown', position='append', file='output/summary.out', action="write",iostat=ios)
        if (ios /= 0) then
           print*, "! iterationMC: can't open file for writing: output/summary.out"
           stop
        end if


        ! write ionratio.out file
        open(unit=30, status='unknown', position='rewind', file='output/ionratio.out', action="write",iostat=ios)
        if (ios /= 0) then
           print*, "! outputGas: can't open file for writing: output/ionratio.out"
           stop
        end if

        if (lgDebug) then

           open(unit=60, status='unknown', position='rewind', file='output/ionDen.out', action="write",iostat=ios)
           if (ios /= 0) then
              print*, "! outputGas: can't open file for writing: output/ionDen.out"
              stop
           end if

        end if


        write(20, *)
        write(20, *) "Mean ionic temperatures Te(ion)"
        write(20, *)
        write(20, *) "Total, integrated over all nebular components"

        write(30, *)
        write(30, *) "Mean ionic ratio <ion>/<H+>"
        write(30, *)
        write(30, *) "Total, integrated over all nebular components"
        write(30, *)

        do iAb = 0, nAbComponents

           if (iAb>0) then

              write(20, *)
              write(20, *) "Mean ionic temperatures Te(ion)"
              write(20, *)
              write(20, *) "Component : ", iAb
              write(20, *)

              write(30, *)
              write(30, *) "Mean ionic ratio <ion>/<H+>"
              write(30, *)
              write(30, *) "Component : ", iAb
              write(30, *)

           end if

           write(20, *) "Element      Ion        Te(Element,ion)"
           write(20, *)
           do elem = 1, nElements
              do ion = 1, min(nstages,elem+1)
                 write(20, *) elem, ion,  TeVol(iAb,elem, ion)
              end do
           end do

           write(27,*) 'T(H+) ', TeVol(iAb,1,2), ' component ', iAb

           write(30, *) "Element      Ion        <ion>/<H+>I     <ion>/<H+>II"
           write(30, *)
           do elem = 1, nElements
              do ion = 1, min(nstages,elem+1)
                 write(30, *) elem, ion, ionDenVol(iAb,elem, ion)
              end do
           end do

           if (lgDebug) then

              write(60, *)
              do iG = 1, nGrids
                 print*, 'Grid : ', iG
                 do i = 1 , grid(iG)%nx
                    do j = 1, grid(iG)%ny
                       do k = 1, grid(iG)%nz
                          do elem = 1, nElements
                             do ion = 1, min(nstages,elem+1)
                                if (grid(iG)%active(i,j,k)<=0) exit
                                if (.not.lgElementOn(elem)) exit
                                write(60, *) i,j,k, elem, ion, grid(iG)%ionDen(grid(iG)%active(i,j,k),elementXref(elem), ion)
                             end do
                          end do
                       end do
                    end do
                 end do
              end do

              close(60)
           end if

        end do

        close(20)
        close(27)
        close(30)
        close(60)

        if (allocated(HIVol)) deallocate(HIVol)
        if (allocated(HeIVol)) deallocate(HeIVol)
        if (allocated(HeIIVol)) deallocate(HeIIVol)
        if (allocated(ionDenVol)) deallocate(ionDenVol)
        if (lgDebug) then
           if (allocated(lineLuminosity)) deallocate(lineLuminosity)
        end if
        if (allocated(forbVol)) deallocate(forbVol)
        if (allocated(forbVolLarge)) deallocate(forbVolLarge)
        if (allocated(TeVol)) deallocate(TeVol)
        if (allocated(recLinesFlux)) deallocate(recLinesFlux)
        if (allocated(denominatorIon)) deallocate(denominatorIon)
        if (allocated(denominatorTe)) deallocate(denominatorTe)

        if (present(extMap)) then
           if (allocated(cMap)) deallocate(cMap)
           if (allocated(flam)) deallocate(flam)
        end if
        if (convPercent >= resLinesTransfer .and. lgDust) then
           if (allocated(resLinesVol)) deallocate(resLinesVol)
           if (allocated(resLinesVolCorr)) deallocate(resLinesVolCorr)
        end if

      contains

!get wavelength of H I and He II lines
!calculation is just for lineFlux.out, nothing else depends on it
!hence hackiness
        real function hwavelength(ilow,iup,z)
        implicit none
        integer, intent(in) :: ilow, iup,z
        real :: rydberg !

        if (z .eq. 1) rydberg = 0.00109679454
        if (z .eq. 2) rydberg = 0.00109725525
        hwavelength = ((rydberg*real(z)**2)*(1/real(ilow)**2 - 1/real(iup)**2))**(-1)
        return
        end function hwavelength


!convert vacuum wavelength to air wavelength
!formula from Morton, 2000, ApJS, 130, 403
        real function wave_a(wave_v)
        implicit none
        real, intent(in) :: wave_v !in angstroms
        real :: n,s !conversion factors

        s = 1.e4/wave_v
        n = 1 + 0.0000834254 + 0.02406147 / (130 - s**2) + 0.00015998 / (38.9 - s**2)
        wave_a = wave_v/n
        return
        end function wave_a

! optical recombination lines subroutines added by Zhang Yong (PKU) February 2003
!***************** for recombination****************************************************

        subroutine roii(lamb,flux,tk,den)
!        ref Storey 1994 A&A 282, 999, Liu 1995, MNRAS, 272, 369
          implicit none

          real, intent(in) :: tk,den
          real(kind=8), intent(inout):: lamb(500),flux(500)

          real(kind=8)  :: ahb,te,emhb,an(4), &
               &        a,b,c,d,logne,aeff,br(3,500),em
          integer       :: i,g2(500)

          open(file=PREFIX//"/share/mocassin/data/Roii.dat",unit=41,status="old", action="read",position="rewind")
          do i=1,415
             read(41,*) lamb(i),g2(i),&
                  &br(1,i),br(2,i),br(3,i)
          end do
!          110 format (6x,f9.4,31x,A4,27x,A7,17x,i2,5x,a7,2x,f6.4,2x,f6.4,2x,f6.4)
          logne=log10(den)
!   4f-3d transitions (Case A=B=C for a,b,c,d as well as Br)
          a=0.232
          b=-0.92009
          c=0.15526
         d=0.03442
         an(1)=0.236
         an(2)=0.232
         an(3)=0.228
         an(4)=0.222
         te=tk/10000.
         ahb=6.68e-14*te**(-0.507)/(1.+1.221*te** 0.653)
         emhb=1.98648E-08/4861.33*ahb
         if(logne.le.2) then
           a=an(1)
          elseif(logne.le.4) then
           a=an(1)+(an(2)-an(1))/2.*(logne-2.)
          elseif(logne.le.5) then
           a=an(2)+(an(3)-an(2))*(logne-2.)
          elseif(logne.le.6) then
           a=an(3)+(an(4)-an(3))*(logne-2.)
          else
           a=an(4)
         endif
         aeff=1.e-14*a*te**(b)
         aeff=aeff*(1.+c*(1.-te)+d*(1.-te) ** 2)
         do i=1,183
          em=aeff*1.98648E-08/lamb(i)*g2(i)*br(2,i)
          flux(i)=em/emhb
         end do
!       3d-3p ^4F transitions (Case A=B=C for a,b,c,d; Br diff.
!        slightly, adopt Case B)
         a=0.876
         b=-0.73465
         c=0.13689
         d=.06220
         an(1)=0.876
         an(2)=0.876
         an(3)=0.877
         an(4)=0.880
         if(logne.le.2) then
            a=an(1)
           elseif(logne.le.4) then
            a=an(1)+(an(2)-an(1))/ 2.*(logne-2.)
           elseif(logne.le.5) then
            a=an(2)+(an(3)-an(2))*(logne-2.)
           elseif(logne.le.6) then
            a=an(3)+(an(4)-an(3))*(logne-2.)
           else
             a=an(4)
          endif
         aeff=1.e-14*a*te**(b)
         aeff=aeff*(1.+c*(1.-te)+d*(1.-te)**2)
         do i=184,219
          em=aeff*1.98648E-08/lamb(i)*g2(i)*br(2,i)
          flux(i)=em/emhb
         end do
!        3d-3p ^4D, ^4P transitions
         a=0.745
         b=-0.74621
         c=0.15710
         d=0.07059
         an(1)=0.747
         an(2)=0.745
         an(3)=0.744
         an(4)=0.745
         if(logne.le.2) then
            a=an(1)
           elseif(logne.le.4) then
            a=an(1)+(an(2)-an(1))/ 2.*(logne-2.)
           elseif(logne.le.5) then
            a=an(2)+(an(3)-an(2))*(logne-2.)
           elseif(logne.le.6) then
            a=an(3)+(an(4)-an(3))*(logne-2.)
           else
            a=an(4)
         endif
         aeff = 1.e-14*a*te**(b)
         aeff =aeff*(1. +c *(1. - te) +d * (1.-te) ** 2)
         do i=220,310
          em=aeff*1.98648E-08/lamb(i)*g2(i)*br(2,i)
          flux(i)=em/emhb
         end do
!     3d-3p ^2F transitions
         a=0.745
         b=-0.74621
         c=0.15710
         d=0.07059
         an(1)=0.727
         an(2)=0.726
         an(3)=0.725
         an(4)=0.726
        if(logne.le.2) then
            a=an(1)
           elseif(logne.le.4) then
            a=an(1)+(an(2)-an(1))/ 2.*(logne-2.)
           elseif(logne.le.5) then
            a=an(2)+(an(3)-an(2))*(logne-2.)
           elseif(logne.le.6) then
            a=an(3)+(an(4)-an(3))*(logne-2.)
           else
            a=an(4)
         endif
         aeff=1.e-14*a*te**(b)
         aeff=aeff*(1.+c*(1.-te)+d*(1.-te)**2)
         do i=311,328
            em=aeff*1.98648E-08/lamb(i)*g2(i)*br(1,i)
            flux(i)=em/emhb
         end do
!       3d-3p ^2D transitions
         a=0.601
         b=-0.79533
         c=0.15314
         d=0.05322
         an(1)=0.603
         an(2)=0.601
         an(3)=0.600
         an(4)=0.599
        if(logne.le.2) then
            a=an(1)
           elseif(logne.le.4) then
            a=an(1)+(an(2)-an(1))/ 2.*(logne-2.)
           elseif(logne.le.5) then
            a=an(2)+(an(3)-an(2))*(logne-2.)
           elseif(logne.le.6) then
            a=an(3)+(an(4)-an(3))*(logne-2.)
           else
            a=an(4)
         endif
         aeff=1.e-14*a*te**(b)
         aeff=aeff*(1.+c*(1.-te)+d*(1.-te)**2)
         do i=329,358
            em=aeff*1.98648E-08/lamb(i)*g2(i)*br(1,i)
            flux(i)=em/emhb
         end do
!     3d-3p ^2P transitions
         a=0.524
         b=-0.78448
         c=0.13681
         d=0.05608
         an(1)=0.526
         an(2)=0.524
         an(3)=0.523
         an(4)=0.524
        if(logne.le.2) then
            a=an(1)
           elseif(logne.le.4) then
            a=an(1)+(an(2)-an(1))/ 2.*(logne-2.)
           elseif(logne.le.5) then
            a=an(2)+(an(3)-an(2))*(logne-2.)
           elseif(logne.le.6) then
            a=an(3)+(an(4)-an(3))*(logne-2.)
           else
            a=an(4)
         endif
         aeff=1.e-14*a*te**(b)
         aeff=aeff*(1.+c*(1.-te)+d*(1.-te)**2)
         do i=359,388
            em=aeff*1.98648E-08/lamb(i)*g2(i)*br(1,i)
            flux(i)=em/emhb
         end do
!      3p-3s ^4D - ^4P transitions
         a=36.2
         b=-0.736
         c=0.033
         d=0.077
         an(1)=36.
         an(2)=36.2
         an(3)=36.4
         an(4)=36.3
        if(logne.le.2) then
            a=an(1)
           elseif(logne.le.4) then
            a=an(1)+(an(2)-an(1))/ 2.*(logne-2.)
           elseif(logne.le.5) then
            a=an(2)+(an(3)-an(2))*(logne-2.)
           elseif(logne.le.6) then
            a=an(3)+(an(4)-an(3))*(logne-2.)
           else
            a=an(4)
         endif
         aeff=1.e-14*a*te**(b)
         aeff=aeff*(1.+c*(1.-te)+d*(1.-te)**2)
         do i=389,396
            em=aeff*1.98648E-08/lamb(i)*g2(i)*br(2,i)
            flux(i)=em/emhb
         end do
!     3p-3s ^4P - ^4P transitions
         a=14.6
         b=-0.732
         c=0.081
         d=0.066
         an(1)=14.6
         an(2)=14.6
         an(3)=14.7
         an(4)=14.6
        if(logne.le.2) then
            a=an(1)
           elseif(logne.le.4) then
            a=an(1)+(an(2)-an(1))/ 2.*(logne-2.)
           elseif(logne.le.5) then
            a=an(2)+(an(3)-an(2))*(logne-2.)
           elseif(logne.le.6) then
            a=an(3)+(an(4)-an(3))*(logne-2.)
           else
            a=an(4)
         endif
         aeff=1.e-14*a*te**(b)
         aeff=aeff*(1.+c*(1.-te)+d*(1.-te)**2)
         do i=397,403
            em=aeff*1.98648E-08/lamb(i)*g2(i)*br(2,i)
            flux(i)=em/emhb
         end do
!       3p-3s ^4S - ^4P transitions
         a=4.90
         b=-0.730
         c=-0.003
         d=0.057
         an(1)=4.80
         an(2)=4.90
         an(3)=4.90
         an(4)=4.90
        if(logne.le.2) then
            a=an(1)
           elseif(logne.le.4) then
            a=an(1)+(an(2)-an(1))/ 2.*(logne-2.)
           elseif(logne.le.5) then
            a=an(2)+(an(3)-an(2))*(logne-2.)
           elseif(logne.le.6) then
            a=an(3)+(an(4)-an(3))*(logne-2.)
           else
            a=an(4)
         endif
         aeff=1.e-14*a*te**(b)
         aeff=aeff*(1.+c*(1.-te)+d*(1.-te)**2)
         do i=404,406
            em=aeff*1.98648E-08/lamb(i)*g2(i)*br(2,i)
            flux(i)=em/emhb
         end do
!       3p-3s ^2D - ^2P transitions
         a=2.40
         b=-0.550
         c=-0.051
         d=0.178
         an(1)=2.40
         an(2)=2.40
         an(3)=2.50
         an(4)=2.60
        if(logne.le.2) then
            a=an(1)
           elseif(logne.le.4) then
            a=an(1)+(an(2)-an(1))/ 2.*(logne-2.)
           elseif(logne.le.5) then
            a=an(2)+(an(3)-an(2))*(logne-2.)
           elseif(logne.le.6) then
            a=an(3)+(an(4)-an(3))*(logne-2.)
           else
            a=an(4)
         endif
         aeff=1.e-14*a*te**(b)
         aeff=aeff*(1.+c*(1.-te)+d*(1.-te)**2)
         do i=407,409
            em=aeff*1.98648E-08/lamb(i)*g2(i)*br(1,i)
            flux(i)=em/emhb
         end do
!       3p-3s ^2P - ^2P transitions
         a=1.20
         b=-0.523
         c=-0.044
         d=0.173
         an(1)=1.10
         an(2)=1.20
         an(3)=1.20
         an(4)=1.20
        if(logne.le.2) then
            a=an(1)
           elseif(logne.le.4) then
            a=an(1)+(an(2)-an(1))/ 2.*(logne-2.)
           elseif(logne.le.5) then
            a=an(2)+(an(3)-an(2))*(logne-2.)
           elseif(logne.le.6) then
            a=an(3)+(an(4)-an(3))*(logne-2.)
           else
            a=an(4)
         endif
         aeff=1.e-14*a*te**(b)
         aeff=aeff*(1.+c*(1.-te)+d*(1.-te)**2)
         do i=410,413
            em=aeff*1.98648E-08/lamb(i)*g2(i)*br(1,i)
            flux(i)=em/emhb
         end do
!     3p-3s ^2S - ^2P transitions
         a= 0.40
         b=-0.461
         c=-0.083
         d=0.287
         an(1)=0.40
         an(2)=0.40
         an(3)=0.40
         an(4)=0.40
        if(logne.le.2) then
            a=an(1)
           elseif(logne.le.4) then
            a=an(1)+(an(2)-an(1))/ 2.*(logne-2.)
           elseif(logne.le.5) then
            a=an(2)+(an(3)-an(2))*(logne-2.)
           elseif(logne.le.6) then
            a=an(3)+(an(4)-an(3))*(logne-2.)
           else
            a=an(4)
         endif
         aeff=1.e-14*a*te**(b)
         aeff=aeff*(1.+c*(1.-te)+d*(1.-te)**2)
         do i=414,415
            em=aeff*1.98648E-08/lamb(i)*g2(i)*br(1,i)
            flux(i)=em/emhb
         end do
         close(unit=41)
         return
       end subroutine roii


         subroutine rmgii(fluxremg, lambd, tk)
         implicit none
         real, intent(in) :: tk
         real(kind=8),intent(inout) :: fluxremg(500), lambd(500)
         real(kind=8) ::te,ahb,emhb,&
         &         aeff,a,b,c,d,f
         data a,b,c,d,f/27.586,-0.055,-0.039,-0.208,-1.1416/
          te=tk/10000.d0
          ahb=6.68e-14*te**(-0.507)/(1.+1.221*te** 0.653)
          emhb=1.98648E-08/4861.33*ahb
          aeff=1.e-14*a*te**(f)
          aeff=aeff*(1.+b*(1.-te)+c*(1-te)**2+d*(1-te)**3)
          lambd(1)=4481.13
          lambd(2)=4481.15
          lambd(3)=4481.32
          fluxremg(1)=aeff*1.98648E-08/4481.13/emhb*4/7
          fluxremg(2)=aeff*1.98648E-08/4481.15/emhb*28/70
          fluxremg(3)=aeff*1.98648E-08/4481.32/emhb*2/70
         return
         end subroutine rmgii

       subroutine rneii(lamb,flux,tk)
!      ref Kisielius AAS, 133, 257
       implicit none
         real, intent(in) :: tk
         real(kind=8),intent(inout) :: flux(500), lamb(500)
         real(kind=8)  :: te,a,b,c,d,f,ahb,emhb,aeff,br
         integer :: i
         te=tk/10000.d0
         ahb=6.68e-14*te**(-0.507)/(1.+1.221*te** 0.653)
         emhb=1.98648E-08/4861.33*ahb
         open(unit=50,file=PREFIX//'/share/mocassin/data/Rneii.dat',status='old', action="read",position='rewind')
         do i=1,426
          read(50,*) a,b,c,d,f,lamb(i),br
          aeff=1.e-14*a*te**(f)
          aeff=aeff*(1.+b*(1.-te)+c*(1-te)**2+d*(1-te)**3)
          flux(i)=aeff*1.98648E-08/lamb(i)/emhb*br
         end do
!         lamb(427)=4391.986
!         flux(427)=0.0966d-1
!         lamb(428)=4409.299
!           flux(428)=0.0642d-1
!         lamb(429)=4379.552
!          flux(429)=0.0598d-1
!         lamb(430)=4428.611
!           flux(430)=0.0422d-1
!         lamb(431)=4219.745
!          flux(431)=0.0536d-1
!                   lamb(432)=4397.988
!          flux(432)=0.0334d-1
!         lamb(433)=4430.944
!          flux(433)=0.0273d-1
!         lamb(434)=4413.217
!          flux(434)=0.0231d-1
!         lamb(435)=4233.853
!          flux(435)=0.0134d-1
!         lamb(436)=4457.051
!          flux(436)=0.00952d-1
!         lamb(437)=4231.635
!          flux(437)=0.0127d-1
!         lamb(438)=4421.391
!          flux(438)=0.00864d-1
!         lamb(439)=4250.639
!          flux(439)=0.00849d-1
         close(unit=50)
!         return
         end subroutine rneii

         subroutine rcii(lamb,flux,tk)
!        ref Davey A&As 2000 142, 85
         implicit none
         real, intent(in) ::tk
         real(kind=8), intent(inout) :: lamb(500),flux(500)
         real(kind=8)          ::te,a,b,c,d,f,ahb,emhb,aeff,br
         integer :: i
         te=tk/10000.d0
         ahb=6.68e-14*te**(-0.507)/(1.+1.221*te** 0.653)
         emhb=1.98648E-08/4861.33*ahb
         open(unit=51,file=PREFIX//'/share/mocassin/data/Rcii.dat',status='old', position='rewind',action="read")
         do i=1,159
          read(51,*) a,b,c,d,f,lamb(i),br
          aeff=1.e-14*a*te**(f)
          aeff=aeff*(1.+b*(1.-te)+c*(1-te)**2+d*(1-te)**3)
          flux(i)=aeff*1.98648E-08/lamb(i)/emhb*br
         end do
         close(unit=51)
!         return
         end subroutine rcii

         subroutine rnii(lamb,flux,tk,den)
!        ref Storey 2002, A&A, 387, 1135
         implicit none
         real, intent(in):: tk,den
         real(kind=8),  intent(inout) :: lamb(500),flux(500)
         real(kind=8) ::logden,te,a,b,c,d,&
          &    f,u,v,ahb,emhb,aeff,br,y
         integer :: i
          te=tk/10000.d0
          logden=log10(den)
          y=logden-4.
          ahb=6.68e-14*te**(-0.507)/(1.+1.221*te** 0.653)
          emhb=1.98648E-08/4861.33*ahb
          open(unit=52,file=PREFIX//'/share/mocassin/data/Rnii.dat',status='old', action="read",position='rewind')
          do i=1,115
           read(52,*) a,b,c,d,f,u,v,lamb(i),br
           aeff=1.e-14*a*te**(f)
           aeff=aeff*(1+0.01*u*y+0.001*v*y**2)
           aeff=aeff*(1.+b*(1.-te)+c*(1-te)**2+d*(1-te)**3)
           flux(i)=aeff*1.98648E-08/lamb(i)/emhb*br
          end do
           close(unit=52)
!          return
          end subroutine rnii

          subroutine rnii4f(lamb,flux,tk)
!     compute N II 3d--4f, ref Escalante 1990, ApJs, 73, 513
          implicit none
          real, intent(in) :: tk
          real(kind=8), intent(inout) :: lamb(500),flux(500)
          real(kind=8)  :: ahb,emhb,te,aeff,&
           &  a(51),b(51),c(51),br(500),em,a1,b1,c1,d1,z,br1
          integer :: i
          do i=1,500
           lamb(i)=0.d0
           flux(i)=0.d0
          end do
          te=tk/10000.d0
          ahb=6.68e-14*te**(-0.507)/(1.+1.221*te**0.653)
          emhb=1.98648E-08/4861.33*ahb
          open(unit=61,file=PREFIX//"/share/mocassin/data/Rniiold.dat",status='old', action="read",position='rewind')
          open(unit=62,file=PREFIX//"/share/mocassin/data/Rnii_aeff.dat",status='old', action="read",position='rewind')
          do i=1,51
           read(62,*) a(i),b(i),c(i)
          end do
          do i=1,99
           read(61,*) lamb(i),br(i)
          end do
          aeff=10.**(a(41)+b(41)*log10(te)+c(41)*log10(te)**2)
          do i=77,82
           em=aeff*1.98648E-08/lamb(i)*br(i)
           flux(i)=em/emhb
          end do
          aeff=10.**(a(42)+b(42)*log10(te)+c(42)*log10(te)**2)
           em=aeff*1.98648E-08/lamb(83)*br(83)
           flux(83)=em/emhb
          aeff=10.**(a(45)+b(45)*log10(te)+c(45)*log10(te)**2)
          do i=84,89
           em=aeff*1.98648E-08/lamb(i)*br(i)
           flux(i)=em/emhb
          end do
        aeff=10.**(a(47)+b(47)*log10(te)+c(47)*log10(te)**2)
          do i=90,95
           em=aeff*1.98648E-08/lamb(i)*br(i)
           flux(i)=em/emhb
          end do
        aeff=10.**(a(48)+b(48)*log10(te)+c(48)*log10(te)**2)
           em=aeff*1.98648E-08/lamb(96)*br(96)
           flux(96)=em/emhb
        aeff=10.**(a(49)+b(49)*log10(te)+c(49)*log10(te)**2)
           em=aeff*1.98648E-08/lamb(97)*br(97)
           flux(97)=em/emhb
          a1=0.108
          b1=-0.754
          c1=2.587
          d1=0.719
          z=2.
          br1=0.35
          aeff=1.e-13*z*a1*(te/z**2)**(b1)
          aeff=aeff/(1.+c1*(te/z**2)**(d1))*br1
          em=aeff*1.98648E-08/lamb(98)*br(98)
          flux(98)=em/emhb
          a1=0.326
          b1=-0.754
          c1=2.587
          d1=0.719
          z=2.
          Br1=0.074
          aeff=1.e-13*z*a1*(te/z**2)**(b1)
          aeff=aeff/(1.+c1*(te/z**2)**(d1))*br1
          em=aeff*1.98648E-08/lamb(99)*br(99)
          flux(99)=em/emhb
          do i=1,23
           lamb(i)=lamb(i+76)
           flux(i)=flux(i+76)
          end do
          do i=1,99
          end do
          close(unit=61)
          close(unit=62)
!          return
          end  subroutine rnii4f



    ! this subroutine is the driver for the calculation of the emissivity
    ! from the heavy elements forbidden lines.
    subroutine forLines()
        implicit none

        integer                     :: elem, ion ! counters

        ! re-initialize forbiddenLines
        forbiddenLines = 0.

        do elem = 3, nElements
           do ion = 1, min(elem+1, nstages)
              if (.not.lgElementOn(elem)) exit

              if (lgDataAvailable(elem, ion)) then

                 if (elem == 26 .and. ion == 2) then
                    if (nstages>2) then
                       call equilibrium(dataFile(elem, ion), &
                            & ionDenUsed(elementXref(elem),ion+1)/&
                            &ionDenUsed(elementXref(elem),ion), &
                            & TeUsed, NeUsed, forbiddenLinesLarge(:,:), &
                            & wavLarge(:,:))
                    else
                       call equilibrium(dataFile(elem, ion), &
                            &0., &
                            & TeUsed, NeUsed, forbiddenLinesLarge(:,:), &
                            & wavLarge(:,:))
                    end if

                    forbiddenLinesLarge(:, :) =forbiddenLinesLarge(:, :)&
                         *elemAbundanceUsed(elem)*&
                         & ionDenUsed(elementXref(elem), ion)

                 else
                    if (ion<nstages) then
                       call equilibrium(dataFile(elem, ion), &
                            & ionDenUsed(elementXref(elem),ion+1)/&
                            &ionDenUsed(elementXref(elem),ion), &
                            & TeUsed, NeUsed, forbiddenLines(elem, ion,:,:), &
                            & wav(elem,ion,:,:))
                    else
                       call equilibrium(dataFile(elem, ion), 0., &
                            & TeUsed, NeUsed, forbiddenLines(elem, ion,:,:), &
                            wav(elem,ion,:,:))
                    end if

                    forbiddenLines(elem, ion, :, :) =forbiddenLines(elem, ion, :, :)&
                         *elemAbundanceUsed(elem)*&
                         & ionDenUsed(elementXref(elem), ion)
                 end if
              end if

           end do
        end do


        ! scale the forbidden lines emissivity to give units of [10^-25 erg/s/Ngas]
        ! comment: the forbidden line emissivity is so far in units of cm^-1/s/Ngas
        !          the energy [erg] of unit wave number [cm^-1] is 1.9865e-16, hence
        !          the right units are obtained by multiplying by 1.9865e-16*1e25
        !          which is 1.9865*1e9
        forbiddenLines = forbiddenLines*1.9865e9

    end subroutine forLines

    subroutine RecLinesEmission()
        implicit none

        ! local variables
        integer                    :: i           ! counters
        integer                    :: ilow,&      ! pointer to lower level
&                                      iup        ! pointer to upper level
        integer                    :: denint

        real                       :: Hbeta       ! Hbeta emission
        real                       :: HeII4686    ! HeII 4686 emission
        real                       :: Lalpha      ! Lalpha emission
        real                       :: T4          ! TeUsed/10000.
        real                       :: x1,x2
        real                       :: hb          ! emissivity of H 4->2
        real                       :: fh          ! emissivity of H


        T4 = TeUsed / 10000.

        ! do hydrogenic ions first


        ! read in HI recombination lines [e-25 ergs*cm^3/s]
        ! (Storey and Hummer MNRAS 272(1995)41)
!        close(94)
!        open(unit = 94,  action="read", file = "data/r1b0100.dat", status = "old", position = "rewind", iostat=ios)
!        if (ios /= 0) then
!            print*, "! RecLinesEmission: can't open file: data/r1b0100.dat"
!            stop
!        end if
!        do iup = 15, 3, -1
!            read(94, fmt=*) (HIRecLines(iup, ilow), ilow = 2, min(8, iup-1))
!        end do

!        close(94)

        ! calculate Hbeta
        ! Hbeta = 2530./(TeUsed**0.833) ! TeUsed < 26000K CASE
        ! fits to Storey and Hummer MNRAS 272(1995)41
!        Hbeta = 10**(-0.870*log10Te + 3.57)
!        Hbeta = Hbeta*NeUsed*ionDenUsed(elementXref(1),2)*elemAbundanceUsed(1)

        ! calculate emission due to HI recombination lines [e-25 ergs/s/cm^3]
!        do iup = 15, 3, -1
!            do ilow = 2, min(8, iup-1)
!                HIRecLines(iup, ilow) = HIRecLines(iup, ilow)*Hbeta
!            end do
!        end do

        ! calculate Hbeta
!        if (TeUsed > 26000.) then
!           print*, "! recLineEmission: [warning] temperature exceeds 26000K - Hbeta &
!                & calculations may be uncertain"
!        end if
        Hbeta = 2530./(TeUsed**0.833) ! TeUsed < 26000K CASE

        ! fits to Storey and Hummer MNRAS 272(1995)41
!        Hbeta = 10**(-0.870*log10Te + 3.57)
        Hbeta = Hbeta*NeUsed*ionDenUsed(elementXref(1),2)*elemAbundanceUsed(1)

        call hlinex(4,2,TeUsed,NeUsed,fh)
        hb = fh
        do ilow = 2, 8
           do iup = 30, ilow+1, -1
              call hlinex(iup,ilow,TeUsed,NeUsed,fh)
              HIRecLines(iup, ilow) = (fh/hb)*Hbeta
           enddo
        enddo


        ! add contribution of Lyman alpha
        ! fits to Storey and Hummer MNRAS 272(1995)41
        Lalpha = 10**(-0.897*log10Te + 5.05)
        HIRecLines(30, 8) =HIRecLines(30, 8) + elemAbundanceUsed(1)*&
             & ionDenUsed(elementXref(1),2)*&
             & NeUsed*Lalpha

        ! reinitialise HeIIRecLines
        ! file used to be read in here

        HeIIRecLines = HeIIRecLineData

        ! calculate HeII 4686 [E-25 ergs*cm^3/s]
        HeII4686 = 10.**(-.997*log10(TeUsed)+5.16)
        HeII4686 = HeII4686*NeUsed*elemAbundanceUsed(2)*ionDenUsed(elementXref(2),3)

        ! calculate emission due to HeI recombination lines [e-25 ergs/s/cm^3]
        do iup = 30, 3, -1
            do ilow = 2, min(16, iup-1)
                HeIIRecLines(iup, ilow) = HeIIRecLines(iup, ilow)*HeII4686
            end do
        end do

        ! now do HeI

        if (NeUsed <= 100.) then
           denint=0
        elseif (NeUsed > 100. .and. NeUsed <= 1.e4) then
           denint=1
        elseif (NeUsed > 1.e4 .and. NeUsed < 1.e6) then
            denint=2
        elseif (NeUsed >= 1.e6) then
           denint=3
        end if

        ! data from Benjamin, Skillman and Smits ApJ514(1999)307 [e-25 ergs*cm^3/s]
        if (denint>0.and.denint<3) then
           do i =1, 34
              x1=HeIrecLineCoeff(i,denint,1)*(T4**(HeIrecLineCoeff(i,denint,2)))*exp(HeIrecLineCoeff(i,denint,3)/T4)
              x2=HeIrecLineCoeff(i,denint+1,1)*(T4**(HeIrecLineCoeff(i,denint+1,2)))*exp(HeIrecLineCoeff(i,denint+1,3)/T4)
              HeIRecLines(i) = x1+((x2-x1)*(NeUsed-100.**denint)/(100.**(denint+1)-100.**(denint)))
           end do
        elseif(denint==0) then
           do i = 1, 34
              HeIRecLines(i) = HeIrecLineCoeff(i,1,1)*(T4**(HeIrecLineCoeff(i,1,2)))*exp(HeIrecLineCoeff(i,1,3)/T4)
           end do
        elseif(denint==3) then
           do i = 1, 34
              HeIRecLines(i) = HeIrecLineCoeff(i,3,1)*(T4**(HeIrecLineCoeff(i,3,2)))*exp(HeIrecLineCoeff(i,3,3)/T4)
           end do
        end if
        HeIRecLines=HeIRecLines*NeUsed*elemAbundanceUsed(2)*ionDenUsed(elementXref(2),2)

    end subroutine RecLinesEmission

    end subroutine outputGas


    ! read atomic data for higher level H transitions.
    ! authors: Wang Wei, Yu Pei (PKU)
    subroutine hdatx
      implicit none
      integer                    :: ios         ! I/O error status
      integer                    :: ia         ! upper level
      integer                    :: ib         ! lower level
      integer                    :: ntempx     ! number of temperature
      integer                    :: ndensx     ! number of density
      integer                    :: ntop       ! top level
      integer                    :: nll        ! lower level
      integer                    :: nlu        ! upper level
      integer                    :: ne         ! level
      integer                    :: ndum       ! level
      integer                    :: j          ! integer

      real, dimension(15)              :: densx
      real, dimension(15)              :: tempx
      real, dimension(5000,15,15)      :: ex
      common/hdatax/densx,tempx,ex,ntempx,ndensx,ntop,nll,nlu
      close(337)
      open(unit =337, file = PREFIX//"/share/mocassin/data/e1bx.d", status = "old", position = "rewind", iostat=ios, action="read")
        if (ios /= 0) then
             print*, "! hdatax: can't open ",PREFIX,"/share/mocassin/data/e1bx.d"
             stop
        end if

      read(337,*) ntempx,ndensx
        do ia=1,ntempx
           do ib=1,ndensx
                read(337,25) densx(ib),tempx(ia),ntop,ndum,nlu,nll
25              format(1x,e10.3,5x,e10.3,5x,4i5)
                ne=(2*ntop-nlu-nll)*(nlu-nll+1)/2
                read(337,30) (ex(j,ia,ib),j=1,ne)
30              format((8e10.3))
           enddo
        enddo
      close(337)

    end subroutine hdatx



    !  Interpolate in density/temperature for specified line emissivity
    !  Interpolate in density/temperature for specified line emissivity (iopt=1)
    !  or 2s recombination coefficient (iopt=2)
    ! authors Wang Wei and Yu Pei (PKU)
    subroutine hlinex(nu,nl,xt,xd,fh)
      implicit none
      integer                    :: nu         ! upper level
      integer                    :: nl         ! lower level
      integer                    :: ntempx     ! number of temperature
      integer                    :: ndensx     ! number of density
      integer                    :: ntop       ! top level
      integer                    :: nll        ! lower level
      integer                    :: nlu        ! upper level
      integer                    :: id, it, nt, j, i0, k, nls, nus, ncut
      integer                    :: ks, j0, ip, kp, jp, ky, kx, js
      integer                    :: intv, maxv, ns, nint1, nintv, is
      real                       :: nof
      real                       :: xt         ! temperature used
      real                       :: xd         ! density used
      real                       :: fh         ! H atomic data

      real, dimension(15)              :: densx
      real, dimension(15)              :: tempx
      real, dimension(5000,15,15)      :: ex
      real, dimension(15,15)           :: r
      real, dimension(15)               :: x
      real, dimension(15)               :: y
      real, dimension(5)               :: ni
      real, dimension(5)               :: cx
      real, dimension(5)               :: cy
      real, dimension(5)               :: ri
      real, dimension(2,15)            :: f

      integer                    :: i
      real                       :: rint, rrr, xp, yp

      common/hdatax/densx,tempx,ex,ntempx,ndensx,ntop,nll,nlu
      data maxv/4/ni/2,3,4,5,6/       ! interpolation parameters

      ncut=0 ! RW 19/06/2016 - was not initialised previously
!          interpolation variables
        do i=1,ndensx
            x(i)=log10(densx(i))
        enddo
        do i=1,ntempx
            y(i)=sqrt(tempx(i))
            f(1,i)=1.0          ! f is emissivity smoothing function in temp
            f(2,i)=y(i)
        enddo
            nus=0
            nls=0
!          set keys to locate transitions of interest
        if((nus+nls).eq.0) then
             ns=2
             ks=999
        else
             ns=1
             ks=(((ncut-nus)*(ncut+nus-1))/2)+nls
        endif
             k=(2*ntop-nll-nl+1)*(nl-nll)/2+ntop-nu+1

        do it=1,ntempx
           do id=1,ndensx
                if(ns.eq.1) then
                     r(it,id)=ex(k,it,id)/ex(ks,it,id)
                else
                     r(it,id)=ex(k,it,id)
                endif
           enddo
        enddo
!          interpolate in r-table
        nt=1

        xp=log10(xd)           ! interpolate in log(dens)
        yp=sqrt(xt)             ! interpolate in temp**0.5
!          find interpolation box
        i=1
        if(xp.lt.x(i)) then
                goto 88
        endif
86      if(xp.ge.x(i).and.xp.le.x(i+1)) then
                goto 88
        else
            i=i+1
            if(i.eq.ndensx) then
                  i = ndensx - 1
!                     stop 'dens overflow'
            endif
                goto 86
        endif
88      i0=i
        j=1
        if(yp.lt.y(j)) then
                goto 92
        endif
90      if(yp.ge.y(j).and.yp.le.y(j+1)) then
                goto 92
        else
           j = j+1
           if(j.eq.ntempx) then
           j = ntempx - 1
                goto 92
!              stop 'temp overflow'
           endif
                goto 90
        endif
92      j0=j
        intv=maxv
        nintv=nint(ni(intv))             ! interpolation order
        nint1=nintv-1
        nof=nint1/2
!          shift i0 to nearest box boundary in each direction if nint is odd
        if(nintv.eq.3.or.nintv.eq.5.or.nintv.eq.7) then  ! note ODD order
            if((xp-x(i0)).gt.(x(i0+1)-xp)) then
                is=nint(i0+1-nof)
            else
                is=nint(i0-nof)
            endif
            if((yp-y(j0)).gt.(y(j0+1)-yp)) then
                js=nint(j0+1-nof)
            else
                js=nint(j0-nof)
            endif
        else
            is=nint(i0-nof)
            js=nint(j0-nof)
        endif
!          ensure that interpolation box lies in table
        if(is.lt.1) then
            is=1
        endif
        if((is+nint1).gt.ndensx) then
            is=ndensx-nint1
        endif
        if(js.lt.1) then
            js=1
        endif
        if((js+nint1).gt.ntempx) then
            js=ntempx-nint1
        endif
        do k=1,nintv
             i=is+k-1
             cx(k)=1.0
           do kp=1,nintv
              if(kp.ne.k) then
                 ip=is+kp-1
                 cx(k)=cx(k)*(xp-x(ip))/(x(i)-x(ip))
              endif
           enddo
        enddo
        do k=1,nintv
            j=js+k-1
            cy(k)=1.0
           do kp=1,nintv
              if(kp.ne.k) then
                 jp=js+kp-1
                 cy(k)=cy(k)*(yp-y(jp))/(y(j)-y(jp))
              endif
           enddo
        enddo
          rint=0.0
        do kx=1,nintv
           do ky=1,nintv
             if((js+ky-1).gt.ntempx.or.(is+kx-1).gt.ndensx) then
                stop 'final loop error'
             endif
                rrr=r(js+ky-1,is+kx-1)*f(ns,js+ky-1) ! smoothing ftn
             if(nt.ne.0) then
                rrr=log(rrr)
             endif
             rint=rint+cx(kx)*cy(ky)*rrr
           enddo
        enddo

        ri(intv)=rint
        if(nt.ne.0) then
           ri(intv)=exp(ri(intv))
        endif
        if(ns.eq.2) then
           ri(intv)=ri(intv)/yp ! remove smoothing function = temp**.5
        endif
        fh=ri(maxv)
!        return
      end subroutine hlinex

    subroutine writeTauNu(grid)
      implicit none

      type(grid_type), intent(in) :: grid(*)

      type(vector) :: aVec, uHat

      real, allocatable :: outTau(:)

      integer :: err, i, ios

      ! find the run of the optical depths from the illuminated
      ! surface to the edge of the nebula

      ! allocate space for temporary optical depth arrays
      allocate (outTau(1:nbins), stat = err)
      if (err /= 0) then
         print*, "! adjustGrid: can't allocate array memory"
         stop
      end if

      close(73)

      open(unit=73, file='output/tauNu.out', status='unknown', position='rewind', iostat = ios, action="write")


      ! initialize arrays with zero
      outTau = 0.

      do i = 1, nbins

         aVec%x = 0.
         aVec%y = 0.
         aVec%z = 0.

         uHat%x = 1.
         uHat%y = 0.
         uHat%z = 0.

         ! find the optical depth
         call integratePathTauNu(grid, aVec, uHat, i, outTau(i))

      end do


      write(73, *) " Optical depth from the centre to the edge of the nubula "
      write(73, *) " direction: 1,0,0"
      write(73, *) " lambda [um]    tau(R_max) "

      do i = 1, nbins
         write(73, *) (c/(nuArray(i)*fr1Ryd))*1.e4, outTau(i)
      end do

      write(73,*) ' '

      ! initialize arrays with zero
      outTau = 0.

      do i = 1, nbins

         aVec%x = 0.
         aVec%y = 0.
         aVec%z = 0.

         uHat%x = 0.
         uHat%y = 0.
         uHat%z = 1.

         ! find the optical depth
         call integratePathTauNu(grid, aVec, uHat, i, outTau(i))

      end do


      write(73, *) " Optical depth from the centre to the edge of the nubula "
      write(73, *) " direction: 0,0,1"
      write(73, *) " lambda [um]    tau(R_max) "

      do i = 1, nbins
         write(73, *) (c/(nuArray(i)*fr1Ryd))*1.e4, outTau(i)
      end do

      write(73,*) ' '

      ! initialize arrays with zero
      outTau = 0.

      do i = 1, nbins

         aVec%x = 0.
         aVec%y = 0.
         aVec%z = 0.

         uHat%x = 0.
         uHat%y = 1.
         uHat%z = 0.

         ! find the optical depth
         call integratePathTauNu(grid, aVec, uHat, i, outTau(i))

      end do


      write(73, *) " Optical depth from the centre to the edge of the nubula "
      write(73, *) " direction: 0,1,0"
      write(73, *) " lambda [um]    tau(R_max) "

      do i = 1, nbins
         write(73, *) (c/(nuArray(i)*fr1Ryd))*1.e4, outTau(i)
      end do

      write(73,*) ' '





      close(73)

      if(allocated(outTau)) deallocate(outTau)

    end subroutine writeTauNu


    subroutine writeSED(grid)
      implicit none

      type(grid_type), intent(in) :: grid(*)     !

      integer :: ios, err                        ! I/O error status
      integer :: i,j,k,freq, imu, iG, ic, ijk    ! counters

      real, allocatable :: SED(:,:),sSED(:,:),dSED(:,:)               ! SED array

      real          :: theta1, theta2, phi1, phi2
      real          :: lambda                    ! lambda [cm]
      real          :: totalE                    ! total energy [erg/sec]

      print*, 'in writeSED'

      close(16)

      open(unit=16,file='output/SED.out',status='unknown', position='rewind',iostat=ios, action="write")
      if (ios /= 0) then
         print*, "! writeSED: Cannot open output/SED.out for writing"
         stop
      end if

!      open(unit=116,file='output/sourceSED.out',status='unknown', position='rewind',iostat=ios, action="write")
!      if (ios /= 0) then
!         print*, "! writeSED: Cannot open output/sourceSED.out for writing"
!         stop
!      end if

      allocate(SED(1:nbins,0:nAngleBins), stat=err)
      allocate(sSED(1:nbins,0:nAngleBins), stat=err)
!      allocate(dSED(1:nbins,0:nAngleBins), stat=err)
      if (err /= 0) then
         print*, "! writeSED: can't allocate array memory: SED"
         stop
      end if


      SED=0.
!      sSED=0.
!      dSED=0.

      write(16,*) 'Spectral energy distribution at the surface of the nebula: '
      write(16,*) '  viewPoints = ', (viewPointTheta(i), viewPointPhi(i), ' , ', i = 1, nAngleBins)
      write(16,*) '   nu [Ryd]        lambda [um]         F(nu)*D^2            '
     write(16,*) '                                       [Jy * pc^2]              '

!      write(116,*) 'Spectral energy distribution of sources: '
!      write(116,*) '   nu [Ryd]        lambda [um]         F(nu)*D^2            '
!     write(116,*) '                                       [Jy * pc^2]              '

      totalE=0.

      do iG = 1, nGrids
       do freq=1,nbins
          if (.not.lgEcho .and. .not.lgNosource) then
             do i = 0, grid(iG)%nCells
                do imu = 0, nAngleBins
                   SED(freq,imu)=SED(freq,imu)+grid(iG)%escapedPackets(i,freq,&
                        &imu)
                end do
             end do
          else
             do i = 1, grid(iG)%nx
              do j = 1, grid(iG)%ny
               do k = 1, grid(iG)%nz
                ijk = grid(iG)%active(i,j,k)
                if (ijk.gt.0) then
!                   do ic=1,nStars
!                      if (grid(iG)%active(starIndeces(ic,1),&
!                           &starIndeces(ic,2),starIndeces(ic,3)).eq.ijk) then
!                         do imu = 0, nAngleBins
!                            sSED(freq,imu)=sSED(freq,imu)+&
!                                 &grid(iG)%escapedPackets(ijk,freq,imu)
!                         end do
!                      endif
!                   enddo
                   if (.not.lgEcho) then
                      if (lgNosource) then ! exclude source if requested
                         do ic=1,nStars
                            if (grid(iG)%active(starIndeces(ic,1),&
                                 &starIndeces(ic,2),starIndeces(ic,3)).ne.ijk)&
                                 & then
                               do imu = 0, nAngleBins
                                  SED(freq,imu)=SED(freq,imu)+&
                                       &grid(iG)%escapedPackets(ijk,freq,imu)
                               end do
                            endif
                         enddo
                      end if
                   else ! only get SED from region defined by light echo
                      do imu = 0, nAngleBins
                         SED(freq,imu)=SED(freq,imu)+&
                              &grid(iG)%escapedPackets(ijk,freq,imu)*&
                              &grid(iG)%echoVol(i,j,k)
! mult by echoVol() corrects for actual percentage of cell that was illuminated
                      end do
                   endif
                endif
               enddo
              enddo
             enddo
            endif
         end do
      end do



      do freq = 1, nbins
!         do imu = 1, nAngleBins
!            if (viewPointTheta(imu)>0.) SED(freq,imu) = SED(freq,imu)/dTheta
!            if (viewPointPhi(imu)>0.) SED(freq,imu) = SED(freq,imu)/dPhi
!         end do

         lambda = c/(nuArray(freq)*fr1Ryd)


         if (lgSymmetricXYZ) then
            SED(freq,0) = SED(freq,0)*8.
!            sSED(freq,0) = sSED(freq,0)*8.
            SED(freq,1:nanglebins) = SED(freq,1:nanglebins)*4.
         endif


         totalE = totalE +  SED(freq,0)

         ! dilute the SEDs -  user must still divide by D^2 in pc
         ! the 1.e18 is absorbed later
         SED(freq,0) = SED(freq,0)/(4.*Pi*3.08*3.08)
!         sSED(freq,0) = sSED(freq,0)/(4.*Pi*3.08*3.08)
         ! convert to Jy
         SED(freq,0) = 1.e23*SED(freq,0)/(3.2898e15*widflx(freq))
!         sSED(freq,0) = 1.e23*SED(freq,0)/(3.2898e15)*widflx(freq)


         do imu = 1, nAngleBins

            ! find theta1 and theta2
            theta1 = int(viewPointTheta(imu)/dTheta)*dTheta
            theta2 = theta1+dTheta
            ! find phi1 and phi2
            phi1 = int(viewPointPhi(imu)/dPhi)*dPhi
            phi2 = phi1+dPhi

!            SED(freq, imu) = SED(freq, imu)/(2.*Pi*3.08*3.08*abs(cos(theta1)-cos(theta2)))
            SED(freq, imu) = SED(freq, imu)/(dPhi*3.08*3.08*abs(cos(theta1)-cos(theta2)))

            SED(freq, imu) = 1.e23*SED(freq, imu)/(3.2898e15*widflx(freq))

         end do

         write(16,*) nuArray(freq), c/(nuArray(freq)*fr1Ryd)*1.e4, (SED(freq,imu), imu=0,nAngleBins )
!         write(6,'(a1,1pg12.4,4es12.4)')"d",c/(nuArray(freq)*fr1Ryd)*1.e4,widflx(freq),SED(freq,0),sSED(freq,0),dSED(freq,0)

!         write(116,*) nuArray(freq), c/(nuArray(freq)*fr1Ryd)*1.e4, sSED(freq,0)

      end do

      if (lgEquivalentTau .and. nIterateMC==1) then
         SEDnoExt = SED(:,0)
      elseif (lgEquivalentTau .and. nIterateMC>1) then

         open (unit=74,file='output/equivalentTau.out',action='write', position='rewind',&
              & iostat=ios, status='unknown')

         do freq = 1, nbins
            if (SEDnoExt(freq)>0. .and. SED(freq,0)>0.) then
               equivalentTau(freq) = log(SEDnoExt(freq)/SED(freq,0))
            else
               equivalentTau(freq) = -1
            end if

            write(74,*) nuArray(freq), c/(nuArray(freq)*fr1Ryd)*1.e4, equivalentTau(freq), SEDnoExt(freq)

         end do

         close(74)


      end if


      write(16,*) ' '
      write(16,*) 'Total energy radiated out of the nebula [e36 erg/s]:', totalE
      print*, 'Total energy radiated out of the nebula [e36 erg/s]:', totalE, Lstar, nphotons
!      write(16,*) 'All SEDs given per unit direction'
!      write(16,*) 'To obtain total emission over all directions must multiply by Pi'

      write(16,*) 'dTheta: ', dTheta
      write(16,*) 'dPhi: ', dPhi


      write(16,*) ' '
      if (nuArray(1)<radio4p9GHzP) then
         write(16,*) 'Flux at 4.9GHz (must multiply by 1.e36/(4 Pi D[cm]^2 to obtain units of [Jy]) :', &
              & SED(radio4p9GHzP,0)*Pi*1.e23/(nuArray(radio4p9GHzP)*fr1Ryd)
         print*, 'Flux at 4.9GHz (must multiply by 1.e36/(4 Pi D[cm]^2 to obtain units of [Jy]) :', &
              & SED(radio4p9GHzP,0)*Pi*1.e23/(nuArray(radio4p9GHzP)*fr1Ryd)
      end if

      close(16)
!      close(116)

      if (allocated(SED)) deallocate(SED)
      if (allocated(sSED)) deallocate(sSED)
      if (allocated(dSED)) deallocate(dSED)

      print*, 'out writeSED...'

    end subroutine writeSED


    subroutine writeContCube(grid, freq1,freq2)
      implicit none

      type(grid_type), intent(in) :: grid(*)

      integer :: ios,ix,iy,iz, iG        ! I/O error status, counters
      integer ::  freq, imu, ifreq1, ifreq2      ! counters

      real, intent(inout)         :: freq1,freq2 ! wavelengths in um
      real                        :: contI(0:nanglebins) ! continuum int in band

      print*, 'in writeContCube'


      close(19)

      open(unit=19,file='output/contCube.out',status='unknown', position='rewind',iostat=ios, action="write")
      if (ios /= 0) then
         print*, "! writeContCube: Cannot open file for writing"
         stop
      end if

      freq1 = c/(freq1*1.e-4*fr1Ryd)
      freq2 = c/(freq2*1.e-4*fr1Ryd)

      call locate(nuArray(1:nbins), freq1, ifreq2)
      if (ifreq2 <= 0) ifreq2=1

      call locate(nuArray(1:nbins), freq2, ifreq1)
      if (ifreq1 <= 0) ifreq1=1


      do iG = 1, nGrids

         do ix = 1, grid(iG)%nx
            do iy = 1, grid(iG)%ny
               do iz = 1, grid(iG)%nz

                  if ( grid(iG)%active(ix,iy,iz)>0 .or. (ig==1 .and. &
                       & ix==iorigin .and. iy==jorigin .and.iz==korigin) ) then

                     do imu=0,nanglebins
                        contI(imu)=0.
!                        do freq = ifreq1, ifreq2
                        do freq = 1, nbins
                           contI(imu) = contI(imu)+&
                                & grid(iG)%escapedPackets(grid(iG)%active(ix,iy,iz),freq,imu)
                        end do

                        if (imu>0) then
                           if (viewPointTheta(imu)>0.) contI(imu) = contI(imu) / dTheta
                           if (viewPointPhi(imu)>0.) contI(imu) = contI(imu) / dPhi
                        else
                           contI(imu) = contI(imu) / (4.*Pi)
                        end if

                     end do

                     write(19,*) iG, ix,iy,iz, (contI(imu), imu=0,nanglebins)

                  else

                     write(19,*) iG, ix,iy,iz, (0., imu=0,nanglebins)

                  end if

               end do
            end do
         end do

      end do


      write(19,*) ' '
      write(19,*) 'All continuum intensities given per unit direction - must multiply column 3&
           & by 4. Pi to obtain total emission over all directions.'


      close(19)

      print*, 'writeContCube'

    end subroutine writeContCube

end module output_mod

! Copyright (C) 2005 Barbara Ercolano
!
! Version 2.02
module xSec_mod

    use common_mod
    use constants_mod
    use elements_mod
    use interpolation_mod
    implicit none


    real, private, allocatable, dimension(:) :: xSecArrayTemp ! temporary xSec array


    public

    ! common variables
    integer, save                      :: bremsXSecP  ! pointer to the brems x section in xSecArray
    integer, save, dimension(nHlevel)  :: HlevXSecP   ! pointer to the nth H level in xSecArray
    integer, save, dimension(9)        :: HeISingXSecP! pointer to the HeI singlet in xSecArray
    integer, save, dimension(9)        :: HeIIXSecP   ! pointer to the HeII bound free in xSecArray
    integer, save, dimension(7)        :: level
    integer, save, dimension(30)       :: nInn
    integer, save, dimension(30)       :: nTot
    integer, save                      :: xSecTop     ! pointer to the top entry of xSecArray


    contains

    subroutine initGammaCont()
      implicit none

      integer :: err ! allocation, i/o error
      integer :: ntkold, itk, i

      print*, 'in initGammaCont'

      close(21)
      open(file=PREFIX//'/share/mocassin/data/gammaHI.dat', unit=21, status='old', iostat = err, action="read")
      if (err /= 0) then
         print*, "! initGammaCont: can't open file: ",PREFIX,"/share/mocassin/data/gammaHI"
         stop
      end if
      close(22)
      open(file=PREFIX//'/share/mocassin/data/gammaHeI.dat', unit=22, status='old', iostat = err, action="read")
      if (err /= 0) then
         print*, "! initGammaCont: can't open file: ",PREFIX,"/share/mocassin/data/gammaHeI"
         stop
      end if
      close(23)
      open(file=PREFIX//'/share/mocassin/data/gammaHeII.dat', unit=23, status='old', iostat = err, action="read")
      if (err /= 0) then
         print*, "! initGammaCont: can't open file: ",PREFIX,"/share/mocassin/data/gammaHeII"
         stop
      end if

      read(21, *) nTkGamma, nlimGammaHI
      ntkold=nTkGamma

      read(22, *) nTkGamma, nlimGammaHeI
      if (ntkold /= ntkGamma) then
         print*, '! initGammaCont: the number of temperature points must &
              & be the same  for all gammas'
         stop
      end if

      read(23, *) nTkGamma, nlimGammaHeII
      if (ntkold /= ntkGamma) then
         print*, '! initGammaCont: the number of temperature points must &
              & be the same  for all gammas'
         stop
      end if

      allocate(tkGamma(nTkGamma), stat=err)
      if (err /= 0) then
         print*, "! initGammaCont: Cannot allocate grid array -0"
         stop
      end if

      allocate(nuGammaHI(nlimGammaHI), stat=err)
      if (err /= 0) then
         print*, "! initGammaCont: Cannot allocate grid array -01"
         stop
      end if
      allocate(nuGammaHeI(nlimGammaHeI), stat=err)
      if (err /= 0) then
         print*, "! initGammaCont: Cannot allocate grid array -02"
         stop
      end if
      allocate(nuGammaHeII(nlimGammaHeII), stat=err)
      if (err /= 0) then
         print*, "! initGammaCont: Cannot allocate grid array -03"
         stop
      end if
      allocate(HINuEdgeP(nlimGammaHI), stat=err)
      if (err /= 0) then
         print*, "! initGammaCont: Cannot allocate grid array -03"
         stop
      end if
      allocate(HeINuEdgeP(nlimGammaHeI), stat=err)
      if (err /= 0) then
         print*, "! initGammaCont: Cannot allocate grid array -03"
         stop
      end if
      allocate(HeIINuEdgeP(nlimGammaHeII), stat=err)
      if (err /= 0) then
         print*, "! initGammaCont: Cannot allocate grid array -03"
         stop
      end if



      read (21,*) (tkGamma(i), i=1,ntkgamma)
      read (22,*) (tkGamma(i), i=1,ntkgamma)
      read (23,*) (tkGamma(i), i=1,ntkgamma)

      ! allocate logGammaHI, logGammaHeI, logGammaHeII
      allocate(logGammaHI(nTkGamma, nlimGammaHI), stat=err)
      if (err /= 0) then
         print*, "! initGammaCont: Cannot allocate grid array -1"
         stop
      end if
      allocate(logGammaHeI(nTkGamma, nlimGammaHeI), stat=err)
      if (err /= 0) then
         print*, "! initGammaCont: Cannot allocate grid array -2"
         stop
      end if
      allocate(logGammaHeII(nTkGamma, nlimGammaHeII), stat=err)
      if (err /= 0) then
         print*, "! initGammaCont: Cannot allocate grid array -3"
         stop
      end if

      do i = 1, nlimGammaHI
         read(21,*) nuGammaHI(i), (logGammaHI(itk, i), itk=1, nTkGamma)
         call locate(nuArray(1:nbins), nuGammaHI(i), HINuEdgeP(i))
         if (HINuEdgeP(i)<nbins) then
            if (nuGammaHI(i) > (nuArray(HINuEdgeP(i))+nuArray(HINuEdgeP(i)+1))/2.) &
                 & HINuEdgeP(i) = HINuEdgeP(i)+1
         end if
      end do

      do itk = 1, ntkgamma
         do i = 1, nlimGammaHI
            if (logGammaHI(itk,i)>0.) then
               logGammaHI(itk,i) = log10(logGammaHI(itk,i))
            else
               logGammaHI(itk,i) = 0.
            end if
         end do
      end do

      do i = 1, nlimGammaHeI
         read(22,*) nuGammaHeI(i), (logGammaHeI(itk,i), itk=1, nTkGamma)
         call locate(nuArray(1:nbins), nuGammaHeI(i), HeINuEdgeP(i))
         if (HeINuEdgeP(i)<nbins) then
            if (nuGammaHeI(i) > (nuArray(HeINuEdgeP(i))+nuArray(HeINuEdgeP(i)+1))/2.) &
                 & HeINuEdgeP(i) = HeINuEdgeP(i)+1
         end if
      end do

      do itk = 1, ntkgamma
         do i = 1, nlimGammaHeI
            if (logGammaHeI(itk,i)>0.) then
               logGammaHeI(itk,i) = log10(logGammaHeI(itk,i))
            else
               logGammaHeI(itk,i) = 0.
            end if
         end do
      end do

      do i = 1, nlimGammaHeII
         read(23,*) nuGammaHeII(i), (logGammaHeII(itk,i), itk=1, nTkGamma)
         call locate(nuArray(1:nbins), nuGammaHeII(i), HeIINuEdgeP(i))
         if (HeIINuEdgeP(i)<nbins) then
            if (nuGammaHeII(i) > (nuArray(HeIINuEdgeP(i))+nuArray(HeIINuEdgeP(i)+1))/2.) &
                 & HeIINuEdgeP(i) = HeIINuEdgeP(i)+1
         end if
      end do

      do itk = 1, ntkgamma
         do i = 1, nlimGammaHeII
            if (logGammaHeII(itk,i)>0.) then
               logGammaHeII(itk,i) = log10(logGammaHeII(itk,i))
            else
               logGammaHeII(itk,i) = 0.
            end if
         end do
      end do

      close(21)
      close(22)
      close(23)

      HINuEdgeP(1) = 1
      HeINuEdgeP(1) = 1
      HeIINuEdgeP(1) = 1

      print*, 'out initGammaCont'

    end subroutine initGammaCont

    subroutine initXSecArray()
        implicit none

        ! local variables
        integer :: err                        ! allocation error status
        integer :: i                          ! counter
        integer :: n                          ! principle QN


        real :: alpha, beta, dx
        real :: thom
        real :: thres                         ! energy threshold [eV]
        real :: xSec                          ! x Section
        real :: x                             ! log10(W/W0) (for use in phFitHIon)
        real :: z                             ! Z

        print*, 'in initXSecArray'



        ! allocate memory for xSecArrayTemp
        allocate (xSecArrayTemp(1:1000000), stat = err)
        if (err /= 0) then
            print*, "! initXSecArray: Cannot allocate grid array"
            stop
        end if


        ! zero out arrays
        xSecArrayTemp = 0.

        ! initialize top of stack pointer, xSecTop
        xSecTop = 0

        if (lgGas) then

           ! Hydrogen Lyman continuum

           HlevXSecP(1) = xSecTop + 1 ! set pointer to the Lyman continuum

           ! set pointers on the energy array nuArray
           call setPointers()

           call makeCollIonData()

           call makeAugerData()

           ! Compton XSecs
           if (lgCompton) then
              ! set up Klein-Nishina X-sec arrays
              call setCompton()

              allocate(comXSecC(nbins), stat=err)
              if (err /= 0) then
                 print*, "! initXSecArray: Cannot allocate grid array"
                 stop
              end if
              allocate(comXSecH(nbins), stat=err)
              if (err /= 0) then
                 print*, "! initXSecArray: Cannot allocate grid array"
                 stop
              end if
              allocate(xSecRecoil(nbins), stat=err)
              if (err /= 0) then
                 print*, "! initXSecArray: Cannot allocate grid array"
                 stop
              end if
              comXSecC=0.
              comXSecH=0.
              xSecRecoil=0.

              ! thomson scattering up to 20.6Ryd xrayP
              thom = 6.65e-25

              do i = 1, nbins
                 ! Compton exchange factors from Tarter
                 alpha = 1./ ( 1. + nuArray(i)* ( 1.1792e-4 + 7.084e-10*nuArray(i) ) )
                 beta = (1. - alpha * nuArray(i)*(1.1792e-4+2.*7.084e-10*nuArray(i))/4.)

                 comXSecH(i) = alpha * nuArray(i)*nuArray(i) * 3.858e-25
                 comXSecC(i) = alpha * beta * nuArray(i) * 3.858e-25

                 if (i<=xrayP) then
                    xSecRecoil(i) = thom
                 else
                    dx = nuArray(i)/3.7573e4
                    xSecRecoil(i)=thom * 3./4.*( (1.+dx)/dx**3 * (2.*dx*(1.+dx)/(1.+2.*dx) - &
                         & log( 1.+2.*dx ) ) + 1./2./dx*log(1.+2.*dx) - &
                         & (1.+3.*dx)/(1.+2.*dx)**3 )
                 end if

              end do

           end if

           do i = HlevNuP(1), nbins
              thres = max(nuArray(i)*RydToeV, ph1(1, 1, 1, 1))
              call phFitEl(1, 1, 1, thres, xSec)
              xSecArrayTemp(i-HlevNuP(1)+HlevXSecP(1)) = xSec*1e-18
           end do
           xSecTop = xSecTop + nbins - HlevNuP(1) + 1

           ! Balmer, Paschen etc. continua (up to n= 10)
           do n = 2, nHlevel
              HlevXSecP(n) = xSecTop + 1 ! set the pointers to the various continua
              do i = HlevNuP(n), HlevNuP(1)
                 x = log10(nuArray(i)) - log10(nuArray(HlevNuP(n)))
                 xSecArrayTemp(i-HlevNuP(n) + HlevXSecP(n)) = phFitHIon(x, n, 1.)
              end do
              xSecTop = xSecTop + HlevNuP(1) - HlevNuP(n) +1

           end do

           ! free-free opacity (bremstrahlung)
           bremsXSecP = xSecTop+1
           do i = 1, nbins
              ! factor of 1e-20 missing to avoid underflow
              ! free-free opacity needs g(ff)*(1-exp(hn/kT))/sqrt(T)*1e-20
              xSecArrayTemp(i-1+bremsXSecP) = 1.03680e-18/(nuArray(i)**3)
           end do
           xSecTop = xSecTop + nbins -1 +1

           ! HeI singlet neutral Helium ground
           HeISingXSecP(1) = xSecTop + 1
           do i = HeIlevNuP(1), nbins
              call phFitEl(2, 2, 1, nuArray(i)*RydToeV, xSec)
              xSecArrayTemp(i-HeIlevNuP(1)+HeISingXSecP(1)) = xSec*1e-18
           end do
           xSecTop = xSecTop + nbins - HeIlevNuP(1) + 1

           ! HeI neutral He 21S from StewartJPhysB 11, L431
           call powLawXSec(HeIlevNuP(2), HeIlevNuP(1), 0.4*8.7e-18, 1.5, HeISingXSecP(2))

           ! HeI singlet bound free excited states
           z = 1.
           do n = 3, nHeIlevel
              xSec = 7.906e-18*float(n) / (z*z)
              call powLawXSec(HeIlevNuP(n), HeIlevNuP(1), xSec, 3.0, HeISingXSecP(n))
           end do

           ! HeII ionized Helium bound free ground state
           HeIIXSecP(1)  = xSecTop + 1
           do i = HeIIlevNuP(1), nbins
              thres = max(nuArray(i)*RydToeV, ph1(1,2,1,1))
              call phFitEl(2, 1, 1, thres, xSec)
              xSecArrayTemp(i-HeIIlevNuP(1)+HeIIXSecP(1)) = xSec*1e-18
           end do
           xSecTop = xSecTop + nbins - HeIIlevNuP(1) +1

           ! HeII ionized Helium bound free excited state
           z = 2.
           do n = 2, nHeIIlevel
              xSec = 7.906e-18*float(n) / (z*z)
              HeIIXSecP(n) = xSecTop + 1
              do i = HeIIlevNuP(n), HeIIlevNuP(1)
                 x = log10(nuArray(i)) - log10(nuArray(HeIIlevNuP(n)))
                 xSecArrayTemp(i-HeIIlevNuP(n)+HeIIXSecP(n)) = phFitHIon(x, n, 2.)
              end do
              xSecTop = xSecTop + HeIIlevNuP(1) - HeIIlevNuP(n) + 1
           end do

           do i = 3, nElements

              if (lgElementOn(i)) call makeOpacity(i)
           end do

           ! set up dust constants and calculate dust extinction cross-sections
           if (lgDust) call makeDustXsec()

        else if (lgDust) then

           call makeDustXsec()

        else

           print*, '! initXSecArray: no gas or dust! the grid is empty.'
           stop

        end if


        ! allocate just enough space to XSecArray
        allocate (xSecArray(1:XSecTop), stat = err)
        if (err /= 0) then
           print*, "! initXSecArray: Cannot allocate grid array"
           stop
        end if

        ! assign the values to XSecArray
        do i=1, XSecTop
           xSecArray(i) = xSecArrayTemp(i)
        end do

        ! free the space occupated by XSecArrayTemp
        if (allocated(XSecArrayTemp)) deallocate(XSecArrayTemp)

        print*, 'out initXSecArray'

      end subroutine initXSecArray


       ! this subroutines reads the ph1 and ph2 parameters needed by the subroutine phFitEl
       ! from the data/ph1.dat and the data/ph2.dat files. also it the level, nInn and
       ! nTot arrays are initialised here
       subroutine phInit()

         ! local variables
         integer :: ios,nt          ! I/O error status
         integer :: i, j, k , l     ! counters

         ! initialise arrays
         level = (/0, 0, 1, 0, 1, 2, 0/)
         nInn  = (/0,0,1,1,1,1,1,1,1,1,3,3, &
              &  3,3,3,3,3,3,5,5,5,5,5,5,5,5,5,5,5,5/)
         nTot  = (/1,1,2,2,3,3,3,3,3,3,4,4, &
              &  5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,7,7/)


         ! open data/ph1.dat file and check for errors in opening
         close(10)
         open(unit = 10, file = PREFIX//"/share/mocassin/data/ph1.dat", status = "old",&
              &  position = "rewind", iostat = ios, action="read")
         if (ios /= 0) then
            print*, "! phInit: can't open file: ",PREFIX,"/share/mocassin/data/ph1.dat"
            stop
         end if

         ! open data/ph2.dat file and check for errors in opening
         close(20)
         open(unit = 20, file = PREFIX//"/share/mocassin/data/ph2.dat", status = "old",&
              &  position = "rewind", iostat = ios, action="read")
         if (ios /= 0) then
            print*, "! phInit: can't open file: ",PREFIX,"/share/mocassin/data/ph2.dat"
            stop
         end if

         ! read data/ph1.dat file and check for errors in reading
         do j = 1, 30
               do k = 1, min(j,30)
                  nt = nTot(k)
                  if (j==k .and.k>18) nt = 7
                  if (j==k+1 .and. &
                       &(j==20.or.j==21.or.j==22.or.j==25.or.j==26)) nt = 7
                  do l = 1, nt
                     read(unit = 10, fmt = *) (ph1(i, j, k, l), i=1, 6)
               end do
            end do
         end do

         ! read data/ph2.dat file and check for errors in reading
         do k = 1, 30
            do j = 1, min(k,30)
               if (k /= 15 .and. k /= 17 .and. k /= 19 .and. &
                    &(k<=20 .or. k==26) ) then
                  read(unit = 20, fmt = *)  (ph2(i, k,j), i=1, 7)
               end if
            end do
         end do

         close(10)
         close(20)

       end subroutine phInit

       ! this subroutine calculates partial photoionization cross sections for
       ! all ionization stages of all atoms from H to Zn (Z=30) using the following
       ! fit parameters:
       ! outer shell of the Opacity Project (OP) elements: Verner, Ferland, Korista
       !    Yakovlev, 1996, ApJ, 465, 487
       ! inner shells of all elements, and outer shells of the non OP elements:
       !    Verner and Yakovlev, 1995, A&AS, 109, 125
       ! shell numbers:
       ! 1 - 1s; 2 - 2s; 3 - 2p; 4 - 3s; 5 - 3p; 6 - 3d; 7 - 4s
       subroutine phFitEl(nz, ne, shell, photEn, xSec)
         implicit none

         integer, intent(in) :: nz                ! atomic number from 1 to 30
         integer, intent(in) :: ne                ! # of electrons from 1 to nz
         integer, intent(in) :: shell             ! shell number

         real, intent(in) :: photEn               ! photon energy [eV]
         real, intent(out) :: xSec                ! cross section [Mb]

         ! local variables
         integer :: nOut, nInt                    ! # of outer or internal shell

         real :: eInn, p1, y, q, a, b, x, z

         ! initialize the cross section to 0.0
         xSec = 0.0

         ! xSec = 0.0 if atomic number < 1 or > 30
         if( (nz < 1) .or. (nz > 30) ) return

         ! xSec = 0.0 if # of electrons  < 1 or > than atomic number
         if( (ne < 1) .or. (ne > nz) ) return

         ! set outer shell number
         nOut = nTot(ne)

         if ( (nz == ne) .and. (nz > 18) ) nOut = 7

         if ( (nz == (ne+1)) .and. ( (nz == 20) .or. (nz == 21) .or. &
&             (nz == 22) .or. (nz == 25) .or. (nz == 26) ) ) nOut = 7

         if ( shell > nOut) return
!         if ( (shell == 6) .and. ( (nz == 20) .or. (nz == 19) ) .and. &
!&             (ne >= 19) ) return

         if ( photEn < ph1(1, nz, ne, shell) ) return

         ! set internal shell number
         nInt = nInn(ne)

         ! set eInn
         if ( (nz == 15) .or. (nz == 17) .or. (nz == 19) .or. &
&             ( (nz > 20) .and. (nz /= 26) ) ) then
            eInn = 0.0
         else
            if (ne < 3) then
               eInn = 1.e30
            else
               eInn = ph1(1, nz, ne, nInt)
            end if
         end if

         ! calculate the cross section
         if( (shell < nOut) .and. (shell > nInt) .and. &
         &(photEn < eInn) ) return
         if( (shell <= nInt) .or. (photEn >= eInn) ) then
            p1 = -ph1(5, nz, ne, shell)
            y = photEn / ph1(2, nz, ne, shell)
            q = -0.5*p1 - level(shell) - 5.5
            a = ph1(3, nz, ne, shell) * &
                 &( (y-1.0)**2 + ph1(6, nz, ne, shell)**2 )
            b = sqrt(y/ph1(4, nz, ne, shell)) + 1.
            xSec = a * y**q * b**p1
         else
            p1 = -ph2(4, nz, ne)
            q = -0.5*p1 - 5.5
            x = photEn / ph2(1, nz, ne) - ph2(6, nz, ne)
            z = sqrt(x*x + ph2(7, nz, ne)*ph2(7, nz, ne))
            a = ph2(2, nz, ne) * ((x-1.)*(x-1.) + &
                 &ph2(5, nz, ne)*ph2(5, nz, ne))
            b = sqrt(z/ph2(3, nz, ne)) + 1.
            xSec = a * z**q * b**p1

         end if
       end subroutine phFitEl


       ! this function calculates photoionisation
       ! cross sections for hydrogenic ions
       ! routine was adapted from cloudy and originally
       ! obtained from Anil Pradhan, Nov90
       ! W = photon energy ; W0 = threshold photon energy
       function phFitHIon(x, n, z)
         implicit none

         real :: phFitHIon              ! cross section [1/cm^2]

         integer :: n                   ! principal QN

         real :: x                      ! log10(W/W0)
         real :: z                      ! nuclear charge

         ! local variables

         real, dimension(10) ::  a, &   ! fit parameters
              &b, c, d, e, f

         ! assign the the fit parameters

         a = (/-17.2004,-16.8584,-16.6670,-16.5339,-16.4319,-16.3491, &
              &-16.2795,-16.2194,-16.1666,-16.1195/)
         b = (/-2.6671, -2.8068, -2.8549, -2.8812, -2.8983, -2.9103, &
              &-2.9193, -2.9264, -2.9321, -2.9369/)
         c = (/-0.3228, -0.1323, -0.0931, -0.0735, -0.0612, -0.0527, &
              &-0.0465, -0.0418, -0.0380, -0.0350/)
         d = (/ 0.0608,  0.0224,  0.0224,  0.0204,  0.0181,  0.0163, &
              &0.0147,  0.0135,  0.0125,  0.0117/)
         e = (/-16.9991,-16.7709,-16.6188,-16.5012,-16.4069,-16.3289, &
              &-16.2624,-16.2046,-16.1536,-16.1078/)
         f = (/-3.1304, -3.0041, -2.9738, -2.9671, -2.9662, -2.9669, &
              &-2.9681, -2.9694, -2.9707, -2.9719/)

         ! check n is within the range [1-10]
         if ( (n > 10) .or. (n<1) ) then
            print*, "! phFitHIon: quantum number n out of range [1,10]"
            stop
         end if

         ! calculate cross sections
         if (x <= 1) then
            phFitHIon = a(n) + x*(b(n) + x*(c(n) + x*d(n)))
         else
            phFitHIon = e(n) + x*f(n)
         end if

         phFitHIon = 10.**phFitHIon
         phFitHIon = phFitHIon / (z*z)

       end function phFitHIon


       ! this subroutine calculates the photoionisation cross-section for
       ! excited  hydrogenic states
       subroutine HFit(h0, pow, n)
         implicit none

         integer, intent(in) :: n

         real, intent(out) :: h0        ! crossection
         real, intent(out) :: pow       ! power

         ! better than 1% fit for n>=30
         h0 = (1.3962688e-10 + 2.7479352e-9 * sqrt(float(n)) ) * &
              &(1.3962688e-10 + 2.7479352e-9 * sqrt(float(n)) )

         ! better than 1% fit for n>=30
         if(n<1000) then
            pow = 2.99377 + 1.11784e-5*n - 0.3382905/n - &
                 &6.72051e-9*n*n
         else
            pow = 3.
         end if
       end subroutine hFit

       subroutine H2plusXSec(low, high, opP)
         implicit none

         integer, intent(in) :: low, high
         integer, intent(out) :: opP                       ! opacity pointer

         ! local variables
         integer, parameter :: nData = 10
         integer :: i, ixSec                               ! counters
         integer :: nPairs                                 ! # of data pair

         real ::  slope                            ! slope for linear interpolation
         real, dimension(nData) :: H2plusAr
         real, dimension(nData/2) :: enerData,  &  ! energy and cross
              &xSecData                            ! section arrays

         opP = xSecTop + 1
         nPairs = nData/2

         ! the array H2plusAr has ordered pairs of elements.
         ! the first is the energy in eV and the second is the cross
         ! section in Mb
         H2plusAr = (/6.75,0.24 , 8.68,2.5, 10.54,7.1, 12.46,6.0, &
              &14.28,2.7/)

         do i = 1, nPairs
            enerData(i) = H2plusAr( (i-1)*2 + 1) / 13.6
            xSecData(i) = H2plusAr(i*2) * 1e-18
         end do

         if ( enerData(1) > nuArray(low) ) then
            print*, "! H2plusOp: the entered opacity energy bandwidth &
                 &is not largee enough [low]"
            stop
        end if

        slope = ( xSecData(2) - xSecData(1) ) / ( enerData(2) - enerData(1) )

        ixSec = 1

        ! fill in the opacities. use linear interpolation
        do i = low, high
           if ( (nuArray(i) > enerData(ixSec)) .and. &
                &(nuArray(i) <= enerData(ixSec+1)) ) then
              xSecArrayTemp(i - low + opP) = xSecData(ixSec) + &
                   &slope * (nuArray(i) - enerData(ixSec))
           else
              ixSec = ixSec + 1
              if (ixSec + 1 > nPairs) then
                 print*, " H2plusOp: the entered opacity energy bandwidth &
                      &is not large enough [high]"
                 stop
              end if
              slope = ( xSecData(ixSec+1) - xSecData(ixSec) ) / &
                   &( enerData(ixSec+1) - enerData(ixSec) )
              if ( (nuArray(i) > enerData(ixSec)) .and. &
                   &(nuArray(i) <= enerData(ixSec+1)) ) then
                 xSecArrayTemp(i - low + opP) = xSecData(ixSec) + &
                      &slope * (nuArray(i) - enerData(ixSec))
              else
                 print*, "! H2plusOp: internal logical error.&
                      &the desired energy is not within the next energy bound"
                 stop
              end if
           end if
        end do

        ! set the pointer to the top of the xSec array
        xSecTop = xSecTop + high - low + 1

        ! check that xSecTop doesn't exceed xSecMax
        if ( xSecTop > xSecMax) then
            print*, "! H2plusOp: xSecMax exceeded"
            stop
        end if

      end subroutine H2plusXSec

      ! this subroutine generates an array of cross
      ! sections using a simple power law fit
      subroutine powLawXSec(low, high, cross, s, xSecP)
        implicit none

        integer, intent(in)  :: low, high ! pointers to boundaries of freq region
        integer, intent(out) :: xSecP     ! pointer to xSec array in xSecArray

        real, intent(in)     :: cross, s

        ! local variables
        integer :: i                      ! counter

        real :: thres                     ! threshold

        xSecP = xSecTop + 1               ! set x Sec pointer
        thres =  nuArray(low)             ! set threshold

        ! generate array of x section
        do i = low, high
            xSecArrayTemp(i-low+xSecP) = &
&                                       cross * (nuArray(i) / thres)**(-s)
        end do

        xSecTop = xSecTop + high - low + 1

        if ( xSecTop > xSecMax )  then
            print*, "! powLawXSec: xSecMax exceeded"
            stop
        end if
      end subroutine powLawXSec

      ! this subroutine generates ionic subshell opacities
      ! by calling the procedure phFitEl
      subroutine makeOpacity(nElem)
        implicit none

        integer, intent(in) :: nElem

        ! local variables
        integer :: binsNeed              ! number of continuum bins needed to store opacity
        integer :: i                     ! counter
        integer :: nElec                 ! number of bound electrons
        integer :: nIon                  ! ionic number
        integer :: shell                 ! shell(suit) number

        real    :: energy                ! energy [eV]
        real    :: xSec                  ! xSec [1/cm^2]


        do nIon = 1, min(nElem, nstages)
           ! find number of bound electrons
           nElec = nElem - nIon +1

           do shell = 1, nShells(nElem, nIon)

              elementP(nElem,nIon , shell, 3) = xSecTop+1
              ! find how many cont bins are needed to store opacity
              binsNeed = elementP(nElem,nIon , shell, 2) - &
&                           elementP(nElem,nIon , shell, 1) + 1
              ! check that there are enough cells left in xSecArrayTemp to store opacities
              if ( (xSecTop + binsNeed) > xSecMax) then
                 print*, "! makeOpacity: xSecMax exceeded"
                 stop
              end if

              if ( elementP(nElem,nIon , shell, 1)>elementP(nElem,nIon , shell, 2) .and. &
&                    ( .not.(elementP(nElem,nIon , shell, 1)==2) .or. &
&                     .not.(elementP(nElem,nIon , shell, 2)==1) ) ) then

                 print*, "! makeOpacity: upper energy limit for this shell is smaller &
                      & than threshold [elem,ion,shell, highlim,thres]", nElem,nIon, &
                      & shell,nuArray(elementP(nElem,nIon,shell,2)),&
                      & nuArray(elementP(nElem,nIon,shell,1))
                 stop
              end if

              do i = elementP(nElem,nIon , shell, 1), elementP(nElem,nIon , shell, 2)

                 energy = max( nuArray(i)*RydToeV, ph1(1, nElem, nElec, shell) )
                 call phFitEl(nElem, nElec, shell, energy, xSec)
                 xSecArrayTemp(i-elementP(nElem,nIon , shell, 1)+&
                      &elementP(nElem,nIon , shell, 3)) = xSec*1e-18
              end do

              if (binsneed>=1) then
                 xSecTop = xSecTop + elementP(nElem,nIon , shell, 2) - &
                      &elementP(nElem,nIon , shell, 1) +1
              end if

           end do
        end do

      end subroutine makeOpacity

      ! optical constants data files needed
      ! note that the number of wavelength points must be the same for all files
      ! makes dust xsections [cm^2] ( pi a^2 Q )
      subroutine makeDustXsec()

        real :: normWeight ! normalization constant for grain size weighting
        real :: readReal     ! real number reader
        real :: value ! general value variable
        real, allocatable :: da(:)
        real, allocatable :: tmp1(:), tmp2(:), tmp3(:), agrain(:), tmp11(:,:), tmp22(:,:),&
             & tmp33(:,:), tmpWav(:), QaTemp(:), QsTemp(:), gTemp(:), temp1nbins(:,:), &
             & temp2nbins(:,:), temp3nbins(:,:), norm(:)
        real, allocatable :: wav(:) ! wavelength in [um]
        real, allocatable :: gCos(:,:,:) ! phase function parameter
        real, allocatable :: Cabs(:,:,:) ! abs cross-section [um^2] for each grain species and size
        real, allocatable :: Csca(:,:,:) ! sca cross-section [um^2] for each grain species and size
        real, allocatable :: CTabs(:) ! total abs cross-section [um^2] for grain mixture
        real, allocatable :: CTsca(:) ! total sca cross-section [um^2] for grain mixture
        real, allocatable :: Ere(:), Eim(:)

        integer :: err ! allocation error status
        integer :: i, j, iwav, n, iSize, icomp ! counter
        integer :: ios ! I/O error status
        integer :: nSpec, ai ! counter
        integer :: nn, iskip ! counter
        integer :: Nwav, NwavOld ! # of wavelength points used
        integer :: nRadii ! # of radii in Qfile

        character(len = 15) :: textString, dustFileType
        character(len=50)   :: readChar, extFile ! character string readers
        character(len=50)   :: extinctionFile

        print*, 'in makeDustXSec'

        allocate(gSca(nbins))
        allocate(norm(nbins))


        allocate(dustComPoint(nDustComponents))
        dustComPoint = 0
        dustComPoint(1) = 1


        nSpecies = 0
        nSpeciesMax = 0

       do icomp = 1, nDustComponents

          close(13)
          open(file = dustSpeciesFile(icomp), action="read",unit=13, &
               &position="rewind",status="old", iostat = ios)
          if (ios /= 0 ) then
             print*, "! makeDustXsec: can't open file ", dustSpeciesFile(icomp)
             stop
          end if
          read(13, *) nSpeciesPart(icomp)

          close(13)
          nSpecies = nSpecies+nSpeciesPart(icomp)

          if (nSpeciesMax < nSpeciesPart(icomp)) nSpeciesMax = nSpeciesPart(icomp)

        end do

        allocate(rho(1:nSpecies), stat = err)
        if (err /= 0) then
           print*, "! makeDustXsec: can't allocate rho memory"
           stop
        end if
        rho=0.
        allocate(grainVn(1:nSpecies), stat = err)
        if (err /= 0) then
           print*, "! makeDustXsec: can't allocate grainVn memory"
           stop
        end if
        grainVn=0.
        allocate(MsurfAtom(1:nSpecies), stat = err)
        if (err /= 0) then
           print*, "! makeDustXsec: can't allocate surfAtom memory"
           stop
        end if
        MsurfAtom=0

        do icomp = 1, nDustComponents
           if (icomp > 1) dustComPoint(icomp) = dustComPoint(icomp-1)+nSpeciesPart(icomp-1)

           close(13)
           open(file = dustSpeciesFile(icomp), action="read",unit=13, &
                & position="rewind",status="old", iostat = ios)
           if (ios /= 0 ) then
              print*, "! makeDustXsec: can't open file ", dustSpeciesFile(icomp)
              stop
           end if
           read(13, *) nSpeciesPart(icomp)

           do i = 1, nSpeciesPart(icomp)
              read(13,*) extFile
              close(14)
              open(file=PREFIX//"/share/mocassin/"//extFile,unit=14,  action="read", position="rewind",status="old", iostat = ios)
              if (ios /= 0 ) then
                 print*, "! makeDustXsec: can't open file ", PREFIX,"/share/mocassin/"//extFile
                 stop
              end if
              read(14,*) readChar

              read(14,*) readChar, readReal, rho(dustComPoint(icomp)+i-1), grainVn(dustComPoint(icomp)+i-1), &
                   &MsurfAtom(dustComPoint(icomp)+i-1)
              close(14)
           end do
           close(13)
        end do


        ! allocate abundances array for dust
        allocate (absOpacSpecies(1:nSpecies, 1:nbins), stat=err)
        if (err/=0) then
           print*, "! makeDustXsec: error allocation memory for absOpacSpecies array"
           stop
        end if
        absOpacSpecies=0.

        ! allocate abundances array for dust
        allocate (grainAbun(1:nDustComponents, 1:nSpeciesMax), stat=err)
        if (err/=0) then
           print*, "! makeDustXsec: error allocation memory for grainAbun array"
           stop
        end if
        grainAbun=0.


        allocate (grainLabel(1:nSpecies), stat=err)
        if (err/=0) then
           print*, "! makeDustXsec: error allocation memory for grainLabel array"
           stop
        end if
        grainLabel=""
        allocate (TdustSublime(1:nSpecies), stat=err)
        if (err/=0) then
           print*, "! makeDustXsec: error allocation memory for TdustSublime array"
           stop
        end if
        TdustSublime=0.

        close(11)
        open (unit=11, file=dustFile(2), iostat = ios, status = 'old', &
             &position = 'rewind', action="read")
        if(ios/=0) then
           print*, '! makeDustXSec: cannot open file for reading ', dustFile(2)
           stop
        end if

        ! chekc how many sizes are used
        read (11, *) nSizes
        allocate (grainRadius(1:nSizes), stat=err)
        if (err/=0) then
           print*, "! makeDustXsec: error allocation memory for grainRadius array"
           stop
        end if
        grainRadius=0.
        allocate (da(1:nSizes), stat=err)
        if (err/=0) then
           print*, "! makeDustXsec: error allocation memory for da array"
           stop
        end if
        da=0.

        allocate (grainWeight(1:nSizes), stat=err)
        if (err/=0) then
           print*, "! makeDustXsec: error allocation memory for grainWeight array"
           stop
        end if
        grainWeight=0.
        normWeight =0.


        do ai = 1, nSizes
           read(11,*) iskip, grainRadius(ai), grainWeight(ai)
        end do

        close(11)

        if (nSizes>1) then
           da(1) = grainRadius(2)-grainRadius(1)
           do ai = 2, nSizes-1
              da(ai) = (grainRadius(ai+1)-grainRadius(ai-1))/2.
           end do
           da(nSizes) = grainRadius(nSizes)-grainRadius(nSizes-1)
        end if
        normWeight=  0.
        do ai = 1, nSizes
           normWeight = normWeight+grainWeight(ai)*da(ai)
!!!           normWeight = normWeight+grainWeight(ai)
        end do
        if (nSizes>1) then
           do ai = 1, nSizes
              grainWeight(ai) = (grainWeight(ai)*da(ai))/normWeight
!!!              grainWeight(ai) = (grainWeight(ai))/normWeight
              if (.not.grainWeight(ai)>=0.) then
                 print*, '! makeDustXSec : Invalid grain weight ', grainWeight(ai), ai
                 stop
              end if
           end do
        else if (nSizes==1) then
           grainWeight(1) = 1.
        else
           print*, '! makeDustXSec : Invalid nSizes', nSizes
           stop
        end if

        if (taskid == 0)  then
           print*, '! makeDustXSec : Size Distribution '
           print*, ' index, a [um], da [um], weight '
           do ai = 1, nSizes
              print*, ai, grainRadius(ai), da(ai), grainWeight(ai)
           end do
        end if

        allocate (dustScaXSecP(0:nSpecies,1:nSizes), stat=err)
        if (err/=0) then
           print*, "! makeDustXsec: error allocation memory for dustScaXSecP array"
           stop
        end if
        dustScaXSecP = -1
        allocate (dustAbsXSecP(0:nSpecies,1:nSizes), stat=err)
        if (err/=0) then
           print*, "! makeDustXsec: error allocation memory for dustAbsXSecP array"
           stop
        end if
        dustAbsXSecP = -1


        do icomp = 1, nDustComponents

           open (unit=10, file=dustSpeciesFile(icomp), iostat = ios, status = &
                &'old', position = 'rewind', action="read")
           if(ios/=0) then
              print*, '! makeDustXSec: cannot open file for reading ', dustSpeciesFile(icomp)
              stop
           end if

           ! check how many species are used
           read (10, *) nSpeciesPart(icomp)

           do nSpec = 1, nSpeciesPart(icomp)

              read(10, *) extinctionFile, grainAbun(icomp, nSpec)

              open (unit=20, file=PREFIX//"/share/mocassin/"//extinctionFile, iostat = ios, &
                   &status = 'old', position = 'rewind', action="read")
              if(ios/=0) then
                 print*, '! makeDustXSec: cannot open file for reading ', PREFIX,'/share/mocassin/',extinctionFile
                 stop
              end if

              read (20, *) dustFileType

              select case (dustFileType)
              case ('nk')

                 read (unit=20, fmt=*, iostat=ios) textString

                 ! count number of frequency points
                 Nwav = 0
                 do
                    read (unit=20, fmt=*, iostat=ios) value
                    if (ios /= 0 ) exit
                    Nwav = Nwav+1
                 end do
                 rewind 20

                 if (nSpec>1 .and. nWav/=nWavOld) then
                    print*, '! makeDustXSec: [warning] extinction files &
                         & do not have the same number of frequency points'
                 end if

                 allocate (wav(1:nWav), stat=err)
                 if (err/=0) then
                    print*, "! makeDustXsec: error allocation &
                         &memory for wav array"
                    stop
                 end if
                 allocate (tmp1(1:nWav), stat=err)
                 if (err/=0) then
                    print*, "! makeDustXsec: error allocation memory for &
                         &tmp1 array"
                    stop
                 end if
                 allocate (tmp2(1:nWav), stat=err)
                 if (err/=0) then
                    print*, "! makeDustXsec: error allocation memory for &
                         &tmp2 array"
                    stop
                 end if
                 allocate (tmp3(1:nWav), stat=err)
                 if (err/=0) then
                    print*, "! makeDustXsec: error allocation memory for &
                         &tmp3 array"
                    stop
                 end if

                 ! initialise arrays
                 tmp1 = 0.
                 tmp2 = 0.
                 tmp3 = 0.
                 wav = 0.

                 if (nSpec == 1) then

                    ! allocate the pointers' memory

                    allocate (Gcos(1:nSpecies,0:nSizes,1:nbins), stat=err)
                    if (err/=0) then
                       print*, "! makeDustXsec: error allocation memory for Gcos array"
                       stop
                    end if
                    allocate (Csca(1:nSpecies,0:nSizes,1:nbins), stat=err)
                    if (err/=0) then
                       print*, "! makeDustXsec: error allocation memory for Csca array"
                       stop
                    end if
                    allocate (Cabs(1:nSpecies,0:nSizes,1:nbins), stat=err)
                    if (err/=0) then
                       print*, "! makeDustXsec: error allocation memory for Cabs array"
                       stop
                    end if
                    allocate (CTsca(1:nbins), stat=err)
                    if (err/=0) then
                       print*, "! makeDustXsec: error allocation memory for CTsca array"
                       stop
                    end if
                    allocate (CTabs(1:nbins), stat=err)
                    if (err/=0) then
                       print*, "! makeDustXsec: error allocation memory for CTabs array"
                       stop
                    end if
                    Gcos = 0.
                    Cabs = 0.
                    Csca = 0.
                    CTabs = 0.
                    CTsca = 0.
                 end if

                 allocate (Ere(1:nWav), stat=err)
                 if (err/=0) then
                    print*, "! makeDustXsec: error allocation memory for Ere array"
                    stop
                 end if
                 allocate (Eim(1:nWav), stat=err)
                 if (err/=0) then
                    print*, "! makeDustXsec: error allocation memory for Eim array"
                    stop
                 end if
                 Ere = 0.
                 Eim = 0.


                 read(20, *) dustFileType

                 read(20, *) grainLabel(dustComPoint(icomp)-1+nSpec), &
                      & TdustSublime(dustComPoint(icomp)-1+nSpec),&
                      & rho(dustComPoint(icomp)-1+nSpec), &
                      & grainVn(dustComPoint(icomp)-1+nSpec), &
                      & MsurfAtom(dustComPoint(icomp)-1+nSpec)

                 do i = 1, Nwav
                    read (20,*) wav(i), Ere(i), Eim(i)
                 end do

                 close(20)

                 nWavOld = nWav

                 ! reverse order of wav, Ere and Eim and map onto mocassin's grid
                 do i = nWav, 1, -1
                    ! convert wav into energy [Ryd]
                    wav(i) = c/(wav(i)*fr1Ryd*1.e-4)
                    tmp1(nWav-i+1) = Ere(i)
                    tmp2(nWav-i+1) = Eim(i)
                    tmp3(nWav-i+1) = wav(i)
                 end do
                 wav=tmp3

                 if (allocated(Ere)) deallocate(Ere)
                 if (allocated(Eim)) deallocate(Eim)

                 allocate (Ere(1:nbins), stat=err)
                 if (err/=0) then
                    print*, "! makeDustXsec: error allocation memory for Ere array - 2"
                    stop
                 end if
                 allocate (Eim(1:nbins), stat=err)
                 if (err/=0) then
                    print*, "! makeDustXsec: error allocation memory for Eim array - 2"
                    stop
                 end if
                 Ere = 0.
                 Eim = 0.

                 ! map onto mocassin grid
                 call linearMap(tmp1, wav, nwav, Ere, nuArray, nbins)
                 call linearMap(tmp2, wav, nwav, Eim, nuArray, nbins)

                 ! calculate efficiencies
                 call getQs(Ere,Eim,Cabs(nSpec,1:nSizes,1:nbins),&
                      & Csca(nSpec,1:nSizes,1:nbins), Gcos(nSpec,1:nSizes,1:nbins))
!                 call getQs(Ere,Eim,Cabs(nSpec,1:nSizes,1:nbins),Csca(nSpec,1:nSizes,1:nbins))


                 if (allocated(wav)) deallocate(wav)
                 if (allocated(Ere)) deallocate(Ere)
                 if (allocated(Eim)) deallocate(Eim)
                 if (allocated(tmp1)) deallocate(tmp1)
                 if (allocated(tmp2)) deallocate(tmp2)
                 if (allocated(tmp3)) deallocate(tmp3)


              case ('Q')

                 ! read (unit=20, fmt=*, iostat=ios) textString

                 rewind(20)
                 read(20, *) dustFileType

                 read(20, *) grainLabel(dustComPoint(icomp)-1+nSpec), &
                      & TdustSublime(nSpec+dustComPoint(icomp)-1), &
                      &rho(dustComPoint(icomp)-1+nSpec), &
                      & grainVn(nSpec+dustComPoint(icomp)-1), &
                      & MsurfAtom(dustComPoint(icomp)-1+nSpec)

                 do i = 1, 2
                    read(20,*) textString
                 end do
                 read(20,*) nRadii
                 read(20,*) nwav
                 read(20,*) textString

                 allocate (wav(1:nWav), stat=err)
                 if (err/=0) then
                    print*, "! makeDustXsec: error allocation memory for wav array"
                    stop
                 end if
                 allocate (agrain(1:nRadii), stat=err)
                 if (err/=0) then
                    print*, "! makeDustXsec: error allocation memory for agrain array"
                    stop
                 end if
                 allocate (QaTemp(1:nWav), stat=err)
                 if (err/=0) then
                    print*, "! makeDustXsec: error allocation memory for QaTemp array"
                    stop
                 end if
                 allocate (QsTemp(1:nWav), stat=err)
                 if (err/=0) then
                    print*, "! makeDustXsec: error allocation memory for QaTemp array"
                    stop
                 end if
                 allocate (gTemp(1:nWav), stat=err)
                 if (err/=0) then
                    print*, "! makeDustXsec: error allocation memory for QaTemp array"
                    stop
                 end if
                 allocate (temp1nbins(1:nRadii,1:nbins), stat=err)
                 if (err/=0) then
                    print*, "! makeDustXsec: error allocation memory for temp1nbins array"
                    stop
                 end if
                 allocate (temp2nbins(1:nRadii,1:nbins), stat=err)
                 if (err/=0) then
                    print*, "! makeDustXsec: error allocation memory for temp1nbins array"
                    stop
                 end if
                 allocate (temp3nbins(1:nRadii,1:nbins), stat=err)
                 if (err/=0) then
                    print*, "! makeDustXsec: error allocation memory for temp1nbins array"
                    stop
                 end if
                 allocate (tmp11(1:nRadii,1:nWav), stat=err)
                 if (err/=0) then
                    print*, "! makeDustXsec: error allocation memory for tmp11 array"
                    stop
                 end if
                 allocate (tmp22(1:nRadii,1:nWav), stat=err)
                 if (err/=0) then
                    print*, "! makeDustXsec: error allocation memory for tmp22 array"
                    stop
                 end if
                 allocate (tmp33(1:nRadii,1:nWav), stat=err)
                 if (err/=0) then
                    print*, "! makeDustXsec: error allocation memory for tmp33 array"
                    stop
                 end if
                 allocate (tmpWav(1:nWav), stat=err)
                 if (err/=0) then
                    print*, "! makeDustXsec: error allocation memory for tmpWav array"
                    stop
                 end if

                 ! initialise arrays
                 QaTemp = 0.
                 QsTemp = 0.
                 gTemp = 0.
                 temp1nbins = 0.
                 temp2nbins = 0.
                 temp3nbins = 0.
                 tmp11 = 0.
                 tmp22 = 0.
                 tmp33 = 0.
                 tmpWav = 0.
                 wav = 0.
                 agrain = 0.

                 if (nSpec == 1) then
                    ! allocate the pointers' memory
                    allocate (gCos(1:nSpecies,0:nSizes,1:nbins), stat=err)
                    if (err/=0) then
                       print*, "! makeDustXsec: error allocation memory for Cabs array"
                       stop
                    end if
                    allocate (Csca(1:nSpecies,0:nSizes,1:nbins), stat=err)
                    if (err/=0) then
                       print*, "! makeDustXsec: error allocation memory for Csca array"
                       stop
                    end if
                    allocate (Cabs(1:nSpecies,0:nSizes,1:nbins), stat=err)
                    if (err/=0) then
                       print*, "! makeDustXsec: error allocation memory for Cabs array"
                       stop
                    end if
                    allocate (CTsca(1:nbins), stat=err)
                    if (err/=0) then
                       print*, "! makeDustXsec: error allocation memory for CTsca array"
                       stop
                    end if
                    allocate (CTabs(1:nbins), stat=err)
                    if (err/=0) then
                       print*, "! makeDustXsec: error allocation memory for CTabs array"
                       stop
                    end if
                    gCos = 0.
                    Cabs = 0.
                    Csca = 0.
                    CTabs = 0.
                    CTsca = 0.
                 end if

                 do i = 1, nRadii
                    do j = 1, nWav
                       read(20,*) agrain(i), wav(j), tmp11(i,j), tmp22(i,j), tmp33(i,j)
                    end do

                    ! reverse order of wav, tmp11, tmp22 and tmp33 and map onto mocassin's grid
                    do iwav = nWav, 1, -1
                       ! convert wav into energy [Ryd]
                       tmpWav(iwav) = c/(wav(iwav)*fr1Ryd*1.e-4)
                       QaTemp(iwav) = tmp11(i,iwav)
                       QsTemp(iwav) = tmp22(i,iwav)
                       gTemp(iwav) = tmp33(i,iwav)
                    end do
                    wav=tmpWav

                    ! map  data onto mocassin's nu grid

                    call linearMap(QaTemp, wav, nwav, temp1nbins(i,:), nuArray, nbins)
                    call linearMap(QsTemp, wav, nwav, temp2nbins(i,:), nuArray, nbins)
                    call linearMap(gTemp, wav, nwav, temp3nbins(i,:), nuArray, nbins)

                 end do

                 close(20)

                 if (allocated(QaTemp)) deallocate(QaTemp)
                 if (allocated(QsTemp)) deallocate(QsTemp)
                 if (allocated(gTemp)) deallocate(gTemp)
                 if (allocated(tmp11)) deallocate(tmp11)
                 if (allocated(tmp22)) deallocate(tmp22)
                 if (allocated(tmp33)) deallocate(tmp33)
                 if (allocated(wav)) deallocate(wav)
                 if (allocated(tmpWav)) deallocate(tmpWav)

                 ! interpolate over the grain size distribution
                 do i = 1, nSizes

                    call locate(agrain, grainRadius(i), iSize)

                    if (grainRadius(i)<agrain(1)) then
                       print*, '! makeDustXsec: [warning] Size distribution &
                            & extends to radii smaller than &
                            & the smallest radius listed in the external Qfile provided'
                       print*, 'Value of the smallest radius was assigned'
                       Cabs(nSpec,i,:) =  temp1nbins(1,:)
                       Csca(nSpec,i,:) =  temp2nbins(1,:)
                       gCos(nSpec,i,:) =  temp3nbins(1,:)
                    else if (grainRadius(i)>agrain(nRadii)) then
                       print*, '! makeDustXsec: [warning] Size distribution &
                            & extends to radii larger than &
                            & the largest radius listed in the external Qfile provided'
                       print*, 'Value of the largest radius was assigned'

                       Cabs(nSpec,i,:) =  temp1nbins(nRadii,:)
                       Csca(nSpec,i,:) =  temp2nbins(nRadii,:)
                       gCos(nSpec,i,:) =  temp3nbins(nRadii,:)

                    else
                       do j =1, nbins

                          Cabs(nSpec,i,j) = temp1nbins(iSize,j)+&
                               & (grainRadius(i)-agrain(iSize))*&
                               & (temp1nbins(iSize+1,j)-temp1nbins(iSize,j))/&
                               & (agrain(iSize+1)-agrain(iSize))

                          Csca(nSpec,i,j) = temp2nbins(iSize,j)+&
                               & (grainRadius(i)-agrain(iSize))*&
                               & (temp2nbins(iSize+1,j)-temp2nbins(iSize,j))/&
                               & (agrain(iSize+1)-agrain(iSize))

                          gCos(nSpec,i,j) = temp3nbins(iSize,j)+&
                               & (grainRadius(i)-agrain(iSize))*&
                               & (temp3nbins(iSize+1,j)-temp3nbins(iSize,j))/&
                               & (agrain(iSize+1)-agrain(iSize))
                       end do
                    end if

                 end do

                 if (allocated(agrain)) deallocate(agrain)
                 if (allocated(temp1nbins)) deallocate(temp1nbins)
                 if (allocated(temp2nbins)) deallocate(temp2nbins)
                 if (allocated(temp3nbins)) deallocate(temp3nbins)


              case default
                 print*, "! makeDustXsec: invalid dustFileType", dustFileType,extinctionFile
                 stop
              end select

           end do

           close(10)

           print*, "! makeDustXsec: Grain Abundances: "
           print*, "(icomp, index, label, abundance, sublimation T)"
           do nSpec = 1, nSpeciesPart(icomp)
              print*, icomp, nSpec, grainLabel(dustComPoint(icomp)-1+nSpec),&
                   & grainAbun(icomp,nSpec),&
                   & TdustSublime(dustComPoint(icomp)-1+nSpec)
           end do
           print*, ""

           ! calculate cross sections [um^2]
           ! combine individual species/sizes cross-sections into total
           ! cross-section for the grain mixture
           do i = 1, nbins
              do nSpec = 1, nSpeciesPart(icomp)
                 do ai = 1, nSizes

                    Csca(nSpec,ai,i) = Csca(nSpec,ai,i)*Pi*grainRadius(ai)*grainRadius(ai)*1.e-8
                    Cabs(nSpec,ai,i) = Cabs(nSpec,ai,i)*Pi*grainRadius(ai)*grainRadius(ai)*1.e-8

                    CTsca(i) = CTsca(i) + grainAbun(icomp, nSpec)*Csca(nSpec,ai,i)*grainWeight(ai)
                    CTabs(i) = CTabs(i) + grainAbun(icomp, nSpec)*Cabs(nSpec,ai,i)*grainWeight(ai)

                 end do
              end do
           end do


           do i = 1, nbins
              xSecArrayTemp(xSecTop+i) = CTsca(i)
              xSecArrayTemp(xSecTop+i+nbins) = CTabs(i)

              nn=2
              do nSpec = 1, nSpeciesPart(icomp)
                 do ai = 1, nSizes

                    xSecArrayTemp(xSecTop+i+nn*nbins) = Csca(nSpec, ai, i)
                    nn=nn+1

                    xSecArrayTemp(xSecTop+i+nn*nbins) = Cabs(nSpec, ai, i)
                    nn=nn+1

                 end do
              end do

           end do

           ! set up dust cross-section pointers
           ! individual species
           dustScaXsecP(0,:) = xSecTop+1
           dustAbsXsecP(0,:) = xSecTop+1+nbins

           nn = 2
           do n = 1, nSpeciesPart(icomp)
              do ai = 1, nSizes
                 dustScaXsecP(dustComPoint(icomp)+n-1,ai) = xSecTop+1+nn*nbins

                 nn = nn+1
                 dustAbsXsecP(dustComPoint(icomp)+n-1,ai) = xSecTop+1+nn*nbins

                 nn=nn+1
              end do
           end do
           ! update value of xSecTop
           xSecTop = xSecTop + 2*nbins*(nSpeciesPart(icomp)+1)*nSizes

           if (allocated(Csca)) deallocate(Csca)
           if (allocated(Cabs)) deallocate(Cabs)
           if (allocated(CTsca)) deallocate(CTsca)
           if (allocated(CTabs)) deallocate(CTabs)

           gSca = 0.
           norm = 0.
           do n = 1, nSpeciesPart(icomp)
              do i = 1, nbins
                 do ai = 1, nSizes
                    absOpacSpecies(dustComPoint(icomp)-1+n, i) = &
                         & absOpacSpecies(dustComPoint(icomp)-1+n, i) &
                         & + xSecArrayTemp(dustAbsXsecP(dustComPoint(icomp)-1+n,ai)+i-1)*&
                         & grainWeight(ai)
!                    gSca(i) = gSca(i)+gCos(n,ai,i)*grainWeight(ai)*&
!                         &grainAbun(icomp, n)
                    gSca(i) = gSca(i)+gCos(n,ai,i)*Pi*grainRadius(ai)**2*&
                         & grainWeight(ai)*grainAbun(icomp, n)
                    norm(i) = norm(i) + Pi*grainRadius(ai)**2*&
                         & grainWeight(ai)*grainAbun(icomp, n)

                 end do
              end do
           end do
!           print*,' '
!           print*,'Dust-grain anisotropy parameter g'
           do i = 1, nbins
              gSca(i)=gSca(i)/norm(i)
!              write(6,'(i5,2es12.4)')i,c/(nuArray(i)*fr1Ryd)*1.e4,gSca(i)
           enddo

        end do

        if (allocated(gCos)) deallocate(gCos)

      end subroutine makeDustXsec



      subroutine getQs(Ere_in,Eim_in,Qabs,Qsca,ggCos)
        implicit none

        real, intent(in) :: Ere_in(*), Eim_in(*)
        real, intent(out) :: Qabs(nsizes,nbins), Qsca(nSizes, nbins),&
             &ggCos(nSizes,nbins)

        complex :: refIndex
        real    :: sizeParam

        integer :: i, ai

        do i = 1, nbins

           ! complex refraction index
           refIndex = cmplx(Ere_in(i),Eim_in(i))

           do ai = 1, nSizes

              ! size parameter
              sizeParam=2.0*3.14159265*grainRadius(ai)/&
                   &( 2.9979250e14/(nuArray(i)*fr1Ryd) )

              ! if size parameter > 100 use 100 (geometrical optics)
              if (sizeParam > 100.) sizeParam=100.

              ! now calculate the efficiencies
              call BHmie(sizeParam,refIndex,Qabs(ai,i),Qsca(ai,i),&
                   & ggCos(ai,i))

              Qabs(ai,i) = Qabs(ai,i) - Qsca(ai,i)

              if (.not.lgDustScattering) Qsca(ai,i)=0.

           end do

        end do

      end subroutine getQs

      ! ***********************************************************************
      ! This subroutine is a modified version of the BH Mie scattering routine
      ! Added the <gsca> from B. Draine implementation.
      ! Ported to F90 and integrated into MOCASSIN by B. Ercolano, Sep 2008
      ! -----------------------------------------------------------------------
      !     __________________________________________________________________
      !
      !     SUBROUTINE BHMIE CALCULATES AMPLITUDE SCATTERING MATRIX ELEMENTS
      !     & EFFICIENCIES FOR EXTINCTION, TOTAL SCATTERING AND BACSCATTERING,
      !     FOR A GIrVEN SIZE PARAMETER AND RELATIVE REFRACTIVE INDEX
      !     __________________________________________________________________

      subroutine BHmie (x,refrel,qext,qsca,ggsca)
        implicit none

        complex, intent(in) :: refrel
        real, intent(in)    :: x

        real, intent(out)   :: qext, qsca, ggsca

        real(kind = 8), dimension(100) ::  amu, theta,pii,tau,pi0,pi1

        double complex              :: d(3000),y,xi,xi0,xi1,an,bn,s1(200),s2(200),&
             &an1,bn1
        real(kind = 8)                 ::  psi0,psi1,psi,dn,dx,xstop,ymod,dang,chi0,&
             &chi1,apsi0,apsi1,apsi,fn,chi,p,t

        double complex :: dpcx

        real(kind=8) :: realpart
        real(kind=8) :: imagpart

        integer              :: nang,j,nstop,nmx,n,nn,rn,jj


        realpart(dpcx)=real(dpcx)
        imagpart(dpcx)=imag(dpcx)


        nang = 2
        dx=x
        y=x*refrel

        ! series terminated after nstop terms
        ! ___________________________________________________________________
        xstop=x+4.*x**.3333 +2.0
        nstop=int(xstop)
        ymod=abs(y)
        nmx=int(max(xstop,ymod)) + 15
        dang=1.570796327/float(nang-1)
        do j = 1,nang
           theta(j)= (float(j)-1.)*dang
           amu(j)=cos(theta(j))

        end do


        ! __________________________________________________________________
        ! logarithmic derivative d(j) calculated by downward recurrence
        ! beginning with initial value 0.0 + i*0.0 at j = nmx
        !__________________________________________________________________
        d(nmx)=cmplx(0.0,0.0)
        nn=nmx-1
        do n=1,nn
           rn=nmx-n+1
           d(nmx-n)=(rn/y)-(1./(d(nmx-n+1)+rn/y))

        end do
        do j=1,nang
           pi0(j)=0.0
           pi1(j)=1.0
        end do
      nn=2*nang-1

      do j=1,nn
         s1(j)=cmplx(0.0,0.0)
         s2(j)=cmplx(0.0,0.0)
      end do
      ! __________________________________________________________________
      ! riccati bessel functions with real argument x calculated by upward
      ! recurrence
      ! __________________________________________________________________
      !
      psi0=cos(dx)
      psi1=sin(dx)
      chi0=-sin(x)
      chi1=cos(x)
      apsi0=psi0
      apsi1=psi1
      xi0=cmplx(apsi0,-chi0,8)
      xi1=cmplx(apsi1,-chi1,8)

      qsca=0.0
      ggsca = 0.0
      n=1
      do
         dn=n
         rn=n

         fn=(2.*rn+1.)/(rn*(rn+1.))
         psi=(2.*dn-1.)*psi1/dx-psi0

         apsi=psi
         chi=(2.*rn-1.)*chi1/x -  chi0
         xi = cmplx(apsi,-chi,8)

         if (n>1) then
            an1 = an
            bn1 = bn
         end if

         an=(d(n)/refrel+rn/x)*apsi - apsi1

         an=an/((d(n)/refrel+rn/x)*xi - xi1)

         bn=(refrel *d(n)+rn/x)*apsi - apsi1

         bn=bn/((refrel*d(n)+rn/x)*xi - xi1)

         qsca=qsca+real((2.*rn+1.)*(abs(an)*abs(an)+abs(bn)*abs(bn)))

         ggsca=ggsca+real(((2.*rn+1.)/(rn*(rn+1.)))*&
              &real(realpart(an)*realpart(bn)+imagpart(an)*imagpart(bn)))

         if(n>1)then
            ggsca=ggsca+real(((rn-1.)*(rn+1.)/rn)*&
                 &(realpart(an1)*realpart(an)+imagpart(an1)*imagpart(an)+&
                 &realpart(bn1)*realpart(bn)+imagpart(bn1)*imagpart(bn)))
         endif

         do j=1,nang

            jj=2*nang-j
            pii(j)=pi1(j)
            tau(j)=rn*amu(j)*pii(j) - (rn+1.)*pi0(j)

            p=(-1.)**(n-1)
            s1(j)=s1(j)+fn*(an*pii(j)+bn*tau(j))
            t=(-1.)**n
            s2(j)=s2(j) + fn*(an*tau(j)+bn*pii(j))

            if (j == jj) exit
            s1(jj)=s1(jj) + fn*(an*pii(j)*p + bn*tau(j)*t)
            s2(jj)=s2(jj) + fn*(an*tau(j)*t + bn*pii(j)*p)

         end do
         psi0=psi1
         psi1=psi
         apsi1=psi1
         chi0=chi1
         chi1=chi
         xi1=cmplx(apsi1,-chi1,8)

         n=n+1
         rn=n
         do j=1,nang
            pi1(j)=((2.*rn-1.)/(rn-1.))*amu(j)*pii(j)
            pi1(j)=pi1(j) - rn*pi0(j)/(rn-1.)
            pi0(j) = pii(j)
         end do

         if (n-1-nstop>=0) exit
      end do

      ggsca=(2.*ggsca/qsca)
      qsca=(2./(x*x))*qsca
      qext=(4./(x*x))*real(realpart(s1(1)))


    end subroutine BHmie


    ! sets up Compton X-Sections and PDFs using the Klein Nishina formula
    subroutine setCompton()
      implicit none

      real    :: P           ! ratio of incoming to outgoing photon energy

      integer :: i,j         ! counters
      integer :: nangles=180 ! # of theta bins

      allocate(KNsigmaT(nbins))
      allocate(KNsigmaArray(nbins,nangles))
      allocate(PcompArray(nbins,nangles))

      KNsigmaT=0.
      KNsigmaArray=0.
      PcompArray=0.

      do i = 1, nbins
         do j = 1, nangles

            P = Pcomp(nuArray(i),real(j))
            PcompArray(i,j) = P
            KNsigmaArray(i,j) = KNsigma(P,real(j))
            KNsigmaT(i) = KNsigmaT(i) + KNsigmaArray(i,j)*&
                 &2.*Pi*Sin(j*Pi/180.)*Pi/180.
         end do
      end do

      ! now calculate PDFs
      do i = 1, nbins
         KNsigmaArray(i,1) = KNsigmaArray(i,1)*2.*Pi*Sin(Pi/180.)*Pi/180.
         do j = 2, nangles
            KNsigmaArray(i,j) = KNsigmaArray(i,j-1)+KNsigmaArray(i,j)*&
                 &2.*Pi*Sin(j*Pi/180.)*Pi/180.
         end do
         KNsigmaArray(i,:) = KNsigmaArray(i,:)/KNsigmaT(i)
         KNsigmaArray(i,nangles) = 1.
      end do


    end subroutine setCompton

    ! calculates the ratio of incoming photon energy to
    ! outgoing photon energy
    real function Pcomp(E,theta)
      implicit none

      real, intent(in) :: E, theta ! E is in [ryd] theta in deg

      real             :: const, thetarad

      ! const = m_e*c^2 * erg2ryd = 37557.99001
      const = 37557.66267

      thetarad = theta*Pi/180.

      Pcomp = 1./(1. + (E/const)*(1.-cos(thetarad)))

    end function Pcomp

    ! calculates the probability that a photon will scatter
    ! into the solid angle dOmega=2 Pi Sin(theta) dtheta
    ! according to the Klein-Nishina formula
    ! dsigma/dOmega = 0.5 r_e^2 (P(E,theta)-
    ! P(E,theta)^2 Sin(theta)^2 + P(E,theta)^3)
    ! r_e = classical electron radius
    ! m_e = mass of electron
    real function KNsigma(P,theta)
      implicit none

      real, intent(in) :: P, theta ! theta in deg
      real             :: const, thetarad

      ! const = 0.5 r_e^2
      const = 3.970393838e-26

      thetarad = theta*Pi/180.

      KNsigma = const*(P-(P**2)*(sin(thetarad)**2)+P**3)

    end function KNsigma


end module xSec_mod

! Copyright (C) 2003 Barbara Ercolano
!
! MoCaSSiNwarm = MOnte CArlo SImulationS of Nebulae
! this is the warm-start driver of the simulation
! (requires grid1.out,grid2.out,grid3.out files)
!
! Version 2.02
program MoCaSSiNwarm
    use common_mod
    use constants_mod
    use dust_mod
    use grid_mod
    use iteration_mod
    use output_mod
    use set_input_mod
    use xSec_mod

    implicit none

    include 'mpif.h'

    type(grid_type) :: grid3D(maxGrids) ! the 3D Cartesian  grid

    integer         :: iGrid            !

    real            :: etime
    real, dimension(2) :: tarray,timing        ! cputimer
    integer         :: nhours, nminutes, nseconds

    timing(1)=etime(tarray)/60.0


    call mpi_init(ierr)
    call mpi_comm_rank(MPI_COMM_WORLD, taskid, ierr)
    call mpi_comm_size(MPI_COMM_WORLD, numtasks, ierr)

!    starttime = mpi_wtime()

    lgWarm = .true.

    if (taskid == 0) then
        print*, "MOCASSIN 2005 warm Version 2.00"
        print*, " "
    end if

    if (taskid == 0) then
        print*, " "
    end if

    ! reset the 3D cartesian grid
    call resetGrid(grid3D)

    call setStarPosition(grid3D(1)%xAxis,grid3D(1)%yAxis,grid3D(1)%zAxis,grid3D)

    ! initialize opacities x sections array
    call initXSecArray()

    ! set the ionzing continuum according to the contShape variable
    call setContinuum()

    ! prepare atomica data stuff
    call makeElements()

    if (taskid == 0) then
        print*, "Total number of grids (mother+sub-grids): ", nGrids
        print*, "Mother grid used:"
        print*, grid3D(1)%xAxis
        print*, grid3D(1)%yAxis
        print*, grid3D(1)%zAxis
    end if

    ! if grains are included, calculate the dust opacity
    if (lgDust) then
       do iGrid = 1, nGrids
          call dustDriver(grid3D(iGrid))
       end do
    end if

    call mpi_barrier(mpi_comm_world, ierr)

    ! start the Monte Carlo simulation
    call MCIterationDriver(grid3D)

    if (taskid ==  0 .and. .not.lgOutput) then
        ! determine final statistics
        if (lgGas) call outputGas(grid3D)
        call writeSED(grid3D)
        if (contCube(1)>0. .and. contCube(2)>0. ) &
             & call writeContCube(grid3D, contCube(1),contCube(2))
    end if

    call mpi_barrier(mpi_comm_world, ierr)

    ! free all space allocated to the 3D grid
    do iGrid=1, nGrids
       call freeGrid(grid3D(iGrid))
    end do

!    endtime  = mpi_wtime()
!
!    if (taskid == 0) then
!        print*, "time: ", endtime-starttime
!    end if

     timing(2) = etime(tarray)/60.0
     nhours = int((timing(2)-timing(1))/60.)
     nminutes = int(mod(timing(2)-timing(1),60.))
     nseconds = nint(60.*((timing(2)-timing(1))-real(nhours*60)-real(nminutes)))

     write(6,100)nhours,nminutes,nseconds
 100 format('total run time per processor ',1i3.2,':',1i2.2,':',1i2.2' (HMS)')


    call mpi_finalize(ierr)
    stop 'mpi done'


end program MoCaSSiNwarm
